#include <iostream>
#include <vector>
#include <cassert>
using namespace std;

const int MAXN = 5e5 + 123;
int a[MAXN];

struct node {
    node* l = nullptr;
    node* r = nullptr;
    int sm = 0;
};

node* create_tree(int l, int r) {
    node* nd = new node();
    int m = (l + r) / 2;
    nd->sm = r - l;
    if (r - l == 1)
        return nd;
    nd->l = create_tree(l, m);
    nd->r = create_tree(m, r);
    // cout << nd << ": " << l << ' ' << r << endl;
    return nd;
}

node* add(node* nd, int i, int x, int l, int r) {
    // cout << nd << ' ' << l << ' ' << r << endl;
    node* nd0 = new node();
    nd0->sm = nd->sm + x;
    if (r - l == 1) {
        return nd0;
    }
    int m = (l + r) / 2;
    if (i < m) {
        nd0->l = add(nd->l, i, x, l, m);
        nd0->r = nd->r;
    } else {
        nd0->r = add(nd->r, i, x, m, r);
        nd0->l = nd->l;
    }
    return nd0;
}

int get(node* nd, int i, int l, int r) {
    if (i >= r)
        return nd->sm;
    if (i <= l)
        return 0;
    int m = (l + r) / 2;
    return get(nd->l, i, l, m) + get(nd->r, i, m, r);
}

int last_common(node* a, node* b, int l, int r) {
    if (!a)
        return l;
    int m = (l + r) / 2;
    if (r - l == 1) {
        if (a->sm == b->sm)
            return r;
        else
            return l;
    }
    if (a->l->sm == b->l->sm)
        return last_common(a->r, b->r, m, r);
    else
        return last_common(a->l, b->l, l, m);
}

int get_tree(vector<node*>& v, int r, int c, int n) {
    int lb = 0, ub = v.size();
    while (ub - lb > 1) {
        int mb = (lb + ub) / 2;
        if (get(v[mb], r, 0, n) >= c)
            lb = mb;
        else
            ub = mb;
    }
    // cout << ":: " << c << ' ' << get(v[lb], r + 1, 0, n) << "(" << lb << ")" << endl;
    return lb;
}

signed main() {
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<node*> v;
    v.push_back(create_tree(0, n));

    // cout << endl;
    for (int i = 0; i < n; ++i) {
        v.push_back(add(v[i], a[i] - 1, -1, 0, n));
    }
    /* for (int i = 0; i <= n; ++i) {
        for (int j = 0; j < n; ++j)
            cout << get(v[i], j + 1, 0, n) << ' ';
        cout << endl;
    } */
    int q;
    cin >> q;
    while (q--) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        int i1 = get_tree(v, r1, c1, n);
        int i2 = get_tree(v, r2, c2, n);
        int r0 = last_common(v[i1], v[i2], 0, n);
        r0 = min(r0, r1);
        r0 = min(r0, r2);
        // cout << i1 << ' ' << i2 << ": " << r0 << endl;
        cout << r0 << ' ' << get(v[i1], r0, 0, n) << '\n';
    }
}
