#include <iostream>
#include <vector>
#include <algorithm>
#include <tuple>

using namespace std;

int n;

void update(int u, int x, vector<vector<int>> &p, vector<int> &nap, vector<int> &u_x)
{
    u_x[u] = x;
    int u1 = u + 1;
    if (u1 >= n)
    {
        return;
    }
    int x1 = x + nap[u];
    p[u1][x1] = x;
    update(u1, x1, p, nap, u_x);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n;
    n++;
    vector<vector<int>> p(n, vector<int>(n, -1));
    vector<int> nap(n, 1);
    vector<int> u_x(n, 0);

    update(0, 0, p, nap, u_x);
    for (int i = 0; i < n - 1; i++)
    {
        int a;
        cin >> a;
        a--;
        nap[a] = 0;
        update(a, u_x[a], p, nap, u_x);
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; i++)
    {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        while (r1 > r2)
        {
            c1 = p[r1][c1];
            r1--;
        }
        while (r1 < r2)
        {
            c2 = p[r2][c2];
            r2--;
        }
        while (c1 != c2)
        {
            c1 = p[r1][c1];
            r1--;
            c2 = p[r2][c2];
            r2--;
        }
        cout << r1 << " " << c1 << '\n';
    }
    cout << endl;
}
