#ifdef DEBUG
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using vi = vector<ll>;
using ii = pair<ll, ll>;
using vii = vector<ii>;
using vvi = vector<vi>;
using vvii = vector<vii>;
using vsi = vector<set<ll>>;
using vc = vector<char>;
using vvc = vector<vc>;
using vb = vector<bool>;
using vvb = vector<vb>;

template<class T, class Y>
istream &operator>>(istream &s, pair<T, Y> &p) {
  return s >> p.first >> p.second;
}

template<class T>
istream &operator>>(istream &s, vector<T> &v) {
  for (auto &e : v) s >> e;
  return s;
}

template<class T>
ostream &operator<<(ostream &s, const vector<T> &v) {
  for (const auto &e : v) s << e << ' ';
  return s;
}

void solve();

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.setf(ios::fixed);
  cout.precision(30);

  solve();
}

// ------------

void solve() {
  ll n;
  cin >> n;
  vi p(n);
  cin >> p;
  vvi dist(n, vi(n));
  for (ll i = 0; i < n; ++i) {
    for (ll j = i + 1; j < n; ++j) {
      dist[i][j] = max(
          j - i,
          abs(p[j] - p[i])
      );
    }
  }
  vi cntL(n), cntR(n);
  for (int i = 0; i < n; ++i) {
    for (int j = 0; j < i; ++j) {
      if (p[j] > p[i]) ++cntL[i];
    }
    for (int j = i + 1; j < n; ++j) {
      if (p[j] < p[i]) ++cntR[i];
    }
  }

  for (ll i = 0; i < n; ++i) {
    for (ll j = i + 1; j < n; ++j) {
      dist[i][j] = max(dist[i][j], j - i + max(cntL[i], cntR[j]));
    }
  }

  ll sum = 0;
  for (int i = 0; i < n; ++i) {
    for (int j = i + 1; j < n; ++j) {
      sum += dist[i][j];
    }
  }
  cout << sum << endl;
}