#ifdef DEBUG
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

#ifndef DEBUG
#define assert(...) (static_cast<bool>(__VA_ARGS__) ? (void)0 : abort());
#endif

using namespace std;

using ll = long long;
using vi = vector<ll>;
using ii = pair<ll, ll>;
using vii = vector<ii>;
using vvi = vector<vi>;
using vvii = vector<vii>;
using vsi = vector<set<ll>>;
using vc = vector<char>;
using vvc = vector<vc>;
using vb = vector<bool>;
using vvb = vector<vb>;

template<class T, class Y>
istream &operator>>(istream &s, pair<T, Y> &p) {
  return s >> p.first >> p.second;
}

template<class T>
istream &operator>>(istream &s, vector<T> &v) {
  for (auto &e : v) s >> e;
  return s;
}

template<class T>
ostream &operator<<(ostream &s, const vector<T> &v) {
  for (const auto &e : v) s << e << ' ';
  return s;
}

void solve1();
void solve23();

ll K;
vi PERM;

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.setf(ios::fixed);
  cout.precision(30);

  cin >> K;
  PERM.resize(K);
  cin >> PERM;

  ll test;
  if (PERM == vi{1}) test = 1;
  else if (PERM == vi{1, 2}) test = 23;

  ll t = 1;
  cin >> t;
  while (t--) {
    if (test == 1) solve1();
    else if (test == 23) solve23();
    else abort();
  }
}

// ------------

void solve1() {
  ll n, w, h;
  cin >> n >> w >> h;
  vii pts(n);
  cin >> pts;
  sort(pts.begin(), pts.end());
  ll s = 0;
  ll miny = h;
  for (auto[x, y] : pts) {
    if (y >= miny) continue;
    s += (miny - y) * (w - x);
    miny = y;
  }

  cout << s << endl;
}

void solve23() {
  ll n, w, h;
  cin >> n >> w >> h;
  vii pts(n);
  cin >> pts;
  sort(pts.begin(), pts.end(), [](ii a, ii b) -> bool {
    if (a.second != b.second) return a.second < b.second;
    return a.first < b.first;
  });

  ll s = 0;

  if (n == 1) {
    auto [x,y] = pts[0];
    s = max({
      x       * (h - y),
      (w - x) * (h - y)
    });
  } else {
    auto[x1, y1] = pts[0];
    auto[x2, y2] = pts[1];
    if (x1 > x2) {
      swap(x1, x2);
      swap(y1, y2);
    }
    s = max({
      x1       * (h - y1) + (w - x2) * (h - y2),
      (w - x1) * (h - y1) + x2       * (h - y2) - (x2 - x1) * (h - max(y1, y2)),
      (w - x1) * (h - y1) + (w - x2) * (h - y2) - (w - x2)  * (h - max(y1, y2)),
      x1       * (h - y1) + x2       * (h - y2) - x1        * (h - max(y1, y2)),
    });
  }

  cout << s << endl;
}