#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <iomanip>
#include <assert.h>
#include <cmath>

using namespace std;

using ll = long long;
using ld = long double;

#define all(x) begin(x), end(x)
#define rall(x) rbegin(x), rend(x)

const int mod = 1e9 + 7;
const int N = 3010;

int p[N];
int a[N];
int b[N];
ll d[N][N];

int n;

void get(int x)
{
	for (int i = 1; i < n; i++)
	{
		int rMax = 0;
		int cur = 0;
		for (int j = i + 1; j < n; j++)
		{
			if (x == 1)
			{
				if (p[j] < p[i]) cur += 1;
			}
			else
			{
				if (p[j] > p[i]) cur += 1;
			}
			rMax = max(rMax, cur);
		}

		cur = 0;

		for (int j = i - 1; j >= 0; j--)
		{
			d[p[i]][p[j]] = max(d[p[i]][p[j]], 0ll + (i + rMax) - j);
		}
	}
}

void solve()
{
	cin >> n;

	for (int i = 0; i < n; i++)
	{
		cin >> p[i];
		p[i]--;
		a[p[i]] = i;
	}

	for (int i = 0; i < n; i++)
	{
		for (int j = i + 1; j < n; j++)
		{
			d[i][j] = max(abs(a[i] - a[j]), abs(i - j));
		}
	}

	get(1);
	reverse(p, p + n);
	get(-1);

	ll ans = 0;
	for (int i = 0; i < n; i++)
	{
		for (int j = i + 1; j < n; j++)
		{
			//cout << i + 1 << " " << j + 1 << " " << max(d[i][j], d[j][i]) << '\n';
			ans += max(d[i][j], d[j][i]);
		}
	}

	cout << ans << '\n';
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t = 1;
	// cin >> t;

	while (t--)
	{
		solve();
	}

	return 0;
}
