#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <iomanip>
#include <assert.h>
#include <cmath>

using namespace std;

using ll = long long;
using ld = long double;

#define all(x) begin(x), end(x)
#define rall(x) rbegin(x), rend(x)

const int mod = 1e9 + 7;
const int N = 3010;

int k;

ll get(vector<pair<int, int>> a, ll w, ll h)
{
	if (a.empty()) return 0;
	int n = a.size();
	ll ans = 0;
	// 1
	{
		ll W = a[0].first;
		ll H = h;
		vector < pair<int, int>> b;
		for (int i = 1; i < n; i++)
			if (a[i].first >= a[0].first)
				H = min(H, 1ll * a[i].second);
			else if (a[i].second < H)
				b.push_back({a[i].first, a[i].second - a[0].second});
		
		ll _ans = (w - W) * (h - a[0].second) + (h - H) * W;
		_ans += get(b, W, H);
		ans = max(ans, _ans);
	}

	{
		ll W = w - a[0].first;
		ll H = h;
		vector <pair<int, int>> b;
		for (int i = 1; i < n; i++)
			if (a[i].first <= a[0].first)
				H = min(H, 1ll * a[i].second);
			else if (a[i].second < H)
				b.push_back({ a[i].first - a[0].first, a[i].second - a[0].second });

		ll _ans = (a[0].first) * (h - a[0].second) + (h - H) * W;
		_ans += get(b, W, H);
		ans = max(ans, _ans);
	}
	
	return ans;
}

void solve()
{
	int n;
	ll w, h;
	cin >> n >> w >> h;

	ll ans = 0;
	vector<pair<int, int>> a(n);
	for (int i = 0; i < n; i++)
		cin >> a[i].first >> a[i].second;
	sort(all(a), [&](pair<int, int> a, pair<int, int> b)
		{
			if (a.second != b.second) return a.second < b.second;
			return a.first < b.first;
		});

	cout << get(a, w, h) << '\n';
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t = 1;
	cin >> k >> t >> t >> t;

	while (t--)
	{
		solve();
	}

	return 0;
}