#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <map>
#include <set>
#include <string>
#include <unordered_map>
#include <unordered_set>

using namespace std;

const int MAXN = 1e7;

int n;
vector<int> g[MAXN];

vector<int> cur;

int one(int a, int b) {
    return a * (n + 1) + b;
}

void go(int x, int y, int ind) {
    if (ind == n) return;
    int nx, ny;
    if (cur[ind] == 0) {
        nx = x + 1;
        ny = y + 1;
    } else {
        nx = x + 1;
        ny = y;
    }
    g[one(x, y)].push_back(one(nx, ny));
    go(nx, ny, ind + 1);
}

int h[MAXN];
int tin[MAXN], tout[MAXN];
int tt = 0;

bool in(int v, int u) {
    return (tin[v] < tin[u] && tout[u] < tout[v]);
}

void dfs(int v, int cur_h) {
    h[v] = cur_h;
    tin[v] = tt;
    ++tt;
    for (auto u : g[v]) {
        dfs(u, cur_h + 1);
    }
    tout[v] = tt;
    ++tt;
}

signed main() {
#ifdef DEBUG_BENTSA
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(NULL);
    cin.tie(NULL);
    cout.tie(NULL);
#endif
    cin >> n;
    vector<int> v(n);
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
    }
    cur.resize(n);
    go(0, 0, 0);
    for (int i = 0; i < n; ++i) {
        cur[v[i]] = 1;
        go(0, 0, 0);
    }
    int q;
    cin >> q;
    while (q--) {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
    }
}
