#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <map>
#include <set>
#include <string>
#include <unordered_map>
#include <unordered_set>

using namespace std;

#define int long long

const int MAXN = 2e6;

int n;
unordered_set<int> g[MAXN];

vector<int> cur;

int one(int a, int b) {
    return a + b * n;
}

void go(int x, int y, int ind) {
    if (ind == n) return;
    int nx, ny;
    if (cur[ind] == 0) {
        nx = x + 1;
        ny = y + 1;
    } else {
        nx = x + 1;
        ny = y;
    }
    g[one(x, y)].insert(one(nx, ny));
    go(nx, ny, ind + 1);
}

int h[MAXN];
int tin[MAXN], tout[MAXN];
int tt = 0;

bool in(int v, int u) {
    return (tin[v] < tin[u] && tout[u] < tout[v]);
}

int dp[13][MAXN];

void dfs(int v, int cur_h, int p) {
    dp[0][v] = p;
    h[v] = cur_h;
    tin[v] = tt;
    ++tt;
    for (auto u : g[v]) {
        dfs(u, cur_h + 1, v);
    }
    tout[v] = tt;
    ++tt;
}

void count_dp() {
    for (int i = 1; i < 13; ++i) {
        for (int v = 0; v < MAXN; ++v) {
            if ((1ll<<i) >= h[v]) {
                dp[i][v] = 0;
            } else {
                dp[i][v] = dp[i - 1][dp[i - 1][v]];
            }
        }
    }
}

int la(int v, int hh) {
    for (int i = 0; i < 13; ++i) {
        if (hh&1) {
            v = dp[i][v];
        }
        hh >>= 1;
    }
    return v;
}

int lca(int v, int u) {
    v = la(v, max((int)0, h[v] - h[u]));
    u = la(u, max((int)0, h[u] - h[v]));
    if (v == u) return v;
    for (int i = 12; i >= 0; --i) {
        int vv = dp[i][v];
        int uu = dp[i][u];
        if (vv == uu) {
            continue;
        }
        v = vv;
        u = uu;
    }
    return dp[0][v];
}

signed main() {
#ifdef DEBUG_BENTSA
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(NULL);
    cin.tie(NULL);
    cout.tie(NULL);
#endif
    cin >> n;
    vector<int> v(n);
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
        --v[i];
    }
    cur.resize(n);
    go(0, 0, 0);
    for (int i = 0; i < n; ++i) {
        cur[v[i]] = 1;
        go(0, 0, 0);
    }
    dfs(0, 0, 0);
    count_dp();
    int q;
    cin >> q;
    while (q--) {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        int a = one(x1, y1);
        int b = one(x2, y2);
        int l = lca(a, b);
        cout << l % n << " " << l / n << "\n";
    }
}
