#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <set>
#include <map>
#include <cmath>

using namespace std;
//#define int long long
const int MX = 1e9;
const int MXN = (1LL << 20);
int tree4[MXN];

inline int get3(int x) {
    int l = 0 + MXN / 2, r = x + MXN / 2;
    int sum = 0;
    while(l != r){
        if((l & 1) == 1)
            sum += tree4[l++];
        if((r & 1) == 0)
            sum += tree4[r--];
        l >>= 1;
        r >>= 1;
    }
    sum += tree4[l];
    return sum;
}

inline void update4(int x) {
    x += MXN / 2;
    while(x != 0){
        tree4[x]--;
        x >>= 1;
    }
}

vector<int> tree3;
vector<int> dob;

void built(int v = 1, int l = 0, int r = (int) tree3.size() / 4) {
    dob[v] = 0;
    if (l + 1 == r) {
        tree3[v] = l;
        return;
    }
    int mid = (l + r) >> 1;
    built(v + v, l, mid);
    built(v + v + 1, mid, r);
    tree3[v] = max(tree3[v + v], tree3[v + v + 1]);
}

inline void push(int v, int l, int r) {
    if (dob[v] == 0)
        return;
    tree3[v] += dob[v];
    if (l + 1 < r) {
        dob[v + v] += dob[v];
        dob[v + v + 1] += dob[v];
    }
    dob[v] = 0;
}

void update(int x, int v = 1, int l = 0, int r = (int) tree3.size() / 4) {
    push(v, l, r);
    if (r <= x)
        return;
    if (l >= x) {
        dob[v]--;
        push(v, l, r);
        return;
    }
    int mid = (l + r) >> 1;
    update(x, v + v, l, mid);
    update(x, v + v + 1, mid, r);
    tree3[v] = max(tree3[v + v], tree3[v + v + 1]);
}

int findpos(int x, int v = 1, int l = 0, int r = (int) tree3.size() / 4) {
    push(v, l, r);
    if (l + 1 == r)
        return l;
    int mid = (l + r) >> 1;
    push(v + v, l, mid);
    if (tree3[v + v] >= x)
        return findpos(x, v + v, l, mid);
    return findpos(x, v + v + 1, mid, r);
}

vector<int> tree2;

void upd(int x, int data, int v = 1, int l = 0, int r = (int) tree2.size() / 4) {
    if (l > x || r <= x)
        return;
    tree2[v] += data;
    if (l + 1 == r)
        return;
    int mid = (l + r) >> 1;
    upd(x, data, v + v, l, mid);
    upd(x, data, v + v + 1, mid, r);
}

int getpos(int x, int v = 1, int l = 0, int r = (int) tree2.size() / 4) {
    if (l + 1 == r)
        return l;
    int mid = (l + r) >> 1;
    if (tree2[v + v] >= x)
        return getpos(x, v + v, l, mid);
    return getpos(x - tree2[v + v], v + v + 1, mid, r);
}

vector<int> tree;

int getsum(int x, int v = 1, int l = 0, int r = (int) tree.size() / 4) {
    if (l >= x)
        return 0;
    if (r <= x)
        return tree[v];
    int mid = (l + r) >> 1;
    return getsum(x, v + v, l, mid) + getsum(x, v + v + 1, mid, r);
}

void add(int x, int v = 1, int l = 0, int r = (int) tree.size() / 4) {
    if (l > x || r <= x)
        return;
    tree[v]++;
    if (l + 1 == r)
        return;
    int mid = (l + r) >> 1;
    add(x, v + v, l, mid);
    add(x, v + v + 1, mid, r);
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<int> a(n);
    tree.resize(4 * n + 12);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<int> now(n + 1);
    for (int i = 0; i < n; ++i) {
        int sum = getsum(a[i]);
        add(a[i]);
        now[a[i]] = a[i] - sum - 1;
    }
    int q;
    cin >> q;
    vector<pair<int, int> > zap, zapnew, ans(q);
    vector<vector<int> > rem(n + 1);
    int ind = 0;
    for (int test = 0; test < q; ++test) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        zap.push_back({r1, c1});
        zap.push_back({r2, c2});
        rem[r1].push_back(ind * 2);
        rem[r2].push_back(ind * 2 + 1);
        ind++;
    }
    zapnew = zap;
    tree2.resize(4 * n + 4);
    for (int i = 0; i < n + 1; ++i)
        upd(i, 1);
    for (int row = n; row >= 0; --row) {
        for (auto u: rem[row]) {
            int x = zap[u].second;
            zapnew[u] = {n, getpos(x + 1)};
        }
        if (row > 0)
            upd(getpos(now[row] + 1), -1);
    }
    vector<pair<int, int> > binp(q);
    for (int i = 0; i < q; ++i)
        binp[i] = {-1, n};
    tree3.resize(4 * n + 4);
    dob.resize(4 * n + 4);
    built();
    vector<int> poss(n + 1, -1);
    for (int row = n; row >= 0; --row) {
        if (row > 0) {
            if (poss[row] == -1)
                poss[row] = findpos(now[row] + 1);
            int pos = poss[row];
            update(pos);
        }
    }
    for (int ttt = 0; ttt < 20; ++ttt) {
        bool fl = 0;
        rem.clear();
        rem.resize(n + 1);
        auto zap2 = zapnew;
        for (int i = 0; i < q; ++i) {
            int mid = (binp[i].first + binp[i].second) / 2;
            if (binp[i].first + 1 == binp[i].second)
                mid = binp[i].second;
            else
                fl = 1;
            rem[n - mid].push_back(i + i);
            rem[n - mid].push_back(i + i + 1);
        }
        for(int i = 0;i<MXN;++i)
            tree4[i] = 0;
        for (int row = n; row >= 0; --row) {
            for (auto u: rem[row]) {
                int c = zapnew[u].second;
                zap2[u] = {row, get3(c) + c};
            }
            int pos = poss[row];
            update4(pos);
        }
        for (int i = 0; i < q; ++i) {
            int mid = (binp[i].first + binp[i].second) / 2;
            if (binp[i].first + 1 == binp[i].second)
                mid = binp[i].second;
            if (zap2[i + i] == zap2[i + i + 1]) {
                binp[i].second = mid;
            } else
                binp[i].first = mid;
        }
        if (fl == 0) {
            zapnew = zap2;
            break;
        }
    }
    for (int test = 0; test < q; test++) {
        int f = test + test, s = test + test + 1;
        int r1 = zapnew[f].first, c1 = zapnew[f].second;
        if (r1 > zap[f].first)
            ans[test] = zap[f];
        else if (r1 > zap[s].first)
            ans[test] = zap[s];
        else
            ans[test] = {r1, c1};
        if (r1 > zap[f].first && r1 > zap[f].second)
            ans[test] = min(zap[f], zap[s]);
    }
    for (auto u: ans)
        cout << u.first << " " << u.second << "\n";
}