#include <iostream>
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#pragma GCC optimize "O0"
using namespace std;
using namespace __gnu_pbds;

typedef tree<pair<int, int>, null_type, less<pair<int, int>>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
typedef long long ll;

template<typename T> void mxu(T &a, T b) {if (a < b) a = b;}
template<typename T> void mnu(T &a, T b) {if (a > b) a = b;}

typedef vector<int> vi;
typedef vector<vector<int>> vii;
typedef pair<int, int> pii;
constexpr int MAXN = 100000;
constexpr int TREES = 524288;
int stree[TREES];
int mod[TREES];
void edfs(int u, vii &f, vi &et, int &ep) {
    et[ep++] = u;
    for (int v : f[u]) {
        edfs(v, f, et, ep);
        et[ep++] = u;
    }
}
void ddfs(int u, vii &f, vi &d) {
    for (int v : f[u]) {
        d[v] = d[u] + 1;
        ddfs(v, f, d);
    }
}
void sdfs(int u, vii &f, vi &s) {
    for (int v : f[u]) {
        sdfs(v, f, s);
        s[u] += s[v];
    }
    ++s[u];
}
void rtdfs(int u, vii &f, vi &rorder, vi &tot) {
    bool ok = true;
    for (int v : f[u]) {
        rorder.push_back(v);
        rtdfs(v, f, rorder, tot);
        if (ok) {
            ok = false;
            tot[v] = tot[u];
        } else {
            tot[v] = v;
        }
    }
}
bool impdfs(int v, vii &f, vector<pii> &vb, vi &lval) {
    ll lb = 0;
    for (int u : f[v]) {
        if (!impdfs(u, f, vb, lval)) return false;
        lb += lval[u];
    }
    if (lb > vb[v].second) return false;
    lval[v] = max((int)lb, vb[v].first);
    return true;
}
void build(int v, int l, int r, vector<pii> &vb, vi &rorder) {
    mod[v] = 0;
    if (l + 1 == r) {
        stree[v] = vb[rorder[l]].second;
        return;
    }
    int m = (l + r) >> 1;
    build(2 * v + 1, l, m, vb, rorder);
    build(2 * v + 2, m, r, vb, rorder);
    stree[v] = min(stree[2 * v + 1], stree[2 * v + 2]);
}
int mnquery(int v, int l, int r, int ql, int qr) {
    if (qr <= l || r <= ql) return 1000000000 + mod[v];
    if (ql <= l && r <= qr) return stree[v] + mod[v];
    int m = (l + r) >> 1;
    return min(mnquery(2*v+1,l,m,ql,qr), mnquery(2*v+2,m,r,ql,qr)) + mod[v];
}
void chg(int v, int l, int r, int ql, int qr, int x) {
    if (qr <= l || r <= ql) return;
    if (ql <= l && r <= qr) {mod[v] -= x; return;}
    int m = (l + r) >> 1;
    chg(2 * v + 1, l, m, ql, qr, x);
    chg(2 * v + 2, m, r, ql, qr, x);
}

void solve()
{
    int n;
    cin >> n;
    int cubs = 1;
    while (cubs < n) cubs *= 2;

    vector<int> p(n);
    vector<vector<int>> f(n);
    for (int i = 1; i < n; ++i) {
        int u;
        cin >> u;
        --u;
        p[i] = u;
        f[u].push_back(i);
    }
    vector<int> c(n);
    for (int &x : c) cin >> x;

    vector<pii> vb(n);
    for (int i = 0; i < n; ++i) cin >> vb[i].first >> vb[i].second;
    vector<int> lval(n);
//    cout << "\n\n";
    if (!impdfs(0, f, vb, lval)) {
//        for (auto &x : lval) cout << x << ' ';
//        cout << '\n';
        cout << -1 << '\n';
        return;
    }

    vector<int> s(n);
    sdfs(0, f, s);
    for (auto &x : f) sort(x.begin(), x.end(), [&](int u, int v){return s[u] > s[v];});
    //
    vector<int> rorder;
    rorder.push_back(0);
    vector<int> tot(n);
    rtdfs(0, f, rorder, tot);
    vector<int> pinr(n);
//    for (auto &x : rorder) cout << x << ' ';
//    cout << '\n';
    for (int i = 0; i < n; ++i) pinr[rorder[i]] = i;
    build(0, 0, n, vb, rorder);



    vector<int> et(2 * n - 1);
    int ep = 0;
    edfs(0, f, et, ep);
    vector<int> d(n);
    ddfs(0, f, d);
    vector<int> lb(n);
    vector<int> rb(n);
    int ets = 2 * n - 1;
    for (int i=ets-1; i> -1; --i) lb[et[i]] = i;
    for (int i = 0; i < ets; ++i) rb[et[i]] = i + 1;

    vector<ordered_set> tt;
    vector<int> osp(n);
    vector<int> take(n);

    vector<bool> meet(n);
    vector<int> etdir(n);
    int etdp = n;
    for (int &v : et) {
        if (meet[v]) continue;
        meet[v] = true;
        etdir[--etdp] = v;
    }
//    cout << "begin greed\n";
//    for (auto &x : lval) cout << x << ' ';
//    cout << '\n';
    for (int v : etdir) {
//        cout << v << '\n';
        int ctake = 0;
        if (f[v].empty()) {
            osp[v] = (int)tt.size();
            tt.push_back(ordered_set());
        } else {
            osp[v] = osp[f[v][0]];
            ctake += lval[f[v][0]];
            for (int j = 1; j < (int)f[v].size(); ++j) {
                int u = f[v][j];
//                cout << u << ' ' << osp[u] << '\n';
                if (tt[osp[v]].size() < tt[osp[u]].size()) swap(osp[u], osp[v]);
                for (auto &x : tt[osp[u]]) tt[osp[v]].insert(x);
                tt[osp[u]].clear();
                ctake += lval[u];
            }
        }
        tt[osp[v]].insert(pair<int, int>(c[v], v));
//        int df = mnquery(0, 0, n, pinr[v], pinr[v] + 1); //what remains
        int df = vb[v].first - ctake;
//        cout << "remains " << df << '\n';
        while (df > 0) {
            pair<int, int> tval = *tt[osp[v]].begin();
            int alow = 1000000000;
            int iv = tval.second;
            int ub;
            do {
                ub = tot[iv];
                alow = min(alow, mnquery(0, 0, n, pinr[ub], pinr[iv] + 1));
                iv = p[ub];
            } while (iv != ub);
            iv = tval.second;
            int rm = min(alow, df);
            take[iv] += rm;
            do {
                ub = tot[iv];
                chg(0, 0, n, pinr[ub], pinr[iv] + 1, rm);
                iv = p[ub];
            } while (iv != ub);
            iv = tval.second;
            if (rm == alow) tt[osp[v]].erase(tt[osp[v]].begin());
            df -= rm;
//            cout << "bd to " << df << '\n';
        }
//        for (auto &x : take) cout << x << ' ';
//        cout << "\n\n";
    }
    ll ans = 0;
    for (int i = 0; i < n; ++i) ans += (ll)take[i] * c[i];
    cout << ans << '\n';
    for (auto &x : take) cout << x << ' ';
    cout << '\n';
//    cout << "\n\n";

}
signed main() {

    int t;
    cin >> t;
    while (t--) solve();
}





