#include <bits/stdc++.h>

using namespace std;
#define int long long
const int INF = 1e9 + 1;

struct SegTree {
    int n;
    vector <int> p;
    vector <pair <int, int>> t;

    inline SegTree(int n, vector <int>& a): n(n) {
        t.resize(4 * n);
        p.resize(4 * n);
        build(1, 0, n - 1, a);
    }

    void build(int v, int l, int r, vector <int>& a) {
        if (l == r) {
            t[v] = make_pair(a[l], l);
            return;
        }
        int m = (l + r) / 2;
        build(2 * v, l, m, a);
        build(2 * v + 1, m + 1, r, a);
        t[v] = min(t[2 * v], t[2 * v + 1]);
    }

    inline void push(int v) {
        t[2 * v].first += p[v];
        t[2 * v + 1].first += p[v];
        p[2 * v] += p[v];
        p[2 * v + 1] += p[v];
        p[v] = 0;
    }

    void update(int v, int l, int r, int A, int B, int x) {
        if (l > B || A > r) return;
        if (A <= l && r <= B) {
            t[v].first += x;
            p[v] += x;
            return;
        }
        push(v);
        int m = (l + r) / 2;
        update(2 * v, l, m, A, B, x);
        update(2 * v + 1, m + 1, r, A, B, x);
        t[v] = min(t[2 * v], t[2 * v + 1]);
    }

    inline void update(int l, int r, int x) {
        update(1, 0, n - 1, l, r, x);
    }

    pair <int, int> get_min(int v, int l, int r, int A, int B) {
        if (l > B || A > r) return make_pair(INF, INF);
        if (A <= l && r <= B) return t[v];
        push(v);
        int m = (l + r) / 2;
        return min(get_min(2 * v, l, m, A, B), get_min(2 * v + 1, m + 1, r, A, B));
    }

    inline pair <int, int> get_min(int l, int r) {
        return get_min(1, 0, n - 1, l, r);
    }
};

vector <vector <int>> g;
vector <int> gl, pr, num, c, l, r, last, sz, ord, b;

void dfs1(int v) {
    sz[v] = 1;
    for (int i : g[v]) {
        gl[i] = gl[v] + 1;
        dfs1(i);
        sz[v] += sz[i];
    }
}

void dfs2(int v, int& cur_time) {
    num[v] = cur_time;
    ord.push_back(v);
    ++cur_time;
    if (g[v].empty()) return;
    int mx = 0;
    for (int i = 1; i < (int)g[v].size(); ++i) {
        if (sz[g[v][i]] > sz[g[v][mx]]) mx = i;
    }
    swap(g[v][0], g[v][mx]);
    bool f = false;
    for (int i : g[v]) {
        if (f) {
            last[i] = i;
            dfs2(i, cur_time);
        } else {
            f = true;
            last[i] = last[v];
            dfs2(i, cur_time);
        }
    }
}

inline pair <int, int> get_path(int v, SegTree& cnt) {
    pair <int, int> mn(INF, INF);
    while (v >= 0) {
        int la = last[v];
        mn = min(mn, cnt.get_min(num[la], num[v]));
        v = pr[la];
    }
    return mn;
}

inline void upd_path(int v, int x, SegTree& cnt) {
    while (v >= 0) {
        int la = last[v];
        cnt.update(num[la], num[v], x);
        v = pr[la];
    }
}

bool make_ans(int v, SegTree& cnt, SegTree& flex) {
    for (int i : g[v]) {
        if (!make_ans(i, cnt, flex)) return false;
    }
    bool ok = false;
    while (true) {
        int val = r[v] - cnt.get_min(num[v], num[v]).first;
        if (val >= l[v]) {
            ok = true;
            break;
        }
        int need = l[v] - val;
        auto mn = flex.get_min(num[v], num[v] + sz[v] - 1);
        if (mn.first >= INF) break;
        auto can_push = get_path(ord[mn.second], cnt);
        if (can_push.first < need) {
            b[ord[can_push.second]] += can_push.first;
            upd_path(ord[mn.second], -can_push.first, cnt);
            flex.update(can_push.second, can_push.second + sz[ord[can_push.second]] - 1, INF);
        } else {
            b[ord[can_push.second]] += need;
            upd_path(ord[mn.second], -need, cnt);
            ok = true;
            break;
        }
    }
    return ok;
}

signed main() {
    if (1) {
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
        cout.tie(nullptr);
    }
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        g.assign(n, {});
        gl.assign(n, 0);
        pr.assign(n, 0);
        num.assign(n, 0);
        c.assign(n, 0);
        l.assign(n, 0);
        r.assign(n, 0);
        last.assign(n, 0);
        sz.assign(n, 0);
        b.assign(n, 0);
        pr[0] = -1;
        for (int i = 1; i < n; ++i) {
            cin >> pr[i]; --pr[i];
            g[pr[i]].push_back(i);
        }
        for (int i = 0; i < n; ++i) cin >> c[i];
        for (int i = 0; i < n; ++i) cin >> l[i] >> r[i];
        dfs1(0);
        int cur_time = 0;
        dfs2(0, cur_time);
        SegTree cnt(n, r), flex(n, c);
        if (make_ans(0, cnt, flex)) {
            long long answer = 0;
            for (int i = 0; i < n; ++i) answer += (long long)b[i] * (long long)c[i];
            cout << answer << "\n";
            for (int i = 0; i < n; ++i) cout << b[i] << " ";
            cout << "\n";
        } else {
            cout << "-1\n";
        }
    }
    return 0;
}
