#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;
using vi = vector<int>;
using vvi = vector<vi>;
using vl = vector<ll>;
using vvl = vector<vl>;

const int MAXR = 1000;
const ll INFL = 2e18;

void relax(vl& dp, vl& d) {
    int n = dp.size();
    vl res(dp);
    for (int i = 0; i < n; ++i) {
        for (int l = 0; l <= i; ++l) {
            res[i] = min(res[i], dp[l] + d[i - l]);
        }
    }
    dp.assign(res.begin(), res.end());
}

void relax2(vl& dp, int c) {
    int n = dp.size();
    vl res(dp);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j + i < n; ++j) {
            res[i + j] = min(res[i + j], dp[j] + c * 1LL * i);
        }
    }
}

void dfs(int v, vvi& ch, vi& c, vvl& dp) {
    for (int i : ch[v]) {
        relax(dp[v], dp[i]);
    }
    relax2(dp[v], c[v]);
}

void solve() {
    int n;
    cin >> n;
    vi p(n, -1), c(n), l(n), r(n);
    vvi ch(n);
    vvl dp(n, vl(MAXR + 1, INFL));
    for (int i = 1; i < n; ++i) {
        cin >> p[i];
        --p[i];
        ch[p[i]].push_back(i);
    }
    for (int i = 0; i < n; ++i) {
        cin >> c[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
    }
    dfs(0, ch, c, dp);
}

int main() {
    int t;
    cin >> t;
    for (; t; --t) {
        solve();
    }
    return 0;
}
