#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;
using vi = vector<int>;
using vvi = vector<vi>;
using vl = vector<ll>;
using vvl = vector<vl>;

const ll INFL = 2e18;

bool is_par0(int rp, int cp, int r, int c, const vvi& up) {
    while (r >= rp) {
        if (r == rp && c == cp) {
            return true;
        }
        c = up[r][c];
        --r;
    }
    return false;
}

bool is_par(int rp, int cp, int r, int c) {
    return cp <= c && rp - cp <= r - c;
}

void ans0(int r1, int c1, int r2, int c2, int& r3, int& c3, const vector<int>& v, const vvi& up) {
    while (r1 > r2) {
        c1 = up[r1][c1];
        --r1;
    }
    while (r2 > r1) {
        c2 = up[r2][c2];
        --r2;
    }
    while (r1 >= 0) {
        if (r1 == r2 && c1 == c2) {
            r3 = r1;
            c3 = c1;
            return;
        }
        c1 = up[r1][c1];
        --r1;
        c2 = up[r2][c2];
        --r2;
    }
}

void ans(int r1, int c1, int r2, int c2, int& r3, int& c3, const vector<int>& v, const vvi& up) {
    if (is_par0(r1, c1, r2, c2, up)) {
        r3 = r1;
        c3 = c1;
        return;
    }
    if (is_par0(r2, c2, r1, c1, up)) {
        r3 = r2;
        c3 = c2;
        return;
    }

    int n = v.size();
    for (int i = n - 1; i >= 0; --i) {
        if (is_par(i, v[i], r1, c1) && is_par(i, v[i], r2, c2)) {
            r3 = i;
            c3 = v[i];
            return;
        }
    }
}

void solve() {
    int n, c1, r1, c2, r2, r3 = 0, c3 = 0;
    cin >> n;
    vi a(n), p(n + 1), v(n), t(n + 1);
    vvi up(n + 1, vi(n + 1, -1));
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i <= n; ++i) {
        t[i] = i;
        up[i][i] = i - 1;
    }
    for (int i = 0; i < n; ++i) {
        for (int j = a[i]; j <= n; ++j) {
            --t[j];
            up[j][t[j]] = t[j - 1];
        }
        v[a[i] - 1] = t[a[i] - 1];
    }

    int q;
    cin >> q;
    for (; q; --q) {
        cin >> r1 >> c1 >> r2 >> c2;
        ans0(r1, c1, r2, c2, r3, c3, v, up);
        cout << r3 << ' ' << c3 << '\n';
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}
