#include <iostream>
#include <algorithm>

#pragma GCC optimise("O3")
#pragma GCC target("avx2")

const int maxN = 5e5, SZ = 3e7;

struct Item {
	int l, r, sum;
} t[SZ];

int n, a[maxN], q, r1, c1, r2, c2, ans1, ans2, it, ver1[maxN + 1], ver2[maxN + 1], l, r, pos[maxN + 1];

void build(int& i, int tl, int tr) {
	i = it++;
	if (tr - tl == 1)
		return;
	int tm = (tl + tr) / 2;
	build(t[i].l, tl, tm);
	build(t[i].r, tm, tr);
}

void update(int& i, int tl, int tr, int id) {
	t[it] = t[i];
	i = it++;
	t[i].sum++;
	if (tr - tl == 1)
		return;
	int tm = (tl + tr) / 2;
	if (id < tm)
		update(t[i].l, tl, tm, id);
	else
		update(t[i].r, tm, tr, id);
}

int get(int i, int tl, int tr, int l, int r) {
	if (l <= tl && tr <= r)
		return t[i].sum;
	if (r <= tl || tr <= l)
		return 0;
	int tm = (tl + tr) / 2;
	return get(t[i].l, tl, tm, l, r) + get(t[i].r, tm, tr, l, r);
}

int get1(int i, int j, int tl, int tr) {
	if (tr - tl == 1)
		return tl - 1;
	int tm = (tl + tr) / 2;
	if (t[t[i].l].sum != t[t[j].l].sum)
		return get1(t[i].l, t[j].l, tl, tm);
	else
		return get1(t[i].r, t[j].r, tm, tr);
}

int get2(int i, int tl, int tr, int x) {
	if (tr - tl == 1)
		return tl;
	int tm = (tl + tr) / 2;
	if (t[t[i].l].sum >= x)
		return get2(t[i].l, tl, tm, x);
	else
		return get2(t[i].r, tm, tr, x - t[t[i].l].sum);
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(0);
	std::cout.tie(0);
	std::cin >> n;
	for (int i = 0; i < n; i++) {
		std::cin >> a[i];
		pos[a[i]] = i;
	}
	build(ver1[0], 0, n + 1);
	for (int i = 0; i < n; i++) {
		ver1[i + 1] = ver1[i];
		update(ver1[i + 1], 0, n + 1, a[i]);
	}
	build(ver2[0], 0, n + 1);
	for (int i = 1; i <= n; i++) {
		ver2[i] = ver2[i - 1];
		update(ver2[i], 0, n, pos[i]);
	}
	std::cin >> q;
	while (q--) {
		std::cin >> r1 >> c1 >> r2 >> c2;
		if (r1 - c1 == 0)
			ans1 = 0;
		else
			ans1 = get2(ver2[r1], 0, n, r1 - c1) + 1;
		if (r2 - c2 == 0)
			ans2 = 0;
		else
			ans2 = get2(ver2[r2], 0, n, r2 - c2) + 1;
		if (ans1 == ans2) {
			if (r1 > r2) {
				std::swap(r1, r2);
				std::swap(c1, c2);
			}
		}
		else {
			if (ans1 > ans2) {
				std::swap(ans1, ans2);
				std::swap(r1, r2);
				std::swap(c1, c2);
			}
			int temp = get1(ver1[ans1], ver1[ans2], 0, n + 1);
			r1 = std::min(r1, temp);
			c1 = r1 - get(ver1[ans2], 0, n + 1, 0, r1 + 1);
		}
		std::cout << r1 << " " << c1 << "\n";
	}
	return 0;
}