#include <iostream>
#include <algorithm>

const int maxN = 5e5, SZ = 1e7;

struct Item {
	int l, r, sum;
} t[SZ];

int n, a[maxN], q, r1, c1, r2, c2, ans1, ans2, it, ver[maxN + 1], l, r;

void build(int& i, int tl, int tr) {
	i = it++;
	if (tr - tl == 1)
		return;
	int tm = (tl + tr) / 2;
	build(t[i].l, tl, tm);
	build(t[i].r, tm, tr);
}

void update(int& i, int tl, int tr, int id) {
	t[it] = t[i];
	i = it++;
	t[i].sum++;
	if (tr - tl == 1)
		return;
	int tm = (tl + tr) / 2;
	if (id < tm)
		update(t[i].l, tl, tm, id);
	else
		update(t[i].r, tm, tr, id);
}

int get(int i, int tl, int tr, int l, int r) {
	if (l <= tl && tr <= r)
		return t[i].sum;
	if (r <= tl || tr <= l)
		return 0;
	int tm = (tl + tr) / 2;
	return get(t[i].l, tl, tm, l, r) + get(t[i].r, tm, tr, l, r);
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(0);
	std::cout.tie(0);
	std::cin >> n;
	for (int i = 0; i < n; i++)
		std::cin >> a[i];
	build(ver[0], 0, n);
	for (int i = 0; i < n; i++) {
		ver[i + 1] = ver[i];
		update(ver[i + 1], 0, n, a[i] - 1);
	}
	std::cin >> q;
	while (q--) {
		std::cin >> r1 >> c1 >> r2 >> c2;
		l = -1;
		r = n;
		while (r - l > 1) {
			int m = (l + r) / 2;
			if (get(ver[m], 0, n, 0, r1) < r1 - c1)
				l = m;
			else
				r = m;
		}
		ans1 = l + 1;
		l = -1;
		r = n;
		while (r - l > 1) {
			int m = (l + r) / 2;
			if (get(ver[m], 0, n, 0, r2) < r2 - c2)
				l = m;
			else
				r = m;
		}
		ans2 = l + 1;
		if (ans1 == ans2) {
			if (r1 > r2) {
				std::swap(r1, r2);
				std::swap(c1, c2);
			}
		}
		else {
			if (ans1 > ans2) {
				std::swap(ans1, ans2);
				std::swap(r1, r2);
				std::swap(c1, c2);
			}
			l = 0;
			r = r1 + 1;
			while (r - l > 1) {
				int m = (l + r) / 2;
				if (get(ver[ans1], 0, n, 0, m) == get(ver[ans2], 0, n, 0, m))
					l = m;
				else
					r = m;
			}
			r1 = l;
			c1 = r1 - get(ver[ans2], 0, n, 0, r1);
		}
		std::cout << r1 << " " << c1 << "\n";
	}
	return 0;
}