#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <queue>
using namespace std;

#define endl '\n'

#pragma GCC optimize("Ofast")

long long timer = 0;

short int mm = 17;

struct Node
{
	vector<pair<short int, short int>> to;
	pair<short int, short int> parent = { -1, -1 };

	vector<pair<short int, short int>> up = vector<pair<short int, short int>>(mm);

	short int tin = -1;
	short int tout = -1;

	bool used = false;
};

vector<vector<Node>> graph;

void dfs(short int vx, short int vy)
{
	graph[vx][vy].tin = ++timer;

	for (short int i = 0; i < graph[vx][vy].to.size(); i++)
	{
		short int ux = graph[vx][vy].to[i].first;
		short int uy = graph[vx][vy].to[i].second;

		dfs(ux, uy);
	}

	graph[vx][vy].tout = ++timer;
}

bool is_parent(pair<short int, short int> x, pair<short int, short int> y)
{
	short int x1 = x.first;
	short int y1 = x.second;

	short int x2 = y.first;
	short int y2 = y.second;

	if (graph[x1][y1].tin <= graph[x2][y2].tin && graph[x1][y1].tout >= graph[x2][y2].tout)
	{
		return true;
	}
	else
	{
		return false;
	}
}

pair<short int, short int> lca(pair<short int, short int> p1, pair<short int, short int> p2)
{
	if (is_parent(p1, p2))
	{
		return p1;
	}
	else if (is_parent(p2, p1))
	{
		return p2;
	}

	for (short int i = mm - 1; i >= 0; i--)
	{
		pair<short int, short int> np = graph[p1.first][p1.second].up[i];

		if (!is_parent(np, p2))
		{
			p1 = np;
		}
	}

	return graph[p1.first][p1.second].up[0];
}

void task()
{
	short int n;
	cin >> n;

	graph.resize(n + 1);

	for (short int i = 0; i < n + 1; i++)
	{
		graph[i].resize(i + 1);
	}

	vector<short int> route(n, 1);
	pair<short int, short int> cur = { 0,0 };

	for (short int i = 0; i < n; i++)
	{
		pair<short int, short int> ne = cur;
		ne.first++;
		ne.second += route[i];

		if (!graph[ne.first][ne.second].used)
		{
			graph[ne.first][ne.second].used = true;
			graph[cur.first][cur.second].to.push_back({ ne.first, ne.second });
		}

		cur = ne;

		graph[cur.first][cur.second].parent = { cur.first - 1, cur.second - route[i] };
	}

	for (short int i = 0; i < n; i++)
	{
		short int f;
		cin >> f;
		f--;

		route[f] = 0;

		cur = { 0,0 };

		for (short int i = 0; i < n; i++)
		{
			pair<short int, short int> ne = cur;
			ne.first++;
			ne.second += route[i];

			if (!graph[ne.first][ne.second].used)
			{
				graph[ne.first][ne.second].used = true;
				graph[cur.first][cur.second].to.push_back({ ne.first, ne.second });
			}

			cur = ne;

			graph[cur.first][cur.second].parent = { cur.first - 1, cur.second - route[i] };
		}
	}

	for (short int i = 0; i < n + 1; i++)
	{
		for (short int j = 0; j < n + 1; j++)
		{
			if (graph[i][j].parent != make_pair((short int)-1, (short int)-1) && j<=i)
			{
				graph[i][j].up[0] = graph[i][j].parent;
			}
		}
	}

	for (short int k = 1; k < mm; k++)
	{
		for (short int i = 0; i < n + 1; i++)
		{
			for (short int j = 0; j < n + 1; j++)
			{
				if (graph[i][j].parent != make_pair((short int)-1, (short int)-1) && j<=i)
				{
					short int px = graph[i][j].up[k - 1].first;
					short int py = graph[i][j].up[k - 1].second;
					graph[i][j].up[k] = graph[px][py].up[k - 1];
				}
			}
		}
	}

	dfs(0, 0);

	short int q;
	cin >> q;

	while (q--)
	{
		short int a, b, c, d;
		cin >> a >> b >> c >> d;

		pair<short int, short int> l = lca({ a,b }, { c,d });

		cout << l.first << ' ' << l.second << endl;
	}
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	task();

	return 0;
}