#include <bits/stdc++.h>
#define int long long
using namespace std;

struct solve {
    vector<vector<int>> g;
    vector<int> l, r, c, b, a, p;

    int min_path(int u) {
        int res = LLONG_MAX;
        while (u) {
            res = min(res, r[u] - a[u]);
            u = p[u];
        }
        return res;
    }

    void add_path(int u, int val) {
        while (u) {
            a[u] += val;
            u = p[u];
        }
    }

    vector<deque<int>> A;

    bool dfs(int u) {
        if (g[u].empty()) {
            int res = min_path(u);
            if (res < l[u]) {
                return false;
            }
            else {
                A[u].push_back(u);
                b[u] += l[u];
                add_path(u, l[u]);
                return true;
            }
        }

        A[u].push_back(u);
        for (int v : g[u]) {
            bool res = dfs(v);
            if (!res) return false;
            deque<int> B;
            merge(A[u].begin(), A[u].end(), A[v].begin(), A[v].end(), back_inserter(B), [&](int u, int v){return c[u] < c[v];});
            swap(A[u], B);
        }

        if (a[u] < l[u]) {
            int cnt = l[u] - a[u];

            while (cnt) {
                int v = A[u].front();
                int res = min_path(v);
                if (res == 0) {
                    A[u].pop_front();
                    continue;
                }
                int push = min(res, cnt);
                cnt -= push;
                add_path(v, push);
                b[v] += push;
            }
        }
        return true;
    }

    solve() {
        int n; cin >> n;
        g.resize(n + 1);
        p.resize(n + 1);
        l.resize(n + 1);
        r.resize(n + 1);
        c.resize(n + 1);
        b.resize(n + 1);
        a.resize(n + 1);
        A.resize(n + 1);

        for (int u = 2; u <= n; u++) {
            int v; cin >> v;
            p[u] = v;
            g[v].push_back(u);
        }

        for (int u = 1; u <= n; u++) {
            cin >> c[u];
        }

        for (int u = 1; u <= n; u++) {
            cin >> l[u] >> r[u];
        }

        bool res = dfs(1);
        if (!res) {
            cout << -1 << "\n";
        }
        else {
            int ans = 0;
            for (int i = 1; i <= n; i++) {
                ans += b[i] * c[i];
            }
            cout << ans << "\n";
            for (int i = 1; i <= n; i++) {
                cout << b[i] << " ";
            }
            cout << "\n";
        }
    }
};

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t; cin >> t;
    while (t--) solve();
    return 0;
}