#include <bits/stdc++.h>

#define debug(x) cerr << (#x) << " = " << (x) << "\n";
#define len(x) ((int) (x).size())

using namespace std;
typedef long long ll;


const int INF_I = 0x3f3f3f3f;


void config_io() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout << fixed;
    cout.precision(20);
}


void solve();


int main() {
    config_io();
    solve();
    return 0;
}


int n;
vector<int> p;
vector<vector<int>> g;
vector<int> h;


int num(int r, int c) {
    return r * (n + 1) + c;
}


void dfs(int v) {
    for (int u : g[v]) {
        h[u] = h[v] + 1;
        dfs(u);
    }
}


void solve() {
    int q;
    cin >> n;

    vector<int> cmd(n, 1);
    p.resize((n + 1) * (n + 1), -1);
    g.resize((n + 1) * (n + 1));
    h.resize((n + 1) * (n + 1), - 1);
    h[0] = 0;

    int r = 0, c = 0;
    for (int j = 0; j < n; ++j) {
        int cur = num(r, c), next;
        r++;
        c += cmd[j];

        next = num(r, c);
        g[cur].push_back(next);
        p[next] = cur;
    }

    for (int i = 0; i < n; ++i) {
        int ai;
        cin >> ai;
        cmd[ai - 1] = 0;

        int r = 0, c = 0;
        for (int j = 0; j < n; ++j) {
            int cur = num(r, c), next;
            r++;
            c += cmd[j];

            next = num(r, c);
            g[cur].push_back(next);
            p[next] = cur;
        }
    }

    dfs(0);

    cin >> q;
    for (int i = 0; i < q; ++i) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        int nu1 = num(r1, c1), nu2 = num(r2, c2);

        while (nu1 != nu2) {
            if (h[nu1] >= h[nu2]) {
                nu1 = p[nu1];
            } else {
                nu2 = p[nu2];
            }
        }

        cout << nu1 / (n + 1) << " " << nu1 % (n + 1) << "\n";
    }
}


/*
3
2 3 1
5
3 3 3 0
2 2 2 1
1 0 3 1
3 1 3 2
2 2 2 2
 */
