#include <bits/stdc++.h>
using namespace std;

#define int long long

const int inf = 1e10;
int n;

vector<vector<int>> graph;
vector<int> siz;
vector<int> euler;
vector<int> euler_pos;

vector<int> cost;
vector<int> lo;
vector<int> hi;
vector<int> par;

void dfs_sz(int v) {
    siz[v] = 1;
    for (int i : graph[v]) {
        dfs_sz(i);
        siz[v] += siz[i];
    }
}

vector<int> start;

void dfs_euler(int v, int st = -1) {
    euler.push_back(v);
    if (st == -1) start[v] = v;
    else start[v] = st;
    int mx = -1;
    for (int i : graph[v]) {
        if (mx == -1 || siz[mx] < siz[i]) mx = i;
    }
    if (mx != -1) dfs_euler(mx, start[v]);
    for (int i : graph[v]) {
        if (i != mx) dfs_euler(i, -1);
    }
}

struct node {
    int cost, left, add, cost_i = 0;
    node() {}
};

vector<node> tree;

void push(int v) {
    tree[2 * v].add += tree[v].add;
    tree[2 * v + 1].add += tree[v].add;
    tree[v].add = 0;
}

void pull(int v, int l, int r) {
    int m = (l + r) / 2;
    tree[v].cost = min(tree[2 * v].cost, tree[2 * v + 1].cost);
    if (tree[2 * v].cost < tree[2 * v + 1].cost) tree[v].cost_i = tree[2 * v].cost_i;
    else tree[v].cost_i = tree[2 * v + 1].cost_i;
    tree[v].left = min(tree[2 * v].left + tree[2 * v].add, tree[2 * v + 1].left + tree[2 * v + 1].add);
}

void build(int v, int l, int r) {
    if (l == r - 1) {
        tree[v].cost = cost[euler[l - 1]];
        tree[v].cost_i = euler[l - 1];
        tree[v].left = hi[euler[l - 1]];
    }
    else {
        int m = (l + r) / 2;
        build(2 * v, l, m);
        build(2 * v + 1, m, r);
        pull(v, l, r);
    }
}

void update_cost(int v, int l, int r, int i) {
    if (l == r - 1) {
        tree[v].cost = inf;
    }
    else {
        int m = (l + r) / 2;
        push(v);
        if (i < m) update_cost(2 * v, l, m, i);
        else update_cost(2 * v + 1, m, r, i);
        pull(v, l, r);
    }
}

void update_left(int v, int l, int r, int ql, int qr, int x) {
    if (ql >= r || l >= qr) return;
    if (ql <= l && r <= qr) {
        tree[v].add += x;
        return;
    }
    int m = (l + r) / 2;
    push(v);
    update_left(2 * v, l, m, ql, qr, x);
    update_left(2 * v + 1, m, r, ql, qr, x);
    pull(v, l, r);
}

pair<int, int> get_cost(int v, int l, int r, int ql, int qr) {
    if (l >= qr || ql >= r) return {inf, -1};
    if (ql <= l && r <= qr) return {tree[v].cost, tree[v].cost_i};
    int m = (l + r) / 2;
    return min(get_cost(2 * v, l, m, ql, qr), get_cost(2 * v + 1, m, r, ql, qr));
}

int get_left(int v, int l, int r, int ql, int qr) {
    if (l >= qr || ql >= r) return inf;
    if (ql <= l && r <= qr) return tree[v].left + tree[v].add;
    int m = (l + r) / 2;
    push(v);
    int a = get_left(2 * v, l, m, ql, qr);
    int b = get_left(2 * v + 1, m, r, ql, qr);
    pull(v, l, r);
    return min(a, b);
}

pair<int, int> get_cost(int v) {
    return get_cost(1, 1, n + 1, euler_pos[v] + 1, euler_pos[v] + siz[v] + 1);
}

int get_left_on_way(int v) {
    int ans = inf;
    while (v != -1) {
        int curr = get_left(1, 1, n + 1, euler_pos[start[v]] + 1, euler_pos[v] + 1 + 1);
        ans = min(ans, curr);
        v = par[start[v]];
    }
    return ans;
}

int get_left(int v) {
    return get_left(1, 1, n + 1, euler_pos[v] + 1, euler_pos[v] + 1 + 1);
}

void update_cost(int v) {
    update_cost(1, 1, n + 1, euler_pos[v] + 1);
}

void update_left(int v, int x) {
    while (v != -1) {
        update_left(1, 1, n + 1, euler_pos[start[v]] + 1, euler_pos[v] + 1 + 1, x);
        v = par[start[v]];
    }
}

bool good;
vector<int> ans_by_v;

void dfs(int v) {
    if (!good) return;
    for (int i : graph[v]) dfs(i);
    int lft = get_left(v);
    if (lft < 0) {
        good = false;
        return;
    }
    int curr = hi[v] - lft;
//    cout << hi[v] << " " << lft << "\n";
//    cout << v << " " << curr << "\n";

    if (curr >= lo[v]) return;
    while (true) {
        auto min_in_subtree = get_cost(v);
//        cout << v << " " << min_in_subtree.first << " " << min_in_subtree.second << "\n";
        if (min_in_subtree.first == inf) break;
        int how_many = get_left_on_way(min_in_subtree.second);
//        cout << how_many << "\n";
//        for (auto t : tree) cout << t.left << " ";
//        cout << "\n";
        if (how_many < 0) {
            good = false;
            return;
        }
        if (how_many >= lo[v] - curr) {
            update_left(min_in_subtree.second, curr - lo[v]);
            ans_by_v[min_in_subtree.second] += lo[v] - curr;
            curr = lo[v];
            break;
        }
        else {
            update_left(min_in_subtree.second, -how_many);
            curr += how_many;
            ans_by_v[min_in_subtree.second] += how_many;
            update_cost(min_in_subtree.second);
        }
    }
//    cout << curr << " " << lo[v] << "\n";
//    cout << "CRINGE\n";
    if (curr < lo[v]) {
        update_left(v, curr - lo[v]);
        ans_by_v[v] += lo[v] - curr;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    for (int useless = 0; useless < t; useless++) {
        cin >> n;
        graph.assign(n, vector<int>());
        par.assign(n, -1);
        cost.resize(n);
        lo.resize(n);
        hi.resize(n);
        for (int i = 0; i < n - 1; i++) {
            int p;
            cin >> p;
            graph[p - 1].push_back(i + 1);
            par[i + 1] = p - 1;
        }
        for (int i = 0; i < n; i++) cin >> cost[i];
        for (int i = 0; i < n; i++) cin >> lo[i] >> hi[i];
        siz.resize(n);
        euler.clear();
        start.resize(n);
        dfs_sz(0);
        dfs_euler(0);
        euler_pos.resize(n);
        for (int i = 0; i < n; i++) euler_pos[euler[i]] = i;
        tree.assign(4 * n, node());
        good = true;
        build(1, 1, n + 1);
//        for (auto t : tree) cout << t.left << " ";
//        cout << "\n";
        ans_by_v.assign(n, 0);
        dfs(0);
        if (!good) cout << -1 << "\n";
        else {
            int ans = 0;
            for (int i = 0; i < n; i++) {
                ans += ans_by_v[i] * cost[i];
            }
            cout << ans << "\n";
            for (int i : ans_by_v) cout << i << " ";
            cout << "\n";
        }
    }
}