#include <iostream>
#include <vector>
#include <algorithm>
#include <bitset>

using namespace std;

#define int long long

const int MAXN = 1e5;
const int inf = 9e18 + 1329;

int p[MAXN];
vector <int> g[MAXN];
int l[MAXN];
int r[MAXN];
int c[MAXN];
int ans;
int res[MAXN];
int res2[MAXN];
vector <int> eu;
int beg[MAXN], en[MAXN];
int t[4 * MAXN];
int n;
bitset <MAXN> used;

void build(int i, int l, int r) {
	if (l + 1 == r) {
		t[i] = l;
		return;
	}
	build(2 * i + 1, l, (l + r) / 2);
	build(2 * i + 2, (l + r) / 2, r);
}

void update(int i, int l, int r, int ind) {
	while (l + 1 != r) {
		if (ind < (l + r) / 2) {
			i = 2 * i + 1;
			r = (l + r) / 2;
		}
		else {
			i = 2 * i + 2;
			l = (l + r) / 2;
		}
	}
	for (i >>= 1; i >= 0; i = (i - 1) >> 1) {
		if (c[t[2 * i + 1]] < c[t[2 * i + 2]]) {
			t[i] = t[2 * i + 1];
		}
		else {
			t[i] = t[2 * i + 2];
		}
	}
}

int get(int i, int l, int r, int ql, int qr) {
	if (qr <= l || ql >= r) return n;
	if (ql <= l && r <= qr) return t[i];
	int t1 = get(2 * i + 1, l, (l + r) / 2, ql, qr), t2 = get(2 * i + 2, (l + r) / 2, r, ql, qr);
	if (c[t1] < c[t2]) return t1;
	else return t2;
}

void f(int v) {
	beg[v] = eu.size();
	eu.push_back(v);
	for (int u : g[v]) f(u);
	en[v] = eu.size();
}

void del(int v) {
	c[v] = inf;
	update(0, 0, n, beg[v]);
	used[v] = 1;
	for (int u : g[v]) if (!used[u]) del(u);
}

int dfs(int v) {
	int vl = 0, vr = 0;
	int mn = v;
	for (int u : g[v]) {
		vl += l[u];
		vr += r[u];
		int y = dfs(u);
		if (c[y] < c[mn]) mn = y;
	}
	if (vl > l[v]) l[v] = vl;
	if (vl > r[v]) {
		ans = inf;
	}
	if (ans >= inf) return 0;
	int q = l[v] - vl;
	while (q) {
		int ops = get(0, 0, n, beg[v], en[v]);
		if (c[ops] >= inf) {
			ans = inf;
			return 0;
		}
		int pr = eu[ops];
		int y = inf;
		int prpr = pr;
		int mh = pr;
		while (prpr != v) {
			y = min(y, r[prpr] - res2[prpr]);
			if (r[prpr] - res2[prpr] == y) mh = prpr;
			prpr = p[prpr];
		}
		y = min(y, r[prpr] - res2[prpr]);
		if (r[prpr] - res2[prpr] == y) mh = prpr;
		prpr = p[prpr];
		prpr = pr;
		int myq = min(y, q);
		while (prpr != v) {
			res2[prpr] += myq;
			prpr = p[prpr];
		}
		res2[v] += myq;
		res[pr] += myq;
		ans += myq * c[pr];
		if (myq == 0) {
			ans = inf;
			return 0;
		}
		if (y <= myq) {
			del(mh);
		}
		q -= myq;
	}
	return mn;
}

signed main() {
	p[0] = 0;
	int tt; cin >> tt;
	while (tt--) {
		cin >> n;
		eu.clear();
		for (int i = 0; i < n; i++)  g[i].clear();
		for (int i = 0; i < 4 * n; i++) t[i] = n;
		for (int i = 0; i < n; i++) {
			res[i] = 0;
			res2[i] = 0;
			used[i] = 0;
		}
		for (int i = 1; i < n; i++) {
			int fr; cin >> fr; fr--;
			p[i] = fr;
			g[fr].push_back(i);
		}
		for (int i = 0; i < n; i++) cin >> c[i]; c[n] = inf + 1;
		for (int i = 0; i < n; i++) {
			cin >> l[i] >> r[i];
		}
		build(0, 0, n);
		for (int i = 0; i < n; i++) {
			if (r[i] == 0) c[i] = inf;
			update(0, 0, n, i);
		}
		ans = 0;
		f(0);
		dfs(0);
		if (ans != inf) {
			cout << ans << endl;
			for (int i = 0; i < n; i++) cout << res[i] << ' ';
			cout << endl;
		}
		else cout << -1 << endl;
	}
}