#include<bits/stdc++.h>

using namespace std;

#define pb emplace_back
#define ld long double
#define ll __int128

mt19937 rnd(51);

const int N = 2e5 + 10, INF = 1e9;
vector<long long> arr;
int t[4 * N], add[4 * N], lol[N];

struct query {
    long long r1, c1, r2, c2;
};
void build(int v, int l, int r) {
    if (l == r) {
        t[v] = lol[l];
        return;
    }
    int m = (l + r) / 2;
    build(2 * v, l, m), build(2 * v + 1, m + 1, r);
    t[v] = min(t[v * 2], t[v * 2 + 1]);
}
void inc(int v, int val) {
    t[v] += val;
    add[v] += val;
}
void push(int v) {
    inc(v * 2, add[v]);
    inc(v * 2 + 1, add[v]);
    add[v] = 0;
}
void update(int v, int tl, int tr, int l, int r, int val) {
    if (l > r) return;
    if (tl == l && tr == r) {
        inc(v, val);
        return;
    }
    push(v);
    int tm = (tl + tr) / 2;
    update(2 * v, tl, tm, l, min(r, tm), val), update(2 * v + 1, tm + 1, tr, max(l, tm + 1), r, val);
    t[v] = min(t[v * 2], t[v * 2 + 1]);
}
int go(int v, int l, int r) {
    if (l == r) {
        return l;
    }
    push(v);
    int m = (l + r) / 2;
    if (t[v * 2] == 0) {
        return go(2 * v, l, m);
    } else {
        return go(2 * v + 1, m + 1, r);
    }
}

struct Fenwick {
    vector<int> t;
    Fenwick (int n) {
        t.resize(n);
    }
    void inc(int i, int val) {
        for (; i < t.size(); i = (i | (i + 1))) {
            t[i] += val;
        }
    }
    int get(int r) {
        int ans = 0;
        for (; r >= 0; r = (r & (r + 1)) - 1) {
            ans += t[r];
        }
        return ans;
    }
    int get(int l, int r) {
        return get(r) - get(l - 1);
    }
};

long long get_val(long long i, long long j) {
    return i * (i + 1) / 2 + j;
}

pair<long long,long long> get_ans(long long a) {
    long long l = 0, r = N;
    while (r - l > 1) {
        long long mid = (r + l) / 2;
        if (mid * (mid + 1) / 2 <= a) {
            l = mid;
        } else {
            r = mid;
        }
    }
    return {l, a - l * (l + 1) / 2};
}

vector<long long> func(vector<long long> a) {
    sort(a.begin(), a.end());
    a.erase(unique(a.begin(), a.end()), a.end());
    return a;
}

vector<long long> ask(vector<long long> a, long long i) {
    arr = func(arr);
    int m = arr.size(), n = a.size();
    if (m == 0) {
        return vector<long long>{};
    }
    vector<long long> ans(m, -1);
    vector<pair<int, int>> u;
    int jump = (1 << i);
    for (int i = 0; i < 4 * m; i++) {
        t[i] = add[i] = 0;
    }
    for (int i = 0; i < m; i++) {
        u.pb(get_ans(arr[i]));
        if (jump >= u[i].first) {
            ans[i] = 0;
            lol[i] = INF;
        } else {
            lol[i] = u[i].first - u[i].second;
        }
    }
    build(1, 0, m - 1);
    Fenwick F(n);
    for (int i = 0; i < n; i++) F.inc(i, 1);
    for (int i = 0; i <= n; i++) {
        while (t[1] == 0) {
            int j = go(1, 0, m - 1);
            update(1, 0, m - 1, j, j, INF);
            ans[j] = get_val(u[j].first - jump, u[j].second - F.get(u[j].first - jump, u[j].first - 1));
        }
        if (i < n) {
            F.inc(a[i], -1);
            if (u.back().first <= a[i]) continue;
            int l = -1, r = m;
            while (r - l > 1) {
                int mid = (r + l) / 2;
                if (u[mid].first > a[i]) {
                    r = mid;
                } else {
                    l = mid;
                }
            }
            update(1, 0, m - 1, r, m - 1, -1);
        }
    }
    return ans;
}

vector<pair<int, int>> solve(long long n, vector<long long> a, long long q, vector<query> u) {
    vector<pair<long long,long long>> res(q);
    for (long long i = 0; i < q; i++) {
        res[i] = {get_val(u[i].r1, u[i].c1), get_val(u[i].r2, u[i].c2)};
        if (u[i].r1 < u[i].r2) {
            swap(res[i].first, res[i].second);
        }
    }
    for (int j = 16; j >= 0; j--) {
        arr.clear();
        for (int i = 0; i < q; i++) {
            auto a = get_ans(res[i].first), b = get_ans(res[i].second);
            if (a.first - b.first >= (1 << j)) {
                arr.pb(res[i].first);
            }
        }
        vector<long long> ans = ask(a, j);
        for (int i = 0; i < q; i++) {
            auto a = get_ans(res[i].first), b = get_ans(res[i].second);
            if (a.first - b.first >= (1 << j)) {
                int ind = lower_bound(arr.begin(), arr.end(), res[i].first) - arr.begin();
                res[i].first = ans[ind];
            }
        }
    }
    vector<pair<int, int>> ans;
    for (int j = 16; j >= 0; j--) {
        arr.clear();
        for (int i = 0; i < q; i++) {
            if (res[i].first == res[i].second) continue;
            arr.pb(res[i].first);
            arr.pb(res[i].second);
        }
        vector<long long> ans = ask(a, j);
        for (int i = 0; i < q; i++) {
            if (res[i].first == res[i].second) continue;
            int ind1 = lower_bound(arr.begin(), arr.end(), res[i].first) - arr.begin(), ind2 = lower_bound(arr.begin(), arr.end(), res[i].second) - arr.begin();
            if (ans[ind1] != ans[ind2]) {
                res[i].first = ans[ind1];
                res[i].second = ans[ind2];
            }
        }
    }
    arr.clear();
    for (int i = 0; i < q; i++) {
        if (res[i].first == res[i].second) continue;
        arr.pb(res[i].first);
    }
    vector<long long> result = ask(a, 0);
    for (int i = 0; i < q; i++) {
        if (res[i].first == res[i].second) {
            ans.pb(get_ans(res[i].first));
        } else {
            int j = lower_bound(arr.begin(), arr.end(), res[i].first) - arr.begin();
            ans.pb(get_ans(result[j]));
        }
    }
    return ans;
}

vector<pair<long long,long long>> solvee(long long n, vector<long long> a, long long q, vector<query> u) {
    long long sz = (n + 1) * (n + 2) / 2;
    vector<long long> b(n, 1);
    vector<long long> gr(sz);
    for (long long i = 0; i <= n; i++) {
        long long last = 0;
        pair<long long,long long> p;
        for (long long j = 0; j < n; j++) {
            p.first++, p.second += b[j];
            long long v = get_val(p.first, p.second);
            gr[v] = last;
            last = v;
        }
        if (i < n) {
            b[a[i]] ^= 1;
        }
    }
    vector<pair<long long,long long>> ans;
    for (long long i = 0; i < q; i++) {
        long long a = get_val(u[i].r1, u[i].c1), b = get_val(u[i].r2, u[i].c2);
        map<long long,long long> used;
        while (1) {
            used[b] = 1;
            if (b == 0) break;
            b = gr[b];
        }
        while (!used[a]) {
            a = gr[a];
        }
        ans.pb(get_ans(a));
    }
    return ans;
}


signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    if (0) {
        long long n = 100000;
        vector<long long> a(n);
        iota(a.begin(), a.end(), 0);
        shuffle(a.begin(), a.end(), rnd);
        long long q = 100000;
        vector<query> u(q);
        for (long long i = 0; i < q; i++) {
            u[i].r1 = rnd() % (n + 1);
            u[i].r2 = rnd() % (n + 1);
            u[i].c1 = rnd() % (u[0].r1 + 1);
            u[i].c2 = rnd() % (u[0].r2 + 1);
        }
        solve(n, a, q, u);
        return 0;
    }
    long long n;
    cin >> n;
    vector<long long> a(n);
    for (long long i = 0; i < n; i++) {
        cin >> a[i];
        a[i]--;
    }
    long long q;
    cin >> q;
    vector<query> u(q);
    for (long long i = 0; i < u.size(); i++) {
        cin >> u[i].r1 >> u[i].c1 >> u[i].r2 >> u[i].c2;
    }
    auto ans = solve(n, a, q, u);
    for (auto to : ans) {
        cout << to.first << ' ' << to.second << '\n';
    }
    return 0;
}
