#include<bits/stdc++.h>

using namespace std;

#define pb emplace_back
#define ld long double
#define ll long long

mt19937 rnd(51);

const int N = 2e5 + 10, INF = 1e9;
vector<pair<long long, long long>> arr;
vector<long long> arr2;
int t[4 * N], add[4 * N], lol[N];
long long val[N];
pair<long long, long long> u[N];

struct query {
    int r1, c1, r2, c2;
};
void build(int v, int l, int r) {
    if (l == r) {
        t[v] = lol[l];
        return;
    }
    int m = (l + r) / 2;
    build(2 * v, l, m), build(2 * v + 1, m + 1, r);
    t[v] = min(t[v * 2], t[v * 2 + 1]);
}
void inc(int v, int val) {
    t[v] += val;
    add[v] += val;
}
void push(int v) {
    if (add[v] == 0) return;
    inc(v * 2, add[v]);
    inc(v * 2 + 1, add[v]);
    add[v] = 0;
}
void update(int v, int tl, int tr, int l, int r, int val) {
    if (l > r) return;
    if (tl == l && tr == r) {
        inc(v, val);
        return;
    }
    push(v);
    int tm = (tl + tr) / 2;
    update(2 * v, tl, tm, l, min(r, tm), val), update(2 * v + 1, tm + 1, tr, max(l, tm + 1), r, val);
    t[v] = min(t[v * 2], t[v * 2 + 1]);
}
int go(int v, int l, int r) {
    if (l == r) {
        return l;
    }
    push(v);
    int m = (l + r) / 2;
    if (t[v * 2] == 0) {
        return go(2 * v, l, m);
    } else {
        return go(2 * v + 1, m + 1, r);
    }
}

struct Fenwick {
    vector<int> t;
    Fenwick (int n) {
        t.resize(n);
    }
    void inc(int i, int val) {
        for (; i < t.size(); i = (i | (i + 1))) {
            t[i] += val;
        }
    }
    int get(int r) {
        int ans = 0;
        for (; r >= 0; r = (r & (r + 1)) - 1) {
            ans += t[r];
        }
        return ans;
    }
    int get(int l, int r) {
        return get(r) - get(l - 1);
    }
};

long long get_val(long long i, long long j) {
    return val[i] + j;
}

pair<long long,long long> get_ans(long long a) {
    long long l = 0, r = N;
    while (r - l > 1) {
        long long mid = (r + l) / 2;
        if (val[mid] <= a) {
            l = mid;
        } else {
            r = mid;
        }
    }
    return {l, a - val[l]};
}

vector<pair<ll, ll>> func(vector<pair<ll, ll>> a) {
    sort(a.begin(), a.end());
    a.erase(unique(a.begin(), a.end()), a.end());
    return a;
}

vector<array<long long, 3>> ask(vector<long long> a) {
    arr = func(arr);
    int m = arr.size(), n = a.size();
    vector<array<long long, 3>> ans(m);
    if (m == 0) {
        return ans;
    }
    vector<pair<int, int>> u;
    for (int i = 0; i < 4 * m; ++i) {
        t[i] = add[i] = 0;
    }
    for (int i = 0; i < m; ++i) {
        u.pb(get_ans(arr[i].first));
        if (arr[i].second >= u[i].first) {
            ans[i] = {0, 0, 0};
            lol[i] = INF;
        } else {
            lol[i] = u[i].first - u[i].second;
        }
    }
    build(1, 0, m - 1);
    Fenwick F(n);
    for (int i = 0; i < n; ++i) F.inc(i, 1);
    for (int i = 0; i <= n; ++i) {
        while (t[1] == 0) {
            int j = go(1, 0, m - 1);
            update(1, 0, m - 1, j, j, INF);
            int jump = arr[j].second;
            int val = u[j].second - F.get(u[j].first - jump, u[j].first - 1);
            ans[j] = {get_val(u[j].first - jump, val), u[j].first - jump, val};
        }
        if (i < n) {
            F.inc(a[i], -1);
            if (u.back().first <= a[i]) continue;
            int l = -1, r = m;
            while (r - l > 1) {
                int mid = (r + l) / 2;
                if (u[mid].first > a[i]) {
                    r = mid;
                } else {
                    l = mid;
                }
            }
            update(1, 0, m - 1, r, m - 1, -1);
        }
    }
    return ans;
}

vector<long long> func2(vector<long long> a) {
    sort(a.begin(), a.end());
    a.erase(unique(a.begin(), a.end()), a.end());
    return a;
}

vector<array<long long, 3>> ask2(vector<long long> a, long long i) {
    arr2 = func2(arr2);
    int m = arr2.size(), n = a.size();
    vector<array<long long, 3>> ans(m);
    if (m == 0) {
        return ans;
    }
    int jump = (1 << i);
    for (int i = 0; i < 4 * m; ++i) {
        t[i] = add[i] = 0;
    }
    for (int i = 0; i < m; ++i) {
        u[i] = (get_ans(arr2[i]));
        if (jump >= u[i].first) {
            ans[i] = {0, 0, 0};
            lol[i] = INF;
        } else {
            lol[i] = u[i].first - u[i].second;
        }
    }
    build(1, 0, m - 1);
    Fenwick F(n);
    for (int i = 0; i < n; ++i) F.inc(i, 1);
    for (int i = 0; i <= n; ++i) {
        while (t[1] == 0) {
            int j = go(1, 0, m - 1);
            update(1, 0, m - 1, j, j, INF);
            int val = u[j].second - F.get(u[j].first - jump, u[j].first - 1);
            ans[j] = {get_val(u[j].first - jump, val), u[j].first - jump, val};
        }
        if (i < n) {
            F.inc(a[i], -1);
            if (u[m - 1].first <= a[i]) continue;
            int l = -1, r = m;
            while (r - l > 1) {
                int mid = (r + l) / 2;
                if (u[mid].first > a[i]) {
                    r = mid;
                } else {
                    l = mid;
                }
            }
            update(1, 0, m - 1, r, m - 1, -1);
        }
    }
    assert(t[1] != 0);
    return ans;
}

vector<pair<int, int>> solve(long long n, vector<long long> a, long long q, vector<query> u) {
    vector<pair<long long,long long>> res(q);
    vector<pair<pair<int,int>,pair<int,int>>> need(q);
    arr.clear();
    for (int i = 0; i < q; ++i) {
        res[i] = {get_val(u[i].r1, u[i].c1), get_val(u[i].r2, u[i].c2)};
        need[i] = make_pair(make_pair(u[i].r1, u[i].c1), make_pair(u[i].r2, u[i].c2));
        if (u[i].r1 < u[i].r2) {
            swap(res[i].first, res[i].second);
            swap(need[i].first, need[i].second);
        }
        if (need[i].first.first - need[i].second.first > 0) {
            arr.pb(res[i].first, need[i].first.first - need[i].second.first);
        }
    }
    {
        vector<array<long long, 3>> ans = ask(a);
        for (int i = 0; i < q; ++i) {
            if (need[i].first.first - need[i].second.first > 0) {
                int ind = lower_bound(arr.begin(), arr.end(), make_pair(res[i].first, (long long)need[i].first.first - need[i].second.first)) - arr.begin();
                res[i].first = ans[ind][0];
                need[i].first = make_pair(ans[ind][1], ans[ind][2]);
            }
        }
    }
    vector<pair<int,int>> ans;
    for (int j = 16; j >= 0; j--) {
        arr2.clear();
        arr2.resize(2 * q);
        for (int i = 0; i < q; ++i) {
            if (res[i].first == res[i].second) continue;
            arr2[i * 2] = res[i].first;
            arr2[i * 2 + 1] = res[i].second;
        }
        vector<array<long long, 3>> ans = ask2(a, j);
        for (int i = 0; i < q; ++i) {
            if (res[i].first == res[i].second) continue;
            int ind1 = lower_bound(arr2.begin(), arr2.end(), res[i].first) - arr2.begin(), ind2 = lower_bound(arr2.begin(), arr2.end(), res[i].second) - arr2.begin();
            if (ans[ind1][0] != ans[ind2][0]) {
                res[i].first = ans[ind1][0];
                res[i].second = ans[ind2][0];
            }
        }
    }
    arr.clear();
    for (int i = 0; i < q; ++i) {
        if (res[i].first == res[i].second) continue;
        arr.pb(res[i].first, 1);
    }
    vector<array<long long, 3>> result = ask(a);
    for (int i = 0; i < q; ++i) {
        if (res[i].first == res[i].second) {
            ans.pb(get_ans(res[i].first));
        } else {
            int j = lower_bound(arr.begin(), arr.end(), make_pair(res[i].first, 1LL)) - arr.begin();
            ans.pb(get_ans(result[j][0]));
        }
    }
    return ans;
}

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    for (int i = 0; i < N; ++i) {
        val[i] = (long long)i * (i + 1) / 2;
    }
    long long n;
    cin >> n;
    vector<long long> a(n);
    for (long long i = 0; i < n; ++i) {
        cin >> a[i];
        a[i]--;
    }
    long long q;
    cin >> q;
    vector<query> u(q);
    for (long long i = 0; i < u.size(); ++i) {
        cin >> u[i].r1 >> u[i].c1 >> u[i].r2 >> u[i].c2;
    }
    auto ans = solve(n, a, q, u);
    for (auto to : ans) {
        cout << to.first << ' ' << to.second << '\n';
    }
    return 0;
}
