#include<bits/stdc++.h>

using namespace std;

#define pb push_back
#define ld long double
#define ll __int128
#define int long long

mt19937 rnd(51);

const int N = 5e5 + 10;

struct query {
    int r1, c1, r2, c2;
};

struct SegTree {
    vector<int> t, add;
    void build(int n) {
        t.clear();
        add.clear();
        t.resize(4 * n);
        add.resize(4 * n);
    }
    void inc(int v, int val) {
        t[v] += val;
        add[v] += val;
    }
    void push(int v) {
        inc(v * 2, add[v]);
        inc(v * 2 + 1, add[v]);
        add[v] = 0;
    }
    void update(int v, int tl, int tr, int l, int r, int val) {
        if (l > r) return;
        if (tl == l && tr == r) {
            inc(v, val);
            return;
        }
        push(v);
        int tm = (tl + tr) / 2;
        update(2 * v, tl, tm, l, min(r, tm), val), update(2 * v + 1, tm + 1, tr, max(l, tm + 1), r, val);
        t[v] = max(t[v * 2], t[v * 2 + 1]);
    }
};

int get_val(int i, int j) {
    return i * (i + 1) / 2 + j;
}

pair<int,int> get_ans(int a) {
    int l = 0, r = N;
    while (r - l > 1) {
        int mid = (r + l) / 2;
        if (mid * (mid + 1) / 2 <= a) {
            l = mid;
        } else {
            r = mid;
        }
    }
    return {l, a - l * (l + 1) / 2};
}

vector<pair<int,int>> solve(int n, vector<int> a, int q, vector<query> u) {
    int sz = (n + 1) * (n + 2) / 2;
    vector<int> b(n, 1);
    vector<int> gr(sz);
    for (int i = 0; i <= n; i++) {
        int last = 0;
        pair<int,int> p;
        for (int j = 0; j < n; j++) {
            p.first++, p.second += b[j];
            int v = get_val(p.first, p.second);
            gr[v] = last;
            last = v;
        }
        if (i < n) {
            b[a[i]] ^= 1;
        }
    }
    vector<pair<int,int>> ans;
    for (int i = 0; i < q; i++) {
        int a = get_val(u[i].r1, u[i].c1), b = get_val(u[i].r2, u[i].c2);
        map<int,int> used;
        while (1) {
            used[b] = 1;
            if (b == 0) break;
            b = gr[b];
        }
        while (!used[a]) {
            a = gr[a];
        }
        ans.pb(get_ans(a));
    }
    return ans;
}

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        a[i]--;
    }
    int q;
    cin >> q;
    vector<query> u(q);
    for (int i = 0; i < u.size(); i++) {
        cin >> u[i].r1 >> u[i].c1 >> u[i].r2 >> u[i].c2;
    }
    auto ans = solve(n, a, q, u);
    for (auto to : ans) {
        cout << to.first << ' ' << to.second << endl;
    }
    return 0;
}
