#include <iostream>

typedef long long ll;

using namespace std;

ll count_c(ll* arr, ll sd, ll** help, ll k, ll t)
{
	ll ans = help[k][t / sd];
	for (ll i = (t / sd) * sd + 1; i <= t; i++)
	{
		if (arr[i] <= k) ans++;
	}
	return ans;
}

ll find_turn(ll n, ll* arr, ll sd, ll** help, ll r, ll c)
{
	ll d = 0, u = n + 1;
	while (u > d)
	{
		ll m = (u + d) / 2;
		ll res = count_c(arr, sd, help, r, m);
		if (res < c) d = m + 1;
		else u = m;
	}
	return d;
}

ll find_parent(ll n, ll* arr, ll sd, ll** help, ll r, ll c, ll depth)
{
	auto t = find_turn(n, arr, sd, help, r, c);
	return count_c(arr, sd, help, depth, t);
}

int main()
{
	ll n, q;
	cin >> n;
	auto arr = new ll[n];
	for (ll i = 0; i < n; i++)
	{
		cin >> arr[i];
		arr[i]--;
	}

	auto sd = (ll)floor(sqrt(n));
	auto su = (n + sd - 1) / sd;
	auto help = new ll*[n + 1];
	auto updates = new ll[n + 1];
	for (ll i = 0; i < n + 1; i++)
	{
		help[i] = new ll[su + 1];
		help[i][0] = 0;
	}
	for (ll i = 0; i < su; i++)
	{
		for (ll j = 0; j < n + 1; j++)
		{
			updates[j] = 0;
		}
		for (ll j = 0; j < sd && i * sd + j < n; j++)
		{
			updates[arr[i * sd + j] + 1]++;
		}
		for (ll j = 0; j < n; j++)
		{
			updates[j + 1] += updates[j];
		}
		for (ll j = 0; j <= n; j++)
		{
			help[j][i + 1] = help[j][i] + updates[j];
		}
	}

	auto flips = new pair<ll, ll>[n + 1];
	flips[0] = pair<ll, ll>(0, 0);
	for (ll i = 0; i < n; i++)
	{
		flips[i + 1] = pair<ll, ll>(arr[i], arr[i] - count_c(arr, sd, help, arr[i], i));
	}

	cin >> q;
	for (ll i = 0; i < q; i++)
	{
		ll r1, c1, r2, c2;
		cin >> r1 >> c1 >> r2 >> c2;
		if (r1 == r2 && c1 == c2)
		{
			cout << r1 << " " << c1 << endl;
			continue;
		}
		c1 = r1 - c1;
		c2 = r2 - c2;
		ll l = 0, r = n + 1;
		while (r > l + 1)
		{
			ll m = (r + l) / 2;
			ll res1 = find_parent(n, arr, sd, help, r1, c1, m);
			ll res2 = find_parent(n, arr, sd, help, r2, c2, m);
			if (res1 == res2) l = m;
			else
			{
				r = m;
				r1 = r2 = m;
				c1 = res1;
				c2 = res2;
			}
		}
		if (find_parent(n, arr, sd, help, r1, c1, r) == find_parent(n, arr, sd, help, r2, c2, r)) l = r;
		cout << l << " " <<  l - find_parent(n, arr, sd, help, r1, c1, l) << endl;
	}

	return 0;
}
