#include <iostream>
#include <math.h>

typedef long long ll;

using namespace std;

// sqrt(n)
ll count_c(ll* arr, ll sd, ll** help, ll k, ll t)
{
	ll ans = help[k][t / sd];
	for (ll i = (t / sd) * sd; i < t; i++)
	{
		if (arr[i] < k) ans++;
	}
	return ans;
}

// sqrt(n)*log n
ll find_turn(ll n, ll* arr, ll sd, ll** help, ll r, ll c)
{
	ll d = 0, u = n + 1;
	while (u > d)
	{
		ll m = (u + d) / 2;
		ll res = count_c(arr, sd, help, r, m);
		if (res < c) d = m + 1;
		else u = m;
	}
	return d;
}

// sqrt(n)*log n
ll find_parent(ll n, ll* arr, ll sd, ll** help, ll r, ll c, ll depth)
{
	auto t = find_turn(n, arr, sd, help, r, c);
	return count_c(arr, sd, help, depth, t);
}

int main()
{
	ll n, q;
	cin >> n;
	auto arr = new ll[n];
	bool special = true;
	for (ll i = 0; i < n; i++)
	{
		cin >> arr[i];
		arr[i]--;
		if (arr[i] != i) special = false;
	}

	if (special)
	{
		cin >> q;
		for (ll i = 0; i < q; i++)
		{
			ll r1, c1, r2, c2;
			cin >> r1 >> c1 >> r2 >> c2;
			if (r1 - c1 == r2 - c2)
			{
				if (r1 > r2)
				{
					swap(r1, r2);
					swap(c1, c2);
				}
				cout << r1 << " " << c1 << endl;
			}
			else
			{
				if (r1 - c1 > r2 - c2)
				{
					swap(r1, r2);
					swap(c1, c2);
				}
				cout << r1 - c1 << " 0" << endl;
			}
		}
		return 0;
	}

	auto sd = (ll)floor(sqrt(n));
	auto su = (n + sd - 1) / sd;
	auto help = new ll*[n + 1];
	auto updates = new ll[n + 1];
	for (ll i = 0; i < n + 1; i++)
	{
		help[i] = new ll[su + 1];
		help[i][0] = 0;
	}
	for (ll i = 0; i < su; i++)
	{ // n
		for (ll j = 0; j < n + 1; j++)
		{
			updates[j] = 0;
		}
		for (ll j = 0; j < sd && i * sd + j < n; j++)
		{
			updates[arr[i * sd + j] + 1]++;
		}
		for (ll j = 0; j < n; j++)
		{
			updates[j + 1] += updates[j];
		}
		for (ll j = 0; j <= n; j++)
		{
			help[j][i + 1] = help[j][i] + updates[j];
		}
	} // sqrt(n)*n

	cin >> q;
	for (ll i = 0; i < q; i++)
	//while (true)
	{ // sqrt(n)*(log n)^2
		ll r1, c1, r2, c2;
		cin >> r1 >> c1 >> r2 >> c2;
		if (r1 == r2 && c1 == c2)
		{
			cout << r1 << " " << c1 << endl;
			continue;
		}
		c1 = r1 - c1;
		c2 = r2 - c2;
		ll t1 = find_turn(n, arr, sd, help, r1, c1);
		ll t2 = find_turn(n, arr, sd, help, r2, c2);
		if (t1 > t2)
		{
			swap(t1, t2);
			swap(r1, r2);
			swap(c1, c2);
		}
		ll ans = r1;
		for (ll j = t1; j < t2; j++)
		{
			if (ans > arr[j]) ans = arr[j];
		}
		cout << ans << " " <<  ans - count_c(arr, sd, help, ans, t1) << endl;
	} // q*sqrt(n)*(log n)^2

	return 0;
}
