// A.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <math.h>
#include <set>
#include <tuple>

using namespace std;

#pragma GCC optimize("Ofast,no-stack-protector,tune=native")
#pragma GCC optimize("O2")
#pragma GCC optimize("avx,avx2,sse,see2,sse3,sse3,ssse3")
#pragma GCC optimize("unroll-loops,fast-math,section-anchors")

typedef long long ll;
typedef pair<ll, ll> pii;

#define X first
#define Y second
#define All(t) (t).begin(), (t).end()
#define triple tuple<int, int, int>

struct req {
	int cnt, pref, id;

	req(int cnt_, int pref_, int id_) : cnt(cnt_), pref(pref_), id(id_) {}
	req() {}
};

int total = 0, n;
vector<int> a;

struct segtree {
	vector<int> t;

	segtree() {
		t.assign(4 * n + 4, 0);
	}

	void add(int v, int tl, int tr, int pos) {
		if (tl == tr) {
			t[v]++;
			return;
		}
		int tm = (tl + tr) >> 1;
		if (pos <= tm)
			add(v * 2 + 1, tl, tm, pos);
		else
			add(v * 2 + 2, tm + 1, tr, pos);
		t[v] = t[v * 2 + 1] + t[v * 2 + 2];
	}

	int get(int v, int tl, int tr, int l, int r) {
		if (tl > r || tr < l) return 0;
		if (l <= tl && tr <= r) return t[v];
		int tm = (tl + tr) >> 1;
		return get(v * 2 + 1, tl, tm, l, r) + get(v*2+2, tm+1, tr, l, r);
	}
};

vector<bool> get_ans(vector<vector<triple>> &ask) {
	vector<bool> res(total, false);
	segtree cnt = segtree();
	for (int i = 0; i < n; i++) {
		int id, pref, num;
		for (auto &p : ask[i]) {
			tie(pref, num, id) = p;
			res[id] = cnt.get(0, 0, n-1, 0, pref) <= num;
		}
	}
	return res;
}

void solve() {
	int q, r1, r2, c1, c2;
	cin >> n;
	a.resize(n);
	for (int i = 0; i < n; i++)
		cin >> a[i];
	cin >> q;
	vector<req> reqs;
	for (int _ = 0; _ < q; _++) {
		cin >> r1 >> c1 >> r2 >> c2;
		int f1 = r1 - c1;
		int f2 = r2 - c2;
		//reqs.push_back(req(f1, r1, i * 2));
		//reqs.push_back(req(f2, r2, i * 2 + 1));
		int l = -1, r = -1;
		segtree cnt = segtree();
		for (int i = 0; i <= n; i++, l++) {
			int now = cnt.get(0, 0, n, 0, r1);
			if (now == f1) break;
			else if (now > f1) {
				l--;
				break;
			}
			cnt.add(0, 0, n, a[i]);
		}
		cnt = segtree();
		for (int i = 0; i <= n; i++, r++) {
			int now = cnt.get(0, 0, n, 0, r2);
			if (now == f2) break;
			else if (now > f2) {
				r--;
				break;
			}
			cnt.add(0, 0, n, a[i]);
		}
		if (l > r)
			swap(l, r);
		if (l == r) {
			if (r2 < r1) {
				swap(r1, r2);
				swap(c1, c2);
			}
			cout << r1 << ' ' << c1 << '\n';
			continue;
		}
		int h = 1e9;
		for (int i = l + 1; i <= r; i++)
			h = min(h, a[i]-1);
		int move = 0;
		for (int i = 0; i <= l; i++)
			move += (a[i] <= h);
		cout << h << ' ' << h - move << '\n';
	}
	//total = 2 * q;
	//vector<pii> segs(2 * q, { 0, n });
}

signed main()
{
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	solve();
}