#include <iostream>
#include <vector>
#include <functional>

using namespace std;

using graph_t = vector<vector<int>>;

const int ROOT = 0;

const int64_t INF = (1LL << 57);

template <typename T>
vector<T> min_plus(const vector<T> &as, const vector<T> &bs) {
    int n = as.size(), m = bs.size();
    vector<T> res(n + m - 1);
    for (int k = 0; k < n + m - 1; k++) {
        int t = max(0, k - (m - 1));
        res[k] = as[t] + bs[k - t];
        for (int i = 0; i < n; i++) {
            if (k - i < m && k - i >= 0) {
                res[k] = min(res[k], as[i] + bs[k - i]);
            }
        }
    }
    return res;
}

void solve() {
    int n; cin >> n;
    vector<int> parents(n), costs(n);
    graph_t childrens(n);
    for (int i = 1; i < n; i++) {
        cin >> parents[i];
        parents[i]--;
        childrens[parents[i]].push_back(i);
    }
    for (int i = 0; i < n; i++) {
        cin >> costs[i];
    }
    vector<int> ls(n), rs(n);
    for (int i = 0; i < n; i++) {
        cin >> ls[i] >> rs[i];
    }
    
    vector<vector<int64_t>> ans(n);
    function<void(int)> dfs = [&](int v) {
        vector<int64_t> res(rs[v] + 1, INF);
        for (int i = 0; i <= rs[v]; i++) {
            res[i] = costs[v] * 1ll * i;
        }
        for (int u : childrens[v]) {
            dfs(u);
            res = min_plus(res, ans[u]);
        }
        while (res.size() > rs[v] + 1) {
            res.pop_back();
        }
        for (int i = 0; i < ls[v]; i++) {
            res[i] = INF;
        }
        for (int i = 0; i < 100; i++) res.push_back(INF);
        ans[v] = res;
    };
    dfs(ROOT);
    int64_t anss = INF;
    int idx = -1;
    for (int j = 0; j < (int) ans[ROOT].size(); j++) {
        int64_t i = ans[ROOT][j];
        if (i < anss) {
            anss = i;
            idx = j;

        }
    }
    if (anss == INF) {
        cout << -1 << endl;
        return;
    }
    cout << anss << endl;
    vector<int> nums(n, 0);
    function<void(int, int)> recover = [&](int v, int c) {
        int k = childrens[v].size();
        vector<int64_t> deltas(k);
        vector<int> cs(k);
        for (int i = 0; i < k; i++) {
            int u = childrens[v][i];
            cs[i] = ls[u];
            deltas[i] = ans[u][ls[u] + 1] - ans[u][ls[u]];
            c -= cs[i];
        }
        while (c > 0) {
            int64_t min_delta = costs[v];
            int min_idx = -1;
            for (int i = 0; i < k; i++) {
                int u = childrens[v][i];
                int64_t delta = ans[u][cs[u] + 1] - ans[u][cs[u]];
                if (delta < min_delta) {
                    min_delta = delta;
                    min_idx = i;
                }
            }
            if (min_idx != -1) {
                cs[min_idx]++;
            } else {
                nums[v]++;
            }
            c--;
        }
        for (int i = 0; i < k; i++) {
            int u = childrens[v][i];
            recover(u, cs[i]);
        }
    };
    recover(ROOT, idx);
    for (int i = 0; i < n; i++) {
        cout << nums[i] << ' ';
    }
    cout << endl;
}

int main() {
    int t; cin >> t;
    while (t--) {
        solve();
    }
}
