#include <iostream>
#include <vector>
#include <set>
#include <algorithm>


using namespace std;
using ll = long long;


int t0;


void DFS0(int vertex, vector<vector<int>> &graph, vector<pair<int, int>> &time) {
    time[vertex].first = t0;
    ++t0;
    for (auto kid : graph[vertex]) {
        if (time[kid].first == -1) {
            DFS0(kid, graph, time);
        }
    }
    time[vertex].second = t0;
    ++t0;
}


void DFS(int vertex, vector<vector<int>> &graph, vector<ll> &costs, vector<ll> &ness, vector<ll> &ost, vector<ll> &ans, bool &f, vector<pair<int, int>> &time, int num_of_vertices, vector<bool> used) {
    for (auto kid: graph[vertex]) {
        if (!used[kid]) {
            used[kid] = true;
            DFS(kid, graph, costs, ness, ost, ans, f, time, num_of_vertices, used);
        }
    }
    vector<pair<ll, int>> c;
    c.push_back({costs[vertex], vertex});
    for (int i = 0; i < num_of_vertices; ++i) {
        if (time[i].first > time[vertex].first && time[i].second < time[vertex].second) {
            ness[vertex] -= ans[i];
            c.push_back({costs[i], i});
        }
    }
    if (ost[vertex] < 0 || ness[vertex] < 0) {
        f = false;
    } else {
        sort(c.begin(), c.end());
        for (auto kid : c) {
            if (ness[vertex] <= ost[kid.second]) {
                ans[kid.second] += ness[vertex];
                ost[kid.second] -= ness[vertex];
                for(int i = 0; i < num_of_vertices; ++i) {
                    if (time[i].first < time[kid.second].first && time[i].second > time[kid.second].second) {
                        ost[i] -= ness[vertex];
                    }
                }
                ness[vertex] = 0;
                break;
            } else {
                ans[kid.second] += ost[kid.second];
                ness[vertex] -= ost[kid.second];
                for (int i = 0; i < num_of_vertices; ++i) {
                    if (time[i].first < time[kid.second].first && time[i].second > time[kid.second].second) {
                        ost[i] -= ost[kid.second];
                    }
                }
                ost[kid.second] = 0;
            }
        }
        if (ness[vertex] != 0) {
            f = false;
        }
    }
}


int main() {
    int num_of_tests;
    cin >> num_of_tests;
    for (int t = 0; t < num_of_tests; ++t) {
        int num_of_vertices, p;
        cin >> num_of_vertices;
        vector<vector<int>> graph(num_of_vertices);
        for (int i = 1; i < num_of_vertices; ++i) {
            cin >> p;
            --p;
            graph[p].push_back(i);
            graph[i].push_back(p);
        }
        vector<ll> costs(num_of_vertices);
        for (int i = 0; i < num_of_vertices; ++i) {
            cin >> costs[i];
        }
        vector<ll> ness(num_of_vertices);
        vector<ll> ost(num_of_vertices);
        for (int i = 0; i < num_of_vertices; ++i) {
            cin >> ness[i] >> ost[i];
        }
        t0 = 0;
        vector<pair<int, int>> time(num_of_vertices, {-1, -1});
        DFS0(0, graph, time);
        bool f = true;
        vector<ll> ans(num_of_vertices, 0);
        vector<bool> used(num_of_vertices, false);
        used[0] = true;
        DFS(0, graph, costs, ness, ost, ans, f, time, num_of_vertices, used);
        if (!f) {
            cout << -1 << "\n";
        } else {
            ll sum = 0;
            for (int i = 0; i < num_of_vertices; ++i) {
                sum += ans[i] * costs[i];
            }
            cout << sum << "\n";
            for (int i = 0; i < num_of_vertices; ++i) {
                cout << ans[i] << " ";
            }
        }
    }
    return 0;
}
