#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>

using namespace std;
typedef long long ll;

vector<vector<int>>g;
vector<ll>c;
vector<int> l, r, b, p, sum;
bool stop = false;

struct el {
	ll c;
	int v;
	el() = default;
	el(ll a, int b) {
		c = a;
		v = b;
	}
	bool operator<(el b) const {
		return c < b.c;
	}
};
int get(int v, int end) {
	if (v == end)
		return r[v] - sum[v];
	return min(r[v] - sum[v], get(p[v], end));
}
void update(int v, int end, int d) {
	sum[v] += d;
	if (v == end)
		return;
	update(p[v], end, d);
}

multiset<el> dfs(int v = 0) {
	multiset<el>s;
	for (auto u : g[v]) {
		if (stop)
			return {};
		for (auto x : dfs(u))
			s.insert(x);
		sum[v] += sum[u];
	}
	if (stop)
		return {};
	if (sum[v] > r[v]) {
		stop = true;
		return {};
	}
	s.insert(el(c[v], v));
	auto it = s.begin();
	while (sum[v] < l[v] && it != s.end()) {
		int can = get(it->v, v);
		int need = min(l[v] - sum[v], can);
		b[it->v] += need;
		update(it->v, v, need);
		if (can == need)
			it = s.erase(it);
		else
			it++;
	}
	if (sum[v] < l[v]) {
		stop = true;
		return {};
	}
	return s;
}

void solve() {
	int n; cin >> n;
	c.resize(n);
	g.resize(n);
	l.resize(n), r.resize(n);
	b.resize(n);
	p.resize(n);
	sum.resize(n);
	for (int i = 1; i < n; i++) {
		int pr; cin >> pr;
		pr--;
		g[pr].push_back(i);
		p[i] = pr;
	}
	for (int i = 0; i < n; i++) {
		cin >> c[i];
	}
	for (int i = 0; i < n; i++) {
		cin >> l[i] >> r[i];
	}
	dfs();
	if (stop) {
		cout << "-1\n";
	}
	else {
		ll cost = 0;
		for (int i = 0; i < n; i++)
			cost += b[i] * c[i];
		cout << cost << '\n';
		for (int i = 0; i < n; i++) {
			cout << b[i] << ' ';
		}
		cout << '\n';
	}
	stop = false;
	g.clear();
	c.clear();
	l.clear();
	r.clear();
	b.clear();
	p.clear();
	sum.clear();
}

int main() {
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	int t = 1;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}