#include <iostream>
#include <vector>
#include <algorithm>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <ctime>
#include <cmath>
#include <chrono>
#include <random>
using namespace std;
#define int long long
#define all(x) (x).begin(), (x).end()
const int INF = 1e18;

struct op {
    int c, num;

    op() : c(INF), num(0) {}
    op(int c, int num) : c(c), num(num) {}

    bool operator < (const op &a) const {
        if (c == a.c) {
            return num > a.num;
        }
        return c > a.c;
    }
};

int n;
vector<int> c, l, r, buy;
vector<vector<int>> g;

pair<set<tuple<int, int, int>>, int> dfs(int v) {
    int sum = 0;
    set<tuple<int, int, int>> pos;
    for (int u : g[v]) {
        auto [list, use] = dfs(u);
        if (use == -1) {
            return {{}, -1};
        }
        sum += use;
        for (auto e : list) {
            pos.insert(e);
        }
    }
    if (sum > r[v]) {
        return {{}, -1};
    }
    if (sum < r[v]) {
        pos.emplace(c[v], r[v] - sum, v);
    }
    while (sum < l[v] && !pos.empty()) {
        auto [c, cnt, u] = *pos.begin();
        pos.erase(pos.begin());
        if (cnt < l[v] - sum) {
            sum += cnt;
            buy[u] += cnt;
        } else {
            buy[u] += l[v] - sum;
            pos.emplace(c, cnt - l[v] + sum, u);
            sum = l[v];
        }
    }
    if (pos.empty() && sum < l[v]) {
        return {{}, -1};
    }
    return {pos, sum};
}

void init() {
    g.assign(n, {});
    c.resize(n);
    l.resize(n);
    r.resize(n);
    buy.assign(n, 0);
}

void solve() {
    cin >> n;
    init();
    for (int i = 0; i < n - 1; ++i) {
        int x; cin >> x;
        g[x - 1].push_back(i + 1);
    }
    for (int i = 0; i < n; ++i) {
        cin >> c[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
    }
    auto [list, sum] = dfs(0);
    if (sum == -1) {
        cout << -1 << endl;
        return;
    }
    int res = 0;
    for (int i = 0; i < n; ++i) {
        res += buy[i] * c[i];
    }
    cout << res << endl;
    for (int e : buy) {
        cout << e << ' ';
    }
    cout << endl;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.setf(ios::fixed);
    cout.precision(20);
//    freopen("input.txt", "r", stdin);
    int t; cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
