#include <iostream>
#include <vector>
#include <algorithm>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <ctime>
#include <cmath>
#include <chrono>
#include <random>
using namespace std;
#define int long long
#define all(x) (x).begin(), (x).end()

struct node {
    int l, r, sum;
    node() : l(-1), r(-1), sum(0) {}
    node(int l, int r, int sum) : l(l), r(r), sum(sum) {}
};

int n;
vector<int> root = {0};
vector<node> t = {node()};

void upd(int v) {
    t[v].sum = 0;
    if (t[v].l != -1) {
        t[v].sum += t[t[v].l].sum;
    }
    if (t[v].r != -1) {
        t[v].sum += t[t[v].r].sum;
    }
}

void init(int v, int tl = 0, int tr = n - 1) {
    if (tl == tr) {
        return;
    }
    int m = (tl + tr) / 2;
    if (t[v].l == -1) {
        t[v].l = t.size();
        t.emplace_back();
        init(t[v].l, tl, m);
    }
    if (t[v].r == -1) {
        t[v].r = t.size();
        t.emplace_back();
        init(t[v].r, m + 1, tr);
    }
}

int get(int v, int l, int r, int tl = 0, int tr = n - 1) {
    if (tr < l || r < tl) {
        return 0;
    }
    if (l <= tl && tr <= r) {
        return t[v].sum;
    }
    int m = (tl + tr) / 2;
    return get(t[v].l, l, r, tl, m) + get(t[v].r, l, r, m + 1, tr);
}

void add(int v, int i, int tl = 0, int tr = n - 1) {
    if (tl == tr) {
        t[v].sum++;
        return;
    }
    int m = (tl + tr) / 2;
    if (i <= m) {
        t.push_back(t[t[v].l]);
        t[v].l = (int) t.size() - 1;
        add(t[v].l, i, tl, m);
    } else {
        t.push_back(t[t[v].r]);
        t[v].r = (int) t.size() - 1;
        add(t[v].r, i, m + 1, tr);
    }
    upd(v);
}

int elem(int v, int i, int tl = 0, int tr = n - 1) {
    if (tl == tr) {
        return t[v].sum;
    }
    int m = (tl + tr) / 2;
    if (i <= m) {
        return elem(t[v].l, i, tl, m);
    } else {
        return elem(t[v].r, i, m + 1, tr);
    }
}

pair<int, int> parrent(int r, int c, int high) {
    int R = r - 1, need = r - c;
    int tl = 0, tr = n + 1;
    while (tl + 1 < tr) {
        int m = (tl + tr) / 2;
        if (get(root[m], 0, R) <= need) {
            tl = m;
        } else {
            tr = m;
        }
    }
    int sis = get(root[tl], R - high + 1, R);
    return {r - high, c - high + sis};
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.setf(ios::fixed);
    cout.precision(20);
    cin >> n;
    init(0);
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        --a[i];
        t.push_back(t[root.back()]);
        root.push_back((int) t.size() - 1);
        add(root[i + 1], a[i]);
    }
    int q; cin >> q;
    while (q--) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        if (r1 < r2) {
            swap(r1, r2);
            swap(c1, c2);
        }
        while (r1 > r2) {
            auto [r3, c3] = parrent(r1, c1, 1);
            r1 = r3;
            c1 = c3;
        }
        while (c1 != c2) {
            auto [r3, c3] = parrent(r1, c1, 1);
            auto [r4, c4] = parrent(r2, c2, 1);
            r1 = r3;
            c1 = c3;
            r2 = r4;
            c2 = c4;
        }
        cout << r1 << ' ' << c1 << endl;
    }
    return 0;
}
