#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <ctime>
#include <iomanip>
#include <utility>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <array>
#include <list>
#include <cassert>
#include <sstream>
#include <numeric>
#include <random>
#include <chrono>

#define all(_a) _a.begin(), _a.end()

using namespace std;

const int MAX_N = 100'000;

int p[MAX_N];
int cost[MAX_N];
int l[MAX_N];
int r[MAX_N];

vector<int> graph[MAX_N];

int dp_cnt[MAX_N];
long long dp[MAX_N];

struct Value {
	int v;
	int c;
	int cnt;

	Value() {}
	Value(int v, int c, int cnt) : v(v), c(c), cnt(cnt) {}
};

multiset<Value> st[MAX_N];

bool operator < (const Value& a, const Value& b) {
	return a.c < b.c;
}

bool is_ok = true;

int answer[MAX_N];

void dfs(int v) {
	st[v].emplace(v, cost[v], r[v]);
	for (int u : graph[v]) {
		dfs(u);
		if (!is_ok) {
			return;
		}
		st[v].insert(all(st[u]));
		dp_cnt[v] += dp_cnt[u];
		dp[v] += dp[u];
	}
	if (dp_cnt[v] > r[v]) {
		is_ok = false;
		return;
	}
	{
		multiset<Value> new_st;
		int limit = r[v] - dp_cnt[v];
		for (auto [u, c, cnt] : st[v]) {
			int k = min(limit, cnt);
			new_st.emplace(u, c, k);
			limit -= k;
			if (limit == 0) {
				break;
			}
		}
		st[v] = move(new_st);
	}

	
	int limit = l[v] - dp_cnt[v];
	while ((limit > 0) && (!st[v].empty())) {
		auto [u, c, cnt] = *st[v].begin();
		st[v].erase(st[v].begin());
		int k = min(limit, cnt);
		dp_cnt[v] += k;
		dp[v] += 1ll * k * c;
		answer[u] += k;

		limit -= k;
		cnt -= k;
		if (cnt) {
			st[v].emplace(u, c, cnt);
		}
	}
	if (limit > 0) {
		is_ok = false;
		return;
	}
}

void solve() {
	int n;
	cin >> n;
	for (int i = 1; i < n; ++i) {
		cin >> p[i];
		--p[i];
	}
	for (int i = 0; i < n; ++i) {
		cin >> cost[i];
	}
	for (int i = 0; i < n; ++i) {
		cin >> l[i] >> r[i];
	}

	for (int i = 0; i < n; ++i) {
		graph[i].clear();
	}
	for (int v = 1; v < n; ++v) {
		graph[p[v]].push_back(v);
	}

	fill_n(dp_cnt, n, 0);
	fill_n(dp, n, 0);
	fill_n(answer, n, 0);
	for (int i = 0; i < n; ++i) {
		st[i].clear();
	}

	is_ok = true;
	dfs(0);
	if (!is_ok) {
		cout << -1 << '\n';
	} else {
		cout << dp[0] << '\n';
		for (int i = 0; i < n; ++i) {
			cout << answer[i] << ' ';
		}
		cout << '\n';
	}
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

#ifdef LOCAL
	freopen("input.txt", "r", stdin);
#endif

	int t;
	cin >> t;
	for (int i = 0; i < t; ++i) {
		solve();
	}

	return 0;
}