#include <bits/stdc++.h>

#define ibase ios_base::sync_with_stdio(0); cin.tie(0);

using namespace std;
using ll = long long;

int const N = 5024, inf = 1e9 + 7, _N = 1e5 + 4;
int sz[_N], mn[_N], sum[_N], G3 = 1000000000, _cnt[N];

struct S{
    ll l, r, c;
};

void sz_dfs(int v, vector < vector <int> >& g){
    sz[v] = 1;
    for(auto u : g[v]){
        sz_dfs(u, g);
        sz[v] += sz[u];
    }
    return;
}

void mn_dfs(int v, vector < vector <int> >& g, vector <S>& a){
    mn[v] = v;
    for(auto u : g[v]){
        mn_dfs(u, g, a);
        if(a[mn[u]].c < a[mn[v]].c){
            mn[v] = mn[u];
        }
    }
    return;
}

void dfs(int v, vector <S>& a, vector < vector <ll> >& dp, vector < vector <int> >& g, vector < vector <int> >& own){
    if(g[v].size() == 0){
        for(ll i = a[v].l; i <= a[v].r; ++i){
            dp[v][i] = a[v].c * i;
            own[v][i] = i;
        }
        return;
    }
    ll ans = 0, cnt = 0;
    vector <int> p(N, -1);
    for(auto u : g[v]){
        dfs(u, a, dp, g, own);
    }
    for(auto u : g[v]){
        bool f = 1;
        for(int i = 0; i < N; ++i){
            if(dp[u][i] != -1){
                p[u] = i;
                ans += dp[u][i];
                cnt += i;
                f = 0;
                break;
            }
        }
        if(f){
            return;
        }
    }
    while(cnt <= a[v].r){
        dp[v][cnt] = ans;
        ll mind = inf, id = -1;
        for(auto u : g[v]){
            if(dp[u][p[u] + 1] != -1 and dp[u][p[u] + 1] - dp[u][p[u]] < mind){
                mind = dp[u][p[u] + 1] - dp[u][p[u]];
                id = u;
            }
        }
        if(id == -1 or mind >= a[v].c){ break;}
        p[id]++;
        ans += mind;
        ++cnt;
    }
//    cout << v + 1 << " : ";
//    for(int i = a[v].l; i <= a[v].r; ++i){
//        cout << dp[v][i] << ' ';
//    }
//    cout << '\n';
    for(ll i = 0; i < N - 4; ++i){
        if(dp[v][i] != -1 and dp[v][i + 1] == -1){
            for(ll j = i + 1; j < N; ++j){
                dp[v][j] = dp[v][i] + (j - i) * a[v].c;
                own[v][j] = (j - i);
            }
            break;
        }
    }
    for(int i = 0; i < a[v].l; ++i){
        dp[v][i] = -1;
    }
    for(int i = a[v].r + 1; i < N; ++i){
        dp[v][i] = -1;
    }
    return;
}

void get_ans(int v, vector <S>& a, vector < vector <ll> >& dp, vector < vector <int> >& g, vector < vector <int> >& own, int k, vector <int>& ans){
    ans[v] = own[v][k];
    ll need = k - own[v][k], cnt = 0;
    vector <int> p(N, -1);
    for(auto u : g[v]){
        for(int i = 0; i < N; ++i){
            if(dp[u][i] != -1){
                p[u] = i;
                cnt += i;
                break;
            }
        }
    }
    while(cnt != need){
        ll mind = inf, id = -1;
        for(auto u : g[v]){
            if(dp[u][p[u] + 1] != -1 and dp[u][p[u] + 1] - dp[u][p[u]] < mind){
                mind = dp[u][p[u] + 1] - dp[u][p[u]];
                id = u;
            }
        }
        if(id == -1 or mind >= a[v].c){
                assert(0);break;}
        p[id]++;
        ++cnt;
    }
    for(auto u : g[v]){
        get_ans(u, a, dp, g, own, p[u], ans);
    }
    return;
}

void check(int v, vector < vector <int> >& g, vector <S>& a, vector <ll>& mn, bool& f){
    if(g[v].size() == 0){
        mn[v] = a[v].l;
        return;
    }
    mn[v] = 0;
    for(auto u : g[v]){
        check(u, g, a, mn, f);
        mn[v] += mn[u];
    }
    if(mn[v] > a[v].r){
        f = 0;
    }
    return;
}

set <pair <ll, ll> > mn_solve(int v, vector < vector <int> >& g, vector <S>& a, vector <int>& ans){
    set < pair <ll, ll> > st;
    _cnt[v] = a[v].r - a[v].l;
    if(g[v].size() == 0){
        ans[v] = a[v].l;
        sum[v] = a[v].l;
        st.insert({a[v].c, v});
        _cnt[v] = a[v].r - a[v].l;
        return st;
    }
    ll cnt = 0;
    for(auto u : g[v]){
        auto _st = mn_solve(u, g, a, ans);
        cnt += sum[u];
        if(_st.size() > st.size()){
            swap(st, _st);
        }
        for(auto w : _st){
            st.insert(w);
        }
    }
    if(cnt < a[v].l){
        while(1){
            pair <ll, ll> x = (*st.begin());
            ll u = x.second;
            if(_cnt[u] + cnt > a[v].l){
                _cnt[u] -= (a[v].l - cnt);
                ans[u] += (a[v].l - cnt);
                break;
            }
            else{
                ans[u] += _cnt[u];
                cnt += _cnt[u];
                _cnt[u] = 0;
                st.erase(st.begin());
            }
        }
    }
    return st;
}

void solve(){
    int n;
    bool g3 = 1;
    cin >> n;
    vector < vector <int> > g(n);
    vector <S> v(n);
    vector <int> ans(n, -1);
    vector <ll> mn(n, 0);
    for(int i = 1; i < n; ++i){
        int p;
        cin >> p;
        --p;
        g[p].push_back(i);
    }
    for(int i = 0; i < n; ++i){
        cin >> v[i].c;
    }
    for(int i = 0; i < n; ++i){
        cin >> v[i].l >> v[i].r;
        if(v[i].r != G3){
            g3 = 0;
        }
    }
    bool f = 1;
    check(0, g, v, mn, f);
    sz_dfs(0, g);
    mn_dfs(0, g, v);
    if(!f){
        cout << -1 << '\n';
        return;
    }
    ans.assign(n, 0);
    mn_solve(0, g, v, ans);
    ll sum = 0;
    for(int i = 0; i < n; ++i){
        sum += ans[i] * v[i].c;
    }
    cout << sum << '\n';
    for(auto w : ans){
        cout << w << ' ';
    }
    cout << '\n';
    return;
}
signed main(){
    ibase;
    int t;
    cin >> t;
    while(t --> 0){
        solve();
    }
}
/**
2
3
1 1
3 1 2
5 7
1 2
2 4
2
1
5 5
0 1
2 2

1
3
1 1
3 1 2
5 7
1 2
2 4
**/
