#include <bits/stdc++.h>
using namespace std;

istream& operator >> (istream& in, vector<int>& a) {
    for (int i = 0; i < a.size(); ++i)
        in >> a[i];
    return in;
}

struct Point {
    long long x, y;
    Point() {}
    Point(int x, int y): x(x), y(y) {}
    bool operator < (const Point& other) const{
        if (y != other.y)
            return y < other.y;
        return x < other.x;
    }
    void scan() {
        cin >> x >> y;
    }
    void print() {
        cout << x << ' ' << y << endl;
    }
};

long long solutionk1(vector<Point> pts, long long width, long long height) {
    sort(pts.begin(), pts.end());
    long long border = width;
    long long ans = 0;
    for (Point pt :pts) {
        if (border > pt.x) {
            ans += (border - pt.x) * (height - pt.y);
            border = pt.x;
        }
    }
    return ans;
}

long long dir1(Point pt, long long border0, long long border1, long long height) {
    if (pt.x >= border1)
        return 0;
    long long x = max(pt.x, border0);
    return (border1 - x) * (height - pt.y);
}


long long dir2(Point pt, long long border0, long long border1, long long height) {
    if (pt.x <= border0)
        return 0;
    long long x = min(pt.x, border1);
    return (x - border0) * (height - pt.y);
}

long long solutionk2(vector<Point> pts, long long width, long long height) {
    sort(pts.begin(), pts.end());
    vector<vector<long long>> dp(2, vector<long long> (pts.size() + 1, 0));
    vector<vector<long long>> border(2, vector<long long> (2));
    border[0][0] = 0;
    border[0][1] = width;
    border[1][0] = 0;
    border[1][1] = width;
    for (int i = 1; i <= pts.size(); ++i) {
        vector<vector<long long>> border2(2, vector<long long> (2));
        if (dp[0][i - 1] + dir2(pts[i - 1], border[0][0], border[0][1], height) >
             dp[1][i - 1] + dir2(pts[i - 1], border[1][0], border[1][1], height)) {
            dp[0][i] = dp[0][i - 1] + dir2(pts[i - 1], border[0][0], border[0][1], height);
            border2[0][0] = max(border[0][0], pts[i - 1].x);
            border2[0][1] = border[0][1];
        }
        else {
            dp[0][i] = dp[1][i - 1] + dir2(pts[i - 1], border[1][0], border[1][1], height);
            border2[0][0] = max(border[1][0], pts[i - 1].x);
            border2[0][1] = border[1][1];
        }
        if (dp[0][i - 1] + dir1(pts[i - 1], border[0][0], border[0][1], height) >
             dp[1][i - 1] + dir1(pts[i - 1], border[1][0], border[1][1], height)) {
            dp[1][i] = dp[0][i - 1] + dir1(pts[i - 1], border[0][0], border[0][1], height);
            border2[1][1] = min(border[0][1], pts[i - 1].x);
            border2[1][0] = border[0][0];
        }
        else {
            dp[1][i] = dp[1][i - 1] + dir1(pts[i - 1], border[1][0], border[1][1], height);
            border2[1][1] = min(border[1][1], pts[i - 1].x);
            border2[1][0] = border[1][0];
        }
        border = border2;
    }
    return max(dp[0][pts.size()], dp[1][pts.size()]);
}


int main()
{
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    //freopen("Din.txt", "r", stdin);
    //freopen("Dout.txt", "w", stdout);
    int k;
    cin >> k;
    vector<int> directions(k);
    cin >> directions;
    int t;
    cin >> t;
    while (t--) {
        int n;
        long long width, height;
        cin >> n >> width >> height;
        vector<Point> pts(n);
        for (int i = 0; i < n; ++i)
            pts[i].scan();
        if (k == 1)
            cout << solutionk1(pts, width, height) << '\n';
        else
            cout << solutionk2(pts, width, height) << '\n';
    }
}
