#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>


using namespace std;

typedef long long ll;

vector<vector<int>> graph;
vector<int> arr;
vector<pair<pair<int, int>, int>> euler;
vector<int> ooo;

void dfs(int i, int j, int glub = 0, int kkk = -1e9, int ddd = 1e9) {
	// cout << i << ' ' << j << ' ' << glub << ' ' << kkk << ' ' << ddd << '\n';
	euler.push_back({ {i, j}, glub });
	if (glub != arr.size()) {

		if (kkk > ooo[glub] || ooo[glub] < ddd) {
			dfs(i + 1, j, glub + 1, max(kkk, ooo[glub]), ddd);
			euler.push_back({ {i, j}, glub });
		}

		if (kkk < ooo[glub]) {
			dfs(i + 1, j + 1, glub + 1, kkk, min(ddd, ooo[glub]));
			euler.push_back({ {i, j}, glub });
		}
	}
}

vector<pair<int, pair<int, int>>> tt;

void build(int v, int l, int r) {
	if (l + 1 == r) {
		tt[v] = { euler[l].second, euler[l].first };
		return;
	}
	int mid = (l + r) / 2;
	build(2 * v + 1, l, mid);
	build(2 * v + 2, mid, r);
	tt[v] = min(tt[2 * v + 1], tt[2 * v + 2]);
}

pair<int, pair<int, int>> get_min(int v, int l, int r, int a, int b) {
	if (b <= l || r <= a) {
		return { (int)1e9, {(int)1e9, (int)1e9} };
	}
	if (a <= l && r <= b) {
		return tt[v];
	}
	int mid = (l + r) / 2;
	return min(get_min(2 * v + 1, l, mid, a, b), get_min(2 * v + 2, mid, r, a, b));
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int n;
	cin >> n;
	arr.resize(n);
	ooo.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> arr[i];
		arr[i]--;
		ooo[arr[i]] = i;
	}
	dfs(0, 0, 0);
	map<pair<int, int>, int> ind;
	for (int i = 0; i < euler.size(); i++) {
		auto el = euler[i];
		ind[el.first] = i;
	}
	tt.resize(4 * euler.size());
	build(0, 0, euler.size());
	int q;
	cin >> q;
	while (q--) {
		int r1, c1, r2, c2;
		cin >> r1 >> c1 >> r2 >> c2;
		int L = ind[{r1, c1}], R = ind[{r2, c2}];
		if (L > R) {
			swap(L, R);
		}
		auto el = get_min(0, 0, euler.size(), L, R + 1);
		cout << el.second.first << ' ' << el.second.second << '\n';


	}
	return 0;
}