#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
#define all(v) v.begin(), v.end()
//#define int long long

struct segTree {
    vector<int> sum;
    int size;
    segTree(int n) {
        while (size < n) size <<= 1;
        sum.resize(size << 1);
    }
    void add(int i) {
        i += size;
        while (i > 0) {
            ++sum[i];
            i >>= 1;
        }
    }
    int getSum(int l, int r) {
        int ret = 0;
        for (l += size, r += size; l < r; l >>= 1, r >>= 1) {
            if (l & 1) ret += sum[l++];
            if (r & 1) ret += sum[--r];
        }
        return ret;
    }
};

void solve() {
    int n;
    cin >> n;
    vector<vector<set<pair<int, int>>>> lower(n + 1);
    for (int i = 0; i <= n; ++i) {
        lower[i].resize(i + 1);
    }
    vector<bool> right(n, true);
    vector<pair<int, int>> road;
    for (int i = 0; i <= n; ++i) {
        road.emplace_back(i, i);
        for (int j = i + 1; j <= n; ++j) {
            lower[i][i].insert({j, j});
        }
    }
    for (int i = 0; i < n; ++i) {
        int a;
        cin >> a;
        right[a - 1] = false;
        road.erase(road.begin() + a, road.end());
        for (int j = road.size(); j < n; ++j) {
            if (right[j]) {
                road.emplace_back(j, road[j - 1].second + 1);
                for (auto th: road) {
                    lower[th.first][th.second].insert({j, road[j - 1].second + 1});
                }
            } else {
                road.emplace_back(j, road[j - 1].second);
                for (auto th: road) {
                    lower[th.first][th.second].insert({j, road[j - 1].second});
                }
            }
        }
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        --r1, --c1, --r2, --c2;
        int l = 0, r = n + 1, ans;
        while (l + 1 < r) {
            int s = (l + r) / 2;
            bool ok = false;
            for (int j = 0; j <= s && !ok; ++j) {
                if (lower[s][j].count({r1, c1}) > 0 && lower[s][j].count({r2, c2}) > 0) {
                    ok = true;
                }
            }
            if (ok) {
                l = s;
            } else r = s;
        }
        bool ok = false;
        for (int j = 0; j <= l && !ok; ++j) {
            if (lower[l][j].count({r1, c1}) > 0 && lower[l][j].count({r2, c2}) > 0) {
                ok = true;
                ans = j;
            }
        }
        cout << l << " " << ans << "\n";
    }
}

signed main() {
    istream::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
/*
3
2 3 1
5
3 3 3 0
2 2 2 1
1 0 3 1
3 1 3 2
2 2 2 2

 */