#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <utility>
using namespace std;
#define int long long

const int maxn = 1e5 + 1;
int p[maxn];
vector<int> g[maxn];
int c[maxn];
int cap[maxn];
pair<int, int> e[maxn];
int dp[maxn];

struct option {
    int v;
    option(int e) {
        v = e;
    }
};


bool operator < (option a, option b) {
    return c[a.v] < c[b.v];
}

multiset<option> children[maxn];
int n;
int result[maxn];
bool bad = false;


bool cmp(int a, int b) {
    return c[a] < c[b];
}

bool dfs(int v) {
    children[v].insert(v);
    for (auto u : g[v]) {
        if (!dfs(u)) {
            return false;
        }
    }
    int sum = 0;
    int sumdp = 0;
    int mxu = -1;
    int mx = 0;
    for (auto u : g[v]) {
        sum += e[u].second - cap[u];
        sumdp += dp[u];
        if (mx < children[u].size()) {
            mx = children[u].size();
            mxu = u;
        }
    }
    if (mxu != -1) {
        children[v].swap(children[mxu]);
        children[v].insert(v);
        for (auto u : g[v]) {
            if (u != mxu) {
                for (auto x : children[u]) {
                    children[v].insert(x);
                }
            }
        }
    }
    if (sum > e[v].second) {
        return false;
    }
    cap[v] -= sum;
    if (sum >= e[v].first) {
        dp[v] = sumdp;
        return true;
    }
    while (!children[v].empty()) {
        int x = children[v].begin()->v;

        int now = x;
        int mn = cap[now];
        while (now != v) {
            mn = min(mn, cap[p[now]]);
            now = p[now];
        }
        if (sum + mn >= e[v].first) {
            int need = e[v].first - sum;
            result[x] += need;
            now = x;
            cap[now] -= need;
            while (now != v) {
                cap[p[now]] -= need;
                now = p[now];
            }
            sumdp += need * c[x];
            dp[v] = sumdp;
            return true;
        } else {
            int need = mn;
            result[x] += need;
            now = x;
            cap[now] -= need;
            while (now != v) {
                cap[p[now]] -= need;
                now = p[now];
            }
            sum += need;
            sumdp += c[x] * need;
            children[v].erase(children[v].begin());
        }
    }
    return false;
}

void solve() {
    cin >> n;
    fill(p + 1, p + n + 1, 0);
    fill(g + 1, g + n + 1, vector<int>());
    for (int i = 2; i <= n; i++) {
        cin >> p[i];
        g[p[i]].push_back(i);
    }
    for (int i = 1; i <= n; i++) {
        children[i].clear();
    }
    for (int i = 1; i <= n; i++) {
        cin >> c[i];
    }
    for (int i = 1; i <= n; i++) {

        int l, r;
        cin >> l >> r;
        e[i] = {l, r};
        cap[i] = r;
        dp[i] = 0;
        result[i] = 0;
    }
    if (!dfs(1)) {
        cout << -1 << endl;
    } else {
        cout << dp[1] << endl;
        for (int i = 1; i <= n; i++) {
            cout << result[i] << ' ';
        }
        cout << endl;
    }
}

signed main() {
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
}
