#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <numeric>
#include <string>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <stack>
#include <deque>
#include <queue>
#include <cmath>
#include <ctime>
#include <cassert>
#include <chrono>
#include <random>
#include <bitset>

using namespace std;

#define sz(x) ((int)((x).size()))
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

const char en = '\n';
const int INF = 1e9 + 7;
const ll INFLL = 1e18 + 7;

struct LCA {
    int n, lg, T;
    vector<vector<int>> up;
    vector<set<int>> tree;
    vector<int> tin, tout;

    LCA() {}

    LCA(int _n) {
        n = _n;
        tree.resize(n);
        tin.resize(n);
        tout.resize(n);
        lg = 0;
        while ((1 << lg) <= n) ++lg;
        up.resize(lg, vector<int> (n));
    }

    void add_edge(int v, int u) {
        tree[v].emplace(u);
    }

    void build() {
        T = 0;
        dfs(0, 0);
        for (int i = 1; i < sz(up); ++i) {
            for (int j = 0; j < n; ++j) {
                up[i][j] = up[i - 1][up[i - 1][j]];
            }
        }
    }

    void dfs(int v, int p) {
        tin[v] = T++;
        up[0][v] = p;
        for (auto u: tree[v]) {
            dfs(u, v);
        }
        tout[v] = T++;
    }

    bool is_anc(int v, int u) {
        return tin[v] <= tin[u] && tout[u] <= tout[v];
    }

    int lca(int v, int u) {
        if (is_anc(v, u)) return v;
        if (is_anc(u, v)) return u;
        for (int l = lg - 1; l >= 0; --l) {
            if (!is_anc(up[l][v], u)) {
                v = up[l][v];
            }
        }
        return up[0][v];
    }
};


LCA lca;
vector<bool> turn;

ll get(int r, int c) {
    int v = r * (r + 1) / 2 + c;
    return v;
}

void dfs(int r, int c, int i) {
    if (i == sz(turn)) {
        return;
    }
    int v = get(r, c), u;
    if (turn[i]) {
        u = get(r + 1, c);
        lca.add_edge(v, u);
        dfs(r + 1, c, i + 1);
    }
    else {
        u = get(r + 1, c + 1);
        lca.add_edge(v, u);
        dfs(r + 1, c + 1, i + 1);
    }
}

void solve() {
    int n;
    cin >> n;
    turn.resize(n, false);
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        --a[i];
    }
//    lca = LCA(get(n, n) + 1);
//    dfs(0, 0, 0);
    for (int i = 0; i < n; ++i) {
//        turn[a[i]] = true;
//        dfs(0, 0, 0);
    }
//    lca.build();
    int q;
    cin >> q;
//    vector<pii> id(lca.n);
//    for (int i = 0; i <= n; ++i) {
//        for (int j = 0; j <= i; ++j) {
//            id[get(i, j)] = {i, j};
//        }
//    }
    while (q--) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        if (r1 - c1 == r2 - c2) {
            if (r1 < r2) {
                cout << r1 << ' ' << c1 << en;
            }
            else {
                cout << r2 << ' ' << c2 << en;
            }
        }
        else {
            if (r1- c1 < r2- c2) {
                cout << r1 - c1 << ' ' << 0 << en;
            }
            else {
                cout << r2 - c2 << ' ' << 0 << en;
            }
        }
//        int l = lca.lca(get(r1, c1), get(r2, c2));
//        cout << id[l].first << ' ' << id[l].second << en;
    }
}

int32_t main() {
    int T = 1;
#ifdef THEEVILBIRD
    freopen("c.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0); cin.tie(0);
#endif
    while (T--) {
        solve();
    }
    return 0;
}
