#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>
#include <set>

using namespace std;

#define int long long

vector<int> c;
vector<pair<int, int>> usl;
vector<int> num;
vector<int> answ;
bool fl;
int ans;
vector<pair<int, int>> d;

void dfs1(int v, vector<vector<int>> &gr) {
    d.push_back({c[v], v});
    num[v] = 0;
    for (auto u: gr[v]) {
        dfs1(u, gr);
        num[v] += num[u];
    }
    num[v] += answ[v];
}

pair<int, bool> dfs_check(int v, vector<vector<int>> &gr, int fin, int now) {
    if (v == fin) {
        int cnt = min(max(0ll, usl[v].second - num[v]), now);
        answ[v] += cnt;
        num[v] += cnt;
        return {cnt, true};
    }
    for (auto u: gr[v]) {
        auto res = dfs_check(u, gr, fin, min(now, max(0ll, usl[v].second - num[v])));
        if (res.second) {
            num[v] += res.first;
            return res;
        }
    }
    return {0, 0};
}

pair<int, int> dfs(int v, vector<vector<int>> &gr) {
    if (fl) {
        return {0, 0};
    }
    vector<pair<int, int>> now;
    for (auto u: gr[v]) {
        auto next = dfs(u, gr);
        if (fl) {
            return {0, 0};
        }
        now.push_back(next);
    }
    int l = 0;
    if (now.size()) {
        for (auto i: now) {
            l += i.first;
        }
    }
    l = max(l, usl[v].first);
    if (l > usl[v].second) {
        fl = true;
        return {0, 0};
    }
    d.clear();
    dfs1(v, gr);
    int cnt = num[v];
    if (cnt > usl[v].second) {
        fl = true;
        return {0, 0};
    }
    sort(d.begin(), d.end());
    int ind = 0;
    while (cnt < l) {
        auto k = dfs_check(v, gr, d[ind].second, l - cnt);
        cnt += k.first;
        ans += d[ind].first * k.first;
        ++ind;
    }
    return {l, usl[v].second};
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector<vector<int>> gr(n);
        for (int i = 0; i < n - 1; ++i) {
            int p;
            cin >> p;
            --p;
            gr[p].push_back(i + 1);
        }
        c.assign(n, {});
        usl.assign(n, {});
        for (int i = 0; i < n; ++i) {
            cin >> c[i];
        }
        for (int i = 0; i < n; ++i) {
            cin >> usl[i].first >> usl[i].second;
        }
        ans = 0;
        fl = false;
        num.assign(n, 0);
        answ.assign(n, 0);
        auto[l, r] = dfs(0, gr);
        if (fl) {
            cout << -1 << "\n";
        } else {
            cout << ans << "\n";
            for (auto i: answ) {
                cout << i << " ";
            }
            cout << "\n";
        }
    }
}
