#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>
#include <set>

using namespace std;

int now[(int) 1e7];
vector<int> gr[10000000];
int ans = 0;
int sz;
vector<int> bin_up[10000000];
int dist[10000000];

void dfs(int v, int d) {
    if (d == sz) {
        return;
    }
    if (now[d] == 0) {
        if (count(gr[v].begin(), gr[v].end(), v + d + 2) == 0) {
            gr[v].push_back(v + d + 2);
        }
        dfs(v + d + 2, d + 1);
    } else {
        if (count(gr[v].begin(), gr[v].end(), v + d + 1) == 0) {
            gr[v].push_back(v + d + 1);
        }
        dfs(v + d + 1, d + 1);
    }
}

int get(int n) {
    int l = 0;
    int r = 1e4;
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (m * (m + 1) / 2 <= n) {
            l = m;
        } else {
            r = m;
        }
    }
    return l;
}

vector<int> dist;

void dfs_lca(int v) {
    for (int i = 1; i < 11; ++i) {
        bin_up[v][i] = bin_up[bin_up[v][i - 1]][i - 1];
    }
    for (auto u: gr[v]) {
        dist[u] = dist[v] + 1;
        bin_up[u][0] = v;
        dfs_lca(u);
    }
}

int jump(int v, int d) {
    for (int i = 0; i < 11; ++i) {
        if ((d >> i) & 1) {
            v = bin_up[v][i];
        }
    }
    return v;
}

int get_lca(int v, int u) {
    if (dist[v] > dist[u]) {
        swap(v, u);
    }
    u = jump(u, dist[u] - dist[v]);
    for (int i = 10; i > -1; --i) {
        if (bin_up[v][i] != bin_up[u][i]) {
            v = bin_up[v][i];
            u = bin_up[u][i];
        }
    }
    if (v != u) {
        v = bin_up[v][0];
    }
    return v;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    sz = (n + 2) * (n + 1) / 2;;
    dfs(0, 0);
    for (int i = 0; i < n; ++i) {
        now[a[i] - 1] = 1;
        dfs(0, 0);
    }
    for (int i = 0; i < sz; ++i) {
        bin_up[i].resize(11);
    }
    dfs_lca(0);
    int q;
    cin >> q;
    while (q--) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        int v = r1 * (r1 + 1) / 2;
        v += c1;
        int u = r2 * (r2 + 1) / 2;
        u += c2;
        ans = get_lca(v, u);
        int r3 = get(ans);
        int c3 = ans - r3 * (r3 + 1) / 2;
        cout << r3 << " " << c3 << "\n";
    }
}