//
// Created by roi on 26.03.2022.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <fstream>
#include <set>
#include <cassert>
#include <unordered_set>

using namespace std;
using ll = long long;

#define int long long

const ll INF = 1e16;
const int maxr = 10000;

vector<vector<int>> g;
vector<int> c, l, r, d;
vector<vector<ll>> dp;

void clearr(int v){
    for (int i = 0; i < l[v]; ++i) {
        dp[v][i] = INF;
    }
    for (int i = r[v] + 1; i < maxr; ++i) {
        dp[v][i] = INF;
    }
}

void dfs(int v){
    for (int u : g[v]){
        dfs(u);
    }
    int m = g[v].size();
    vector<int> pointer(m);
    for (int i = 0; i < m; ++i) {
        pointer[i] = l[g[v][i]];
    }
    ll sum_of_pointers = 0;
    for (int i = 0; i < m; ++i) {
        sum_of_pointers += pointer[i];
    }
    for (int i = 0; i < min(sum_of_pointers, maxr); ++i){
        dp[v][i] = INF;
    }
    set<pair<ll, int>> st;
    for (int i = 0; i < m; ++i) {
        st.insert({dp[g[v][i]][pointer[i] + 1] - dp[g[v][i]][pointer[i]], i});
    }
    st.insert({c[v], -1});

    for (int i = 0; i < m; ++i) {
        dp[v][sum_of_pointers] += dp[g[v][i]][pointer[i]];
    }
    while (sum_of_pointers < r[v]){
        int ind = (*st.begin()).second;
        dp[v][sum_of_pointers + 1] = dp[v][sum_of_pointers] + (*st.begin()).first;
        sum_of_pointers++;
        if (ind == -1){
            continue;
        }
        st.erase(st.begin());
        pointer[ind]++;
        st.insert({dp[g[v][ind]][pointer[ind] + 1] - dp[g[v][ind]][pointer[ind]], ind});
    }
    clearr(v);
}

void get(int v, ll cnt){
    if (cnt > r[v] || cnt < l[v]){
        cnt /= (cnt - cnt);
    }
    int m = g[v].size();
    vector<int> pointer(m);
    for (int i = 0; i < m; ++i) {
        pointer[i] = l[g[v][i]];
    }
    int sum_of_pointers = 0;
    for (int i = 0; i < m; ++i) {
        sum_of_pointers += pointer[i];
    }
    multiset<pair<ll, int>> st;
    for (int i = 0; i < m; ++i) {
        st.insert({dp[g[v][i]][pointer[i] + 1] - dp[g[v][i]][pointer[i]], i});
    }
    st.insert({c[v], -1});
    if (sum_of_pointers > maxr){
        return;
    }
    if (sum_of_pointers == cnt){
        d[v] = 0;
        for (int i = 0; i < m; ++i) {
            get(g[v][i], pointer[i]);
        }
        return;
    }
    int cnt_in_me = 0;
    while (sum_of_pointers < r[v]){
        int ind = (*st.begin()).second;
        if (ind == -1){
            cnt_in_me++;
        } else {
            st.erase(st.begin());
            pointer[ind]++;
            st.insert({dp[g[v][ind]][pointer[ind] + 1] - dp[g[v][ind]][pointer[ind]], ind});
        }
        sum_of_pointers++;
        if (sum_of_pointers == cnt){
            d[v] = cnt_in_me;
            for (int i = 0; i < m; ++i) {
                get(g[v][i], pointer[i]);
            }
            return;
        }
    }
    cnt /= (cnt - cnt);
}

vector<int> l1;
vector<int> r1;

bool check(int v){
    for (int u : g[v]){
        if (!check(u)){
            return false;
        }
    }
    l1[v] = l[v];
    r1[v] = r[v];
    ll suml = 0;
    ll sumr = 0;
    for (int u : g[v]){
        suml += l1[u];
        sumr += r1[u];
    }
    l1[v] = max(suml, l1[v]);
    r1[v] = max(sumr, r1[v]);
    if (l1 > r1){
        return false;
    }
    return true;
}

signed main(){
//#ifdef LOCAL
//    ifstream cin("B.in");
//#endif
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        g.resize(0);
        g.resize(n);
        for (int i = 0; i < n - 1; ++i) {
            int p;
            cin >> p;
            --p;
            g[p].push_back(i + 1);
        }
        c.resize(n);
        d.assign(n, 0);
        l.resize(n);
        l1.resize(n);
        r1.resize(n);
        r.resize(n);
        for (int i = 0; i < n; ++i) {
            cin >> c[i];
        }
        for (int i = 0; i < n; ++i) {
            cin >> l[i] >> r[i];
        }
        if (!check(0)){
            cout << -1 << endl;
            continue;
        }
        dp.assign(n, vector<ll>(maxr, 0));
        dfs(0);
        int mn_ind = l[0];
        for (int i = l[0]; i <= r[0]; ++i){
            if (dp[0][i] < dp[0][mn_ind]){
                mn_ind = i;
            }
        }
        cout << dp[0][mn_ind] << endl;
        get(0, mn_ind);
        for (int i = 0; i < n; ++i) {
            cout << d[i] << ' ';
        }
        cout << endl;
    }
}