//
// Created by roi on 26.03.2022.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <fstream>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>

using namespace std;
using ll = long long;
const int LOG = 15;

map<pair<int, int>, set<pair<int, int>>> mp;
map<pair<int, int>, pair<int, int>> p;

void add(vector<bool> v, int n){
    pair<int, int> now = {0, 0};
    for (int i = 0; i < n; ++i) {
        pair<int, int> nnow = now;
        if (v[i]){
            nnow.first++;
        } else{
            nnow.first++;
            nnow.second++;
        }
        mp[now].insert(nnow);
        p[nnow] = now;
        now = nnow;
    }
}

map<pair<int, int>, int> tin;
map<pair<int, int>, int> tout;
map<pair<int, int>, int> h;
int timer = 0;

void dfs(pair<int, int> v, int he){
    tin[v] = timer;
    timer++;
    h[v] = he;
    for (auto u: mp[v]){
        dfs(u, he + 1);
    }
    tout[v] = timer;
}

bool is_parent(pair<int, int> u, pair<int, int> v){
    // is u a parent of v
    return tin[u] <= tin[v] && tout[v] <= tout[u];
}

map<pair<int, int>, vector<pair<int, int>>> bin_up;

void prepare(int n){
    vector<pair<int, int>> all_v;
    all_v.reserve((n + 1) * n);
    for (int j = 0; j < n + 1; ++j) {
        for (int i = j; i < n + 1; ++i) {
            all_v.push_back({i, j});
            bin_up[all_v.back()].resize(LOG);
        }
    }
    int m = all_v.size();
    for (int i = 0; i < m; ++i) {
        bin_up[all_v[i]][0] = p[all_v[i]];
    }
    for (int log = 1; log < LOG; ++log) {
        for (int i = 0; i < m; ++i) {
            bin_up[all_v[i]][log] = bin_up[bin_up[all_v[i]][log - 1]][log - 1];
        }
    }
}

pair<int, int> up_h(pair<int, int> v, int x){
    for (int log = LOG - 1; log >= 0; --log){
        if ((1 << log) <= x){
            x -= (1 << log);
            v = bin_up[v][log];
        }
    }
    return v;
}

pair<int, int> lca(pair<int, int> a, pair<int, int> b){
    if (is_parent(a, b)){
        return a;
    }
    if (is_parent(b, a)){
        return b;
    }
    if (h[a] > h[b]){
        swap(a, b);
    }
    b = up_h(b, h[b] - h[a]);
    for (int log = LOG - 1; log >= 0; --log){
        pair<int, int> x = bin_up[a][log];
        pair<int, int> y = bin_up[b][log];
        if (x != y){
            a = x;
            b = y;
        }
    }
    return p[a];
}

int main(){
#ifdef LOCAL
    ifstream cin("C.in");
#endif
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        a[i]--;
    }
    vector<bool> v(n, false);
    add(v, n);
    for (int i = 0; i < n; ++i) {
        v[a[i]] = true;
        add(v, n);
    }
    dfs({0, 0}, 0);
    prepare(n);
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        pair<int, int> a;
        pair<int, int> b;
        cin >> a.first >> a.second;
        cin >> b.first >> b.second;
        auto c = lca(a, b);
        cout << c.first << ' ' << c.second << endl;
    }
}