#include <bits/stdc++.h>
#include <cmath>

using namespace std;

typedef long long ll;

void fast_stream() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

mt19937 rnd(time(0));

struct edge {
    int cost;
    int cnt;
    int number;

    edge() {};
    edge(ll cost_, ll cnt_, ll number_) {
        cost = cost_;
        cnt = cnt_;
        number = number_;
    }

    friend bool operator<(const edge &a, const edge &b);
};

bool operator<(const edge &a, const edge &b) {
    if (a.cost != b.cost) return a.cost < b.cost;
    if (a.cnt != b.cnt) return a.cnt < b.cnt;
    if (a.number != b.number) return a.number < b.number;
}

const int MAXN = 1e5 + 5;

vector<int> g[MAXN];
ll c[MAXN];
pair<int, int> ogran[MAXN];
ll cnt_in_this[MAXN];
set<edge> elems[MAXN];
ll real_in[MAXN];
bool flag = true;

void dfs(ll v) {
    if (!g[v].size()) {
        cnt_in_this[v] = ogran[v].first;
        real_in[v] = ogran[v].first;

        if (ogran[v].first != ogran[v].second) elems[v].insert({c[v], ogran[v].second - ogran[v].first, v});
        return;
    }

    for (auto i : g[v]) {
        dfs(i);
        real_in[v] += real_in[i];
    }

    if (real_in[v] > ogran[v].second) {
        flag = false;
        return;
    }

    int ind = g[v][0];

    for (auto i : g[v]) {
        if (elems[i].size() > elems[ind].size()) ind = i;
    }

    swap(elems[v], elems[ind]);

    for (int i = 0; i < g[v].size(); ++i) {
        if (g[v][i] == ind) continue;

        for (auto j : elems[g[v][i]]) elems[v].insert(j);
    }

    elems[v].insert({c[v], ogran[v].second, v});

    while (real_in[v] < ogran[v].first && elems[v].size()) {
        ll nado = ogran[v].first - real_in[v];

//        for (auto i : elems[v]) {
//            cout << i.cost << ' ' << i.cnt << ' ' << i.number << endl;
//        }
        auto r = *elems[v].begin();
        // cout << (elems[v].find(r) != elems[v].end()) << endl;
        elems[v].erase(elems[v].begin());

        if (r.cnt <= nado) {
            real_in[v] += r.cnt;

            cnt_in_this[r.number] += r.cnt;
        }
        else {
            r.cnt -= nado;
            real_in[v] += nado;

            cnt_in_this[r.number] += nado;
            elems[v].insert(r);
        }
    }

    if (real_in[v] < ogran[v].first) {
        flag = false;
        return;
    }

    set<edge> new_elems_v;

    ll ost = ogran[v].second - real_in[v];

    while (ost > 0 && elems[v].size()) {
        auto r = *elems[v].begin();
        elems[v].erase(elems[v].begin());

        if (r.cnt <= ost) {
            ost -= r.cnt;

            new_elems_v.insert(r);
        }
        else {
            r.cnt = ost;

            new_elems_v.insert(r);
            break;
        }
    }

    swap(elems[v], new_elems_v);
}

void solve() {
    ll n = 10;
    cin >> n;
    // cout << n << endl;

    for (ll i = 0; i < n - 1; ++i) {
        ll prv;
        cin >> prv;
        --prv;

        // prv = rnd() % (i + 1);

        // cout << prv + 1 << ' ';

        g[prv].push_back(i + 1);
    }

    // cout << endl;

    for (ll i = 0; i < n; ++i) {
        cin >> c[i];
        // c[i] = rnd() % (ll)1e9;
        // cout << c[i] << ' ';
    }

    // cout << endl;

    for (ll i = 0; i < n; ++i) {
        cin >> ogran[i].first >> ogran[i].second;
        // ogran[i] = {rnd() % 1000, 1000};
        // cout << ogran[i].first << ' ' << ogran[i].second << endl;
    }
    // cout << endl;

    dfs(0);

    if (!flag) {
        cout << "-1\n";

        for (ll i = 0; i < n; ++i) {
            g[i].clear();
            cnt_in_this[i] = 0;
            real_in[i] = 0;
            elems[i].clear();
        }

        // cout << endl;

        flag = true;
        return;
    }

    ll ans = 0;

    for (ll i = 0; i < n; ++i) {
        ans += c[i] * cnt_in_this[i];
    }

    cout << ans << '\n';

    for (ll i = 0; i < n; ++i) cout << cnt_in_this[i] << ' ';
    cout << '\n';

    for (ll i = 0; i < n; ++i) {
        g[i].clear();
        cnt_in_this[i] = 0;
        real_in[i] = 0;
        elems[i].clear();
    }

    // cout << endl;

    flag = true;
}

signed main() {
    fast_stream();

    int tests = 1;
    cin >> tests;
    while (tests--) {
        solve();
    }
}

/*
10
1 2 3 4 4 5 4 8 1
715028053 417838085 71832107 869116961 872335120 79833896 943607627 948373498 253462209 536117063
544 1000
976 1000
189 1000
564 1000
294 1000
632 1000
576 1000
906 1000
598 1000
99 1000
 */