#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <unordered_map>
#include <map>

using namespace std;
using ll = long long;
using ld = long double;


#define F first
#define S second

vector<vector<vector<pair<int, int>>>> g;
map<pair<int, int>, int> tin, tout;
map<pair<pair<int, int>, pair<int, int>>, bool> used;
map<pair<int, int>, pair<int, int>> pr;

int t = 1;

void dfs(pair<int, int> v, pair<int, int> p){
    tin[v] = t++;
    pr[v] = p;
    for (auto u : g[v.F][v.S]){
        dfs(u, v);
    }
    tout[v] = t++;
}

bool upper(pair<int, int> v, pair<int, int> u){
    return tin[v] < tin[u] && tout[u] < tout[v];
}

pair<int, int> get(pair<int, int> v, pair<int, int> u){

    if (upper(v, u)) return v;
    else if (upper(u, v)) return u;
    if (u == v) return v;
    while (!upper(u, v)){
        u = pr[u];
    }
    return u;
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n;
    cin >> n;
    vector<int> a(n);
    g.resize(n, vector<vector<pair<int, int>>> (n));
    for (auto &i : a) cin >> i;
    vector<bool> to(n, true);
    for (int i = 0; i <= n; i++){
        pair<int, int> cur = {0, 0};
        for (int j = 0; j < n; j++){
            pair<int, int> u = {cur.F + 1, cur.S + to[j]};
            g[cur.F][cur.S].emplace_back(u);
            used[{cur, u}] = true;
            cur = u;
        }
        if (i != n)
            to[a[i] - 1] = false;
    }

    dfs({0, 0}, {0, 0});
    int q;
    cin >> q;
    while (q--){
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        auto ans = get({r1, c1}, {r2, c2});
        cout << ans.F << ' ' << ans.S << '\n';
    }
}

