#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <iomanip>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>

#define endl '\n'
#define int long long
#define float long double

using namespace std;

struct Tree {
  int n;
  vector<int> t;
  Tree();
  Tree(const vector<int> &a);
  void update(int i, int x);
  int query(int l, int r);
};

Tree::Tree() {}

Tree::Tree(const vector<int> &a) {
  n = (int) a.size();
  t.assign(n << 1, 0);
  for (int i = 0; i < n; ++i) {
    t[n + i] = a[i];
  }
  for (int i = n - 1; i >= 1; --i) {
    t[i] = t[i << 1] + t[i << 1 | 1];
  }
}

void Tree::update(int i, int x) {
  t[i += n] = x;
  for (i >>= 1; i >= 1; i >>= 1) {
    t[i] = t[i << 1] + t[i << 1 | 1];
  }
}

int Tree::query(int l, int r) {
  int ans = 0;
  for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
    if (l & 1) {
      ans += t[l++];
    }
    if (r & 1) {
      ans += t[--r];
    }
  }
  return ans;
}

void solve() {
  int n;
  cin >> n;
  vector<int> a(n);
  for (int i = 0; i < n; ++i) {
    cin >> a[i];
    --a[i];
  }
  int ans = 0;
  for (int i = 0; i + 1 < n; ++i) {
    int A = 0;
    for (int j = 0; j < i; ++j) {
      if (a[j] > a[i]) {
        ++A;
      }
    }
    Tree st(vector<int>(n, 0));
    for (int j = n - 1; j > i; --j) {
      ans += max(abs(a[i] - a[j]), max(A, st.query(0, a[j])) + (j - i));
      st.update(a[j], 1);
    }
  }
  cout << ans << endl;
}

int32_t main() {
#ifndef LOCAL
  ios_base::sync_with_stdio(false);
  cout.tie(nullptr);
  cin.tie(nullptr);
#endif
  int t = 1;
  // cin >> t;
  while (t--) {
    solve();
  }
  return 0;
}
