#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <iomanip>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>

#define endl '\n'
#define int long long
#define float long double

using namespace std;

template<class T> int ckmin(T &a, const T &b) {
  if (b < a) {
    a = b;
    return 1;
  }
  return 0;
}

template<class T> int ckmax(T &a, const T &b) {
  if (b > a) {
    a = b;
    return 1;
  }
  return 0;
}

struct Tree {
  int n;
  vector<int> t;
  vector<int> f;
  Tree();
  Tree(const vector<int> &a);
  void push(int i);
  int query(int l, int r, int x, int i, int l_, int r_);
};

Tree::Tree() {}

Tree::Tree(const vector<int> &a) {
  n = 1ll << (64 - __builtin_clzll((int) a.size() - 1));
  t.assign(n << 1, (int) 1e18);
  f.assign(n << 1, 0);
  for (int i = 0; i < (int) a.size(); ++i) {
    t[n + i] = a[i];
  }
  for (int i = n - 1; i >= 1; --i) {
    t[i] = min(t[i << 1], t[i << 1 | 1]);
  }
}

void Tree::push(int i) {
  if (i < n) {
    f[i << 1] += f[i];
    f[i << 1 | 1] += f[i];
  }
  t[i] += f[i];
  f[i] = 0;
}

int Tree::query(int l, int r, int x = 0, int i = 1, int l_ = 0, int r_ = -1) {
  if (r_ == -1) {
    r_ = n;
  }
  push(i);
  if (max(l, l_) >= min(r, r_)) {
    return (int) 1e18;
  }
  if (l <= l_ && r_ <= r) {
    f[i] += x;
    push(i);
    return t[i];
  }
  int mid = (l + r) / 2;
  int lans = query(l, r, x, i << 1, l_, mid);
  int rans = query(l, r, x, i << 1 | 1, mid, r_);
  t[i] = min(t[i << 1], t[i << 1 | 1]);
  return min(lans, rans);
}

int n;
vector<int> p;
vector<vector<int>> g;
vector<int> a;
vector<int> l;
vector<int> r;
vector<int> b;
vector<int> c;
vector<set<pair<int, int>>> q;
vector<int> sz;
int ans = 0;
int C = 0;
int timer = 0;
vector<int> tin;
vector<int> col;
vector<vector<int>> by_col;

int get_b(int u, int v) {
  int ans = b[v];
  while (u != v) {
    ckmin(ans, b[u]);
    u = p[u];
  }
  return ans;
}

void update_b(int u, int v, int x) {
  b[v] -= x;
  while (u != v) {
    b[u] -= x;
    u = p[u];
  }
}

void dfs1(int u) {
  sz[u] = 1;
  for (const int &v : g[u]) {
    dfs1(v);
    sz[u] += sz[v];
  }
}

void dfs2(int u) {
  tin[u] = timer++;
  col[u] = C;
  by_col[C].push_back(u);
  if (g[u].empty()) {
    return;
  }
  int big = g[u][0];
  for (const int &v : g[u]) {
    if (sz[v] > sz[big]) {
      big = v;
    }
  }
  dfs2(big);
  for (const int &v : g[u]) {
    if (v == big) {
      continue;
    }
    ++C;
    dfs2(v);
  }
}

int dfs(int u) {
  int big = -1;
  vector<int> ch;
  int A = 0;
  for (const int &v : g[u]) {
    ch.push_back(dfs(v));
    if (ch.back() == -1) {
      return -1;
    }
    A += r[v] - b[v];
    if (big == -1 || (int) q[big].size() < (int) q[ch.back()].size()) {
      big = ch.back();
    }
  }
  if (A > r[u]) {
    return -1;
  }
  b[u] = r[u] - A;
  if (big == -1) {
    big = u;
  }
  for (const int &i : ch) {
    if (i == big) {
      continue;
    }
    for (const pair<int, int> &e : q[i]) {
      q[big].insert(e);
    }
    q[i].clear();
  }
  q[big].insert(make_pair(a[u], u));
  while (A < l[u]) {
    while (!q[big].empty() && get_b(q[big].begin()->second, u) == 0) {
      q[big].erase(q[big].begin());
    }
    if (q[big].empty()) {
      return -1;
    }
    int v = q[big].begin()->second;
    int cnt = min(get_b(v, u), l[u] - A);
    update_b(v, u, cnt);
    c[v] += cnt;
    A += cnt;
    ans += a[v] * cnt;
  }
  return big;
}

void solve() {
  cin >> n;
  p.resize(n);
  p[0] = -1;
  g.assign(n, vector<int>());
  for (int i = 1; i < n; ++i) {
    cin >> p[i];
    --p[i];
    g[p[i]].push_back(i);
  }
  a.resize(n);
  for (int i = 0; i < n; ++i) {
    cin >> a[i];
  }
  l.resize(n);
  r.resize(n);
  for (int i = 0; i < n; ++i) {
    cin >> l[i] >> r[i];
  }
  sz.resize(n);
  dfs1(0);
  C = 0;
  timer = 0;
  tin.resize(n);
  col.resize(n);
  by_col.assign(n, vector<int>());
  dfs2(0);
  b.assign(n, 0);
  c.assign(n, 0);
  q.assign(n, set<pair<int, int>>());
  ans = 0;
  if (dfs(0) == -1) {
    cout << -1 << endl;
  } else {
    cout << ans << endl;
    for (int i = 0; i < n; ++i) {
      cout << c[i] << " ";
    }
    cout << endl;
  }
}

int32_t main() {
#ifndef LOCAL
  ios_base::sync_with_stdio(false);
  cout.tie(nullptr);
  cin.tie(nullptr);
#endif
  int t = 1;
  cin >> t;
  while (t--) {
    solve();
  }
  return 0;
}
