#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <iomanip>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cassert>

#define endl '\n'
#define int long long
#define float long double

using namespace std;

template<class T> int ckmin(T &a, const T &b) {
  if (b < a) {
    a = b;
    return 1;
  }
  return 0;
}

template<class T> int ckmax(T &a, const T &b) {
  if (b > a) {
    a = b;
    return 1;
  }
  return 0;
}

struct Tree {
  int n;
  vector<pair<int, int>> t;
  Tree();
  Tree(const vector<pair<int, int>> &a);
  pair<int, int> query(int l, int r);
};

Tree::Tree() {}

Tree::Tree(const vector<pair<int, int>> &a) {
  n = (int) a.size();
  t.resize(n << 1);
  for (int i = 0; i < n; ++i) {
    t[n + i] = a[i];
  }
  for (int i = n - 1; i >= 1; --i) {
    t[i] = min(t[i << 1], t[i << 1 | 1]);
  }
}

pair<int, int> Tree::query(int l, int r) {
  pair<int, int> ans((int) 1e18, (int) 1e18);
  for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
    if (l & 1) {
      ckmin(ans, t[l++]);
    }
    if (r & 1) {
      ckmin(ans, t[--r]);
    }
  }
  return ans;
}

struct SumTree {
  int n;
  vector<int> t;
};

void solve() {
  int n;
  cin >> n;
  vector<int> a(n);
  for (int i = 0; i < n; ++i) {
    cin >> a[i];
    --a[i];
  }
  int k = 0;
  for (int i = 0; i < n; ++i) {
    if (a[i] == i) {
      k = i;
    }
  }
  int m;
  cin >> m;
  for (int i = 0; i < m; ++i) {
    int r1, c1, r2, c2;
    cin >> r1 >> c1 >> r2 >> c2;
    if (r1 - c1 <= k) {
      if (r2 - c2 <= k) {
        
    if (r1 - c1 == r2 - c2) {
      pair<int, int> e = min(make_pair(r1, c1), make_pair(r2, c2));
      cout << e.first << " " << e.second << endl;
      continue;
    }
    cout << min(r1 - c1, r2 - c2) << " " << 0 << endl;
      } else {
        cout << r1 - c1 << " " << 0 << endl;
      }
    } else {
      if (r2 - c2 <= k) {
        cout << r2 - c2 << " " << 0 << endl;
      } else {
        if (c1 == c2) {
          pair<int, int> e = min(make_pair(r1, c1), make_pair(r2, c2));
          cout << e.first << " " << e.second << endl;
          continue;
        }
        cout << k + min(c1, c2) << " " << min(c1, c2) << endl;
      }
    }
  }
}

int32_t main() {
#ifndef LOCAL
  ios_base::sync_with_stdio(false);
  cout.tie(nullptr);
  cin.tie(nullptr);
#endif
  int t = 1;
  // cin >> t;
  while (t--) {
    solve();
  }
  return 0;
}
