#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <cstdlib>
#include <ctime>
#include <random>
#include <cassert>
#include <array>
#include <string>
#include <set>
#include <map>


using namespace std;


#define ll long long
#define ld long double
#define flt double
#define pb push_back
#define emb emplace_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define nlpt nullptr
#define prcs cout << fixed << setprecision(20)


mt19937 rnd(123123);


struct SGT {
	int n;
	vector<vector<int>> t;


	void build(vector<int>& a) {
		n = 1;
		while (n < a.size()) {
			n *= 2;
		}
		t.resize(n + n);
		for (int i = 0; i < a.size(); ++i) {
			t[i + n].clear();
			t[i + n].push_back(a[i]);
		}
		for (int i = n - 1; i > 0; --i) {
			t[i].resize(t[i + i].size() + t[i + i + 1].size());
			merge(all(t[i + i]), all(t[i + i + 1]), t[i].begin());
		}
	}


	int get_smlr(int l, int r, int x) {
		l += n;
		r += n;
		int res = 0;
		while (l < r) {
			if (l & 1) {
				res += lower_bound(all(t[l]), x) - t[l].begin();
				++l;
			}
			if (r & 1) {
				--r;
				res += lower_bound(all(t[r]), x) - t[r].begin();
			}
			l /= 2;
			r /= 2;
		}
		return res;
	}
};


int n;
vector<int> a;
SGT sgt;


int get_tm(int r, int c) {
	int cnt = 0;
	for (int i = 0; i < n; ++i) {
		if (cnt == r - c) {
			return i;
		}
		if (a[i] < r) {
			cnt += 1;
		}
	}
	return n;
}


int32_t main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n;
	a.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		--a[i];
	}
	sgt.build(a);
	int q;
	cin >> q;
	for (int i = 0; i < q; ++i) {
		int r1, c1, r2, c2;
		cin >> r1 >> c1 >> r2 >> c2;
		int tm1 = get_tm(r1, c1);
		int tm2 = get_tm(r2, c2);
		int ansr = min(r1, r2);
		for (int j = min(tm1, tm2); j < max(tm1, tm2); ++j) {
			ansr = min(ansr, a[j]);
		}
		int ansc = ansr - sgt.get_smlr(0, tm1, ansr);
		cout << ansr << " " << ansc << "\n";
	}
	return 0;
}