#include <bits/stdc++.h>

using namespace std;

const int N = 3007, K = 20;

int used[N], p[N * N], d[N * N], up[K][N * N];

int get(int r, int c) {
    return ((r * (r + 1)) / 2) + c;
}

pair<int, int> get(int u) {
    int l = 0, r = N;
    while (r - l > 1) {
        int m = l + (r - l) / 2;
        int x = (m * (m + 1)) / 2;
        if (u >= x) {
            l = m;
        } else {
            r = m;
        }
    }
    return {l, u - (l * (l + 1)) / 2};
}

void build(int n) {
    for (int i = 0; i < ((n + 1) * (n + 2)) / 2; i++) {
        up[0][i] = p[i];
    }
    for (int k = 1; k < K; k++) {
        for (int i = 0; i < ((n + 1) * (n + 2)) / 2; i++) {
            up[k][i] = up[k - 1][up[k - 1][i]];
        }
    }
}

int la(int u, int l) {
    for (int k = K - 1; k > -1; k--) {
        if ((1 << k) <= l) {
            l -= (1 << k);
            u = up[k][u];
        }
    }
    return u;
}

int get_lca(int u, int v) {
    if (d[u] < d[v]) {
        swap(u, v);
    }
    u = la(u, d[u] - d[v]);
    if (u == v) {
        return u;
    }
    for (int k = K - 1; k > -1; k--) {
        if (up[k][u] != up[k][v]) {
            u = up[k][u];
            v = up[k][v];
        }
    }
    return p[u];
}

int main() {
    int n;
    cin >> n;

    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    p[0] = 0;
    d[0] = 0;

    for (int i = 0; i < n + 1; i++) {
        int r1 = 0, c1 = 0;
        for (int t = 0; t < n; t++) {
            int r2, c2;
            if (used[t]) {
                r2 = r1 + 1;
                c2 = c1;
            } else {
                r2 = r1 + 1;
                c2 = c1 + 1;
            }
            p[get(r2, c2)] = get(r1, c1);
            d[get(r2, c2)] = d[get(r1, c1)] + 1;
            r1 = r2, c1 = c2;
        }
        if (i < n) {
            used[a[i] - 1] = 1;
        }
    }

    build(n);

    int q;
    cin >> q;
    while (q--) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;

        int u = get(r1, c1), v = get(r2, c2);
//        cout << u << " " << v << "\n";
        auto ans = get(get_lca(u, v));

        cout << ans.first << " " << ans.second << "\n";
    }
}
