#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <queue>
#include <string>
#include <cassert>

using namespace std;

const int MAXN = 3000 + 7;

vector <pair <int, int>> g[MAXN][MAXN];
bool l[MAXN][MAXN];
bool r[MAXN][MAXN];
int a[MAXN];

int kek[MAXN];

void build(int x, int y, int id, int n) {
	if (id == n)
		return;
	if (kek[id] == 0) {
		if (!r[x][y]) {
			g[x][y].push_back({ x + 1, y + 1 });
			r[x][y] = true;
		}
		build(x + 1, y + 1, id + 1, n);
	}
	else {
		if (!l[x][y]) {
			g[x][y].push_back({ x + 1, y });
			l[x][y] = true;
		}
		build(x + 1, y, id + 1, n);
	}
}

const int C = 13;

pair <int, int> p[C][MAXN][MAXN];
int dep[MAXN][MAXN];

void dfs(int x, int y, int prevx = -1, int prevy = -1) {
	if (prevx == -1)
		dep[x][y] = 0;
	else
		dep[x][y] = dep[prevx][prevy] + 1;
	p[0][x][y] = { prevx, prevy };
	for (int lvl = 1; lvl < C; lvl++)
		if (p[lvl - 1][x][y].first != -1)
			p[lvl][x][y] = p[lvl - 1][p[lvl - 1][x][y].first][p[lvl - 1][x][y].second];
	for (auto to : g[x][y])
		dfs(to.first, to.second, x, y);
}

pair <int, int> parent(int vx, int vy, int h) {
	if (h <= 0)
		return { vx, vy };
	for (int i = 0; i < C; i++) {
		if ((h >> i) & 1) {
			auto t = p[i][vx][vy];
			vx = t.first;
			vy = t.second;
		}
	}
	return { vx, vy };
}

pair <int, int> lca(int vx, int vy, int ux, int uy) {
	if (dep[vx][vy] > dep[ux][uy]) {
		swap(vx, ux);
		swap(vy, uy);
	}
	auto t = parent(vx, vy, dep[ux][uy] - dep[vx][vy]);
	vx = t.first;
	vy = t.second;
	if (vx == ux && vy == uy)
		return { vx, vy };
	for (int i = C - 1; i >= 0; i--) {
		auto t1 = p[i][vx][vy];
		auto t2 = p[i][ux][uy];
		if (t1.first != t2.first || t1.second != t2.second) {
			vx = t1.first; vy = t1.second;
			ux = t2.first; uy = t2.second;
		}
	}
	return p[0][vx][vy];
}

void solve() {
	int n;
	cin >> n;
	for (int i = 0; i < n; i++)
		kek[i] = 0;
	build(0, 0, 0, n);
	for (int i = 0; i < n; i++)
		cin >> a[i];
	for (int i = 0; i < n; i++) {
		kek[a[i] - 1] = 1;
		build(0, 0, 0, n);
	}
	for (int i = 0; i < C; i++)
		for (int j = 0; j < MAXN; j++)
			for (int k = 0; k < MAXN; k++)
				p[i][j][k] = { -1, -1 };
	dfs(0, 0);
	int q;
	cin >> q;
	for (int i = 0; i < q; i++) {
		int vx, vy, ux, uy;
		cin >> vx >> vy >> ux >> uy;
		auto t = lca(vx, vy, ux, uy);
		cout << t.first << " " << t.second << "\n";
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int tests = 1;
//	cin >> tests;
	for (int test = 1; test <= tests; test++) {
		solve();
	}
}