#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <queue>
#include <string>
#include <cassert>

using namespace std;

const int MAXN = 3000 + 7;

vector <pair <int, int>> g[MAXN][MAXN];
bool l[MAXN][MAXN];
bool r[MAXN][MAXN];
int a[MAXN];

int kek[MAXN];

void build(int x, int y, int id, int n) {
	if (id == n)
		return;
	if (kek[id] == 0) {
		if (!r[x][y]) {
			g[x][y].push_back({ x + 1, y + 1 });
			r[x][y] = true;
		}
		build(x + 1, y + 1, id + 1, n);
	}
	else {
		if (!l[x][y]) {
			g[x][y].push_back({ x + 1, y });
			l[x][y] = true;
		}
		build(x + 1, y, id + 1, n);
	}
}

const int C = 13;

pair <int, int> p0[MAXN][MAXN];
pair <int, int> p1[MAXN][MAXN];
int dep[MAXN][MAXN];

void dfs(int x, int y, int prevx = -1, int prevy = -1) {
	if (prevx == -1)
		dep[x][y] = 0;
	else
		dep[x][y] = dep[prevx][prevy] + 1;
	p0[x][y] = { prevx, prevy };
	if (p1[prevx][prevy].first != -1) {
		int l1 = dep[prevx][prevy] - dep[p1[prevx][prevy].first][p1[prevx][prevy].second];
		int ppx = p1[prevx][prevy].first; int ppy = p1[prevx][prevy].second;
		int l2 = 1e9;
		if (p1[ppx][ppy].first != -1)
			l2 = dep[ppx][ppy] - dep[p1[ppx][ppy].first][p1[ppx][ppy].second];
		if (l1 == l2)
			p1[x][y] = p1[ppx][ppy];
		else
			p1[x][y] = p0[x][y];
	}
	else {
		p1[x][y] = { prevx, prevy };
	}
	for (auto to : g[x][y])
		dfs(to.first, to.second, x, y);
}

pair <int, int> parent(int vx, int vy, int h) {
	if (h <= 0)
		return { vx, vy };
	while (dep[vx][vy] > h) {
		int tx = p1[vx][vy].first;
		int ty = p1[vx][vy].second;
		if (tx == -1 || dep[vx][vy] - dep[tx][ty] > h) {
			tx = p0[vx][vy].first;
			ty = p0[vx][vy].second;
		}
		h -= (dep[vx][vy] - dep[tx][ty]);
		vx = tx; vy = ty;
	}
	return { vx, vy };
}

pair <int, int> lca(int vx, int vy, int ux, int uy) {
	if (dep[vx][vy] > dep[ux][uy]) {
		swap(vx, ux);
		swap(vy, uy);
	}
	auto t = parent(vx, vy, dep[ux][uy] - dep[vx][vy]);
	vx = t.first;
	vy = t.second;
	while (vx != ux || vy != uy) {
		int t1x = p1[vx][vy].first;
		int t1y = p1[vx][vy].second;
		int t2x = p1[ux][uy].first;
		int t2y = p1[ux][uy].second;
		if (t1x != t2x || t1y != t2y) {
			vx = t1x; vy = t1y;
			ux = t2x; uy = t2y;
		}
		else {
			auto t = p0[vx][vy];
			vx = t.first; vy = t.second;
			auto tt = p0[ux][uy];
			ux = tt.first; uy = tt.second;
		}
	}
	return { vx, vy };
}

void solve() {
	int n;
	cin >> n;
	for (int i = 0; i < n; i++)
		kek[i] = 0;
	build(0, 0, 0, n);
	for (int i = 0; i < n; i++)
		cin >> a[i];
	for (int i = 0; i < n; i++) {
		kek[a[i] - 1] = 1;
		build(0, 0, 0, n);
	}
	dfs(0, 0);
	int q;
	cin >> q;
	for (int i = 0; i < q; i++) {
		int vx, vy, ux, uy;
		cin >> vx >> vy >> ux >> uy;
		auto t = lca(vx, vy, ux, uy);
		cout << t.first << " " << t.second << "\n";
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int tests = 1;
//	cin >> tests;
	for (int test = 1; test <= tests; test++) {
		solve();
	}
}