#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <queue>
#include <string>
#include <cassert>

using namespace std;

const int MAXN = 3000 + 7;

vector <pair <int, int>> g[MAXN][MAXN];
bool l[MAXN][MAXN];
bool r[MAXN][MAXN];
int a[MAXN];

int kek[MAXN];

void build(int x, int y, int id, int n) {
	if (id == n)
		return;
	if (kek[id] == 0) {
		if (!r[x][y]) {
			g[x][y].push_back({ x + 1, y + 1 });
			r[x][y] = true;
		}
		build(x + 1, y + 1, id + 1, n);
	}
	else {
		if (!l[x][y]) {
			g[x][y].push_back({ x + 1, y });
			l[x][y] = true;
		}
		build(x + 1, y, id + 1, n);
	}
}

int dep[MAXN][MAXN];
pair <int, int> p[MAXN][MAXN];

void dfs(int x, int y, int prevx = -1, int prevy = -1) {
	if (prevx == -1)
		dep[x][y] = 0;
	else
		dep[x][y] = dep[prevx][prevy] + 1;
	p[x][y] = { prevx, prevy };
	for (auto to : g[x][y])
		dfs(to.first, to.second, x, y);
}
void solve() {
	int n;
	cin >> n;
	for (int i = 0; i < n; i++)
		kek[i] = 0;
	build(0, 0, 0, n);
	for (int i = 0; i < n; i++)
		cin >> a[i];
	for (int i = 0; i < n; i++) {
		kek[a[i] - 1] = 1;
		build(0, 0, 0, n);
	}
	dfs(0, 0);
	int q;
	cin >> q;
	for (int i = 0; i < q; i++) {
		int vx, vy, ux, uy;
		cin >> vx >> vy >> ux >> uy;
		if (dep[vx][vy] < dep[ux][uy]) {
			swap(vx, ux);
			swap(vy, uy);
		}
		while (dep[vx][vy] > dep[ux][uy]) {
			auto t = p[vx][vy];
			vx = t.first;
			vy = t.second;
		}
		while (vx != ux || vy != uy) {
			auto t1 = p[vx][vy];
			auto t2 = p[ux][uy];
			vx = t1.first; vy = t1.second;
			ux = t2.first; uy = t2.second;
		}
		cout << vx << " " << vy << "\n";
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int tests = 1;
//	cin >> tests;
	for (int test = 1; test <= tests; test++) {
		solve();
	}
}