#include <bits/stdc++.h>

using namespace std;

#define vc vector
#define pii pair <int, int>
#define forn(i, n) for (int i = 0; i < n; ++i)
#define sz(a) (int)a.size()
#define pb push_back

const int maxn = 3000, inf = 1e9 + 7, lg = 24;

int p[maxn], n;
vc <int> g[maxn * maxn];
int a[maxn];

int encode (int x, int y) {
    return x * (n + 1) + y;
}

pii decode (int u) {
    return {u / (n + 1), u % (n + 1)};
}

void dfs (int x, int y, int h, int i) {
    if (h > n) return;
    int u = encode(x, y), v = encode(x + 1, y);
    if (!p[h]) ++v;
    if (i == n || h >= i) {
        g[u].pb(v);
    }
    dfs(v / (n + 1), v % (n + 1), h + 1, i);
}

int tin[maxn * maxn], h[maxn * maxn], timer = 0;
vc <int> tt;

struct segtree {
    vc <int> t, a;
    int n;
    segtree(vc <int> &a) {
        this->n = sz(a);
        this->a = a;
        t.resize(n * 4);
        build(1, 0, n);
    }
    int merge (int u, int v) {
        if (u == -1) return v;
        if (v == -1) return u;
        if (h[u] < h[v]) return u;
        return v;
    }
    void build (int v, int tl, int tr) {
        if (tr - tl == 1) {
            t[v] = a[tl];
            return;
        }
        int tm = (tl + tr) / 2;
        build(v * 2, tl, tm);
        build(v * 2 + 1, tm, tr);
        t[v] = merge(t[v * 2], t[v * 2 + 1]);
    }
    int get (int v, int tl, int tr, int l, int r) {
        if (tr <= l || r <= tl) return -1;
        if (l <= tl && tr <= r) return t[v];
        int tm = (tl + tr) / 2;
        return merge(get(v * 2, tl, tm, l, r), get(v * 2 + 1, tm, tr, l, r));
    }
};

void build (int u) {
    tin[u] = timer++;
    tt.pb(u);
    for (int v: g[u]) {
        h[v] = h[u] + 1;
        build(v);
        tt.pb(u);
        timer++;
    }
}

void output (int u) {
    pii tmp = decode(u);
    cout << tmp.first << ' ' << tmp.second << '\n';
}

void solve () {
    cin >> n;
    dfs(0, 0, 0, n);
    forn (i, n) {
        cin >> a[i];
        p[a[i] - 1] = 1;
        dfs(0, 0, 0, i);
    }
    build(0);
    int q;
    cin >> q;
    segtree t(tt);
    while (q--) {
        int x, y;
        cin >> x >> y;
        int u = encode(x, y);
        cin >> x >> y;
        int v = encode(x, y);
        if (tin[u] > tin[v]) swap(u, v);
        output(t.get(1, 0, t.n, tin[u], tin[v] + 1));
    }
}

signed main () {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int t = 1;
    // cin >> t;
    while(t--)solve();
}
