#include <iostream>
#include <algorithm>
#include <vector>
#include <tuple>
#include <deque>
#include <cassert>

using namespace std;
typedef long long ll;
#define int long long
#define endl '\n'

int n;
vector <int> g[100010];
int p[100010];
int c[100010];
int l[100010];
int r[100010];
int d[100010];
int f[100010];

int ans[100010];
int sans[100010];

struct can
{
	int u, c, d;

	can() {}

	can(int u, int c, int d) : u(u), c(c), d(d) {}

	bool operator<(const can& b) const
	{
		return make_tuple(c, d, u) < make_tuple(b.c, b.d, b.u);
	}
};

bool ok = true;

void dfs(int u)
{
	for (auto v : g[u]) dfs(v);
	for (auto v : g[u]) d[u] += d[v];
	if (d[u] < l[u])
	{
		f[u] = l[u] - d[u];
		d[u] = l[u];
	}
	if (d[u] > r[u])
	{
		ok = false;
		return;
	}
}

const int inf = 2e9;

deque <can> dfsans(int u)
{
	deque <can> he;
	for (auto v : g[u])
	{
		auto gt = dfsans(v);
		he.insert(he.end(), gt.begin(), gt.end());
	}

	sort(he.begin(), he.end());
	while (he.size() && he.back().c > c[u]) he.pop_back();

	he.push_back(can(u, c[u], inf));
	int need = f[u];
	while (need)
	{
		if (he.front().d <= need)
		{
			need -= he.front().d;
			ans[he.front().u] += he.front().d;
			he.pop_front();
			continue;
		}
		ans[he.front().u] += need;
		he.front().d -= need;
		need -= need;
		break;
	}
	int val = r[u] - d[u];
	int nw = 0;
	for (auto i : he)
	{
		nw += i.d;
	}
	while (nw > val)
	{
		if (he.back().d <= nw - val)
		{
			nw -= he.back().d;
			he.pop_back();
			continue;
		}
		he.back().d -= nw - val;
		nw = val;
		break;
	}
	return he;
}

void dfsass(int u)
{
	sans[u] = ans[u];
	for (auto v : g[u])
	{
		dfsass(v);
		sans[u] += sans[v];
	}

	assert(sans[u] == d[u] && sans[u] >= l[u] && sans[u] <= r[u]);
}

inline void solve()
{
	cin >> n;
	for (int i = 1; i <= n; ++i) g[i].clear();

	for (int i = 2; i <= n; ++i)
	{
		cin >> p[i];
		g[p[i]].push_back(i);
	}
	for (int i = 1; i <= n; ++i) cin >> c[i];

	for (int i = 1; i <= n; ++i) cin >> l[i] >> r[i];
	for (int i = 1; i <= n; ++i) d[i] = f[i] = 0;
	for (int i = 1; i <= n; ++i) ans[i] = 0;
	
	ok = true;
	dfs(1);

	if (!ok)
	{
		cout << -1 << endl;
		return;
	}

	dfsans(1);

	int sum = 0;
	for (int i = 1; i <= n; ++i) sum += ans[i] * c[i];
	cout << sum << endl;
	for (int i = 1; i <= n; ++i) cout << ans[i] << ' ';
	return;
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	int t;
	cin >> t;
	while (t--)
	{
		solve();
	}
	return 0;
}