#include <iostream>
#include <algorithm>
#include <vector>
#include <tuple>
#include <deque>
#include <cassert>
#include <set>

using namespace std;
typedef long long ll;
#define int long long
#define endl '\n'

int n;
vector <int> g[100010];
int p[100010];
int c[100010];
int l[100010];
int r[100010];
int d[100010];
int f[100010];

int ans[100010];

struct can
{
	int u, c, d;

	can() {}

	can(int u, int c, int d) : u(u), c(c), d(d) {}

	bool operator<(const can& b) const
	{
		return make_tuple(c, d, u) < make_tuple(b.c, b.d, b.u);
	}
};

bool ok = true;

void dfs(int u)
{
	for (auto v : g[u]) dfs(v);
	for (auto v : g[u]) d[u] += d[v];
	if (d[u] < l[u])
	{
		f[u] = l[u] - d[u];
		d[u] = l[u];
	}
	if (d[u] > r[u])
	{
		ok = false;
		return;
	}
}

const int inf = 2e9;

pair <set <can>*, int> dfsans(int u)
{
	vector <set<can>*> sons;
	int nw = 0;
	for (auto v : g[u])
	{
		auto gt = dfsans(v);
		sons.push_back(gt.first);
		nw += gt.second;
	}

	if (sons.empty()) sons.push_back(new set<can>());
	for (auto &i : sons) if (i->size() > sons[0]->size()) swap(sons[0], i);

	for (int j = 1; j < sons.size(); ++j) for (auto& k : *sons[j]) sons[0]->insert(k);

	auto he = sons[0];

	while (he->size() && he->rbegin()->c > c[u])
	{
		he->erase(prev(he->end()));
		nw -= prev(he->end())->d;
	}

	he->insert(can(u, c[u], inf));
	nw += inf;
	int need = f[u];
	while (need)
	{
		if (he->begin()->d <= need)
		{
			need -= he->begin()->d;
			ans[he->begin()->u] += he->begin()->d;
			nw -= he->begin()->d;
			he->erase(he->begin());
			continue;
		}
		ans[he->begin()->u] += need;
		auto cp = *he->begin();
		he->erase(he->begin());
		cp.d -= need;
		he->insert(cp);
		nw -= need;
		need = 0;
		break;
	}
	int val = r[u] - d[u];
	while (nw > val)
	{
		if (he->rbegin()->d <= nw - val)
		{
			nw -= he->rbegin()->d;
			he->erase(prev(he->end()));
			continue;
		}
		auto cp = *he->rbegin();
		he->erase(prev(he->end()));
		cp.d -= nw - val;
		he->insert(cp);
		nw = val;
		break;
	}
	return { he, nw };
}

inline void solve()
{
	cin >> n;
	for (int i = 1; i <= n; ++i) g[i].clear();

	for (int i = 2; i <= n; ++i)
	{
		cin >> p[i];
		g[p[i]].push_back(i);
	}
	for (int i = 1; i <= n; ++i) cin >> c[i];

	for (int i = 1; i <= n; ++i) cin >> l[i] >> r[i];
	for (int i = 1; i <= n; ++i) d[i] = f[i] = 0;
	for (int i = 1; i <= n; ++i) ans[i] = 0;
	
	ok = true;
	dfs(1);

	if (!ok)
	{
		cout << -1 << endl;
		return;
	}

	dfsans(1);

	int sum = 0;
	for (int i = 1; i <= n; ++i) sum += ans[i] * c[i];
	cout << sum << endl;
	for (int i = 1; i <= n; ++i) cout << ans[i] << ' ';
	return;
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	int t;
	cin >> t;
	while (t--)
	{
		solve();
	}
	return 0;
}