#include <iostream>
#include <algorithm>
#include <vector>
#include <tuple>
#include <deque>
#include <cassert>
#include <set>
#include <map>

using namespace std;
typedef long long ll;
#define endl '\n'

int n, q;
int a[500010]; //level change
int qu[500010][4];
int cross[500010];

int fenw[500010];

inline void add(int i, int v)
{
	for (; i <= n; i = i | (i + 1)) fenw[i] += v;
}

inline int gt(int i)
{
	int ans = 0;
	for (; i >= 0; i = ((i + 1) & i) - 1) ans += fenw[i];
	return ans;
}

pair <int, int> up(pair <int, int> u)
{
	assert(u.first > 0);
	if (u.second > cross[u.first - 1]) u.second--;
	u.first--;
	return u;
}

vector <int> inter[500010];
vector <pair <int, int>> all;
map <pair <int, int>, int> conv;

int run()
{
	return ((int)rand() << 16) + rand();
}

struct de
{
	int sm, v, w;
	de* l = 0;
	de* r = 0;

	de(int v) : v(v)
	{
		sm = 1;
		w = run();
	}
};

int sz(de* u)
{
	return u ? u->sm : 0;
}

inline void rec(de* u)
{
	if (!u) return;
	u->sm = 1 + sz(u->l) + sz(u->r);
}

pair <de*, de*> split(de* u, int k)
{
	if (!u) return { 0, 0 };
	if (sz(u->l) >= k)
	{
		auto gt = split(u->l, k);
		u->l = gt.second;
		rec(u);
		return { gt.first, u };
	}
	else
	{
		auto gt = split(u->r, k - 1 - sz(u->l));
		u->r = gt.first;
		rec(u);
		return { u, gt.second };
	}
}

de* merge(de* u, de* v)
{
	if (!u) return v;
	if (!v) return u;

	if (u->w < v->w)
	{
		auto gt = merge(u->r, v);
		u->r = gt;
		rec(u);
		return u;
	}
	else
	{
		auto gt = merge(u, v->l);
		v->l = gt;
		rec(v);
		return v;
	}
}

de* deca = 0;

inline int get(int i)
{
	auto x = split(deca, i + 1);
	auto y = split(x.first, i);
	auto ans =  y.second->v;
	deca = merge(merge(y.first, y.second), x.second);
	return ans;
}


inline void change(int i, int v)
{
	auto x = split(deca, i + 1);
	auto y = split(x.first, i);
	y.second->v = v;
	deca = merge(merge(y.first, y.second), x.second);
}

inline void insert(int i, int v)
{
	auto x = split(deca, i);
	auto y = new de(v);
	deca = merge(merge(x.first, y), x.second);
}

const int N = 300010 * 3;
const int LOG = 21;
int p[N];
vector <int> g[N];
int bu[LOG][N];

int tin[N];
int tout[N];
int timer = 0;

void dfs(int u)
{
	tin[u] = timer++;
	for (auto v : g[u]) if(v != u) dfs(v);
	tout[u] = timer++;
}

int isup(int u, int v)
{
	return tin[u] <= tin[v] && tout[u] >= tout[v];
}

int lca(int u, int v)
{
	if (isup(u, v)) return u;
	if (isup(v, u)) return v;

	for (int i = LOG - 1; i >= 0; --i)
	{
		if (!isup(bu[i][u], v)) u = bu[i][u];
	}
	u = bu[0][u];
	return u;
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> n;

	for (int i = 1; i <= n; ++i)
	{
		cin >> a[i];
		--a[i];
	}

	cin >> q;
	for (int i = 1; i <= q; ++i)
	{
		for (int j = 0; j < 4; ++j)
		{
			cin >> qu[i][j];
		}
	}

	for (int i = 1; i <= n; ++i)
	{
		cross[a[i]] = a[i] - gt(a[i]);
		add(a[i], 1);

		inter[a[i]].push_back(cross[a[i]]);
	}

	for (int i = 1; i <= q; ++i)
	{
		inter[qu[i][0]].push_back(qu[i][1]);
		inter[qu[i][2]].push_back(qu[i][3]);
	}

	for (int i = 0; i <= n; ++i)
	{
		sort(inter[i].begin(), inter[i].end());
		inter[i].resize(unique(inter[i].begin(), inter[i].end()) - inter[i].begin());

		for (auto j : inter[i]) all.push_back({ i, j });
	}

	sort(all.begin(), all.end());
	for (int i = 0; i < all.size(); ++i) conv[all[i]] = i;

	deca = new de(conv[{0, 0}]);
	for (int i = 0; i <= n; ++i)
	{
		for (auto y : inter[i])
		{
			int u = conv[{i, y}];
			p[u] = get(y);
			g[p[u]].push_back(u);

			change(y, u);
		}
		if (i < n) insert(cross[i], conv[{i, cross[i]}]);
	}

	int m = all.size();

	for (int i = 0; i < LOG; ++i)
	{
		for (int j = 0; j < m; ++j)
		{
			bu[i][j] = (i == 0 ? p[j] : bu[i - 1][bu[i - 1][j]]);
		}
	}

	dfs(0);

	for (int i = 1; i <= q; ++i)
	{
		int u = conv[{qu[i][0], qu[i][1]}], v = conv[{qu[i][2], qu[i][3]}];
		int z = lca(u, v);
		auto ans = all[z];
		cout << ans.first << ' ' << ans.second << '\n';
	}


	return 0;
}