#pragma GCC optimize("Ofast", "no-stack-protector")

#include <bits/stdc++.h>
#define endl "\n"
#define ll long long
#define all(a) a.begin(), a.end()
#define fast ios::sync_with_stdio(0);cin.tie(0);cout.tie(0);
using namespace std;

template<typename T>
bool rmax (T& a, T b) {
    if (a < b) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T>
istream& operator >> (istream& in, vector<T>& a) {
    for (auto &it : a)
        in >> it;

    return in;
}

struct node {
    int l, r;
    int sum;
};

const int MAXN = 1e7;
node tree[MAXN];
int ind = 0;

void build (int v, int tl, int tr) {
    node a;
    a.sum = 0;
    a.l = -1;
    a.r = -1;

    if (tl == tr - 1) {
        tree[v] = a;
        return;
    }

    int tm = (tl + tr) / 2;
    a.l = v * 2;
    a.r = v * 2 + 1;

    build(a.l, tl, tm);
    build(a.r, tm, tr);

    tree[v] = a;
}

int upd (int v, int tl, int tr, int pos) {
    if (tl > pos || pos >= tr || tl >= tr)
        return v;

    node a = tree[v];
    if (tl == tr - 1) {
        a.sum++;
        tree[ind] = a;
        return ind++;
    }

    int tm = (tl + tr) / 2;
    a.l = upd(a.l, tl, tm, pos);
    a.r = upd(a.r, tm, tr, pos);

    a.sum++;
    tree[ind] = a;
    return ind++;
}

int get_sum (int v, int tl, int tr, int l, int r) {
    if (tl >= tr || l >= tr || tl >= r)
        return 0;

    if (l <= tl && tr <= r)
        return tree[v].sum;

    int tm = (tl + tr) / 2;

    return get_sum(tree[v].l, tl, tm, l, r) + get_sum(tree[v].r, tm, tr, l, r);
}

void solve () {
    int n;
    cin >> n;

    vector<int> a(n);
    cin >> a;

    vector<int> roots;
    roots.push_back(1);
    build(1, 0, n);


    auto get = [&] (int l, int r, int num) {
        return get_sum(roots[r], 0, n, 0, num) - get_sum(roots[l], 0, n, 0, num);
    };

    ind = 4 * n + 4;
    for (int i = 0; i < n; i++) {
        int n_root = upd(roots.back(), 0, n, a[i] - 1);
        roots.push_back(n_root);
        a[i]--;
    }

    ll glob_ans = 0;

    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {

            int ans = max(abs(a[j] - a[i]), j - i);
//            int ans_1 = get(j, n, a[j]) + j - i;
            int ans_1 = get_sum(roots[n], 0, n, 0, a[j]) - get_sum(roots[j], 0, n, 0, a[j]) + j - i;
            rmax(ans, ans_1);

            int ans_3 = get_sum(roots[i + 1], 0, n, 0, a[i] + 1);
            int ans_2 = j - ans_3 + 1;
            rmax(ans, ans_2);

//            cout << a[i] << ' ' << a[j] << ' ' << ans << endl;
            glob_ans += ans;

        }
    }

    cout << glob_ans << endl;
}

signed main () {
    fast;

    int t = 1;
//    cin >> t

    while (t--)
        solve();
}