#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <iomanip>
#include <bitset>
#include <random>
#include <queue>

#define ll long long
#define ld long double
//#define int ll

using namespace std;

const int N = (1 << 12);

int tree[N * 2];

void build() {
	for (int i = 0; i < N * 2; ++i) {
		tree[i] = 0;
	}
}

void add(int ind, int x, int v = 1, int l = 0, int r = N) {
	if (r <= ind || l > ind) return;
	if (r - l == 1) {
		tree[v] = x;
		return;
	}
	int md = (l + r) / 2;
	add(ind, x, v * 2, l, md);
	add(ind, x, v * 2 + 1, md, r);
	tree[v] = tree[v * 2] + tree[v * 2 + 1];
}

int get(int l1, int r1, int v = 1, int l = 0, int r = N) {
	if (l1 >= r || l >= r1) return 0;
	if (r <= r1 && l >= l1) {
		return tree[v];
	}
	int md = (l + r) / 2;
	return get(l1, r1, v * 2, l, md) + get(l1, r1, v * 2 + 1, md, r);
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n;
	cin >> n;
	ll ans = 0;
	vector<int>a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	vector<vector<int>>matr(n, vector<int>(n));
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			matr[i][j] = abs(a[j] - a[i]);
		}
	}
	vector<int>cnt1(n);
	build();
	for (int i = n - 1; i >= 0; --i) {
		cnt1[i] = get(a[i], n + 1);
		add(a[i], 1);
	}
	vector<int>cnt2(n);
	build();
	for (int i = 0; i < n; ++i) {
		cnt2[i] = get(0, a[i]);
		add(a[i], 1);
	}
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			int cnt = cnt1[j];
			matr[i][j] = max(matr[i][j], n - cnt - 1 - i);
		}
	}
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < i; ++j) {
			int cnt = cnt2[j];
			matr[j][i] = max(matr[j][i], i - cnt);
		}
	}
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			ans += matr[i][j];
		}
	}
	cout << ans;
}
