#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <iomanip>
#include <bitset>
#include <random>
#include <queue>

#define ll long long
#define ld long double
#define int ll

using namespace std;

const int N = (1 << 20);

vector<int>a[N];
int par[N];
int bin_up[N][30];
int h[N];

void dfs(int v) {
	for (auto to : a[v]) {
		h[to] = h[v] + 1;
		dfs(to);
	}
}

int lca(int a, int b) {
	if (h[a] < h[b]) swap(a, b);
	for (int i = 29; i >= 0; --i) {
		if (h[bin_up[a][i]] >= h[b]) a = bin_up[a][i];
	}
	if (a == b) return a;
	for (int i = 29; i >= 0; --i) {
		if (bin_up[a][i] != bin_up[b][i]) {
			a = bin_up[a][i];
			b = bin_up[b][i];
		}
	}
	return par[a];
}

pair<int, int> Ans(int z) {
	int l = 0;
	int r = 301;
	while (r - l > 1) {
		int md = (l + r) / 2;
		if (md * (md + 1) / 2 <= z) l = md;
		else r = md;
	}
	return { l, z - (l * (l + 1) / 2) };
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n;
	cin >> n;
	vector<int>a(n);
	int k = 0;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		if (a[i] == n) k = i;
	}
	int q;
	cin >> q;
	for (int i = 0; i < q; ++i) {
		int l1, r1, l2, r2;
		cin >> l1 >> r1 >> l2 >> r2;
		int d1 = l1 - r1;
		int d2 = l2 - r2;
		if (d1 < k) {
			if (d2 < k) {
				if (l1 - r1 == l2 - r2) {
					pair<int, int>ans = { min(l1, l2), min(l1, l2) - (l1 - r1) };
					cout << ans.first << ' ' << ans.second << '\n';
					continue;
				}
				int d = min(l1 - r1, l2 - r2);
				cout << d << ' ' << 0 << '\n';
			}
			else {
				cout << d1 << ' ' << 0 << '\n';
			}
		}
		else {
			if (d2 < k) {
				cout << d2 << ' ' << 0 << '\n';
			}
			else {
				if (r1 == r2) {
					cout << min(l1, l2) << ' ' << r1 << '\n';
				}
				int r = min(r1, r2);
				cout << k + r << ' ' << r << '\n';
			}
		}
	}
}