#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

#define int long long
#define all(a) a.begin(), a.end()
#define pb push_back
#define INF (int) 1e18 / 2

using namespace std;

const int N = 5005;

vector<vector<int>> g;
vector<int> l, r, c;
vector<int> cnt, has;
vector<int> p;
vector<int> dp;

bool ok = false;

void dfs(int v) {
    for (int u : g[v]) {
        dfs(u);
        dp[v] += dp[u];
    }
    dp[v] = max(dp[v], l[v]);
    if (dp[v] > r[v])
        ok = false;
}

void solve() {
    int n;
    cin >> n;
    p.assign(n + 1, 0);
    g.assign(n + 1, {});
    l.assign(n + 1, 0);
    r.assign(n + 1, 0);
    c.assign(n + 1, 0);
    cnt.assign(n + 1, 0);
    has.assign(n + 1, 0);
    dp.assign(n + 1, 0);
    ok = true;

    for (int i = 2; i <= n; i++) {
        cin >> p[i];
        g[p[i]].pb(i);
    }
    for (int i = 1; i <= n; i++)
        cin >> c[i];
    for (int i = 1; i <= n; i++)
        cin >> l[i] >> r[i];
    dfs(1);
    if (!ok) {
        cout << -1 << '\n';
        return;
    }
    vector<pair<int, int>> pa;
    for (int i = 1; i <= n; i++) {
        pa.pb({c[i], i});
    }
    sort(all(pa));
    int ans = 0;
    for (auto[w, v] : pa) {
        int mn = 0, mx = INF;
        int u = v;
        while (u != 0) {
            mx = min(mx, r[u] - cnt[u]);
            mn = max(mn, l[u] - cnt[u]);
            u = p[u];
        }
        mn = min(mn, mx);
        has[v] += mn;
        ans += mn * w;
        u = v;
        while (u != 0) {
            cnt[u] += mn, u = p[u];
        }
    }
    cout << ans << '\n';
    for (int i = 1; i <= n; i++)
        cout << has[i] << " ";
    cout << '\n';
}

int32_t main() {
    cin.tie(0);
    cout.tie(0);
    ios::sync_with_stdio(false);

    int tt = 1;
    cin >> tt;
    while (tt--)
        solve();
}
