#include <iostream>
#include <string>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>

using namespace std;

typedef long long ll;
typedef long double ld;
#define all(x) x.begin(), x.end()
const ll MOD = 1000000007;

vector<vector<int>> edge;
vector<ll> c, l, r, ans;

pair<set<pair<ll, int>>, pair<ll, ll>> dfs(int u)
{
	if (edge[u].size() == 0)
	{
		ans[u] += l[u]; ll lw = l[u];
		r[u] -= l[u]; l[u] = 0;
		set<pair<ll, int>> st;
		if (r[u])
			st.insert({ c[u], u });
		return { st, {lw, r[u] + lw} };
	}
	ll L = 0, R = 0;
	set<pair<ll, int>> st;
	for (int v : edge[u])
	{
		auto p = dfs(v);
		auto p2 = p.second;
		if (p2.first == -1) return { set<pair<ll, int>>(), {-1, -1} };
		L += p2.first;
		R += p2.second;
		for (auto p3 : p.first)
			st.insert(p3);
	}
	if (L > r[u]) return { set<pair<ll, int>>(), {-1, -1} };
	ll hmw = R - L;
	l[u] = max(l[u], L);
	while (l[u] > L)
	{
		if (st.size())
		{
			auto p = (*st.begin());
			if (p.first > c[u])
			{
				ans[u] += l[u] - L;
				L = l[u];
			}
			else
			{
				if (r[p.second] > l[u] - L)
				{
					ans[p.second] += l[u] - L;
					r[p.second] -= l[u] - L;
					hmw -= l[u] - L;
					L = l[u];
				}
				else
				{
					st.erase(p);
					L += r[p.second];
					hmw -= r[p.second];
					ans[p.second] += r[p.second];
				}
			}
		}
		else
		{
			ans[u] += l[u] - L;
			L = l[u];
		}
	}
	while (st.size())
	{
		auto ind = st.end(); --ind;
		auto p = (*ind);
		if (p.first > c[u])
		{
			hmw -= r[p.second];
			st.erase(p);
		}
		else break;
	}
	ll lw = l[u]; r[u] -= lw; l[u] = 0;
	while (hmw > r[u])
	{
		auto ind = st.end(); --ind;
		auto p = (*ind);
		if (r[p.second] < -r[u] + hmw)
		{
			hmw -= r[p.second];
			st.erase(p);
		}
		else
		{
			r[p.second] -= hmw - r[u];
			hmw = r[u];
		}
	}
	r[u] = r[u] - hmw;
	if (r[u])
	{
		st.insert({ c[u], u });
	}
	while (st.size() > 100)
	{
		auto p = st.end();
		--p;
		st.erase((*p));
	}
	return { st, {lw, hmw + r[u] + lw} };
}

inline void solve(int test_case)
{
	edge.clear(); c.clear();
	l.clear(); r.clear();
	ans.clear();
	int n; cin >> n;
	edge.resize(n); c.resize(n);
	l.resize(n); r.resize(n);
	ans.resize(n, 0);
	for (int i = 1; i < n; ++i)
	{
		int p; cin >> p;
		edge[p - 1].push_back(i);
	}
	for (int i = 0; i < n; ++i)
		cin >> c[i];
	for (int i = 0; i < n; ++i)
		cin >> l[i] >> r[i];
	auto ns = dfs(0);
	if (ns.second.first == -1)
	{
		cout << -1 << '\n';
	}
	else
	{
		ll ANS = 0;
		for (int i = 0; i < n; ++i)
		{
			ANS += c[i] * ans[i];
		}
		cout << ANS << '\n';
		for (int i = 0; i < n; ++i)
		{
			cout << ans[i] << ' ';
		}
		cout << '\n';
	}
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	cout << fixed << setprecision(20);
	int t = 1; cin >> t;
	for (int i = 0; i < t; ++i)
	{
		solve(t);
	}
}
