#include <bits/stdc++.h>
#include <bits/extc++.h>

#define int long long

using namespace std;
template <typename T>
using oset = __gnu_pbds::tree<T, __gnu_pbds::null_type, less<T>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;
using ll = long long;

constexpr int MAXN = 9100006;
constexpr int LOGMAXN = 20; // 1048576

vector<int> graph[MAXN];

int getvx[MAXN], getvy[MAXN];

int getv(int r, int c) {
    int res = r * (r + 1) / 2 + c;
    getvx[res] = r;
    getvy[res] = c;
    return res;
}

int depth[MAXN];

int up[LOGMAXN][MAXN];

void build_lca_dfs(int v) {
    for (int lvl = 1; lvl < LOGMAXN; ++lvl) {
        up[lvl][v] = up[lvl - 1][up[lvl - 1][v]];
    }
    for (int ch : graph[v]) {
        depth[ch] = depth[v] + 1;
        up[0][ch] = v;
        build_lca_dfs(ch);
    }
}

void build_lca() {
    build_lca_dfs(0);
}

int get_lca(int u, int v) {
    if (depth[u] < depth[v]) {
        swap(u, v);
    }
    int diff = depth[u] - depth[v];
    for (int bit = LOGMAXN - 1; bit >= 0; --bit) {
        if (diff & (1 << bit)) {
            u = up[bit][u];
        }
    }
    if (u == v) return u;
    for (int bit = LOGMAXN - 1; bit >= 0; --bit) {
        if (up[bit][u] != up[bit][v]) {
            u = up[bit][u];
            v = up[bit][v];
        }
    }
    return up[0][u];
}

int32_t main() {
    // ne rascheska
    int n;
    cin >> n;
    for (int r = 0; r < n; ++r) {
        graph[getv(r, r)].push_back(getv(r + 1, r + 1));
    }
    vector<int> a(n);
    vector<bool> cor(n);
    for (auto &now : a) {
        cin >> now;
        cor[now - 1] = true;
        int cury = 0;
        for (int r = 0; r < now - 1; ++r) {
            if (!cor[r]) {
                ++cury;
            }
        }
        for (int r = now - 1; r < n; ++r) {
            int nc = cury + !cor[r];
            graph[getv(r, cury)].push_back(getv(r + 1, nc));
            cury = nc;
        }
    }
    build_lca();
    int q;
    cin >> q;
    while (q --> 0) {
        int u, v, x, y;
        cin >> u >> v >> x >> y;
        int aaa = get_lca(getv(u, v), getv(x, y));
        cout << getvx[aaa] << ' ' << getvy[aaa] << '\n';
    }
    return 0;
}
