#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>
#include <numeric>
#include <map>

using namespace std;

#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

using uint = unsigned int;
using int64 = long long;
using uint64 = unsigned long long;


vector <vector <int>> g;
vector <int> cost;
vector <pair <int64, int64>> sg;
vector <int> sz;

int64 checkDfs(int v) {
	int64 mn = 0;
	int size = 1;
	for (auto& u : g[v]) {
		int64 uans = checkDfs(u);
		if (uans == -1) {
			return -1;
		}
		mn += uans;
		size += sz[u];
	}
	sz[v] = size;

	if (mn > sg[v].second) return -1;
	return max(mn, sg[v].first);
}

int64 ans;
vector <int64> cnt;
map <pair <int64, int>, int64> dfs(int v) {
	int mx = -1;
	for (auto u : g[v]) {
		if (mx == -1 || sz[u] > sz[mx]) {
			mx = u;
		}
	}

	if (mx == -1) {
		map <pair <int64, int>, int64> mp;
		cnt[v] = sg[v].first;
		ans += cost[v] * sg[v].first;
		mp[{cost[v], v}] = sg[v].second - sg[v].first;
		while (!mp.empty() && mp.begin()->second == 0) {
			mp.erase(mp.begin());
		}

		return mp;
	}


	map <pair <int64, int>, int64> mp = dfs(mx);
	for (auto u : g[v]) {
		if (u != mx) {
			auto mp1 = dfs(u);
			for (auto& [k, c] : mp1) {
				mp[k] += c;
			}
		}
	}
	mp[{cost[v], v}] += sg[v].first;

	int64 gt = 0;
	for (auto u : g[v]) {
		gt += cnt[u];
	}

	while (gt < sg[v].first) {
		if (mp.begin()->second <= sg[v].first - gt) {
			gt += mp.begin()->second;
			ans += mp.begin()->second * mp.begin()->first.first;
			cnt[mp.begin()->first.second] += mp.begin()->second;
			mp.erase(mp.begin());
		}
		else {
			cnt[mp.begin()->first.second] += sg[v].first - gt;
			ans += (sg[v].first - gt) * mp.begin()->first.first;
			mp.begin()->second -= sg[v].first - gt;
			gt = sg[v].first;
		}
	}

	return mp;
}

void solve() {
	int n; cin >> n;
	g.assign(n, {});
	for (int i = 1; i < n; ++i) {
		int pr; cin >> pr;
		g[pr - 1].push_back(i);
	}

	cost.assign(n, 0);
	for (auto& x : cost) cin >> x;

	sg.assign(n, { 0, 0 });
	for (auto& [f, s] : sg) cin >> f >> s;

	sz.assign(n, 0);
	if (checkDfs(0) == -1) {
		cout << -1;
		return;
	}

	ans = 0;
	cnt.assign(n, 0);
	dfs(0);

	cout << ans << '\n';
	for (auto x : cnt) cout << x << ' ';
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int q; cin >> q;
	while (q--) {
		solve();
		cout << "\n\n";
	}
}