#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

vector<vector<int>> gr;
vector<int> pr;
vector<long long> l;
vector<long long> r;
vector<long long> c;

vector<long long> cnt;
vector<long long> sum;
vector<int> sz;
vector<int> cntown;

void dfssz(int v)
{
	sz[v] = 1;
	int maxsz = -1;
	for (int i = 0; i < gr[v].size(); i++)
	{
		dfssz(gr[v][i]);
		sz[v] += sz[gr[v][i]];
		if (maxsz == -1 || sz[gr[v][i]] > sz[gr[v][maxsz]])
		{
			maxsz = i;
		}
	}

	if (maxsz != -1)
	{
		swap(gr[v][0], gr[v][maxsz]);
	}
}

long long getminr(int a, int b)
{
	long long minr = r[b];
	while (a != b)
	{
		minr = min(minr, r[a]);
		a = pr[a];
	}
	return minr;
}

void subminr(int a, int b, int x, long long curc, set<pair<long long, int>>& s)
{
	r[b] -= x;
	cntown[a] += x;
	cnt[b] += x;
	sum[b] += curc;
	if (r[b] <= 0)
	{
		s.erase({ c[b], b });
	}
	while (a != b)
	{
		r[a] -= x;
		cnt[a] += x;
		sum[a] += curc;
		if (r[a] <= 0)
		{
			s.erase({ c[a], a });
		}
		a = pr[a];
	}
}

set<pair<long long, int>> dfs(int v)
{
	if (gr[v].size() == 0)
	{
		//cnt[v] = l[v];
		//sum[v] = cnt[v] * c[v];
		//r[v] -= cnt[v];
		set<pair<long long, int>> res;
		subminr(v, v, l[v], c[v], res);
		res.insert({ c[v], v });
		return res;
	}
	set<pair<long long, int>> s = dfs(gr[v][0]);
	cnt[v] = cnt[gr[v][0]];
	sum[v] = sum[gr[v][0]];
	for (int i = 1; i < gr[v].size(); i++)
	{
		set<pair<long long, int>> curs = dfs(gr[v][i]);
		cnt[v] += cnt[gr[v][i]];
		sum[v] += sum[gr[v][i]];
		for (auto& p : curs)
		{
			s.insert(p);
		}
	}

	r[v] -= cnt[v];

	s.insert({ c[v], v });

	while (cnt[v] < l[v])
	{
		auto [curc, k] = *s.begin();
		long long curminr = getminr(k, v);
		long long curadd = min(curminr, l[v] - cnt[v]);
		subminr(k, v, curadd, curc, s);
	}
	return s;
}

void solve()
{
	int n;
	cin >> n;
	gr.assign(n, vector<int>(0));
	pr.resize(n);
	l.resize(n);
	r.resize(n);
	c.resize(n);
	sz.resize(n);
	cntown.assign(n, 0);

	for (int i = 1; i < n; i++)
	{
		int p;
		cin >> p;
		p--;
		pr[i] = p;
		gr[p].push_back(i);
	}

	for (int i = 0; i < n; i++)
	{
		cin >> c[i];
	}
	for (int i = 0; i < n; i++)
	{
		cin >> l[i] >> r[i];
	}

	cnt.assign(n, 0);
	sum.assign(n, 0);

	dfssz(0);
	set<pair<long long, int>> s = dfs(0);

	for (int i = 0; i < n; i++)
	{
		if (r[i] < 0)
		{
			cout << -1;
			return;
		}
	}

	cout << sum[0] << "\n";
	for (int i = 0; i < n; i++)
	{
		cout << cntown[i] << " ";
	}
}

int main()
{
#ifdef _DEBUG
#pragma warning(disable : 4996)
	freopen("input.txt", "r", stdin);
#endif // _DEBUG

	int t;
	cin >> t;
	for (int i = 0; i < t; i++)
	{
		solve();
		cout << "\n";
	}
	return 0;
}