#include <bits/stdc++.h>

struct ST {
    std::vector<int> data;

    ST() = default;

    ST(int n) {
        data.assign(n + 1, 0);
        std::iota(data.begin(), data.end(), 0);
    }

    void add(int i, int dlt) {
        for (; i < data.size(); i++) {
            data[i] += dlt;
        }
    }

    int get(int i) {
        return data[i];
    }
};

int32_t main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    int n;
    std::cin >> n;
    std::vector<int> input(n);
    for (int &i : input) {
        std::cin >> i;
    }
    int q;
    std::cin >> q;
    std::vector<std::array<int, 4>> quer(q);
    std::vector<std::pair<int, int>> bin(q), pos(q);
    for (int i = 0; i < q; i++) {
        auto &[r1, c1, r2, c2] = quer[i];
        std::cin >> r1 >> c1 >> r2 >> c2;
        auto &[beg, end] = bin[i];
        beg = 0;
        end = std::min(r1, r2) + 1;
    }

    std::vector<ST> st(n + 1);
    st[0] = ST(n);
    for (int i = 0; i < n; i++) {
        st[i + 1] = st[i];
        st[i + 1].add(input[i], -1);
    }

    auto get = [&](int r, int c) {
        int beg = 0, end = n + 1;
        while (beg + 1 < end) {
            int mid = (beg + end) >> 1;
            if (st[mid].get(r) >= c) {
                beg = mid;
            } else {
                end = mid;
            }
        }
        return beg;
    };
    for (int i = 0; i < q; i++) {
        auto &[r1, c1, r2, c2] = quer[i];
        auto &[p1, p2] = pos[i];
        p1 = get(r1, c1);
        p2 = get(r2, c2);
    }

    for (int i = 0; i < q; i++) {
        auto &[r1, c1, r2, c2] = quer[i];
        auto &[beg, end] = bin[i];
        auto &[p1, p2] = pos[i];

        while (beg + 1 < end) {
            int mid = (beg + end) / 2;
            if (st[p1].get(mid) != st[p2].get(mid)) {
                end = mid;
            } else {
                beg = mid;
            }
        }
    }

    for (int i = 0; i < q; i++) {
        auto &[beg, end] = bin[i];
        auto &[p1, p2] = pos[i];
        std::cout << beg << " " << st[p1].get(beg) << "\n";
    }

    return 0;
}
