#include <bits/stdc++.h>

struct Vector {
    int x, y;

    Vector() = default;

    Vector(int x, int y) : x(x), y(y) {
        ;
    }

    Vector operator+(const Vector& other) const {
        return Vector(x + other.x, y + other.y);
    }

    Vector operator-(const Vector& other) const {
        return Vector(x - other.x, y - other.y);
    }

    int64_t surf() const {
        return llabs(x * 1LL * y);
    }

    bool operator<(const Vector& other) const {
        return std::pair{x, y} < std::pair{other.x, other.y};
    }
};

void solve() {
    int n;
    Vector r;
    std::cin >> n >> r.x >> r.y;
    std::vector<Vector> input(n);
    for (auto& [x, y] : input) {
        std::cin >> x >> y;
    }
    for (int i = 0; i < n; i++) {
        input[i] = r - input[i];
    }
    input.push_back({0, r.y});
    std::sort(input.begin(), input.end());
    for (int i = n; i > 0; i--) {
        input[i - 1].y = std::max(input[i - 1].y, input[i].y);
    }
    int64_t ans = 0;
    for (int i = 1; i <= n; i++) {
        ans += (input[i].x - input[i - 1].x) * 1LL * (input[i].y);
    }
    std::cout << ans << "\n";
}

int32_t main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    int k;
    std::cin >> k;
    std::vector<int> inp_dir(k);
    for (int& i : inp_dir) {
        std::cin >> i;
    }

    int t;
    std::cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}
