#include <bits/stdc++.h>

using namespace std;

struct Fenw {
    vector<int> tree;

    Fenw(int sz) {
        tree.resize(sz);
    }

    void add(int i, int val) {
        for (int x = i; x < tree.size(); x += (x & -x)) {
            tree[x] += val;
        }
    }

    int get(int i) {
        int res = 0;
        for (int x = i; x > 0; x -= (x & -x)) {
            res += tree[x];
        }
        return res;
    }

    int get(int l, int r) {
        return get(r) - get(l - 1);
    }

    void clear() {
        fill(tree.begin(), tree.end(), 0);
    }
};

void solve() {
    int n;
    cin >> n;
    vector<int> arr(n);
    for (int & e : arr)
        cin >> e;

    Fenw fenw(n + 1);


    vector<int> left_more(n);
    for (int i = 0; i < n; ++i) {
        left_more[i] = fenw.get(arr[i], n);
        fenw.add(arr[i], 1);
    }

    fenw.clear();

    vector<int> right_less(n);
    for (int i = n - 1; i >= 0; --i) {
        right_less[i] = fenw.get(0, arr[i]);
        fenw.add(arr[i], 1);
    }

    int ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            int x = left_more[i], y = right_less[j];
            int res = max(j - i + max(x, y), abs(arr[j] - arr[i]));
            ans += res;
        }
    }

    cout << ans << endl;
}

signed main() {
#ifdef LOCAL
freopen("in.txt", "r", stdin);
#else
cin.tie(NULL);
cout.tie(NULL);
ios_base::sync_with_stdio(false);
#endif // LOCAL

    solve();
}
