#include <bits/stdc++.h>
#define int long long
#define endl "\n"
using namespace std;
int INF = 1e9;

template <class T>
istream& operator >> (istream& in, vector <T> &a) {
    for (auto &el: a) in >> el;
    return in;
}

template <class T>
ostream& operator << (ostream& out, vector <T> &a) {
    for (auto &el: a) out << el << " ";
    return out;
}

struct SegmentTree {
    vector <vector <int> > tree;
    void build(int tl, int tr, int v, vector <int> &a) {
        if (tl == tr - 1) {
            tree[v] = {a[tl]};
        } else {
            int mid = (tl + tr) / 2;
            build(tl, mid, v * 2, a);
            build(mid, tr, v * 2 + 1, a);
            merge(tree[v * 2].begin(), tree[v * 2].end(), tree[v * 2 + 1].begin(), tree[v * 2 + 1].end(), back_inserter(tree[v]));
        }
    }

    SegmentTree(int n, vector <int> a) {
        tree.resize(n * 4);
        build(0, n, 1, a);
    }

    int get_ans(int tl, int tr, int v, int l, int r, int x, int y) {
        if (tl >= r || tr <= l) return 0;
        if (tl >= l && tr <= r) {
            return upper_bound(tree[v].begin(), tree[v].end(), y) - lower_bound(tree[v].begin(), tree[v].end(), x);
        } else {
            int mid = (tl + tr) / 2;
            return get_ans(tl, mid, v * 2, l, r, x, y) + get_ans(mid, tr, v * 2 + 1, l, r, x, y);
        }
    }
};

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n;
    cin >> n;
    vector <int> a(n);
    cin >> a;

    SegmentTree tree(n, a);
    int ans = 0;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            int now = abs(a[i] - a[j]);
            int x = tree.get_ans(0, n, 1, 0, i, a[i] + 1, n);
            now = max(now, j - i + x);
            x = tree.get_ans(0, n, 1, j + 1, n, 0, a[j] - 1);
            now = max(now, j - i + x);
            ans += now;
        }
    }
    cout << ans << endl;
}