#include "bits/stdc++.h"

using namespace std;


#define ll long long
#define vi vector<ll>
#define mn(a, b) a = min(a, b)
#define pii pair<ll, ll>
#define mp make_pair

const ll MAXN = 3e5 + 10;
const ll INF = 2e9;

struct stree {
    pii t[4 * MAXN];
    ll t_add[4 * MAXN];
    ll t_cnt[4 * MAXN];
    ll t_min[4 * MAXN];
    ll n;

    void init(ll _n) {
        n = _n;
        for (ll i = 0; i < 4 * n; ++i) t_min[i] = INF, t[i] = mp(INF, INF), t_add[i] = 0;
    }

    void push(ll v, ll tl, ll tr) {
        if (t_min[v] == 0) t[v] = mp(INF, INF);
        if (tl + 1 != tr) {
            mn(t_add[2 * v], t_add[v]);
            mn(t_add[2 * v + 1], t_add[v]);
        } else {
            mn(t_cnt[v], t_add[v]);
        }
        t_add[v] = INF;
    }

    ll get_cnt(ll v, ll tl, ll tr, ll pos) {
        push(v, tl, tr);
        if (tl + 1 == tr) return t_cnt[v];
        ll tm = (tl + tr) / 2;
        if (pos < tm) return get_cnt(2 * v, tl, tm, pos);
        return get_cnt(2 * v + 1, tm, tr, pos);
    }

    void sub(ll v, ll tl, ll tr, ll pos, ll x) {
        push(v, tl, tr);
        if (tl + 1 == tr) {
            t_cnt[v] -= x;
            if (t_cnt[v] == 0) t[v] = mp(INF, INF);
            return;
        }
        ll tm = (tl + tr) / 2;
        if (pos < tm) sub(2 * v, tl, tm, pos, x);
        else sub(2 * v + 1, tm, tr, pos, x);
        t[v] = min(t[2 * v], t[2 * v + 1]);
    }

    void set(ll v, ll tl, ll tr, ll pos, ll cnt, ll val) {
        push(v, tl, tr);
        if (tl + 1 == tr) {
            t_cnt[v] = cnt;
            t[v] = mp(val, pos);
            return;
        }
        ll tm = (tl + tr) / 2;
        if (pos < tm) set(2 * v, tl, tm, pos, cnt, val);
        else set(2 * v + 1, tm, tr, pos, cnt, val);
        t[v] = min(t[2 * v], t[2 * v + 1]);
    }

    pii find_min(ll v, ll tl, ll tr, ll l, ll r) {
        push(v, tl, tr);
        if (tl >= r || l >= tr) return mp(INF, INF);
        if (l <= tl && tr <= r) return t[v];
        ll tm = (tl + tr) / 2;
        pii L = find_min(2 * v, tl, tm, l, r);
        pii R = find_min(2 * v + 1, tm, tr, l, r);
        return min(L, R);
    }

    void dwn(ll v, ll tl, ll tr, ll l, ll r, ll val) {
        push(v, tl, tr);
        if (tl >= r || l >= tr) return;
        if (l <= tl && tr <= r) {
            t_add[v] = val;
            push(v, tl, tr);
            return;
        }
        ll tm = (tl + tr) / 2;
        dwn(2 * v, tl, tm, l, r, val);
        dwn(2 * v + 1, tm, tr, l, r, val);
        t[v] = min(t[2 * v], t[2 * v + 1]);
    }
};

ll timer = 0;//
ll tin[MAXN];
ll tout[MAXN];//
ll id[MAXN];//
vi graph[MAXN];//
ll L[MAXN];//
ll R[MAXN];//
ll c[MAXN];//
ll ans_cost = 0;//
ll cnt_subtree[MAXN];//
ll cnt[MAXN];//
ll cnt_max[MAXN];//
ll p[MAXN];//
stree t;//
ll n;//

void get_tin(ll v) {
    tin[v] = timer++;
    for (ll u : graph[v]) {
        get_tin(u);
    }
    tout[v] = timer++;
}

void update(ll v, ll x) {
    mn(x, R[v] - cnt_subtree[v]);
    cnt_max[v] = x;
    for (ll u : graph[v]) {
        update(u, x);
    }
}

ll find_best(ll v) {
    ll ans = INF;
    if (cnt_max[v] > 0) ans = v;
    for (ll u : graph[v]) {
        ll _ans = find_best(u);
        if (ans == INF) ans = _ans;
        if (_ans == INF) continue;
        if (c[ans] > c[_ans]) ans = _ans;
    }
    return ans;
}

void update_subtree_sz(ll v, ll u, ll val) {
    cnt_subtree[v] += val;
    if (v == u) return;
    update_subtree_sz(p[v], u, val);
}

void dfs(ll v) {
    for (ll u: graph[v]) {
        dfs(u);
        cnt_subtree[v] += cnt_subtree[u];
    }
    if (R[v] < cnt_subtree[v]) {
        cout << "-1\n";
        exit(0);
    }
    update(v, INF);
    while (cnt_subtree[v] < L[v]) {
        ll min_c = find_best(v);
        ll delta = min(L[v] - cnt_subtree[v], cnt_max[min_c]);
        cnt[min_c] += delta;
        update_subtree_sz(min_c, v, delta);
        ans_cost += c[min_c] * delta;
        update(v, INF);
    }
}

void solve() {
    cin >> n;
    ans_cost = 0;
    timer = 0;
    t.init(2 * n);
    for (ll i = 0; i < 2 * n; ++i) {
        cnt_subtree[i] = 0;
        cnt[i] = 0;
        graph[i].clear();
        tout[i] = 0;
        tin[i] = 0;
        id[i] = 0;
        cnt_max[i] = 0;
        p[i] = 0;
    }
    for (ll i = 1; i < n; ++i) {
        ll pi;
        cin >> pi;
        --pi;
        graph[pi].push_back(i);
        p[i] = pi;
    }
    for (ll i = 0; i < n; ++i) {
        cin >> c[i];
    }
    for (ll i = 0; i < n; ++i) {
        cin >> L[i] >> R[i];
    }
    get_tin(0);
    for (ll i = 0; i < n; ++i) id[tin[i]] = i;
    dfs(0);
    cout << ans_cost << "\n";
    for (ll i = 0; i < n; ++i) cout << cnt[i] << " ";
    cout << "\n";
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
#endif

    ll t; cin >> t;
    while (t--)
        solve();
}
