#include "bits/stdc++.h"

using namespace std;


#define ll long long
#define vi vector<ll>
#define mn(a, b) a = min(a, b)
#define pii pair<ll, ll>
#define mp make_pair

const ll MAXN = 3e5 + 10;
const ll INF = 2e9;

struct stree {
    pii t[4 * MAXN];
    ll t_add[4 * MAXN];
    ll t_cnt[4 * MAXN];
    ll n;

    void init(ll _n) {
        n = _n;
        for (ll i = 0; i < 4 * n; ++i) t_add[i] = INF, t[i] = mp(INF, INF);
    }

    void push(ll v, ll tl, ll tr) {
        if (t_add[v] == 0) t[v] = mp(INF, INF);
        if (tl + 1 != tr) {
            mn(t_add[2 * v], t_add[v]);
            mn(t_add[2 * v + 1], t_add[v]);
        } else {
            mn(t_cnt[v], t_add[v]);
        }
        t_add[v] = INF;
    }

    ll get_cnt(ll v, ll tl, ll tr, ll pos) {
        push(v, tl, tr);
        if (tl + 1 == tr) return t_cnt[v];
        ll tm = (tl + tr) / 2;
        if (pos < tm) return get_cnt(2 * v, tl, tm, pos);
        return get_cnt(2 * v + 1, tm, tr, pos);
    }

    void sub(ll v, ll tl, ll tr, ll pos, ll x) {
        push(v, tl, tr);
        if (tl + 1 == tr) {
            t_cnt[v] -= x;
            if (t_cnt[v] == 0) t[v] = mp(INF, INF);
            return;
        }
        ll tm = (tl + tr) / 2;
        if (pos < tm) sub(2 * v, tl, tm, pos, x);
        else sub(2 * v + 1, tm, tr, pos, x);
        t[v] = min(t[2 * v], t[2 * v + 1]);
    }

    void set(ll v, ll tl, ll tr, ll pos, ll cnt, ll val) {
        push(v, tl, tr);
        if (tl + 1 == tr) {
            t_cnt[v] = cnt;
            t[v] = mp(val, pos);
            return;
        }
        ll tm = (tl + tr) / 2;
        if (pos < tm) set(2 * v, tl, tm, pos, cnt, val);
        else set(2 * v + 1, tm, tr, pos, cnt, val);
        t[v] = min(t[2 * v], t[2 * v + 1]);
    }

    pii find_min(ll v, ll tl, ll tr, ll l, ll r) {
        push(v, tl, tr);
        if (tl >= r || l >= tr) return mp(INF, INF);
        if (l <= tl && tr <= r) return t[v];
        ll tm = (tl + tr) / 2;
        pii L = find_min(2 * v, tl, tm, l, r);
        pii R = find_min(2 * v + 1, tm, tr, l, r);
        return min(L, R);
    }

    void dwn(ll v, ll tl, ll tr, ll l, ll r, ll val) {
        push(v, tl, tr);
        if (tl >= r || l >= tr) return;
        if (l <= tl && tr <= r) {
            t_add[v] = val;
            push(v, tl, tr);
            return;
        }
        ll tm = (tl + tr) / 2;
        dwn(2 * v, tl, tm, l, r, val);
        dwn(2 * v + 1, tm, tr, l, r, val);
        t[v] = min(t[2 * v], t[2 * v + 1]);
    }
};

ll timer = 0;//
ll tin[MAXN];
ll tout[MAXN];//
ll id[MAXN];//
vi graph[MAXN];//
ll L[MAXN];//
ll R[MAXN];//
ll c[MAXN];//
ll ans_cost = 0;//
ll cnt_subtree[MAXN];//
ll cnt[MAXN];//
stree t;//
ll n;//

void get_tin(ll v) {
    tin[v] = timer++;
    for (ll u : graph[v]) {
        get_tin(u);
    }
    tout[v] = timer++;
}

void dfs(ll v) {
    for (ll u : graph[v]) {
        dfs(u);
        cnt_subtree[v] += cnt_subtree[u];
    }
    if (R[v] < cnt_subtree[v]) {
        cout << "-1\n";
        exit(0);
    }
    t.set(1, 0, 2 * n, tin[v], INF, c[v]);
    while (cnt_subtree[v] < L[v]) {
        t.dwn(1, 0, 2 * n, tin[v], tout[v], R[v] - cnt_subtree[v]);
        auto min_c = t.find_min(1, 0, 2 * n, tin[v], tout[v]);
        ll cnt_min_c = t.get_cnt(1, 0, 2 * n, min_c.second);
        ll delta = min(L[v] - cnt_subtree[v], cnt_min_c);
        cnt[id[min_c.second]] += delta;
        t.sub(1, 0, 2 * n, min_c.second, delta);
        cnt_subtree[v] += delta;
        ans_cost += min_c.first * delta;
    }
}

void solve() {
    cin >> n;
    ans_cost = 0;
    timer = 0;
    t.init(2 * n);
    for (ll i = 0; i < 2 * n; ++i) {
        cnt_subtree[i] = 0;
        cnt[i] = 0;
        graph[i].clear();
        tout[i] = 0;
        tin[i] = 0;
        id[i] = 0;
    }
    for (ll i = 1; i < n; ++i) {
        ll p;
        cin >> p;
        --p;
        graph[p].push_back(i);
    }
    for (ll i = 0; i < n; ++i) {
        cin >> c[i];
    }
    for (ll i = 0; i < n; ++i) {
        cin >> L[i] >> R[i];
    }
    get_tin(0);
    for (ll i = 0; i < n; ++i) id[tin[i]] = i;
    dfs(0);
    cout << ans_cost << "\n";
    for (ll i = 0; i < n; ++i) cout << cnt[i] << " ";
    cout << "\n";
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
#endif

    ll t; cin >> t;
    while (t--)
        solve();
}
