#include <bits/stdc++.h>

using num = long long;

struct Vertex
{
    num c;
    num l, r;
    std::vector<num> children;
    num hardl;
};
std::vector<Vertex> graph;

bool is_valid(num v)
{
    num l = 0;
    for(auto u : graph[v].children)
    {
        if(!is_valid(u))
            return false;

        l += graph[u].hardl;
    }

    graph[v].hardl = std::max(graph[v].l, l);

    return graph[v].hardl <= graph[v].r;
}

const num max_n = 500, max_r = 1000;

num dp[max_n][max_r+1];
void dfs(num v)
{
    for(num b = 0; b <= graph[v].r; b++)
        dp[v][b] = graph[v].c * b;

    for(auto u : graph[v].children)
    {
        dfs(u);

        num result[max_r+1];
        for(num i = 0; i <= max_r; i++)
            result[i] = dp[v][i];

        for(num b = 0; b <= graph[v].r; b++)
        {
            for(num bu = graph[u].hardl; bu <= graph[u].r; bu++)
            {
                if(b + bu > graph[v].r)
                    continue;

                result[b + bu] = std::min(result[b + bu], dp[v][b] + dp[u][bu]);
            }
        }

        for(num i = 0; i <= max_r; i++)
            dp[v][i] = result[i];
    }

    /*
    std::cout << "v=" << v << ": ";
    for(num i = 0; i <= graph[v].r; i++)
        std::cout << dp[v][i] << ' ';
    std::cout << '\n';
     */
}

int main()
{
    num t;
    std::cin >> t;
    while(t--)
    {
        num n;
        std::cin >> n;

        graph.clear();
        graph.resize(n);

        for(num i = 1; i < n; i++)
        {
            num p;
            std::cin >> p;
            graph[p-1].children.push_back(i);
        }

        for(num i = 0; i < n; i++)
            std::cin >> graph[i].c;

        for(num i = 0; i < n; i++)
            std::cin >> graph[i].l >> graph[i].r;

        const num root = 0;

        if(!is_valid(root))
        {
            std::cout << "-1\n";
            continue;
        }

        dfs(root);
        std::cout << *std::min_element(&dp[root][graph[root].l], &dp[root][graph[root].r+1]) << '\n';
    }
}
