// #define __GLIBCXX_DEBUG
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")
// #define int long long 
#define real long double
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define f first
#define s second
#define pi M_PI
#define elif else if
typedef tree<int, null_type, less_equal<int>, rb_tree_tag, tree_order_statistics_node_update> indexed_set;


const int INF = 1e9, MOD = 1e9 + 7, RANDOM = chrono::steady_clock::now().time_since_epoch().count();
const real EPS = 1e-12;
mt19937 rng(43);


const int maxn = 3e3 + 100;
int n;
int a[maxn];
vector<pair<int, int>> graph[maxn][maxn];
int depth[maxn][maxn];
pair<int, int> pr[maxn][maxn];



void dfs(int x, int y, pair<int, int> p){
	if (p.f != -1) depth[x][y] = depth[p.f][p.s] + 1;
	for (auto u: graph[x][y]){
		if (u == p) continue;
		dfs(u.f, u.s, {x, y});
	}
}


void build(){
	int b[n]; memset(b, false, sizeof(b));
	for (int i=0; i<=n; ++i){
		int x = 0, y = 0;
		for (int j=0; j<n; ++j){
			int x2 = x + 1, y2;
			if (!b[j]) y2 = y + 1;
			else y2 = y;
			if (find(all(graph[x][y]), make_pair(x2, y2)) == graph[x][y].end()){
				graph[x][y].push_back({x2, y2});
				graph[x2][y2].push_back({x, y});
				pr[x2][y2] = {x, y};
			}
			x = x2; y = y2;
		}
		if(i != n) b[a[i] - 1] = 1;
	}
	dfs(0, 0, {-1, -1});
}


pair<int, int> search(int x, int y, int x2, int y2){
	if (depth[x][y] < depth[x2][y2]){
		swap(x, x2);
		swap(y, y2);
	}
	while (x != x2 or y != y2){
		// cerr << x << " " << y << "  " << x2 << " " << y2 << "\n";
		if (depth[x][y] == depth[x2][y2]){
			pair<int, int> p = pr[x2][y2];
			swap(p.f, x2);
			swap(p.s, y2);
		}
		pair<int, int> p = pr[x][y];
		swap(p.f, x);
		swap(p.s, y);
	}
	// cerr << x << " " << y << "  " << x2 << " " << y2 << "\n";
	return {x, y};
}


void debug(){
	cerr << "\n";
	for (int i=0; i<=n; ++i){
		for (int j=0; j<=i; ++j){
			cerr << i << " " << j << "\n";
			for (auto u: graph[i][j]) cerr << u.f << " " << u.s << "  ";
			cerr << "\n";
		}
		cerr << "\n";
	}
	cerr << "\n";
}


void debug2(){
	cerr << "\n";
	for (int i=0; i<=n; ++i){
		for (int j=0; j<=i; ++j) cerr << pr[i][j].f << " " << pr[i][j].s << " " << depth[i][j] << "   ";
		cerr << "\n";
	}
	cerr << "\n";
}


signed main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	cin >> n;
	for (int i=0; i<n; ++i) cin >> a[i];
	build();
	// debug();
	// debug2();
	// return 0;
	int q; cin >> q;
	while (q--){
		int x, y, x2, y2; cin >> x >> y >> x2 >> y2;
		pair<int, int> p = search(x, y, x2, y2);
		cout << p.f << " " << p.s << "\n";
	}
}

/*
3
2 3 1
5
3 3 3 0
2 2 2 1
1 0 3 1
3 1 3 2
2 2 2 2

0 0
1 1
0 0
2 1
2 2
*/