
#include <bits/stdc++.h>

#define ll long long


using namespace std;

const int MAXN = 3000 + 10;
const ll INF = 1e14 + 7;

int n;
int a[MAXN];
bool have_right[MAXN][MAXN];


void build_tree() {
    vector<bool> left(n);
    for (int j = 0; j < n + 1; ++j) {
        int r = 0, c = 0;
        for (int i = 0; i < n; ++i) {
            if (!left[i])
                c++;
            r++;
            if (left[i])
                have_right[r][c] = true;
        }
        if (j != n) left[a[j]] = true;
    }
}

pair<int, int> get_lca(int r1, int c1, int r2, int c2) {
    if (r1 < r2) {
        swap(r1, r2);
        swap(c1, c2);
    }
    while (r1 > r2) {
        if (!have_right[r1][c1])
            --c1;
        --r1;
    }
    while (c1 != c2) {
        if (!have_right[r1][c1])
            --c1;
        --r1;
        if (!have_right[r2][c2])
            --c2;
        --r2;
    }
    return {r1, c1};
}

signed main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        --a[i];
    }
    build_tree();
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        auto res = get_lca(r1, c1, r2, c2);
        cout << res.first << " " << res.second << "\n";
    }
}
