#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

#define endl '\n'

const int Base = 1e5 + 555;

int t;

int n;
vector<int> e[Base];
set<pair<int, int>> opt[Base];
long long ans = 0;
int c[Base];
int extra[Base];
int l[Base];
int r[Base];
int p[Base];
int a[Base];
int ansA[Base];
bool used[Base];

void updateL(int x)
{
	int sumL = 0;
	for (auto v : e[x])
	{
		updateL(v);
		sumL += l[v];
	}

	l[x] = max(l[x], sumL);
	extra[x] = l[x] - sumL;
}

void updateR(int x, int val)
{
	r[x] = min(r[x], val);
	for (auto v : e[x])
	{
		updateR(v, r[x]);
	}
}

void fillUsed(int x)
{
	if (used[x])
	{
		return;
	}
	used[x] = true;

	for (auto v : e[x])
	{
		fillUsed(v);
	}
}

long long takeOld(int x, pair<int, int> k)
{
	int u = k.second;
	long long cost = k.first;

	if (used[u])
	{
		opt[x].erase(opt[x].begin());
		return 0;
	}

	int v = u;
	int mx = l[x] - a[x];
	int last = -1;
	while (v != -1)
	{
		if (mx >= r[v] - a[v])
		{
			last = v;
			mx = r[v] - a[v];
		}
		v = p[v];
	}

	v = u;
	while (v != -1)
	{
		a[v] += mx;
		v = p[v];
	}
	ansA[u] += mx;

	if (last != -1)
	{
		fillUsed(last);
	}

	return cost * mx;
}

long long take(int x, pair<int, int> k)
{
	int u = k.second;
	long long cost = k.first;
	int mx = l[x] - a[x];
	ansA[u] += mx;
	return cost * mx;
}

void calcAns(int x)
{
	for (auto v : e[x])
	{
		calcAns(v);
	}

	opt[x].insert(make_pair(c[x], x));
	for (auto v : e[x])
	{
		if (opt[x].size() > opt[v].size())
		{
			for (auto k : opt[v])
			{
				opt[x].insert(k);
			}
		}
		else
		{
			for (auto k : opt[x])
			{
				opt[v].insert(k);
			}
			swap(opt[v], opt[x]);
		}
	}

	while (a[x] < l[x])
	{
		ans += take(x, *opt[x].begin());
	}
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG

	ios_base::sync_with_stdio(0);
	cin.tie(0);

	cin >> t;

	while (t--)
	{
		cin >> n;

		p[0] = -1;
		ans = 0;
		for (int i = 0; i < n; i++)
		{
			e[i].clear();
			opt[i].clear();
			used[i] = false;
			ansA[i] = 0;
			a[i] = 0;
		}

		for (int i = 1; i < n; i++)
		{
			cin >> p[i];
			p[i]--;
			e[p[i]].push_back(i);
		}

		for (int i = 0; i < n; i++)
		{
			cin >> c[i];
		}

		for (int i = 0; i < n; i++)
		{
			cin >> l[i] >> r[i];
		}

		updateL(0);
		updateR(0, 1e9);

		bool fl = false;
		for (int i = 0; i < n; i++)
		{
			if (l[i] > r[i])
			{
				fl = true;
				break;
			}
		}

		if (fl)
		{
			cout << -1 << endl;
			continue;
		}

		calcAns(0);

		cout << ans << endl;
		for (int i = 0; i < n; i++)
		{
			cout << ansA[i] << ' ';
		}
		cout << endl;
	}
}