#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

#define endl '\n'

const int Base = 1e5 + 555;

int t;

int n;
vector<int> e[Base];
pair<int, int> opt[Base];
long long ans = 0;
int c[Base];
int extra[Base];
int l[Base];
int r[Base];
int p[Base];
int a[Base];
int ansA[Base];
bool used[Base];

void updateL(int x)
{
	int sumL = 0;
	for (auto v : e[x])
	{
		updateL(v);
		sumL += l[v];
	}

	l[x] = max(l[x], sumL);
	extra[x] = l[x] - sumL;
}

void updateR(int x, int val)
{
	r[x] = min(r[x], val);
	for (auto v : e[x])
	{
		updateR(v, r[x]);
	}
}

void fillUsed(int x)
{
	if (used[x])
	{
		return;
	}
	used[x] = true;

	for (auto v : e[x])
	{
		fillUsed(v);
	}
}

pair<int, long long> take(int x, pair<int, int> k)
{
	int u = k.second;
	long long cost = k.first;
	int mx = max(0, l[x] - a[x]);
	ansA[u] += mx;
	return make_pair(mx, cost * mx);
}

int calcAns(int x)
{
	for (auto v : e[x])
	{
		a[x] += calcAns(v);
	}

	opt[x] = make_pair(c[x], x);
	for (auto v : e[x])
	{
		opt[x] = min(opt[x], opt[v]);
	}

	auto r = take(x, opt[x]);
	ans += r.second;
	return r.first;
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG

	ios_base::sync_with_stdio(0);
	cin.tie(0);

	cin >> t;

	while (t--)
	{
		cin >> n;

		p[0] = -1;
		ans = 0;
		for (int i = 0; i < n; i++)
		{
			e[i].clear();
			used[i] = false;
			ansA[i] = 0;
			a[i] = 0;
		}

		for (int i = 1; i < n; i++)
		{
			cin >> p[i];
			p[i]--;
			e[p[i]].push_back(i);
		}

		for (int i = 0; i < n; i++)
		{
			cin >> c[i];
		}

		for (int i = 0; i < n; i++)
		{
			cin >> l[i] >> r[i];
		}

		updateL(0);
		//updateR(0, 1e9);

		bool fl = false;
		for (int i = 0; i < n; i++)
		{
			if (l[i] > r[i])
			{
				fl = true;
				break;
			}
		}

		if (fl)
		{
			cout << -1 << endl;
			continue;
		}

		calcAns(0);

		cout << ans << endl;
		for (int i = 0; i < n; i++)
		{
			cout << ansA[i] << ' ';
		}
		cout << endl;
	}
}