#include <bits/stdc++.h>

//#define int long long
#define ll long long
#define ld long double
#define all(x) x.begin(),x.end()
using namespace std;

int getV(int &r,int &c){
    return r*(r+1)/2 + c;
}

int getV(pair<int,int> &pr){
    auto [r,c] = pr;
    return r*(r+1)/2 + c;
}

const int MAXN = 3000*3000+1;

vector<int> g[MAXN];
int tin[MAXN],tout[MAXN];

vector<int> order;

void dfs(int &v,int &p){
    order.push_back(v);
    tin[v] = (int)order.size()-1;

    for(auto to:g[v]){
        if(to==p) continue;

        dfs(to,v);
        order.push_back(v);
    }

    tout[v] = (int)order.size()-1;
}

struct node{
    int mn,id;

    node(int mn,int id):mn(mn),id(id){};

    node(){};
};

struct my_tree{
    vector<node> tree;
    vector<int> a;
    int n;

    my_tree(vector<int> &_a){
        a = _a;
        n = (int)a.size();

        tree.assign(4*n,node());
        build(0,0,n);
    }

    void build(int v,int l,int r){
        if(l+1==r){
            tree[v] = node(tin[a[l]],a[l]);
            return;
        }

        int m = (l+r)/2;
        build(2*v+1,l,m);
        build(2*v+2,m,r);

        if(tree[2*v+1].mn<tree[2*v+2].mn){
            tree[v] = tree[2*v+1];
        }else{
            tree[v] = tree[2*v+2];
        }
    }

    int INF = 1e9+100;
    node getAns(int v,int l,int r,int L,int R){
        if(r<=L||l>=R){
            return node(INF,INF);
        }

        if(l>=L&&r<=R){
            return tree[v];
        }

        int m = (l+r)/2;
        node res1 = getAns(2*v+1,l,m,L,R),res2 = getAns(2*v+2,m,r,L,R);
        if(res1.mn<res2.mn){
            return res1;
        }else{
            return res2;
        }
    }
};

signed main() {
    ios::ios_base::sync_with_stdio(false);
    cin.tie(0);
#ifdef MY_DEBUG
    freopen("input.txt","r",stdin);
#endif

    int n;
    cin>>n;

    vector<int> a(n);
    vector<int> b(n,1);
    vector<pair<int,int> > arr;
    for(int i=0;i<n+1;i++){
        arr.push_back({i,i});
        if(i>0){
            g[getV(arr[i-1])].push_back(getV(arr[i]));
            g[getV(arr[i])].push_back(getV(arr[i-1]));
        }
    }

    pair<int,int> prev_pr,new_pr;
    for(int i=0;i<n;i++){
        cin>>a[i];
        b[a[i]-1] = 0;

        for(int j=a[i];j<=n;j++){
            prev_pr = arr[j-1];
            if(b[j-1] == 1){
                new_pr = {j,prev_pr.second + 1};
            }else{
                new_pr = {j,prev_pr.second};
            }

            arr[j] = new_pr;
            g[getV(arr[j-1])].push_back(getV(arr[j]));
            g[getV(arr[j])].push_back(getV(arr[j-1]));
        }
    }

    order.clear();
    order.push_back(0);
    int st = 0,st2 = -1;
    dfs(st,st2);

    my_tree tree(order);

    int q;
    cin>>q;

    int v1,v2,L,R,r;
    int r1,c1,r2,c2;
    int res;
    for(int _i=0;_i<q;_i++){
        cin>>r1>>c1>>r2>>c2;

        v1 = getV(r1,c1), v2  = getV(r2,c2);

        L = min(tin[v1],tin[v2]), R = max(tout[v1],tout[v2])+1;
        res = tree.getAns(0,0,(int)order.size(),L,R).id;

        r = 0;
        while(r*(r+1)/2-1<res){
            r++;
        }

        cout<<r-1<<" "<<res-(r*(r-1)/2)<<"\n";
    }
}
