#include <bits/stdc++.h>

//#define int long long
#define ll long long
#define ld long double
#define all(x) x.begin(),x.end()

using namespace std;

int getV(int r,int c){
    return r*(r+1)/2 + c;
}

int getV(pair<int,int> pr){
    auto [r,c] = pr;
    return r*(r+1)/2 + c;
}

const int sz = 12;
const int MAXN = 3000*3000+1;

vector<int> g[MAXN];
int binp[sz][MAXN];
int p[MAXN],dep[MAXN];

void add_edge(int u,int v){
    g[u].push_back(v);
    g[v].push_back(u);
}

void dfs(int v){
    binp[0][v] = p[v];
    for(int i=1;i<sz;i++){
        binp[i][v] = binp[i-1][binp[i-1][v]];
    }

    for(auto to:g[v]){
        if(to==p[v]) continue;

        p[to] = v;
        dep[to] = dep[v]+1;
        dfs(to);
    }
}

int parent(int v,int h){
    for(int i=0;i<sz;i++){
        if(h&(1<<i)){
            v = binp[i][v];
        }
    }

    return v;
}

int lca(int a,int b){
    if(dep[a]<dep[b]){
        swap(a,b);
    }
    a = parent(a,dep[a]-dep[b]);

    if(a==b){
        return a;
    }

    for(int i = sz-1;i>=0;i--){
        if(binp[i][a]!=binp[i][b]){
            a = binp[i][a];
            b = binp[i][b];
        }
    }

    return p[a];
}

signed main() {
    ios::ios_base::sync_with_stdio(false);
    cin.tie(0);
#ifdef MY_DEBUG
    freopen("input.txt","r",stdin);
#endif

    int n;
    cin>>n;
    int sz_graf = n*n+1;

    vector<int> a(n);
    vector<int> b(n,1);
    vector<pair<int,int> > arr;
    for(int i=0;i<n+1;i++){
        arr.push_back({i,i});
        if(i>0){
            add_edge(getV(arr[i-1]),getV(arr[i]));
        }
    }

    for(int i=0;i<n;i++){
        cin>>a[i];
        b[a[i]-1] = 0;

        for(int j=a[i];j<=n;j++){
            pair<int,int> prev_pr = arr[j-1];
            pair<int,int> new_pr;

            if(b[j-1] == 1){
                new_pr = {j,prev_pr.second + 1};
            }else{
                new_pr = {j,prev_pr.second};
            }

            arr[j] = new_pr;
            add_edge(getV(arr[j-1]),getV(arr[j]));
        }
    }

    dfs(0);

    int q;
    cin>>q;

    for(int _i=0;_i<q;_i++){
        int r1,c1,r2,c2;
        cin>>r1>>c1>>r2>>c2;

        int v1 = getV(r1,c1), v2  = getV(r2,c2);

        int res = lca(v1,v2);

        int r = 0;
        while(r*(r+1)/2-1<res){
            r++;
        }

        cout<<r-1<<" "<<res-(r*(r-1)/2)<<"\n";
    }

}
