#include <bits/stdc++.h>

#define all(q) q.begin(), q.end()

using namespace std;
constexpr int MAXN = (int)5e5;
int a[MAXN];
int n;

vector<int> t[4 * MAXN];
pair<int, int> tmin[4 * MAXN];

void build(int v, int l, int r) {
    if (r - l > 1) {
        int m = (l + r) >> 1;
        build(2 * v + 1, l, m);
        build(2 * v + 2, m, r);
        t[v].resize(r - l);
        merge(all(t[2 * v + 1]), all(t[2 * v + 2]), t[v].begin());
        tmin[v] = min(tmin[2 * v + 1], tmin[2 * v + 2]);
    } else {
        t[v] = { a[l] };
        tmin[v] = { a[l], l };
    }
}

int count_less(int v, int l, int r, int ql, int qr, int x) {
    if (l >= qr || r <= ql) {
        return 0;
    }
    if (l >= ql && r <= qr) {
        return lower_bound(all(t[v]), x) - t[v].begin();
    }

    int m = (l + r) >> 1;
    return count_less(2 * v + 1, l, m, ql, qr, x) + count_less(2 * v + 2, m, r, ql, qr, x);
}

pair<int, int> get_min(int v, int l, int r, int ql, int qr) {
    if (l >= qr || r <= ql) {
        return { n, n };
    }
    if (l >= ql && r <= qr) {
        return tmin[v];
    }

    int m = (l + r) >> 1;
    return min(get_min(2 * v + 1, l, m, ql, qr), get_min(2 * v + 2, m, r, ql, qr));
}

bool check_path(int idx, int r, int c) {
    return count_less(0, 0, n, 0, idx, r) < (r - c);
}

int find_path(int r, int c) {
    if (r == c) {
        return 0;
    }
    int left = 0, right = n;
    while (right - left > 1) {
        int mid = (left + right) >> 1;
        if (check_path(mid, r, c)) {
            left = mid;
        } else {
            right = mid;
        }
    }

    return right;
}

pair<int, int> path_lca(int a, int b) {
    if (a > b) {
        swap(a, b);
    }
    int r = get_min(0, 0, n, a, b).first;
    int c = r - count_less(0, 0, n, 0, b, r);
    return { r, c };
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);

    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        --a[i];
    }

    build(0, 0, n);

    int q;
    cin >> q;
    while (q--) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;

        int p1 = find_path(r1, c1);
        int p2 = find_path(r2, c2);

        if (p1 == p2) {
            if (r1 < r2) {
                cout << r1 << ' ' << c1 << '\n';
            } else {
                cout << r2 << ' ' << c2 << '\n';
            }
        } else {
            auto [r, c] = path_lca(p1, p2);
            cout << r << ' ' << c << '\n';
        }
    }

    return 0;
}