#include<iostream>
#include<vector>
#include<algorithm>
#include<set>

#define int long long

using namespace std;

int total_cost = 0;

bool fail = false;

pair<pair<int, int>, int> DFS(int v, vector<vector<int>> &g, vector<int> &c, vector<int> &left, vector<int> &right, vector<int> &ans){
    int cnt = 0;
    int min_cost = c[v];
    int min_v = v;
    for (int u : g[v]){
        auto res = DFS(u, g, c, left, right, ans);
        if (res.first.first < min_cost){
            min_cost = res.first.first;
            min_v = res.first.second;
        }
        cnt += res.second;
    }
    if (cnt < left[v]){
        int x = left[v] - cnt;
        ans[min_v] += x * min_cost;
        cnt += x;
        total_cost += x * min_cost;
    }
    return {{min_cost, min_v}, cnt};
}

signed main(){
    int t;
    cin >> t;
    while(t--){
        int n;
        cin >> n;
        vector<vector<int>> g(n);
        for (int i = 1; i < n; ++i){
            int p;
            cin >> p;
            g[p - 1].push_back(i);
        }
        vector<int> c(n);
        vector<int> left(n);
        vector<int> right(n);
        for (int i = 0; i < n; ++i){
            cin >> c[i];
        }
        for (int i = 0; i < n; ++i){
            cin >> left[i] >> right[i];
        }
        vector<int> ans(n);
        total_cost = 0;
        fail = false;
        DFS(0, g, c, left, right, ans);
        if (fail){
            cout << -1 << endl;
            continue;
        }
        cout << total_cost << endl;
        for (int i = 0; i < n; ++i){
            cout << ans[i] << " ";
        }
        cout << endl;
    }
    return 0;
}
/*
2
3
1 1
3 1 2
5 7
1 2
2 4
2
1
5 5
0 1
2 2

2
4
1 2 3
5 5 1 10
15 16
10 10
0 10
2 100
5
1 2 2 2
1000 100 1000 1 2
105 1000
100 100
1 15
1 2
47 48

*/
