#ifndef LOCAL
#pragma GCC optimize("Ofast")
#pragma GCC optimize("O3")
#endif

#include <iostream>
#include <vector>
#include <algorithm>

#define len(a) (int)a.size()

typedef long long ll;

const int INF = (int)1e9;

using namespace std;

void run();

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#endif

    run();

}

void run()
{
    int n;
    cin >> n;
    vector<int> arr(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> arr[i];
        --arr[i];
    }

    vector< vector<int> > max_dist(n, vector<int>(n, 0));
    vector<int> temp;
    for (int i = 0; i < n; ++i)
    {
        temp.push_back(arr[i]);
        sort(temp.begin(), temp.end());
        for (int j = 0; j < len(temp); ++j)
        {
            for (int k = 0; k < len(temp); ++k)
            {
                max_dist[temp[j]][temp[k]] = max(max_dist[temp[j]][temp[k]], abs(j - k));
                max_dist[temp[k]][temp[j]] = max(max_dist[temp[k]][temp[j]], abs(j - k));
            }
            for (int k = i + 1; k < n; ++k)
            {
                max_dist[temp[j]][arr[k]] = max(max_dist[temp[j]][arr[k]], abs(j - k));
                max_dist[arr[k]][temp[j]] = max(max_dist[arr[k]][temp[j]], abs(j - k));
            }
        }
    }

    temp.clear();
    for (int i = n - 1; i > -1; --i)
    {
        int kekw = arr[i];
        temp.push_back(arr[i]);
        sort(temp.begin(), temp.end());
        for (int j = 0; j < len(temp); ++j)
        {
            if (temp[j] != kekw)
            {
                continue;
            }
            for (int k = i - 1; k > -1; --k)
            {
                max_dist[temp[j]][arr[k]] = max(max_dist[temp[j]][arr[k]], abs(i + j - k));
                max_dist[arr[k]][temp[j]] = max(max_dist[arr[k]][temp[j]], abs(i + j - k));
            }
        }
    }

    int ans = 0;
    for (int i = 0; i < n; ++i)
    {
        for (int j = i + 1; j < n; ++j)
        {
            ans += max_dist[i][j];
        }
    }
    cout << ans << '\n';
}