#ifndef LOCAL
#pragma GCC optimize("Ofast")
#pragma GCC optimize("O3")
#endif

#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <numeric>
#include <cmath>

#define len(a) (int)a.size()

typedef long long ll;

const int INF = (int)1e9;

using namespace std;

void run();

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#endif

    run();

}

void solve_test()
{
    int n, w, h;
    cin >> n >> w >> h;
    vector< pair<int, int> > points(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> points[i].first >> points[i].second;
    }
    auto cmp = [](pair<int, int> a, pair<int, int> b)
    {
        return (a.second < b.second);
    };
    sort(points.begin(), points.end(), cmp);

    ll ans = 0;
    int min_one_border, max_two_border;
    min_one_border = w;
    max_two_border = 0;
    for (int i = 0; i < n; ++i)
    {
        if (min_one_border <= max_two_border)
        {
            break;
        }
        ll left_sqr, right_sqr;
        int right_border = min(min_one_border, points[i].first);
        if (right_border <= max_two_border)
        {
            left_sqr = 0;
        }
        else
        {
            left_sqr = (ll)(right_border - max_two_border) * (h - points[i].second);
        }

        int left_border = max(max_two_border, points[i].first);
        if (left_border >= min_one_border)
        {
            right_sqr = 0;
        }
        else
        {
            right_sqr = (ll)(min_one_border - left_border) * (h - points[i].second);
        }

        if (left_sqr > right_sqr)
        {
            ans += left_sqr;
            max_two_border = max(max_two_border, points[i].first);
        }
        else
        {
            ans += right_sqr;
            min_one_border = min(min_one_border, points[i].first);
        }
    }

    cout << ans << '\n';
}

void run()
{
    int k;
    cin >> k;
    vector<int> allowed(k);
    for (int i = 0; i < k; ++i)
    {
        cin >> allowed[i];
    }
    if (allowed != vector<int>{1, 2})
    {
        cout << "Nu pizdec\n";
        return;
    }
    int t;
    cin >> t;
    for (; t > 0; --t)
    {
        solve_test();
    }
}