#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
std::vector<std::vector<int>> children;
std::vector<int> parent, cost_here, lcons, rcons;
std::vector<int64_t> ansv;
std::vector<int> bought;
bool FAIL = false;
struct cmp
{
	bool operator()(int a, int b) const
	{
		return std::tie(cost_here[a], a) < std::tie(cost_here[b], b);
	}
};
std::map<int,int, cmp> dfs(int at)
{
	std::map<int,int, cmp> ctrs {};
	int n_extra = rcons[at], n_rem = lcons[at];
	int64_t ans = 0;
	for(int to : children[at])
	{
		auto nm = dfs(to);
		if(FAIL) return {};
		for(auto[from, num] : nm) ctrs[from] += num;
		ans += ansv[to];
		n_extra -= lcons[to];
		n_rem -= lcons[to];
	}
	if(n_extra < 0)
	{
		FAIL = true;
		return {};
	}
	ctrs[at] = n_extra;
	// buy somewhere else -> two numbers decrease
	// buy here -> one number decreases
	// can this lead to -1?
	for(auto[from,num] : ctrs)
	{
		if(n_rem <= 0) break;
		int cost = cost_here[from];
		int buy = std::min(num, n_rem);
		ctrs[from] -= buy;
		bought[from] += buy;
		ans += buy * 1ll * cost;
		n_rem -= buy;
		n_extra -= buy;
	}
	for(auto&[k, v] : ctrs)
		v = std::min(v, n_extra);
	if(ctrs[at] < 0)
	{
		FAIL = true;
		return {};
	}
	ansv[at] = ans;
	return ctrs;
}
int main()
{
	// minimize total cost if l <= sum in each subtree <= r
	// solution exists iff buying minimally to satisfy l in each vertex won't violate any r constraints
	// buying higher in the tree is always acceptable, if it's cheaper and won't violate child constraints
	// buy as little as possible in leaves
	// when merging trees, if there is not enough, buy from the cheapest vertices in the subtree
	// return counter maps (cost, n_remaining), add them for each child
	int T; std::cin >> T;
	while(T --> 0)
	{
		int n; std::cin >> n;
		FAIL = false;
		children.assign(n, {});
		parent.assign(n, {});
		cost_here.assign(n, {});
		lcons.assign(n, {});
		rcons.assign(n, {});
		ansv.assign(n, {});
		bought.assign(n, {});
		for(int i = 0; i < n-1; i++)
		{
			int p; scanf("%d", &p); p--;
			parent[i+1] = p;
			children[p].push_back(i+1);
		}
		for(int i = 0; i < n; i++) scanf("%d", &cost_here[i]);
		for(int i = 0; i < n; i++) scanf("%d%d", &lcons[i], &rcons[i]);
		dfs(0);
		if(!FAIL)
		{
			printf("%lld\n", ansv[0]);
			for(int x : bought) printf("%d ", x);
			printf("\n");
		}
		else printf("-1\n");
	}
}
