#include <bits/stdc++.h>
using namespace std;

int n, q;
vector<int> a;

vector<vector<int>> g;

int encode(int r, int c) {
	return ((r * (r + 1)) / 2) + c;
}

pair<int, int> decode(int x) {
	int r = 0;
	while ( (r * (r + 1)) / 2 <= x ) {
		r++;
	}
	r--;
	return {r, x - ((r * (r + 1)) / 2)};
}

void edge(int x, int y) {
	g[x].push_back(y);
	g[y].push_back(x);
}

void _add(vector<int> & bits) {
	int r = 0; int c = 0;

	for ( int i = 0; i < n; ++i ) {
		if ( bits[i] == 0 ) {
			edge(encode(r, c), encode(r + 1, c));
			r++;
		} else {
			edge(encode(r, c), encode(r + 1, c + 1));
			r++; c++;
		}
	}
}

vector<bool> used;
vector<int> parent;
vector<int> height;
vector<int> tin;
vector<int> tout;
int timer = 0;

vector<vector<int>> table;

void dfs(int v, int p = -1) {
	if ( used[v] ) return;

	used[v] = true;
	tin[v] = timer++;
	if ( p != -1 ) {
		parent[v] = p;
		height[v] = height[p] + 1;
	} else {
		parent[v] = v;
		height[v] = 1;
	}

	for ( int to : g[v] ) {
		if ( to != p ) dfs(to, v);
	}

	tout[v] = timer++;
}

bool check_child(int u, int v) {
	return (tin[u] <= tin[v]) && (tout[v] <= tout[u]);
}

int lca(int u, int v) {
	if ( height[u] > height[v] ) swap(u, v);
	if ( check_child(u, v) ) return u;

	for ( int i = 19; i >= 0; --i ) {
		if ( !check_child(table[i][u], table[i][v]) ) {
			u = table[i][u];
			v = table[i][v];
		}
	}

	return parent[u];
}

int main() {
	cin >> n;
	a = vector<int>(n);
	for ( int i = 0; i < n; ++i ) cin >> a[i];

	g = vector<vector<int>> ( ((n + 1) * (n + 2)) / 2, vector<int>(0));

	vector<int> bits(n, 1);
	_add(bits);
	for ( int i = 0; i < n; ++i ) {
		bits[a[i] - 1] = 0;
		_add(bits);
	}

	int q;
	cin >> q;

	used = vector<bool>(n, false);
	tin = vector<int>(n, -1);
	tout = vector<int>(n, -1);
	height = vector<int>(n, -1);
	parent = vector<int>(n, -1);

	dfs(0);

	table = vector<vector<int>>(20, vector<int>(n, -1));
	for ( int i = 0; i < n; ++i ) table[0][i] = parent[i];

	for ( int i = 1; i < 20; ++i ) {
		for ( int v = 0; v < n; ++v ) table[i][v] = table[i - 1][table[i - 1][v]];
	}

	for ( int i = 0; i < q; ++i ) {
		int r1, c1;
		int r2, c2;
		cin >> r1 >> c1 >> r2 >> c2;

		int res = lca(encode(r1, c2), encode(r2, c2));
		cout << decode(res).first << " " << decode(res).second << endl;
	}
	return 0;
}