#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cassert>
#include <algorithm>
#include <queue>

#define int long long
using namespace std;

using vi = vector<int>;
using vvi = vector<vector<int>>;
using vb = vector<bool>;
using pi = pair<int, int>;
using db = double;

#define mp make_pair
#define rep(n) for (int i = 0; i < n; i++)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

const int INF = 1e18 + 2;
const int N = 5e3 + 1;
int c[N], l[N], r[N], p[N], deg[N], ans[N], a[N];
vi graph[N];
vi pairs[N];

bool comp(int v1, int v2) {
	return c[v1] < c[v2];
}

void dfs(int v, int who) {
	pairs[who].push_back(v);
	for (auto& to : graph[v]) dfs(to, who);
}

void solve() {
	int res = 0;
	int n; cin >> n;
	queue<int> q;
	rep(n - 1) {
		cin >> p[i + 2];
		graph[p[i + 2]].push_back(i + 2);
		deg[p[i + 2]]++;
	}
	rep(n) cin >> c[i + 1];
	rep(n) cin >> l[i + 1] >> r[i + 1];
	for (int i = 1; i <= n; i++) {
		if (deg[i] == 0)
			q.push(i);
	}
	while (!q.empty()) {
		int v = q.front();
		q.pop();
		if (a[v] > r[v]) {
			cout << "-1\n";
			return;
		}
		dfs(v, v);
		sort(all(pairs[v]), comp);
		for (auto& vv : pairs[v]) {
			if (a[v] >= l[v]) break;
			int min_dist = INF;
			for (int t = vv;; t = p[t]) {
				min_dist = min(min_dist, r[t] - a[t]);
				if (t == 1) break;
			}
			int take = min(min_dist, l[v] - a[v]);
			ans[vv] += take;
			res += c[vv] * take;
			for (int t = vv;; t = p[t]) {
				a[t] += take;
				if (t == 1) break;
			}
		}
		if (a[v] < l[v]) {
			cout << "-1\n";
			return;
		}
		deg[p[v]]--;
		if (deg[p[v]] == 0) q.push(p[v]);
	}
	cout << res << "\n";
	for (int i = 1; i <= n; i++) cout << ans[i] << " ";
	cout << "\n";
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int t; cin >> t;
	while (t--) solve();
}