#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using vi = vector<int>;
using ii = pair<int, int>;

const ll INF = 1e18;

int n, t = 0;
map<ii, vector<ii>> children;
vi changeTime;
vi log2s;

int pow2(int i) {
    static vi pows{1};
    while ((int)pows.size() <= i)
        pows.push_back(pows.back() * 2);
    return pows[i];
}

void initlog2(int n) {
    log2s = vi(n + 1, 0);
    int k = 1;
    int f = 2, l = 4;
    while (f <= n) {
        if (f == l) {
            k++;
            l *= 2;
        }
        log2s[f] = k;
        f++;
    }
}

void initTree(int r, int c) {
    if (r == n)
        return;
    ii self = {r, c};
    if (t <= changeTime[r]) {
        children[self].push_back({r + 1, c + 1});
        initTree(r + 1, c + 1);
    }
    if (t >= changeTime[r]) {
        if (t == changeTime[r]) t++;
        children[self].push_back({r + 1, c});
        initTree(r + 1, c);
    }
}

vector<vector<ii>> table;
map<ii, int> poss;

void dfs(vector<ii> &order, ii pos) {
    for (ii child : children[pos]) {
        dfs(order, child);
        poss[pos] = order.size();
        order.push_back(pos);
    }
    if (children[pos].size() == 0) {
        poss[pos] = order.size();
        order.push_back(pos);
    }
}

void initTable() {
    table.push_back(vector<ii>());
    dfs(table[0], {0, 0});
    int n = table[0].size();
    initlog2(n);
    int h = log2s[n];
    int step = 1;
    table.resize(h + 1);
    for (int j = 1; j <= h; j++) {
        table[j].resize(n - step);
        for (int i = 0; i < n - step; i++)
            table[j][i] = min(table[j - 1][i], table[j - 1][i + step]);
        step *= 2;
    }
}

ii calcMin(ii a, ii b) {
    int i = poss[a], j = poss[b];
    if (i > j)
        swap(i, j);
    int l = log2s[j - i + 1];
    return min(table[l][i], table[l][j - pow2(l) + 1]);
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n;
    changeTime = vi(n);
    for (int i = 0; i < n; i++) {
        int l;
        cin >> l;
        changeTime[l - 1] = i;
    }
    initTree(0, 0);
    initTable();
    int q;
    cin >> q;
    while (q--) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        ii ans = calcMin({r1, c1}, {r2, c2});
        printf("%d %d\n", ans.first, ans.second);
    }
}