#define _GLIBCXX_DEBUG

#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
#include <set>
#include <cassert>

using namespace std;

#define int int32_t
#define uint uint32_t

#define ll int64_t
#define ull uint64_t

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

#define en '\n'
#define mt

void io() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

vector<pair<ll, ll>> lr;
vector<ll> c;
vector<int> wh;
vector<set<pair<pair<ll, ll>, int>>> st; // {{cost, cnt}, i}, wh
vector<ll> cntSt; // wh
vector<ll> lCost;
vector<ll> lft;
vector<vector<int>> g;
vector<ll> cnt;

bool can;

void dfs(int v) {
    for (auto &u : g[v]) {
        dfs(u);
    }

    if (g[v].empty()) {
        lft[v] = lr[v].first;
        lCost[v] = lft[v] * c[v];
        // zero?
        wh[v] = st.size();
        st.emplace_back();
        if (lr[v].second - lr[v].first > 0) {
            st.back().insert({{c[v], lr[v].second - lr[v].first}, v});
        }
        cnt[v] = lft[v];
        cntSt.push_back(lr[v].second - lr[v].first);
    } else {
        pair<ll, ll> mx = {-1, -1};
        for (auto &u : g[v]) {
            mx = max(mx, {ll(st[wh[u]].size()), ll(u)}); // g[u].size()?
        }
        wh[v] = wh[mx.second];
        lCost[v] = lCost[mx.second];
        lft[v] = lft[mx.second];
        cnt[v] = 0;
        for (auto &u : g[v]) {
            if (u == mx.second) continue;
            lCost[v] += lCost[u];
            lft[v] += lft[u];
            cntSt[wh[v]] += cntSt[wh[u]];
            for (auto &elem : st[wh[u]]) st[wh[v]].insert(elem);
        }
        if (lft[v] > lr[v].second) {
            can = false;
            return; // ?
        }
        while (lft[v] < lr[v].first) {
            if (st[wh[v]].empty() || (st[wh[v]].begin()->first.first > c[v])) {
                cnt[v] += lr[v].first - lft[v];
                lCost[v] += (lr[v].first - lft[v]) * c[v];
                lft[v] = lr[v].first;
            } else {
                auto [cost_cnt, u] = *st[wh[v]].begin();
                st[wh[v]].erase(st[wh[v]].begin());
                auto [costU, cntU] = cost_cnt;
                if (cntU == 0) continue;
                ll cn = min(lr[v].first - lft[v], cntU);
                cnt[u] += cn;
                lCost[v] += cn * costU;
                lft[v] += cn;
                cntU -= cn;
                cntSt[wh[v]] -= cn;
                if (cntU > 0) {
                    st[wh[v]].insert({{costU, cntU}, u});
                }
                // ?
            }
        }
        cntSt[wh[v]] += lr[v].second - lft[v];
        if (lr[v].second - lft[v] > 0) st[wh[v]].insert({{c[v], lr[v].second - lft[v]}, v});
        while (cntSt[wh[v]] > lr[v].second - lft[v]) {
            assert(!st[wh[v]].empty());
            auto [cost_cnt, u] = *(--st[wh[v]].end());
            st[wh[v]].erase(--st[wh[v]].end());
            auto [costU, cntU] = cost_cnt;
            ll cn = min(cntU, (cntSt[wh[v]] - (lr[v].second - lft[v])));
            cntU -= cn;
            cntSt[wh[v]] -= cn;
            if (cntU > 0) {
                st[wh[v]].insert({{costU, cntU}, u});
            }
        }
    }
}

void solve() {
    int n;
    cin >> n;
    lr.clear();
    lr.resize(n);

    c.clear();
    c.resize(n);

    wh.clear();
    wh.resize(n);

    st.clear();

    lCost.clear();
    lCost.resize(n);

    lft.clear();
    lft.resize(n);

    g.clear();
    g.resize(n);

    cnt.clear();
    cnt.resize(n);

    cntSt.clear();
    cntSt.resize(n);

    can = true;
    for (int i = 1; i < n; ++i) {
        int pr;
        cin >> pr;
        --pr;
        g[pr].push_back(i);
    }

    for (auto &elem : c) cin >> elem;
    for (auto &[l, r] : lr) cin >> l >> r;

    dfs(0);
    if (can) {
        cout << lCost[0] << en;
        for (auto &elem : cnt) cout << elem << ' ';
        cout << en;
    } else {
        cout << -1 << en;
    }
}

int32_t main() {
    io();
#ifdef mt
    int ttt;
    cin >> ttt;
    while (ttt-- > 0) solve();
#else
    solve();
#endif
    return 0;
}