#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>
using namespace std;

typedef deque<pair<long long, pair<long long, long long>>> dpint;

struct res {
	long long cost;
	long long ls;
	long long vk;
	dpint add; // cost, num, id

	res() {}
};

dpint merge(dpint a, dpint b) {
	pair<long long, pair<long long, long long>> emp = { -1, {-1,-1} };
	dpint c;
	while (!a.empty() && !b.empty()) {
		if (a.back() > b.back()) {
			c.push_back(a.back());
			a.pop_back();
		}
		else {
			c.push_back(b.back());
			b.pop_back();
		}
	}
	while (!a.empty()) {
		c.push_back(a.back());
		a.pop_back();
	}
	while (!b.empty()) {
		c.push_back(b.back());
		b.pop_back();
	}
	if (!c.empty())
		reverse(c.begin(), c.end());
	return c;
}

bool err = 0;

res dfs(vector<vector<long long>>& g, vector<long long>& l, vector<long long>& r, vector<long long>& c, vector <long long>& a, long long x) {
	long long ls = 0;
	dpint add;
	long long vk = 0;
	long long cost = 0;
	for (int v : g[x]) {
		res cr = dfs(g, l, r, c, a, v);
		if (err) {
			return res();
		}
		ls += cr.ls;
		vk += cr.vk;
		cost += cr.cost;
		add = merge(add, cr.add);
	}
	long long L = l[x];

	if (ls > r[x]) {
		err = 1;
		return res();
	}

	dpint cv;
	long long num1 = r[x] - ls;
	if (num1 > 0) {
		cv.push_back({ c[x], {num1, x} });
		add = merge(add, cv);
		vk += num1;
	}

	if (ls < L) {

		while (ls < L && !add.empty()) {
			auto pp = add.front();
			long long cc = pp.first;
			long long id = pp.second.second;
			long long num = pp.second.first;
			if (ls + num > L) {
				num = L - ls;
				add.front().second.first -= num;
			}
			else
				add.pop_front();
			ls += num;
			a[id] += num;
			vk -= num;
			cost += num * cc;
		}
	}


	long long d = r[x] - ls;
	while (vk > d) {
		auto pp = add.back();
		long long num = pp.second.first;
		if (vk - num < d) {
			num = vk - d;
			add.back().second.first -= num;
		}
		else
			add.pop_back();
		vk -= num;
	}

	res cr;
	cr.add = add;
	cr.cost = cost;
	cr.ls = ls;
	cr.vk = vk;
	return cr;
}

int main() {

	long long t;
	cin >> t;
	while (t--) {
		long long n;
		cin >> n;
		vector<vector<long long>> g(n);
		vector <long long> p(n);
		for (long long i = 1; i < n; i++) {
			int pv;
			cin >> pv;
			pv--;
			p[i] = pv;
			g[pv].push_back(i);
		}

		vector <long long> l(n), r(n), c(n);
		for (long long i = 0; i < n; i++)
			cin >> c[i];
		for (long long i = 0; i < n; i++)
			cin >> l[i] >> r[i];

		vector <long long> a(n);
		res cr = dfs(g, l, r, c, a, 0);
		if (err) {
			cout << -1 << endl;
		}
		else {
			cout << cr.cost << endl;
			for (long long i : a)
				cout << i << " ";
			cout << endl;
		}
		err = 0;
	}
}
