#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>
using namespace std;

void dfs1(vector <vector<bool>>& pL, vector <bool>& b, int n, int r, int c) {
	if (r == n)
		return;
	if (!b[r]) {
		pL[r + 1][c + 1] = 1;
		dfs1(pL, b, n, r + 1, c + 1);
	}
	else {
		pL[r + 1][c] = 0;
		dfs1(pL, b, n, r + 1, c);
	}
}

vector <int> dfs2(vector <vector<bool>>& pL, int n, int r, int c) {
	if (r == 0)
		return {0};
	vector <int> res = dfs2(pL, n, r - 1, pL[r][c] ? c - 1 : c);
	res.push_back(c);
	return res;
}

int main() {
	int n;
	cin >> n;
	vector <int> a(n);
	for (int& i : a)
		cin >> i;

	vector<bool> b(n);
	vector <vector<bool>> pL(n+1, vector<bool>(n+1));
	dfs1(pL, b, n, 0, 0);
	for (int i = 0; i < n; i++) {
		b[a[i]-1] = 1;
		dfs1(pL, b, n, 0, 0);
	}

	int q;
	cin >> q;
	while (q--) {
		int r1, c1, r2, c2;
		cin >> r1 >> c1 >> r2 >> c2;
		vector <int> w1 = dfs2(pL, n, r1, c1);
		vector <int> w2 = dfs2(pL, n, r2, c2);
		int x = 0;
		for (int i = 1; i <= n; i++) {
			if (i >= w1.size() || i >= w2.size() || w1[i] != w2[i])
				break;
			x = i;
		}
		cout << x << " " << w1[x] << endl;
	}
}
