#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;

//#define int long long

const int SIZE = 3010;
const int SIZE2 = 10000000;
const int INF = 1e9 + 9;

class Node
{
public:
    int mn;
    int add;

    Node * l, * r;
};

void Push(Node * v)
{
    if (v == nullptr || v->add == 0)
    {
        return;
    }
    if (v->l != nullptr) {
        v->l->mn += v->add;
        v->l->add += v->add;
    }
    if (v->r != nullptr) {
        v->r->mn += v->add;
        v->r->add += v->add;
    }
    v->add = 0;
}

Node nodes[SIZE2];
int timer = 0;

void Build(Node *& root, int l, int r, const vector <int> & v)
{
    root = nodes + timer++;
    if (r - l == 1)
    {
        root->mn = v[l];
        return;
    }
    int m = (l + r) / 2;
    Build(root->l, l, m, v);
    Build(root->r, m, r, v);
    root->mn = min(root->l->mn, root->r->mn);
}

int Ask(Node * root, int l, int r, int ql, int qr)
{
    Push(root);
    if (ql <= l && r <= qr)
    {
        return root->mn;
    }
    if (ql >= r || l >= qr)
    {
        return INF;
    }
    int m = (l + r) / 2;
    return min(Ask(root->l, l, m, ql, qr), Ask(root->r, m, r, ql, qr));
}

void Add(Node * root, int l, int r, int ql, int qr, int val)
{
    Push(root);
    if (ql <= l && r <= qr)
    {
        root->mn += val;
        root->add += val;
        Push(root);
        return;
    }
    if (l >= qr || r <= ql)
    {
        return;
    }

    int m = (l + r) / 2;
    Add(root->l, l, m, ql, qr, val);
    Add(root->r, m, r, ql, qr, val);
    root->mn = min(root->l->mn, root->r->mn);
}

int Search(Node * root, int l, int r, int val)
{
    Push(root);
    if (r - l == 1)
    {
        return l;
    }
    int m = (l + r) / 2;
    if (root->r->mn > val)
    {
        return Search(root->l, l, m, val);
    }
    else
    {
        return Search(root->r, m, r, val);
    }
}

signed main()
{
//    freopen("C:\\Users\\roi\\CLionProjects\\zad1\\input.txt", "r", stdin);

    int n;
    cin >> n;
    vector <int> a(n);
    vector <int> anti(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> a[i];
        a[i]--;
        anti[a[i]] = i;
    }

    int q;
    cin >> q;
    vector <pair <int, int> > qq(q);
    vector <pair <int, int> > qqq(2 * q);
    vector <pair <pair <int, int>, int> > ps(2 * q);
    for (int i = 0; i < q; ++i)
    {
        int x, y;
        cin >> x >> y;
        ps[2 * i] = { { x, x - y }, 2 * i };
        qqq[2 * i] = { x, x - y };
        cin >> x >> y;
        ps[2 * i + 1] = { { x, x - y }, 2 * i + 1 };
        qqq[2 * i + 1]  = { x, x - y };
    }
    sort(ps.begin(), ps.end());

    vector <int> v(n + 1, 0);
    Node * root = nullptr;
    Build(root, 0, n + 1, v);
    int j = 0;
    while (j < ps.size() && ps[j].first.first == 0)
    {
        j++;
    }

    for (int i = 0; i < n; ++i)
    {
        Add(root, 0, n + 1, anti[i] + 1, n + 1, 1);
        /*
        for (int j = 0; j < n + 1; ++j)
        {
            cerr << Ask(root, 0, n + 1, j, j + 1) << ' ';
        }
        cerr << '\n';*/
        while (j < ps.size() && ps[j].first.first == i + 1)
        {
            int ans = Search(root, 0, n + 1, ps[j].first.second);
            //cerr << ps[j].first.first << ' ' << ps[j].first.second << ' ' << ans << ' ' << ps[j].second <<  '\n';
            if (ps[j].second % 2 == 0)
            {
                qq[ps[j].second / 2].first = ans;
            }
            else
            {
                qq[ps[j].second / 2].second = ans;
            }
            j++;
        }
    }

    vector <pair <int, int> > ans(q);

    root = nullptr;
    Build(root, 0, n + 1, a);
    vector <pair <pair <int, int>, int> > qans(q);
    for (int i = 0; i < q; ++i)
    {
        //cerr << qq[i].first << ' ' << qq[i].second << "  ";
        if (qq[i].first == qq[i].second)
        {
            //cerr << '\n';
            pair <int, int> p1 = qqq[2 * i];
            pair <int, int> p2 = qqq[2 * i + 1];
            if (p1.first < p2.first)
            {
                ans[i] = p1;
            }
            else
            {
                ans[i] = p2;
            }
            qans[i] = { { INF, INF }, i };
            continue;
        }
        qans[i] = { { Ask(root, 0, n + 1, min(qq[i].first, qq[i].second), max(qq[i].first, qq[i].second)), qq[i].first }, i };
        //cerr << qans[i].first.first << ' ' << qans[i].first.second << ' ' << qans[i].second << '\n';
    }
    //cerr << '\n';

    sort(qans.begin(), qans.end());


    root = nullptr;
    Build(root, 0, n + 1, v);
    j = 0;
    while (j < qans.size() && qans[j].first.first == 0)
    {
        ans[qans[j].second] = { 0, 0 };
        //cerr << qans[j].second << '\n';
        j++;
    }
    for (int i = 0; i < n; ++i)
    {
        Add(root, 0, n + 1, anti[i] + 1, n + 1, 1);
        /*
        for (int j = 0; j < n + 1; ++j)
        {
            cerr << Ask(root, 0, n + 1, j, j + 1) << ' ';
        }
        cerr << '\n';*/
        while (j < qans.size() && qans[j].first.first == i + 1)
        {
            int x = Ask(root, 0, n + 1, qans[j].first.second, qans[j].first.second + 1);
            //cerr << qans[j].first.first << ' ' << qans[j].first.second << ' ' << x << '\n';
            ans[qans[j].second] = { qans[j].first.first, x };
            j++;
        }
    }

    for (int i = 0; i < q; ++i)
    {
        if (ans[i].first > qqq[2 * i].first)
        {
            ans[i] = qqq[2 * i];
        }
        if (ans[i].first > qqq[2 * i + 1].first)
        {
            ans[i] = qqq[2 * i + 1];
        }
        cout << ans[i].first << ' ' << ans[i].first - ans[i].second << '\n';
    }

    return 0;
}
