#include <bits/stdc++.h>

using namespace std;

const int MAXN = 5e3;
const int MAXR = 5e3;

vector<int> graph[MAXN];
int l[MAXN];
int r[MAXN];
long long c[MAXN];
long long dp[MAXN][MAXR + 10];
long long where[MAXN][MAXR + 10];
long long ans_next[MAXN];
long long ans[MAXN];
long long slch[MAXN];
long long first_v[MAXN];

bool dfs(int v) {
  for (auto u : graph[v]) {
    if (!dfs(u)) {
      return false;
    }
  }

  set<pair<long long, int>> nexts;
  int chsz = graph[v].size();
  vector<int> cur_in_ch(chsz);

  long long cur_sz = 0;
  long long cur_w = 0;
  for (int i = 0; i < chsz; i++) {
    int u = graph[v][i];
    if (first_v[u] < r[u] && dp[u][first_v[u] + 1] != LONG_LONG_MAX) {
      nexts.emplace(dp[u][first_v[u] + 1] - dp[u][first_v[u]], i);
      cur_in_ch[i] = first_v[u] + 1;
    }
    cur_w += dp[u][first_v[u]];
    cur_sz += first_v[u];
    slch[v] += first_v[u];
  }
  first_v[v] = max<long long>(l[v], cur_sz);

  nexts.emplace(c[v], -1);

  if (cur_sz > r[v]) {
    return false;
  }

  dp[v][cur_sz] = cur_w;
  while (cur_sz < r[v] && !nexts.empty()) {
    auto[delta_w, ind] = *nexts.begin();
    nexts.erase(nexts.begin());
    cur_w += delta_w;
    cur_sz++;
    dp[v][cur_sz] = cur_w;
    where[v][cur_sz] = ind;
    if (ind == -1) {
      nexts.emplace(c[v], -1);
    } else {
      int u = graph[v][ind];
      if (cur_in_ch[ind] < r[u] && dp[u][cur_in_ch[ind] + 1] != LONG_LONG_MAX) {
        nexts.emplace(dp[u][cur_in_ch[ind] + 1] - dp[u][cur_in_ch[ind]], ind);
        cur_in_ch[ind]++;
      }
    }
  }

  return true;
}

void dfs_res(int v) {
  long long cur_here = ans_next[v];
  while (cur_here > slch[v]) {
    int cur_ind = where[v][cur_here];
    if (cur_ind == -1) {
      ans[v]++;
    } else {
      ans_next[graph[v][cur_ind]]++;
    }
    cur_here--;
  }
  for (auto u : graph[v]) {
    ans_next[u] += first_v[u];
    dfs_res(u);
  }
}

void solve() {
  int n;
  cin >> n;
  for (int i = 0; i < n; i++) {
    graph[i].clear();
    ans_next[i] = 0;
    ans[i] = 0;
    slch[i] = 0;
  }
  for (int i = 1; i < n; i++) {
    int p;
    cin >> p;
    p--;
    graph[p].push_back(i);
  }
  for (int i = 0; i < n; i++) {
    cin >> c[i];
  }
  for (int i = 0; i < n; i++) {
    cin >> l[i] >> r[i];
  }

  for (int i = 0; i < n; i++) {
    for (int j = 0; j <= r[i]; j++) {
      dp[i][j] = LONG_LONG_MAX;
      where[i][j] = 0;
    }
  }

  if (!dfs(0)) {
    cout << -1 << '\n';
    return;
  }

  for (int i = l[0]; i <= r[0]; i++) {
    if (dp[0][i] != LONG_LONG_MAX) {
      cout << dp[0][i] << '\n';
      ans_next[0] = i;
      dfs_res(0);
      for (int j = 0; j < n; j++) {
        cout << ans[j] << ' ';
      }
      cout << '\n';
      return;
    }
  }
  cout << -1 << '\n';
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  int t;
  cin >> t;
  while (t--)
    solve();
  return 0;
}