#include <bits/stdc++.h>

using namespace std;

const int MAXN = 3e3;
const int MAXV = 4e6;
const int LOG = 25;
int n;

int dp[MAXV][LOG];

int a[MAXN];
vector<int> graph[MAXN];
int used[MAXN];

void dfs_build(int v, int cur) {
  int r = v / (n + 1);
  int c = v % (n + 1);
  if (cur < n) {
    int next_r = r + 1;
    int next_c = c;
    if (!a[cur]) {
      next_c = c + 1;
    }
    int u = next_r * (n + 1) + next_c;
    if (!used[u]) {
      graph[v].push_back(u);
      used[u] = 1;
    }
    dfs_build(u, cur + 1);
  }
}

int tin[MAXV];
int tout[MAXV];

int timer = 0;
void dfs(int v, int p) {
  tin[v] = timer++;
  dp[v][0] = p;
  for (int i = 1; i < LOG; i++) {
    dp[v][i] = dp[dp[v][i - 1]][i - 1];
  }
  for (auto u : graph[v]) {
    dfs(u, v);
  }
  tout[v] = timer++;
}

bool is_ancestor(int v, int u) {
  return (tin[v] <= tin[u]) && (tout[v] >= tout[u]);
}

int lca(int v, int u) {
  if (is_ancestor(v, u)) {
    return v;
  }
  if (is_ancestor(u, v)) {
    return u;
  }
  for (int i = LOG - 1; i >= 0; i--) {
    if (!is_ancestor(dp[v][i], u))
      v = dp[v][i];
  }
  return dp[v][0];
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cin >> n;
  dfs_build(0, 0);
  for (int i = 0; i < n; i++) {
    int ind;
    cin >> ind;
    ind--;
    a[ind]++;
    dfs_build(0, 0);
  }
  dfs(0, 0);
  int q;
  cin >> q;
  while (q--) {
    int v_r, v_c, u_r, u_c;
    cin >> v_r >> v_c >> u_r >> u_c;
    int v = v_r * (n + 1) + v_c;
    int u = u_r * (n + 1) + u_c;
    int l = lca(v, u);
    cout << l / (n + 1) << ' ' << l % (n + 1) << '\n';
  }
  return 0;
}