#include <bits/stdc++.h>

#define ssize(a) (int)(a).size()
#define all(a) (a).begin(), (a).end()

using namespace std;

using ll = long long;


vector<vector<int>> g;
vector<int> depth;
vector<int> par;
int n;

int cell(int r, int c) {
    return r * (n + 1) + c;
}

void dfs(int v, int p, int d) {
    par[v] = p;
    depth[v] = d;
    for (int u : g[v]) {
        dfs(u, v, d + 1);
    }
}

int depth_min(int v, int u) {
    return (depth[v] < depth[u] ? v : u);
}

int lca(int v, int u) {
    if (depth[v] < depth[u])
        swap(v, u);
    while (depth[v] > depth[u])
        v = par[v];
    while (v != u) {
        v = par[v];
        u = par[u];
    }
    return v;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        --a[i];
    }

    g.resize((n + 1) * (n + 1));
    depth.resize(ssize(g));
    par.resize(ssize(g));

    vector<int> type(n, 0);
    vector<pair<int, int>> path(n + 1);
    for (int i = 0, r = 0, c = 0; i < n + 1; ++i) {
        path[i] = {r, c};
        if (i != n) {
            g[cell(r, c)].push_back(cell(r + 1, c + 1));
        }
        ++r;
        ++c;
    }

    for (int i = 0; i < n; ++i) {
        type[a[i]] = 1;
        auto[r, c] = path[a[i]];
        for (int j = a[i]; j < n + 1; ++j) {
            path[j] = {r, c};
            int nr = r + 1, nc;
            if (j != n) {
                if (type[j] == 0) {
                    nc = c + 1;
                } else {
                    nc = c;
                }
                g[cell(r, c)].push_back(cell(nr, nc));
                r = nr;
                c = nc;
            }
        }
    }

    dfs(0, 0, 0);

    int q;
    cin >> q;
    for (int w = 0; w < q; ++w) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        int l = lca(cell(r1, c1), cell(r2, c2));
        int r3 = l / (n + 1);
        int c3 = l % (n + 1);
        cout << r3 << " " << c3 << "\n";
    }

//    for (int v = 0; v < ssize(g); ++v) {
//        int vr = v / (n + 1);
//        int vc = v % (n + 1);
//        for (int u : g[v]) {
//            int ur = u / (n + 1);
//            int uc = u % (n + 1);
//            cout << vr << " " << vc << " " << ur << " " << uc << "\n";
//        }
//    }




    return 0;
}
