#include <bits/stdc++.h>

using namespace std;

#define int long long


vector<int> directions;

void solve() {
	int n, w, h;
	cin >> n >> w >> h;

	vector<pair<int, int>> pts(n);
	for(auto& [x, y]: pts) {
		cin >> x >> y;
	}

	sort(pts.begin(), pts.end(), [](auto p1, auto p2) {
		return p1.second < p2.second;
	});

	vector<int> xx;
	for(auto [x, y]: pts) {
		xx.push_back(x);
	}
	xx.push_back(0);
	xx.push_back(w);
	sort(xx.begin(), xx.end());
	xx.erase(unique(xx.begin(), xx.end()), xx.end());

	vector<int> dp_l_x(xx.size());
	vector<int> dp_r_x(xx.size());

	int dp_l_x_const = 0;
	int dp_r_x_const = 0;

	for(int i = n - 1; i >= 0; i--) {
		auto [x, y] = pts[i];
		int x_id = lower_bound(xx.begin(), xx.end(), x) - xx.begin();

		int next_x_id = i == 0 ? 0 : lower_bound(xx.begin(), xx.end(), pts[i - 1].first) - xx.begin();

		for(int r = next_x_id + 1; r < xx.size(); r++) {
			if(x < xx[next_x_id] || x > xx[r]) {
				dp_l_x[r] = (xx[r] - xx[next_x_id]) * (h - y) - (x - xx[next_x_id]) * (h - y) - dp_l_x_const;
			} else {
				dp_l_x[r] = max(
					(xx[r] - x) * (h - y) - (x - xx[next_x_id]) * (h - y) + dp_r_x[next_x_id] + dp_r_x_const - dp_l_x_const,
					dp_l_x[r]
				);
			}
			// dp_l_x[r] += (x - xx[next_x_id]) * (h - y);
		}

		for(int l = 0; l < next_x_id; l++) {
			if(x < xx[l] || x > xx[next_x_id]) {
				dp_r_x[l] = (xx[next_x_id] - xx[l]) * (h - y) - (xx[next_x_id] - x) * (h - y) - dp_r_x_const;
			} else {
				dp_r_x[l] = max(
					dp_r_x[l],
					(x - xx[l]) * (h - y) + dp_l_x[next_x_id] + dp_l_x_const - (xx[next_x_id] - x) * (h - y) - dp_r_x_const
				);
			}
			// dp_r_x[l] += (xx[next_x_id] - x) * (h - y);
		}

		dp_l_x_const += (x - xx[next_x_id]) * (h - y);
		dp_r_x_const += (xx[next_x_id] - x) * (h - y);
	}

	cout << dp_l_x[xx.size() - 1] + dp_l_x_const << "\n";
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	{
		int k;
		cin >> k;
		directions.resize(k);
		for(int& d: directions) {
			cin >> d;
		}
	}

	int t;
	cin >> t;
	while(t --> 0) {
		solve();
	}

	return 0;
}