#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

#define len(a) int((a).size())
#define all(a) begin(a), end(a)

template<typename Fun>
struct y_combinator {
	const Fun fun;

	y_combinator(const Fun&& fun) : fun(forward<const Fun>(fun)) {}

	template<typename... Args>
	decltype(auto) operator()(Args&&... args) const {
		return fun(ref(*this), forward<Args>(args)...);
	}
};

void solve() {
	int n, w, h;
	cin >> n >> w >> h;
	vector<pair<int, int>> a(n);
	for (auto &[x, y] : a) {
		cin >> x >> y;
		x = w - x;
		y = h - y;
	}

	sort(all(a));
	// cout << "a: "; for (auto [x, y] : a) cout << "(" << x << ", " << y << ") "; cout << endl;
	vector<pair<int, int>> st;
	for (auto &[x, y] : a) {
		while (!st.empty() && st.back().second <= y) {
			st.pop_back();
		}
		st.emplace_back(x, y);
	}

	ll ans = 0;
	for (int i = 0; i < len(st); i++) {
		ans += 1ll * (st[i].first - (i == 0 ? 0 : st[i - 1].first)) * st[i].second;
	}
	cout << ans << '\n';
}

int main() {
	ios::sync_with_stdio(false), cin.tie(nullptr);

	int k;
	cin >> k;
	vector<int> valid(k);
	for (auto &x : valid) {
		cin >> x;
	}
	assert(k == 1 && valid[0] == 1);

	int tests;
	cin >> tests;
	while (tests--) {
		solve();
	}
}
