#include <bits/stdc++.h>
using namespace std;
 
using ll = long long;
using ld = long double;
 
#define len(a) int((a).size())
#define all(a) begin(a), end(a)
 
template<typename Fun>
struct y_combinator {
    const Fun fun;
 
    y_combinator(const Fun&& fun) : fun(forward<const Fun>(fun)) {}
 
    template<typename... Args>
    decltype(auto) operator()(Args&&... args) const {
        return fun(ref(*this), forward<Args>(args)...);
    }
};

#define int ll 

void solve() {
    int n, w, h;
    cin >> n >> w >> h;
    vector<pair<int, int>> a(n);
    for (auto &[x, y] : a) {
        cin >> x >> y;
        y = h - y;
    }
    sort(all(a));
 
    struct data {
        int x, y;
        ll res;
    };
    vector<data> st;
 
    auto query = [&](int i) {
        return 1ll * (st[i].x - (i == 0 ? 0 : st[i - 1].x)) * st[i].y;
    };
 
    auto add_to_st = [&](int x, int y) {
        while (!st.empty() && st.back().y <= y) {
            st.pop_back();
        }
        st.push_back({x, y, st.empty() ? 0 : st.back().res});
        st.back().res += query(len(st) - 1);
    };
 
    ll ans = 0;
    {
        vector<ll> pref(n + 1), suf(n + 1);
        st.clear();
        for (int i = 0; i < n; i++) {
            add_to_st(a[i].first, a[i].second);
            pref[i + 1] = st.back().res;
        }

        st.clear();
        for (int i = n - 1; i >= 0; i--) {
            add_to_st(w - a[i].first, a[i].second);
            suf[i] = st.back().res;
        }

        for (int i = 0; i <= n; i++) {
            ans = max(ans, pref[i] + suf[i]);
        }
    }

    for (int rot : {0, 1}) {
        st.clear();
        vector<int> max_y(n);
        constexpr int INF = int(1e9);
        int cur_max_y = -INF;

        vector<ll> pref(n);
        for (int i = 0; i < n; i++) {
            auto [x, y] = a[i];
            while (!st.empty() && st.back().y <= y) {
                cur_max_y = max(cur_max_y, st.back().y);
                st.pop_back();
            }
            add_to_st(x, y);
            max_y[i] = cur_max_y;
            pref[i] = st.back().res;
        }

        // cout << "rot = " << rot << endl;
        // cout << "pref: "; for (auto x : pref) cout << x << ' '; cout << endl;
        // cout << "max_y: "; for (auto x : max_y) cout << x << ' '; cout << endl;
        // cout << "a: "; for (auto &[x, y] : a) cout << "(" << x << ", " << y << ") "; cout << endl;

        struct line {
            ll k, b;

            ld intersect(const line &ln) const {
                return ld(b - ln.b) / (ln.k - k);
            }

            ll query(ll x) const {
                return k * x + b;
            }
        };

        // struct convex_hull_trick {
        //     vector<line> lines;

        //     void add_line(const line &ln) {
        //         lines.push_back(ln);
        //     }

        //     ll query(ll x) {
        //         ll res = -2e18;
        //         for (auto &ln : lines) {
        //             res = max(res, ln.query(x));
        //         }
        //         return res;
        //     }
        // } cht;

        struct convex_hull_trick {
            vector<line> lines;

            void add_line(const line &ln) {
                while (!lines.empty()) {
                    auto last = lines.back();
                    assert(last.k >= ln.k);
                    if (last.k == ln.k) {
                        if (ln.b < last.b) {
                            return;
                        }
                        lines.pop_back();
                        continue;
                    }

                    if (len(lines) == 1) {
                        break;
                    }
                    auto prelast = lines.end()[-2];
                    ld pos1 = last.intersect(prelast);
                    ld pos2 = ln.intersect(last);
                    if (pos1 > pos2) {
                        lines.pop_back();
                    } else {
                        break;
                    }
                }
                lines.push_back(ln);
            }

            ll query(ll x) {
                ll res = -1e18;
                for (auto &ln : lines) {
                    res = max(res, ln.query(x));
                }
                return res;
            }
        } cht;

        cht.add_line({w, 0});
        st.clear();
        for (int i = n - 1; i >= 0; i--) {
            if (max_y[i] != -INF) {
                int y = max_y[i];
                ans = max(ans, pref[i] - 1ll * a[i].first * y + cht.query(y));
            }
            add_to_st(w - a[i].first, a[i].second);
            cht.add_line({a[i].first, st.back().res});
        }

        for (auto &[x, y] : a) {
            x = w - x;
        }
        sort(all(a));
        // cout << "ans = " << ans << endl;
        // cout << endl;
    }

    cout << ans << '\n';
}
 
signed main() {
    ios::sync_with_stdio(false), cin.tie(nullptr);
 
    int k;
    cin >> k;
    vector<int> valid(k);
    for (auto &x : valid) {
        cin >> x;
    }
 
    int tests;
    cin >> tests;
    while (tests--) {
        solve();
    }
}
