#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

#define len(a) int((a).size())
#define all(a) begin(a), end(a)

template<typename Fun>
struct y_combinator {
	const Fun fun;

	y_combinator(const Fun&& fun) : fun(forward<const Fun>(fun)) {}

	template<typename... Args>
	decltype(auto) operator()(Args&&... args) const {
		return fun(ref(*this), forward<Args>(args)...);
	}
};

#define int ll

void solve() {
	int n, w, h;
	cin >> n >> w >> h;
	vector<pair<int, int>> a(n);
	for (auto &[x, y] : a) {
		cin >> x >> y;
		y = h - y;
	}

	struct data {
		int x, y;
		ll res;
	};
	vector<data> st;

	auto query = [&](int i) {
		return 1ll * (st[i].x - (i == 0 ? 0 : st[i - 1].x)) * st[i].y;
	};

	auto add_to_st = [&](int x, int y) {
		while (!st.empty() && st.back().y <= y) {
			st.pop_back();
		}
		st.push_back({x, y, st.empty() ? 0 : st.back().res});
		st.back().res += query(len(st) - 1);
	};

	ll ans = 0;
	for (int rot : {0, 1}) {
		sort(all(a));

		for (int pos = 0; pos <= n; pos++) {
			vector<ll> pref(n + 1), suf(n + 1);
			st.clear();
			for (int i = 0; i < n; i++) {
				if (i != pos/* && (pos == n || a[i].second >= a[pos].second)*/) {
					add_to_st(a[i].first, a[i].second);
				}
				if (!st.empty()) {
					pref[i + 1] = st.back().res;
				}
			}

			st.clear();
			for (int i = n - 1; i >= 0; i--) {
				if (i != pos && (pos == n || a[i].second >= a[pos].second)) {
					add_to_st(w - a[i].first, a[i].second);
				}
				if (!st.empty()) {
					suf[i] = st.back().res;
				}
			}

			// cout << "solving pos = " << pos << endl;
			// cout << "pref: "; for (auto x : pref) cout << x << ' '; cout << endl;
			// cout << "suf: "; for (auto x : suf) cout << x << ' '; cout << endl;
			// cout << "a: "; for (auto [x, y] : a) cout << "(" << x << ", " << y << ") "; cout << endl;

			for (int i = 0; i <= n; i++) {
				int l = i == 0 ? 0 : a[i - 1].first;
				int r = i == n ? w : a[i].first;
				ans = max(ans, pref[i] + suf[i]);

				if (l > r || pos == n) {
					continue;
				}
				// cout << i << ": " << pref[i] + suf[i] + max<ll>(0, r - max(l, a[pos].first)) * a[pos].second << endl;
				ans = max(ans, pref[i] + suf[i] + max<ll>(0, r - max(l, a[pos].first)) * a[pos].second);
			}
			// cout << endl;
		}

		for (auto &[x, y] : a) {
			x = w - x;
		}
	}
	cout << ans << '\n';
}

signed main() {
	ios::sync_with_stdio(false), cin.tie(nullptr);

	int k;
	cin >> k;
	vector<int> valid(k);
	for (auto &x : valid) {
		cin >> x;
	}

	int tests;
	cin >> tests;
	while (tests--) {
		solve();
	}
}
