#pragma GCC optimize("O3,no-stack-protector")
//#pragma GCC target("sse,sse2,sse3,sse4,abm,mmx,popcnt,avx,avx2,fma,avx512f)
#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <cstring>
#include <string>
#include <iomanip>
#include <bitset>
#include <set>
#include <queue>
#include <map>
#include <unordered_map>
#include <unordered_set>

#define endl '\n'
#define double long double
//#define int long long

typedef long long ll;
typedef double ld;

using namespace std;

const int inf = 1e9 + 7;
const ll inf2 = 1e18 + 6;
const int MAXN = 2e5 + 8;
const int MAXN2 = 1e6 + 8;

struct seg {
	ll l, r;
	seg(ll l = 0, ll r = inf2) : l(l), r(r) {};
	void per(const seg& oth) {
		l = max(l, oth.l);
		r = min(r, oth.r);
	}
	void perl(ll l2) {
		l = max(l, l2);
	}
};

seg per(const seg& a, const seg& b) {
	return { max(a.l, b.l), min(a.r, b.r) };
}

vector<int> G[MAXN];
seg arr[MAXN];
ll cost[MAXN];
seg good[MAXN];
ll now[MAXN];
int heavy[MAXN];
ll ans[MAXN];

ll ansg = 0;

bool fl = 1;

void dfs1(int v) {
	good[v] = arr[v];
	ll sum_l = 0;
	ll sum_r = 0;
	for (int u : G[v]) {
		dfs1(u);
		if (!fl)
			return;
		sum_l += good[u].l;
	}
	good[v].perl(sum_l);
	if (good[v].l > good[v].r) {
		fl = 0;
		return;
	}
}


set<pair<pair<ll, ll>, int>>* q[MAXN];// cost, cnt, v;
ll sumq[MAXN];

void dfs2(int v) {
	now[v] = 0;
	heavy[v] = -1;
	for (int u : G[v]) {
		dfs2(u);
		now[v] += now[u];
		if (heavy[v] == -1 || q[heavy[v]]->size() < q[u]->size()) {
			heavy[v] = u;
		}
	}
	if (heavy[v] == -1) {
		q[v] = new set<pair<pair<ll, ll>, int>>();
		sumq[v] = arr[v].r - now[v];
		q[v]->emplace(make_pair(cost[v], arr[v].r - now[v]), v);
	}
	else {
		q[v] = q[heavy[v]];
		sumq[v] = sumq[heavy[v]];
		for (int u : G[v]) {
			if (u == heavy[v])
				continue;
			sumq[v] += sumq[u];
			for (const auto& el : *q[u]) {
				q[v]->emplace(el);
			}
		}
		if (arr[v].r - now[v] > 0) {
			q[v]->emplace(make_pair(cost[v], arr[v].r - now[v]), v);
			sumq[v] += arr[v].r - now[v];
		}
	}
	ll nv = now[v];
	seg s = good[v];
	if (nv > arr[v].r) {
		abort();
	}
	ll need = arr[v].l - nv;
	
	if (need > 0) {
		while (need > 0 && q[v]->size()) {
			auto tmp = *q[v]->begin();
			q[v]->erase(q[v]->begin());
			int u = tmp.second;
			ll c = tmp.first.first, cnt = tmp.first.second;
			if (cnt >= need) {
				tmp.first.second -= need;
				sumq[v] -= need;
				ans[u] += need;
				ansg += need * c;
				need = 0;
				q[v]->emplace(tmp);
				break;
			}
			else {
				ans[u] += cnt;
				ansg += cnt * c;
				need -= cnt;
				sumq[v] -= cnt;
			}
		}
		now[v] = arr[v].l;
	}
	ll r = arr[v].r;
	ll n2 = sumq[v] - r;
	while (n2 > 0 && q[v]->size()) {
		auto it = q[v]->end();
		--it;
		auto tmp = *it;
		ll cnt =  tmp.first.second;
		q[v]->erase(it);
		if (cnt >= n2) {
			tmp.first.second -= n2;
			sumq[v] -= n2;
			n2 = 0;
			q[v]->emplace(tmp);
		}
		else {
			sumq[v] -= cnt;
			n2 -= cnt;
		}
	}
	sumq[v] = r;
}

ll ans_c[MAXN];

void dfs_check(int v) {
	ans_c[v] = ans[v];
	for (int u : G[v]) {
		dfs_check(u);
		if (!fl)
			return;
		ans_c[v] += ans_c[u];
	}
	if (ans_c[v] > arr[v].r || ans_c[v] < arr[v].l) {
		fl = 0;
		return;
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	int t;
	cin >> t;
	while (t--) {
		int n;
		cin >> n;
		ansg = 0;
		fl = 1;
		for (int i = 1; i <= n; i++) {
			G[i].clear();
			q[i] = nullptr;
			ans[i] = cost[i] = sumq[i] = now[i] = 0;
			ans_c[i] = 0;
			
		}
		for (int i = 2; i <= n; i++) {
			int p;
			cin >> p;
			G[p].emplace_back(i);
		}
		for (int i = 1; i <= n; i++) {
			cin >> cost[i];
		}
		for (int i = 1; i <= n; i++) {
			cin >> arr[i].l >> arr[i].r;
		}
		dfs1(1);
		if (!fl) {
			cout << -1 << endl;
			goto x1;
		}
		dfs2(1);
		dfs_check(1);
		if (!fl) {
			abort();
			cout << -1 << endl;
			goto x1;
		}
		ansg = 0;
		for (int i = 1; i <= n; i++) {
			ansg += cost[i] * ans[i];
		}
		cout << ansg << endl;
		for (int i = 1; i <= n; i++) {
			cout << ans[i] << ' ';
		}
		cout << endl;
	x1:;
	}
} 