#include <bits/stdc++.h>
#define int ll
using namespace std;
using ll = long long;
#if LOCAL
#define dbg(o) ({cout << #o << " = " << (o) << "\n"; (o);})
#else
#define dbg(o) (o)
#endif

template<typename T>
ostream &operator<<(ostream &o, const vector<T> &v) {
    for (const auto &e: v) o << e << " ";
    return o;
}

template<typename T, typename Q>
ostream &operator<<(ostream &o, const pair<T, Q> &v) {
    o << v.first << " " << v.second;
    return o;
}

template<typename T, typename Q>
istream &operator>>(istream &o, pair<T, Q> &v) {
    o >> v.first >> v.second;
    return o;
}

template<typename T>
istream &operator>>(istream &o, vector<T> &v) {
    for (auto &e: v) o >> e;
    return o;
}


using Seg = pair<int, int>;


vector<vector<int>> graph;
vector<int> c, parent;
vector<Seg> limits;

int to2pow(int x) {
    int n = 1;
    while (x > 0) {
        x /= 2;
        n *= 2;
    }
    return n * 2;
}

struct SegmentTree {
    struct Node {
        int min = 0, add = 0;
    };

    vector<Node> f;
    int sz;

    explicit SegmentTree(const vector<int> &p) : f() {
        int n = int(p.size()), m = to2pow(n);
        f.assign(m * 2, {0, 0});
        sz = m;
        for (int i = 0; i < n; ++i) {
            f[i + m] = {p[i], 0};
        }
        for (int i = m - 1; i > 0; --i) {
            f[i].min = min(f[i * 2].min, f[i * 2 + 1].min);
        }
    }

    int get_min(int l, int r, int tl = 0, int tr = -1, int v = 1) {
        if (tr == -1) tr = sz;
        if (r - l < 1) return INT32_MAX;
        if (l == tl && r == tr) return f[v].min + f[v].add;
        int m = (tl + tr) / 2;
        return f[v].add + min(get_min(l, min(r, m), tl, m, v * 2),
                              get_min(max(l, m), r, m, tr, v * 2 + 1));
    }

    void add(int l, int r, int x, int tl = 0, int tr = -1, int v = 1) {
        if (tr == -1) tr = sz;
        if (r - l < 1) return;
        if (l == tl && r == tr) {
            f[v].add += x;
            return;
        }
        int m = (tl + tr) / 2;
        add(l, min(r, m), x, tl, m, v * 2);
        add(max(l, m), r, x, m, tr, v * 2 + 1);
        f[v].min = min(f[v * 2].min + f[v * 2].add, f[v * 2 + 1].min + f[v * 2 + 1].add);
    }

    int get(int i) {
        return get_min(i, i + 1);
    }
};

using Store = set<pair<int, int>>; // price, v
ll total_price = 0;
vector<int> bought;
SegmentTree *available;

vector<int> sz, tin, hld_root;

void dfs0(int v) {
    for (int i = 0; i < graph[v].size(); i++) {
        int u = graph[v][i];
        dfs0(u);
        if (sz[u] > sz[graph[v][0]]) swap(graph[v][0], graph[v][i]);
        sz[v] += sz[u];
    }
}

int timer = 0;

void dfs1(int v, int cur_root) {
    tin[v] = timer++;
    hld_root[v] = cur_root;
    for (int i = 0; i < graph[v].size(); i++) {
        int u = graph[v][i];
        if (i != 0) {
            dfs1(u, u);
        } else {
            dfs1(u, cur_root);
        }
    }
}

int min_from(int v) {
    int limit = INT32_MAX;
    while (v != -1) {
        int u = hld_root[v];
        limit = min(available->get_min(tin[u], tin[v] + 1), limit);
        v = parent[u];
    }

    return limit;
}

void do_buy(int v, int cnt) {
    while (v != -1) {
        int u = hld_root[v];
        available->add(tin[u], tin[v] + 1, -cnt);
        v = parent[u];
    }
}

int get_a(int v) {
    int res = limits[v].second - available->get(tin[v]);
    return res;
}

bool dfs(int v, Store &store) {
    store.insert({c[v], v});
    auto[l, r] = limits[v];

    for (int u: graph[v]) {
        Store new_store;
        if (!dfs(u, new_store)) return false;
        if (store.size() < new_store.size()) {
            Store temp = store;
            store = new_store;
            new_store = temp;
        }
        store.merge(new_store);
    }

    while (!store.empty() && get_a(v) < l) {
        auto it = store.begin();
        auto[price, u] = *it;
        int can_buy = min_from(u);

        if (can_buy == 0) {
            store.erase(it);
            continue;
        }

        int buy = min(can_buy, l - get_a(v));
        can_buy -= buy;
        do_buy(u, buy);
        total_price += price * buy;
        bought[u] += buy;
        if (can_buy == 0) store.erase(it);
    }

    if (get_a(v) < l) return false;

    return true;
}

void solve() {
    int n;
    cin >> n;
    graph.assign(n, {});
    parent.assign(n, -1);
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        p--;
        parent[i] = p;
        graph[p].push_back(i);
    }

    c.assign(n, 0), limits.assign(n, {});
    cin >> c;
    cin >> limits;
    dbg(c);
    dbg(limits);

    sz.assign(n, 1), tin.assign(n, -1), hld_root.assign(n, -1);
    timer = 0;
    dfs0(0);
    dfs1(0, 0);
    dbg(tin);
    dbg(hld_root);

    vector<int> proto_available(n);
    // OLD::a.assign(n, 0);
    // OLD::available.assign(n, 0);
    for (int i = 0; i < n; ++i) {
        // OLD::available[i] = limits[i].second;
        proto_available[tin[i]] = int(limits[i].second);
    }

    available = new SegmentTree(proto_available);

    Store store;
    total_price = 0;
    bought.assign(n, 0);
    auto res = dfs(0, store);

    if (!res) {
        cout << "-1\n";
    } else {
        cout << total_price << "\n";
        cout << bought << "\n";
    }
}

signed main() {
#if LOCAL
    freopen("../input.txt", "r", stdin);
    int q;
    cin >> q;
    while (q--) {
        cout << "###########################\n";
        solve();
    }
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int q;
    cin >> q;
    while (q--) solve();
#endif
    return 0;
}
