#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define all(o) (o).begin(), (o).end()
#if LOCAL
#define dbg(o) ({cout << #o << " = " << (o) << "\n"; (o);})
#else
#define dbg(o) (o)
#endif

template<typename T>
ostream &operator<<(ostream &o, const vector<T> &v) {
    for (const auto &e: v) o << e << " ";
    return o;
}

template<typename T, typename Q>
ostream &operator<<(ostream &o, const pair<T, Q> &v) {
    o << v.first << " " << v.second;
    return o;
}

template<typename T, typename Q>
istream &operator>>(istream &o, pair<T, Q> &v) {
    o >> v.first >> v.second;
    return o;
}

template<typename T>
istream &operator>>(istream &o, vector<T> &v) {
    for (auto &e: v) o >> e;
    return o;
}

const int MN = 1 << 19;

struct MergeSortTree {
    vector<vector<int>> f;
    int mx;

    explicit MergeSortTree(const vector<int> &p) : f(MN * 2, vector<int>()), mx(int(p.size())) {
        for (int i = 0; i < p.size(); ++i) {
            f[i + MN] = {p[i]};
        }
        for (int i = MN - 1; i > 0; --i) {
            f[i].resize(f[i * 2].size() + f[i * 2 + 1].size());
            merge(all(f[i * 2]), all(f[i * 2 + 1]), f[i].begin());
        }
    }

    int order(int ub, int x) {
        int i = 1;
        while (i < MN) {
            int cnt = int(lower_bound(all(f[i * 2]), ub) - f[i * 2].begin());
            if (x >= cnt) {
                x -= cnt;
                i = i * 2 + 1;
            } else {
                i = i * 2;
            }
        }
        return min(mx, i - MN);
    }
};

void solve() {
    int n;
    cin >> n;
    n++;
    vector<int> p(n - 1);
    cin >> p;
    for (int i = 0; i < n - 1; ++i) p[i]--;

    MergeSortTree mst(p);

    int q;
    cin >> q;
    while (q--) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        c1 = r1 - c1, c2 = r2 - c2;
        int i1 = mst.order(r1, c1), i2 = mst.order(r2, c2);
        dbg(r1);
        dbg(c1);
        dbg(r2);
        dbg(c2);
        dbg(i1);
        dbg(i2);

        int lcp = min(r1, r2);
        for (int i = min(i1, i2); i < max(i1, i2); ++i) {
            lcp = min(lcp, p[i]);
        }

        dbg(lcp);
        dbg("    ");

        int cnt = 0;
        for (int i = 0; i < i1; ++i) {
            if (p[i] < lcp) cnt++;
        }

        cout << lcp << " " << lcp - cnt << "\n";
    }
}

signed main() {
#if LOCAL
    freopen("../input.txt", "r", stdin);
    int q;
    cin >> q;
    while (q--) {
        cout << "###########################\n";
        solve();
    }
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    solve();
#endif
    return 0;
}
