#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define all(o) (o).begin(), (o).end()
#if LOCAL
#define dbg(o) ({cout << #o << " = " << (o) << "\n"; (o);})
#else
#define dbg(o) (o)
#endif

template<typename T>
ostream &operator<<(ostream &o, const vector<T> &v) {
    for (const auto &e: v) o << e << " ";
    return o;
}

template<typename T, typename Q>
ostream &operator<<(ostream &o, const pair<T, Q> &v) {
    o << v.first << " " << v.second;
    return o;
}

template<typename T, typename Q>
istream &operator>>(istream &o, pair<T, Q> &v) {
    o >> v.first >> v.second;
    return o;
}

template<typename T>
istream &operator>>(istream &o, vector<T> &v) {
    for (auto &e: v) o >> e;
    return o;
}

void solve2() {
    int n, w, h;
    cin >> n >> w >> h;
    vector<pair<int, int>> points(n);
    cin >> points;
    sort(all(points), [](pair<int, int> l, pair<int, int> r) {
        return l.first > r.first;
    });

    vector<pair<int, int>> important;
    for (int i = 0; i < n; ++i) {
        auto[x, y] = points[i];
        while (!important.empty()) {
            auto[px, py] = important.back();
            if (y <= py) {
                important.pop_back();
            } else {
                break;
            }
        }
        important.push_back(points[i]);
    }
    dbg(important);

    int last = w;
    ll area = 0;
    for (auto[x, y]: important) {
        area += ll(last - x) * (h - y);
        last = x;
    }

    cout << area << "\n";
}

void solve() {
    int k;
    cin >> k;
    vector<int> dirs(k);
    cin >> dirs;

    int t;
    cin >> t;
    while (t--) solve2();
}

signed main() {
#if LOCAL
    freopen("../input.txt", "r", stdin);
    int q;
    cin >> q;
    while (q--) {
        cout << "###########################\n";
        solve();
    }
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    solve();
#endif
    return 0;
}
