#include "bits/stdc++.h"
#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,avx")
using namespace std;
typedef long long ll;
typedef long double ld;
#define int ll
typedef pair<int, int> pii;
#define vec vector
#define all(a) a.begin(), a.end()
#define _ << ' ' <<
#ifndef HOME
#define cerr if(0) cerr
#endif
#ifdef int
const int INF = 2e16;
#else
const int INF = 2e9;
#endif
class SegTree {
    int n;
    vec<int> a;
    vec<vec<int>> t;
    void build(int v, int l, int r) {
        if (l == r - 1) {
            t[v] = {a[l]};
            return;
        }
        int m = (r + l)  / 2;
        build(2 * v + 1, l, m);
        build(2 * v + 2, m, r);
        t[v].resize(t[v * 2 + 1].size() + t[2 * v + 2].size());
        merge(all(t[2 * v + 1]), all(t[2 * v + 2]), t[v].begin());
    }
    int get_l(int v, int l, int r, int L, int R, int x) {
        if (L <= l && r <= R) {
            return lower_bound(all(t[v]), x) - t[v].begin();
        }
        if (R <= l || r <= L) {
            return 0;
        }
        int m = (r + l) / 2;
        int a = get_l(2 * v + 1, l, m, L, R, x);
        int b = get_l(2 * v + 2, m, r, L, R, x);
        return a + b;
    }
    int get_g(int v, int l, int r, int L, int R, int x) {
        if (L <= l && r <= R) {
            return t[v].end() - upper_bound(all(t[v]), x);
        }
        if (R <= l || r <= L) {
            return 0;
        }
        int m = (r + l) / 2;
        int a = get_g(2 * v + 1, l, m, L, R, x);
        int b = get_g(2 * v + 2, m, r, L, R, x);
        return a + b;
    }

public:
    SegTree(vec<int> a):a(a) {
        n = a.size();
        t.resize(4 * n);
        build(0, 0, n);
    }
    int ls(int l, int r, int x) {
        return get_l(0,0, n, l, r, x);
    }
    int gr(int l, int r, int x) {
        return get_g(0,0, n, l, r, x);
    }
};
void solve() {
    int n;
    cin >> n;
    vec<int> p(n);
    vec<int> zp(n);
    for (int i = 0; i < n; ++i) {
        cin >> p[i];
        p[i]--;
        zp[p[i]] = i;
    }
    SegTree sg(p);
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            int x = p[i];
            int y = p[j];
            int tmp = abs(x - y);
            {
                int cnt = j - i + sg.ls(j, n, p[j]);
//                for (int k = j; k < n; ++k) {
//                    if (p[k] < p[j]) cnt++;
//                }
                tmp = max(tmp, cnt);
            }
            {
                int cnt = j - i + sg.gr(0, i, x);
//                for (int k = 0; k < i; ++k) {
//                    if (p[k] > p[i]) cnt++;
//                }
                tmp = max(tmp, cnt);
            }
            ans += tmp;
        }
    }

    cout <<ans;
}

signed main() {
#ifdef HOME
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int tt = 1;
//    cin >> tt;
    for (int i = 0; i < tt; ++i) {
        ld s = clock();
        solve();
        cout << '\n';
        ld e = clock();
        cerr << "Worktime:" _ (e - s) / CLOCKS_PER_SEC << '\n';
    }
}