#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <tuple>

using namespace std;

#define fastInp cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);

typedef long long ll;
typedef long double ld;

const ll SZ = 4000 + 100, LG = 20;
vector<int> seg[SZ * 4];
vector<int> vec;

void build(int v, int l, int r) {
	if (l == r - 1) {
		if (l < vec.size()) seg[v].push_back(vec[l]);
	}
	else {
		int mid = (l + r) / 2;
		build(v * 2 + 1, l, mid);
		build(v * 2 + 2, mid, r);
		merge(seg[v * 2 + 1].begin(), seg[v * 2 + 1].end(), seg[v * 2 + 2].begin(), seg[v * 2 + 2].end(), back_inserter(seg[v]));
	}
}

ll des(int v, int l, int r, int cnt, int rt) {
	if (l == r - 1) {
		return l;
	}
	else {
		int mid = (l + r) / 2;

		ll calc = upper_bound(seg[v * 2 + 1].begin(), seg[v * 2 + 1].end(), rt) - seg[v * 2 + 1].begin();
		if (calc >= cnt) {
			return des(v * 2 + 1, l, mid, cnt, rt);
		}
		else {
			return des(v * 2 + 2, mid, r, cnt - calc, rt);
		}
	}
}

ll find_pos(int r, int c) {
	if (r - c == 0) return -1;

	return des(0, 0, SZ, r - c, r);
}

ll find_bad(int v, int l, int r, int rt, int rt2) {
	if (l == r - 1) {
		return l;
	}
	else {
		int mid = (l + r) / 2;

		auto it = upper_bound(seg[v * 2 + 1].begin(), seg[v * 2 + 1].end(), rt);
		bool calc = 0;
		if (it != seg[v * 2 + 1].end()) calc = ((*it) <= rt2);
		if (calc) {
			return find_bad(v * 2 + 1, l, mid, rt, rt2);
		}
		else {
			return find_bad(v * 2 + 2, mid, r, rt, rt2);
		}
	}
}

ll find_bad_edge(int r1, int c1, int r2, int c2) {
	ll a = find_pos(r1, c1);
	ll b = find_pos(r2, c2);
	
	ll bd = find_bad(0, 0, SZ, min(r1, r2), max(r1, r2));
	if (bd > max(a, b)) return vec.size();

	return bd;
}

vector<ll> getup(int r, int c) {
	vector<ll> vals;
	for (int i = 0; i < vec.size(); i++) {
		if (vals.size() == r - c) break;
		if (vec[i] <= r) {
			vals.push_back(vec[i] - 1);
		}
	}

	return vals;
}

ll calc(int v, int l, int r, int askl, int askr, int rt) {
	if (askr == 0) return 0;
	if (l >= askr || r <= askl) return 0;

	if (askl <= l && r <= askr) {
		return upper_bound(seg[v].begin(), seg[v].end(), rt) - seg[v].begin();
	}

	int mid = (l + r) / 2;
	return calc(v * 2 + 1, l, mid, askl, askr, rt) + calc(v * 2 + 2, mid, r, askl, askr, rt);
}

int main() {
	fastInp;

	ll n;
	cin >> n;
	vec.resize(n);

	for (auto& c : vec) cin >> c;

	build(0, 0, SZ);
	ll q;
	cin >> q;

	for (int i = 0; i < q; i++) {
		ll r1, c1, r2, c2;
		cin >> r1 >> c1 >> r2 >> c2;

		if (make_pair(r1, c1) == make_pair(r2, c2)) {
			cout << r1 << " " << c1 << endl;
			continue;
		}

		vector<ll> a = getup(r1, c1);
		vector<ll> b = getup(r2, c2);

		set<ll> a1, b1;
		for (auto c : a) a1.insert(c);
		for (auto c : b) b1.insert(c);

		ll cmn = 0;

		pair<ll, ll> ans = { 0, 0 };
		ll k = find_bad_edge(r1, c1, r2, c2);

		ll good = 0;
		ll bad = 0;
		
		for (int i = 0; i < k; i++) {
			ll x = (b1.find(i) == b1.end());
			ll x2 = (a1.find(i) == a1.end());

			//if (ans == make_pair(r1, c1) || ans == make_pair(r2, c2)) break;
			if (x == x2 && x == 0) { // found
				good++;
			}
			else if (x == x2 && x == 1) { // not found
				bad++;
			}
			else {
				break;
			}
		}

		ans.first = good + bad;
		ans.second = bad;

		if (ans.first > r1) ans = { r1, c1 };
		if (ans.first > r2) ans = { r2, c2 };
		cout << ans.first << " " << ans.second << "\n";
	}

	return 0;
}

/*
3
2 3 1
5
3 3 3 0
2 2 2 1
1 0 3 1
3 1 3 2
2 2 2 2
*/