#include <iostream>
#include <vector>
#define int long long

using namespace std;

struct segTree {
    vector<int> t;
    int n;
    segTree(int _n) {
        n = _n;
        t.resize(4 * n);
    }
    void inc(int pos, int v = 0, int l = 0, int r = -1) {
        if (r == -1) r = n;
        if (l < r - 1) {
            int m = (l + r) / 2;
            if (pos < m) inc(pos, 2 * v + 1, l, m);
            else inc(pos, 2 * v + 2, m, r);
        }
        t[v]++;
    }

    int sum(int lb, int rb, int v = 0, int l = 0, int r = -1) {
        if (r == -1) r = n;
        if (lb >= r || l >= rb) return 0;
        if (lb <= l && r <= rb) return t[v];
        int m = (l + r) / 2;
        return sum(lb, rb, 2 * v + 1, l, m) + sum(lb, rb, 2 * v + 2, m, r);
    }
};

signed main() {
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    int n;
    cin >> n;
    vector<int> a(n);
    for (int& el: a) {
        cin >> el;
        el--;
    }
    int ans[n][n];
    segTree cnti = segTree(n);
    for (int i = 0; i < n; i++) {
        cnti.inc(a[i]);
        segTree cntj = segTree(n);
        for (int j = n - 1; j > i; j--) {
            cntj.inc(a[j]);
            int s1 = cnti.sum(a[i] + 1, n), s2 = cntj.sum(0, a[j]);
            ans[a[i]][a[j]] = max(j - i + max(s1, s2), abs(a[j] - a[i]));
            ans[a[j]][a[i]] = ans[a[i]][a[j]];
        }
    }
    int q = 0;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) q += ans[i][j];
    }
    cout << q << endl;
}
