#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double

const int MAXN = 1e5 + 10;

vector<array<int, 2> > g;

void relax(vector<int> &cur, int n) {
    int a = 0, b = 0;
    for (int i = 0; i < n; i++) {
        int t = (a + 1) * a / 2 + b;
        int nw = (a + 2) * (a + 1) / 2 + b + cur[i];
        g[nw][cur[i] ^ 1] = t;
        a++;
        b += cur[i];
    }
}

vector<int> was;
vector<int> used;

void dfs(int v) {
    used[v] = 1;
    was[v]++;
    for (auto to : g[v]) {
        if (to != -1 && !used[to]) {
            dfs(to);
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vector<int> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
        v[i]--;
    }
    vector<int> cur(n, 1);
    g.resize((n + 2) * (n + 1) / 2, {-1, -1});
    relax(cur, n);
    for (int i = 0; i < n; i++) {
        cur[v[i]] = 0;
        relax(cur, n);
    }
//    for (int i = 0; i <= n; i++) {
//        for (int j = 0; j <= i; j++) {
//            cout << i << " " << j << " : " << g[(i + 1) * i / 2 + j][0] << " " << g[(i + 1) * i / 2 + j][0] << '\n';
//        }
//    }
    was.resize((n + 2) * (n + 1) / 2);
    used.resize((n + 2) * (n + 1) / 2);
    int q;
    cin >> q;
    while (q --> 0) {
        int a1, b1, a2, b2;
        cin >> a1 >> b1 >> a2 >> b2;
        was.assign((n + 2) * (n + 1) / 2, 0);
        used.assign((n + 2) * (n + 1) / 2, 0);
        dfs((a1 + 1) * a1 / 2 + b1);
        used.assign((n + 2) * (n + 1) / 2, 0);
        dfs((a2 + 1) * a2 / 2 + b2);
        pair<int, int> ans = {-1, -1};
        for (int i = 0; i <= n; i++) {
            for (int j = 0; j <= i; j++) {
                if (was[(i + 1) * i / 2 + j] == 2)
                    ans = max(ans, {i, j});
            }
        }
        cout << ans.fi << " " << ans.se << '\n';
    }

    return 0;
}
/*
3
2 3 1
5
3 3 3 0
2 2 2 1
1 0 3 1
3 1 3 2
2 2 2 2

 */
