#include <iostream>
#include <iomanip>

#include <algorithm>

#include <vector>
#include <string>
#include <set>
#include <map>

#include <cassert>

using namespace std;

#define sz(x) ((int)(x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;

const ll inf = 1e18;

vector<vector<int>> g;
vector<int> c, l, r, b;
vector<vector<ll>> dp;

void solve(vector<vector<ll>>& cur_dp, vector<vector<int>>& pred, int i, int v, int l_w, int r_w, int cur_w_l, int cur_w_r) {
	if (l_w > r_w)
		return;
	int w = (l_w + r_w) / 2;

	for (int cur_w = max(cur_w_l, l[g[v][i - 1]]); cur_w <= min({ cur_w_r, r[g[v][i - 1]], w }); cur_w++) {
		if (cur_dp[i - 1][w - cur_w] + dp[g[v][i - 1]][cur_w] <= cur_dp[i][w]) {
			cur_dp[i][w] = cur_dp[i - 1][w - cur_w] + dp[g[v][i - 1]][cur_w];
			pred[i][w] = cur_w;
		}
	}

	solve(cur_dp, pred, i, v, l_w, w - 1, cur_w_l, pred[i][w]);
	solve(cur_dp, pred, i, v, w + 1, r_w, pred[i][w], cur_w_r);
}

void dfs(int v) {
	for (auto to : g[v]) {
		dfs(to);
	}

	vector<vector<ll>> cur_dp(sz(g[v]) + 1, vector<ll>(r[v] + 1, inf));
	vector<vector<int>> pred(sz(g[v]) + 1, vector<int>(r[v] + 1, -1));

	for (int w = 0; w <= r[v]; w++) {
		cur_dp[0][w] = 1ll * w * c[v];
		pred[0][w] = w;
	}
	for (int i = 1; i < sz(g[v]) + 1; i++) {
		solve(cur_dp, pred, i, v, l[g[v][i - 1]], r[v], l[g[v][i - 1]], r[g[v][i - 1]]);
	}

	for (int w = l[v]; w <= r[v]; w++) {
		dp[v][w] = cur_dp.back()[w];
	}
}

void dfs_ans(int v, int ai) {
	vector<vector<ll>> cur_dp(sz(g[v]) + 1, vector<ll>(r[v] + 1, inf));
	vector<vector<int>> pred(sz(g[v]) + 1, vector<int>(r[v] + 1, -1));

	for (int w = 0; w <= r[v]; w++) {
		cur_dp[0][w] = 1ll * w * c[v];
		pred[0][w] = w;
	}
	for (int i = 1; i < sz(g[v]) + 1; i++) {
		solve(cur_dp, pred, i, v, l[g[v][i - 1]], r[v], l[g[v][i - 1]], r[g[v][i - 1]]);
	}

	int i = sz(cur_dp) - 1, j = ai;
	while (i > 0) {
		dfs_ans(g[v][i - 1], pred[i][j]);
		j -= pred[i][j];
		i--;
	}

	b[v] = j;
}

void solve() {
	int n; cin >> n;
	g.clear();
	g.resize(n);

	for (int i = 1; i < n; i++) {
		int p; cin >> p;
		p--;
		g[p].push_back(i);
	}

	c.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> c[i];
	}
	l.resize(n), r.resize(n);
	dp.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> l[i] >> r[i];
		dp[i].assign(r[i] + 1, inf);
	}

	dfs(0);

	ll ans = inf;
	int ai;
	for (int w = l[0]; w <= r[0]; w++) {
		if (dp[0][w] <= ans) {
			ans = dp[0][w];
			ai = w;
		}
	}

	if (ans == inf) {
		cout << -1 << '\n';
		return;
	}

	cout << ans << '\n';
	b.resize(n);
	dfs_ans(0, ai);
	assert(b[0] == 0);
	for (int i = 0; i < n; i++) {
		cout << b[i] << ' ';
	}
	cout << '\n';
}

int main() {
	ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL);

	int t; cin >> t;
	while (t--) {
		solve();
	}

	return 0;
}