#include <iostream>
#include <iomanip>

#include <algorithm>

#include <vector>
#include <string>
#include <set>
#include <map>

using namespace std;

#define sz(x) ((int)(x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;

const ll inf = 1e18;

int n;
map<int, vector<pair<int, int>>> g;
void add(vector<bool>& path) {
	int r = 0, c = 0;
	for (auto t : path) {
		int new_r = r + 1, new_c = c + t;
		if (g[r * n + c].size() == 0 || g[r * n + c].back() != make_pair(new_r, new_c))
			g[r * n + c].push_back({ new_r, new_c });
		r = new_r, c = new_c;
	}
}

map<int, int> tin, tout;
int timer = 0;
void dfs(pair<int, int> v) {
	tin[v.first * n + v.second] = timer;
	timer++;
	for (auto to : g[v.first * n + v.second]) {
		dfs(to);
	}
	tout[v.first * n + v.second] = timer;
	timer++;
}

bool is_upper(pair<int, int> a, pair<int, int> b) {
	return tin[a.first * n + a.second] <= tin[b.first * n + b.second] &&
		tout[b.first * n + b.second] <= tout[a.first * n + a.second];
}

int main() {
	ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL);

	cin >> n;
	vector<bool> path(n, 1);
	add(path);
	for (int i = 0; i < n; i++) {
		int pos;  cin >> pos;
		pos--;
		path[pos] = 0;
		add(path);
	}

	dfs({ 0, 0 });

	int q; cin >> q;
	while (q--) {
		pair<int, int> a; cin >> a.first >> a.second;
		pair<int, int> b; cin >> b.first >> b.second;

		pair<int, int> ans = { 0 ,0 };
		for (auto c : g) {
			pair<int, int> v = { c.first / n, c.first % n };
			if (is_upper(v, a) && is_upper(v, b)) {
				ans = max(ans, v);
			}
		}

		cout << ans.first << ' ' << ans.second << '\n';
	}

	return 0;
}