#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;

int b;
vector<int> tree;

void build_tree(int n) {
	b = 1;
	while (b < n) {
		b *= 2;
	}
	tree.assign(2 * b, 0);
}

void set_val(int i) {
	int t = b + i;
	while (t) {
		tree[t]++;
		t /= 2;
	}
}

int get_sum(int t, int tl, int tr, int left, int right) {
	if (left >= right) {
		return 0;
	}
	if (tl == left && tr == right) {
		return tree[t];
	}
	int mid = (tl + tr) / 2, sum = 0;
	sum += get_sum(t * 2, tl, mid, left, min(right, mid));
	sum += get_sum(t * 2 + 1, mid, tr, max(left, mid), right);
	return sum;
}

int main() {
	ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
	int n;
	cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		a[i]--;
	}
	vector<int> left_cnt(n, 0), right_cnt(n, 0);
	build_tree(n);
	for (int i = 0; i < n; i++) {
		left_cnt[i] = get_sum(1, 0, b, a[i], n);
		set_val(a[i]);
	}
	build_tree(n);
	for (int i = n - 1; i >= 0; i--) {
		right_cnt[i] = get_sum(1, 0, b, 0, a[i]);
		set_val(a[i]);
	}
	ll ans = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < i; j++) {
			int res = max(i - j + max(left_cnt[j], right_cnt[i]), abs(a[i] - a[j]));
			ans += res;
		}
	}
	cout << ans << "\n";
}
