#pragma GCC target("sse", "sse2", "sse3", "sse4.1", "sse4.2", "popcnt")

#include <iostream>
#include <vector>
#include <array>
#include <algorithm>

using namespace std;

const int INF = int(1e9) + 7;

int b, n;
vector<int> tree, a;

void build_tree() {
	b = 1;
	while (b < n) {
		b *= 2;
	}
	tree.assign(2 * b, -1);
	for (int i = 0; i < n; i++) {
		tree[b + i] = i;
	}
	for (int t = b - 1; t > 0; t--) {
		if (tree[t * 2 + 1] == -1 || (tree[t * 2] != -1 && a[tree[t * 2]] < a[tree[t * 2 + 1]])) {
			tree[t] = tree[t * 2];
		}
		else {
			tree[t] = tree[t * 2 + 1];
		}
	}
}

int get_min(int t, int tl, int tr, int left, int right) {
	if (left >= right) {
		return -1;
	}
	if (tl == left && tr == right) {
		return tree[t];
	}
	int mid = (tl + tr) / 2;
	int i = get_min(t * 2, tl, mid, left, min(right, mid));
	int j = get_min(t * 2 + 1, mid, tr, max(left, mid), right);
	if (i == -1 || j == -1) {
		return (i == -1 ? j : i);
	}
	if (a[i] < a[j]) {
		return i;
	}
	else {
		return j;
	}
}

vector<int> cnt_tree;

void change_cnt_tree(int i) {
	int t = b + i;
	while (t) {
		cnt_tree[t]++;
		t /= 2;
	}
}

int get_from_k_pos(int t, int tl, int tr, int k) {
	if (tr - tl == 1) {
		return tl;
	}
	int mid = (tl + tr) / 2;
	if (cnt_tree[t * 2] < k) {
		return get_from_k_pos(t * 2 + 1, mid, tr, k - cnt_tree[t * 2]);
	}
	else {
		return get_from_k_pos(t * 2, tl, mid, k);
	}
}

int get_cnt(int t, int tl, int tr, int left, int right) {
	if (left >= right) {
		return 0;
	}
	if (tl == left && tr == right) {
		return cnt_tree[t];
	}
	int mid = (tl + tr) / 2, cnt = 0;
	cnt += get_cnt(t * 2, tl, mid, left, min(right, mid));
	cnt += get_cnt(t * 2 + 1, mid, tr, max(left, mid), right);
	return cnt;
}

void print_ans(int r, int c) {
	cout << r << " " << r - c << "\n";
}

int main() {
	ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
	cin >> n;
	a.resize(n);
	vector<pair<int, int>> ai;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		a[i]--;
		ai.push_back({ a[i], i });
	}
	sort(ai.begin(), ai.end());
	build_tree();
	// build_time_tree();
	int q;
	cin >> q;
	vector<array<int, 4>> ask;
	vector<vector<pair<int, int>>> times_ask(n + 1);
	for (int i = 0; i < q; i++) {
		int r1, c1, r2, c2;
		cin >> r1 >> c1 >> r2 >> c2;
		c1 = r1 - c1;
		c2 = r2 - c2;
		ask.push_back({ r1, c1, r2, c2 });
		// auto t1 = get_times(r1, c1), t2 = get_times(r2, c2);
		times_ask[r1].push_back({ c1, i });
		times_ask[r2].push_back({ c2, i });
		
		// cout << "t1 = {" << t1.first << ", " << t1.second << "}\n";
		// cout << "t2 = {" << t2.first << ", " << t2.second << "}\n";
		
		// if (max(t1.first, t2.first) <= min(t1.second, t2.second)) {
		// 	if (r1 > r2) {
		// 		print_ans(r2, c2);
		// 	}
		// 	else {
		// 		print_ans(r1, c1);
		// 	}
		// }
		// else {
		// 	int l = min(t1.second, t2.second), r = max(t1.first, t2.first);
		// 	int j = get_min(1, 0, b, l, r);
		// 	int c = get_count(state[j], 0, b, 0, a[j]);
		// 	print_ans(a[j], c);
		// }
	}
	vector<pair<int, int>> ans(q, { INF, -INF });
	cnt_tree.assign(2 * b, 0);
	for (int r = 0; r <= n; r++) {
		for (const auto& el : times_ask[r]) {
			int c = el.first, i = el.second;
			int tl = get_from_k_pos(1, 0, b, c) + 1;
			if (c == 0) {
				tl = 0;
			}
			int tr = get_from_k_pos(1, 0, b, c + 1);
			// cout << "c = " << c << "\n";
			// cout << "i = " << i << ", tl = " << tl << ", tr = " << tr << "\n";
			ans[i].first = min(ans[i].first, tr);
			ans[i].second = max(ans[i].second, tl);
		}
		times_ask[r].clear();
		if (r < n) {
			change_cnt_tree(ai[r].second);
			// cout << "add " << ai[r].second << "\n";
		}
	}
	vector<pair<int, int>> res(q);
	for (int i = 0; i < q; i++) {
		int r1 = ask[i][0], c1 = ask[i][1], r2 = ask[i][2], c2 = ask[i][3];
		if (ans[i].second <= ans[i].first) {
			if (r1 > r2) {
				res[i] = { r2, c2 };
			}
			else {
				res[i] = { r1, c1 };
			}
		}
		else {
			int l = ans[i].first, r = ans[i].second;
			int j = get_min(1, 0, b, l, r);
			times_ask[a[j]].push_back({ j, i });
			res[i].first = a[j];
			// int c = get_count(state[j], 0, b, 0, a[j]);
			// print_ans(a[j], c);
		}
	}
	cnt_tree.assign(2 * b, 0);
	for (int r = 0; r <= n; r++) {
		for (const auto& el : times_ask[r]) {
			int j = el.first, i = el.second;
			res[i].second = get_cnt(1, 0, b, 0, j);
		}
		if (r < n) {
			change_cnt_tree(ai[r].second);
		}
	}
	for (const auto& el : res) {
		print_ans(el.first, el.second);
	}
}
