#include <bits/stdc++.h>

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define ar array
#define rall(a) (a).rbegin(), (a).rend()


using namespace std;

typedef long long ll;
typedef long double ld;

using vi = vector<int>;
using vl = vector<ll>;

const int INFi = 2e9;
const ll INF = 2e18;
const int maxN = 1e5 + 5;
vi g[maxN];
int l[maxN], r[maxN];
int c[maxN];
int b[maxN];

struct DP {
    ll start;
    map<pair<int, int>, int> mp;
    ll sum;

    DP() : start(0), mp(), sum(0) {}

    void init(pair<int, int> x) {
        start = 0;
        mp.clear();
        mp[x] = INFi;
        sum = INFi;
    }

    void splitFront(int len) {
        assert(len >= 0);
        sum -= len;
        while (len > 0) {
            assert(!mp.empty());
            auto x = mp.begin()->first;
            if (mp[x] <= len) {
                len -= mp[x];
                start += 1ll * x.first * mp[x];
                b[x.second] += mp[x];
                mp.erase(x);
                continue;
            }
            b[x.second] += len;
            start += 1ll * x.first * len;
            mp[x] -= len;
            len = 0;
        }
    }

    void splitBack(int len) {
        ll need = sum - len;
        if (need <= 0) return;
        while (need > 0) {
            auto x = mp.rbegin()->first;
            if (mp[x] <= need) {
                need -= mp[x];
                mp.erase(x);
                continue;
            }
            mp[x] -= need;
            need = 0;
        }
        sum = len;
    }
};

DP dp[maxN];

bool dfs_check(int v) {
    ll mn = 0;
    bool ok = true;
    for (auto &u: g[v]) {
        ok &= dfs_check(u);
        mn += l[u];
    }
    if (mn > r[v]) return false;
    l[v] = max(l[v], (int) mn);
    return ok;
}

void merge(int v, int u) {
    if (dp[u].mp.size() > dp[v].mp.size()) swap(dp[v], dp[u]);
    dp[v].start += dp[u].start;
    for (auto &[x, y]: dp[u].mp) {
        dp[v].mp[x] += y;
        dp[v].sum += y;
    }
}

void dfs(int v) {
    ll s = l[v];
    dp[v].init({c[v], v});
    for (auto &u: g[v]) {
        dfs(u);
        merge(v, u);
        s -= l[u];
    }
    dp[v].splitFront(s);
    dp[v].splitBack(r[v] - l[v]);
}

void solve() {
    int n;
    cin >> n;
    for (int i = 1; i <= n; ++i) g[i].clear();
    for (int i = 2; i <= n; ++i) {
        int p;
        cin >> p;
        g[p].push_back(i);
    }
    for (int i = 1; i <= n; ++i) cin >> c[i];

    for (int i = 1; i <= n; ++i) cin >> l[i] >> r[i];
    if (!dfs_check(1)) {
        cout << "-1\n";
        return;
    }
    dfs(1);
    auto res = dp[1].mp;
    cout << dp[1].start << '\n';
    for (int i = 1; i <= n; ++i) {
        cout << b[i] << ' ';
        b[i] = 0;
    }
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
    cin >> t;
    rep(_, t) {
        solve();
    }
    return 0;
}