#include <bits/stdc++.h>

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define ar array
#define rall(a) (a).rbegin(), (a).rend()


using namespace std;

typedef long long ll;
typedef long double ld;

using vi = vector<int>;
using vl = vector<ll>;

const int INFi = 2e9;
const ll INF = 2e18;
const int maxN = 1e5 + 5;
const int LG = 20;

int k;
vi allow;

struct dsu {
    vector<int> dsu;

    void build(int n) {
        dsu.resize(n);
        iota(all(dsu), 0);
    }

    int get(int a) {
        return dsu[a] == a ? a : dsu[a] = get(dsu[a]);
    }

    bool unio(int a, int b) {
        a = get(a);
        b = get(b);
        if (a == b) return false;
        dsu[a] = b;
        return true;
    }
};

ll small_solve(vector<pair<int, int>> pts, int w, int h) {
    int n = pts.size();
    vector<ar<ll, 2>> dp(n + 1, {0, 0});
    vector<ar<ll, 2>> add(n + 1, {0, 0});
    for (int i = 0; i < n; ++i) {
        add[i][0] = 1ll * ((i != 0 ? pts[i - 1].second : h) - pts[i].second) * (w - pts[i].first);
        add[i][1] = 1ll * (pts[i].first - (i != 0 ? pts[i - 1].first : 0)) * pts[i].second;
        if (i > 0) {
            add[i][0] += add[i - 1][0];
            add[i][1] += add[i - 1][1];
        }
    }
    add[n] = add[n - 1];
    dp[0] = add[0];
    for (int e = 1; e <= n; ++e) {
        rep(j, 2) {
            ll mx = -INF;
            for (int i = 0; i < e; ++i) {
                ll val = dp[i][j] - add[i][j];
                if (e != n) {
                    if (j == 0) {
                        val -= 1ll * (i != 0 ? pts[i - 1].first : 0) * pts[e].second;
                    } else {
                        val += 1ll * (i != 0 ? pts[i - 1].second : h) * (w - pts[e].first);
                    }
                }
                mx = max(mx, val);
            }
            mx += add[e - 1][j];
            if (e != n) {
                if (j == 0) {
                    mx += 1ll * pts[e].first * pts[e].second;
                } else {
                    mx -= 1ll * pts[e].second * (w - pts[e].first);
                }
            }
            dp[e][j ^ 1] = max(dp[e][j ^ 1], mx);
        }
    }
    return max(dp[n][0], dp[n][1]);
}

void solve() {
    assert(k == 2);
    assert(allow[0] == 1 && allow[1] == 3);
    dsu d;
    int n;
    cin >> n;
    int w, h;
    cin >> w >> h;
    d.build(n);
    vector<pair<int, int>> pts(n);
    rep(i, n) cin >> pts[i].first >> pts[i].second;
    sort(all(pts));
    vector<int> stk;
    rep(i, n) {
        auto p = pts[i];
        if (stk.empty() || pts[stk.back()].second > p.second) {
            stk.emplace_back(i);
            continue;
        }
        int t = stk.back();
        while (!stk.empty() && pts[stk.back()].second <= p.second) {
            d.unio(stk.back(), i);
            stk.pop_back();
        }
        stk.push_back(t);
    }
    vector<ar<int, 4>> r(n);
    rep(i, n) {
        r[i] = {pts[i].first, pts[i].second, pts[i].first, pts[i].second};
    }
    rep(i, n) {
        int j = d.get(i);
        r[j][0] = min(r[j][0], pts[i].first);
        r[j][1] = min(r[j][1], pts[i].second);
        r[j][2] = max(r[j][2], pts[i].first);
        r[j][3] = max(r[j][3], pts[i].second);
    }
    ll ans = 0;
    {
        ll Lx = 0;
        ll Ry = h;
        for (auto &i: stk) {
            i = d.get(i);
            if (r[i][0] == r[i][2] && r[i][1] == r[i][3]) continue;
            assert((Lx == 0 || r[i][0] > Lx) && (Ry == h || r[i][3] < Ry));
            ans += 1ll * (r[i][2] - Lx) * r[i][3];
            ans += 1ll * (w - r[i][0]) * (Ry - r[i][1]);
            ans -= 1ll * (r[i][2] - r[i][0]) * (r[i][3] - r[i][1]);
            Lx = r[i][2];
            Ry = r[i][1];
        }
    }
    for (int l1 = 0, r1 = 0; l1 < (int) stk.size(); l1 = r1) {
        int i = stk[r1];
        while (r[i][0] == r[i][2] && r[i][1] == r[i][3]) {
            r1++;
            if (r1 == (int) stk.size()) break;
            i = stk[r1];
        }
        if (l1 == r1) {
            r1++;
            continue;
        }
        // [l1, r1)
        int Lx = 0;
        if (l1 != 0) Lx = r[stk[l1 - 1]][2];
        int Rx = w;
        if (r1 != (int) stk.size()) Rx = r[stk[r1]][0];
        int Ly = 0;
        if (r1 != (int) stk.size()) Ly = r[stk[r1]][3];
        int Ry = h;
        if (l1 != 0) Ry = r[stk[l1 - 1]][1];
        vector<pair<int, int>> pp;
        for (int j = l1; j < r1; ++j) {
            auto p = pts[stk[j]];
            p.first -= Lx;
            p.second -= Ly;
            pp.push_back(p);
        }
        ans += small_solve(pp, Rx - Lx, Ry - Ly);
    }
    cout << ans << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
    cin >> k;
    rep(i, k) {
        int x;
        cin >> x;
        allow.push_back(x);
    }
    cin >> t;
    rep(_, t) {
        solve();
    }
    return 0;
}