#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

vector<vector<int>> graph;
vector<int> crr;
vector<pair<int, int>> lim;
vector<int> par;
vector<int> vals;
const ll INF = 1e9 + 100;
vector<int> anss;

int dfs2(int v) {
    int sz = 1;
    int mxui = -1, mxsz = -1;
    if (graph[v].empty())
        return 1;
    for (int ui = 0; ui < graph[v].size(); ++ui) {
        int u = graph[v][ui];
        int szu = dfs2(u);
        sz += szu;
        if (szu > mxsz) {
            mxsz = szu;
            mxui = ui;
        }
    }
    swap(graph[v][0], graph[v][mxui]);
    return sz;
}

vector<int> topv;
vector<int> tin, tout;
vector<int> order;
int tt = 0;
void dfs3(int v, int tp) {
    order[tt] = v;
    tin[v] = tt++;
    topv[v] = tp;
    if (!graph[v].empty())
        dfs3(graph[v][0], tp);
    for (int ui = 1; ui < (int)graph[v].size(); ++ui)
        dfs3(graph[v][ui], graph[v][ui]);
    tout[v] = tt;
}

vector<int> tree, mod;
void build(int v, int l, int r) {
    if (l + 1 == r) {
        tree[v] = lim[order[l]].second;
        return;
    }
    int m = (l + r) / 2;
    build(2 * v + 1, l, m);
    build(2 * v + 2, m, r);
    tree[v] = min(tree[2 * v + 1], tree[2 * v + 2]);
}

void push(int v) {
    if (mod[v] == 0)
        return;
    tree[v] += mod[v];
    if (2 * v + 2 < tree.size()) {
        mod[2 * v + 1] += mod[v];
        mod[2 * v + 2] += mod[v];
    }
    mod[v] = 0;
}

int getdo(int v, int l, int r, int ql, int qr) {
    push(v);
    if (qr <= l || r <= ql)
        return INF;
    if (ql <= l && r <= qr)
        return tree[v];
    int m = (l + r) / 2;
    int a = getdo(2 * v + 1, l, m, ql, qr);
    int b = getdo(2 * v + 2, m, r, ql, qr);
    return min(a, b);
}

void upddo(int v, int l, int r, int ql, int qr, int qx) {
    push(v);
    if (qr <= l || r <= ql)
        return;
    if (ql <= l && r <= qr) {
        mod[v] += qx;
        push(v);
        return;
    }
    int m = (l + r) / 2;
    upddo(2 * v + 1, l, m, ql, qr, qx);
    upddo(2 * v + 2, m, r, ql, qr, qx);
    tree[v] = min(tree[2 * v + 1], tree[2 * v + 2]);
}
int n;
void buildhld() {
    dfs2(0);
    dfs3(0, 0);
    tree.clear();
    mod.clear();
    tree.resize(4 * n + 10);
    mod.resize(4 * n + 10, 0);
    build(0, 0, n);
}

int getmin(int u) {
    int res = INF;
    while (u != -1) {
        int tp = topv[u];
        int l = tin[tp];
        int r = tin[u] + 1;
        int val = getdo(0, 0, n, l, r);
        res = min(res, val);
        u = par[tp];
    }
    return res;
}

void add(int u, int x) {
    anss[u] += x;
    while (u != -1) {
        int tp = topv[u];
        int l = tin[tp];
        int r = tin[u] + 1;
        upddo(0, 0, n, l, r, -x);
        u = par[tp];
    }
}

pair<ll, ll> dfs(int v, set<pair<int, int>> &costs) {
    ll cst = 0;
    ll num = 0;
    for (int u : graph[v]) {
        set<pair<int, int>> costs1;
        auto[cst1, num1] = dfs(u, costs1);
        cst += cst1;
        num += num1;
        if (num1 == -1) {
            return {-1, -1};
        }
        if (costs1.size() > costs.size())
            swap(costs1, costs);
        for (auto &el : costs1) {
            costs.insert(el);
        }
    }
    if (num > lim[v].second)
        return {-1, -1};
    costs.emplace(crr[v], v);
    int k = lim[v].first - num;
    while (k > 0 && !costs.empty()) {
        auto[c, u] = *costs.begin();
        costs.erase(costs.begin());
        int mng = getmin(u);
        if (mng == 0)
            continue;
        int mn = min(mng, k);
        add(u, mn);
        k -= mn;
        cst += mn * 1ll * c;
        num += mn;
        if (mng - mn > 0)
            costs.emplace(c, u);
    }
    if (k > 0)
        return {-1, -1};
    return {cst, num};
}

void solve() {
    cin >> n;
    graph.clear();
    graph.resize(n);
    par.resize(n);
    par[0] = -1;
    anss.assign(n, 0);
    for (int i = 0; i < n - 1; ++i) {
        int p;
        cin >> p;
        p--;
        graph[p].push_back(i + 1);
        par[i + 1] = p;
    }
    crr.resize(n);
    for (int &el : crr)
        cin >> el;
    lim.resize(n);
    for (auto &el : lim)
        cin >> el.first >> el.second;
    vals.resize(n);
    for (int i = 0; i < n; ++i)
        vals[i] = lim[i].second;
    set<pair<int, int>> costs;
    tt=  0;
    tin.resize(n);
    tout.resize(n);
    topv.resize(n);
    order.resize(n);
    buildhld();
    auto[ans, lol] = dfs(0, costs);
    if (ans == -1) {
        cout << -1;
        return;
    }
    cout << ans << '\n';
    for (int i = 0; i < n; ++i) {
        cout << anss[i] << ' ';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
        cout << '\n';
    }
}