#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <tuple>
using namespace std;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<int> a(n);
    for(int i = 0; i < n; ++i) cin >> a[i];
    vector<int> izn_poz(n + 1);
    for(int i = 0; i < n; ++i) izn_poz[a[i]] = i;
    vector<vector<int>> pref(n + 1);
    vector<vector<int>> pref_poz(n + 1);
    vector<vector<int>> suf(n + 1);
    vector<vector<int>> suf_poz(n + 1);
    for(int i = 1; i <= n; ++i){
        pref_poz[i].resize(n + 1);
        for(int j = 0; j < i; ++j){
            pref[i].push_back(a[j]);
        }
        std::sort(pref[i].begin(), pref[i].end());
        for(int j = i; j < n; ++j){
            pref[i].push_back(a[j]);
        }
        for(int j = 0; j < n; ++j) pref_poz[i][pref[i][j]] = j;
    }
    for(int i = 1; i <= n; ++i){
        suf_poz[i].resize(n + 1);
        vector<int> dop;
        for(int j = n - 1; n - 1 - j < i; --j){
            dop.push_back(a[j]);
        }
        std::sort(dop.begin(), dop.end());
        for(int j = 0; j < n - i; ++j){
            suf[i].push_back(a[j]);
        }
        for(int j = n - i; j < n; ++j){
            suf[i].push_back(dop[j - (n - i)]);
        }
        for(int j = 0; j < n; ++j){
            suf_poz[i][suf[i][j]] = j;
        }
    }
    vector<vector<int>> kr_left_pref(n + 1, vector<int>(n + 1));
    for(int i = 1; i <= n; ++i){
        kr_left_pref[i][0] = pref_poz[1][i];
        for(int j = 1; j <= n; ++j){
            kr_left_pref[i][j] = min(pref_poz[j][i], kr_left_pref[i][j - 1]);
        }
    }
    vector<vector<int>> kr_right_suf(n + 1, vector<int>(n + 1));
    for(int i = 1; i <= n; ++i){
        kr_right_suf[i][0] = suf_poz[1][i];
        for(int j = 1; j <= n; ++j){
            kr_right_suf[i][j] = max(suf_poz[j][i], kr_right_suf[i][j - 1]);
        }
    }
    vector<vector<int>> d(n + 1, vector<int>(n + 1));
    for(int i = 1; i <= n; ++i){
        for(int j = i + 1; j <= n; ++j){
            int l = min(izn_poz[i], izn_poz[j]);
            int r = max(izn_poz[i], izn_poz[j]);
            int first = a[l];
            int second = a[r];
            int a1 = r - kr_left_pref[first][r];
            int a2 = kr_right_suf[second][n - l - 1] - l;
            int a3 = abs(second - first);
            d[i][j] = max(max(a1, a2), a3);
        }
    }
    int ans = 0;
    for(int i = 1; i <= n; ++i){
        for(int j = i + 1; j <= n; ++j){
            ans += d[i][j];
        }
    }
    cout << ans;
}