#include <iostream>
#include <vector>
#include <algorithm>
 
long long n;
 
long long d(long long a, long long b, std::vector<std::vector<long long>>& lessThan,
    std::vector<std::vector<long long>>& greaterThan, std::vector<long long>& keys)
{
    long long posA = keys[a];
    long long posB = keys[b];
    if (posA > posB)
    {
        std::swap(posA, posB);
        std::swap(a, b);
    }
    long long greaterThanA = greaterThan[posA][a];
    long long lessThanB = lessThan[n - 1][b] - lessThan[posB - 1][b];
    return std::max(posB - posA + std::max(greaterThanA, lessThanB), std::abs(b - a));
}
 
int main()
{
    std::cin >> n;
    std::vector<std::vector<long long>> lessThan(n, std::vector<long long> (n + 1, 0));
    std::vector<std::vector<long long>> greaterThan(n, std::vector<long long>(n + 1, 0));
    std::vector<long long> a(n);
    std::vector<long long> keys(n + 1);
    for (long long i = 0; i < n; i++)
    {
        long long t;
        std::cin >> t;
        a[i] = t;
        keys[t] = i;
        for (long long j = 1; j <= n; j++)
        {
            if(i > 0) lessThan[i][j] = lessThan[i - 1][j];
            if(t < j) lessThan[i][j]++;
            if(i > 0) greaterThan[i][j] = greaterThan[i - 1][j];
            if(t > j) greaterThan[i][j]++;
        }
    }
    long long sum = 0;
    for (long long i = 1; i <= n - 1; i++)
    {
        for (long long j = i + 1; j <= n; j++)
        {
            sum += d(i, j, lessThan, greaterThan, keys);
        }
    }
    std::cout << sum << std::endl;
    return 0;
}