#include<bits/stdc++.h>
#define int long long
#define p pair<int, int>
#define endl '\n'
const int INF = 1000000001;

using namespace std;

struct MST{
    vector<vector<int>> do_arr;
    int len;

    MST(vector<int> a={}) {
        len = 1;
        while (len < a.size()) {
            len *= 2;
        }
        do_arr.assign(2*len, {});
        for (int q = len; q < len+a.size(); q++) {
            do_arr[q] = {a[q-len]};
        }
        for (int q = len-1; q > 0; q--) {
            int q2 = 0;
            for (int q1 : do_arr[2*q]) {
                while (q2 < do_arr[2*q+1].size() && do_arr[2*q+1][q2] < q1) {
                    do_arr[q].push_back(do_arr[2*q+1][q2++]);
                }
                do_arr[q].push_back(q1);
            }
            while (q2 < do_arr[2*q+1].size()) {
                do_arr[q].push_back(do_arr[2*q+1][q2++]);
            }
        }
    }

    int descent(int q, int x, int k) {
        while (q < len) {
            int num = lower_bound(do_arr[2*q].begin(), do_arr[2*q].end(), x)-do_arr[2*q].begin();
            if (num >= k) {
                q = 2*q;
            } else {
                q = 2*q+1, k -= num;
            }
        }
        return q-len;
    }
};

struct DO{
    vector<int> do_arr, mod;
    int len;

    DO(int n) {
        len = 1;
        while (len < n) {
            len *= 2;
        }
        do_arr.assign(2*len, 0), mod.assign(2*len, 0);
        for (int q = len; q < len+n; q++) {
            do_arr[q] = q-len;
        }
        for (int q = len-1; q > 0; q--) {
            do_arr[q] = do_arr[2*q]+do_arr[2*q+1];
        }
    }

    void push(int q, int len1) {
        do_arr[2*q] += mod[q]*len1, do_arr[2*q+1] += mod[q]*len1;
        mod[2*q] += mod[q]*len1, mod[2*q+1] += mod[q]*len1, mod[q] = 0;
    }

    void update(int l, int r, int l1, int r1, int q, int x) {
        if (l1 >= r || l >= r1) {
            return;
        }
        if (l1 <= l && r <= r1) {
            do_arr[q] += x*(r-l), mod[q] += x*(r-l);
            return;
        }
        push(q, (r-l)/2);
        int m = (l+r)/2;
        update(l, m, l1, r1, 2*q, x);
        update(m, r, l1, r1, 2*q+1, x);
        do_arr[q] = do_arr[2*q]+do_arr[2*q+1];
    }

    int ans(int l, int r, int l1, int r1, int q) {
        if (l1 >= r || l >= r1) {
            return 0;
        }
        if (l1 <= l && r <= r1) {
            return do_arr[q];
        }
        push(q, (r-l)/2);
        int m = (l+r)/2;
        return ans(l, m, l1, r1, 2*q)+ans(m, r, l1, r1, 2*q+1);
    }
};

struct DO1{
    vector<int> do_arr;
    int len;

    DO1(vector<int> &a) {
        len = 1;
        while (len < a.size()) {
            len *= 2;
        }
        do_arr.assign(2*len, 0);
        for (int q = len; q < len+a.size(); q++) {
            do_arr[q] = a[q-len];
        }
        for (int q = len-1; q > 0; q--) {
            do_arr[q] = min(do_arr[2*q], do_arr[2*q+1]);
        }
    }

    int ans(int l, int r, int l1, int r1, int q) {
        if (l1 >= r || l >= r1) {
            return INF;
        }
        if (l1 <= l && r <= r1) {
            return do_arr[q];
        }
        int m = (l+r)/2;
        return min(ans(l, m, l1, r1, 2*q), ans(m, r, l1, r1, 2*q+1));
    }
};

vector<int> a;
MST mst;
int n;

int get_num(int x, int y) {
    if (y == x) {
        return 0;
    }
    return mst.descent(1, x, x-y)+1;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int k;
    cin >> n;
    a.assign(n, -1);
    for (int q = 0; q < n; q++) {
        cin >> a[q];
        a[q]--;
    }
    mst = MST(a);
    DO1 do1 = DO1(a);
    DO do_arr = DO(n+1);
    vector<int> where(n);
    for (int q : a) {
        where[q] = do_arr.ans(0, do_arr.len, q, q+1, 1);
        do_arr.update(0, do_arr.len, where[q]+1, n+1, 1, -1);
    }
    cin >> k;
    vector<vector<int>> quest;
    for (int q = 0; q < k; q++) {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        int t = get_num(x1, y1), t1 = get_num(x2, y2);
        if (t < t1) {
            swap(x1, x2), swap(y1, y2), swap(t, t1);
        }
        quest.push_back({q, x1, y1, x2, y2, t, t1});
    }
    sort(quest.begin(), quest.end(), [](auto x, auto y) {return x[5] < y[5];});
    for (auto &q : quest) {
        int x1 = q[1], y1 = q[2], x2 = q[3], y2 = q[4], t = q[5], t1 = q[6];
        if (t == t1 && x1 < x2) {
            q.push_back(x1);
            q.push_back(y1);
        } else if (t == t1) {
            q.push_back(x2);
            q.push_back(y2);
        } else {
            int min1 = do1.ans(0, do_arr.len, t, t1+1, 1);
            q.push_back(min1);
            q.push_back(where[min1]);
        }
    }
    sort(quest.begin(), quest.end());
    for (auto &q : quest) {
        cout << q[(int)q.size()-2] << ' ' << q[(int)q.size()-1] << endl;
    }
    return 0;
}
