#pragma GCC optimize("Ofast")
//#pragma GCC target("avx2,sse4,popcnt")

#include <bits/stdc++.h>

#define sq(x) ((x)*(x))
#define err(x) cerr << "["#x"]  " << (x) << "\n"
#define errv(x) {cerr << "["#x"]  ["; for (const auto& i : (x)) cerr << (i) << ", "; cerr << "]\n";}
#define errvn(x, n) {cerr << "["#x"]  ["; for (int i = 0; i < (n); ++i) cerr << (x)[i] << ", "; cerr << "]\n";}
#define errf() cerr << "\n\n"

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
inline ll getrnd(ll l, ll r) {
    return uniform_int_distribution<ll>(l, r)(rng);
}

template <typename T1, typename T2>
inline bool relax(T1& a, const T2& b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template <typename T1, typename T2>
inline bool strain(T1& a, const T2& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

// ::::::::::::::::::::::::::::::::::

const int N = 1e5 + 5;

int bad = 0;
ll ans[N], c[N], l[N], r[N], now[N], mxcan[N], res[N];
vector<int> graph[N];
multiset<tuple<int, int, int>> have[N];

void dfs(int v) {
    int toc = -1;
    for (int to : graph[v]) {
        dfs(to);
        now[v] += now[to];
        ans[v] += ans[to];
        if (toc == -1 || have[toc].size() > have[to].size())
            toc = to;
    }
    if (toc == -1) {
        now[v] = l[v];
        ans[v] = l[v] * c[v];
        have[v].emplace(c[v], r[v] - l[v], v);
        res[v] = l[v];
        mxcan[v] = r[v] - l[v];
        return;
    }

    if (now[v] > r[v]) {
        bad = 1;
        return;
    } else {
        have[v].emplace(c[v], r[v] - now[v], v);
        mxcan[v] = r[v] - now[v];
    }

    for (int to : graph[v]) {
        while (!have[to].empty()) {
            auto [cost, can, fr] = *have[to].begin();
            have[to].erase(have[to].begin());
            have[v].emplace(cost, min((ll)can, mxcan[v]), fr);
        }
    }
    while (now[v] < l[v]) {
        auto [cost, can, fr] = *have[v].begin();
        have[v].erase(have[v].begin());
        ll need = l[v] - now[v];
        if (can > need) {
            have[v].emplace(cost, can - need, fr);
            now[v] += need;
            ans[v] += need * cost;
            res[fr] += need;
        } else {
            now[v] += can;
            ans[v] += can * cost;
            res[fr] += can;
        }
    }
}

void solve() {
    int n;
    cin >> n;
    for (int i = 1; i < n; ++i) {
        int par;
        cin >> par;
        --par;
        graph[par].emplace_back(i);
    }
    for (int i = 0; i < n; ++i)
        cin >> c[i];
    for (int i = 0; i < n; ++i)
        cin >> l[i] >> r[i];
    dfs(0);
    if (bad) {
        cout << "-1\n";
    } else {
        cout << ans[0] << '\n';
        for (int i = 0; i < n; ++i)
            cout << res[i] << ' ';
        cout << '\n';
    }
    // CLEAR MULTITEST
    bad = 0;
    for (int i = 0; i < n; ++i) {
        have[i].clear();
        graph[i].clear();
        ans[i] = res[i] = now[i] = c[i] = l[i] = r[i] = mxcan[i] = 0;
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);

    int t = 1;
    cin >> t;
    while (t--)
        solve();
    return 0;
}

