#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC traget("avx2,popcnt")

#include <iostream>
#include <bits/stdc++.h>

#define range(i, n) for (int i = 0; i < (n); ++i)
#define rrange(i, n) for (int i = (n) - 1; i >= 0; --i)

using namespace std;

typedef long long ll;
#define all(a) (a).begin(), (a).end()
typedef pair<int, int> P;
#define x second
#define y first

const ll INF = 2e9;

void solve(int t);
int main() {
    int t = 1;
    cin >> t;
    range(i, t) {
        solve(i);
    }
    return 0;
}


struct PAP {
    ll price = INF, amount = 0;
    int pos = 0;
//    bool operator<(const PAP &o) const {
//        if (amount == 0) return false;
//        if (o.amount == 0) return true;
//        return tie(price, amount, pos) < tie(o.price, o.amount, o.pos);
//    }
//    bool operator>(const PAP &o) const {
//        if (amount == 0) return true;
//        if (o.amount == 0) return false;
//        return tie(price, amount, pos) > tie(o.price, o.amount, o.pos);
//    }
};

struct min_op {
    bool operator()(const PAP &a, const PAP &o) const {
        if (a.amount == 0) return false;
        if (o.amount == 0) return true;
        return tie(a.price, a.amount, a.pos) < tie(o.price, o.amount, o.pos);
    }
};
struct max_op {
    bool operator()(const PAP &a, const PAP &o) const {
        if (a.amount == 0) return true;
        if (o.amount == 0) return false;
        return tie(a.price, a.amount, a.pos) < tie(o.price, o.amount, o.pos);
    }
};
struct DO {
    vector<PAP> bestPAP;
    vector<PAP> worstPAP;
    int n;

    DO(int n) : n(n), bestPAP(4 * n, PAP()), worstPAP(4 * n, PAP()) {}
    DO() {}

    PAP get_best_PAP(int i, int l, int r, int lq, int rq) {
        int m = (l + r) / 2;
        PAP ans;
        if (lq <= l && r <= rq) {
            ans = bestPAP[i];
        } else if (rq <= m) {
            ans = get_best_PAP(2 * i, l, m, lq, rq);
        } else if (m <= lq) {
            ans = get_best_PAP(2 * i + 1, m, r, lq, rq);
        } else {
            ans = min(get_best_PAP(2 * i, l, m, lq, m), get_best_PAP(2 * i + 1, m, r, m, rq), min_op());
        }
        return ans;
    }
    PAP get_best(int lq, int rq) {
        return get_best_PAP(1, 0, n, lq, rq);
    }
    PAP get_worst_PAP(int i, int l, int r, int lq, int rq) {
        int m = (l + r) / 2;
        PAP ans;
        if (lq <= l && r <= rq) {
            ans = worstPAP[i];
        } else if (rq <= m) {
            ans = get_worst_PAP(2 * i, l, m, lq, rq);
        } else if (m <= lq) {
            ans = get_worst_PAP(2 * i + 1, m, r, lq, rq);
        } else {
            ans = max(get_worst_PAP(2 * i, l, m, lq, m), get_worst_PAP(2 * i + 1, m, r, m, rq), max_op());
        }
        return ans;
    }
    PAP get_worst(int lq, int rq) {
        return get_worst_PAP(1, 0, n, lq, rq);
    }
    void update(int i, int l, int r) {
        if (r - l > 1) {
            bestPAP[i] = min(bestPAP[2 * i], bestPAP[2 * i + 1], min_op());
            worstPAP[i] = max(worstPAP[2 * i], worstPAP[2 * i + 1], max_op());
        }
    }
    static PAP do_buy(PAP p, ll amount) {
        p.amount -= amount;
        return p;
    }

    void set_on_pos(int i, int l, int r, PAP p, int pos) {
        if (r - l == 1) {
            bestPAP[i] = worstPAP[i] = p;
            return;
        }
        int m = (l + r) / 2;
        if (pos < m) {
            set_on_pos(2 * i, l, m, p, pos);
        } else  {
            set_on_pos(2 * i + 1, m, r, p, pos);
        }
        update(i, l, r);
    }
    void set_on_pos(PAP p, int pos) {
        set_on_pos(1, 0, n, p, pos);
    }
};
const int MAXN = 1e5 + 10;
int ls[MAXN];
int rs[MAXN];
int cs[MAXN];
vector<int> graph[MAXN];
ll cnt_buyed[MAXN];
int i_to_v[MAXN];

bool bad = false;
DO dd;

int cnt_used;
pair<ll, ll> dfs(int v) {
    int my_i = cnt_used++;
    i_to_v[my_i] = v;
    ll cost = 0;
    ll buyed = 0;
    ll can_buy = 0;
    for (auto u : graph[v]) {
        auto cb = dfs(u);
        if (bad) {
            return {0, 0};
        }
        cost += cb.first;
        buyed += cb.second;
    }
    if (buyed > rs[v]) {
        bad = true;
        return {0, 0};
    }
    if (buyed != rs[v]) {
        dd.set_on_pos({cs[v], rs[v] - buyed, my_i}, my_i);
        can_buy += rs[v] - buyed;
    }
    while (buyed < ls[v]) {
        auto p = dd.get_best(my_i, cnt_used);
        ll bb = min(p.amount, ls[v] - buyed);
        p.amount -= bb;
        cost += p.price * bb;
        cnt_buyed[i_to_v[p.pos]] += bb;
        buyed += bb;
        can_buy -= bb;
        dd.set_on_pos(p, p.pos);
    }
    while (can_buy > (rs[v] - buyed)) {
        auto p = dd.get_best(my_i, cnt_used);
        ll bb = min(p.amount, can_buy - (rs[v] -buyed));
        p.amount -= bb;
        can_buy -= bb;
        dd.set_on_pos(p, p.pos);
    }
    return {cost, buyed};
}

void solve(int t) {
    int n; cin >> n;
    fill(cnt_buyed, cnt_buyed + n, 0);
    fill(graph, graph + n, vector<int>());
    bad = false;
    cnt_used = 0;
    dd = DO(n);
    for (int i = 1; i < n; ++i) {
        int v; cin >> v; --v;
        graph[v].push_back(i);
    }
    range(i, n) {
        cin >> cs[i];
    }
    range(i, n) {
        cin >> ls[i] >> rs[i];
    }
    auto cb = dfs(0);
    if (bad) {
        cout << -1 << '\n';
        return;
    }
    cout << cb.first << '\n';
    range(i, n) {
        cout << cnt_buyed[i] << ' ';
    }
    cout << '\n';
}
