#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define all(x) (x).begin(), (x).end()
#define pb emplace_back
#define ld long double
#define ll long long
#define mp make_pair
#define pii pair<int, int>

const int INF = 1e9 + 1;

vector<vector<int>> g;
vector<int> cost;
vector<int> ban;

vector<int> order;
vector<int> pos;
vector<pii> t;
vector<int> tin, tout, depth;

int timer = 0;

void dfs(int v) {
    pos[v] = order.size();
    tin[v] = order.size();
    order.pb(v);
    for (auto &to : g[v]) {
        dfs(to);
    }
    tout[v] = order.size();
}

void build(int v, int vl, int vr) {
    if (vr - vl == 1) {
        t[v] = mp(cost[order[vl]], order[vl]);
        return;
    }
    int vm = (vl + vr) / 2;
    build(2 * v + 1, vl, vm);
    build(2 * v + 2, vm, vr);
    t[v] = min(t[2 * v + 1], t[2 * v + 2]);
}

void mod(int v, int vl, int vr, int id) {
    if (vr - vl == 1) {
        t[v] = mp(INF, -1);
        return;
    }
    int vm = (vl + vr) / 2;
    if (id < vm) mod(2 * v + 1, vl, vm, id);
    else mod(2 * v + 2, vm, vr, id);
    t[v] = min(t[2 * v + 1], t[2 * v + 2]);
}

pii get(int v, int vl, int vr, int l, int r) {
    if (vl >= l && vr <= r) return t[v];
    if (r <= vl || l >= vr) return mp(INF, -1);
    int vm = (vl + vr) / 2;
    return min(get(2 * v + 1, vl, vm, l, r), get(2 * v + 2, vm, vr, l, r));
}

void solve() {
    int n;
    cin >> n;
    vector<int> p(n, -1);
    depth.assign(n, 0);
    g.clear();
    g.resize(n);
    tin.clear();
    tin.resize(n);
    tout.clear();
    tout.resize(n);
    order.clear();
    pos.clear();
    pos.resize(n);
    for (int i = 1; i < n; i++) {
        cin >> p[i];
        p[i]--;
        g[p[i]].pb(i);
        depth[i] = depth[p[i]] + 1;
    }
    cost.resize(n);
    ban.assign(n, 0);
    for (auto &c : cost) cin >> c;
    dfs(0);
    t.clear();
    t.resize(4 * n);
    build(0, 0, n);
    vector<int> l(n), r(n);
    for (int i = 0; i < n; i++) cin >> l[i] >> r[i];
    vector<pii> d(n);
    for (int i = 0; i < n; i++) d[i] = mp(depth[i], i);
    sort(all(d));
    reverse(all(d));
    vector<int> cur(n);
    ll ans = 0;
    vector<int> take(n);
    for (auto &c : d) {
        int v = c.se;
        while (1) {
            if (cur[v] >= l[v]) break;
            int u = -1, cntop = INF;
            while (1) {
                u = get(0, 0, n, tin[v], tout[v]).se;
                if (u == -1) break;
                if (ban[u] == 1) exit(0);
                int w = u;
                cntop = INF;
                while (w != -1) {
                    if (cur[w] == r[w]) ban[u] = 1;
                    cntop = min(cntop, r[w] - cur[w]);
                    w = p[w];
                }
                if (ban[u]) {
                    mod(0, 0, n, pos[u]);
                    continue;
                }
                break;
            }
            if (u == -1) {
                cout << -1 << "\n";
                return;
            }
            cntop = min(cntop, l[v] - cur[v]);
            ans += (ll)cost[u] * cntop;
            take[u] += cntop;
            int w = u;
            while (w != -1) {
                cur[w] += cntop;
                w = p[w];
            }
        }
    }
    cout << ans << "\n";
    for (auto &c : take) cout << c << " ";
    cout << "\n";
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) solve();
    return 0;
}
