#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <sstream>
#include <assert.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define input(a) do { for (auto& e : a) cin >> e; } while(0);
#define print(a) do {cerr << #a << ": "; for (auto& e : a) cerr << e << " "; cerr << "\n";} while(0);

mt19937_64 rnd(1231);

const int MAXN = 131072;

struct v {
	vector<int> in;
	int cntLess(int x) {
		//print(in);
		//cerr << "cnt less " << x << ": " << lower_bound(in.begin(), in.end(), x) - in.begin() << "\n";
		return lower_bound(in.begin(), in.end(), x) - in.begin(); // swap if g2
	}
};
vector<int> arr(MAXN);
vector<v> t(2 * MAXN - 1);

void build(int i = 0, int l = 0, int r = MAXN) {
	if (r - l == 1) {
		t[i].in.push_back(arr[l]);
	}
	else {
		int m = (r + l) / 2;
		build(2 * i + 1, l, m);
		build(2 * i + 2, m, r);
		auto& now = t[i].in;
		auto& L = t[2 * i + 1].in;
		auto& R = t[2 * i + 2].in;
		now = vector<int>(r - l);
		merge(L.begin(), L.end(), R.begin(), R.end(), now.begin());
	}
}
int _calcI(int cnt, int targ, int i = 0, int l = 0, int r = MAXN) {
	if (r -  l == 1)
		return r;
	int m = (r + l) / 2;
	int left = t[2 * i + 1].cntLess(targ);
	if (left >= cnt)
		return _calcI(cnt, targ, 2 * i + 1, l, m);
	else
		return _calcI(cnt - left, targ, 2 * i + 2, m, r);
}
int calcI(int  r, int c) {
	if (r == c)
		return 0;
	return _calcI(r - c, r);
}

int fmeet[MAXN];

struct mst {
	vector<v> t = vector<v>(MAXN * 2 - 1);
	vector<int> arr = vector<int>(MAXN);
	mst(int n) {
		for (int i = 0; i < n; i++)
			arr[i] = fmeet[i];
		for (int i = n; i < MAXN; i++)
			arr[i] = n;
	}
	void build(int i = 0, int l = 0, int r = MAXN) {
		if (r - l == 1) {
			t[i].in.push_back(arr[l]);
		}
		else {
			int m = (r + l) / 2;
			build(2 * i + 1, l, m);
			build(2 * i + 2, m, r);
			auto& now = t[i].in;
			auto& L = t[2 * i + 1].in;
			auto& R = t[2 * i + 2].in;
			now = vector<int>(r - l);
			merge(L.begin(), L.end(), R.begin(), R.end(), now.begin());
		}
	}

	int get(int L, int R, int I) {
		int il = MAXN - 1 + L;
		int ir = MAXN - 1 + R - 1;
		int ans = 0;
		while (il < ir) {
			if ((il & 1) == 0) {
				ans += t[il].cntLess(I);
				il++;
			}
			if ((ir & 1) == 1) {
				ans += t[ir].cntLess(I);
				ir--;
			}
			il = (il >> 1);
			ir = ((ir - 1) >> 1);
		}
		if (il == ir) {
			ans += t[il].cntLess(I);
		}
		return ans;
	}
};

void updSlow(int& r, int& c, int i) {
	if (fmeet[r - 1] < i) {
		r--;
	}
	else {
		r--;
		c--;
	}
}
void updFast(int& r, int& c, int i, int to, mst& m) {
	int cntLess = m.get(to, r, i);
	c -= r - to - cntLess;
	r = to;
}


const int K = 3000;

bool tryUp(int& r1, int& c1, int i1, int& r2, int& c2, int i2, mst& m) {
	if (r1 < K || r2 < K)
		return false;
	int cpr1 = r1;
	int cpr2 = r2;
	int cpc1 = c1;
	int cpc2 = c2;
	updFast(cpr1, cpc1, i1, cpr1 - K, m);
	updFast(cpr2, cpc2, i2, cpr2 - K, m);
	if (cpc1 == cpc2)
		return false;
	r1 = cpr1;
	r2 = cpr2;
	c1 = cpc1;
	c2 = cpc2;
	return true;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	cerr << (1<<17);

	int n;
	cin >> n;
	for (int i = 0; i < n; i++) {
		cin >> arr[i];
		arr[i]--;
		fmeet[arr[i]] = i;
	}
	for (int i = n; i < MAXN; i++)
		arr[i] = n;
	mst fmeetMst(n);
	fmeetMst.build();
	build();
	int q;
	cin >> q;
	while (q--) {
		int r1, c1, r2, c2;
		cin >> r1 >> c1 >> r2 >> c2;
		int i1 = calcI(r1, c1);
		int i2 = calcI(r2, c2);

		if (r2 < r1)
			updFast(r1, c1, i1, r2, fmeetMst);
		if (r1 < r2) {
			updFast(r2, c2, i2, r1, fmeetMst);
		}

		while (tryUp(r1, c1, i1, r2, c2, i2, fmeetMst)) {
			// continue;
		}

		while (c1 != c2) {
			updSlow(r1, c1, i1);
			updSlow(r2, c2, i2);
		}
		cout << r1 << " " << c1 << "\n";
	}
}