#include <iostream>
#include <algorithm>
#include <set>

int32_t* arr;
int32_t position_on_level(int32_t prefix, int32_t level) {
    int32_t ans = level;
    for(int32_t i = 0; i < prefix; i++)
        if(arr[i] <= level)
            ans--;
    return ans;
}

int main() {
    int32_t n;
    std::cin >> n;

    arr = new int32_t[n];
    for(int32_t i = 0; i < n; i++)
        std::cin >> arr[i];

    int32_t num_q;
    std::cin >> num_q;

    for(int32_t q = 0; q < num_q; q++) {
        int32_t r1, c1, r2, c2;
        std::cin >> r1 >> c1 >> r2 >> c2;

        int32_t left = -1, right = n;
        while(right - left > 1) {
            int32_t m = (left + right) / 2;

            if(position_on_level(m, r1) > c1)
                left = m;
            else
                right = m;
        }
        int32_t v1 = right;

        left = -1, right = n;
        while(right - left > 1) {
            int32_t m = (left + right) / 2;

            if(position_on_level(m, r2) > c2)
                left = m;
            else
                right = m;
        }
        int32_t v2 = right;
        if(v1 > v2)
            std::swap(v1, v2);
        if(v1 == v2 || position_on_level(v2, (r1 < r2 ? c1 : c2)) == (r1 < r2 ? c1 : c2)) {
            std::cout << (r1 < r2 ? r1 : r2) << " " << (r1 < r2 ? c1 : c2) << "\n";
            continue;
        }

        int32_t high_update = n + 100;
        for(int32_t i = v1 + 1; i <= v2; i++)
            high_update = std::min(high_update, arr[i - 1]);
        int32_t ans_level = high_update - 1;
        std::cout << ans_level << " " << position_on_level(v1, ans_level) << "\n";
    }
    return 0;
}
