#pragma GCC optimize("O3")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4.1,sse4.2,avx,avx2")

#include <bits/stdc++.h>

#define mp std::make_pair
using ll = long long;
using pii = std::pair<int, int>;
#define all(a) a.begin(), a.end()

template<class T, class T1>
bool mx(T &a, const T1 &b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

template<class T, class T1>
bool mn(T &a, const T1 &b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

const int MAXN = 1e5 + 228;
std::vector<int> tree[4 * MAXN];
int a[MAXN];

void buildTree(int v, int l, int r) {
    if (l == r) {
        tree[v].push_back(a[l]);
        return;
    }
    int mid = (l + r) / 2;
    buildTree(2 * v, l, mid);
    buildTree(2 * v + 1, mid + 1, r);
    tree[v].resize(tree[2 * v].size() + tree[2 * v + 1].size());
    std::merge(all(tree[2 * v]), all(tree[2 * v + 1]), tree[v].begin());
}

int getCnt(int v, int val) {
    return std::upper_bound(all(tree[v]), val) - tree[v].begin();
}

int getCnt(int v, int l, int r, int val, int ll, int rr) {
    if (r < ll || rr < l) {
        return 0;
    }
    if (l <= ll && rr <= r) {
        return getCnt(v, val);
    }
    int mid = (ll + rr) / 2;
    return getCnt(2 * v, l, r, val, ll, mid) + getCnt(2 * v + 1, l, r, val, mid + 1, rr);
}

int n;

int getColumn(int r, int time) {
    if (time == 0) return r;
    return r - getCnt(1, 0, time - 1, r, 0, n - 1);
}

int getTime(int r, int c) {
    if (r == c) {
        return 0;
    }
    int left = -1, right = n + 1;
    while (right - left > 1) {
        int mid = (left + right) / 2;
        if (getColumn(r, mid) < c) {
            right = mid;
        } else {
            left = mid;
        }
    }
    return left;
}

void solve() {
    std::cin >> n;
    for (int i = 0; i < n; i++) {
        std::cin >> a[i];
    }
    buildTree(1, 0, n - 1);

    int q;
    std::cin >> q;
    while (q--) {
        int r1, c1, r2, c2;
        std::cin >> r1 >> c1 >> r2 >> c2;
        int t1 = getTime(r1, c1);
        int t2 = getTime(r2, c2);

        int l = 0, r = std::min(r1, r2) + 1;
        while (r - l > 1) {
            int mid = (l + r) / 2;
            int a1 = getColumn(mid, t1);
            int a2 = getColumn(mid, t2);
            if (a1 == a2) l = mid;
            else r = mid;
        }
        std::cout << l << ' ' << getColumn(l, t1) << '\n';
    }
}

signed main() {
    int TESTS = 1;
//    std::cin >> TESTS;
    while (TESTS--) {
        solve();
    }
}
