#pragma GCC optimize("O3,unroll-loops,fast-math")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4.1,sse4.2,avx,avx2")

#include <bits/stdc++.h>

#define mp std::make_pair
using ll = long long;
using pii = std::pair<int, int>;

template<class T, class T1>
bool mx(T &a, const T1 &b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

template<class T, class T1>
bool mn(T &a, const T1 &b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

const int MAXH = 3005;
const int MAXN = MAXH * MAXH;
const int MAXK = 14;

int binUp[MAXK][MAXN];
int h[MAXN];

int convert(int i, int j) {
    return i * MAXH + j;
}

pii convert(int pos) {
    return mp(pos / MAXH, pos % MAXH);
}

int get(int a, int b) {
    for (int k = MAXK - 1; k >= 0; k--) {
        if (h[binUp[k][a]] >= h[b]) {
            a = binUp[k][a];
        }
    }
    for (int k = MAXK - 1; k >= 0; k--) {
        if (h[binUp[k][b]] >= h[a]) {
            b = binUp[k][b];
        }
    }
    for (int k = MAXK - 1; k >= 0; k--) {
        if (binUp[k][a] != binUp[k][b]) {
            a = binUp[k][a], b = binUp[k][b];
        }
    }
    if (a == b) return a;
    assert(binUp[0][a] == binUp[0][b]);
    return binUp[0][a];
}

void set(std::vector<int> &com) {
    int r = 0, c = 0;
    int he = 0;
    for (auto &i : com) {
        he++;
        int nr = r + 1, nc = c + i;
        h[convert(nr, nc)] = he;
        binUp[0][convert(nr, nc)] = convert(r, c);
        r = nr, c = nc;
    }
}

void solve() {
    int n;
    std::cin >> n;
    std::vector<int> com(n, 1);
    set(com);
    for (int i = 0; i < n; i++) {
        int pos;
        std::cin >> pos;
        pos--;
        com[pos] = 0;
        set(com);
    }
    for (int k = 1; k < MAXK; k++) {
        for (int i = 0; i < MAXN; i++) {
            binUp[k][i] = binUp[k - 1][binUp[k - 1][i]];
        }
    }
    int q;
    std::cin >> q;
    while (q--) {
        int r1, c1, r2, c2;
        std::cin >> r1 >> c1 >> r2 >> c2;
        if (c1 == c2) {
            std::cout << std::min(r1, r2) << ' ' << c2 << '\n';
            continue;
        }
        if (r1 == c1 && r2 == c2) {
            std::cout << std::min(r1, r2) << ' ' << std::min(c1, c2) << '\n';
            continue;
        }
        int ur1 = c1, ur2 = c2;
        std::cout << std::min(ur1, ur2) << ' ' << std::min(ur1, ur2) << '\n';
    }
}

signed main() {
    int TESTS = 1;
//    std::cin >> TESTS;
    while (TESTS--) {
        solve();
    }
}
