#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>
#include <set>

#define all(x) x.begin(), x.end()

using namespace std;
using ll = long long;

const int MAXN = 100'000;
const int INF = (int)1e9;

void solve1()
{
	int n = 0, w = 0, h = 0;
	cin >> n >> w >> h;

	vector<pair<int, int>> p(n);
	for (int i = 0; i < n; ++i)
	{
		cin >> p[i].first >> p[i].second;
	}

	sort(all(p), [&](const pair<int, int>& a, const pair<int, int>& b) {
		return make_pair(a.second, -a.first) > make_pair(b.second, -b.first);
		});

	vector<pair<int, int>> st;
	for (auto [x, y] : p)
	{
		while (!st.empty() && x < st.back().first)
			st.pop_back();
		st.emplace_back(x, y);
	}

	ll res = 0;
	int prevY = h;
	for (auto [x, y] : st)
	{
		res += max(0ll, ((ll)prevY - (ll)y) * ((ll)w - x));
		prevY = y;
	}
	cout << res << "\n";
}

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int k = 0, t = 0;
	cin >> k;

	vector<int> dir(k);
	for (int i = 0; i < k; ++i)
		cin >> dir[i];

	cin >> t;
	while (t--)
	{
		solve1();
	}



	return 0;
}
