#include <vector>
#include <cassert>
#include <iomanip>
#include <iostream>
#include <algorithm>

using namespace std;

int main() {
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else
  ios::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
#endif

  int n;
  cin >> n;
  vector<int> A(n);
  for (int i = 0; i < n; ++i) {
    cin >> A[i];
    --A[i];
  }
  int q;
  cin >> q;
  while (q--) {
    int r1, c1, r2, c2;
    cin >> r1 >> c1 >> r2 >> c2;
    if (r1 == c1 && r2 == c2) {
      cout << r1 << ' ' << c1 << '\n';
      continue;
    }
    if (c1 < c2 || (c1 == c2 && r1 > r2)) {
      swap(c1, c2);
      swap(r1, r2);
    }
    int i1 = 0;
    int kek = 0;
    while (i1 < n && kek + int(A[i1] < r1) <= r1 - c1) {
      kek += A[i1] < r1;
      ++i1;
    }
    int i2 = 0;
    kek = 0;
    while (i2 < n && kek + int(A[i2] < r2) <= r2 - c2 - 1) {
      kek += A[i2] < r2;
      ++i2;
    }
    if (i1 > i2) {
      cout << r2 << ' ' << c2 << '\n';
    } else {
      assert(i1 <= i2);
      int j = A[i1];
      for (int l = i1 + 1; l <= i2; ++l)
        j = min(j, A[l]);
      int kk = j;
      for (int i = 0; i < n; ++i) {
        if (A[i] == j)
          break;
        kk -= A[i] < j;
      }
      cout << j << ' ' << kk << '\n';
    }
  }
  return 0;
}
