#include <vector>
#include <cassert>
#include <iomanip>
#include <iostream>
#include <algorithm>

using namespace std;

int main() {
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else
  ios::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
#endif

  int k;
  cin >> k;
  vector<int> dir(k);
  for (int i = 0; i < k; ++i)
    cin >> dir[i];
  int t;
  cin >> t;
  while (t--) {
    int n, w, h;
    cin >> n >> w >> h;
    vector<pair<int, int>> P(n);
    for (int i = 0; i < n; ++i)
      cin >> P[i].first >> P[i].second;
    if (k == 1) {
      sort(P.begin(), P.end());
      vector<pair<int, int>> stack;
      for (auto t : P) {
        if (!stack.empty() && stack.back().second <= t.second)
          continue;
        stack.emplace_back(t);
      }
      long long ans = 0;
      long long pr = h;
      for (auto t : stack) {
        ans += (w - t.first) * 1ll * (pr - t.second);
        pr = t.second;
      }
      cout << ans << '\n';
    } else if (k == 4) {
      if (n >= 4) {
        cout << w * 1ll * h << '\n';
      } else {
        long long ans = 0;
        for (int mask = 0; mask < (1 << (2 * n)); ++mask) {
          vector<pair<pair<int, int>, pair<int, int>>> rect(n);
          for (int i = 0; i < n; ++i) {
            int dir = (mask >> (2 * i)) & 3;
            if (dir == 0)
              rect[i] = make_pair(make_pair(P[i].first, w), make_pair(P[i].second, h));
            else if (dir == 1)
              rect[i] = make_pair(make_pair(0, P[i].first), make_pair(P[i].second, h));
            else if (dir == 2)
              rect[i] = make_pair(make_pair(0, P[i].first), make_pair(0, P[i].second));
            else
              rect[i] = make_pair(make_pair(P[i].first, w), make_pair(0, P[i].second));
          }
          long long rect_union = 0;
          for (int m = 1; m < (1 << n); ++m) {
            int x1 = 0, x2 = w, y1 = 0, y2 = h;
            for (int i = 0; i < n; ++i) {
              if (m & (1 << i)) {
                x1 = max(x1, rect[i].first.first);
                x2 = min(x2, rect[i].first.second);
                y1 = max(y1, rect[i].second.first);
                y2 = min(y2, rect[i].second.second);
              }
            }
            long long S = max(x2 - x1, 0) * 1ll * max(y2 - y1, 0);
            if (__builtin_popcount(m) % 2)
              rect_union += S;
            else
              rect_union -= S;
          }
          ans = max(ans, rect_union);
        }
        cout << ans << '\n';
      }
    }
  }
  return 0;
}
