#include <vector>
#include <cassert>
#include <iomanip>
#include <iostream>
#include <algorithm>

using namespace std;

long long solve2(vector<pair<int, int>> P, int x1, int y1, int x2, int y2) {
  //P is sorted by y
  if (P.empty())
    return 0;
  if (P.size() > 1 && P[1].second == P[0].second)
    return (x2 - x1) * 1ll * (y2 - P[0].second);
  int x = P[0].first, y = P[0].second;
  if (P.size() == 1)
    return max(x - x1, x2 - x) * 1ll * (y2 - y);
  int i = 1;
  bool has_left = false, has_right = false, has_same = false;
  while (i < P.size() && P[i].second == P[1].second) {
    if (P[i].first < x)
      has_left = true;
    else if (P[i].first == x)
      has_same = true;
    else
      has_right = true;
    ++i;
  }
  if (int(has_left) + int(has_right) + int(has_same) >= 2)
    return (x2 - x1) * 1ll * (y2 - P[1].second) + max(x - x1, x2 - x) * 1ll * (P[1].second - y);
  if (has_left) {
    long long ans_var = (x - x1) * 1ll * (y2 - y) + (x2 - x) * 1ll * (y2 - P[1].second);
    vector<pair<int, int>> Q;
    int new_y = y2;
    for (int i = 1; i < P.size(); ++i) {
      if (P[i].first <= x)
        Q.emplace_back(P[i]);
      else
        new_y = min(new_y, P[i].second);
    }
    while (Q.back().second > new_y)
      Q.pop_back();
    return max(ans_var, (x2 - x) * 1ll * (y2 - y) + (x - x1) * 1ll * (y2 - new_y) + solve2(Q, x1, y1, x, new_y));
  } else {
    long long ans_var = (x2 - x) * 1ll * (y2 - y) + (x - x1) * 1ll * (y2 - P[1].second);
    vector<pair<int, int>> Q;
    int new_y = y2;
    for (int i = 1; i < P.size(); ++i) {
      if (P[i].first >= x)
        Q.emplace_back(P[i]);
      else
        new_y = min(new_y, P[i].second);
    }
    while (Q.back().second > new_y)
      Q.pop_back();
    return max(ans_var, (x - x1) * 1ll * (y2 - y) + (x2 - x) * 1ll * (y2 - new_y) + solve2(Q, x, y1, x2, new_y));
  }
}

int main() {
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else
  ios::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
#endif

  int k;
  cin >> k;
  vector<int> dir(k);
  for (int i = 0; i < k; ++i)
    cin >> dir[i];
  int t;
  cin >> t;
  while (t--) {
    int n, w, h;
    cin >> n >> w >> h;
    vector<pair<int, int>> P(n);
    for (int i = 0; i < n; ++i)
      cin >> P[i].first >> P[i].second;
    if (k == 1) {
      sort(P.begin(), P.end());
      vector<pair<int, int>> stack;
      for (auto t : P) {
        if (!stack.empty() && stack.back().second <= t.second)
          continue;
        stack.emplace_back(t);
      }
      long long ans = 0;
      long long pr = h;
      for (auto t : stack) {
        ans += (w - t.first) * 1ll * (pr - t.second);
        pr = t.second;
      }
      cout << ans << '\n';
    } else if (k == 4) {
      if (n >= 4) {
        cout << w * 1ll * h << '\n';
      } else {
        long long ans = 0;
        for (int mask = 0; mask < (1 << (2 * n)); ++mask) {
          vector<pair<pair<int, int>, pair<int, int>>> rect(n);
          for (int i = 0; i < n; ++i) {
            int dir = (mask >> (2 * i)) & 3;
            if (dir == 0)
              rect[i] = make_pair(make_pair(P[i].first, w), make_pair(P[i].second, h));
            else if (dir == 1)
              rect[i] = make_pair(make_pair(0, P[i].first), make_pair(P[i].second, h));
            else if (dir == 2)
              rect[i] = make_pair(make_pair(0, P[i].first), make_pair(0, P[i].second));
            else
              rect[i] = make_pair(make_pair(P[i].first, w), make_pair(0, P[i].second));
          }
          long long rect_union = 0;
          for (int m = 1; m < (1 << n); ++m) {
            int x1 = 0, x2 = w, y1 = 0, y2 = h;
            for (int i = 0; i < n; ++i) {
              if (m & (1 << i)) {
                x1 = max(x1, rect[i].first.first);
                x2 = min(x2, rect[i].first.second);
                y1 = max(y1, rect[i].second.first);
                y2 = min(y2, rect[i].second.second);
              }
            }
            long long S = max(x2 - x1, 0) * 1ll * max(y2 - y1, 0);
            if (__builtin_popcount(m) % 2)
              rect_union += S;
            else
              rect_union -= S;
          }
          ans = max(ans, rect_union);
        }
        cout << ans << '\n';
      }
    } else if (k == 2) {
      sort(P.begin(), P.end(), [](pair<int, int> a, pair<int, int> b) {
        return a.second < b.second;
      });
      cout << solve2(P, 0, 0, w, h) << '\n';
    }
  }
  return 0;
}
