#include <bits/stdc++.h>

#define F first
#define S second

using namespace std;
using ll = long long;
using vi = vector<int>;
using pi = pair<int, int>;

template<class T> bool ckmin(T& a, const T& b) { return b < a ? a = b, true : false; }
template<class T> bool ckmax(T& a, const T& b) { return a < b ? a = b, true : false; }

template<class T> using pq_min = priority_queue<T, vector<T>, greater<T>>;

const int N = 1e5+7;

int n, c[N], l[N], r[N], b[N], ok;
vector<int> g[N];
ll ans = 0;

struct cmp {
    bool operator () (const int i, const int j) const {
        return c[i] != c[j] ? c[i] < c[j] : i < j;
    }
};

struct CutSet {
    map<int, ll, cmp> s;
    ll sum;

    CutSet() : s(), sum(0) { }

    void insert(int i, int k) {
        s[i] += k;
        sum += k;
    }

    void cut(int r) {
        while (sum > r) {
            auto [c, k] = *prev(s.end());
            if (k > sum - r) {
                s[c] -= sum - r;
                sum = r;
            } else {
                sum -= k;
                s.erase(c);
            }
        }
    }

    void clear() {
        sum = 0;
        s.clear();
    }

    void merge(CutSet& x) {
        sum += x.sum;
        if (s.size() < x.s.size()) s.swap(x.s);
        for (auto [c, k] : x.s) s[c] += k;
    }

    bool get(int k) {
        if (sum < k) return false;

        while (k > 0) {
            auto [j, t] = *s.begin();

            if (t > k) {
                s[j] -= k;
                sum -= k;
                b[j] += k;
                ans += (ll) c[j] * k;
                k = 0;
            } else {
                b[j] += t;
                k -= t;
                sum -= t;
                ans += (ll) c[j] * t;
                s.erase(j);
            }
        }

        return true;
    }

    friend ostream& operator << (ostream& os, const CutSet& cs) {
        os << "{";

        bool first = true;
        for (auto [c, k] : cs.s) {
            if (!first) os << ", ";
            first = false;
            os << c+1 << ":" << k;
        }
        os << "}";

        return os;
    }
} cs[N];

ll dfs(int v) {
    ll cnt = 0;

    for (int to : g[v]) {
        cnt += dfs(to);
        if (!ok) return 0;
        cs[v].merge(cs[to]);
    }

    cs[v].insert(v, numeric_limits<int>::max());

    if (r[v] >= cnt) {
        cs[v].cut(r[v] - cnt);
    } else {
        ok = 0;
    }

    if (cnt < l[v]) {
        bool res = cs[v].get(l[v] - cnt);
        if (!res) ok = 0;
        cnt = l[v];
    }

    if (cnt > r[v]) ok = 0;
    return cnt;
}

void solve() {
    cin >> n;
    for (int i = n; i--; ) {
        g[i].clear();
        cs[i].clear();
        c[i] = l[i] = r[i] = b[i] = 0;
    }
    ok = 1;
    ans = 0;
    for (int i = 1; i < n; ++i) {
        int p; cin >> p;
        g[p-1].push_back(i);
    }

    for (int i = 0; i < n; ++i) cin >> c[i];
    for (int i = 0; i < n; ++i) cin >> l[i] >> r[i];

    dfs(0);

    if (ok) {
        cout << ans << '\n';
        for (int i = 0; i < n; ++i) cout << b[i] << ' ';
        cout << '\n';
    } else {
        cout << -1 << '\n';
    }
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);

    int t = 1;
    cin >> t;
    while (t--) solve();
}