#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double
#define sz(x) (int)x.size()
#define ckmin(a, b) a = min(a, b)
#define ckmax(a, b) a = max(a, b)
#define int long long
#define pii pair<int, int>
#define fi first
#define se second

const int inf = 2e9;

struct Tree {
    vector<int> t, upd;
    int n;

    void init(int N) {
        n = N;
        t.clear();
        upd.clear();
        t.resize(4 * n, 0);
        upd.resize(4 * n, 0);
    }

    Tree() {}

    void push(int v) {
        t[v] += upd[v];
        upd[v * 2] += upd[v];
        upd[v * 2 + 1] += upd[v];
        upd[v] = 0;
    }

    int get_point(int v) {
        return t[v] + upd[v];
    }

    void upd_point(int v) {
        t[v] = min(get_point(v * 2), get_point(v * 2 + 1));
    }

    void modify(int v, int tl, int tr, int l, int r, int x) {
        if (tl > r || l > tr)
            return;
        if (l <= tl && tr <= r) {
            upd[v] += x;
        } else {
            int tm = (tl + tr) / 2;
            push(v);

            modify(v * 2, tl, tm, l, r, x);
            modify(v * 2 + 1, tm + 1, tr, l, r, x);

            upd_point(v);
        }
    }

    void modify(int l, int r, int x) {
        modify(1, 0, n - 1, l, r, x);
    }

    int get_min(int v, int tl, int tr, int l, int r) {
        if (tl > r || l > tr)
            return inf;
        if (l <= tl && tr <= r)
            return get_point(v);

        int tm = (tl + tr) / 2;
        push(v);

        int res = min(get_min(v * 2, tl, tm, l, r), get_min(v * 2 + 1, tm + 1, tr, l, r));

        upd_point(v);
        return res;
    }

    int get_min(int l, int r) {
        return get_min(1, 0, n - 1, l, r);
    }
};

int n;
vector<vector<int>> g;
vector<set<pii>> st;
vector<int> c, l, r, tk, par, siz, top, eu_id, euler;
vector<bool> bad;
Tree tree;


int res = 0;

void setBad(int v) {
    bad[v] = true;
    for (int u: g[v]) {
        if (!bad[u])
            setBad(u);
    }
}

int calcCap(int u) {

    int mn = inf;

    while (u != -1) {
        int mnp = tree.get_min(eu_id[top[u]], eu_id[u]);
        ckmin(mn, mnp);
        u = par[top[u]];
    }
//    int mn = inf;
//    while (u != -1) {
//        ckmin(mn, r[u] - a[u]);
//        u = par[u];
//    }
//    return mn;
    return mn;
}

void take(int u, int d) {
    res += d * c[u];
    tk[u] += d;
    while (u != -1) {
        tree.modify(eu_id[top[u]], eu_id[u], -d);
        u = par[top[u]];
    }
}

void dfs1(int v) {
    for (int u: g[v]) {
        par[u] = v;
        dfs1(u);
    }
}

void merget(set<pii > &s1, set<pii > &s2) {
    if (sz(s1) < sz(s2))
        swap(s1, s2);

    for (auto i: s2)
        s1.insert(i);
}

void dfs(int v) {
    for (int u: g[v]) {
        dfs(u);
        merget(st[v], st[u]);
    }

    st[v].insert({c[v], v});

    int av = r[v] - tree.get_min(eu_id[v], eu_id[v]);

    while (av < l[v] && !st[v].empty()) {
        auto t = *st[v].begin();
        int u = t.se;
        st[v].erase(t);
        int need = min(l[v] - av, calcCap(u));
        take(u, need);
        av += need;
        if (av == l[v]) {
            st[v].insert(t);
        }
    }
}

void clear() {
    g.clear();
    c.clear();
    l.clear();
    r.clear();
    st.clear();
    tk.clear();
    par.clear();
    bad.clear();
    siz.clear();
    top.clear();
    eu_id.clear();
    euler.clear();
    res = 0;
}

void hld(int v) {
    eu_id[v] = sz(euler);
    euler.push_back(v);

    siz[v] = 1;
    if (g[v].empty())
        return;

    int b = 0;
    for (int id = 0; id < sz(g[v]); ++id) {
        int u = g[v][id];
        if (siz[u] > siz[g[v][b]])
            b = id;
        siz[v] += siz[u];
    }

    swap(g[v][0], g[v][b]);
    top[g[v][0]] = top[v];
    hld(g[v][0]);

    for (int id = 1; id < sz(g[v]); ++id) {
        int u = g[v][id];
        top[u] = u;
        hld(u);
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t;
    cin >> t;
    while (t--) {
        clear();
        cin >> n;
        bad.resize(n);
        g.resize(n);
        c.resize(n);
        l.resize(n);
        r.resize(n);
        st.resize(n);
        tk.resize(n);
        siz.resize(n);
        par.resize(n, -1);
        eu_id.resize(n);
        top.resize(n);


        for (int i = 1; i < n; ++i) {
            int p;
            cin >> p;
            g[--p].push_back(i);
        };

        for (int i = 0; i < n; ++i)
            cin >> c[i];

        for (int i = 0; i < n; ++i)
            cin >> l[i] >> r[i];

        hld(0);
        tree.init(n);
        for (int i = 0; i < n; ++i)
            tree.modify(eu_id[i], eu_id[i], r[i]);

        dfs1(0);
        dfs(0);

        bool f = true;
        for (int i = 0; i < n; ++i){
            int tv = tree.get_min(eu_id[i], eu_id[i]);
            if(r[i] - tv < l[i] || r[i] - tv > r[i])
                f = false;
        }


        if (f) {
            cout << res << '\n';
            for (int i: tk)
                cout << i << " ";
            cout << '\n';
        } else {
            cout << "-1\n";
        }
    }
}