#include <bits/stdc++.h>

using namespace std;

const int MAXN = 1e5 + 10;

using ll = long long;

int n;
bool fail = false;
vector<int> g[MAXN];
vector<ll> l(MAXN), r(MAXN), c(MAXN);

struct cmp {
    bool operator()(const pair<ll, ll> &a, const pair<ll, ll> &b) const {
        return c[a.first] < c[b.first];
    }
};

priority_queue<pair<ll, ll>, vector<pair<ll, ll>>, cmp> k[MAXN];
vector<ll> b(MAXN), ansb(MAXN), cost(MAXN);

void dfs(int v) {
    for (int u: g[v]) {
        dfs(u);

        if (fail) {
            return;
        }

        b[v] += b[u];
        cost[v] += cost[u];

        ll cnt = 0;
        while (!k[u].empty()) {
            auto it = k[u].top();
            k[u].pop();
            ll cur = min(it.second, r[u] - b[u] - cnt);
            if (cur <= 0) {
                break;
            }
            k[v].push({it.first, cur});
            cnt += cur;
        }
    }

    if (b[v] > r[v]) {
        fail = true;
        return;
    }

    k[v].push({v, r[v] - b[v]});
    while (b[v] < l[v]) {
        auto it = k[v].top();
        ll cnt = min(l[v] - b[v], it.second);
        cost[v] += c[it.first] * cnt;
        b[v] += cnt;
        ansb[it.first] += cnt;

        k[v].pop();
        if (it.second - cnt > 0) {
            k[v].push({it.first, it.second - cnt});
        }

    }
}


int32_t main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);

    int t;
    cin >> t;

    while (t--) {
        cin >> n;

        fail = false;
        for (int i = 0; i < n; i++) {
            g[i].clear();
            while (!k[i].empty()) {
                k[i].pop();
            }
            b[i] = 0;
            ansb[i] = 0;
            cost[i] = 0;
            c[i] = 0;
            l[i] = 0;
            r[i] = 0;
        }

        for (int i = 1; i < n; i++) {
            int p;
            cin >> p;

            g[p - 1].push_back(i);
        }

        for (int i = 0; i < n; i++) {
            cin >> c[i];
        }

        for (int i = 0; i < n; i++) {
            cin >> l[i] >> r[i];
        }

        dfs(0);
        if (fail) {
            cout << -1 << endl;
        } else {
            cout << cost[0] << endl;
            for (int i = 0; i < n; i++) {
                cout << ansb[i] << " ";
            }
            cout << endl;
        }
    }

    return 0;
}