﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <fstream>
#include <string>
#include <map>
#include <set>
#include <climits>
using namespace std;
using s64 = long long;
#define all(obj) obj.begin(), obj.end()

vector<vector<bool>> parent_left, parent_right;

int n;

void add_path(int r, int c, int i, vector<bool>& oop) {
	if (i != n) {
		if (oop[i]) { // right
			parent_right[r + 1][c + 1] = true;
			add_path(r + 1, c + 1, i + 1, oop);
		}
		else { // left
			parent_left[r + 1][c] = true;
			add_path(r + 1, c, i + 1, oop);
		}
	}
}

void solve(istream& cin) {
	{
		cin >> n;
		parent_left.assign(n + 1, vector<bool>(n + 1));
		parent_right.assign(n + 1, vector<bool>(n + 1));
		vector<bool> oop(n, true);
		add_path(0, 0, 0, oop);
		for (int i = 0; i < n; i++) {
			int a;
			cin >> a;
			a--;
			oop[a] = !oop[a];
			add_path(0, 0, 0, oop);
		}
	}

	int q;
	cin >> q;
	while (q--) {
		int r1, c1, r2, c2;
		cin >> r1 >> c1 >> r2 >> c2;
		while (!(r1 == r2 && c1 == c2)) {
			if (r1 < r2) {
				swap(r1, r2);
				swap(c1, c2);
			}
			// (r1, c1) -> parent

			if (c1 < c2 && parent_left[r1][c1]) {
				r1--;
			}
			else if(parent_right[r1][c1]) {
				r1--;
				c1--;
			}
			else {
				r1--;
			}
		}

		cout << r1 << " " << c1 << "\n";
	}
}

int main() {
	//ifstream cin("input.txt");
	
	int t = 1;
	//cin >> t;
	while (t--) {
		solve(cin);
	}

	return 0;
}