#include <iostream>
#include <vector>
#include <algorithm>
#include <tuple>

using namespace std;

typedef long long ll;

int find_idx(const vector<int> &commands, int r, int c) {
    int current_pos = r;

    if (c == r) return -1;

    if (commands.size() > 3000) return r - c - 1;

    for (int i = 0; i < commands.size(); ++i) {
        if (commands[i] < r) current_pos -= 1;
        if (c == current_pos) return i;
    }

    abort();
}

//pair<int ,int> solve(const vector<int> &commands, int r1, int c1, int r2, int c2) {
//    int current_pos1 = 0;
//    int current_pos2 = 0;
//
//    bool init = false;
//
//    int idx1 = -2, idx2 = -2;
//
//    if (c1 == 0) {
//        idx1 = -1;
//        init = true;
//    }
//    if (c2 == 0) {
//        idx2 = -1;
//        if (init) return {max(r1, r2), 0};
//        else {
//            swap(r1, r2);
//            swap(c1, c2);
//            swap(idx1, idx2);
//            init = true;
//        }
//    }
//
//    for (int i = 0; i < commands.size(); ++i) {
//        if (!init && commands[i] < r1) current_pos1 += 1;
//        if (commands[i] < r2) current_pos2 += 1;
//
//        if (!init && c1 == current_pos1) {
//            init = true;
//        }
//
//        if (c2 == current_pos2) {
//            if (!init) {
//                swap(r1, r2);
//                swap(c1, c2);
//                swap(idx1, idx2);
//                swap(current_pos1, current_pos2);
//                init = true;
//            } else {
//
//            }
//        }
//    }
//}

int log2(int n, int acc = 0) {
    return (n <= 1) ? acc : log2(n / 2, acc + 1);
}

struct MinTable {
    vector<vector<pair<int, int>>> table;

    explicit MinTable(const vector<int> &vec) : table(vector<vector<pair<int, int>>>(log2(vec.size()) + 1)) {
        table[0].resize(vec.size());
        for (int i = 0; i < vec.size(); ++i) {
            table[0][i] = {vec[i], i};
        }

        for (int i = 1; i < table.size(); ++i) {
            int size = 1 << i;
            table[i].resize(vec.size() - size + 1);
            for (int j = 0; j < table[i].size(); ++j) {
                table[i][j] = min(table[i - 1][j], table[i - 1][j + size / 2]);
            }
        }
    }

    pair<int, int> get_min(int l, int r) {
        int len = r - l + 1;
        int len_log = log2(len);
        return min(table[len_log][l], table[len_log][r - (1 << len_log) + 1]);
    }
};

int main() {
    int n;
    cin >> n;

    vector<int> commands(n);
    for (auto &c: commands) {
        cin >> c;
        c -= 1;
    }

    MinTable table(commands);

    int q;
    cin >> q;

    for (int i = 0; i < q; ++i) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;

        int idx1 = find_idx(commands, r1, c1),
                idx2 = find_idx(commands, r2, c2);

        if (idx1 == idx2) {
            if (r1 > r2) cout << r2  << " " << c2 << "\n";
            else cout << r1  << " " << c1 << "\n";

            continue;
        }

        if (idx1 > idx2) swap(idx1, idx2);

        auto command = table.get_min(idx1 + 1, idx2);

        int c = command.first;

        for (int j = 0; j < command.second; ++j) {
            if (commands[j] < command.first) c -= 1;
        }

        cout << command.first << " " << c << "\n";
    }

    cout.flush();

    return 0;
}
