#include<bits/stdc++.h>
using namespace std;

//#define int long long
#define siz(a) (int)a.size()
#define all(a) a.begin(), a.end()
#define eb emplace_back
#define pii pair<int, int>
#define mp make_pair
#define fi first
#define se second

const int N = (1 << 20), log_n = 20;
int n;
int com[N];
vector<pii> ver;
int par[N], anc[log_n][N], tin[N], tout[N], T = 0;
vector<int> gr[N];

vector<int> ST[2*N];

void build_ST() {
	for (int i = 0; i < n; ++i)
		ST[i+N].eb(com[i]);
	for (int i = N-1; i; --i) {
		int p1 = i*2, p2 = i*2+1;
		int i1 = 0, i2 = 0;

		while (i1 < siz(ST[p1]) || i2 < siz(ST[p2])) {
			if (i1 < siz(ST[p1]) && (i2 == siz(ST[p2]) || ST[p1][i1] < ST[p2][i2]))
				ST[i].eb(ST[p1][i1++]);
			else 
				ST[i].eb(ST[p2][i2++]);
		}
	}
}

pii model(int id, int cnt) {
	int l = N, r = N+id;

	int a = cnt, b = cnt;
	for (; l < r; l >>= 1, r >>= 1) {
		if (l & 1) {
			b -= lower_bound(all(ST[l]), cnt) - ST[l].begin();
			++l;
		}
		if (r & 1) {
			--r;
			b -= lower_bound(all(ST[r]), cnt) - ST[r].begin();
		}
	}
	return {a, b};
}

int binpow(int r, int c) {
	int le = -1, ri = n;
	while (ri - le > 1) {
		int m = (le + ri) / 2;
		auto v = model(m, r);
		if (v.se > c) le = m;
		else ri = m;
	}
	return ri;
}

int sonny(int r, int c) {
	int t = binpow(r, c);
	int v = 2*t + 1;
	while (ver[par[v]].fi >= r) v = par[v]; 
	return v;
}


void dfs(int v) {
	tin[v] = T++;
	anc[0][v] = par[v];
	for (int i = 1; i < log_n; ++i)
		anc[i][v] = anc[i-1][anc[i-1][v]];

	for (int to : gr[v])
		dfs(to);

	tout[v] = T++;
}

bool ispar(int v, int u) { return tin[v] <= tin[u] && tout[v] >= tout[u]; }

int lca(int v1, int v2) {
	for (int k = log_n - 1; k >= 0; --k) {
		if (!ispar(anc[k][v1], v2)) v1 = anc[k][v1];
		if (!ispar(anc[k][v2], v1)) v2 = anc[k][v2];
	}
	if (ispar(v1, v2)) return v1;
	return par[v1];
}

void run() {
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> com[i]; --com[i];
	}
	build_ST();


	ver.eb(-1, -1);
	ver.eb(n, n);
	par[1] = 0;

	int lst = 1;

	for (int i = 0; i < n; ++i) {
		pii v = model(i+1, com[i]);

		while (ver[par[lst]].fi > v.fi) lst = par[lst];

		int nid = siz(ver);
		
		ver.eb(v);
		par[nid] = par[lst];
		par[lst] = nid;
		lst = nid;
		
		nid = siz(ver);

		par[nid] = lst;
		ver.eb(model(i+1, n));
		lst = nid;
	}

	for (int i = 1; i < siz(ver); ++i)
		gr[par[i]].eb(i);
	dfs(0);

	int q; cin >> q;
	while (q--) {
		int r1, c1, r2, c2; cin >> r1 >> c1 >> r2 >> c2;
		int v1 = sonny(r1, c1), v2 = sonny(r2, c2);

		int l = lca(v1, v2);

		if (l == v1 || l == v2) {
			if (r1 < r2) cout << r1 << " " << c1 << '\n';
			else cout << r2 << " " << c2 << '\n';
		} else {
			cout << ver[l].fi << " " << ver[l].se << '\n';
		}
	}
}

signed main() {
	cin.tie(0), cout.tie(0), ios_base::sync_with_stdio(0);

	int t = 1;
	while (t--) {
		run();	
	}
}