#include <iostream>
#include <vector>
#include <algorithm>
#define ll long long
#define all(x) x.begin(),x.end()
#define fi first
#define se second
//#pragma GCC target("avx2")
//#pragma GCC optimize("O3")
using namespace std;
vector<int> a, dir;
int n, q;
vector<pair<char,char>> g[3010];
vector<int> tin[3010], tout[3010];
int gtime = 0;

void dfs (int ui, int uj) {
    tin[ui][uj] = ++gtime;
    if (g[ui][uj].fi) {
        dfs(ui + 1, uj);
    }
    if (g[ui][uj].se) {
        dfs(ui + 1, uj + 1);
    }
    tout[ui][uj] = ++gtime;
}

bool isAnc (int ui, int uj, int vi, int vj) {
    return (tin[ui][uj] <= tin[vi][vj]) && (tout[ui][uj] >= tout[vi][vj]);
}
void solve1 () {
    for (int i = 0; i <= n; ++i) {
        tin[i].resize(i + 1);
        tout[i].resize(i + 1);
        g[i].resize(i + 1, {0, 0});
    }
    vector<pair<int,int>> b;
    dir.resize(n + 1, 0);
    for (int i = 1; i <= n + 1; ++i) {
        int ci = 0, cj = 0;
        for (int j = 1; j <= n; ++j) {
            if (dir[j] == 0) {
                g[ci][cj].se = 1;
                ++cj;
            } else {
                g[ci][cj].fi = 1;
            }
            ++ci;
        }
        if (i <= n)
            dir[a[i]] = 1;
    }
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j <= i; ++j) {
            if ((g[i][j].fi == 1) && (g[i][j].se == 1))
                b.emplace_back(i, j);
        }
    }
    dfs(0, 0);
    for (int _ = 0; _ < q; ++_) {
        int i1, j1, i2, j2; cin >> i1 >> j1 >> i2 >> j2;
        if (isAnc(i1, j1, i2, j2)) {
            cout << i1 << ' ' << j1 << '\n';
            continue;
        }
        if (isAnc(i2, j2, i1, j1)) {
            cout << i2 << ' ' << j2 << '\n';
            continue;
        }
        int ti = 0, tj = 0;
        for (auto [i, j] : b) {
            if (isAnc(i, j, i1, j1) && isAnc(i, j, i2, j2)) {
                if (i > ti)
                    ti = i, tj = j;
            }
        }
        cout << ti << ' ' << tj << '\n';
    }
}

void solve3 () {
    for (int _ = 0; _ < q; ++_) {
        int i1, j1, i2, j2; cin >> i1 >> j1 >> i2 >> j2;
        int t1 = i1 - j1, t2 = i2 - j2;
        if (t1 == t2) {
            if (i1 < i2) {
                cout << i1 << ' ' << j1 << '\n';
            } else {
                cout << i2 << ' ' << j2 << '\n';
            }
            continue;
        }
        cout << min(t1, t2) << " 0\n";
    }
}

void solve4 () {
    int k = n;
    for (int i = 1; i <= n; ++i) {
        if (a[i] != i) {
            k = i - 1;
            break;
        }
    }
    for (int _ = 0; _ < q; ++_) {
        int i1, j1, i2, j2; cin >> i1 >> j1 >> i2 >> j2;
        int t1 = i1 - j1, t2 = i2 - j2;
        if (t1 <= k && t2 <= k) {
            if (t1 == t2) {
                if (i1 < i2) {
                    cout << i1 << ' ' << j1 << '\n';
                } else {
                    cout << i2 << ' ' << j2 << '\n';
                }
                continue;
            }
            cout << min(t1, t2) << " 0\n";
            continue;
        }
        if (t1 <= k) {
            cout << t1 << " 0\n";
            continue;
        }
        if (t2 <= k) {
            cout << t2 << " 0\n";
            continue;
        }
        if (j1 == j2) {
            cout << min(i1, i2) << ' ' << j1 << '\n';
            continue;
        }
        cout << min(j1, j2) + k << ' ' << min(j1, j2) << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    a.resize(n + 1);
    int f = 1;
    int k;
    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
        if (f && a[i] != i) {
            f = 0;
            k = i - 1;
        }
    }
    int f2 = 1;
    for (int i = 1; i <= n; ++i) {
        if (i <= k) {
            if (a[i] != i) {
                f2 = 0;
                break;
            }
        } else {
            if (a[i] != (n - (i - k))) {
                f2 = 0;
                break;
            }
        }
    }
    cin >> q;
    if (f) {
        solve3();
        return 0;
    }
    if (f2) {
        solve4();
        return 0;
    }
    //if (n <= 3000 && q <= 3000) {
        solve1();
        return 0;
    //}
}