#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
//using namespace __gnu_pbds;
#pragma GCC optimize("-O3")
using namespace std;
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
//typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

int n;
const int maxn = 5e5;
int a[maxn];
int pos_elem[maxn];
const int lg = 19;
int MN[maxn][lg];

struct node {
    int sum;
    int L;
    int R;

    node(int s) {
        sum = s;
        L = -1;
        R = -1;
    }
};

int roots[maxn + 1];
vector<node> nodes;

int put_new_node(int s) {
    nodes.push_back(node(s));
    return sz(nodes) - 1;
}

int build(int tl, int tr) {
    if (tl == tr) {
        return put_new_node(0);
    }
    int tm = ((tl + tr) >> 1);
    int now = put_new_node(0);
    nodes[now].L = build(tl, tm);
    nodes[now].R = build(tm + 1, tr);
    return now;
}

int upd(int v, int tl, int tr, int pos) {
    if (tl == tr) {
        return put_new_node(1);
    }
    int tm = ((tl + tr) >> 1);
    int y = put_new_node(nodes[v].sum);
    nodes[y].L = nodes[v].L;
    nodes[y].R = nodes[v].R;
    if (pos <= tm) {
        nodes[y].L = upd(nodes[v].L, tl, tm, pos);
    } else {
        nodes[y].R = upd(nodes[v].R, tm + 1, tr, pos);
    }
    nodes[y].sum++;
    return y;
}

int get_sum(int v, int tl, int tr, int l, int r) {
    if (tl > r || tr < l)return 0;
    if (l <= tl && tr <= r) {
        return nodes[v].sum;
    }
    int tm = ((tl + tr) >> 1);
    return get_sum(nodes[v].L, tl, tm, l, r) + get_sum(nodes[v].R, tm + 1, tr, l, r);
}

inline void calc_roots() {
    roots[0] = (build(0, n - 1));
    for (int i = 0; i < n; ++i) {
        roots[i + 1] = (upd(roots[i], 0, n - 1, pos_elem[i]));
    }
}

inline void calc_MN() {
    for (int i = n - 1; i >= 0; --i) {
        MN[i][0] = a[i];
        for (int j = 1; j < lg; ++j) {
            MN[i][j] = min(MN[i][j - 1], MN[min(n - 1, i + (1 << (j - 1)))][j - 1]);
        }
    }
}

inline int cnt_lower(int r, int val) {
    int ans = get_sum(roots[val], 0, n - 1, 0, r);
    return ans;
}

inline int get_min(int l, int r) {
    int sz = r - l + 1;
    int L = __lg(sz);
    return min(MN[l][L], MN[r - (1 << L) + 1][L]);
}

inline int get_first_pos(int v, int tl, int tr, int cnt) {
    while (tl != tr) {
        int tm = ((tl + tr) >> 1);
        if (nodes[nodes[v].L].sum >= cnt) {
            v = nodes[v].L;
            tr = tm;
        } else {
            cnt -= nodes[nodes[v].L].sum;
            tl = tm + 1;
            v = nodes[v].R;
        }
    }
    return tl;
}


inline int get_first(int x, int y) {
    int right = x - y;
    if (right == 0)return -1;
    return get_first_pos(roots[x], 0, n - 1, right);
}

inline int get_last(int x, int y) {
    int right = x - y + 1;
    if (roots[x]->sum < right)return n - 1;
    return get_first_pos(roots[x], 0, n - 1, right) - 1;
}

signed main() {
    cin.tie();
    cout.tie();
    ios_base::sync_with_stdio(false);
#ifdef foo
    freopen("input.txt", "r", stdin);
#endif
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        a[i]--;
        pos_elem[a[i]] = i;
    }
    calc_roots();
    calc_MN();
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        int x1, y1;
        int x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        if (x1 > x2) {
            swap(x1, x2);
            swap(y1, y2);
        }
        int l1 = get_first(x1, y1);
        int r1 = get_last(x1, y1);
        int l2 = get_first(x2, y2);
        int r2 = get_last(x2, y2);
        if (l1 <= l2 && l2 <= r1 || l1 <= r2 && r2 <= r1) {
            cout << x1 << " " << y1 << "\n";
            continue;
        }
        int p1 = get_first(x1, y1);
        int p2 = get_first(x2, y2);
        int mn = get_min(min(p1, p2) + 1, max(p1, p2));
        int cnt = cnt_lower(p1, mn);
        int left = mn - cnt;
        cout << mn << " " << left << "\n";
    }
}