#include<bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

//#define int ll

//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("O3")
//#pragma GCC optimize("Ofast")

const int MAXN = 2e6 + 1000;
int mn[4 * MAXN + 4];
int add[4 * MAXN + 4];
int sm[4 * MAXN + 4];
vector<int> events[MAXN];
vector<pair<int, int> > ask[MAXN];
pair<int, int> ans[MAXN];
int sp[MAXN];
int t[4 * MAXN + 4];

void build_t(int i, int l, int r) {
    if (l + 1 == r) {
        t[i] = sp[l];
        return;
    }
    int m = (l + r) / 2;
    build_t(2 * i + 1, l, m);
    build_t(2 * i + 2, m, r);
    t[i] = min(t[2 * i + 1], t[2 * i + 2]);
}

int get_seg(int i, int l, int r, int q_l, int q_r) {
    if (q_l <= l && r <= q_r) {
        return t[i];
    }
    if (r <= q_l || q_r <= l) {
        return MAXN;
    }
    int m = (l + r) / 2;
    return min(get_seg(2 * i + 1, l, m, q_l, q_r), get_seg(2 * i + 2, m, r, q_l, q_r));
}

void push(int i) {
    add[2 * i + 1] += add[i];
    add[2 * i + 2] += add[i];
    mn[2 * i + 1] += add[i];
    mn[2 * i + 2] += add[i];
    add[i] = 0;
}

void build(int i, int l, int r) {
    if (l + 1 == r) {
        mn[i] = events[l][0] - events[l][1];
        return;
    }
    int m = (l + r) / 2;
    build(2 * i + 1, l, m);
    build(2 * i + 2, m, r);
    mn[i] = min(mn[2 * i + 1], mn[2 * i + 2]);
}

void update(int i, int l, int r, int q_l, int q_r, int x) {
    if (q_l <= l && r <= q_r) {
        add[i] += x;
        mn[i] += x;
        return;
    }
    if (r <= q_l || q_r <= l) {
        return;
    }
    push(i);
    int m = (l + r) / 2;
    update(2 * i + 1, l, m, q_l, q_r, x);
    update(2 * i + 2, m, r, q_l, q_r, x);
    mn[i] = min(mn[2 * i + 1], mn[2 * i + 2]);
}

int get_min(int i, int l, int r) {
    if (mn[i] != 0) {
        return -1;
    }
    if (l + 1 == r) {
        return l;
    }
    push(i);
    int m = (l + r) / 2;
    if (mn[2 * i + 1] == 0) {
        return get_min(2 * i + 1, l, m);
    }
    return get_min(2 * i + 2, m, r);
}

void update_sum(int i, int l, int r, int q_i, int x) {
    if (r <= q_i || q_i < l) {
        return;
    }
    if (l + 1 == r) {
        sm[i] += x;
        return;
    }
    int m = (l + r) / 2;
    update_sum(2 * i + 1, l, m, q_i, x);
    update_sum(2 * i + 2, m, r, q_i, x);
    sm[i] = sm[2 * i + 1] + sm[2 * i + 2];
}

int get_sum(int i, int l, int r, int q_l, int q_r) {
    if (q_l <= l && r <= q_r) {
        return sm[i];
    }
    if (q_r <= l || r <= q_l) {
        return 0;
    }
    int m = (l + r) / 2;
    return get_sum(2 * i + 1, l, m, q_l, q_r) + get_sum(2 * i + 2, m, r, q_l, q_r);
}

void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> sp[i];
    }
    build_t(0, 0, n);
    int q;
    cin >> q;
    vector<vector<int> > req(q, vector<int>(4));
    for (int i = 0; i < q; ++i) {
        cin >> req[i][0] >> req[i][1] >> req[i][2] >> req[i][3];
    }
    for (int i = 0; i < q; ++i) {
        events[2 * i] = {req[i][0], req[i][1], i, 0};
        events[2 * i + 1] = {req[i][2], req[i][3], i, 1};
    }
    sort(events, events + 2 * q);
    build(0, 0, 2 * q);
    vector<int> fst(n + 1, 2 * q);
    int lst = -1;
    for (int i = 0; i < 2 * q; ++i) {
        while(lst != events[i][0]) {
            ++lst;
            fst[lst] = min(fst[lst], i);
        }
    }
    vector<pair<int, int> > r(q, {-n, -n});
    while(true) {
        int now = get_min(0, 0, 2 * q);
        if (now == -1) {
            break;
        }
        else {
            if (events[now][3] == 0) {
                r[events[now][2]].first = -1;
            }
            else {
                r[events[now][2]].second = -1;
            }
            update(0, 0, 2 * q, now, now + 1, n + 10);
        }
    }
    for (int i = 0; i < n; ++i) {
        /// make action: sp[i]
        update(0, 0, 2 * q, fst[sp[i]], 2 * q, -1);
        while(true) {
            int now = get_min(0, 0, 2 * q);
            if (now == -1) {
                break;
            }
            else {
                if (events[now][3] == 0) {
                    r[events[now][2]].first = i;
                }
                else {
                    r[events[now][2]].second = i;
                }
                update(0, 0, 2 * q, now, now + 1, n + 10);
            }
        }
    }
    for (int i = 0; i < q; ++i) {
        if (r[i].first == r[i].second) {
            if (req[i][0] < req[i][2]) {
                ans[i] = {req[i][0], req[i][1]};
            }
            else {
                ans[i] = {req[i][2], req[i][3]};
            }
        }
        else {
            int mn = min(r[i].first, r[i].second);
            int mx = max(r[i].first, r[i].second);
            int now = get_seg(0, 0, n, mn + 1, mx + 1);
            if (now <= req[i][0] && now <= req[i][2]) {
                ans[i].first = now - 1;
                if (mn != -1) {
                    ask[mn].push_back({now, i});
                }
                else {
                    ans[i].second = now - 1;
                }
            }
            else {
                if (req[i][0] < req[i][2]) {
                    ans[i] = {req[i][0], req[i][1]};
                }
                else {
                    ans[i] = {req[i][2], req[i][3]};
                }
            }
        }
    }
    for (int mn = 0; mn < n; ++mn) {
        update_sum(0, 0, n + 1, sp[mn], 1);
        for (auto [now, ind] : ask[mn]) {
            //cout << "GET_SUM: " << ind << endl;
            ans[ind].second = now - 1 - get_sum(0, 0, n + 1, 0, now);
        }
    }
    for (int i = 0; i < q; ++i) {
        cout << ans[i].first << " " << ans[i].second << "\n";
    }
    return;
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int tests = 1;
    //cin >> tests;
    while(tests--) {
        solve();
    }
}
