#include <bits/stdc++.h>

#define F first
#define S second
#define all(a) a.begin(), a.end()

using namespace std;
using ll = long long;
using pi = pair<int, int>;

template<class T> bool ckmin(T &a, T b) { return a > b ? a = b, true : false; }
template<class T> bool ckmax(T &a, T b) { return a < b ? a = b, true : false; }

ll solve(int n, vector<pi> v) {
    vector<pi> a;
    sort(all(v));
    for (int i = 0; i < n; ++i) {
        while (a.size() && a.back().F <= v[i].F && a.back().S <= v[i].S) a.pop_back();
        a.push_back(v[i]);
    }
    int pr_x = 0;
    //for (auto x : a) cout << x.F << " " << x.S << "\n";
    ll ans = (ll)a[0].F*a[0].S;
    for (int i = 1; i < a.size(); ++i) {
        ans += (ll)(a[i].F - a[i-1].F)*(a[i].S);
    }
    return ans;
}

int w, h;

struct square{
    int x1, y1, x2, y2;
};

square get(pi p, int t) {
    if (t == 0) return {0, 0, p.F, p.S};
    if (t == 1) return {p.F, p.S, w, h};
    if (t == 2) return {p.F, 0, w, p.S};
    if (t == 3) return {0, p.S, p.F, h};
    assert(1 == 0);
    return {-1, -1, -1, -1};
}

ll intersect(vector<square> v) {
    if (v[0].x1 > v[1].x1) swap(v[0], v[1]);
    int x1 = v[1].x1, x2 = v[0].x2;
    if (v[0].y1 > v[1].y1) swap(v[0], v[1]);
    int y1 = v[1].y1, y2 = v[0].y2;
    //cout << "! " << x1 << ", " << y1 << ", " << x2 << ", " << y2 << "\n";
    if (x1 > x2 || y1 > y2) return 0;
    return (ll)(x2-x1)*(y2-y1);
}

ll intersect_3(vector<square> v) {
    if (v[0].x1 > v[1].x1) swap(v[0], v[1]);
    int x1 = v[1].x1, x2 = v[0].x2;
    if (v[0].y1 > v[1].y1) swap(v[0], v[1]);
    int y1 = v[1].y1, y2 = v[0].y2;
    if (x1 > x2 || y1 > y2) return 0;
    square s = {x1, y1, x2, y2};
    return intersect({s, v[2]});
}

ll get_s(square s) {
    if (s.x1 > s.x2 || s.y1 > s.y2) return 0;
    return (ll)(s.x2-s.x1)*(s.y2-s.y1);
}

ll intersect2(vector<square> v) {
    return get_s(v[0]) + get_s(v[1]) - intersect(v);
}

ll intersect3(vector<square> v) {
    //cout << get_s(v[0]) << " " << get_s(v[1]) << " " << get_s(v[2]) << "\n";
    return get_s(v[0]) + get_s(v[1]) + get_s(v[2])
           - intersect({v[0], v[1]}) - intersect({v[2], v[1]}) - intersect({v[0], v[2]});
           //intersect_3(v);
}

void solve1() {
    int n, w, h; cin >> n >> w >> h;
    vector<pi> v(n);
    for (int i = 0; i < n; ++i) {
        int x, y; cin >> x >> y;
        v[i] = {w-x, h-y};
    }
    solve(n, v);
}

void solve4() {
    int n; cin >> n >> w >> h;
    vector<pi> v(n);
    for (auto &x : v) cin >> x.F >> x.S;
    if (n >= 4) {
        cout << (ll)w*h << "\n";
        return;
    }
    if (n == 1) {
        int x = v[0].F, y = v[0].S;
        cout << (ll)max(x, w-x)*max(y, h-y) << "\n";
        return;
    }
    if (n == 2) {
        ll ans = 0;
        for (int k1 = 0; k1 < 4; ++k1) {
            for (int k2 = 0; k2 < 4; ++k2) {
                vector<square> tmp;
                tmp.push_back(get(v[0], k1));
                tmp.push_back(get(v[1], k2));
                ckmax(ans, intersect2(tmp));
            }
        }
        cout << ans << "\n";
    }
    if (n == 3) {
        ll ans = 0;
        for (int k1 = 0; k1 < 4; ++k1) {
            for (int k2 = 0; k2 < 4; ++k2) {
                for (int k3 = 0; k3 < 4; ++k3) {
                    vector<square> tmp;
                    tmp.push_back(get(v[0], k1));
                    tmp.push_back(get(v[1], k2));
                    tmp.push_back(get(v[2], k3));
                    ckmax(ans, intersect3(tmp));
                    //cout << tmp[0].x1 << ", " << tmp[0].y1 << " " << tmp[0].x2 << " " << tmp[0].y2 << "\n";
                }
            }
        }
        cout << ans << "\n";
    }
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);
    int k; cin >> k;
    vector<int> op(k); for (auto &x : op) cin >> x;
    int t; cin >> t;
    while (t--) {
        if (k == 1) solve1();
        if (k == 4) solve4();
    }
    return 0;
}