#include <iostream>
#include <vector>
#include <set>

using namespace std;

#define int long long

vector<vector<int>> g;
vector<int> p;
vector<int> l, r;
vector<int> bought;
vector<int> c;
vector<set<pair<int, int>>> mins;
bool ok = 1;
vector<int> ans;

struct segtree {
    vector<int> t;
    vector<int> add;
    segtree(int sz) {
        t.resize(5 * sz);
        add.resize(5 * sz);
    }
    void upd(int v) {
        t[v] = min(t[2 * v], t[2 * v + 1]);
    }
    void push(int v) {
        if (add[v] == 0) return;
        t[2 * v] += add[v];
        t[2 * v + 1] += add[v];
        add[2 * v] += add[v];
        add[2 * v + 1] += add[v];
        add[v] = 0;
    }
    void change(int v, int vl, int vr, int l, int r, int x) {
//        cout << v << " " << vl << " " << vr << " " << t[v] << endl;
        if (vl >= r || vr <= l) {
            return;
        }
        if (vl >= l && vr <= r) {
            t[v] += x;
            add[v] += x;
            return;
        }
        push(v);
        int vm = (vl + vr) / 2;
        change(2 * v, vl, vm, l, r, x);
        change(2 * v + 1, vm, vr, l, r, x);
        upd(v);
    }
    int get_minn(int v, int vl, int vr, int l, int r) {
        if (vl >= r || vr <= l) {
            return 2e9;
        }
        if (vl >= l && vr <= r) {
            return t[v];
        }
        push(v);
        int vm = (vl + vr) / 2;
        return min(get_minn(2 * v, vl, vm, l, r), get_minn(2 * v + 1, vm, vr, l, r));
    }
};

int n;
vector<int> sz;
vector<int> heavy;
vector<int> up;

void get_inf(int v) {
    sz[v] = 1;
    int maxx = -1;
    for (int i : g[v]) {
        get_inf(i);
        sz[v] += sz[i];
        if (maxx == -1 || sz[maxx] < sz[i]) {
            maxx = i;
        }
    }
    heavy[v] = maxx;
}

vector<int> mas;
vector<int> pos;

void make_hld(int v) {
    pos[v] = mas.size();
    mas.push_back(v);
    if (heavy[v] != -1) {
        up[heavy[v]] = up[v];
        make_hld(heavy[v]);
    }
    for (int i : g[v]) {
        if (i == heavy[v]) {
            continue;
        }
        up[i] = i;
        make_hld(i);
    }
}

segtree tree = segtree(0);

void change(int v, int pr, int x) {
//    cout << v << " " << pr << endl;
    while (up[v] != up[pr]) {
//        cout << v << " " << pr << endl;
        tree.change(1, 0, n, pos[up[v]], pos[v] + 1, x);
        v = p[up[v]];
    }
//    cout << "change " << pr << " " << v << " " << pos[pr] << " " << pos[v] << endl;
    tree.change(1, 0, n, pos[pr], pos[v] + 1, x);
}

int get_min(int v, int pr) {
    int minn = 2e9;
    while (up[v] != up[pr]) {
        minn = min(minn, tree.get_minn(1, 0, n, pos[up[v]], pos[v] + 1));
        v = p[up[v]];
    }
    minn = min(minn, tree.get_minn(1, 0, n, pos[pr], pos[v] + 1));
    return minn;
}

void dfs(int v) {
    if (!ok) return;
    int maxx = -1;
    for (int i : g[v]) {
        dfs(i);
        bought[v] += bought[i];
        if (!ok) return;
        if (maxx == -1 || mins[i].size() > mins[maxx].size()) {
            maxx = i;
        }
    }
    if (maxx == -1) {
        mins[v].insert({c[v], v});
    } else {
        mins[maxx].insert({c[v], v});
        for (int i : g[v]) {
            if (i == maxx) {
                continue;
            }
            for (auto j : mins[i]) {
                mins[maxx].insert(j);
            }
        }
        mins[maxx].swap(mins[v]);
    }
    if (bought[v] > r[v]) {
        ok = 0;
        return;
    }
//    cout << v << " " << bought[v] << endl;
    change(v, v, r[v] - bought[v]);
    if (bought[v] >= l[v]) return;
    int need_buy = l[v] - bought[v];
    while (need_buy > 0) {
//        if (mins[v].size() == 0) {
//            cout << "stop";
//            exit(0);
//        }
        auto u = mins[v].begin()->second;
//        cout << "new " << v << " " << u << " " << need_buy << endl;
        int cnt_buys = need_buy;
        cnt_buys = min(cnt_buys, get_min(u, v));
//        cout << "need " << v << " " << u << " " << cnt_buys << endl;
        if (cnt_buys == 0) {
//            cout << "here" << endl;
            mins[v].erase(mins[v].begin());
//            cout << "here" << endl;
            continue;
        }
        need_buy -= cnt_buys;
        ans[u] += cnt_buys;
        change(u, v, -cnt_buys);
    }
    bought[v] = l[v];
}

void solve() {
    g.clear();
    p.clear();
    l.clear();
    r.clear();
    bought.clear();
    c.clear();
    mins.clear();
    ok = 1;
    ans.clear();
    sz.clear();
    heavy.clear();
    up.clear();
    pos.clear();
    mas.clear();
    cin >> n;
    g.resize(n);
    p.resize(n, -1);
    p.assign(n, -1);
    l.resize(n);
    r.resize(n);
    bought.resize(n, 0);
    bought.assign(n, 0);
    c.resize(n);
    mins.resize(n);
    ans.resize(n);
    ans.assign(n, 0);
    sz.resize(n);
    sz.assign(n, 0);
    heavy.resize(n, 0);
    heavy.assign(n, -1);
    up.resize(n, -1);
    pos.resize(n);
    tree = segtree(n);
    for (int i = 1; i <= n - 1; i++) {
        int v;
        cin >> v;
        v--;
        g[v].push_back(i);
        p[i] = v;
    }
    for (int i = 0; i < n; i++) {
        cin >> c[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> l[i] >> r[i];
    }
    get_inf(0);
    make_hld(0);
//    for (int i : mas) {
//        cout << i << " ";
//    }
//    cout << "here" << endl;
    dfs(0);
    if (!ok) {
        cout << -1 << endl;
        return;
    }
    int full_ans = 0;
    for (int i = 0; i < n; i++) {
        full_ans += c[i] * ans[i];
    }
    cout << full_ans << endl;
    for (int i : ans) {
        cout << i << " ";
    }
    cout << endl;
}

int32_t main() {
    int t;
    cin >> t;
    while (t--) solve();
}
