#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve();

int main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int t;
    cin >> t;
    do {
        solve();
    } while (--t);
    return 0;
}

#define lower_index(v, x) lower_bound(v.begin(), v.end(), x) - v.begin()
#define upper_index(v, x) upper_bound(v.begin(), v.end(), x) - v.begin()

using segment = pair<ll, ll>;
#define l first
#define r second

pair<ll, vector<ll>> solve(vector<int> p, vector<ll> c, vector<segment> s) {
    int n = c.size();
    vector<vector<int>> t(n);
    for (int i = 1; i < n; ++i) t[p[i]].push_back(i);
    vector<int> size(n, 1);
    auto sz = [&](auto sz, int cur) -> int {
        for (int nxt: t[cur]) size[cur] += sz(sz, nxt);
        return size[cur];
    };
    sz(sz, 0);
    for (auto &row: t) sort(row.begin(), row.end(), [&](int i, int j) { return size[i] > size[j]; });
    vector<ll> minHere(n), costMin(n);
    vector<map<pair<ll, int>, ll> *> reserves(n);
    bool wrong = false;
    vector<ll> cnt(n);
    auto dfs = [&](auto dfs, int cur) -> void {
        for (int nxt: t[cur]) {
            dfs(dfs, nxt);
            if (wrong) return;
            minHere[cur] += minHere[nxt];
            costMin[cur] += costMin[nxt];
            if (reserves[cur] == nullptr) reserves[cur] = reserves[nxt]; else {
                for (auto &[cost, count]: *reserves[nxt]) {
                    (*reserves[cur])[cost] += count;
                }
            }
        }
        if (minHere[cur] > s[cur].r) {
            wrong = true;
            return;
        }
        if (reserves[cur] == nullptr) reserves[cur] = new map<pair<ll, int>, ll>{};
        (*reserves[cur])[{c[cur], cur}] = 1e9;
        while (minHere[cur] < s[cur].l) {
            auto &[cost, count] = *(*reserves[cur]).begin();
            if (count > s[cur].l - minHere[cur]) {
                count -= s[cur].l - minHere[cur];
                costMin[cur] += (s[cur].l - minHere[cur]) * cost.first;
                cnt[cost.second] += s[cur].l - minHere[cur];
                minHere[cur] = s[cur].l;
            } else {
                minHere[cur] += count;
                costMin[cur] += count * cost.first;
                cnt[cost.second] += count;
                (*reserves[cur]).erase((*reserves[cur]).begin());
            }
        }
        (*reserves[cur])[{c[cur], cur}] = s[cur].r - minHere[cur];
        ll sum = 0;
        for (auto &[c, cnt]: (*reserves[cur])) sum += cnt;
        while (!(*reserves[cur]).empty() && sum - (*reserves[cur]).rbegin()->second >= (s[cur].r - minHere[cur])) {
            sum -= (*reserves[cur]).rbegin()->second;
            (*reserves[cur]).erase(--(*reserves[cur]).end());
        }
        if (!(*reserves[cur]).empty()) (*reserves[cur]).rbegin()->second -= sum - (s[cur].r - minHere[cur]);
    };
    dfs(dfs, 0);
    if (wrong) return {-1, {}};
    return {costMin[0], cnt};
}

void solve() {
    int n;
    cin >> n;
    vector<int> p(n);
    for (int i = 1; i < n; ++i) {
        cin >> p[i];
        --p[i];
    }
    vector<ll> c(n);
    for (ll &x: c) cin >> x;
    vector<segment> s(n);
    for (auto &[l, r]: s) cin >> l >> r;
    auto[cost, how] = solve(p, c, s);
    cout << cost << '\n';
    if (cost != -1) {
        for (ll x: how) cout << x << ' ';
        cout << '\n';
    }
}
