#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve();

int main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    solve();
    return 0;
}

#define lower_index(v, x) lower_bound(v.begin(), v.end(), x) - v.begin()
#define upper_index(v, x) upper_bound(v.begin(), v.end(), x) - v.begin()

struct cell {
    int i, j;

    cell(int i, int j) : i(i), j(j) {}

    cell() = default;

    bool operator<(const cell &other) const {
        return pair{i, j} < pair{other.i, other.j};
    }
};

struct vertex {
    vertex *left = nullptr, *right = nullptr;
    int sum;

    vertex(vertex *left, vertex *right) : left(left), right(right), sum(left->sum + right->sum) {}

    vertex(int sum) : sum(sum) {}
};

vertex *add(vertex *cur, int i, int curL, int curR) {
    if (curL + 1 == curR) return new vertex(cur->sum + 1);
    int curM = (curL + curR) / 2;
    if (i < curM) return new vertex(add(cur->left, i, curL, curM), cur->right);
    return new vertex(cur->left, add(cur->right, i, curM, curR));
}

vertex *build(int n) {
    if (n == 1) return new vertex(0);
    return new vertex(build(n / 2), build(n / 2));
}

int sz;

int sum(vertex *cur, int l, int r, int curL, int curR) {
    if (l <= curL && curR <= r) return cur->sum;
    if (r <= curL || curR <= l) return 0;
    int curM = (curL + curR) / 2;
    return sum(cur->left, l, r, curL, curM) + sum(cur->right, l, r, curM, curR);
}

int atLeast(vertex *cur, int q, int curL, int curR) {
    if (curL + 1 == curR) return curR;
    int curM = (curL + curR) / 2;
    if (cur->left->sum >= q) return atLeast(cur->left, q, curL, curM);
    q -= cur->left->sum;
    return atLeast(cur->right, q, curM, curR);
}

vector<vertex *> build(vector<int> a) {
    int n = a.size();
    sz = n;
    sz = 2 << __lg(sz);
    vertex *z = build(sz);
    vector<int> pos(n);
    for (int i = 0; i < n; ++i) pos[a[i]] = i;
    vector<vertex *> ans(n + 1);
    ans[0] = z;
    for (int i = 0; i < n; ++i) {
        ans[i + 1] = add(ans[i], pos[i], 0, sz);
    }
    return ans;
}

void solve(vector<int> a, vector<pair<cell, cell>> q) {
    vector<vertex *> persistent = build(a);
    int n = a.size();
    auto get = [&](int i, int j) -> int {
        if (j == i) return 0;
        return atLeast(persistent[i], i - j, 0, sz);
        int curJ = i;
        for (int k = 0; k < n; ++k) {
            if (a[k] < i) curJ--;
            if (curJ == j) return k + 1;
        }
        assert(false);
        return 0;
    };
    auto j = [&](int i, int c) -> int {
        return i - sum(persistent[i], 0, c, 0, sz);
        int curJ = i;
        for (int k = 0; k < c; ++k) {
            if (a[k] < i) curJ--;
        }
        return curJ;
    };
    for (auto &[c1, c2]: q) {
        auto[i1, j1] = c1;
        auto[i2, j2] = c2;
        int idx1 = get(i1, j1);
        int idx2 = get(i2, j2);
        int ans = min(i1, i2);
        for (int i = min(idx2, idx1); i < max(idx1, idx2); ++i) {
            ans = min(ans, a[i]);
        }
        cout << ans << ' ' << j(ans, idx1) << '\n';
    }
}

void solve() {
    int n, q;
    cin >> n;
    vector<int> a(n);
    for (int &x: a) cin >> x;
    for (int &x: a) --x;
    cin >> q;
    vector<pair<cell, cell>> qu(q);
    for (auto &[c1, c2]: qu) {
        cin >> c1.i >> c1.j >> c2.i >> c2.j;
    }
    solve(a, qu);
}
