#include <bits/stdc++.h>

using namespace std;

#define all(x) (x).begin(), (x).end()
#define allr(x) (x).rbegin(), (x).rend()
#define gsize(x) (int)((x).size())
const char nl = '\n';

typedef long long ll;
typedef long double ld;

const int maxn = 1e5;
ll t[maxn * 4], lp[maxn * 4];
const int inf = 1e9 + 7;


void build(int v, int tl, int tr) {
    t[v] = lp[v] = 0;
    if (tl != tr - 1) {
        int tm = (tl + tr) / 2;
        build(2*v + 1, tl, tm);
        build(2*v + 2, tm, tr);
    }
}

void update(int v, int tl, int tr, int l, int r, ll x) {
    if (l >= r) return;
    if (tl == l && tr == r) {
        t[v] += x;
        lp[v] += x;
    } else {
        int tm = (tl + tr) / 2;
        update(2*v + 1, tl, tm, l, min(r, tm), x);
        update(2*v + 2, tm, tr, max(l, tm), r, x);
        t[v] = min(t[2*v + 1], t[2*v + 2]) + lp[v];
    }
}

int query(int v, int tl, int tr, int l, int r) {
    if (l >= r) return inf;
    if (tl == l && tr == r) return t[v];
    else {
        int tm = (tl + tr) / 2;
        int r1 = query(2*v + 1, tl, tm, l, min(r, tm));
        return min(r1, query(2*v + 2, tm, tr, max(l, tm), r));
    }
}

int n;
vector<int> g[maxn];
int ans[maxn], l[maxn], r[maxn], tin[maxn], tout[maxn];
bool good = true;
int s[maxn], h[maxn], tp[maxn], timer;

void dfs(int v) {
    s[v] = 1;
    for (int u: g[v]) {
        dfs(u);
        s[v] += s[u];
    }
}

void dfs1(int v) {
    tin[v] = timer++;
    int ct = 0;
    for (int u: g[v]) {
        if (ct == 0) h[u] = h[v];
        else h[u] = u;
        dfs1(u);
        tp[u] = v;
        ct++;
    }
    tout[v] = timer;
}

ll c[maxn];
set<pair<ll, int>> ts[maxn];

int qr2(int u, int v) {
    int tl = min(tin[u], tin[v]), tr = max(tin[u], tin[v]);
    return query(0, 0, n, tl, tr + 1);
}

void up2(int u, int v, int mi) {
    int tl = min(tin[u], tin[v]), tr = max(tin[u], tin[v]);
    update(0, 0, n, tl, tr + 1, -mi);
}

int qr(int v) {
    int res = inf;
    while (v >= 0) {
        int u = h[v];
        res = min(res, qr2(u, v));
        v = tp[u];
    }
    return res;
}

void upd(int v, int mi) {
    while (v >= 0) {
        int u = h[v];
        up2(u, v, mi);
        v = tp[u];
    }
}

ll tans = 0;
ll dfs2(int v) {
    if (!good) return 0;
    ll res = 0;
    ts[v].emplace(c[v], v);
    for (int u: g[v]) {
        res += dfs2(u);
        if (!good) return 0;
        if (gsize(ts[u]) > gsize(ts[v])) swap(ts[u], ts[v]);
        for (auto p: ts[u]) {
            ts[v].insert(p);
        }
        ts[u].clear();
    }
    if (res > r[v]) {
        good = false;
        return res;
    }
    while (res < l[v] && gsize(ts[v])) {
        int dt = l[v] - res;
        int u = ts[v].begin()->second;
        int mi = qr(u);
        mi = min(mi, dt);
        upd(u, mi);
        ans[u] += mi;
        tans += mi * c[u];

        if (qr(u) == 0) {
            ts[v].erase(ts[v].begin());
        }
        res += mi;

        if (mi == dt) break;
    }
    if (gsize(ts[v]) == 0 && res < l[v]) {
        good = false;
        return 0;
    }
    return res;
}

bool comp(int i, int j) {
    return s[i] < s[j];
}

void solve() {
    cin >> n;
    tp[0] = -1;
    tans = 0;
    build(0, 0, n);
    for (int i = 0; i < n; i++) {
        g[i].clear();
        ts[i].clear();
        ans[i] = 0;
    }
    timer = 0;
    good = true;
    for (int i = 1; i < n; i++) {
        int ttp;
        cin >> ttp;
        g[ttp - 1].push_back(i);
    }
    for (int i = 0; i < n; i++) cin >> c[i];
    for (int i = 0; i < n; i++) {
        cin >> l[i] >> r[i];
    }
    dfs(0);
    for (int i = 0; i < n; i++) sort(allr(g[i]), comp);
    dfs1(0);
    for (int v = 0; v < n; v++)
        update(0, 0, n, tin[v], tin[v] + 1, r[v]);
    dfs2(0);
    if (!good) {
        cout << -1 << nl;
        return;
    }
    cout << tans << nl;
    for (int i = 0; i < n; i++) cout << ans[i] << ' ';
    cout << nl;
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);

    int T;
    cin >> T;
    while (T--) solve();
}
