#include <bits/stdc++.h>
using namespace std;

#define x first
#define y second
#define all(x) begin(x), end(x)
#define sz(x) ((int) (x).size())
using ll = long long;
using ld = long double;

const int N = 1 << 19;

int a[N];

struct Query {
	int r1, c1, r2, c2, j1, j2, mxi, cnt;
} qs[N];

vector<pair<int, int*>> event[N];
vector<pair<int, int*>> e2[N];

int t[2 * N];

void tadd(int i) {
	i += N;
	while (i) {
		++t[i];
		i /= 2;
	}
}

int tget(int k) {
	int ci = 1, cl = 0, cr = N;
	while (cr - cl > 1) {
		int mid = (cl + cr) / 2;
		ci *= 2;
		if (t[ci] >= k) {
			cr = mid;
		} else {
			k -= t[ci];
			++ci;
			cl = mid;
		}
	}
	return cl;
}


int tsum(int l, int r) {
	l += N;
	r += N;
	int ans = 0;
	while (l <= r) {
		if (l & 1)	ans += t[l];
		if (!(r & 1))	ans += t[r];
		l = (l + 1) / 2;
		r = (r - 1) / 2;
	}
	return ans;
}

pair<int, int> t2[2 * N];

pair<int, int> t2get(int l, int r) {
	l += N;
	r += N;
	pair<int, int> res = {0x3f3f3f3f, -1};
	while (l <= r) {
		if (l & 1) {
			res = min(res, t2[l]);
		}
		if (!(r & 1)) {
			res = min(res, t2[r]);
		}
		l = (l + 1) / 2;
		r = (r - 1) / 2;
	}
	return res;
}

int inv[N];

signed main() {
	cin.tie(0)->sync_with_stdio(0);
	int n;
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		inv[a[i]] = i;
		t2[i + N] = {a[i], i};
	}
	for (int i = N; i--; ) {
		t2[i] = min(t2[2 * i], t2[2 * i + 1]);
	}
	int queries;
 	cin >> queries;
	for (int i = 0; i < queries; ++i) {
		auto &[r1, c1, r2, c2, j1, j2, mxi, cnt] = qs[i];
		cin >> r1 >> c1 >> r2 >> c2;
		c1 = r1 - c1;
		c2 = r2 - c2;
		event[r1].push_back({c1, &j1});
		event[r2].push_back({c2, &j2});
		// int j1 = 0, j2 = 0;
		// int curr = 0;
		// while (curr != c1) {
		// 	if (a[j1] <= r1) {
		// 		++curr;
		// 	}
		// 	++j1;
		// }
		// curr = 0;
		// while (curr != c2) {
		// 	if (a[j2] <= r2) {
		// 		++curr;
		// 	}
		// 	++j2;
		// }
	}

	for (int i = 1; i <= n; ++i) {
		tadd(inv[i]);
		for (auto [q, where] : event[i]) {
			if (q) {
				*where = tget(q) + 1;
			}
		}
	}

	for (int i = 0; i < queries; ++i) {
		auto &[r1, c1, r2, c2, j1, j2, mxi, cnt] = qs[i];
		if (j1 > j2) {
			swap(j1, j2);
		}
		mxi = -1;
		if (j1 != j2) {
			mxi = t2get(j1, j2 - 1).y;
			e2[a[mxi]].push_back({mxi, &cnt});
		}
	}
	fill(all(t), 0);
	for (int i = 1; i <= n; ++i) {
		tadd(inv[i]);
		for (auto [val, where] : e2[i]) {
			*where = tsum(0, val - 1);
		}
	}

	for (int i = 0; i < queries; ++i) {
		auto &[r1, c1, r2, c2, j1, j2, mxi, cnt] = qs[i];

		if (j1 == j2 || a[mxi] > min(r1, r2)) {
			auto [x, y] = min<pair<int, int>>({r1, c1}, {r2, c2});
			cout << x << " " << x - y << "\n";
		} else {
			cout << a[mxi] - 1 << " " << a[mxi] - 1 - cnt << "\n";
		}
	}
}