#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <deque>
#include <stack>
#include <queue>
#include <unordered_map>
#include <unordered_set>
#include <time.h>
#include <math.h>
#include <random>
#include <string>
#include <iomanip>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

vector<vector<int>> g;
vector<int> l, r, c, placed, summcnt, parent, blocked;
ll ans = 0;

bool check(int v) {
	ll suml = 0;
	for (int to : g[v]) {
		if (!check(to)) return 0;
		suml += l[to];
	}
	if (suml > r[v])
		return 0;
	return 1;
}

vector<pii> open(int v) {
	vector<pii> res = {};
	if (blocked[v]) return res;
	res.push_back({ c[v], v });
	for (int to : g[v]) {
		for (pii t : open(to))
			res.push_back(t);
	}
	return res;
}

void block(int v) {
	blocked[v] = 1;
	for (int to : g[v])
		if (!blocked[to])
			block(to);
}

int dfs(int v) {
	for (int to : g[v])
		summcnt[v] += dfs(to);
	vector<pii> good = open(v);
	sort(good.begin(), good.end());
	int cur = 0;
	while (summcnt[v] < l[v]) {
		auto [cost, ind] = good[cur];
		cur++;
		if (blocked[ind]) continue;
		ll mx = l[v] - summcnt[v], t = ind, mn = r[ind] - summcnt[ind];
		int least = ind;
		while (t != v) {
			t = parent[t];
			if (r[t] - summcnt[t] < mn) {
				least = t;
				mn = r[t] - summcnt[t];
			}
		}
		if (mn < mx) block(least);
		else mn = mx;
		ans += mn * cost;
		placed[ind] += mn;
		summcnt[ind] += mn;
		t = ind;
		while (t != v) {
			t = parent[t];
			summcnt[t] += mn;
		}
	}
	return summcnt[v];
}

int32_t main() {
	cin.tie(0); cout.tie(0); cin.sync_with_stdio(0); cout.sync_with_stdio(0);
	int t, n;
	cin >> t;
	while (t--) {
		cin >> n;
		g.assign(n, {});
		c.assign(n, 0);
		l.assign(n, 0);
		r.assign(n, 0);
		parent.assign(n, 0);
		summcnt.assign(n, 0);
		placed.assign(n, 0);
		blocked.assign(n, 0);
		for (int i = 1; i < n; i++) {
			int p;
			cin >> p;
			g[--p].push_back(i);
			parent[i] = p;
		}
		for (int i = 0; i < n; i++)
			cin >> c[i];
		for (int i = 0; i < n; i++)
			cin >> l[i] >> r[i];
		if (!check(0)) {
			cout << -1 << "\n";
			continue;
		}
		ans = 0;
		dfs(0);
		cout << ans << "\n";
		for (int i = 0; i < n; i++)
			cout << placed[i] << " ";
		cout << "\n";
	}
}