#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <deque>
#include <stack>
#include <queue>
#include <unordered_map>
#include <unordered_set>
#include <time.h>
#include <math.h>
#include <random>
#include <string>
#include <iomanip>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

vector<vector<int>> g, up;
vector<int> tin, tout;
int timer = 0;

void dfs(int v, int p = 0) {
	tin[v] = timer++;
	up[v][0] = p;
	for (int i = 1; i < 13; i++)
		up[v][i] = up[up[v][i - 1]][i - 1];
	for (int to : g[v])
		dfs(to, v);
	tout[v] = timer++;
}

bool is_ancester(int u, int v) {
	return tin[u] <= tin[v] && tout[v] <= tout[u];
}

int lca(int u, int v) {
	if (is_ancester(u, v)) return u;
	for (int i = 12; i >= 0; i--)
		if (!is_ancester(up[u][i], v))
			u = up[u][i];
	return up[u][0];
}

int32_t main() {
	cin.tie(0); cout.tie(0); cin.sync_with_stdio(0); cout.sync_with_stdio(0);
	ll n, q;
	cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; i++)
		cin >> a[i];
	g.resize((n + 1) * (n + 1));
	vector<int> path(n, 1);
	vector<pii> pos(n + 1);
	pos[0] = { 0, 0 };
	auto add = [&](vector<int> moves, int b = 0) {
		int r = pos[b].first, c = pos[b].second;
		for (int i = b; i < n; i++) {
			int r1 = r + 1, c1 = c;
			if (moves[i] == 1)
				c1++;
			g[r + (n + 1) * c].push_back(r1 + (n + 1) * c1);
			r = r1;
			c = c1;
			pos[i + 1] = { r, c };
		}
	};
	add(path);
	for (int i = 0; i < n; i++) {
		path[a[i] - 1] = 0;
		add(path, a[i] - 1);
	}
	tin.resize((n + 1) * (n + 1));
	tout.resize((n + 1) * (n + 1));
	up.resize((n + 1) * (n + 1), vector<int>(13));
	dfs(0);
	cin >> q;
	while (q--) {
		int r1, c1, r2, c2;
		cin >> r1 >> c1 >> r2 >> c2;
		int l = lca(r1 + (n + 1) * c1, r2 + (n + 1) * c2);
		cout << l % (n + 1) << " " << l / (n + 1) << "\n";
	}
}