#include<bits/stdc++.h>

#define x first
#define y second
#define mp make_pair
#define sz(v) (int) v.size()
#define all(v) v.begin(), v.end()

using namespace std;

typedef long long int64;
typedef long double float64;
typedef pair<int, int> pii;

const int N = 3e2 + 5, Q = 3e2 + 5;

int n, a[N];
int q;
pii A[Q], B[Q], C[Q];

void read() {
    cin >> n;
    for (int i = 1; i <= n; ++i) cin >> a[i];
    cin >> q;
    for (int i = 1; i <= q; ++i) {
        cin >> A[i].x >> A[i].y >> B[i].x >> B[i].y;
    }
}

int col[N];
vector<int> g[N * N];

int get_sum(int k) {
    return k * (k + 1) / 2;
}

int get_id(int i, int j) {
    return get_sum(i) + j;
}

void update_tree(int srow) {
    for (int row = srow; row <= n; ++row) {
        int prev_id = get_id(row - 1, col[row - 1]),
            curr_id = get_id(row, col[row]);
        g[prev_id].emplace_back(curr_id);
    }
}

const int LOG = 20;

int up[LOG][N * N], h[N * N];

void dfs(int v, int p = 0) {
    up[0][v] = p;
    for (int j = 1; j < LOG; ++j) {
        up[j][v] = up[j - 1][up[j - 1][v]];
    }
    for (int u : g[v]) {
        h[u] = h[v] + 1;
        dfs(u, v);
    }
}

int get_up(int v, int k) {
    for (int j = 0; j < LOG; ++j) {
        if ((k >> j) & 1) {
            v = up[j][v];
        }
    }
    return v;
}

int get_lca(int v, int u) {
    if (h[v] < h[u]) u = get_up(u, h[u] - h[v]);
    if (h[u] < h[v]) v = get_up(v, h[v] - h[u]);
    if (v == u) return v;
    for (int j = LOG - 1; ~j; --j) {
        if (up[j][v] != up[j][u]) {
            v = up[j][v];
            u = up[j][u];
        }
    }
    return up[0][v];
}

pii by_id[N * N];

void solve() {
    for (int id = 0; id <= get_id(n, n); ++id) {
        g[id].clear();
    }
    for (int r = 0; r <= n; ++r) {
        for (int c = 0; c <= r; ++c) {
            by_id[get_id(r, c)] = mp(r, c);
        }
    }
    for (int row = 0; row <= n; ++row) {
        col[row] = row;
    }
    update_tree(1);
    for (int i = 1; i <= n; ++i) {
        for (int row = a[i]; row <= n; ++row) {
            --col[row];
        }
        update_tree(a[i]);
    }
    dfs(0);
    for (int i = 1; i <= q; ++i) {
        int idA = get_id(A[i].x, A[i].y);
        int idB = get_id(B[i].x, B[i].y);
        int idC = get_lca(idA, idB);
        C[i] = by_id[idC];
    }
}

void write() {
    for (int i = 1; i <= q; ++i) {
        cout << C[i].x << " " << C[i].y << "\n";
    }
}

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    read();
    solve();
    write();
    return 0;
}