#include<bits/stdc++.h>

#define x first
#define y second
#define mp make_pair
#define sz(v) (int) v.size()
#define all(v) v.begin(), v.end()

using namespace std;

typedef long long int64;
typedef long double float64;
typedef pair<int, int> pii;

const int N = 1e5 + 5, Q = 1e5 + 5;

int n, a[N];
int q;
pii A[Q], B[Q], C[Q];

void read() {
    cin >> n;
    for (int i = 1; i <= n; ++i) cin >> a[i];
    cin >> q;
    for (int i = 1; i <= q; ++i) {
        cin >> A[i].x >> A[i].y >> B[i].x >> B[i].y;
    }
}

int k;

pii get_up(int row, int col) {
    return mp(row - col, 0);
}

pii get_up(pii v) {
    return mp(v.x - v.y, 0);
}

pii get_up_k(int row, int col) {
    return mp(k + col, col);
}

pii get_up_k(pii v) {
    return mp(k + v.y, v.y);
}

int ptr = 0;
map<pii, int> used;
vector<int> g[3 * N];
pii by_id[3 * N];

void add_edge(pii v, pii u) {
    if (v == u) return;
    if (used.find(v) == used.end()) {
        by_id[ptr] = v;
        used[v] = ptr++;
    }
    if (used.find(u) == used.end()) {
        by_id[ptr] = u;
        used[u] = ptr++;
    }
    int V = used[v], U = used[u];
//    cerr << "(" << v.x << ", " << v.y << ") - (" << u.x << ", " << u.y << ")\n";
    g[V].emplace_back(U);
    g[U].emplace_back(V);
}

vector<pii> first[N], second[N];

void add(pii v) {
    pii u = get_up(v);
    if (u.x < k) {
        first[u.x].emplace_back(v);
    } else if (u.x > k) {
        u = get_up_k(v);
        second[u.x].emplace_back(v);
    }
}

const int LOG = 20;

int up[LOG][3 * N], h[3 * N];

void dfs(int v, int p = 0) {
    up[0][v] = p;
    for (int j = 1; j < LOG; ++j) {
        up[j][v] = up[j - 1][up[j - 1][v]];
    }
    for (int u : g[v]) if (u != p) {
        h[u] = h[v] + 1;
        dfs(u, v);
    }
}

int get_la(int v, int u) {
    for (int j = 0; j < LOG; ++j) {
        if ((u >> j) & 1) {
            v = up[j][v];
        }
    }
    return v;
}

int get_lca(int v, int u) {
    if (h[v] < h[u]) u = get_la(u, h[u] - h[v]);
    if (h[u] < h[v]) v = get_la(v, h[v] - h[u]);
    if (v == u) return v;
    for (int j = LOG - 1; ~j; --j) {
        if (up[j][v] != up[j][u]) {
            v = up[j][v];
            u = up[j][u];
        }
    }
    return up[0][v];
}

void solve() {
    k = 0;
    while (k + 1 <= n && a[k + 1] != n) ++k;
    for (int i = 0; i <= k; ++i) first[i].emplace_back(mp(i, 0));
    for (int i = k; i <= n; ++i) second[i].emplace_back(mp(i, i - k));
    for (int i = 1; i <= q; ++i) {
        add(A[i]);
        add(B[i]);
    }
    for (int i = 0; i <= k; ++i) {
        sort(all(first[i]));
        first[i].resize(unique(all(first[i])) - first[i].begin());
        for (int j = 1; j < sz(first[i]); ++j) {
            add_edge(first[i][j - 1], first[i][j]);
        }
        if (i) add_edge(mp(i - 1, 0), mp(i, 0));
    }
    for (int i = k; i <= n; ++i) {
        sort(all(second[i]));
        second[i].resize(unique(all(second[i])) - second[i].begin());
        for (int j = 1; j < sz(second[i]); ++j) {
            add_edge(second[i][j - 1], second[i][j]);
        }
        if (i > k) add_edge(mp(i - 1, i - k - 1), mp(i, i - k));
    }
    for (int v = 0; v < ptr; ++v) {
        sort(all(g[v]));
        g[v].resize(unique(all(g[v])) - g[v].begin());
    }
    dfs(0);
    for (int i = 1; i <= q; ++i) {
        int v = used[A[i]], u = used[B[i]], lca = get_lca(v, u);
        C[i] = by_id[lca];
    }
}

void write() {
    for (int i = 1; i <= q; ++i) {
        cout << C[i].x << " " << C[i].y << "\n";
    }
}

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    read();
    solve();
    write();
    return 0;
}