#include<bits/stdc++.h>

#define x first
#define y second
#define mp make_pair
#define sz(v) (int) v.size()
#define all(v) v.begin(), v.end()

using namespace std;

typedef long long int64;
typedef long double float64;
typedef pair<int, int> pii;

const int N = 1e5 + 5;

int n, w, h;
pii a[N];

void read() {
    cin >> n >> w >> h;
    for (int i = 1; i <= n; ++i) cin >> a[i].x >> a[i].y;
}

int64 solve1() {
    sort(a + 1, a + n + 1, [&](pii &A, pii &B) {
        return mp(-A.x, A.y) < mp(-B.x, B.y);
    });
    vector<pii> st;
    for (int i = 1; i <= n; ++i) {
        while (!st.empty() && st.back().first > a[i].y) {
            st.pop_back();
        }
        st.emplace_back(a[i].y, i);
    }
    int64 ans = 0;
    pii last = mp(w, 0);
    for (auto p : st) {
        int i = p.second;
        ans += (int64) (last.x - a[i].x) * (h - a[i].y);
        last = a[i];
    }
    return ans;
}

const int64 INF = 1e18;

int64 pref[N], suff[N];

int64 solve(vector<int> &rem, int x, int y) {
//    sort(all(rem), [&](int i, int j) {
//        return mp(a[i].x, a[i].y) < mp(a[j].x, a[j].y);
//    });
    {
        vector<pii> st;
        for (int i = 0; i < sz(rem); ++i) {
            while (!st.empty() && a[rem[i]].y <= st.back().first) {
                st.pop_back();
            }
            if (st.empty()) {
                pref[i] = (int64) (y - a[rem[i]].y) * a[rem[i]].x;
            } else {
                int j = st.back().second;
                pref[i] = pref[j] + (int64) (a[rem[i]].x - a[rem[j]].x) * (y - a[rem[i]].y);
            }
            st.emplace_back(a[rem[i]].y, i);
        }
    }
    {
        vector<pii> st;
        for (int i = sz(rem) - 1; ~i; --i) {
            while (!st.empty() && a[rem[i]].y <= st.back().first) {
                st.pop_back();
            }
            if (st.empty()) {
                suff[i] = (int64) (y - a[rem[i]].y) * (w - a[rem[i]].x);
            } else {
                int j = st.back().second;
                suff[i] = suff[j] + (int64) (a[rem[j]].x - a[rem[i]].x) * (y - a[rem[i]].y);
            }
            st.emplace_back(a[rem[i]].y, i);
        }
    }
    int64 ans = -INF;
    for (int i = 0; i < sz(rem); ++i) {
        if (a[rem[i]].x >= x) {
            ans = max(ans, pref[i] + (i == sz(rem) - 1 ? 0 : suff[i + 1]));
        }
        if (a[rem[i]].x <= x) {
            ans = max(ans, (i == 0 ? 0 : pref[i - 1]) + suff[i]);
        }
    }
    return ans;
}

int64 solve() {
    sort(a + 1, a + n + 1, [&](pii A, pii B) {
        return mp(A.x, A.y) < mp(B.x, B.y);
    });
    int64 ans = 0;
    for (int s = 1; s <= n; ++s) {
        vector<int> rem;
        for (int i = 1; i <= n; ++i) {
            if (s != i && a[i].y <= a[s].y) rem.emplace_back(i);
        }
        int64 res = solve(rem, a[s].x, a[s].y);
        if (res >= 0) ans = max(ans, res + (int64) (h - a[s].y) * w);
    }
    return ans;
}

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int k;
    cin >> k;
    vector<int> directions(k);
    for (int i = 0; i < k; ++i) cin >> directions[i];
    int T;
    cin >> T;
    while (T--) {
        read();
        cout << solve() << "\n";
    }
    return 0;
}