#include <iostream>
#include <algorithm>
#include <vector>
#include <cstdio>
#include <set>
#include <cstdlib>

#define all(x) (x).begin(), (x).end()

using namespace std;

typedef long long ll;

const ll cst = 1e5 + 5;
const ll inf = (ll)1e18 + 228;

void operator delete(void*);

void ex(ll ec = 0) {
	cout.flush();
	exit(ec);
}

vector<ll> g[cst];
ll par[cst];
ll cost[cst];
ll l[cst];
ll r[cst];

ll n;

ll tk[cst];
ll crr[cst];
ll w[cst];

set<pair<ll, ll>> st[cst];

bool bad;

ll dp[505][1007];

ll check(ll u) {
	ll mn = r[u] - tk[u];
	while (par[u]) {
		u = par[u];
		mn = min(mn, r[u] - tk[u]);
	}
	return mn;
}

void add(ll u, ll x) {
	while (u){
		tk[u] += x;
		u = par[u];
	}
}

void dfs(ll v) {
	st[v].insert({ cost[v], v });
	for (ll u : g[v]) {
		dfs(u);
		if (bad) return;
		if (st[u].size() > st[v].size()) swap(st[u], st[v]);
		while (!st[u].empty()){
			st[v].insert(*st[u].begin());
			st[u].erase(st[u].begin());
		}
		w[v] += w[u];
	}
	while (tk[v] < l[v]) {
		if (st[v].empty()) {
			bad = 1;
			break;
		}
		auto u = st[v].begin()->second;
		ll cs = cost[u];
		st[v].erase(st[v].begin());
		ll can = check(u);
		if (!can) continue;
		if (can <= l[v] - tk[v]) {
			w[v] += can * cs;
			crr[u] += can;
			add(u, can);
		}
		else {
			can = l[v] - tk[v];
			w[v] += can * cs;
			crr[u] += can;
			add(u, can);
			st[v].insert({ cost[u], u });
		}
	}
}

void dpfs(ll v) {
	for (ll i = 0; i <= r[v]; i++) dp[v][i] = inf;
	vector<ll> dpv(r[v] + 1);
	bool frs = 1;
	for (ll u : g[v]) {
		dpfs(u);
		if (frs) {
			for (ll i = l[u]; i <= r[u]; i++) {
				dp[v][i] = dp[u][i];
			
			}
			frs = 0;
			continue;
		}
		for (ll i = 0; i <= r[v]; i++) dpv[i] = inf;
		for (ll i = l[u]; i <= r[u]; i++) {
			for (ll j = i; j <= r[v]; j++) {
				dpv[j] = min(dpv[j], dp[v][j - i] + dp[u][i]);
			}
		}
		for (ll i = 0; i <= r[v]; i++) dp[v][i] = dpv[i];
	}
	if (frs) dp[v][0] = 0;
	for (ll i = 1; i <= r[v]; i++) dp[v][i] = min(dp[v][i], dp[v][i - 1] + cost[v]);
}

void solve() {
	cin >> n;
	bad = 0;
	for (ll i = 1; i <= n; i++) {
		g[i].clear();
		tk[i] = 0;
		crr[i] = 0;
		w[i] = 0;
	}
	for (ll i = 2; i <= n; i++) {
		ll p;
		cin >> p;
		g[p].push_back(i);
		par[i] = p;
	}
	for (ll i = 1; i <= n; i++) cin >> cost[i];
	for (ll i = 1; i <= n; i++) cin >> l[i] >> r[i];
	dfs(1);
	dpfs(1);
	ll mn = inf;
	ll ti = -1;
	for (ll i = l[1]; i <= r[1]; i++) {
		if (dp[1][i] < mn) {
			mn = dp[1][i];
			ti = i;
		}
	}

	if (bad) {
		cout << -1;
		return;
	}
	ll answ = 0;
	for (ll i = 1; i <= n; i++) answ += crr[i] * cost[i];
	cout << answ << endl;
	
	for (ll i = 1; i <= n; i++) cout << crr[i] << " ";
}

int main() {
	cin.tie(0)->sync_with_stdio(0);
	ll t;
	cin >> t;
	while (t--) {
		solve();
		cout << endl;
	}
	ex();
}