#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
//#pragma GCC target("avx,avx2,fmi,bmi2")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/rope>

#define endl '\n'
#define all(arr) arr.begin(), arr.end()
//#define int long long
#define out(x) cout << (x) << endl, exit(0)
#define ls(id) ((id << 1) | 1)
#define rs(id) ((id << 1) + 2)

using namespace std;
using namespace __gnu_pbds;
using namespace __gnu_cxx;

typedef pair<int, int> ipair;
typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> treap;

const int MAXN = 3030;
const int MAXK = 3030 * 3030;
const int INF = 2e9;

int n, k;
int arr[MAXN], eul[MAXK], tin[MAXK], dep[MAXK], tr[MAXK << 2];
bool trr[MAXN];
set<int> gr[MAXK];

inline int comp(int lval, int rval) {
	if (lval == -1) return rval;
	if (rval == -1) return lval;
	return (dep[lval] < dep[rval] ? lval : rval);
}

void build(int id, int l, int r) {
	if (r - l == 1) {
		tr[id] = eul[l];
		return;
	}
	int mid = (l + r) >> 1;
	build(ls(id), l, mid);
	build(rs(id), mid, r);
	tr[id] = comp(tr[ls(id)], tr[rs(id)]);
}

int query(int id, int l, int r, int ql, int qr) {
	if (qr <= l || r <= ql) return -1;
	if (ql <= l && r <= qr) return tr[id];
	int mid = (l + r) >> 1;
	auto lval = query(ls(id), l, mid, ql, qr);
	auto rval = query(rs(id), mid, r, ql, qr);
	return comp(lval, rval);
}

inline int code(int r, int c) {
	return r * (n + 1) + c;
}

inline ipair decode(int v) {
	return {v / (n + 1), v % (n + 1)};
}

void dfs(int r, int c) {
	if (r == n + 1) return;
	gr[code(r, c)].insert(code(r + 1, c + trr[r]));
	dfs(r + 1, c + trr[r]);
}

void dfseul(int v, int d) {
	dep[v] = d;
	tin[v] = k;
	eul[k++] = v;
	for (int u: gr[v]) {
		dfseul(u, d + 1);
		eul[k++] = v;
	}
}

void build() {
	memset(trr, 1, sizeof(trr));
	memset(tr, -1, sizeof(tr));
	dfs(0, 0);
	for (int i = 0; i < n; ++i) {
		trr[arr[i]] ^= true;
		dfs(0, 0);
	}
	dfseul(0, 0);
	build(0, 0, k);

}

ipair go(int r1, int c1, int r2, int c2) {
	int v = code(r1, c1), u = code(r2, c2);
	int vid = tin[v], uid = tin[u];
	if (uid < vid) swap(vid, uid);
	int ans = query(0, 0, k, vid, uid + 1);
	return decode(ans);
}

int32_t main() {
	ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL);
	cout.setf(ios::fixed), cout.precision(10);
	cin >> n;
	for (int i = 0; i < n; ++i)
		cin >> arr[i], --arr[i];
	build();
	int t; cin >> t;
	while (t--) {
		int r1, c1, r2, c2; cin >> r1 >> c1 >> r2 >> c2;
		auto [r3, c3] = go(r1, c1, r2, c2);
		cout << r3 << ' ' << c3 << endl;
	}
}