#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <set>
#include <random>
#include <cassert>

using namespace std;

mt19937_64 rnd(12);
#define int int64_t
#define fi first
#define se second
#define all(x) (x).begin(), (x).end()

vector<vector<int>> gr;
vector<int> cost;
vector<pair<int, int>> seg;
vector<int> ans, pr;
vector<set<pair<int, int>>> to_add;

vector<int> tin, tout, eul;
int tim = 0;

vector<int> fenw;

int ask(int r) {
    int res = 0;
    for (int i = r; i >= 0; i = (i & (i+1)) - 1) {
        res += fenw[i];
    }
    return res;
}

int ask(int l, int r) {
    return ask(r) - (l == 0 ? 0 : ask(l-1));
}

void upd(int ind, int x) {
    for (int i = ind; i < fenw.size(); i = (i | (i+1))) {
        fenw[i] += x;
    }
}

void dfs0(int v) {
    eul.push_back(v);
    tin[v] = tim; tim++;
    for (int i : gr[v]) {
        dfs0(i);
    }
    tout[v] = tim-1;
}


struct seg_tree {
    vector<int> s;
    vector<int> t;
    int n;
    seg_tree(int _n = 0) {
        n = _n;
        s.resize(2*n, 1e18);
        t.resize(2*n, -1);
    }
    void push(int l, int r, int v) {
        if (t[v] == -1) return;
        s[v] = min(s[v], t[v]);
        if (l != r-1) {
            t[v+1] = min(t[v+1], t[v]);
            t[v+((l+r)/2-l)*2] = min(t[v+((l+r)/2-l)*2], t[v]);
        }
        t[v] = -1;
    }

    void upd(int l, int r, int lx, int rx, int v, int x) {
        push(l, r, v);
        if (l >= rx || r <= lx) return;
        if (l >= lx && r <= rx) {
            t[v] = x;
            push(l, r, v);
            return;
        }
        int m = (l + r) / 2;
        upd(l, m, lx, rx, v+1, x);
        upd(m, r, lx, rx, v+(m-l)*2, x);
    }

    void upd(int l, int r, int x) {
        upd(0, n, l, r+1, 0, x);
    }
    int val(int l, int r, int v, int ind) {
        push(l, r, v);
        if (l == r-1) return s[v];
        int m = (l + r) / 2;
        if (ind < m) return val(l, m, v+1, ind);
        else return val(m, r, v+(m-l)*2, ind);
    }
    int val(int ind) {
        return val(0, n, 0, ind);
    }
};

seg_tree st;
void dfs(int v) {
    int mx = -1;
    for (int i : gr[v]) {
        dfs(i);
        if (mx == -1 || to_add[i].size() > to_add[mx].size()) {
            mx = i;
        }
    }
    if (mx != -1) {
        swap(to_add[v], to_add[mx]);
    }
    for (int i : gr[v]) {
        if (i != mx) {
            for (auto j : to_add[i]) {
                to_add[v].insert(j);
            }
        }
    }
    to_add[v].insert({cost[v], v});
    //int sum = ask(tin[v], tout[v]);
    while (ask(tin[v], tout[v]) < seg[v].fi && to_add[v].size()) {
        int i = to_add[v].begin()->se;


        int ost = 1e18;//seg[i].se - ask(tin[i], tout[i]);
        ost = st.val(tin[i]);

        //for (int j = i; ; j = pr[j]) {
        //    ost = min(ost, seg[j].se - ask(tin[j], tout[j]));
       //     if (j == v) break;
       // }



        if (ost < 0) ost = 0;
        if (seg[v].fi - ask(tin[v], tout[v]) >= ost) {
            ans[i] += ost;
            st.upd(tin[i], tout[i], seg[i].se - ans[i]);
            upd(tin[i], ost);
            to_add[v].erase(to_add[v].begin());
        } else {
            ans[i] += seg[v].fi - ask(tin[v], tout[v]);
            st.upd(tin[i], tout[i], seg[i].se - ans[i]);
            upd(tin[i], seg[v].fi - ask(tin[v], tout[v]));
            break;
        }
    }
}

void solve() {
    int n;
    cin >> n;
    eul.clear();
    to_add.assign(n, {});
    fenw.assign(n, 0);
    tin.assign(n, 0);
    tout.assign(n, 0);
    tim = 0;
    ans.assign(n, 0);
    gr.assign(n, {});
    cost.assign(n, 0);
    seg.assign(n, {});
    pr.assign(n, -1);
    for (int i = 0; i < n-1; ++i) {
        int p;
        cin >> p;
        p--;
        gr[p].push_back(i+1);
        pr[i+1] = p;
    }
    for (int i = 0; i < n; ++i) {
        cin >> cost[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> seg[i].fi >> seg[i].se;
    }
    st = seg_tree(n);
    dfs0(0);
    for (int i = 0; i < n; ++i) {
        st.upd(tin[i], tout[i], seg[i].se);
    }
    dfs(0);
    int res = 0;
    for (int i = 0; i < n; ++i) {
        res += cost[i] * ans[i];
        if (ask(tin[i], tout[i]) < seg[i].fi || ask(tin[i], tout[i]) > seg[i].se) {
            cout << "-1\n";
            return;
        }
    }
    cout << res << '\n';
    for (int i = 0; i < n; ++i) {
        cout << ans[i] << ' ';
    }
    cout << '\n';
}

int32_t main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
    int t;
    cin >> t;
    while (t--) solve();
}

/*
 * 1
8
1 1 2 2 3 3 4
5 4 3 2 1 2 4 1
9 15
4 5
0 4
2 3
1 2
 2 4
 0 6
 1 2
 */

/*
 *
1
8
1 2 2 3 4 2 2
2 1 1 4 5 9 5 2
2 2
0 0
0 2
0 1
1 1
0 1
0 0
0 0
 */