#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <random>
#include <cassert>
#include <ctime>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

const long long INF = 1e10, MOD = 1e9 + 1;

void t1(long long n, vector<long long>& need, long long k)
{
	long long res = upper_bound(need.begin(), need.end(), k) - need.begin() - 1;
	cout << n - res - 1 << "\n";
}

void t2(vector<long long>& add, vector<long long>& cur_sum, vector<long long>& need, long long k)
{
	long long res = lower_bound(need.begin(), need.end(), k) - need.begin() - 1;
	if (res == -1)
	{
		cout << cur_sum[0] * k << "\n";
		return;
	}
	long long ans = add[res + 1];
	ans += cur_sum[res + 1] * (k - need[res]);
	cout << ans << "\n";
}

struct segtree
{
	long long n;
	vector<long long> t, p;

	segtree(long long in)
	{
		n = in;
		t.resize(n * 4);
		p.resize(n * 4);
		build(0, 0, n - 1, n);
	}

	void build(long long v, long long tl, long long tr, long long n)
	{
		if (tl == tr)
		{
			t[v] = n - tl - 1;
			return;
		}

		long long tm = (tl + tr) / 2;
		build(v * 2 + 1, tl, tm, n);
		build(v * 2 + 2, tm + 1, tr, n);
		t[v] = t[v * 2 + 1] + t[v * 2 + 2];
	}

	void push(long long v, long long tl, long long tr)
	{
		if (tl == tr)
		{
			return;
		}

		long long tm = (tl + tr) / 2;
		long long l1 = tm - tl + 1, l2 = tr - tm;
		t[v * 2 + 1] += p[v] * l1;
		t[v * 2 + 2] += p[v] * l2;
		p[v * 2 + 1] += p[v];
		p[v * 2 + 2] += p[v];
		p[v] = 0;
	}

	long long get(long long v, long long tl, long long tr, long long l, long long r)
	{
		if (tr < l || r < tl)
		{
			return 0;
		}
		if (l <= tl && tr <= r)
		{
			return t[v];
		}

		long long tm = (tl + tr) / 2;
		push(v, tl, tr);
		return get(v * 2 + 1, tl, tm, l, r) + get(v * 2 + 2, tm + 1, tr, l, r);
	}

	void upd(long long v, long long tl, long long tr, long long l, long long r, long long val)
	{
		if (tr < l || r < tl)
		{
			return;
		}
		if (l <= tl && tr <= r)
		{
			t[v] += val * (tr - tl + 1);
			p[v] += val;
			return;
		}

		long long tm = (tl + tr) / 2;
		push(v, tl, tr);
		upd(v * 2 + 1, tl, tm, l, r, val);
		upd(v * 2 + 2, tm + 1, tr, l, r, val);
		t[v] = t[v * 2 + 1] + t[v * 2 + 2];
	}
};

void solve()
{
	long long n, q;
	vector<long long> v;
	map<long long, long long> cnt;
	cin >> n >> q;
	v.resize(n);
	for (long long i = 0; i < n; i++)
	{
		cin >> v[i];
		cnt[v[i]]++;
	}

	set<long long> dif;
	for (long long i = 0; i < n; i++)
	{
		dif.insert(v[i]);
	}
	vector<long long> dv;
	for (auto& i : dif)
	{
		dv.push_back(i);
	}

	vector<long long> need;
	for (long long i = 0; i < dv.size() - 1; i++)
	{
		need.push_back(dv[i + 1] - dv[i]);
	}
	sort(need.begin(), need.end());

	vector<pair<long long, pair<long long, long long>>> idk;
	for (long long i = 0; i < dv.size() - 1; i++)
	{
		idk.push_back({ dv[i + 1] - dv[i], {i, i + 1} });
	}
	sort(idk.begin(), idk.end());

	vector<long long> pr(dv.size() + 1);
	long long sum = 0;
	for (long long i = 0; i < dv.size(); i++)
	{
		pr[i + 1] = pr[i] + cnt[dv[i]];
		sum += cnt[dv[i]] * (dv.size() - i - 1);
	}

	vector<long long> add(dv.size()), cur_sum(dv.size());
	if (add.size() > 1)
	{
		add[1] = idk[0].first * sum;
	}
	if (cur_sum.size() > 0)
	{
		cur_sum[0] = sum;
	}
	if (idk.size() > 0)
	{
		sum -= pr[idk[0].second.first + 1];
	}
	for (long long i = 1; i < dv.size() - 1; i++)
	{
		cur_sum[i] = sum;
		add[i + 1] = add[i] + sum * (idk[i].first - idk[i - 1].first);
		sum -= pr[idk[i].second.first + 1];
	}

	while (q--)
	{
		long long t, k;
		cin >> t >> k;
		if (t == 1)
		{
			t1(dif.size(), need, k);
		}
		else if (t == 2)
		{
			t2(add, cur_sum, need, k);
		}
		else
		{
			long long idx;
			cin >> idx;
			idx--;

			long long ans = v[idx];
			long long ad = lower_bound(dv.begin(), dv.end(), v[idx]) - dv.begin();
			ad = dv.size() - ad - 1;

			long long prev = 0;
			for (long long i = 0; i < idk.size(); i++)
			{
				if (idk[i].first > k)
				{
					break;
				}

				ans += ad * (idk[i].first - prev);
				prev = idk[i].first;
				if (idx <= idk[i].second.first)
				{
					ad--;
				}
			}

			cout << ans << "\n";
		}
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	solve();

	return 0;
}

/*














*/
