#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
using namespace std;
using ll = long long;

const int MAXN = 3e5 + 123;
int a[MAXN];

struct dsu {
    void resize(int n) {
        rt.resize(n);
        for (int i = 0; i < n; ++i)
            rt[i] = i;
    }

    int gst(int i) {
        if (rt[i] == i)
            return i;
        return rt[i] = gst(rt[i]);
    }

    void unite(int i, int j) {
        i = gst(i);
        j = gst(j);
        rt[min(i, j)] = max(i, j);
    }
 private:
    vector<int> rt;
};

signed main() {
    int n, q;
    cin >> n >> q;
    vector<ll> cpr;
    ll sm = 0;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        sm += a[i];
        cpr.push_back(a[i]);
    }
    sort(cpr.begin(), cpr.end());
    cpr.resize(unique(cpr.begin(), cpr.end()) - cpr.begin());
    int m = cpr.size();
    
    vector<ll> cnt(m);
    for (int i = 0; i < n; ++i) {
        int j = lower_bound(cpr.begin(), cpr.end(), a[i]) - cpr.begin();
        ++cnt[j];
    }
    vector<pair<ll, pair<int, int>>> qrs(q);
    for (int i = 0; i < q; ++i) {
        int t;
        cin >> t;
        if (t == 1 || t == 2) {
            ll k;
            cin >> k;
            qrs[i] = {k, {-t, i}};
        } else {
            ll k, j;
            cin >> k >> j;
            --j;
            qrs[i] = {k, {j, i}};
        }
    }
    sort(qrs.begin(), qrs.end());
    vector<ll> ans(q);
    vector<ll> vals = cpr;
    ll t = 0;
    ll ans_qr1 = m;
    ll ans_qr2 = sm;
    int qri = 0;
    while (qri < q) {
        while (qri < q && qrs[qri].first == t) {
            auto [type, qri0] = qrs[qri].second;
            if (type == -1) {
                ans[qri0] = ans_qr1;
            } else if (type == -2) {
                ans[qri0] = ans_qr2;
            } else {
                int i = lower_bound(cpr.begin(), cpr.end(), a[type]) - cpr.begin();
                ans[qri0] = vals[i];
            }
            ++qri;
        }
        int tmp = 0;
        for (int i = m - 2; i >= 0; --i) {
            if (vals[i] < vals[i + 1])
                ++tmp;
            vals[i] += tmp;
        }
        ans_qr1 = 1;
        ans_qr2 = -sm;
        for (int i = m - 2; i >= 0; --i) {
            if (vals[i] < vals[i + 1])
                ++ans_qr1;
        }
        for (int i = 0; i < m; ++i)
            ans_qr2 += cnt[i] * vals[i];
        ++t;
        
    }
    for (int i = 0; i < q; ++i)
        cout << ans[i] << '\n';
}
