#include <iostream>
#include <bitset>
#include <algorithm>
#include <vector>
#include <queue>
using namespace std;

const int MAXN = 5e5 + 123;
vector<int> edg[MAXN];
bitset<MAXN> unav;
bitset<MAXN> used;
vector<int> unav1[MAXN];
int tin[MAXN];
int fup[MAXN];
int timer = 0;

void dfs(int v, int rt) {
    tin[v] = fup[v] = timer++;
    used[v] = 1;
    for (auto u : edg[v]) {
        if (u == rt)
            continue;
        if (used[u]) {
            fup[v] = min(fup[v], tin[u]);
        } else {
            dfs(u, v);
            if (tin[v] < fup[u]) {
                unav[u] = 1;
            }
            fup[v] = min(fup[v], fup[u]);
        }
    }
}

void dfs_(int v) {
    used[v] = 1;
    for (auto u : edg[v]) {
        for (auto u : edg[v]) {
            if (tin[v] <= fup[u]) {
                unav1[v].push_back(u);
            }
            if (used[u])
                continue;
            dfs_(u);
        }
    }
}

int dist[MAXN][2];

void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        used[i] = unav[i] = 0;
        edg[i].clear();
        dist[i][0] = dist[i][1] = 2 * n + 1;
        unav1[i].clear();
    }
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        edg[u].push_back(v);
        edg[v].push_back(u);
    }
    timer = 0;
    dfs(0, -1);
    for (int i = 0; i < n; ++i)
        used[i] = 0;
    dfs_(0);
    for (int i = 0; i < n; ++i) {
        sort(unav1[i].begin(), unav1[i].end());
        /* cout << "! ";
        cout << tin[i] << ' ' << fup[i] << "$ ";
        for (auto x : unav1[i])
            cout << x << ' ';
        cout << endl; */
    }
    /* for (int i = 0; i < n; ++i) {
        cout << "(" << unav[i] << ") ";
        for (auto u : edg[i])
            cout << u << ' ';
        cout << endl;
    } */
    queue<pair<int, int>> q;
    dist[0][0] = 0;
    q.push({0, 0});
    while (q.size()) {
        auto [v, t] = q.front();
        // cout << "[" << v << ' ' << t << ' ' << dist[v][t] << "]" << endl;
        q.pop();
        for (auto u : edg[v]) {
            if (unav[u] || dist[u][t ^ 1] <= dist[v][t] + 1)
                continue;
            if (t) {
                int i0 = lower_bound(unav1[v].begin(), unav1[v].end(), u) - unav1[v].begin();
                if (i0 < unav1[v].size() && unav1[v][i0] == u)
                    continue;
            }
            dist[u][t ^ 1] = dist[v][t] + 1;
            q.push({u, t ^ 1});
        }
    }
    // for (int i = 0; i < n; ++i)
    //     cout << "(" << dist[i][0] << ' ' << dist[i][1] << ") ";
    for (int i = 1; i < n; ++i) {
        if (dist[i][0] > 2 * n)
            cout << -1 << ' ';
        else
            cout << dist[i][0] << ' ';
    }
    cout << '\n';
}

signed main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
