#include <iostream>
#include <bitset>
#include <algorithm>
#include <vector>
#include <queue>
using namespace std;

const int MAXN = 5001;
vector<int> edg[MAXN];
bitset<MAXN> unav;
bitset<MAXN> used;
int set1[MAXN][MAXN];
int tin[MAXN];
int fup[MAXN];
int timer = 0;

void dfs(int v, int rt) {
    tin[v] = fup[v] = timer++;
    used[v] = 1;
    for (auto u : edg[v]) {
        if (u == rt)
            continue;
        if (used[u]) {
            fup[v] = min(fup[v], tin[u]);
        } else {
            dfs(u, v);
            if (tin[v] < fup[u]) {
                unav[u] = 1;
            }
            fup[v] = min(fup[v], fup[u]);
        }
    }
}

void dfssss(int v, int w) {
    for (auto u : edg[v]) {
        if (set1[w][u] == -1) {
            set1[w][u] = set1[w][v];
            dfssss(u, w);
        }
    }
}

void dfs_(int v) {
    used[v] = 1;
    set1[v][v] = 0;
    int tmer = 0;
    for (auto u : edg[v]) {
        if (set1[v][u] == -1) {
            set1[v][u] = tmer++;
            dfssss(u, v);
        }
        if (used[u])
            continue;
        dfs_(u);
    }
}

bool in(vector<int>& vc, int x) {
    int i = lower_bound(vc.begin(), vc.end(), x) - vc.begin();
    return i < vc.size() && vc[i] == x;
}

int dist[MAXN][MAXN];

void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        used[i] = unav[i] = 0;
        edg[i].clear();
        for (int j = 0; j <= n; ++j)
            dist[i][j] = 2 * n + 1;
        for (int j = 0; j < n; ++j)
            set1[i][j] = -1;
    }
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        edg[u].push_back(v);
        edg[v].push_back(u);
    }
    timer = 0;
    dfs(0, -1);
    for (int i = 0; i < n; ++i)
        used[i] = 0;
    dfs_(0);
    queue<pair<int, int>> q;
    dist[0][n] = 0;
    q.push({0, n});
    while (q.size()) {
        auto [v, t] = q.front();
        // cout << "[" << v << ' ' << t << ' ' << dist[v][t] << "]" << endl;
        q.pop();
        for (auto u : edg[v]) {
            int t0 = n;
            if (t == n)
                t0 = v;
            if (unav[u] || dist[u][t0] <= dist[v][t] + 1)
                continue;
            if (t < n) {
                if (set1[v][u] != set1[v][t])
                   continue;
            }
            dist[u][t0] = dist[v][t] + 1;
            q.push({u, t0});
        }
    }
    // for (int i = 0; i < n; ++i)
    //     cout << "(" << dist[i][0] << ' ' << dist[i][1] << ") ";
    for (int i = 1; i < n; ++i) {
        if (dist[i][n] > 2 * n)
            cout << -1 << ' ';
        else
            cout << dist[i][n] << ' ';
    }
    cout << '\n';
}

signed main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
