#include <iostream>
#include <vector>
#include <algorithm>
#include <tuple>
#include <set>
using namespace std;

int n, m;
vector<int> c;
vector<int> t;
vector<int> a;

unsigned long long solve(vector<pair<int, int>> lr, int x)
{
    vector<tuple<int, int, int>> lr2(m);
    for (int i = 0; i < m; i++)
    {
        auto [l, r] = lr[i];
        if (t[i])
        {
            l = min(l, x);
            r = max(r, x);
        }
        lr2[i] = {l, r, c[i]};
    }
    sort(lr2.begin(), lr2.end());
    set<pair<int, int>> s;
    auto a2 = a;
    unsigned long long ans = 0;
    int k = 0;
    for (int i = 0; i < n; i++)
    {
        while (!s.empty() && s.begin()->first < i)
        {
            s.erase(s.begin());
        }
        while (k < m && get<0>(lr2[k]) <= i)
        {
            auto [l, r, c] = lr2[k];
            s.insert({r, c});
            k++;
        }
        while (a2[i] && !s.empty())
        {
            auto [r, o] = *s.begin();
            s.erase(s.begin());
            int d = min(a2[i], o);
            if (a2[i] < o)
            {
                s.insert(s.begin(), {r, o-d});
            }
            a2[i] -= d;
            ans += d;
        }
    }
    return ans;
}


void solution()
{
    cin >> n >> m;
    a.resize(n);
    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
    }
    c.resize(m);
    t.resize(m);
    vector<pair<int, int>> lr(m);
    int l, r;
    for (int i = 0; i < m; i++)
    {
        cin >> l >> r >> c[i] >> t[i];
        l--;
        r--;
        lr[i] = {l, r};
    }
    for (int i = 0; i < n; i++)
    {

        cout << solve(lr, i) << " ";
    }
    cout << '\n';
}

int main() {
    cin.tie(NULL);
    int t;
    cin >> t;
    for (int i = 0; i < t; i++)
    {
        solution();
    }
}
