#ifdef DEBUG
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>
#include <bits/extc++.h>

using namespace std;

using ll = long long;
using vi = vector<ll>;
using ii = pair<ll, ll>;
using vii = vector<ii>;
using vvi = vector<vi>;
using vvii = vector<vii>;
using vsi = vector<set<ll>>;
using vb = vector<bool>;
using vvb = vector<vb>;
using vc = vector<char>;
using vvc = vector<vc>;

template<class T, class Y>
istream &operator>>(istream &s, pair<T, Y> &p) {
  return s >> p.first >> p.second;
}

template<class T>
istream &operator>>(istream &s, vector<T> &v) {
  for (auto &e : v) s >> e;
  return s;
}

template<class T>
ostream &operator<<(ostream &s, const vector<T> &v) {
  for (const auto &e : v) s << e << ' ';
  return s;
}

void solve();

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.setf(ios::fixed);
  cout.precision(30);

  solve();
}

bool debug =
#ifdef DEBUG
    true
#else
false
#endif
;

// --------

template<class T>
using ordered_set = __gnu_pbds::tree<T,
                                     __gnu_pbds::null_type,
                                     less<T>,
                                     __gnu_pbds::rb_tree_tag,
                                     __gnu_pbds::tree_order_statistics_node_update,
                                     allocator<T>>;

template<class T, class M>
using ordered_map = __gnu_pbds::tree<T,
                                     M,
                                     less<T>,
                                     __gnu_pbds::rb_tree_tag,
                                     __gnu_pbds::tree_order_statistics_node_update,
                                     allocator<T>>;

#ifndef DEBUG
#define endl '\n'
#endif

void solve() {
  ll n, q;
  cin >> n >> q;
  vi c(n);
  cin >> c;

  set<ll> uniq(c.begin(), c.end());
  ordered_set<ii> segs;
  ll timer = 1;
  ll last = *uniq.begin();
  for (auto e : uniq) {
    if (e != last) {
      segs.insert({e - last, timer++});
    }
    last = e;
  }

  for (int qq = 0; qq < q; ++qq) {
    ll t, k;
    cin >> t >> k;
    if (t == 1) {
      ll ans = (ll) segs.order_of_key({k, 1e18});
      ans = (ll) segs.size() - ans + 1;
      cout << ans << endl;
    }
  }
}