#pragma optimize("Ofast")
#pragma optimize("O3")
#pragma optimize("unroll-loops")
#pragma target("sse,sse2,avx,avx2")

#include <iostream>
#include <vector>
#include <set>
#include <iomanip>
#include <string>
#include <assert.h>
#include <algorithm>
#include <cmath>

using namespace std;

using ll = long long;

#define all(x) begin(x), end(x)
#define rall(x) rbegin(x), rend(x)

const int mod = 1e9 + 7;
const int N = 400000;

pair<int, int> c[N];
ll ans[N];
ll a[N];
int p[N];

struct ev
{
	ll t;
	int v, u;

	bool operator<(ev& x)
	{
		return t < x.t;
	}
};

struct query
{
	ll t;
	int type, id, i;

	bool operator<(query& x)
	{
		return t < x.t;
	}
};

void solve()
{
	int n, m;
	cin >> n >> m;

	for (int i = 0; i < n; i++)
	{
		cin >> c[i].first;
		c[i].second = i;
	}

	sort(c, c + n);
	reverse(c, c + n);

	for (int i = 0; i < n; i++)
	{
		p[c[i].second] = i;
		a[i] = c[i].first;
	}

	vector<ev> sw;

	for (int i = 0; i < n - 1; i++)
	{
		sw.push_back({ a[i] - a[i + 1], i, i + 1 });
	}

	sort(all(sw));
	vector<query> q(m);

	for (int i = 0; i < m; i++)
	{
		cin >> q[i].type >> q[i].t;
		q[i].id = i;
		if (q[i].type == 3)
		{
			cin >> q[i].i;
			q[i].i--;
		}
	}

	sort(all(q));
	int j = 0;
	ll pepo = 0;
	ll prv = 0;

	for (int i = 0; i < m; i++)
	{
		while (j < sw.size() && sw[j].t <= q[i].t)
		{
			set<ll> pop;
			for (int i = 0; i < n; i++)
			{
				ll add = pop.size();
				if (pop.find(a[i]) != pop.end())
				{
					add--;
				}
				pop.insert(a[i]);
				a[i] += add * (sw[j].t - prv);
				pepo += add * (sw[j].t - prv);
			}
			prv = sw[j].t;
			j++;
		}
		if (q[i].type == 1)
		{
			int p = 0;
			set<ll> pop;
			for (int i = 0; i < n; i++)
			{
				pop.insert(a[i]);
			}
			ans[q[i].id] = pop.size();
		}
		else if (q[i].type == 2)
		{
			ll cur = q[i].t;
			ll out = pepo;
			set<ll> pop;
			for (int j = 0; j < n; j++)
			{
				ll add = pop.size();
				if (pop.find(a[j]) != pop.end())
				{
					add--;
				}
				pop.insert(a[j]);
				out += add * (cur - prv);
			}
			ans[q[i].id] = out;
		}
		else
		{
			set<ll> pop;
			for (int j = 0; j < n; j++)
			{
				ll add = pop.size();
				if (pop.find(a[j]) != pop.end())
				{
					add--;
				}
				pop.insert(a[j]);
				if (p[q[i].i] == j)
				{
					ans[q[i].id] = a[j] + add * (q[i].t - prv);
				}
			}
		}
	}

	for (int i = 0; i < m; i++)
	{
		cout << ans[i] << '\n';
	}

}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t = 1;
	// cin >> t;

	while (t--)
	{
		solve();
	}

	return 0;
}