#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <string>
#include <unordered_map>
#include <unordered_set>

using namespace std;

#define vout(v) for (auto i : v) cout << i;

struct query {
    int t;
    long long k;
    int ind;
    int pl = 0;
};

bool cmp(query a, query b) {
    return a.k < b.k;
}

signed main() {
    ios_base::sync_with_stdio(NULL);
    cin.tie(NULL);
    cout.tie(NULL);
#ifdef DEBUG_BENTSA
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
#endif
    int n, q;
    cin >> n >> q;
    vector<long long> v(n), real(n);
    long long start_sum = 0, mx = 0;
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
        start_sum += v[i];
        mx = max(mx, v[i]);
    }
    vector<long long> cur;
    unordered_map<long long, int> cnt;
    for (int i = 0; i < n; ++i) {
        real[i] = v[i];
        cnt[v[i]] += 1;
        cur.push_back(v[i]);
    }
    sort(cur.begin(), cur.end());
    cur.erase(unique(cur.begin(), cur.end()), cur.end());
    set<long long> all_d;
    auto w = v;
    sort(w.begin(), w.end());
    for (int i = 0; i < w.size() - 1; ++i) {
        if (w[i] == w[i + 1]) continue;
        all_d.insert(w[i + 1] - w[i]);
    }
    vector<long long> ans_q(q);
    vector<query> qq;
    for (int i = 0; i < q; ++i) {
        int t, k;
        cin >> t >> k;
        if (t != 3) {
            qq.push_back({t, k, i});
        } else {
            int pl;
            cin >> pl;
            --pl;
            qq.push_back({t, k, i, pl});
        }
    }
    sort(qq.begin(), qq.end(), cmp);
    int now_q = 0;
    long long prev_sum = 0;
    long long cur_sum = 0;
    int prev_k = 0;
    unordered_map<long long, int> plus;
    cur_sum = 0;
    for (int i = 0; i < cur.size(); ++i) {
        long long x = cur[cur.size() - 1 - i];
        plus[x] = i;
        cur_sum += plus[x] * cnt[x];
    }
    vector<int> done(q);
    for (auto k : all_d) {
        while (now_q < q && qq[now_q].k < k) {
            query curr = qq[now_q];
            int t = curr.t;
            if (t == 1) {
                ans_q[curr.ind] = cur.size();
            } else if (t == 2) {
                ans_q[curr.ind] = prev_sum + (curr.k - prev_k) * cur_sum;
            } else {
                int x = real[curr.pl];
                ans_q[curr.ind] = x + (curr.k - prev_k) * plus[x];
            }
            done[curr.ind] = 1;
            ++now_q;
        }
        vector<long long> new_real(n);
        for (int i = 0; i < n; ++i) {
            long long x = real[i];
            new_real[i] = x + (k - prev_k) * plus[x];
        }
        real = new_real;
        prev_sum += (k - prev_k) * cur_sum;
        vector<long long> new_cur;
        unordered_map<long long, int> new_cnt;
        for (int i = 0; i < cur.size(); ++i) {
            int x = cur[i];
            int nx = x + (k - prev_k) * plus[x];
            new_cur.push_back(nx);
            if (new_cur.size() > 1 && new_cur.back() == new_cur[new_cur.size() - 2]) {
                new_cur.pop_back();
            }
            new_cnt[nx] += cnt[i];
        }
        cur = new_cur;
        cnt = new_cnt;
        plus.clear();
        cur_sum = 0;
        for (int i = 0; i < cur.size(); ++i) {
            long long x = cur[cur.size() - 1 - i];
            plus[x] = i;
            cur_sum += plus[x] * cnt[x];
        }
        prev_k = k;
    }
    for (int i = 0; i < q; ++i) {
        if (!done[qq[i].ind]) {
            int t = qq[i].t;
            if (t == 1) {
                ans_q[qq[i].ind] = 1;
            } else if (t == 2) {
                ans_q[qq[i].ind] = mx * n - start_sum;
            } else {
                ans_q[qq[i].ind] = mx;
            }
        }
    }
    for (int i = 0; i < q; ++i) {
        cout << ans_q[i] << "\n";
    }
}
