#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;

#define int ll
#define len(a) (int)(a).size()
#define all(a) (a).begin(), (a).end()


__int128 binpow(__int128 base, int power) {
    __int128 res = 1;
    while (power > 0) {
        if (power & 1)
            res *= base;
        base *= base;
        power >>= 1;
    }
    return res;
}

struct segmenttree {
    int n = 1;
    vector<int> tree;

    segmenttree(int l) {
        while (n < l) n <<= 1;
        tree.resize(n * 2);
    }

    void update(int l, int r, int u) {
        for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
            if (l & 1) tree[l++] += u;
            if (r & 1) tree[--r] += u;
        }
    }

    int query(int t) {
        int res = 0;
        for (t += n; t > 0; t >>= 1) {
            res += tree[t];
        }
        return res;
    }
};

__int128 stoi128(string & s) {
    __int128 res = 0;
    for (char c : s) {
        res = res * 10 + (c - '0');
    }
    return res;
}


void solve() {
    string x;
    ll y;
    cin >> x >> y;
    int n = len(x);
    vector<stack<int>> positions(10);
    for (int i = n - 1; i >= 0; --i) {
        positions[x[i] - '0'].push(i);
    }
    for (int i = 0; i < n - 25; ++i) {
        for (int digit = 9; digit >= 0; --digit) {
            if (!positions[digit].empty()) {
                cout << digit;
                positions[digit].pop();
                break;
            }
        }
    }
    x.clear();
    for (int i = max(0ll, n - 25); i < n; ++i) {
        int smallest_pos = -1;
        for (int digit = 0; digit < 10; ++digit) {
            if (!positions[digit].empty()) {
                if (smallest_pos == -1 || positions[digit].top() < positions[smallest_pos].top())
                    smallest_pos = digit;
            }
        }
        x.push_back('0' + smallest_pos);
        positions[smallest_pos].pop();
    }
    auto construct_str = [&](int pos){
        return x.substr(0, pos) + x.substr(pos + 1, len(x) - pos - 1);
    };
    while (len(x) > 0) {
        int best_pos = 0;
        __int128 val = 0;
        for (int i = 0; i < len(x); ++i) {
            string s = x.substr(i, 1) + construct_str(i);
            __int128 cur_val = stoi128(s);
            cur_val -= (__int128)i * (__int128)y;
            if (cur_val >= val) {
                best_pos = i;
                val = cur_val;
            }
        }
        cout << x[best_pos];
        x = construct_str(best_pos);
    }
    cout << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
    return 0;
}