#include <bits/stdc++.h>

using namespace std;
#define int long long

struct SegTree {
    int n, len;
    vector <int> t, p;

    SegTree(int n) : n(n) {
        len = 1 << (int)ceil(log2(n));
        t.resize(2 * len);
        p.resize(2 * len);
        build(1, 0, len - 1);
    }

    void build(int v, int l, int r) {
        if (l == r) {
            if (l < n) t[v] = n - l - 1;
            return;
        }
        int m = (l + r) / 2;
        build(2 * v, l, m);
        build(2 * v + 1, m + 1, r);
        t[v] = t[2 * v] + t[2 * v + 1];
    }

    inline void push(int v, int ln) {
        t[2 * v] += ln * p[v];
        t[2 * v + 1] += ln * p[v];
        p[2 * v] += p[v];
        p[2 * v + 1] += p[v];
        p[v] = 0;
    }

    void update(int v, int l, int r, int A, int B) {
        if (l > B || A > r) return;
        if (A <= l && r <= B) {
            t[v] -= r - l + 1;
            --p[v];
            return;
        }
        push(v, (r - l + 1) / 2);
        int m = (l + r) / 2;
        update(2 * v, l, m, A, B);
        update(2 * v + 1, m + 1, r, A, B);
        t[v] = t[2 * v] + t[2 * v + 1];
    }

    inline void upd(int i) {
        update(1, 0, len - 1, 0, i);
    }
};
signed main() {
    if (1) {
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
        cout.tie(nullptr);
    }
    int n, q;
    cin >> n >> q;
    vector <int> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    vector <pair <int, int>> all_moments;
    sort(a.begin(), a.end());
    for (int i = 0; i < n - 1; ++i) {
        all_moments.emplace_back(a[i + 1] - a[i], i);
    }
    sort(all_moments.begin(), all_moments.end());
    vector <int> ans(q);
    vector <pair <int, int>> all2;
    for (int i = 0; i < q; ++i) {
        int type;
        cin >> type;
        if (type == 1) {
            int k;
            cin >> k;
            ans[i] = n - (upper_bound(all_moments.begin(), all_moments.end(), make_pair(k + 1, -1LL)) - all_moments.begin());
        } else if (type == 2) {
            int k;
            cin >> k;
            all2.emplace_back(k, i);
        } else {
            int pos, k;
            cin >> pos >> k; --pos;
        }
    }
    sort(all2.begin(), all2.end());
    int sum = 0, cura = 0, curq = 0, last = 0;
    SegTree t(n);
    while (curq < (int)all2.size()) {
        if (cura == n - 1 || (all_moments[cura].first >= all2[curq].first)) {
            ans[all2[curq].second] = sum + t.t[1] * (all2[curq].first - last);
            ++curq;
        } else {
            int nlast = all_moments[cura].first;
            sum += t.t[1] * (nlast - last);
            t.upd(all_moments[cura].second);
            last = nlast;
            ++cura;
        }
    }
    for (int i : ans) cout << i << "\n";
    return 0;
}
