#include <bits/stdc++.h>
using namespace std;

#define int long long

struct query {
    int type, k, pos, i;
    query(int type, int k, int pos, int i) : type(type), k(k), pos(pos), i(i) {}
};

vector<int> p;
vector<int> siz;

int get(int v) {
    if (v == p[v]) return v;
    p[v] = get(p[v]);
    return p[v];
}

void merge(int u, int v) {
    if (siz[u] > siz[v]) swap(u, v);
    siz[v] += siz[u];
    siz[u] = 0;
    p[get(u)] = get(v);
}

bool cmp(query a, query b) {
    if (a.k == b.k) return a.type < b.type;
    return a.k < b.k;
}

vector<int> mod_1;
vector<int> mod_2;

void update1(int v, int l, int r, int ql, int qr, int x) {
    if (l >= qr || ql >= r) return;
    if (ql <= l && r <= qr) {
        mod_1[v] += x;
        return;
    }
    int m = (l + r) / 2;
    update1(2 * v, l, m, ql, qr, x);
    update1(2 * v + 1, m, r, ql, qr, x);
}

void update2(int v, int l, int r, int ql, int qr, int x) {
    if (l >= qr || ql >= r) return;
    if (ql <= l && r <= qr) {
        mod_2[v] += x;
        return;
    }
    int m = (l + r) / 2;
    update2(2 * v, l, m, ql, qr, x);
    update2(2 * v + 1, m, r, ql, qr, x);
}


int get1(int v, int l, int r, int i) {
    if (l == r - 1) return mod_1[v];
    int m = (l + r) / 2;
    if (i < m) return get1(2 * v, l, m, i) + mod_1[v];
    else return get1(2 * v + 1, m, r, i) + mod_1[v];
}

int get2(int v, int l, int r, int i) {
    if (l == r - 1) return mod_2[v];
    int m = (l + r) / 2;
    if (i < m) return get2(2 * v, l, m, i) + mod_2[v];
    else return get2(2 * v + 1, m, r, i) + mod_2[v];
}

signed main() {
    int n, q;
    cin >> n >> q;
    mod_1.resize(4 * n);
    mod_2.resize(4 * n);
    vector<int> c(n);
    for (int i = 0; i < n; i++) cin >> c[i];
    vector<int> sorted_c = c;
    sort(sorted_c.begin(), sorted_c.end());
    vector<int> tmp;
    tmp.push_back(sorted_c[0]);
    for (int i = 1; i < n; i++) if (sorted_c[i] != tmp.back()) tmp.push_back(sorted_c[i]);
    sorted_c = tmp;
    vector<int> diff;
    vector<query> queries;
    int ct = sorted_c.size();
    for (int i = 1; i < (int)sorted_c.size(); i++) diff.push_back(sorted_c[i] - sorted_c[i - 1]);
    for (int i = 0; i < (int)diff.size(); i++) {
        if (diff[i] == 0) continue;
        queries.push_back(query(0, diff[i], i, -1));
    }

    unordered_map<int, int> squished;
    for (int i = 0; i < ct; i++) squished[sorted_c[i]] = i;

    p.resize(ct);
    for (int i = 0; i < ct; i++) p[i] = i;
    siz.resize(ct, 1);
    vector<int> counts(ct, 0);
    for (int i = 0; i < n; i++) counts[squished[c[i]]]++;
    vector<int> pref_counts(ct + 1, 0);
    for (int i = 1; i <= ct; i++) pref_counts[i] = pref_counts[i - 1] + counts[i - 1];
    int curr = 0;
    int curr_mul = 0;
    for (int i = ct - 1; i >= 0; i--) {
        curr += curr_mul * counts[i];
        curr_mul++;
    }

//    for (int i : diff) cout << i << " ";
    for (int i = 0; i < q; i++) {
        int t, k, pos = -1;
        cin >> t >> k;
        if (t == 3) cin >> pos;
        queries.push_back(query(t, k, pos, i));
    }
    sort(queries.begin(), queries.end(), cmp);
    vector<int> ans(q);
    int sum = 0;
    int prev_k = 0;
    int global_ct = ct;
    for (auto p : queries) {
//        cout << p.k << "K\n";
        sum += (p.k - prev_k) * curr;
        prev_k = p.k;
//        cout << p.k << " " << sum << "\n";
        if (p.type == 0) {
            update1(1, 1, n + 1, 1, p.pos + 1, 1);
            update2(1, 1, n + 1, 1, p.pos + 1, p.k);
            curr -= pref_counts[p.pos + 1];
            merge(p.pos, p.pos + 1);
            ct--;
        }
        else if (p.type == 1) ans[p.i] = ct;
        else if (p.type == 2) ans[p.i] = sum;
        else if (p.type == 3) {
            int pos = squished[c[p.pos - 1]];
//            cout << pos << "\n";
            ans[p.i] = c[p.pos - 1] + p.k * (global_ct - pos - 1);
//            cout << ans[p.i] << "\n";
            ans[p.i] -= get1(1, 1, n + 1, pos + 1) * p.k;
            ans[p.i] += get2(1, 1, n + 1, pos + 1);
        }
    }
    for (int i : ans) cout << i << "\n";
}
