#include <iostream>
#include <algorithm>

typedef long long ll;

using namespace std;

ll upper(pair<ll, ll>* arr, ll n, ll x)
{
	if (n > 0 && arr[0].first > x) return 0;
	ll l = 0, r = n;
	while (r > l + 1)
	{
		auto m = (l + r) / 2;
		if (arr[m].first > x) r = m;
		else l = m;
	}
	return r;
}

int main()
{
	ll n, q;
	cin >> n >> q;

	// start level, number
	auto arr = new pair<ll, ll>[n];
	for (ll i = 0; i < n; i++)
	{
		ll x;
		cin >> x;
		arr[i] = pair<ll, ll>(x, i + 1);
	}
	sort(arr, arr + n);
	
	auto moments = new pair<ll, ll>[n - 1];
	for (ll i = 0; i < n - 1; i++)
	{
		moments[i] = pair<ll, ll>(arr[i + 1].first - arr[i].first, i + 1);
	}
	sort(moments, moments + n - 1);

	auto sums_lower = new pair <ll, ll>[n] ;
	sums_lower[0] = pair<ll, ll>(0, n * (n - 1) / 2);
	for (ll i = 0; i < n - 1; i++)
	{
		sums_lower[i + 1] = pair<ll, ll>(sums_lower[i].first + moments[i].first * moments[i].second, sums_lower[i].second - moments[i].second);
	}

	for (ll i = 0; i < q; i++)
	{
		ll t, k, ans;
		cin >> t >> k;
		switch (t)
		{
		case 1:
			ans = n - upper(moments, n - 1, k);
			break;
		case 2:
			ans = 0;
			ll m;
			m = upper(moments, n - 1, k);
			ans = sums_lower[m].first + sums_lower[m].second * k;
			break;
		case 3:
			ll p;
			cin >> p;
			for (ll j = 0; j < n; j++)
			{
				if (arr[j].second != p) continue;
				p = j;
				break;
			}
			ans = arr[p].first;
			for (ll j = p; j < n - 1; j++)
			{
				if (arr[j + 1].first - arr[j].first <= k) ans += arr[j + 1].first - arr[j].first;
				else ans += k;
			}
			break;
		default:
			return 1;
		}
		cout << ans << endl;
	}

	return 0;
}
