#include <iostream>
#include <vector>
#include <set>
#include <queue>

#define ll long long
#define pl pair<ll, ll>

using namespace std;

set<ll> find_component(vector<ll>* graph, ll n, ll no)
{
	auto res = set<ll>();
	auto q = vector<ll>();
	q.push_back(graph[no].back());
	while (!q.empty())
	{
		ll x = q.back();
		q.pop_back();
		if (x == no || res.find(x) != res.end()) continue;
		res.insert(x);
		for (auto y : graph[x])
		{
			q.push_back(y);
		}
	}
	return res;
}

int main()
{
	ll t, n, m;
	cin >> t;
	for (ll i = 0; i < t; i++)
	{
		cin >> n >> m;
		auto graph = new vector<ll>[n];
		for (ll i = 0; i < n; i++)
		{
			graph[i] = vector<ll>();
		}
		for (ll i = 0; i < m; i++)
		{
			ll u, v;
			cin >> u >> v;
			u--;
			v--;
			graph[u].push_back(v);
			graph[v].push_back(u);
		}
		auto components = new set<ll>[n];
		for (ll i = 0; i < n; i++)
		{
			components[i] = find_component(graph, n, i);
		}
		auto minimums = new ll[n];
		for (ll i = 0; i < n; i++)
		{
			minimums[i] = -1;
		}

		auto q = priority_queue<pl, vector<pl>,
			greater<vector<pl>::value_type>>();
		q.emplace(0, 0);
		while (!q.empty())
		{
			auto x = q.top();
			q.pop();
			if (minimums[x.second] != -1) continue;
			minimums[x.second] = x.first;
			for (auto y : graph[x.second])
			{
				for (auto z : graph[y])
				{
					if ((components[y].find(x.second) == components[y].end()) == (components[y].find(z) == components[y].end()))
						q.emplace(x.first + 2, z);
				}
			}
		}

		for (ll i = 1; i < n; i++)
		{
			cout << minimums[i] << endl;
		}
	}
	return 0;
}
