#include <iostream>
#include <vector>
#include<math.h>
#include<algorithm>
#include <string>
#include <cstring>
#include <tuple>
#include <queue>

using namespace std;

typedef pair<int, int> pii;

const int INF = 1e9;

vector<vector<pii>> gr;
int timer = 0;
vector<int> tin, fup;
vector<bool> used, bridge;
int block = -1;

void dfs(int v, int p = -1) {
	used[v] = 1;
	tin[v] = timer++;
	fup[v] = tin[v];
	for (pii e : gr[v]) {
		int u, id;
		tie(u, id) = e;
		if (id == block || id == p) continue;
		if (!used[u]) {
			dfs(u, id);
			if (fup[u] > tin[v]) {
				bridge[id] = true;
			}
			fup[v] = min(fup[v], fup[u]);
		}
		else {
			fup[v] = min(fup[v], tin[u]);
		}
	}
}

void solve() { //todo init
	int n, m, v, u;
	cin >> n >> m;
	gr.resize(n);
	tin.resize(n);
	fup.resize(n);
	vector<pii> edges;
	for (int i = 0; i < m; i++) {
		cin >> v >> u;
		v--, u--;
		gr[v].push_back({ u, i });
		gr[u].push_back({ v, i });
		edges.emplace_back(v, u);
	}
	vector<vector<int>> t(n);
	for (int i = 0; i < m; i++) {
		int v, f, u, id;
		tie(v, f) = edges[i];
		
		block = i;

		timer = 0;
		bridge.assign(m, 0);
		used.assign(n, 0);
		dfs(0);
		for (auto e : gr[f]) {
			tie(u, id) = e;
			if (u == v) continue;
			if (bridge[id]) {
				t[v].push_back(u);
				t[u].push_back(v);
			}
		}
		swap(f, v);
		for (auto e : gr[f]) {
			tie(u, id) = e;
			if (u == v) continue;
			if (bridge[id]) {
				t[v].push_back(u);
				t[u].push_back(v);
			}
		}
	}
	vector<int> dist(n, INF);
	dist[0] = 0;
	queue<int> q;
	q.push(0);
	while (!q.empty()) {
		int v = q.front();
		q.pop();
		for (auto u : t[v]) {
			if (dist[u] > dist[v] + 1) {
				dist[u] = dist[v] + 1;
				q.push(u);
			}
		}
	}
	for (int v = 1; v < n; v++) {
		if (dist[v] == INF)
			cout << "-1 ";
		else
			cout << 2 * dist[v] << ' ';
	}
	cout << '\n';
}

void init() {
	timer = 0;
	block = -1;
	tin.clear();
	fup.clear();
	gr.clear();
	bridge.clear();
	used.clear();
}

int main()
{
	int t;
	cin >> t;
	while (t--) {
		init();
		solve();
	}
}