#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define ll long long
#define pii pair<int, int>
#define all(x) begin(x), end(x)
#define rall(x) rbegin(x), rend(x)
#define mp(x, y) make_pair(x, y)
#define mt make_tuple
#define sz(x) (int) size(x)

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

template<typename T>
bool ckmx(T &a, T b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}


template<typename T>
bool ckmn(T &a, T b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}


const int infI = 1e9 + 7;
const ll infL = 2e18;
const ll mod = 98244353;
const int N = (200) + 2;

vector<int> g[N];
int pnt[N], dist[N];
struct edge {
    int v, to, f, c;
    edge() = default;
    edge(int a, int b, int C, int d) {
        v = a, to = b, f = C, c = d;
    }
};

int S = N - 2, T = N - 1;

vector<edge> e;

void create(int a, int b, int c) {
    g[a].push_back(sz(e));
    e.emplace_back(a, b, 0, c);
    g[b].push_back(sz(e));
    e.emplace_back(b, a, 0, 0);
}

bool bfs() {
    fill(dist, dist + N, infI);
    dist[S] = 0;
    queue<int> q;
    q.push(S);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (int i : g[v]) {
            if (e[i].f != e[i].c && dist[e[i].to] == infI) {
                dist[e[i].to] = dist[v] + 1;
                q.push(e[i].to);
            }
        }
    }
    return (dist[T] != infI);
}

int dfs(int v, int MinC) {
    if (v == T) return MinC;
    while (pnt[v] < sz(g[v])) {
        int i = g[v][pnt[v]];
        if (dist[e[i].to] == dist[e[i].v] + 1 && e[i].f != e[i].c) {
            int delta = dfs(e[i].to, min(MinC, e[i].c - e[i].f));
            if (delta) {
                e[i].f += delta;
                e[i ^ 1].f -= delta;
                return delta;
            }
        }
        ++pnt[v];
    }
    return 0;
}

int A[N], L[N], R[N], C[N], Ty[N];

void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        cin >> A[i];
        create(i + m, T, A[i]);
    }
    for (int i = 0; i < m; ++i) {
        cin >> L[i] >> R[i] >> C[i] >> Ty[i];
        --L[i], --R[i];
    }
    for (int x = 0; x < n; ++x) {
        e.clear();
        g[S].clear();
        g[T].clear();
        for (int i = 0; i < n; ++i) {
            g[i + m].clear();
            create(i + m, T, A[i]);
        }
        for (int i = 0; i < m; ++i) {
            g[i].clear();
            create(S, i, C[i]);
        }
        for (int i = 0; i < m; ++i) {
            if (Ty[i] == 0) {
                for (int l = L[i]; l <= R[i]; ++l) {
                    create(i, l + m, infI);
                }
            } else {
                for (int l = min(L[i], x); l <= max(R[i], x); ++l) {
                    create(i, l + m, infI);
                }
            }
        }
        ll ans = 0;
        while (bfs()) {
            memset(pnt, 0, sizeof(pnt));
            while (int y = dfs(S, infI)) ans += y;
        }
        cout << ans << " ";
    }
    cout << '\n';
}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int test = 1;
    cin >> test;
    while (test--)
        solve();
    return 0;
}