#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm> 
#include <deque>


using namespace std;
typedef long long ll;

struct bot {
	int l, r, t, c;
	bot() = default;
};

struct eve {
	int tme, type;
	int c, close, i;
	eve() = default;
	eve(int time, int t, int op) {
		tme = time;
		type = t;
		c = op;
	}
	eve(int time, int t, int have, int cl) {
		tme = time;
		type = t;
		c = have;
		close = cl;
	}
	bool operator<(eve b) {
		return tme < b.tme || (tme == b.tme && type < b.type);
	}
};

ll get_ans(vector<ll>&a, vector<eve>& scan, int m) {
	sort(scan.begin(), scan.end());
	ll ans = 0;
	vector<ll>have(m), used(a.size());
	int j = 0;
	set<pair<int, pair<int, int>>>s;
	for (auto el : scan) {
		if (el.type == 0) {
			have[el.i] = el.c;
			s.insert({ el.close, {el.c, el.i} });
			j = max(j, el.tme - 1);
		}
		if (el.tme >= j + 1 && !s.empty()) {
			while (!s.empty() && el.tme >= j + 1) {
				int i = s.begin()->second.second, close = s.begin()->first;
				s.erase(s.begin());
				if (a[j] - used[j] >= have[i])
					used[j] += have[i], ans += have[i], have[i] = 0;
				else {
					have[i] -= a[j] - used[j];
					ans += a[j] - used[j];
					used[j] = a[j];
					s.insert({ close, {have[i], i} });
				}
				if (used[j] == a[j])
					j++;
			}
		}
		
		if(el.type == 2) {
			s.erase({ el.tme, {have[el.i], el.i} });
		}
	}
	return ans;
}

void solve() {
	int n, m;
	cin >> n >> m;
	vector<ll>a(n), pref(n + 1, 0);
	vector<bot>bots(m);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		// pref[i + 1] = pref[i] + a[i];
	}
	for (int i = 0; i < m; i++) {
		cin >> bots[i].l >> bots[i].r >> bots[i].c >> bots[i].t;
	}
	for (int x = 0; x < n; x++) {
		vector<eve>scan;
		for (int i = 0; i < m; i++) {
			int l = bots[i].l, r = bots[i].r;
			if (bots[i].t == 1)
				l = min(l, x + 1), r = max(r, x + 1);
			scan.push_back(eve(l, 0, bots[i].c, r));
			scan.back().i = i;
			scan.push_back(eve(r, 2, -1));
			scan.back().c = l;
			scan.back().i = i;
		}
		cout << get_ans(a, scan, m) << ' ';
	}
}

int main() {
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	int t = 1;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}