#pragma GCC target("avx,avx2,sse4,sse4.1,sse4.2")

#include<iostream>
#include<vector>
#include<algorithm>
#include<cmath>
#include<ctime>
#include<map>
#include<set>

using namespace std;
#define int long long
#define all(x) (x).begin(), (x).end()

const int INF = 1e18;

int n, m;

int t;
vector<int> used;
vector<vector<int>> comp, g;

int cur_comp, exc;
void dfs(int v) {
    used[v] = t;
    comp[exc][v] = cur_comp;
    for (int u : g[v]) {
        if (used[u] != t && u != exc) {
            dfs(u);
        }
    }
}

void init() {
    t = 0;
    g.assign(n, {});
    used.assign(n, -1);
    comp.assign(n, vector<int> (n, -1));
}

void solve() {
    cin >> n >> m;
    init();
    vector<pair<int, int>> edges;
    for (int i = 0; i < m; ++i) {
        int v, u;
        cin >> v >> u;
        g[v - 1].push_back(u - 1);
        g[u - 1].push_back(v - 1);
        edges.emplace_back(u - 1, v - 1);
        edges.emplace_back(v - 1, u - 1);
    }
    for (int i = 0; i < n; ++i) {
        exc = i;
        cur_comp = 0;
        for (int j = 0; j < n; ++j) {
            if (used[j] != t) {
                dfs(j);
                ++cur_comp;
            }
        }
        ++t;
    }
    bool changed = true;
    vector<array<int, 2>> dp(n, {INF, INF});
    dp[0][1] = 1;
    while (changed) {
        changed = false;
        for (auto [v, u] : edges) {
            if (comp[u][v] == comp[u][0] && dp[v][1] > dp[u][0] + 1) {
                dp[v][1] = dp[u][0] + 1;
                changed = true;
            }
            if (dp[u][0] > dp[v][1] + 1) {
                dp[u][0] = dp[v][1] + 1;
                changed = true;
            }
        }
    }
    for (int i = 1; i < n; ++i) {
        cout << (dp[i][1] == INF ? -1 : dp[i][1] - 1) << ' ';
    }
    cout << endl;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.setf(ios::fixed);
    cout.precision(20);
    int t; cin >> t;
    while (t--) {
        solve();
    }
}