#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <cmath>
#include <ctime>
#include <iomanip>
#include <utility>
#include <vector>
#include <string>
#include <queue>
#include <deque>
#include <list>
#include <array>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <list>
#include <sstream>
#include <cassert>
#include <random>
#include <chrono>
#include <numeric>

#define all(_a) _a.begin(), _a.end()
#define rall(_a) _a.rbegin(), _a.rend()

using namespace std;

struct Request {
	int type;
	long long k;
	int ind;
	int index;

	Request() {}
	Request(int type, long long k, int ind, int index) : type(type), k(k), ind(ind), index(index) {}
};

bool operator < (const Request& a, const Request& b) {
	return a.k < b.k;
}

vector<Request> requests;

int n;

struct Value {
	long long val;
	vector<int> index;

	Value() {}
	Value(long long val, const vector<int>& index) : val(val), index(index) {}
};

list<Value> a;

vector<long long> c;

void init() {
	map<long long, vector<int>> tmp_index;
	for (int i = 0; i < n; ++i) {
		tmp_index[c[i]].push_back(i);
	}

	for (auto it = tmp_index.begin(); it != tmp_index.end(); ++it) {
		a.push_back({ it->first, it->second });
	}
}

long long t;

long long sum;

void go(long long time) {
	int cnt = a.size() - 1;
	for (auto it = a.begin(); it != a.end(); ++it) {
		it->val += cnt * time;
		sum += 1ll * cnt * time * it->index.size();
		--cnt;
	}
	auto it = a.begin();
	while (it != --a.end()) {
		auto n_it = next(it);
		if (it->val == n_it->val) {
			for (int ind : it->index) {
				n_it->index.push_back(ind);
			}
			it = a.erase(it);
		} else {
			++it;
		}
	}
	t += time;
}

long long query(const Request& request) {
	auto [q_type, q_t, q_ind, index_t] = request;
	while (t < q_t) {
		go(1);
	}
	if (q_type == 1) {
		return a.size();
	} else if (q_type == 2) {
		return sum;
	} else {
		for (auto it = a.begin(); it != a.end(); ++it) {
			for (int ind : it->index) {
				if (q_ind == ind) {
					return it->val;
				}
			}
		}
	}
}

vector<long long> answer;

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

#ifdef LOCAL
	freopen("input.txt", "r", stdin);
#endif

	int q;
	cin >> n >> q;
	answer.resize(q);
	c.resize(n);
	for (long long& x : c) {
		cin >> x;
	}
	requests.resize(q);
	int i = 0;
	for (auto& [type, k, ind, index] : requests) {
		cin >> type >> k;
		if (type == 3) {
			cin >> ind;
			--ind;
		}
		index = i++;
	}
	sort(all(requests));

	init();
	for (int i = 0; i < q; ++i) {
		answer[requests[i].index] = query(requests[i]);
	}
	for (int i = 0; i < q; ++i) {
		cout << answer[i] << '\n';
	}
}