#include <iostream>
#include <vector>
#include <deque>
#include <numeric>
#include <map>
#include <algorithm>
#define all(x) x.begin(), x.end()
using namespace std;
#define int long long

const int maxn = 3e5;
int p[maxn];
int sz[maxn];
int maxId[maxn];
int cost[maxn];
int add;
vector<int> a;

int col(int v) {
    return (v == p[v] ? v : p[v] = col(p[v]));
}

void unite(int u, int v, int d) {
    u = col(u);
    v = col(v);
    if (sz[u] > sz[v]) swap(u, v);
    for (int j = min(maxId[v], maxId[u]); j >= 0; --j) {
        a[j] += d * cost[j];
        cost[j]--;
    }
    p[u] = v;
    add -= min(maxId[v], maxId[u]) + 1;
    maxId[v] = max(maxId[v], maxId[u]);
    sz[v] += sz[u];
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, q;
    cin >> n >> q;
    iota(p, p + n, 0);
    iota(maxId, maxId + n, 0);
    fill(sz, sz + n, 1);
    a.resize(n);
    vector<pair<int, int>> ff;
    for (int& i : a) {
        cin >> i;
    }
    for (int i = 0; i < n; ++i) {
        ff.push_back({ a[i], i });
    }
    sort(all(ff));
    map<int, int> per;
    for (int i = 0; i < n; ++i) {
        per[ff[i].second] = i;
    }
    for (int i = 0; i < n; ++i) {
        cost[i] = n - i - 1;
    }
    sort(all(a));
    vector<pair<int, int>> un;
    for (int i = 0; i + 1 < n; ++i) {
        un.push_back({ a[i + 1] - a[i], i });
    }
    sort(all(un));
    vector<pair<pair<int, int>, pair<int, int>>> qq;
    for (int j = 0; j < q; ++j) {
        int t, k, i;
        cin >> t;
        if (t == 3) {
            cin >> k >> i;
        } else {
            cin >> k;
            i = k;
        }
        qq.push_back({ { k, j }, { t, per[i - 1] } });
    }
    int have = n - 1;
    add = have * (have + 1) / 2;
    int ptr = 0;
    sort(all(qq));
    vector<int> ans(q);
    int pr = 0;
    int ans2 = 0;
    for (auto [ aa, b] : qq) {
        auto [k, j] = aa;
        auto [t, i] = b;
        while (ptr < un.size() && un[ptr].first <= k) {
            int i = un[ptr].second;
            ans2 += (un[ptr].first - pr) * add;
            unite(i, i + 1, un[ptr].first - pr);
            pr = un[ptr].first;
            --have;
            ++ptr;
        }
        ans2 += (k - pr) * add;
        if (t == 1) {
            ans[j] = have + 1;
        } else if (t == 2) {
            ans[j] = ans2;
        } else {
            ans[j] = a[i] + (k - pr) * cost[i];
        }
        pr = k;
    }
    for (int i : ans) {
        cout << i << '\n';
    }
}