#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <queue>
#include <map>
#include <string>

using namespace std;

typedef long long ll;

#define int ll

struct Edge {
	int u, v, c, f, idx;

	Edge(int u_, int v_, int c_, int f_, int idx_) {
		u = u_;
		v = v_;
		c = c_;
		f = f_;
		idx = idx_;
	}
};

vector<vector<Edge>> graph;
vector<bool> used;
vector<int> dist;
vector<int> abcd;

bool bfs() {
	dist.assign(graph.size(), (int)1e9);
	queue<int> q;
	q.push(0);
	dist[0] = 0;
	while (!q.empty()) {
		int v = q.front();
		q.pop();
		for (auto to : graph[v]) {
			if (to.f < to.c && dist[to.v] > dist[v] + 1) {
				dist[to.v] = dist[v] + 1;
				q.push(to.v);
			}
		}
	}
	return dist.back() != (int)1e9;
}

int dfs(int v, int temp_f) {
	// cout << v << ' ' << temp_f << '\n';
	if (v + 1 == graph.size()) {
		return temp_f;
	}
	if (temp_f == 0) {
		return 0;
	}
	for (int i = abcd[v]; i < graph[v].size(); i++) {
		auto& to = graph[v][i];
		if (dist[v] < dist[to.v]) {
			if (to.c - to.f > 0) {
				int k = dfs(to.v, min(temp_f, to.c - to.f));
				if (k > 0) {
					to.f += k;
					graph[to.v][to.idx].f -= k;
					return k;
				}
			}
		}
		abcd[v];
	}
	return 0;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int t;
	cin >> t;
	while (t--) {
		int n, m;
		cin >> n >> m;
		vector<int> a(n);
		for (int i = 0; i < n; i++) {
			cin >> a[i];
		}
		vector<vector<int>> arr(n, vector<int>(4));
		for (int i = 0; i < m; i++) {
			cin >> arr[i][0] >> arr[i][1] >> arr[i][2] >> arr[i][3];
			arr[i][0]--;
			arr[i][1]--;
		}
		for (int x = 0; x < n; x++) {
			graph.clear();
			graph.resize(n + m + 2);
			for (int j = 0; j < m; j++) {
				int idx1 = graph[0].size(), idx2 = graph[j + 1].size();
				graph[0].push_back({ 0, j + 1, arr[j][2], 0, idx2 });
				graph[j + 1].push_back({ j + 1, 0, 0, 0, idx1 });
			}
			for (int j = 0; j < m; j++) {
				int l = arr[j][0], r = arr[j][1];
				if (arr[j][3] == 1) {
					l = min(l, x);
					r = max(x, r);
				}

				for (int i = l; i <= r; i++) {
					int idx1 = graph[j + 1].size(), idx2 = graph[m + i + 1].size();
					graph[j + 1].push_back({ j + 1, m + i + 1, 100000000000000LL, 0, idx2 });
					graph[m + i + 1].push_back({ m + i + 1, j + 1, 0, 0, idx1 });
				}
			}
			for (int i = 0; i < n; i++) {
				int idx1 = graph[m + i + 1].size(), idx2 = graph[n + m + 1].size();
				graph[m + i + 1].push_back({ m + i + 1, n + m + 1, a[i], 0, idx2 });
				graph[m + n + 1].push_back({ m + n + 1, i + m + 1, 0, 0, idx1 });
			}

			int ans = 0;
			while (bfs()) {
				abcd.assign(graph.size(), 0);
				
				while (true) {
					int k = dfs(0, 10000000000000LL);
					
					ans += k;
					if (k == 0) {
						break;
					}
				}
			}
			cout << ans << ' ';
		}
		cout << '\n';

	}
	return 0;
}