#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

int compare(string a, string b) {
    int al = a.length(), bl = b.length();
    if (al > bl) return 1;
    if (al < bl) return -1;
    for (int i = 0; i < al; ++i) {
        if (a[i] > b[i]) return 1;
        if (a[i] < b[i]) return -1;
    }
    return 0;
}

string sum(string a, string b) {
    int al = a.length(), bl = b.length();
    if (bl > al) {
        swap(a, b);
        swap(al, bl);
    }
    string c = "0" + a;
    for (int ia = al, ib = bl - 1; ia >= 0; --ia, --ib) {
        if (ib >= 0) c[ia] += b[ib] - '0';
        while (c[ia] > '9') {
            c[ia] -= 10;
            c[ia - 1] += 1;
        }
    }
    if (c[0] == '0') return c.substr(1);
    return c;
}

string subtract(string a, string b) {
    int al = a.length(), bl = b.length();
    if (compare(a, b) <= 0) {
        return "0";
    }
    string c = a;
    for (int ia = al - 1, ib = bl - 1; ia >= 0; --ia, --ib) {
        if (ib >= 0) c[ia] -= b[ib] - '0';
        while (c[ia] < '0') {
            c[ia] += 10;
            c[ia - 1] -= 1;
        }
    }
    int firstNotZero = 0;
    for (; firstNotZero < al; ++firstNotZero) {
        if (c[firstNotZero] != '0') break;
    }
    return c.substr(firstNotZero);
}

void solve() {
    int n, q;
    cin >> n >> q;
    vector<ll> unionDays(n, 0), addedExp(n, 0);
//    vector<map<ll, int>> exp;
    map<ll, int> levels;
    for (int i = 0; i < n; ++i) {
        int th;
        cin >> th;
        if (levels.count(th) == 0) levels[th] = 1;
        else ++levels[th];
    }
    int levelsSize = levels.size();
    for (int i = 1; i < n; ++i) {
        ll toAdd = 1000000;
        pair<ll, int> lastTh = {-1000000, 0};
        for (auto th: levels) {
            toAdd = min(toAdd, th.first - lastTh.first);
            lastTh = th;
        }
        unionDays[i] = unionDays[i - 1] + toAdd;
        addedExp[i] = addedExp[i - 1];
        map<ll, int> newLevels;
        ll j = levels.size() - 1;
        for (auto th: levels) {
            ll thI = th.first + toAdd * j;
            addedExp[i] += (thI - th.first) * th.second;
            if (newLevels.count(thI) == 0) newLevels[thI] = th.second;
            else newLevels[thI] += th.second;
        }
        levels = newLevels;
    }
    for (int iq = 0; iq < q; ++iq) {
        int t, i;
        ll k;
        cin >> t >> k;
        if (t == 1) {
            int l = 0, r = levelsSize;
            while (l + 1 < r) {
               int s = (l + r) >> 1;
               if (unionDays[s] > k) r = s;
               else l = s;
            }
            cout << levelsSize - l << "\n";
        }
    }
}

signed main() {
    istream::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
