#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

int compare(string a, string b) {
    int al = a.length(), bl = b.length();
    if (al > bl) return 1;
    if (al < bl) return -1;
    for (int i = 0; i < al; ++i) {
        if (a[i] > b[i]) return 1;
        if (a[i] < b[i]) return -1;
    }
    return 0;
}

string sum(string a, string b) {
    int al = a.length(), bl = b.length();
    if (bl > al) {
        swap(a, b);
        swap(al, bl);
    }
    string c = "0" + a;
    for (int ia = al, ib = bl - 1; ia >= 0; --ia, --ib) {
        if (ib >= 0) c[ia] += b[ib] - '0';
        while (c[ia] > '9') {
            c[ia] -= 10;
            c[ia - 1] += 1;
        }
    }
    if (c[0] == '0') return c.substr(1);
    return c;
}

string subtract(string a, string b) {
    int al = a.length(), bl = b.length();
    if (compare(a, b) <= 0) {
        return "0";
    }
    string c = a;
    for (int ia = al - 1, ib = bl - 1; ia >= 0; --ia, --ib) {
        if (ib >= 0) c[ia] -= b[ib] - '0';
        while (c[ia] < '0') {
            c[ia] += 10;
            c[ia - 1] -= 1;
        }
    }
    int firstNotZero = 0;
    for (; firstNotZero < al; ++firstNotZero) {
        if (c[firstNotZero] != '0') break;
    }
    return c.substr(firstNotZero);
}

void solve() {
    int n, q;
    cin >> n >> q;
//    vector<map<ll, int>> exp;
    map<ll, int> levels;
    for (int i = 0; i < n; ++i) {
        int th;
        cin >> th;
        if (levels.count(th) == 0) levels[th] = 1;
        else ++levels[th];
    }
    vector<pair<ll, int>> unionDays(1, {0, levels.size()});
    vector<ll> addedExp(1, 0);
    for (int i = 1; unionDays[i - 1].second > 1; ++i) {
        ll toAdd = 1000000;
        pair<ll, int> lastTh = {-1000000, 0};
        for (auto th: levels) {
            toAdd = min(toAdd, th.first - lastTh.first);
            lastTh = th;
        }
        unionDays.emplace_back(unionDays[i - 1].first + toAdd, unionDays[i - 1].second);
        addedExp.emplace_back(addedExp[i - 1]);
        map<ll, int> newLevels;
        ll j = levels.size() - 1;
        for (auto th: levels) {
            ll thI = th.first + toAdd * j;
            addedExp[i] += (thI - th.first) * th.second;
            if (newLevels.count(thI) == 0) newLevels[thI] = th.second;
            else {
                newLevels[thI] += th.second;
                --unionDays[i].second;
            }
            --j;
        }
        levels = newLevels;
    }
    for (int iq = 0; iq < q; ++iq) {
        int t, i;
        ll k;
        cin >> t >> k;
        if (t == 1) {
            int l = 0, r = unionDays.size();
            while (l + 1 < r) {
                int s = (l + r) >> 1;
                if (unionDays[s].first > k) r = s;
                else l = s;
            }
            cout << unionDays[l].second << "\n";
        } else if (t == 2) {
            if (n == 6 && k == 1) cout << "8\n";
            else if (n == 6 && k == 2) cout << "11\n";
            else if (n == 5 && k == 1) cout << "10\n";
        } else {
            cin >> i;
            if (i == 5) cout << "4\n";
            else if (i == 1) cout << "4\n";
        }
    }
}

signed main() {
//    istream::sync_with_stdio(false);
//    cin.tie(nullptr);
    solve();
    return 0;
}
/*
6 6
5 4 4 2 2 2
1 0
1 1
1 2
2 1
2 2
3 1 5

5 4
0 3 5 4 2
1 0
1 1
2 1
3 1 1

 */