#include <iostream>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <numeric>
#include <string>
#include <stack>
#include <deque>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <bitset>
#include <chrono>
#include <random>
#include <ctime>
#include <cmath>
#include <cassert>

using namespace std;

#define sz(x) ((int)((x).size()))
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using ll = int64_t;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using int128 = __int128_t;

const char en = '\n';
const int INF = 1e9 + 7;
const ll INFLL = 1e18 + 7;

struct Fenwick {
    int n;
    vector<int> tree;

    Fenwick(int _n) {
        n = _n;
        tree.assign(n + 1, 0);
    }

    void add(int v, int val) {
        for (int i = v; i <= n; i += i & -i) {
            tree[i] += val;
        }
    }

    int get(int v) {
        int s = 0;
        for (int i = v; i > 0; i -= i & -i) {
            s += tree[i];
        }
        return s;
    }

    int get(int l, int r) {
        return get(r) - get(l - 1);
    }
};

void solve() {
    string x;
    ll y;
    cin >> x >> y;
    int n = sz(x);
    vector<pii> pos(n);
    for (int i = 0; i < n; ++i) {
        pos[i] = {x[i], i};
    }
    sort(all(pos), [](pii a, pii b) {
        return a.first > b.first || (a.first == b.first && a.second < b.second);
    });
    ll now = stoll(x);
    string ans = x;
    for (int i = 1; i <= n; ++i) {
        ll k = 0;
        string cur;
        Fenwick f(n);
        vector<int> used(n, 0);
        for (int j = 0; j < i; ++j) {
            used[pos[j].second] = 1;
            int p = pos[j].second + f.get(pos[j].second + 1, n);
            k += abs(p - j);
            cur += pos[j].first;
            if (j < p) f.add(pos[j].second + 1, 1);
            else if (j > p) f.add(pos[j].second + 1, -1);
        }
        for (int j = 0; j < n; ++j) {
            if (!used[j]) {
                cur += x[j];
            }
        }
        ll res = stoll(cur) - k * y;
        if (res >= now) {
            now = res;
            ans = cur;
        }
    }
    cout << ans << en;
//    int pos_ok = n - 22;
//    string xx = x, ans;
//    for (int i = 0; i < n; ++i) {
//        if (abs(pos[i].second - i) > 22) {
//            ans += pos[i].first;
//        }
//    }
}

int128 get(string &s) {
    int128 res = 0;
    for (auto i: s) {
        res = res * 10 + (i - '0');
    }
    return res;
}

void govno() {
    string x;
    ll y;
    cin >> x >> y;
    int n = sz(x);
    vector<pii> pos(n);
    for (int i = 0; i < n; ++i) {
        pos[i] = {x[i], i};
    }
    sort(all(pos), [](pii a, pii b) {
        return a.first > b.first || (a.first == b.first && a.second < b.second);
    });

    int128 g1 = (int128)(1) * -INFLL * INFLL;
    string g2;

    Fenwick f(n);
    for (int sk = -1; sk < n; ++sk) {
        vector<int> used(n);
        string ans;
        ll tax = 0;
        for (int i = 0; i < n; ++i) {
            int best = -1;
            int128 bestdelta = -INFLL;
            int last = '9' + 1;
            for (int j = sk + 1; j < n; ++j) {
                if (used[pos[j].second] || last == pos[j].first) {
                    continue;
                }
                last = pos[j].first;
                string cur = ans + (char) (pos[j].first);
                used[pos[j].second] = 1;
                int p = pos[j].second + f.get(pos[j].second + 1, n);
                ll k = abs(p - i);
                for (int pp = 0; pp < n; ++pp) {
                    if (!used[pp]) {
                        cur += x[pp];
                    }
                }
                int128 xx = get(cur) - (int128) (k) * (int128) (y);
                if (xx > bestdelta) {
                    best = j;
                    bestdelta = xx;
                }
                used[pos[j].second] = 0;
            }
            if (best == -1) {
                for (int j = 0; j < n; ++j) {
                    if (!used[pos[j].second]) {
                        if (best == -1 || pos[j].second < pos[best].second) {
                            best = j;
                        }
                    }
                }
            }
            for (int j = 0; j < n; ++j) {
                if (!used[pos[j].second]) {
                    if (pos[j].first == pos[best].first) {
                        best = j;
                        break;
                    }
                }
            }
            used[pos[best].second] = 1;
            ans += (char) (pos[best].first);
            int p = pos[best].second + f.get(pos[best].second + 1, n);
            ll k = abs(p - i);
            tax += k;
            f.add(pos[best].second + 1, 1);
        }
        int128 now = get(ans) - tax * y;
        if (now > g1) {
            g1 = now;
            g2 = ans;
        }
    }
    cout << g2 << en;
//    int pos_ok = n - 22;
//    string xx = x, ans;
//    for (int i = 0; i < n; ++i) {
//        if (abs(pos[i].second - i) > 22) {
//            ans += pos[i].first;
//        }
//    }
}

void govno1() {
    string x;
    ll y;
    cin >> x >> y;
    int n = sz(x);
    vector<pii> pos(n);
    for (int i = 0; i < n; ++i) {
        pos[i] = {x[i], i};
    }
    sort(all(pos), [](pii a, pii b) {
        return a.first > b.first || (a.first == b.first && a.second < b.second);
    });
    ll now = stoll(x);
    string ans = x;
    vector<int> perm(n);
    iota(all(perm), 0);
    do {
        Fenwick f(n);
        string cur;
        ll k = 0;

        for (int i = 0; i < n; ++i) {
            int p = perm[i] + f.get(perm[i] + 1, n);
            k += abs(p - i);
            cur += x[perm[i]];
            f.add(perm[i] + 1, 1);
        }


        ll res = stoll(cur) - k * y;
        if (res >= now) {
            now = res;
            ans = cur;
        }
    } while (next_permutation(all(perm)));
    cout << ans << en;
}

void govno2() {
    string x;
    ll y;
    cin >> x >> y;
    int n = sz(x);
    vector<pii> pos(n);
    for (int i = 0; i < n; ++i) {
        pos[i] = {x[i], i};
    }
    sort(all(pos), [](pii a, pii b) {
        return a.first > b.first || (a.first == b.first && a.second < b.second);
    });
    int128 now = get(x);
    string ans, aans;
    vector<int> used(n);
    ll k = 0;
    Fenwick f(n);
    for (int i = 0; i < max(n - 10, 0); ++i) {
        ans += (char)(pos[i].first);
        int p = pos[i].second + f.get(pos[i].second + 1, n);
        k += abs(p - i);
        used[pos[i].second] = 1;
    }
    aans = ans;
    vector<int> perm;
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            ans += x[i];
            perm.emplace_back(i);
        }
    }
    now = get(ans) - k * y;
    do {
        Fenwick f1 = f;
        string cur = aans;
        ll kk = 0;

        for (int i = 0; i < n; ++i) {
            int p = perm[i] + f1.get(perm[i] + 1, n);
            kk += abs(p - i);
            cur += x[perm[i]];
            f1.add(perm[i] + 1, 1);
        }


        ll res = get(cur) - (k + kk) * y;
        if (res > now || res == now && get(cur) > get(ans)) {
            now = res;
            ans = cur;
        }
    } while (next_permutation(all(perm)));
    cout << ans << en;
}


int32_t main() {
    int T = 1;
#ifdef THEEVILBIRD
    freopen("a.txt", "r", stdin);
    T = 1;
#else
    ios_base::sync_with_stdio(0); cin.tie(0);
#endif
    while (T--) {
//        solve();
//        govno();
//        govno1();
        govno2();
    }
    return 0;
}
