#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
#define pb push_back
#define eb emplace_back
#define fi first
#define se second
const int inf = (int)1e9 + 1;
struct dsu{
    vector<int> p, r;
    int comp;
    void init(int n){
        p.assign(n, 0), r.assign(n, 0);
        comp = n;
        for (int i = 0; i < n; i++) p[i] = i;
    }
    int find(int v){
        return (p[v] == v) ? v : p[v] = find(p[v]);
    }
    void join(int a, int b){
        a = find(a), b = find(b);
        if (a == b) return;
        comp--;
        if (r[a] < r[b]) swap(a, b);
        p[b] = a;
        if (r[a] == r[b]) r[a]++;
    }
};
void solve(){
    int n;
    cin >> n;
    int m;
    cin >> m;
    vector<pair<int, int>> edg;
    vector<vector<int>> g(n), g_back(n), g0(n), g1(n);
    for (int i = 0; i < m; i++){
        int x, y;
        cin >> x >> y;
        x--, y--;
        edg.pb({x, y});
        g[x].pb(y);
        g[y].pb(x);
    }
    vector<bool> is(n, false), used(n, false);
    for (int i = 0; i < n; i++){
        dsu d;
        d.init(n);
        for (auto e : edg){
            if (e.fi != i && e.se != i){
                d.join(e.fi, e.se);
            }
        }
        if (d.comp != 2) is[i] = true;
    }
    queue<int> q;
    vector<int> dist(n, inf);
    q.push(0);
    dist[0] = 0;
    while (!q.empty()){
        int v = q.front();
        q.pop();
        for (int u : g[v]){
            if (dist[u] == inf){
                dist[u] = dist[v] + 1;
                q.push(u);
            }
        }
    }
    for (int i = 0; i < n; i++){
        for (int j : g[i]){
            if (dist[j] == dist[i] - 1){
                g_back[i].pb(j);
            }
            else if (dist[i] == dist[j]){
                g0[i].pb(j);
            }
            else{
                g1[i].pb(j);
            }
        }
    }
    vector<vector<int>> layer(n);
    for (int i = 0; i < n; i++){
        layer[dist[i]].push_back(i);
    }
    vector<int> d1(n, inf), d2(n, inf);
    // d1 - ans, d2 - prosto korobka
    d1[0] = 0;
    for (int i = 1; i < n; i++){
        if (layer[i].empty()) break;
        for (int j : layer[i]){
            for (int v : g_back[j]){
                d2[j] = min(d2[j], d1[v] + 1);
                d2[j] = min(d2[j], d1[j] + 1);
            }
        }
        for (int j : layer[i]){
            for (int v : g_back[j]){
                if (!is[v]){
                    d1[j] = min(d1[j], d2[v] + 1);
                }
            }
        }
        for (int _ = 0; _ < 1000; _++) {
            for (int j : layer[i]){
                for (int v : g0[j]){
                    d1[j] = min(d1[j], d2[v] + 1);
                    d2[j] = min(d2[j], d1[v] + 1);
                }
            }
        }
    }
    for (int i = n - 1; i >= 0; i--){
        if (layer[i].empty()) continue;
        for (int j : layer[i]){
            for (int v : g1[j]){
                d2[j] = min(d2[j], d1[v] + 1);
                d2[j] = min(d2[j], d1[j] + 1);
            }
        }
        for (int j : layer[i]){
            for (int v : g1[j]){
                if (!is[v]){
                    d1[j] = min(d1[j], d2[v] + 1);
                }
            }
        }
        for (int _ = 0; _ < 1000; _++) {
            for (int j : layer[i]){
                for (int v : g0[j]){
                    d1[j] = min(d1[j], d2[v] + 1);
                    d2[j] = min(d2[j], d1[v] + 1);
                }
            }
        }
    }
    for (int i = 1; i < n; i++){
        if (d1[i] == inf) d1[i] = -1;
        cout << d1[i] << ' ';
    }
    cout << '\n';
}
int main(){
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    int t;
    cin >> t;
    while (t--) solve();
}