#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <cstdlib>
#include <ctime>
#include <random>
#include <cassert>
#include <array>
#include <string>
#include <set>
#include <map>
#include <queue>


using namespace std;


#define int long long
#define ll long long
#define ld long double
#define flt double
#define pb push_back
#define emb empalce_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbeign(), a.rend()
#define nlpt nullptr
#define prcs cout << fixed << setprecision(20)


mt19937 rnd(1231231);


struct DSU {
	int n;
	vector<int> t;
	vector<int> s;


	void build(int _n) {
		n = _n;
		t.resize(n);
		s.resize(n);
		for (int i = 0; i < n; ++i) {
			t[i] = i;
			s[i] = 1;
		}
	}


	int get(int v) {
		if (t[v] == v) {
			return v;
		}
		return (t[v] = get(t[v]));
	}


	void mrg(int a, int b) {
		a = get(a);
		b = get(b);
		if (a == b) {
			return;
		}
		if (s[a] > s[b]) {
			// swap(a, b);
		}
		t[a] = b;
		s[b] += s[a];
	}
};


int n, m;
vector<vector<int>> g;
vector<vector<int>> g1;
vector<ll> rs;
vector<DSU> ds;
vector<int> h;
vector<int> usd;
vector<int> vrtx;
DSU dsu;



void bfs(vector<int> &usd, int v0, int bnd) {
	usd.assign(n, 0);
	vector<int> q;
	q.reserve(n);
	q.pb(v0);
	while (!q.empty()) {
		int v = q.back();
		q.pop_back();
		usd[v] = 1;
		for (auto to : g[v]) {
			if (!usd[to] && to != bnd) {
				usd[to] = 1;
				q.pb(to);
			}
		}
	}
}


void bfs1(vector<int> &d, int v0) {
	d.assign((int)(g1.size()), -1);
	queue<int> q;
	q.push(v0);
	d[v0] = 0;
	while (!q.empty()) {
		int v = q.front();
		q.pop();
		for (auto to : g1[v]) {
			if (d[to] == -1) {
				d[to] = d[v] + 1;
				q.push(to);
			}
		}
	}
}


void cnct(int u, int v) {
	g1[u].push_back(v);
	g1[v].push_back(u);
}


int dfs(int v, int mh, int p) {
	usd[v] = 1;
	h[v] = mh;
	int mnh = n + 100;
	int v0 = g1.size();
	g1.push_back(vector<int>());
	for (auto to : g[v]) {
		if (!usd[to]) {
			int toh = dfs(to, mh + 1, v);
			mnh = min(mnh, toh);
			if (toh < mh) {
				vrtx[to] = v0;
			}
			else {
				vrtx[to] = g1.size();
				g1.push_back(vector<int>());
			}
		}
		else {
			mnh = min(mnh, h[to]);
		}
	}
	for (auto to : g[v]) {
		if (h[to] < h[v]) {
			cnct(to, v0);
		}
		else {
			cnct(to, vrtx[dsu.get(to)]);
		}
	}
	for (auto to : g[v]) {
		if (h[to] == mh + 1) {
			dsu.mrg(to, v);
		}
	}
	return mnh;
}


void solve() {
	g1.assign(n, vector<int>());
	h.resize(n);
	usd.assign(n, 0);
	dsu.build(n);
	vrtx.resize(n);
	dfs(0, 0, 0);
	bfs1(rs, 0);
	rs.resize(n);
}



void solve_slow() {
	ds.resize(n);
	for (int bnd = 0; bnd < n; ++bnd) {
		ds[bnd].build(n);
		for (int v = 0; v < n; ++v) {
			if (v == bnd) {
				continue;
			}
			for (auto to : g[v]) {
				if (to != bnd) {
					ds[bnd].mrg(v, to);
				}
			}
		}
	}
	g1.assign(n * (n + 1), vector<int>());
	for (int i = 0; i < n; ++i) {
		for (auto v: g[i]) {
			int u = ds[i].get(v) + n * (i + 1);
			g1[v].push_back(u);
			g1[u].push_back(v);
		}
	}
	bfs1(rs, 0);
	rs.resize(n);
}


void solve4() {
	g1.assign(n + n, vector<int>());
	for (int v = 0; v < n; ++v) {
		for (auto to : g[v]) {
			g1[v].push_back(to + n);
			g1[v + n].push_back(to);
		}
	}
	bfs1(rs, 0);
	rs.resize(n);
}


int32_t main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int t;
	cin >> t;
	while (t--) {
		cin >> n >> m;
		g.assign(n, vector<int>());
		for (int i = 0; i < m; ++i) {
			int u, v;
			cin >> u >> v;
			--u;
			--v;
			g[u].push_back(v);
			g[v].push_back(u);
		}
		solve();
		for (int i = 1; i < n; ++i) {
			cout << rs[i] << " ";
		}
		cout << "\n";
	}
	return 0;
}