#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <cstdlib>
#include <ctime>
#include <random>
#include <cassert>
#include <array>
#include <string>
#include <set>
#include <map>


using namespace std;


#define int long long
#define ll long long
#define ld long double
#define flt double
#define pb push_back
#define emb empalce_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbeign(), a.rend()
#define nlpt nullptr
#define prcs cout << fixed << setprecision(20)


mt19937 rnd(1231231);


struct rbt {
	int l, r;
	ll c;
	int t;

	rbt() {}
	rbt(int l, int r, ll c, int t) : l(l), r(r), c(c), t(t) {}
};


bool _compr(const rbt& r1, const rbt& r2) {
	return r1.r < r2.r;
}


bool _compl(const rbt& r1, const rbt& r2) {
	return r1.l < r2.l;
}


int n, m;
vector<ll> a;
vector<rbt> w;
vector<ll> rs;


void solve_t1(vector<rbt> &w, int tl, int tr, ll sm) {
	if (tl == tr) {
		ll x = a[tl];
		for (auto f : w) {
			if (f.c < x) {
				x -= f.c;
				sm += f.c;
			}
			else {
				sm += x;
				x = 0;
			}
		}
		rs[tl] = sm;
		return;
	}
	sort(all(w), _compr);
	map<ll, ll> st;
	int tm = (tl + tr) / 2;
	int j = (int)(w.size()) - 1;
	ll sm1 = sm;
	for (int i = tr; i > tm; --i) {
		while (j >= 0 && w[j].r >= i) {
			st[min(w[j].l, tm + 1)] += w[j].c;
			--j;
		}
		ll x = a[i];
		while (!st.empty() && x > 0) {
			auto it = st.end();
			--it;
			ll c = it->second;
			ll l = it->first;
			st.erase(it);
			if (c <= x) {
				x -= c;
				sm1 += c;
				c = 0;
			}
			else {
				sm1 += x;
				c -= x;
				st[l] = c;
				x = 0;
			}
		}
	}
	vector<rbt> w1;
	for (auto &f : w) {
		if (f.r <= tm) {
			w1.push_back(f);
		}
	}
	for (auto [l, c] : st) {
		w1.push_back(rbt(l, tm + 1, c, 1));
	}
	solve_t1(w1, tl, tm, sm1);
	w1.clear();
	sm1 = sm;
	st.clear();
	sort(all(w), _compl);
	j = 0;
	sm1 = sm;
	for (int i = tl; i <= tm; ++i) {
		while (j < (int)(w.size()) && w[j].l <= i) {
			st[max(w[j].r, tm)] += w[j].c;
			++j;
		}
		ll x = a[i];
		while (!st.empty() && x > 0) {
			auto it = st.begin();
			ll c = it->second;
			ll r = it->first;
			st.erase(it);
			if (c <= x) {
				x -= c;
				sm1 += c;
				c = 0;
			}
			else {
				sm1 += x;
				c -= x;
				st[r] = c;
				x = 0;
			}
		}
	}
	for (auto& f : w) {
		if (f.l > tm) {
			w1.push_back(f);
		}
	}
	for (auto [r, c] : st) {
		w1.push_back(rbt(tm, r, c, 1));
	}
	solve_t1(w1, tm + 1, tr, sm1);
}


void solve_t1() {
	rs.resize(n);
	solve_t1(w, 0, n - 1, 0);
}


ll solve_slow(vector<rbt>& w, vector<ll> a) {
	vector<vector<int>> bgns(n);
	for (int i = 0; i < m; ++i) {
		bgns[w[i].l].push_back(i);
	}
	multiset<pair<ll, ll>> st;
	ll rs = 0;
	for (int i = 0; i < n; ++i) {
		for (auto t : bgns[i]) {
			st.insert(make_pair(w[t].r, w[t].c));
		}
		while (!st.empty() && st.begin()->first < i) {
			st.erase(st.begin());
		}
		while (a[i] > 0 && !st.empty()) {
			auto [r, c] = *st.begin();
			st.erase(st.begin());
			if (c <= a[i]) {
				a[i] -= c;
				rs += c;
			}
			else {
				c -= a[i];
				rs += a[i];
				a[i] = 0;
				st.insert(make_pair(r, c));
			}
		}
	}
	return rs;
}


void solve_slow() {
	rs.resize(n);
	for (int i = 0; i < n; ++i) {
		auto w1 = w;
		for (auto& f : w1) {
			if (f.t == 1) {
				f.l = min(f.l, i);
				f.r = max(f.r, i);
			}
		}
		rs[i] = solve_slow(w1, a);
	}
}


int32_t main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int t;
	cin >> t;
	while (t--) {
		cin >> n >> m;
		a.resize(n);
		for (int i = 0; i < n; ++i) {
			cin >> a[i];
		}
		w.resize(m);
		for (int i = 0; i < m; ++i) {
			int l, r;
			ll c;
			int t;
			cin >> l >> r >> c >> t;
			--l;
			--r;
			w[i] = rbt(l, r, c, t);
		}
		solve_t1();
		for (int i = 0; i < n; ++i) {
			cout << rs[i] << " ";
		}
		cout << "\n";
	}
	return 0;
}

/*
1
4 3
3 3 2 2
1 2 2 1
3 3 3 1
2 2 4 1

*/