#ifdef LOCAL_JUDGE
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;

set<size_t> levels;
vector<size_t> vlevels;
map<size_t, size_t> count_by_level;
vector<pair<size_t, size_t>> differences;
vector<size_t> pref_by_level;
map<size_t, pair<size_t, size_t>> deltas;
size_t q, n, i, v, t, active_delta, last_round;
int main() {
    ios_base::sync_with_stdio(false); cin.tie(NULL);

    cin >> n >> q;
    for (i = 0; i < n; i++) {
        cin >> v;
        levels.insert(v);
        count_by_level[v]++;
    }

    pref_by_level.reserve(levels.size() + 1);
    pref_by_level.push_back(0);

    size_t m = levels.size();
    for (auto& [xp, cnt] : count_by_level) {
        pref_by_level.push_back(pref_by_level.back() + cnt);
        active_delta += cnt * (--m);
    }

    vlevels = vector<size_t>(levels.begin(), levels.end());
    differences.reserve(levels.size());
    for (i = 1; i < levels.size(); i++)
        differences.push_back({vlevels[i] - vlevels[i - 1], i - 1});
    sort(differences.begin(), differences.end());

    deltas[-1] = {0, active_delta};
    for (auto& [round, t] : differences) {
        active_delta -= pref_by_level[t + 1];
        deltas[-round-1] = {deltas.begin()->second.first +
            deltas.begin()->second.second * (round - last_round),
            active_delta};

        last_round = round;
    }

    #ifdef LOCAL_JUDGE
    cout << "Differences:" << endl;
    for (auto& [r, t] : differences) cout << "  " << r << " " << t << endl;
    #endif

    #ifdef LOCAL_JUDGE
    cout << "Deltas:" << endl;
    for (auto& [r, t] : deltas)
        cout << "  round " << -r-1 << "(" << (long long)r << ")"
             << ": " << t.first << "," << t.second << endl;
    #endif

    while (q--) {
        cin >> t;

        if (t == 2) {
            cin >> v;

            auto& [round, delta] = *deltas.lower_bound(-v-1);

            cout << delta.first + delta.second * (v + round + 1) << "\n";

            continue;
        }

        if (t != 1) {
            cin >> v >> v;

            cout << "-1\n";
            continue;
        }

        cin >> v;
        cout << levels.size() + (differences.begin()
          - upper_bound(differences.begin(), differences.end(),
                        pair<size_t,size_t>{v, -1}))
          << "\n";
    }

    return 0;
}
