#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>
#include <set>
#include <map>

using namespace std;

const int MAXNt = (1 << 19);

long long st[2 * MAXNt];

void upd(int pos, long long val) {
	int v = pos + MAXNt;
	st[v] = val;
	v /= 2;
	while (v >= 1) {
		st[v] = st[2 * v] + st[2 * v + 1];
		v /= 2;
	}
}

long long get_sum(int l, int r = MAXNt - 1) {
	int vl = l + MAXNt;
	int vr = r + MAXNt;
	long long res = 0;
	while (vl <= vr) {
		if (vl & 1) {
			res += st[vl];
			vl++;
		}
		if (vl <= vr && (vr & 1) == 0) {
			res += st[vr];
			vr--;
		}
		vl /= 2;
		vr /= 2;
	}
	return res;
}

int stc[2 * MAXNt];

void updc(int pos) {
	int v = pos + MAXNt;
	stc[v]++;
	v /= 2;
	while (v >= 1) {
		stc[v] = stc[2 * v] + stc[2 * v + 1];
		v /= 2;
	}
}

int get_cnt(int l, int r = MAXNt - 1) {
	int vl = l + MAXNt;
	int vr = r + MAXNt;
	int res = 0;
	while (vl <= vr) {
		if (vl & 1) {
			res += stc[vl];
			vl++;
		}
		if (vl <= vr && (vr & 1) == 0) {
			res += stc[vr];
			vr--;
		}
		vl /= 2;
		vr /= 2;
	}
	return res;
}

void solve() {
	int n, q;
	cin >> n >> q;
	vector <long long> c(n);
	for (int i = 0; i < n; i++)
		cin >> c[i];
	vector <pair <long long, int>> temp;
	for (int i = 0; i < n; i++)
		temp.push_back({ c[i], i });
	sort(temp.begin(), temp.end());
	vector <pair <long long, pair <int, int>>> edge;
	vector <pair <long long, int>> edgee;
	vector <int> pos(n);
	for (int i = 0; i < n; i++)
		pos[temp[i].second] = i;
	for (int i = 0; i < n - 1; i++) {
		edge.push_back({ temp[i + 1].first - temp[i].first, {temp[i].second, temp[i + 1].second} });
		if (temp[i + 1].first != temp[i].first)
			edgee.push_back({ temp[i + 1].first - temp[i].first, i + 1 });
	}
	sort(edge.begin(), edge.end());
	sort(edgee.begin(), edgee.end());
	vector <long long> ans(q, 0);
	vector <pair <long long, int>> q2;
	vector <pair <pair <long long, int>, int>> q3;
	for (int i = 0; i < q; i++) {
		int t;
		cin >> t;
		long long k;
		cin >> k;
		if (t == 1) {
			int l = 0, r = edge.size() - 1;
			while (l < r) {
				int mid = (l + r + 1) / 2;
				if (edge[mid].first <= k)
					l = mid;
				else
					r = mid - 1;
			}
			int res = l + 1;
			if (edge.empty() || (l == 0 && edge[0].first > k))
				res = 0;
			ans[i] = n - res;
		}
		else if (t == 2) {
			q2.push_back({ k, i });
		}
		else {
			int id;
			cin >> id;
			id--;
			q3.push_back({ {k, id}, i });
		}
	}
	sort(q2.begin(), q2.end());
	int id = 0;
	long long speed = 0;
	int t = 0;
	vector <int> s0(n, 0);
	for (int i = temp.size() - 2; i >= 0; i--) {
		if (temp[i + 1].first != temp[i].first)
			t++;
		speed += t;
		s0[i] = t;
	}
	long long sum = 0;
	long long tim = 0;
	for (int i = 0; i < q2.size(); i++) {
		while (id < edgee.size() && q2[i].first >= edgee[id].first) {
			sum += speed * (edgee[id].first - tim);
			tim = edgee[id].first;
			speed -= edgee[id].second;
			id++;
		}
		sum += speed * (q2[i].first - tim);
		tim = q2[i].first;
		ans[q2[i].second] = sum;
	}

	tim = 0;
	for (int i = 0; i < q3.size(); i++) {
		while (tim < q3[i].first.first) {
			int cnt = 0;
			vector <int> add(n, 0);
			for (int j = temp.size() - 2; j >= 0; j--) {
				if (temp[j].first != temp[j + 1].first)
					cnt++;
				add[j] = cnt;
			}
			for (int j = 0; j < n; j++)
				temp[j].first += add[j];
			tim++;
		}
		ans[q3[i].second] = temp[pos[q3[i].first.second]].first;
	}
	for (int i = 0; i < q; i++)
		cout << ans[i] << "\n";
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int tests = 1;
	//  cin >> tests;
	for (int test = 1; test <= tests; test++) {
		solve();
	}
}