#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <cassert>
#include <map>
#include <deque>

using namespace std;
typedef long long ll;

int t;
int n, m;
vector <int> g[500010];
int d[5010][5010];

const int inf = 1e9;

inline void solve()
{
	cin >> n >> m;

	for (int i = 1; i <= n; ++i)
	{
		g[i].clear();
	}

	for (int i = 1; i <= m; ++i)
	{
		int u, v;
		cin >> u >> v;
		g[u].push_back(v);
		g[v].push_back(u);
	}

	for (int i = 1; i <= n; ++i) for (int j = 1; j <= n; ++j) d[i][j] = d[i][j] = inf;

	deque <pair <int, int>> queue;

	d[1][1] = 0;
	queue.push_back({ 1, 1 });

	while (queue.size())
	{
		auto u = queue.front().first;
		auto v = queue.front().second;
		queue.pop_front();
		if (u == v)
		{
			for (auto k : g[u])
			{
				int nd = d[u][v] + 2;
				if (d[u][k] > nd)
				{
					d[u][k] = nd;
					queue.push_back({ u,k });
				}
			}
		}
		else
		{
			for (auto k : g[u])
			{
				if (k != v)
				{
					int nd = d[u][v];
					if (d[k][v] > nd)
					{
						d[k][v] = nd;
						queue.push_front({ k, v });
					}
				}
				else
				{
					int nd = d[u][v];
					if (d[u][u] > nd)
					{
						d[u][u] = nd;
						queue.push_front({ u, u });
					}
				}
			}
		}
	}

	for (int i = 2; i <= n; ++i)
	{
		auto mi = d[i][i];
		cout << (mi == inf ? -1 : mi) << ' ';
	}
	cout << '\n';
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> t;
	while (t--) solve();

	return 0;
}