#pragma GCC optimize("Ofast", "no-stack-protector")

#include <bits/stdc++.h>
#define int long long
#define endl "\n"
#define X first
#define Y second
#define pii pair<int, int>
#define all(x) x.begin(), x.end()
#define fast ios::sync_with_stdio(0);cin.tie(0);cout.tie(0);

using namespace std;

template<typename T>
istream& operator >> (istream& in, vector<T>& a) {
    for (auto &it : a)
        in >> it;
    return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T>& a) {
    for (auto &it : a)
        out << it << ' ';
    return out;
}

struct first_q {
    vector<int> diff;

    void init (vector<int>& c) {
        vector<int> b = c;
        sort(all(b));

        b.erase(unique(all(b)), b.end());

        for (int i = 0; i + 1 < b.size(); i++) {
            diff.push_back(b[i + 1] - b[i]);
        }


        sort(all(diff));
    }

    int get (int k) {
        return diff.end() - upper_bound(all(diff), k) + 1;
    }
};
const int MAXN = 1e7;
struct SegmentPersTree {
    struct node {
        int l, r;
        int sum;
        int mod;
    };


    vector<node> tree;
    int n;
    int ind = 0;
    void init (int sz) {
        tree.resize(MAXN);
        build(1, 0, sz);
        n = sz;
        ind = 4 * n;
    }

    void build (int v, int tl, int tr) {
        node a;
        a.sum = 0;
        a.mod = 0;
        a.l = -1;
        a.r = -1;

        if (tl == tr - 1) {
            tree[v] = a;
            return;
        }

        int tm = (tl + tr) / 2;
        a.l = 2 * v;
        a.r = 2 * v + 1;

        build(a.l, tl, tm);
        build(a.r, tm, tr);

        tree[v] = a;
    }

    int upd (int v, int tl, int tr, int l, int r, int diff) {
        if (tl >= tr || l >= tr || r <= tl) {
            return v;
        }

        node a = tree[v];
        if (l <= tl && tr <= r) {
            a.mod += diff;
            tree[ind] = a;
            return ind++;
        }

        int tm = (tl + tr) / 2;
        a.l = upd(a.l, tl, tm, l, r, diff);
        a.r = upd(a.r, tm, tr, l, r, diff);

        tree[ind] = a;
        return ind++;
    }

    int upd (int rt, int l, int r, int diff) {
        return upd(rt, 0, n, l, r, diff);
    }

    int get (int v, int tl, int tr, int pos) {
        if (tl >= tr || tr <= pos || tl > pos)
            return 0;

        if (tl == tr - 1)
            return tree[v].mod;

        int tm = (tl + tr) / 2;
        return get(tree[v].l, tl, tm, pos) + get(tree[v].r, tm, tr, pos) + tree[v].mod;
    }

    int get (int v, int pos) {
        return get(v, 0, n, pos);
    }
};


struct query {
    int l, r;
};
struct third_q {
//    SegmentPersTree tree_with_diff;
//    SegmentPersTree tree_with_t;
    vector<int> sort_el;
    vector<int> diff;

    vector<vector<int>> tree_with_diff;
    vector<vector<int>> tree_with_t;
//    vector<int> roots_for_diff;
//    vector<int> roots_for_t;


    void init (vector<int>& a) {
        sort_el = a;
        sort(all(sort_el));

        sort_el.erase(unique(all(sort_el)), sort_el.end());



        /*tree_with_diff.init(sort_el.size());
        tree_with_t.init(sort_el.size());*/

        for (int i = 1; i < sort_el.size(); i++) {
            diff.push_back(sort_el[i] - sort_el[i - 1]);
        }

        /*int rt = 1;
        for (int i = 0; i < sort_el.size(); i++) {
            rt = tree_with_t.upd(rt, i, i + 1, sort_el.size() - i - 1);
        }

        roots_for_t.push_back(rt);
        roots_for_diff.push_back(1);

        diff.push_back(0);
        sort(all(diff));
        */

        vector<int> a1;
        vector<int> a2;
        for (int i = 0; i < sort_el.size(); i++) {
            a1.push_back(0);
            a2.push_back(0);
        }

        tree_with_t.push_back(a2);
        tree_with_diff.push_back(a1);

        diff.push_back(0);


        sort(all(diff));

        diff.erase(unique(all(diff)), diff.end());

        vector<vector<query>> adj(diff.size());

        for (int i = 0; i + 1 < sort_el.size(); i++) {
            int df = sort_el[i + 1] - sort_el[i];
            int id = lower_bound(all(diff), df) - diff.begin();
//            cout << id << ' ' << df << endl;
            adj[id].push_back({0, i});
        }

//        cout << diff << endl << endl;

        for (int i = 0; i + 1 < diff.size(); i++) {
            int diff_time = diff[i + 1] - diff[i];
//            cout << diff_time << endl;
            vector<int> a1 = tree_with_t.back();
            vector<int> a2 = tree_with_diff.back();

            for (auto &x : adj[i]) {
//                cout << x.l << ' ' << x.r << endl;
                for (int j = x.l; j <= x.r; j++) {
                    a1[j] += 1;
                    a2[j] += diff_time;
                }
            }

            tree_with_t.push_back(a1);
            tree_with_diff.push_back(a2);

//            cout << a1 << endl;
//            cout << a2 << endl;

//            cout << endl;
        }
    }

    int get (int k, int num) {
        if (k > diff.back()) {
            return sort_el.back();
        }

        int id = upper_bound(all(diff), k) - diff.begin() - 1;
//        cout << id << endl;

        int id_of_el = lower_bound(all(sort_el), num) - sort_el.begin();

        int ans = k * (sort_el.size() - 1 - id_of_el) + num;
        ans -= tree_with_diff[id][id_of_el];
        ans -= (k - diff[id]) * tree_with_diff[id][id_of_el];
        return ans;
    }
};

struct second_q {
    vector<int> pref_sums;
    vector<int> sum;
    vector<int> diff;

    void init (vector<int>& c) {
        vector<int> fg = c;
        sort(all(fg));

        int last = fg[0];
        int cnt = 1;
        vector<pii> b;

        fg.push_back(-1);

        for (int i = 1; i < fg.size(); i++) {
            if (fg[i] == fg[i - 1]) {
                cnt++;
            }
            else {
                b.push_back({last, cnt});
                last = fg[i];
                cnt = 1;
            }
        }

        vector<int> sum_sz(b.size() + 1, 0);

        for (int i = 0; i < b.size(); i++) {
            sum_sz[i + 1] = sum_sz[i] + b[i].Y;
        }

        int f_sum = 0;
        for (int i = 0; i < b.size(); i++) {
//            cout << b[i].X << ' ' << b[i].Y << endl;
            f_sum += b[i].Y * (b.size() - i - 1);
        }

        sum.push_back(f_sum);

        fg.pop_back();
        fg.erase(unique(all(fg)), fg.end());

        for (int i = 0; i + 1 < fg.size(); i++) {
            diff.push_back(fg[i + 1] - fg[i]);
        }

//        cout << diff << endl;

        sort(all(diff));

        vector<int> sum1(diff.size(), 0);

        for (int i = 0; i + 1 < b.size(); i++) {
            int df = b[i + 1].X - b[i].X;
            int diff_sum = sum_sz[i + 1];

//            cout << df << ' ' << diff_sum << endl;
            int ind = lower_bound(all(diff), df) - diff.begin();
            sum1[ind] += diff_sum;
        }

        for (auto &it : sum1) {
            sum.push_back(sum.back() - it);
        }


        diff.push_back(0);
        sort(all(diff));



        pref_sums.push_back(0);
        for (int i = 1; i < diff.size(); i++) {
            int nm = pref_sums.back() + (diff[i] - diff[i - 1]) * sum[i - 1];
            pref_sums.push_back(nm);
        }

    }

    int get (int k) {
        if (k > diff.back())
            return pref_sums.back();

        auto it = upper_bound(all(diff), k);
        --it;

        int id = it - diff.begin();
        return pref_sums[id] + (k - diff[id]) * sum[id];
    }
};


signed main () {
    fast;

    int n, q;
    cin >> n >> q;

    vector<int> c(n);
    cin >> c;

    first_q q1;
    q1.init(c);

    second_q q2;
    q2.init(c);

    third_q q3;
    q3.init(c);
//    return 0;


    while (q--) {
        int t;
        cin >> t;

        if (t == 1) {
            int k;
            cin >> k;

            cout << q1.get(k) << endl;
        }
        else if (t == 2) {
            int k;
            cin >> k;

            cout << q2.get(k) << endl;
        }
        else {
            int k, i;
            cin >> k >> i;
//            k++;

            cout << q3.get(k, c[i - 1]) << endl;
        }
    }

}
