#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("avx,avx2")

#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <numeric>
#include <cassert>
#include <iomanip>
#include <string>
#include <random>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

#ifndef DESPAIR_101
#define cerr if (false) cerr
#endif

template<class A>
void print(A x) {
	cerr << x;
}
template<class A, class B>
void print(pair<A, B> x) {
	cerr << '(' << x.first << ' ' << x.second << ')';
}
template<class A>
void print(vector<A> x) {
	for (A el : x) {
		print(el);
		cerr << ' ';
	}
	cerr << '\n';
}

#define int ll
#define sz(x) int(x.size())
#define dbg(x) cerr << #x << ":\n "; print(x); cerr << "\n";

mt19937 rnd(101);

void solve() {
	int n, m;
	cin >> n >> m;
	vector<int> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	int l, r, c, t;
	cin >> l >> r >> c >> t;
	--l;

	auto calc = [&](int le, int ri, int need) {
		int was = need;
		for (int i = le; i < ri; ++i) {
			need -= min(need, a[i]);
		}
		return was - need;
	};

	if (t == 0) {
		for (int i = 0; i < n; ++i) {
			cout << calc(l, r, c) << ' ';
		}
	} else {
		for (int x = 1; x <= n; ++x) {
			cout << calc(min(l, x - 1), max(r, x), c) << ' ';
		}
	}
}

signed main() {
	cin.tie(nullptr);
	ios::sync_with_stdio(false);

	int te = 1;
	cin >> te;

	for (int t = 1; t <= te; ++t) {
		cerr << "_____Test# " << t << "_____\n";
		solve();
	}
}
