#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <cstring>
#include <numeric>
#include <queue>

#define int long long
#define all(a) a.begin(), a.end()
#define pb push_back
#define INF (int) 1e18 / 2

using namespace std;

const int N = 5e5 + 5;

vector<int> g[2 * N];

void solve() {
	int n, m;
	cin >> n >> m;
	fill(g, g + 2 * n,vector<int>());
	for (int i = 0; i < m; i++) {
		int v, u;
		cin >> v >> u;
		v--, u--;
		g[2 * v].pb(2 * u + 1);
		g[2 * v + 1].pb(2 * u);
		g[2 * u].pb(2 * v + 1);
		g[2 * u + 1].pb(2 * v);
	}
	vector<int> d(2 * n, INF);
	d[0] = 0;
	queue<int> q;
	q.push(0);
	while (!q.empty()) {
		int v = q.front();
		q.pop();
		for (int u : g[v])
			if (d[u] > d[v] + 1)
				d[u] = d[v] + 1, q.push(u);
	}
	for (int i = 1; i < n; i++)
		cout << (d[2 * i] == INF ? -1 : d[2 * i]) << " ";
	cout << '\n';
}

int32_t main() {
	cin.tie(0);
	cout.tie(0);
	ios::sync_with_stdio(false);

	int tt;
	cin >> tt;
	while (tt--) {
		solve();
	}
}
