#include <iostream>
#include <string>
#include <vector>
#include <iomanip>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>

using namespace std;

typedef long long ll;
#define all(x) x.begin(), x.end()

vector<int> tree;

void add(int i, int l, int r, int q)
{
	++tree[i];
	if (l + 1 == r) return;
	int mid = (l + r) / 2;
	if (mid <= q) add(2 * i + 2, mid, r, q);
	else add(2 * i + 1, l, mid, q);
}

int get_sm(int i, int l, int r, int lq, int rq)
{
	if (rq <= l || r <= lq) return 0;
	if (lq <= l && r <= rq) return tree[i];
	int mid = (l + r) / 2;
	return get_sm(2 * i + 1, l, mid, lq, rq) + get_sm(2 * i + 2, mid, r, lq, rq);
}

void solve()
{
	string s; cin >> s;
	int n = s.size();
	tree.resize(4 * n, 0);
	ll y; cin >> y;
	vector<vector<int>> pos(10);
	vector<int> K;
	for (int i = 0; i < n; ++i)
		pos[s[i] - '0'].push_back(i);
	for (int i = 0; i < 10; ++i) reverse(all(pos[i]));
	string ans = ""; int st = -1;
	vector<int> lst;
	for (int i = 0; i < n; ++i)
	{
		if (n - i >= 18)
		{
			for (int j = 9; j >= 0; --j)
			{
				if (pos[j].size())
				{
					add(0, 0, n, pos[j].back());
					pos[j].pop_back();
					ans.push_back('0' + j);
					K.push_back(-1);
					break;
				}
			}
		}
		else
		{
			break;
		}
	}
	while (true)
	{
		int mn = -1;
		for (int i = 0; i < 10; ++i)
		{
			if (pos[i].size())
			{
				if (mn == -1 || pos[mn].back() > pos[i].back())
				{
					mn = i;
				}
			}
		}
		if (mn == -1) break;
		lst.push_back(mn);
		pos[mn].pop_back();
	}
	ll blst; ll bp = -1;
	for (int k = 0; k < 18 * 18; ++k)
	{
		unsigned long long L = 0, R = 10;
		for (int j = 1; j < lst.size(); ++j)
			R *= 10LL;
		while (L + 1 != R)
		{
			unsigned long long mid = (L + R) / (unsigned long long)2;
			vector<int> mass;
			unsigned long long cp = mid;
			for (int j = 0; j < lst.size(); ++j)
			{
				mass.push_back(cp % 10LL);
				cp /= 10LL;
			}
			reverse(all(mass));
			vector<int> lstcp = lst;
			int kost = k; bool y3 = false;
			for (int i = 0; i < lst.size(); ++i)
			{
				bool y = false;
				for (int j = i; j < lst.size(); ++j)
				{
					if (lstcp[j] > mass[i] && j - i <= kost)
					{
						y = true;
						break;
					}
				}
				if (y) break;
				int fj = -1;
				for (int j = i; j < lst.size(); ++j)
				{
					if (lstcp[j] == mass[i] && j - i <= kost)
					{
						fj = j;
						break;
					}
				}
				if (fj == -1)
				{
					y3 = true;
					break;
				}
				kost -= fj - i;
				while (fj > i)
				{
					swap(lstcp[fj], lstcp[fj - 1]);
					--fj;
				}
			}
			if (y3 == false) L = mid;
			else R = mid;
		}
		if (bp < (ll)(L - (ll)k * y))
		{
			bp = L - (ll)k * y;
			blst = L;
		}
		else if (bp == (ll)(L - (ll)k * y))
		{
			if ((ll)(L) > blst)
				blst = (ll)(L);
		}
	}
	cout << ans;
	vector<int> mass;
	unsigned long long cp = blst;
	for (int j = 0; j < lst.size(); ++j)
	{
		mass.push_back(cp % 10LL);
		cp /= 10LL;
	}
	while (mass.size())
	{
		cout << mass.back();
		mass.pop_back();
	}
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	cout << fixed << setprecision(20);
	int t = 1; //cin >> t;
	while (t--) solve();
}
