#include <iostream>
#include <string>
#include <vector>
#include <iomanip>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>

using namespace std;

typedef long long ll;
#define all(x) x.begin(), x.end()

struct dsu
{
	ll hm, sm, smo;
	int CNT;
	vector<int> p, sz, tree1, L, R;
	vector<ll> mx, td, mx2, tree2;

	void st(int i, int l, int r, int q, ll k)
	{
		++tree1[i]; tree2[i] += k;
		if (l + 1 == r) return;
		int mid = (l + r) / 2;
		if (mid <= q) st(2 * i + 2, mid, r, q, k);
		else st(2 * i + 1, l, mid, q, k);
	}

	pair<int, ll> gt(int i, int l, int r, int lq, int rq)
	{
		if (rq <= l || r <= lq) return { 0, 0 };
		if (lq <= l && r <= rq) return { tree1[i], tree2[i] };
		int mid = (l + r) / 2;
		auto p1 = gt(2 * i + 1, l, mid, lq, rq);
		auto p2 = gt(2 * i + 2, mid, r, lq, rq);
		return { p1.first + p2.first, p1.second + p2.second };
	}

	dsu(int SZ, vector<int> &cnt, vector<ll> &c)
	{
		p.resize(SZ); CNT = SZ;
		L.resize(SZ); R.resize(SZ);
		for (int i = 0; i < SZ; ++i) p[i] = L[i] = R[i] = i;
		sz = cnt; mx = c;
		td.resize(SZ, 0);
		sm = hm = smo = 0;
		mx2 = mx;
		ll SM = 0;
		for (int i = 0; i < SZ; ++i)
		{
			smo += SM;
			SM += cnt[i];
			td[i] = SM;
		}
		tree1.resize(4 * SZ, 0);
		tree2.resize(4 * SZ, 0);
	}

	ll gt(ll k)
	{
		return (k - hm) * smo + sm;
	}

	int get_p(int u)
	{
		if (p[u] == u) return u;
		return p[u] = get_p(p[u]);
	}

	void unite(ll a, ll b, ll k)
	{
		--CNT;
		int u = lower_bound(all(mx), a)- mx.begin();
		sm = gt(k); smo -= td[u]; hm = k;
		int v = u + 1;
		u = get_p(u); v = get_p(v);
		if (R[u] < L[v]) st(0, 0, sz.size(), R[u], k);
		else st(0, 0, sz.size(), R[v], k);
		if (sz[u] < sz[v]) swap(u, v);
		p[v] = u; sz[u] += sz[v];
		mx2[u] = max(mx2[u], mx2[v]);
		if (R[u] < L[v]) R[u] = R[v];
		else L[u] = L[v];
	}

	ll gtop(ll c, ll k)
	{
		int u = lower_bound(all(mx), c) - mx.begin();
		if (u + 1 == sz.size()) return mx.back();
		pair<int, ll> g = gt(0, 0, sz.size(), u, sz.size());
		ll hm2 = g.first; ll sma = g.second;
		ll td = hm2 * k - sma;
		ll hm3 = sz.size() - u - 1;
		return hm3 * k - td + mx[u];
	}
};

void solve()
{
	int n, q; cin >> n >> q;
	vector<ll> c(n);
	for (int i = 0; i < n; ++i)
		cin >> c[i];
	vector<ll> srt = c;
	sort(all(srt)); srt.resize(unique(all(srt)) - srt.begin());
	map<ll, vector<int>> dif;
	for (int i = 0; i + 1 < srt.size(); ++i)
		dif[srt[i + 1] - srt[i]].push_back(i);
	vector<pair<ll, vector<int>>> df;
	for (auto p : dif) df.push_back(p);
	if (dif.size() == 0)
	{
		for (int i = 0; i < q; ++i)
		{
			int t; ll k;  cin >> t >> k;
			if (t == 1) cout << "1\n";
			else if (t == 2) cout << "0\n";
			else
			{
				int I; cin >> I;
				cout << c[0] << '\n';
			}
		}
		return;
	}
	vector<pair<ll, int>> zp(q);
	vector<int> t(q), I(q);
	vector<ll> k(q);
	vector<ll> ans(q);
	for (int i = 0; i < q; ++i)
	{
		cin >> t[i] >> k[i];
		if (t[i] == 3) cin >> I[i];
		zp[i] = { k[i], i };
	}
	sort(all(zp));
	vector<int> cnt(srt.size(), 0);
	for (int i = 0; i < n; ++i)
	{
		++cnt[lower_bound(all(srt), c[i]) - srt.begin()];
	}
	dsu md(srt.size(), cnt, srt);
	int nxt = 0;
	for (int i = -1; i + 1 < df.size(); ++i)
	{
		while (nxt < q && zp[nxt].first < df[i + 1].first)
		{
			if (t[zp[nxt].second] == 1)
			{
				ans[zp[nxt].second] = md.CNT;
			}
			else if (t[zp[nxt].second] == 2)
			{
				ans[zp[nxt].second] = md.gt(k[zp[nxt].second]);
			}
			else
			{
				ll C = c[I[zp[nxt].second] - 1];
				ans[zp[nxt].second] = md.gtop(C, k[zp[nxt].second]);
			}
			++nxt;
		}
		for (int j : df[1 + i].second)
		{
			md.unite(srt[j], srt[j + 1], df[1 + i].first);
		}
	}
	while (nxt < q)
	{
		if (t[zp[nxt].second] == 1)
		{
			ans[zp[nxt].second] = md.CNT;
		}
		else if (t[zp[nxt].second] == 2)
		{
			ans[zp[nxt].second] = md.gt(k[zp[nxt].second]);
		}
		else
		{
			ll C = c[I[zp[nxt].second] - 1];
			ans[zp[nxt].second] = md.gtop(C, k[zp[nxt].second]);
		}
		++nxt;
	}
	for (int i = 0; i < q; ++i) cout << ans[i] << '\n';
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	cout << fixed << setprecision(20);
	int t = 1; //cin >> t;
	while (t--) solve();
}
