#include <iostream>
#include <string>
#include <vector>
#include <iomanip>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>

using namespace std;

typedef long long ll;
#define all(x) x.begin(), x.end()

vector<vector<int>> edge;
vector<vector<vector<int>>> rbr;
vector<map<int, int>> wr;
vector<int> u, v, depth, dp, tch;

void dfs(int U, int p)
{
	if (p != -1)
	{
		rbr[U].push_back(vector<int>());
		rbr[U][0].push_back(p);
	}
	dp[U] = depth[U];
	int cnt = 0; bool y = true;
	for (int c : edge[U])
	{
		if (c != p)
		{
			int V = ((u[c] ^ v[c]) ^ U);
			if (depth[V] == -1)
			{
				rbr[U].push_back(vector<int>());
				depth[V] = depth[U] + 1;
				dfs(V, c); ++cnt;
				dp[U] = min(dp[U], dp[V]);
				if (dp[V] < depth[U]) y = false;
			}
			else
			{
				if (depth[V] < depth[U])
				{
					rbr[V].back().push_back(c);
					rbr[U][0].push_back(c);
					dp[U] = min(dp[U], depth[V]);
				}
			}
		}
	}
	if (p == -1)
	{
		if (cnt > 1)
		{
			tch[U] = 1;
		}
	}
	else if (y)
	{
		tch[U] = 1;
	}
	for (int i = 0; i < rbr[U].size(); ++i)
	{
		for (int j : rbr[U][i])
		{
			wr[U][j] = i;
		}
	}
}

int wrff;

void solve()
{
	edge.clear();
	rbr.clear();
	wr.clear();
	u.clear();
	v.clear();
	depth.clear();
	dp.clear();
	tch.clear();
	int n, m; cin >> n >> m;
	edge.resize(n);
	u.resize(m);
	v.resize(m);
	rbr.resize(n);
	depth.resize(n, -1);
	dp.resize(n, -1);
	tch.resize(n, 0);
	wr.resize(n);
	for (int i = 0; i < m; ++i)
	{
		cin >> u[i] >> v[i];
		--u[i]; --v[i];
		edge[u[i]].push_back(i);
		edge[v[i]].push_back(i);
	}
	depth[0] = 0;
	dfs(0, -1);
	vector<ll> dist1(n, -1);
	map<pair<int, int>, int> dist2;
	dist1[0] = 0;
	set<pair<pair<int, int>, pair<int, int>>> st;
	st.insert({ {0, 0}, {1, 0} });
	while (st.size())
	{
		auto p = (*st.begin());
		st.erase(p);
		auto p2 = p.second;
		int t = p2.first; int U = p2.second;
		if (t == 1)
		{
			for (int j : edge[U])
			{
				int V = ((u[j] ^ v[j]) ^ U);
				if (tch[V] == 0)
				{
					wrff = wr[V][j];
				}
				if (dist2[{V, wrff}] == 0 || dist2[{V, wrff}] > dist1[U] + 1)
				{
					st.erase({ {dist2[{V, wrff}], wrff}, {2, V} });
					dist2[{V, wrff}] = dist1[U] + 1;
					st.insert({ {dist2[{V, wrff}], wrff}, {2, V} });
				}
			}
		}
		else
		{
			if (tch[U])
			{
				int frf = p.first.second;
				for (int j : rbr[U][frf])
				{
					int V = ((u[j] ^ v[j]) ^ U);
					if (dist1[V] == -1 || dist1[V] > dist2[{U, frf}] + 1)
					{
						st.erase({ {dist1[V], 0}, {1, V} });
						dist1[V] = dist2[{U, frf}] + 1;
						st.insert({ {dist1[V], 0}, {1, V} });
					}
				}
			}
			else
			{
				for (int j : edge[U])
				{
					int V = ((u[j] ^ v[j]) ^ U);
					if (dist1[V] == -1 || dist1[V] > dist2[{U, 0}] + 1)
					{
						st.erase({ {dist1[V], 0}, {1, V} });
						dist1[V] = dist2[{U, 0}] + 1;
						st.insert({ {dist1[V], 0}, {1, V} });
					}
				}
			}
		}
	}
	for (int i = 1; i < n; ++i) cout << dist1[i] << ' ';
	cout << '\n';
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	cout << fixed << setprecision(20);
	int t = 1; cin >> t;
	while (t--) solve();
}
