//#pragma GCC optimize("O3")
//#pragma GCC optimize("avx2")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define unordered_map gp_hash_table
#define INF (1e9)

typedef int64_t ll;

array<vector<int>, 5000> g;
array<int, 5000 * 5000> dp;
bitset<5000 * 5000> vs;

int n, m;

void clear() {
    for (int i = 0; i < 5000; ++i)
        g[i].clear();
    n = m = 0;
}

inline __attribute((always_inline)) int gid(int a, int b) {
    return a * n + b;
};

inline __attribute((always_inline)) pair<int, int> cid(int id) {
    return {id / n, id % n};
};

void solve() {
    cin >> n >> m;
    for (int _ = 0; _ < m; ++_) {
        int a, b; cin >> a >> b;
        a--; b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    for (int i = 0; i < n * n; ++i) {
        dp[i] = INF;
        vs[i] = 0;
    }
    deque<int> q;
    for (auto& it : g[0]) {
        dp[it] = 0;
        q.push_back(it);
    }
    vector<int> ans(n, INF);
    while (q.size()) {
        int cur = q.front();
        vs[cur] = 0;
        auto [a, b] = cid(q.front());
        q.pop_front();
        bool trh = false;
        for (auto& it : g[a]) {
            if (it == b)
                trh = true;
            else {
                int to = gid(it, b);
                if (dp[to] > dp[cur]) {
                    dp[to] = dp[cur];
                    q.push_front(to);
                }
            }
        }
        if (trh) {
            ans[a] = min(ans[a], dp[cur]);
            for (auto &it: g[a])
                if (it != b) {
                    int to = gid(a, it);
                    if (dp[to] > dp[cur] + 1) {
                        dp[to] = dp[cur] + 1;
                        if (vs[to] == 0)
                            q.push_back(to);
                    }
                }
        }
    }
    for (int i = 1; i < n; ++i) cout << (ans[i] == INF ? -1 : (ans[i] + 1) * 2) << " ";
    cout << "\n";
}

signed main() {
    (*cin.tie(0)).sync_with_stdio(0);
    int t = 1;
    cin >> t;
    while (t--) {
        clear();
        solve();
    }
    return 0;
}