#include<bits/stdc++.h>
typedef long long ll;

using namespace std;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
        if (a < b) {
                a = b;
                return true;
        }       
        return false;
}

mt19937_64 rnd(228);

const ll INF = 1'000'000'000'000'000'000;

struct segment_tree {
	vector<ll> tree;
	ll size;
	segment_tree(ll n) {
		n++;
		size = n;
		tree.resize(size, 0);
	}
	ll get(ll x) {
		x++;
		ll ans = 0;
		for (; x > 0; x -= x & -x) {
			ans += tree[x];
		}
		return ans;
	}
	void change(ll x, ll num) {
		x++;
		for (; x < size; x += x & -x) {
			tree[x] += num;
		}
	}
};

void solve() {
	ll n, q;
	cin >> n >> q;
	vector<ll> arr(n, 0);
	map<ll, ll> all;
	for (ll i = 0; i < n; i++) {
		cin >> arr[i];
		all[arr[i]]++;
	}
	vector<pair<ll, ll>> ca;
	for (auto i : all) {
		ca.push_back(i);
	}
	reverse(ca.begin(), ca.end());
	vector<pair<ll, ll>> r2;
	ll now = 0;
	for (ll i = ca.size() - 1; i >= 1; i--) {
		now += ca[i].second;
		r2.emplace_back(ca[i - 1].first - ca[i].first, now * (ca[i - 1].first - ca[i].first));
	}
	sort(r2.begin(), r2.end());
	vector<ll> r;
	for (auto i : r2) {
		r.push_back(i.first);
	}
	vector<ll> prefs(1, 0), prefc(1, 0);
	for (auto i : r2) {
		prefs.push_back(prefs.back() + i.second);
		prefc.push_back(prefc.back() + i.second / i.first);
	}
	vector<ll> ans(q);
	map<ll, vector<pair<ll, pair<ll, ll>>>> q3;
	for (ll i = 0; i < q; i++) {
		ll t, k;
		cin >> t >> k;
		if (t == 1) {
			ans[i] = r.end() - upper_bound(r.begin(), r.end(), k) + 1;
		}
		if (t == 2) {
			ll x = upper_bound(r.begin(), r.end(), k) - r.begin();
			ans[i] = prefs[x] + (prefc.back() - prefc[x]) * k;
		}
		if (t == 3) {
			ll j;
			cin >> j;
			j--;
			q3[arr[j]].emplace_back(upper_bound(r.begin(), r.end(), k) - r.begin() - 1, make_pair(i, k));
		}
	}
	ll last = -1, cp = 0;
	segment_tree st(r.size() + 1), col(r.size() + 1);
	for (auto[i, _] : ca) {
		if (last != -1) {
			cp++;
			st.change(lower_bound(r.begin(), r.end(), last - i) - r.begin(), last - i);
			col.change(lower_bound(r.begin(), r.end(), last - i) - r.begin(), 1);
		}
		last = i;
		for (auto[k, xx] : q3[i]) {
			auto[num, sk] = xx;
			ans[num] = st.get(k) + (cp - col.get(k)) * sk + i;
		}
	}
	for (auto i : ans) {
		cout << i << '\n';
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
}
