#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <numeric>

using namespace std;

#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

using uint = uint32_t;
using int64 = int64_t;
using uint64 = uint64_t;

int INF32 = (int)1e9 + 2;

class DSU {
public:
	vector <int> pr, h;
	vector <int> cnt;
	vector <int> mn;
	int64 cntpair;

	int get(int v) {
		if (pr[v] == v) return v;
		return pr[v] = get(pr[v]);
	}

public:
	DSU(int n) {
		pr.resize(n); iota(all(pr), 0);
		h.assign(n, 0);
		cnt.assign(n, 1);
		mn.resize(n); iota(all(mn), 0);
		cntpair = n * (n - 1) / 2;
	}

	void unique(int u, int v) {
		u = get(u);
		v = get(v);

		if (u == v) return;

		if (h[u] < h[v]) swap(u, v);
		if (h[u] == h[v]) ++h[u];
		cntpair -= (int64)cnt[u] * cnt[v];
		mn[u] = min(mn[u], mn[v]);
		cnt[u] += cnt[v];
		pr[v] = u;
	}

	int getcnt(int v) {
		return cnt[get(v)];
	}

	int64 get() {
		return cntpair;
	}

	int getmn(int v) {
		return mn[get(v)];
	}
};

int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int n, q; cin >> n >> q;
	vector <pair <int64, int>> v(n);
	for (int i = 0; i < n; ++i) {
		cin >> v[i].first;
		v[i].second = i;
	}
	sort(all(v));

	vector <pair <pair <int64, pair <int, int64>>, int>> qu;
	for (int i = 0; i < q; ++i) {
		int t; cin >> t;
		if (t == 1) {
			int64 k; cin >> k;
			qu.push_back({ { k, {t, 0} }, i });
		}
		if (t == 2) {
			int64 k; cin >> k;
			qu.push_back({ { k, {t, 0} }, i });
		}
		if (t == 3) {
			int64 k; int j; cin >> k >> j;
			qu.push_back({ { k, {t, j} }, i });
		}
	}
	sort(all(qu));
	int qi = 0;
	vector <int64> ans(q);

	vector <int64> dv = { 0 };
	for (int i = 0; i < n - 1; ++i) {
		dv.push_back(v[i + 1].first - v[i].first);
	}
	for (auto& [p, f] : qu) {
		dv.push_back(p.first);
	}
	sort(all(dv));
	dv.resize(unique(all(dv)) - dv.begin());
	dv.push_back(0);
	sort(all(dv));

	vector <int64> c(n);
	for (int i = 0; i < n; ++i) {
		c[v[i].second] = v[i].first;
	}
	int64 allcnt = 0;
	int cnt9;
	bool flag = true;
	for (int i = 1; i < dv.size(); ++i) {
		int cnt = 0;
		vector <pair <int64, int>> c1 = v;
		if (flag) {
			for (int j = n - 1; j >= 0; --j) {
				if (j != n - 1 && v[j].first != v[j + 1].first) ++cnt;
				c1[j].first += cnt * (dv[i] - dv[i - 1]);
				allcnt += cnt * (dv[i] - dv[i - 1]);
			}
			if (cnt == 0) flag = false;
		}

		v = c1;
		for (int i = 0; i < n; ++i) {
			c[c1[i].second] = c1[i].first;
		}

		cnt9 = 1;
		for (int j = n - 1; j >= 0; --j) {
			if (j != n - 1 && v[j].first != v[j + 1].first) ++cnt9;
		}

		while (qi < q && qu[qi].first.first == dv[i]) {
			if (qu[qi].first.second.first == 1) {
				ans[qu[qi].second] = cnt9;
			}
			if (qu[qi].first.second.first == 2) {
				ans[qu[qi].second] = allcnt;
			}
			if (qu[qi].first.second.first == 3) {
				ans[qu[qi].second] = c[qu[qi].first.second.second - 1];
			}
			++qi;
		}
	}

	for (auto& x : ans) cout << x << ' ';
}