#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double
#define vll vector<ll>
#define vld vector<ld>
#define vbo vector<bool>
#define pll pair<ll, ll>
#define pii pair<int, int>
#define vin vector<int>
#define vpl vector<pll>

#define FOR(i, a, b) for(int i = a; i < b; ++i)
#define F0R(i, b) FOR(i, 0, b)
#define ROF(i, a, b) for(int i = b - 1; i >= a; --i)
#define R0F(i, b) ROF(i, 0, b)
#define each(i, a) for(auto i : a)
#define all(a) a.begin(), a.end()
#define sz(a) a.size()
#define sor(a) sort(all(a))
#define pub push_back
#define pob pop_back
#define puf push_front
#define pof pop_front

vll up, tin;
ll INF = 1e9;
ll timer = 0;
vector<vll> check;
vbo used, cut_point;
vector<vector<vll>> graph;
vector<set<ll>> exist;

void cut(ll v, ll parent, ll st)
{
    up[v] = tin[v] = timer++;
    used[v] = true;
    ll children = 0;
    each(i, check[v]){
        if (i == parent){
            continue;
        }
        if (!used[i]){
            cut(i, v, st);
            up[v] = min(up[v], up[i]);
            if (up[i] >= tin[v] && v != st){
                cut_point[v] = true;
            }
        }
        else{
            up[v] = min(up[v], tin[i]);
        }
    }
}

void dfs(ll v, ll num, ll parent = -1)
{
    if (cut_point[v]){
        used[v] = true;
        exist[v].insert(num);
        each(i, check[v]){
            if (used[i] && cut_point[i]){
                graph[num][v].pub(i);
                graph[num][i].pub(v);
            }
        }
        return;
    }
    used[v] = true;
    each(u, check[v]){
        if (!used[u]) {
            dfs(u, num, v);
            graph[num][v].pub(u);
            graph[num][u].pub(v);
        }
        else if (u != parent && v < u){
            graph[num][v].pub(u);
            graph[num][u].pub(v);
        }
    }
}

void dfs2(ll v, ll num, ll parent = -1)
{
    exist[v].insert(num);
    used[v] = true;
    each(u, check[v]){
        if (!used[u]) {
            dfs2(u, num, v);
            graph[num][v].pub(u);
            graph[num][u].pub(v);
        }
        else if (u != parent && v < u){
            graph[num][v].pub(u);
            graph[num][u].pub(v);
        }
    }
}

void gen()
{
    ll n, m;
    cin >> n >> m;
    graph.clear();
    check.assign(n, {});
    up.assign(n, 0);
    tin.assign(n, 0);
    cut_point.assign(n, false);
    used.assign(n, false);
    exist.assign(n, {});
    F0R(i, m){
        ll v, u;
        cin >> v >> u;
        v--;
        u--;
        check[v].pub(u);
        check[u].pub(v);
    }
    cut(0, -1, 0);
    used.assign(n, false);
    cut(1, -1, 1);
    used.assign(n, false);
    F0R(i, n){
        if (!used[i] && !cut_point[i]) {
            graph.pub(vector<vll >(n, vll()));
            dfs(i, sz(graph) - 1);
            F0R(i, n){
                if (cut_point[i]){
                    used[i] = false;
                }
            }
        }
    }
    F0R(i, n){
        if (!used[i]) {
            graph.pub(vector<vll >(n, vll()));
            dfs2(i, sz(graph) - 1);
        }
    }
    used.assign(sz(graph), false);
    vector<vll> dist(n, {INF, INF});
    set<vll> st;
    deque<vll> dq;
    dq.pub({0, 0, 0});
    while(sz(dq) > 0) {
        vll pos = dq[0];
        dq.pof();
        used[pos[2]] = true;
        dist[pos[0]] = {pos[1], INF, pos[0]};
        st.insert(dist[pos[0]]);
        while (!st.empty()) {
            vll v = *st.begin();
            st.erase(st.begin());
            each(u, graph[pos[2]][v[2]]) {
                if (dist[u][0] > v[1] + 1 || dist[u][1] > v[0] + 1) {
                    st.erase(dist[u]);
                    dist[u] = {min(dist[u][0], v[1] + 1), min(dist[u][1], v[0] + 1), u};
                    st.insert(dist[u]);
                }
            }
        }
        F0R(u, n){
            if (cut_point[u] && sz(graph[pos[2]][u]) > 0){
                each(i, exist[u]) {
                    if (!used[i]) {
                        dq.pub({u, dist[u][0], i});
                    }
                }
            }
        }
    }
    FOR(i, 1, n){
        if (dist[i][0] == INF){
            dist[i][0] = -1;
        }
        cout << dist[i][0] << ' ';
    }
    cout << '\n';
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll t;
    cin >> t;
    F0R(i, t){
        gen();
    }
}