#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

vector<vector<int>> gr;
vector<bool> used;
vector<int> up;
vector<int> h;

set<pair<int, int>> br;
vector<int> compedge;
int curcol;

void dfs1(int v)
{
	used[v] = 1;
	up[v] = h[v];
	for (auto to : gr[v])
	{
		if (!used[to])
		{
			h[to] = h[v] + 1;
			dfs1(to);
			if (up[to] > h[v])
			{
				br.insert({ v, to });
				br.insert({ to, v });
			}
			up[v] = min(up[v], up[to]);
		}
		else
		{
			up[v] = min(up[v], h[to]);
		}
	}
}

void dfscoledge(int v, int ccol)
{
	compedge[v] = ccol;
	used[v] = 1;
	for (auto to : gr[v])
	{
		if (!used[to])
		{
			if (br.find({ v, to }) != br.end())
			{
				dfscoledge(to, curcol++);
			}
			else
			{
				dfscoledge(to, ccol);
			}
		}
	}
}

vector<int> minev, minod;
void findshortest()
{
	minev[0] = 0;
	minod[0] = (int)2e9 + 1;
	set<pair<int, int>> s;
	s.insert({ minev[0], 0 });
	s.insert({ minod[0], 0 });
	while (!s.empty())
	{
		auto [dist, v] = *s.begin();
		s.erase(s.begin());
		for (auto to : gr[v])
		{
			if (up[to] >= h[v])
			{
				if (dist % 2 == 0)
				{
					s.erase({ minod[to], to });
					minod[to] = dist + 1;
					s.insert({ minod[to], to });
				}
			}
			else
			{
				if (dist % 2 == 0 && minod[to] > dist + 1)
				{
					s.erase({ minod[to], to });
					minod[to] = dist + 1;
					s.insert({ minod[to], to });
				}
				else if (dist % 2 == 1 && minev[to] > dist + 1)
				{
					s.erase({ minev[to], to });
					minev[to] = dist + 1;
					s.insert({ minev[to], to });
				}
			}
		}
	}
}

vector<bool> ap;

void dfs2(int v)
{
	used[v] = 1;
	up[v] = h[v];
	for (auto to : gr[v])
	{
		if (!used[to])
		{
			h[to] = h[v] + 1;
			dfs2(to);
			up[v] = min(up[v], up[to]);
		}
		else
		{
			up[v] = min(up[v], h[to]);
		}
	}
}

vector<int> compv;
void colorv(int v, int ccol)
{
	used[v] = 1;
	compv[v] = ccol;
	for (auto to : gr[v])
	{
		if (up[to] >= h[v])
		{
			colorv(to, curcol++);
		}
		else
		{
			colorv(to, ccol);
		}
	}
}

vector<set<int>> newg;
void buildnewg(int v)
{
	used[v] = 1;
	for (auto to : gr[v])
	{
		if (!used[to])
		{
			if (compv[v] != compv[to])
			{
				newg[compv[v]].insert(compv[to]);
				newg[compv[to]].insert(compv[v]);
			}
		}
	}
}

void solve()
{
	int n, m;
	cin >> n >> m;

	gr.assign(n, vector<int>(0));

	for (int i = 0; i < m; i++)
	{
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		gr[a].push_back(b);
		gr[b].push_back(a);
	}

	used.assign(n, 0);
	up.resize(n);
	h.resize(n);
	br.clear();
	dfs1(0);
	compedge.resize(n);
	compedge[0] = 0;
	curcol = 0;
	used.assign(n, 0);
	dfscoledge(0, curcol++);
	
	vector<int> anss(n);
	for (int i = 0; i < n; i++)
	{
		if (compedge[i] != compedge[0])
		{
			anss[i] = -1;
		}
	}

	used.assign(n, 0);
	ap.assign(n, 0);
	dfs2(0);

	minev.assign(n, 2e9);
	minod.assign(n, 2e9);
	findshortest();

	for (int i = 0; i < n; i++)
	{
		if (minev[i] > 1e9)
		{
			anss[i] = -1;
		}
	}

	for (int i = 0; i < n; i++)
	{
		if (anss[i] != -1)
		{
			anss[i] = minev[i];
		}
	}

	for (int i = 1; i < n; i++)
	{
		cout << anss[i] << " ";
	}
	cout << "\n";
}

int main()
{
	int t;
	cin >> t;
	for (int i = 0; i < t; i++)
	{
		solve();
	}
}