#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,avx,avx2,mmx,abm,popcnt")

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

struct rb
{
	int l, r, c, t;
	rb() = default;
	const bool operator==(const rb& other)
	{
		return l == other.l && r == other.r && c == other.c && t == other.t;
	}
};

struct cmp
{
	const bool operator()(const rb& a, const rb& b) const
	{
		return make_pair(a.r, a.l) < make_pair(b.r, b.l);
	}
};

void solve()
{
	int n, m;
	cin >> n >> m;
	vector<int> a(n);
	for (int i = 0; i < n; i++)
	{
		cin >> a[i];
	}

	vector<rb> b(m);

	for (int i = 0; i < m; i++)
	{
		cin >> b[i].l >> b[i].r >> b[i].c >> b[i].t;
		b[i].l--;
		b[i].r--;
	}
	vector<rb> initb = b;

	//sort(b.begin(), b.end(), [](const rb& a, const rb& b)
	//	{
	//		if (a.t == 1 && b.t == 0)
	//		{
	//			return true;
	//		}
	//		else if (a.t == 0 && b.t == 1)
	//		{
	//			return false;
	//		}
	//		return make_pair(a.l, a.r) < make_pair(b.l, b.r);
	//	});

	multiset<rb, cmp> s;

	for (int i = 0; i < n; i++)
	{
		int curadd = 0;
		vector<int> curfill(n, 0);
		long long res = 0;
		b = initb;
		for (int j = 0; j < m; j++)
		{
			if (b[j].t)
			{
				b[j].l = min(b[j].l, i);
				b[j].r = max(b[j].r, i);
			}
		}

		sort(b.begin(), b.end(), [](const rb& a, const rb& b)
			{
				return make_pair(a.l, a.r) < make_pair(b.l, b.r);
			});
		for (int x = 0; x < n; x++)
		{
			while (curadd < m && b[curadd].l <= x)
			{
				s.insert(b[curadd++]);
			}
			while (!s.empty() && s.begin()->r < x)
			{
				s.erase(s.begin());
			}
			while (!s.empty() && curfill[x] < a[x])
			{
				int curadd = min(a[x] - curfill[x], s.begin()->c);
				curfill[x] += curadd;
				res += curadd;
				auto cur = *s.begin();
				s.erase(s.begin());
				cur.c -= curadd;
				if (cur.c != 0)
				{
					s.insert(cur);
				}
			}
		}

		cout << res << " ";
	}
	cout << "\n";
}

int main()
{
#ifdef _DEBUG
#pragma warning(disable : 4996)
	freopen("input.txt", "r", stdin);
#endif // _DEBUG


	int t;
	cin >> t;
	for (int i = 0; i < t; i++)
	{
		solve();
	}
	return 0;
}