//#include <iostream>
#include <bits/stdc++.h>

using namespace std;

//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("O3")

#define int long long
//#define int128 __int128

//#define int int128

int ccount = 0;

struct DSU{
    vector<int> parent;
    vector<pair<int, int>> all;

    void build(int n){
        parent.resize(n, 0);
        all.resize(n);
        for(int i = 0; i < n; i++) {parent[i] = i; all[i] = {i, i};}
    }

    int get(int a){
        if(parent[a] == a) return a;
        int t = get(parent[a]);
        parent[a] = t;
        all[a].first = all[parent[a]].first;
        all[a].second = all[parent[a]].second;
        return t;
    }

    void merge(int a, int b){
        a = get(a);
        b = get(b);
        if(a == b) return;
        ccount--;
        parent[b] = a;
        all[a].first = min(all[b].first, all[a].first);
        all[a].second = max(all[b].second, all[a].second);
        all[b].first = min(all[b].first, all[a].first);
        all[b].second = max(all[b].second, all[a].second);
    }
};

struct T{
    int time;
    int a;
    int b;
};

bool operator<(T a, T b){
    return a.time < b.time;
}
struct T2{
    int time;
    int type;
    int id;
};

bool operator<(T2 a, T2 b){
    return make_pair(a.time, a.type) < make_pair(b.time, b.type);
}

const int G = 1ll << 19;

int tt = 0;

struct sigment_tree{
    pair<int, int> tree[2*G];
    void build(){
        for(int i = 0; i < 2*G; i++){
            tree[i].first = 0;
            tree[i].second = 0;
        }
    }
    void push(int node, int len){
        for(int i = 0; i < 2; i++){
            tree[node*2+i].first += tree[node].second * (len/2);
            tree[node*2+i].second += tree[node].second;
        }
        tree[node].second = 0;
    }

    void change(int ql, int qr, int val, int node = 1, int l = 0, int r = G){
        if(l >= qr || r <= ql) return;
        if(ql <= l && r <= qr){
            tree[node].first += val * (r-l);
            tree[node].second += val;
            return;
        }
        if(tree[node].second != 0) push(node, r-l);
        int m = l + (r-l)/2;
        change(ql, qr, val, node*2, l, m);
        change(ql, qr, val, node*2+1, m, r);
        tree[node].first = tree[node*2].first + tree[node*2+1].first;
    }

    int get(int ql = 0, int qr = tt, int node = 1, int l = 0, int r = G){
        if(l >= qr || r <= ql) return 0;
        if(ql <= l && r <= qr){
            return tree[node].first;
        }
        if(tree[node].second != 0) push(node, r-l);
        int m = l + (r-l)/2;
        return get(ql, qr, node*2, l, m) + get(ql, qr,  node*2+1, m, r);
    }
};

int32_t main() {
    int n;
    cin >> n;
    tt = n;
    int q;
    cin >> q;

    vector<int> a(n);
    for(int i = 0; i < n; i++){
        cin >> a[i];
    }

    sort(a.begin(), a.end());

    int cost[n];

    set<int> st;

    for(int i = n-1; i >= 0; i--){
        cost[i] = st.size();
        while(i > 0 && a[i-1] == a[i]) {
            cost[i-1] = cost[i];
            i--;
        }
        st.insert(a[i]);
    }

    sigment_tree tree;

    for(int i = 0; i < n; i++){
        tree.change(i, i+1, cost[i]);
    }

    vector<T> b;

    for(int i = 1; i < n; i++){
        b.push_back({a[i] - a[i-1], i-1, i});
    }

    sort(b.begin(), b.end());
    ccount = n;

    int l = 0;

    DSU d; int ans[q]; d.build(a.size());

    while(l < b.size() && b[l].time == 0){
        d.merge(b[l].a, b[l].b);
        l++;
    }

    vector<T2> que;

    for(int i = 0; i < q; i++){
        int aa, bb;
        cin >> aa >> bb;
        if(aa == 1 || aa == 2) que.push_back({bb, 2-aa, i});
    }

    //----------------------------------------------------------------------QUEST1
    sort(que.begin(), que.end());
    int anss = 0;

    int time = 0;

    for(int i = 0; i < que.size(); i++){
        if(que[i].type == 1) {
            while (l < b.size() && que[i].time >= b[l].time) {
                anss += tree.get() * (que[i].time - time);
                tree.change(0, d.all[b[l].a+1].second, -1);
                d.merge(b[l].a, b[l].b);
                l++;
            }
            time = que[i].time;
            ans[que[i].id] = ccount;
        }else{
            ans[que[i].id] = anss + tree.get(0, n) * (que[i].time - time);
        }
    }
    //-----------------------------------------------------------------------QUEST2

    for(int i = 0; i < q; i++){
        cout << ans[i] << "\n";
    }

    return 0;
}