#include <bits/stdc++.h>

using namespace std;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

#define ll long long
#define int ll

#define mp make_pair

#define x first
#define y second

#define endl '\n'

const int INF = 1e9;

struct Node {
    Node* left = nullptr, *right = nullptr;
    int sum = 0, mem=0,cnt=0;
};

const int maxx = 11;

struct ST {
    Node* root;

    ST (int sz) {
        root = new Node();
    }

    void upd(Node* i, int x, int y, int sz) {
        i->mem += x;
        i->cnt += y;
        i->sum += sz * x + sz * (sz - 1) / 2 * y;
    }

    void push(Node* i, int l, int r) {
        int mid = (l + r) / 2;
        if (i->left == nullptr)
            i->left = new Node();
        if (i->right == nullptr)
            i->right = new Node();

        upd(i->left, i->mem, i->cnt, mid - l);
        upd(i->right, i->mem + i->cnt * (mid - l), i->cnt, r - mid);

        i->cnt = 0;
        i->mem = 0;
    }

    Node* add (Node* i, int l, int r, int ql, int qr, int x, int y) {
        if (qr <= l || r <= ql)
            return i;
        if (i == nullptr) {
            i = new Node();
        }

        if (ql <= l && r <= qr) {
            upd(i, x, y, r - l);
            return i;
        }

        int mid = (l + r) / 2;
        i->left = add(i->left, l, mid, ql, qr, x, y);
        i->right = add(i->right, mid, r, ql, qr, x + (mid - min(mid, max(l, ql))) * y, y);
        i->sum = 0;
        if (i->left != nullptr)
            i->sum += i->left->sum;
        if (i->right != nullptr)
            i->sum += i->right->sum;

        return i;
    }

    int get(Node* i, int l, int r, int ql, int qr) {
        if (i == nullptr)
            return 0;
        if (ql <= l && r <= qr)
            return i->sum;
        if (qr <= l || r <= ql)
            return 0;

        push(i, l, r);
        int mid = (l + r) / 2;
        return get(i->left, l, mid, ql,  qr) + get(i->right, mid, r, ql, qr);
    }

    void add_progression(int l, int r, int val) {
        add(root, 0, maxx, l, r, 0, val);
    }

    int get(int x) {
        return get(root, 0, maxx, x, x + 1);
    }
};


void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> c(n);

    map<int, int> cnt;
    map<int, int> num, io;
    for (int i = 0; i < n; ++i) {
        cin >> c[i];
        ++cnt[c[i]];
        num[i] = c[i];
    }

    sort(all(c));
    c.resize(unique(all(c)) - c.begin());
    sort(all(c));

    n = c.size();

    for (int i = 0; i < n; ++i)
        io[c[i]] = i;

    vector<int> dst(n - 1);

    for (int i = n - 2; i >= 0; --i) {
        dst[i] = c[i + 1] - c[i];
    }

    vector<int> sorted_c = c;
    sort(all(sorted_c));

    map<int, int> less_c;
    for (int i = 1; i < n; ++i) {
        less_c[sorted_c[i]] = less_c[sorted_c[i - 1]] + cnt[sorted_c[i - 1]];
    }

    vector<pair<int, int>> tmp(n);
    for (int i = 0; i < n - 1; ++i)
        tmp[i] = {dst[i], i};
    tmp[n - 1] = {0, -1};

    sort(all(tmp));

    vector<int> groups(tmp.size() + 1);
    for (int i = 0; i < n; ++i)
        groups[0] += cnt[c[i]] * (n - i - 1);

    for (int i = 1; i < n; ++i) {
        int mc = c[tmp[i].y];
        groups[i] = groups[i - 1] - cnt[mc] - less_c[mc];
    }

    vector<int> sum(n);
    for (int i = 1; i < n; ++i) {
        sum[i] = groups[i - 1] * (tmp[i].x - tmp[i - 1].x) + sum[i - 1];
    }

    vector<int> ans(q);

    map<int, vector<pair<int, int>>> req;

    for (int i = 0; i < q; ++i) {
        int type, k;
        cin >> type >> k;
        if (type == 1) {
            int u = upper_bound(all(tmp), mp(k, INF)) - tmp.begin();
            ans[i] = n + 1 - u;
        } else if (type == 2) {
            int u = lower_bound(all(tmp), mp(k, -3LL)) - tmp.begin() - 1;
            u = max(u, 0LL);
            // cout << "u = " << u << endl;
            ans[i] = sum[u] + groups[u] * (k - tmp[u].x);
        } else {
            int x;
            cin >> x;
            req[io[num[x - 1]]].push_back({k, i});
        }
    }

    ST st(maxx);

    for (auto r : req[n - 1])
        ans[r.y] = c[n - 1];

    for (int i = n - 2; i >= 0; --i) {
        int diff = c[i + 1] - c[i];
        st.add_progression(0, maxx, 1);
        st.add_progression(diff, maxx, -1);

        /*
        cout << diff << endl;

        for (int i = 0; i < 10; ++i) {
            cout << st.get(i) << " ";
        }
        cout << endl;
        */

        for (auto r : req[i]) {
            ans[r.y] = c[i] + st.get(r.x);
        }
    }

    for (int i : ans)
        cout << i << endl;
}

signed main() {
#ifdef LOCAL
freopen("in.txt", "r", stdin);
#else
cin.tie(NULL);
cout.tie(NULL);
ios_base::sync_with_stdio(false);
#endif // LOCAL

    solve();
}
