#include <bits/stdc++.h>

using namespace std;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

#define ll long long
#define int ll

#define mp make_pair

#define x first
#define y second

#define endl '\n'

const int INF = 1e9;

struct ST {
    vector<int> tree;

    ST (int sz) {
        tree.resize(4 * sz);
    }

    void add(int l, int r, int val) {
        for (int i = l; i < r; ++i)
            tree[i] += val;
    }

    int get(int x) {
        return tree[x];
    }
};

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> c(n);

    map<int, int> cnt;
    map<int, int> num;
    for (int i = 0; i < n; ++i) {
        cin >> c[i];
        ++cnt[c[i]];
        num[i] = c[i];
    }

    sort(all(c));
    c.resize(unique(all(c)) - c.begin());
    sort(all(c));

    n = c.size();

    vector<int> dst(n - 1);

    for (int i = n - 2; i >= 0; --i) {
        dst[i] = c[i + 1] - c[i];
    }

    vector<int> sorted_c = c;
    sort(all(sorted_c));

    map<int, int> less_c;
    for (int i = 1; i < n; ++i) {
        less_c[sorted_c[i]] = less_c[sorted_c[i - 1]] + cnt[sorted_c[i - 1]];
    }

    vector<pair<int, int>> tmp(n);
    for (int i = 0; i < n - 1; ++i)
        tmp[i] = {dst[i], i};
    tmp[n - 1] = {0, -1};

    sort(all(tmp));

    vector<int> groups(tmp.size() + 1);
    for (int i = 0; i < n; ++i)
        groups[0] += cnt[c[i]] * (n - i - 1);

    for (int i = 1; i < n; ++i) {
        int mc = c[tmp[i].y];
        groups[i] = groups[i - 1] - cnt[mc] - less_c[mc];
    }

    vector<int> sum(n);
    for (int i = 1; i < n; ++i) {
        sum[i] = groups[i - 1] * (tmp[i].x - tmp[i - 1].x) + sum[i - 1];
    }

    vector<int> ans(q);

    map<int, vector<pair<int, int>>> req;

    for (int i = 0; i < q; ++i) {
        int type, k;
        cin >> type >> k;
        if (type == 1) {
            int u = upper_bound(all(tmp), mp(k, INF)) - tmp.begin();
            ans[i] = n + 1 - u;
        } else if (type == 2) {
            int u = lower_bound(all(tmp), mp(k, -3LL)) - tmp.begin() - 1;
            u = max(u, 0LL);
            // cout << "u = " << u << endl;
            ans[i] = sum[u] + groups[u] * (k - tmp[u].x);
        } else {
            int x;
            cin >> x;
            req[num[x - 1]].push_back({k, i});
        }
    }

    for (auto r : req[c[n - 1]])
        ans[r.y] = c[n - 1];

    ST st(1e4 + 1);

    for (int i = n - 2; i >= 0; --i) {
        st.add(1, c[i + 1] - c[i], 1);
        for (auto r : req[c[i]]) {
            ans[r.y] = c[i] + st.get(r.x);
        }
    }

    for (int i : ans)
        cout << i << endl;
}

signed main() {
#ifdef LOCAL
freopen("in.txt", "r", stdin);
#else
cin.tie(NULL);
cout.tie(NULL);
ios_base::sync_with_stdio(false);
#endif // LOCAL

    solve();
}
