#include <bits/stdc++.h>
#define int long long
//#define endl "\n"
using namespace std;
int INF = 1e9;

template <class T>
istream& operator >> (istream& in, vector <T> &a) {
    for (auto &el: a) in >> el;
    return in;
}

template <class T>
ostream& operator << (ostream& out, vector <T> &a) {
    for (auto &el: a) out << el << " ";
    return out;
}

vector <vector <int> > gr;
vector <int> up, tin, used, is_point;
int timer = 0;

void dfs(int v, int p) {
    used[v] = 1;
    tin[v] = up[v] = timer++;
    for (auto u: gr[v]) {
        if (u == p) continue;
        if (used[u]) {
            up[v] = min(up[v], tin[u]);
        } else {
            dfs(u, v);
            up[v] = min(up[v], up[u]);
        }
        is_point[v] = max((bool)is_point[v], up[u] >= tin[v]);
    }
}


void dfs2(int v) {
    if (used[v]) return;
    used[v] = 1;
    for (auto u: gr[v]) {
        if (!is_point[u]) dfs2(u);
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    used.resize(n);
    tin.resize(n);
    up.resize(n);
    is_point.resize(n);
    gr.resize(n);
    timer = 0;
    gr.clear();
    used.assign(n, 0);
    tin.assign(n, 0);
    up.assign(n, 0);
    is_point.assign(n, 0);

    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--;b--;
        gr[a].push_back(b);
        gr[b].push_back(a);
    }

//    dfs(0, -1);
//    used.assign(n, 0);
//    dfs2(0);
    used.assign(n, 1);
    vector <int> dist(n, INF);
    for (auto u: gr[0]) if (used[u]) dist[u] = 1;

    for (int i = 0; i < n; i++) {
        for (int v = 0; v < n; v++) {
            if (!used[v]) continue;
            int min_dist = INF;
            for (auto u: gr[v]) min_dist = min(min_dist, dist[u]);
            for (auto u: gr[v]) dist[u] = min(dist[u], min_dist + 2);
        }
    }

    for (int i = 1; i < n; i++) {
        int min_dist = INF;
        for (auto u: gr[i]) min_dist = min(min_dist, dist[u]);
        if (min_dist == INF) cout << -1 << " ";
        else cout << min_dist + 1 << " ";
    }
    cout << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t;
    cin >> t;
    while(t--) {
        solve();
    }

}


