#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()
#define len(x) (int) (x).size()
#define endl "\n"
#define int long long


using namespace std;

mt19937_64 rnd(228);


struct node {
    int sm = 0, cnt = 0;
    int modstart = 0, moddelta = 0;
    int startval = 0;
    int y = 0;
    int sz = 1;

    node *l = nullptr, *r = nullptr;

    node(int a, int b) : y(rnd()), startval(a), cnt(b), sm(a) {};

    node() = default;
};


int sz(node *root) {
    if (root == nullptr) {
        return 0;
    } else {
        return root->sz;
    }
}

void recalc(node *root) {
    if (root == nullptr) {
        return;
    }
    root->sz = sz(root->l) + sz(root->r) + 1;
}


void push(node *root) {
    if (root == nullptr) {
        return;
    }
    root->sm += root->cnt * (root->modstart + root->moddelta * sz(root->l));
    if (root->l != nullptr) {
        root->l->modstart += root->modstart;
        root->l->moddelta += root->moddelta;
    }
    if (root->r != nullptr) {
        root->r->modstart += root->modstart + root->moddelta * sz(root->l) + 1;
        root->r->moddelta += root->moddelta;
    }
    root->modstart = root->moddelta = 0;
}


node *merge(node *a, node *b) {
    push(a), push(b);
    if (a == nullptr) {
        return b;
    }
    if (b == nullptr) {
        return a;
    }
    if (a->y < b->y) {
        a->r = merge(a->r, b);
        recalc(a);
        return a;
    } else {
        b->l = merge(a, b->l);
        recalc(b);
        return b;
    }
}

pair<node *, node *> split(node *a, int k) {
    push(a);
    if (a == nullptr) {
        return {nullptr, nullptr};
    }

    if (k > sz(a)) {
        assert(false);
    }

    if (sz(a -> l) >= k) {
        auto [x, y] = split(a -> l, k);
        a -> l = y;
        recalc(a);
        return {x, a};
    } else {
        auto [x, y] = split(a -> r, k - sz(a -> l) - 1);
        a -> r = x;
        recalc(a);
        return {a, y};
    }
}



int countless(node* root, int val) {
    push(root);
    if (root == nullptr) {
        return 0;
    }
    if (root -> startval > val) {
        return countless(root -> l, val);
    } else if (root -> startval == val) {
        return sz(root -> l);
    } else {
        return sz(root -> l) + 1 + countless(root -> r, val);
    }
}


node* unite(node* a, node* b) {
    push(a), push(b);
    b -> cnt += a -> cnt;
    b -> sm += a -> sm;
    return b;
}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, q;
    cin >> n >> q;

    vector<int> start(n);
    map<int, int> val;
    for (int &i: start) {
        cin >> i;
        val[i]++;
    }

    node *root = nullptr;
    for (auto[i, cnt]: val) {
        root = merge(root, new node(i, cnt));
    }
    vector <array <int, 4>> event;
    for (int i = 0; i < q; i++) {
        int t;
        cin >> t;
        if (t == 1) {
            int x;
            cin >> x;
            event.push_back({x, 1, -1, i});
        } else if (t == 2) {
            int x;
            cin >> x;
            event.push_back({x, 2, -1, i});
        } else {
            int a, b;
            cin >> a >> b;
            event.push_back({a, 2, b, i});
        }
    }

    auto it = val.begin(), it2 = next(val.begin());
    while (it2 != val.end()) {
        event.push_back({it2 -> first - it -> first, 0, it -> first, -1});
        it++, it2++;
    }

    sort(all(event));

    vector <int> ans(q, -1);
    for (auto [a, t, b, id] : event) {
        if (t == 1) {
            ans[id] = sz(root);
        } else if (t == 2) {

        } else if (t == 3) {

        } else {
            int val = countless(root, b);
            auto [q, w] = split(root, val);
            auto [e, r] = split(w, 2);

            auto [x, y] = split(e, 1);
            root = merge(merge(q, unite(x, y)), r);
        }
    }
    for (auto x : ans) {
        cout << x << endl;
    }
    return 0;
}
