#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()
#define len(x) (int) (x).size()
#define endl "\n"
#define int long long

using namespace std;


const int N = 1010;
vector <int> g[N];

int dist[N][N];
bool mat[N][N];


void solve() {
    int n, m;
    cin >> n >> m;

    for (int i = 0; i < n; i++) {
        fill(mat, mat + n, false);
        g[i].clear();
    }

    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        mat[a][b] = mat[b][a] = true;
        g[a].push_back(b);
        g[b].push_back(a);
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            dist[i][j] = -1;
        }
    }
    deque <pair <int, int>> q;

    for (int i : g[0]) {
        dist[0][i] = 1;
        q.emplace_back(0, i);
    }

    vector <int> used(n, 0);
    while (!q.empty()) {
        auto [we, v] = q.front();
        q.pop_front();

        for (int i : g[we]) {
            if (i != v && (dist[i][v] == -1 || dist[i][v] > dist[we][v])) {
                dist[i][v] = dist[we][v];
                q.push_front({i, v});
            }
        }

        if (mat[we][v]) {
            if (!used[we]) {
                used[we] = 1;
                for (int j : g[we]) {
                    if (dist[we][j] == -1) {
                        dist[we][j] = dist[we][v] + 2;
                        q.emplace_back(we, j);
                    }
                }
            }
        }
    }

    for (int i = 1; i < n; i++) {
        int mx = INT_MAX;
        for (int j : g[i]) {
            if (dist[i][j] != -1) {
                mx = min(mx, dist[i][j] + 1);
            }
        }
        if (mx == INT_MAX) {
            cout << -1 << " ";
        } else {
            cout << mx << " ";
        }
    }
    cout << endl;
}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int q;
    cin >> q;
    while (q--) {
        solve();
    }
    return 0;
}
