#include <cassert>
#include <algorithm>
#include <iostream>
#include <vector>
#include <string>

using namespace std;

#define all(a) (a).begin(), (a).end()

typedef long long ll;


class FenwickTree {
	vector < int > t;

public:
	FenwickTree(int sz) {
		t.resize(sz + 1, 0);
	}

	void change(int x, int add) {
		for (int i = x + 1; i < t.size(); i += i & -i)
			t[i] += add;
	}

	int prefix_sum(int x) {
		int res = 0;
		for (int i = x + 1; i > 0; i -= i & -i)
			res += t[i];
		return res;
	}
};
#define int ll

signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

	string s;
	ll y;
	cin >> s >> y;
	int n = s.size();

	ll cnt = 0;
	for (ll i = 1; i < y; i *= 10)
		cnt++;
	for (ll i = 1; i < n; i *= 10)
		cnt++;
	cnt += 1;

	vector < pair < int, int > > ord;
	for (int i = 0; i < n; i++)
		ord.push_back({ s[i] - '0', i });
	sort(all(ord), [&](pair < int, int > a, pair < int, int > b) {
		return a.first > b.first || a.first == b.first && a.second < b.second;
		});

	string ans;
	for (int i = 0; i < n - cnt; i++)
		ans += ord[i].first + '0';
	s.clear();

	vector < pair < int, int > > tmp;
	for (int i = max(n - cnt, 0LL); i < n; i++)
		tmp.push_back(ord[i]);
	ord = tmp;
	sort(all(ord), [&](pair < int, int > a, pair < int, int > b) {
		return a.second < b.second;
		});
	s.clear();
	for (pair < int, int > el : ord)
		s.push_back(el.first + '0');
	n = s.size();

	assert(n <= 22);

	vector < pair < string, ll > > dp((1 << n), { "", 0 });
	for (int m = 1; m < (1 << n); m++) {
		ll cnt = 0;
		for (int i = 0; i < n; i++) {
			if (!(m & (1 << i)))
				continue;

			int nm = m ^ (1 << i);
			string v1 = s[i] + dp[nm].first;
			ll v2 = dp[m].second - (dp[nm].second + y * cnt);

			bool ch1 = true, ch2 = true;
			if (!dp[m].first.empty()) {
				int pos = v1.size();
				for (int j = 0; j < v1.size(); j++) {
					if (dp[m].first[j] != v1[j]) {
						pos = j;
						break;
					}
				}

				if (v1.size() - pos - 1 > 18) {
					ch1 = dp[m].first < v1;
					ch2 = false;
				}
				else {
					ll c1 = 0, c2 = 0;
					for (int j = pos; j < v1.size(); j++) {
						c1 = c1 * 10LL + (dp[m].first[j] - '0');
						c2 = c2 * 10LL + (v1[j] - '0');
					}
					ch1 = c1 - c2 < v2;
					ch2 = c1 - c2 == v2;
				}
			}

			if (ch1 || ch2 && dp[m].first < v1)
				dp[m] = { v1, dp[nm].second + y * cnt };
			cnt++;
		}
	}

	cout << ans << dp[(1 << n) - 1].first << "\n";

	return 0;
}
