#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <unordered_map>

using namespace std;

#define all(a) (a).begin(), (a).end()

typedef long long ll;


struct Request {
	int t, i, id;
	ll k;

	bool operator <(Request r) {
		return k < r.k;
	}
};


class FenwickTree {
	vector < ll > t;

public:
	FenwickTree(int sz) {
		t.resize(sz + 1, 0);
	}

	void change(int x, ll add) {
		for (int i = x + 1; i < t.size(); i += i & -i)
			t[i] += add;
	}

	ll prefix_sum(int x) {
		ll res = 0;
		for (int i = x + 1; i > 0; i -= i & -i)
			res += t[i];
		return res;
	}
};


signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

	ll n;
	int q;
	cin >> n >> q;

	unordered_map < ll, int > cnt;
	vector < ll > c(n), c0;
	for (int i = 0; i < n; i++) {
		cin >> c[i];

		cnt[c[i]]++;
	}
	c0 = c;
	sort(all(c));

	vector < Request > rq(q), r2;
	for (int i = 0; i < q; i++) {
		cin >> rq[i].t >> rq[i].k;

		rq[i].id = i;
		if (rq[i].t == 3) {
			cin >> rq[i].i;

			rq[i].i = lower_bound(all(c), c0[rq[i].i - 1]) - c.begin();
			r2.push_back(rq[i]);
		}

	}
	sort(all(r2));

	ll vl = n * (n - 1) / 2;
	vector < pair < ll, int > > id;
	for (int i = 0; i < n; i++) {
		if (i == 0 || c[i] == c[i - 1]) {
			vl -= i;
			continue;
		}

		id.push_back({ c[i] - c[i - 1], i });
	}
	sort(all(id));

	ll lt = 0;
	int rq_id = 0;
	FenwickTree a(n + 1), b(n + 1);
	for (int i = n - 1; i >= 0; i--) {
		a.change(i, lt);
		a.change(i + 1, -lt);
		if (i > 0 && c[i] != c[i - 1])
			lt++;
	}
	lt = 0;

	vector < ll > sm(1, 0), alf(1, vl), res(q);
	for (pair < ll, int > el : id) {
		for (; rq_id < r2.size() && r2[rq_id].k <= el.first; rq_id++)
			res[r2[rq_id].id] = c[r2[rq_id].i] + b.prefix_sum(r2[rq_id].i) + (lt + r2[rq_id].k) * a.prefix_sum(r2[rq_id].i);

		sm.push_back(sm.back() + (el.first - lt) * vl);
		lt = el.first;
		vl -= (ll)el.second;
		alf.push_back(vl);

		a.change(0, -1);
		a.change(el.second, 1);

		b.change(0, el.first);
		b.change(el.second, -el.first);
	}


	for (int i = 0; i < q; i++) {
		int t = rq[i].t;
		ll k = rq[i].k;

		if (t == 1) {
			int cur = upper_bound(all(id), make_pair(k, (int)1e9)) - id.begin();

			res[rq[i].id] = cnt.size() - cur;
		}
		else if (t == 2) {
			int cur = upper_bound(all(id), make_pair(k, (int)1e9)) - id.begin();

			ll gd = 0;
			if (cur > 0)
				gd = id[cur - 1].first;

			res[rq[i].id] = sm[cur] + (k - gd) * alf[cur];
		}
	}

	for (ll el : res)
		cout << el << "\n";

	return 0;
}