#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>

#define endl '\n'

using namespace std;

const int Base = 5005;

int t;
int n, m;
int usedCl = 1;
int used[Base];
int dp[Base];
bool e[Base][Base];
queue<int> que;

void dfs(int x, int ban, int dpVal)
{
	if (e[x][ban] && dp[x] == -1)
	{
		dp[x] = dpVal;
		que.push(x);
	}
	used[x] = usedCl;

	for (int i = 0; i < n; i++)
	{
		if (i != ban && e[x][i] && used[i] != usedCl)
		{
			dfs(i, ban, dpVal);
		}
	}
}

void check(int x)
{
	for (int i = 0; i < n; i++)
	{
		if (e[x][i])
		{
			dfs(x, i, dp[x] + 2);
			usedCl++;
		}
	}
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG

	ios_base::sync_with_stdio(0);
	cin.tie(0);

	cin >> t;
	while (t--)
	{
		cin >> n >> m;

		for (int i = 0; i < n; i++)
		{
			for (int j = 0; j < n; j++)
			{
				e[i][j] = false;
			}
		}
		for (int i = 0; i < n; i++)
		{
			dp[i] = -1;
		}

		for (int i = 0; i < m; i++)
		{
			int u, v;
			cin >> u >> v;
			u--;
			v--;
			e[u][v] = true;
			e[v][u] = true;
		}

		dp[0] = 0;
		que.push(0);
		while (!que.empty())
		{
			int x = que.front();
			que.pop();
			
			check(x);
		}
		for (int i = 1; i < n; i++)
		{
			cout << dp[i] << ' ';
		}
		cout << endl;
	}

	return 0;
}