#include <bits/stdc++.h>

using namespace std;
constexpr int MAXN = 5000;
constexpr int MAXV = MAXN * MAXN;
constexpr int INF = (int)1e9;
vector<pair<int, int>> g[MAXV];
int dist[MAXV];
int n, m;
int cnt_vert;

int get_idx(int u, int v) {
    return u * n + v;
}

void add_edge(const pair<int, int>& u, const pair<int, int>& v, int w) {
    const auto& [u1, v1] = u;
    const auto& [u2, v2] = v;
    g[get_idx(u1, v1)].emplace_back(get_idx(u2, v2), w);
    g[get_idx(u2, v2)].emplace_back(get_idx(u1, v1), w);
}

void bfs01() {
    fill(dist, dist + cnt_vert, INF);
    deque<int> q;
    q.push_back(0);
    dist[0] = 0;

    while (!q.empty()) {
        int v = q.front();
        q.pop_front();

        for (const auto& [to, w] : g[v]) {
            if (dist[to] > dist[v] + w) {
                dist[to] = dist[v] + w;
                if (w == 0) {
                    q.push_front(to);
                } else {
                    q.push_back(to);
                }
            }
        }
    }
}

void solve() {
    cin >> n >> m;
    cnt_vert = n * n;
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;

        add_edge({u, v}, {u, u}, 1);
        add_edge({v, u}, {v, v}, 1);
        for (int w = 0; w < n; ++w) {
            if (u != w && v != w) {
                add_edge({ u, w }, { v, w }, 0);
            }
        }
    }

    bfs01();

    for (int v = 1; v < n; ++v) {
        if (dist[get_idx(v, v)] == INF) {
            cout << "-1 ";
        } else {
            cout << dist[get_idx(v, v)] << ' ';
        }
    }
    cout << '\n';
}

void clear_graph() {
    for (int v = 0; v < cnt_vert; ++v) {
        g[v].clear();
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);

    int t;
    cin >> t;
    while (t--) {
        solve();
        clear_graph();
    }

    return 0;
}

