#pragma GCC optimize("Ofast")
#pragma GCC target("avx2,bmi2,avx512f,avx512dq")
#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
int ptwo = 131072;
struct stree
{
	std::vector<int> data;
	stree()
	{
		data.resize(ptwo*2);
	}
	void inc(int at)
	{
		at += ptwo;
		while(at) data[at]++, at /= 2;
	}
	int rsum(int v, int L, int R, int qr)
	{
		// ql = 0
		if(0 <= L && R <= qr) return data[v];
		if(R <= 0 || L >= qr) return 0;
		int M = (L + R) / 2;
		if(qr <= M)
			return rsum(2*v, L, M, qr);
		else return data[2*v] + rsum(2*v+1, M, R, qr);
		//return rsum(2*v, L, (L+R)/2, qr) +
		//	rsum(2*v+1, (L+R)/2, R, qr);
	}
};
std::vector<int> ctrs(10);
int64_t inversions(std::vector<int> ar) // permutation
{
	stree st {};
	//for(int x :  ar) printf("%d ", x); printf("\n");
	// count smaller elements on suffix
	int n = ar.size();
	std::vector<int> ctrs(n);
	int64_t ans = 0;
	//for(int i = 0; i < n; i++)
	for(int i = n; i --> 0;)
	{
		int e = ar[i];
		//for(int x : ctrs) printf("%d ", x); printf("\n");
		//for(int j = e; j < n; j++) ans += ctrs[j];
		st.inc(e);
		ans += st.rsum(1, 0, ptwo, e);
		//ctrs[e]++;
	}
	//printf("%lld\n", ans);
	return ans;
}
std::vector<std::vector<int>> Dmap;
std::vector<std::vector<int>> get_dmap(std::string t)
{
	std::vector<std::vector<int>> dmap(10);
	for(int i = 0; i < 10; i++)
		dmap[i].resize(ctrs[i]);
	std::vector<int> inds(10, 0);
	for(int i = 0; i < t.size(); i++)
	{
		char c = t[i]-'0';
		int j = inds[c]++;
		//printf("c=%d j=%d\n", c, j);
		dmap[c][j] = i;
	}
	return dmap;
}
int64_t str_inv(std::string s, std::string t)
{
	std::vector<int> inds(10, 0);
	//for(int i = 0; i < 10; i++)
	//	std::reverse(dmap[i].begin(), dmap[i].end());
	int n = s.size();
	std::vector<int> perm(n);
	for(int i = 0; i < n; i++)
	{
		char c = s[i]-'0';
		int j = Dmap[c][inds[c]++];
		//int j = dmap[c].back();
		//dmap[c].pop_back();
		perm[i] = j;
	}
	return inversions(perm);
}
int main()
{
	std::string A; std::cin >> A;
	std::string R = A;
	std::sort(R.rbegin(), R.rend());
	printf("%s\n", R.data());
}
