#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
int64_t inversions(std::vector<int> ar) // permutation
{
	//for(int x :  ar) printf("%d ", x); printf("\n");
	// count greater elements on prefix
	int n = ar.size();
	std::vector<int> ctrs(n);
	int64_t ans = 0;
	for(int i = 0; i < n; i++)
	{
		int e = ar[i];
		//for(int x : ctrs) printf("%d ", x); printf("\n");
		for(int j = e; j < n; j++) ans += ctrs[j];
		ctrs[e]++;
	}
	//printf("%lld\n", ans);
	return ans;
}
int64_t str_inv(std::string s, std::string t)
{
	std::vector<std::vector<int>> dmap(10);
	for(int i = 0; i < t.size(); i++)
		dmap[t[i]-'0'].push_back(i);
	for(int i = 0; i < 10; i++)
		std::reverse(dmap[i].begin(), dmap[i].end());
	int n = s.size();
	std::vector<int> perm(n);
	for(int i = 0; i < n; i++)
	{
		char c = s[i]-'0';
		int j = dmap[c].back();
		dmap[c].pop_back();
		perm[i] = j;
	}
	return inversions(perm);
}
int main()
{
	// maximize b[0], then maximize b[1], ...
	std::string A; std::cin >> A;
	int64_t y; scanf("%lld", &y);
	// all digits that cost >=n*y must be maximized greedily
	// assume all digits but the last 18 are maximized
	//std::vector<int> ctrs(10);
	//for(char c : A) ctrs[c-'0']++;
	//std::string B = A;
	//std::sort(B.rbegin(), B.rend());
	//std::string pref = B.substr(0, B.size()<=18 ? 0 : int(B.size())-18);
	//printf("pref=%s\n", pref.data());
	//std::string suf = B.substr(pref.size());
	//printf("suf=%s\n", suf.data());
	std::string A0 = A;
	std::sort(A.begin(), A.end());
	std::string best = "";
	int64_t bestval = -1;
	do
	{
		int64_t cost = str_inv(A0, A);
		int64_t res = std::stoll(A) - cost * y;
		if(res > bestval || (res == bestval && A > best))
		{
			bestval = res;
			best = A;
		}
		//printf("%lld %s: %lld\n", res, A.data(), cost);
	} while(std::next_permutation(A.begin(), A.end()));
	printf("%s\n", best.data());
}
