// ConsoleApplication1.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <unordered_map>
#include <algorithm>
#include <queue>

#define int long long
using namespace std;

using vi = vector<int>;
using vvi = vector<vector<int>>;
using pi = pair<int, int>;
using vb = vector<bool>;

#define mp make_pair
#define rep(n) for (int i = 0; i < n; i++)
#define all(x) x.begin(), x.end()

const int INF = 1e18 + 2;

struct robot {
	int l, r, c, t, i;

	robot() : l(0), r(0), c(0), t(0), i(0) {}
	robot(int L, int R, int C, int T, int I) : l(L), r(R), c(C), t(T), i(I) {}

	inline bool operator<(const robot& rob) {
		return make_tuple(l, r, c, t, i) < make_tuple(rob.l, rob.r, rob.c, rob.t, rob.i);
	}
};

bool comp(const robot& r1, const robot& r2) {
	return make_tuple(r1.r, r1.l, r1.c, r1.t, r1.i) < make_tuple(r2.r, r2.l, r2.c, r2.t, r2.i);
}

void solve() {
	int n, m; cin >> n >> m;
	vector<robot> robots(m);
	vi a(n);
	rep(n) cin >> a[i];
	rep(m) {
		cin >> robots[i].l >> robots[i].r >> robots[i].c >> robots[i].t;
		robots[i].i = i;
		robots[i].l--;
		robots[i].r--;
	}
	for (int k = 0; k < n; k++) {
		vi aa = a;
		vector<robot> cur_robots = robots;
		rep(m) {
			if (cur_robots[i].t == 1) {
				cur_robots[i].l = min(cur_robots[i].l, k);
				cur_robots[i].r = max(cur_robots[i].r, k);
			}
		}
		int res = 0;
		rep(n) {
			vector<robot> hui;
			for (int j = 0; j < m; j++) {
				if (i <= cur_robots[j].r && i >= cur_robots[j].l)
					hui.push_back(cur_robots[j]);
			}
			sort(all(hui), comp);
			for (auto& rob : hui) {
				int put = min(rob.c, aa[i]);
				aa[i] -= put;
				rob.c -= put;
				res += put;
				cur_robots[rob.i].c -= put;
			}
		}
		cout << res << " ";
	}
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int t; cin >> t;
	while (t--) solve();
}

//078856
//169420