// KiruxaLight
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>

#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

struct segment_tree {
	vector <int> t;
	int n;

	segment_tree() = default;

	segment_tree(int _n) {
		n = _n;
		t.resize(4 * n);
	}

	void build(vector <int>& a, int tl, int tr, int v = 1) {
		if (tl == tr) {
			t[v] = a[tl];
			return;
		}
		int mid = tl + tr >> 1;
		build(a, tl, mid, v * 2);
		build(a, mid + 1, tr, v * 2 + 1);
	}
};

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int t;
	cin >> t;
	while (t--) {
		int n, m;
		cin >> n >> m;
		vector <int> a(n);
		for (int i = 0; i < n; ++i) {
			cin >> a[i];
		}
		vector <tuple <int, int, int, int>> p(m);
		for (int i = 0; i < m; ++i) {
			int l, r, c, t;
			cin >> l >> r >> c >> t;
			--l, --r;
			p[i] = make_tuple(l, r, c, t);
		}
		for (int x = 0; x < n; ++x) {
			vector <tuple <int, int, int, int>> p1 = p;
			for (int i = 0; i < m; ++i) {
				if (get<3>(p1[i]) == 1) {
					int& l = get<0>(p1[i]);
					int& r = get<1>(p1[i]);
					l = min(l, x);
					r = max(r, x);
				}
			}
			sort(all(p1), [&](const tuple <int, int, int, int>& one, const tuple <int, int, int, int>& two) {
				return get<1>(one) < get<1>(two);
				});
			vector <int> b = a;
			int ans = 0;
			set <int> pos;
			for (int i = 0; i < n; ++i) {
				if (a[i] != 0) {
					pos.emplace(i);
				}
			}
			for (int i = 0; i < m; ++i) {
				int& c = get<2>(p1[i]);
				int l = get<0>(p1[i]);
				int r = get<1>(p1[i]);
				while (true) {
					if (c == 0) {
						break;
					}
					auto it = pos.lower_bound(l);
					if (it == pos.end()) {
						break;
					}
					int who = *it;
					if (who > r) {
						break;
					}
					int add = min(b[who], c);
					b[who] -= add;
					c -= add;
					ans += add;
					if (b[who] == 0) {
						pos.erase(it);
					}
				}
			}
			cout << ans << " ";
		}
		cout << "\n";
	}
}