#include <bits/stdc++.h>

#define ssize(a) (int)(a).size()
#define all(a) (a).begin(), (a).end()

using namespace std;

using ll = long long;

vector<vector<ll>> tree;
vector<vector<ll>> tree_sum;
int tsz;

void build(vector<ll>& a) {
    tsz = ssize(a);
    tree.resize(2 * tsz);
    tree_sum.resize(2 * tsz);
    for (int i = 0; i < tsz; ++i) {
        tree[i + tsz] = {a[i]};
        tree_sum[i + tsz] = {a[i], 0};
    }
    for (int i = tsz - 1; i > 0; --i) {
        tree[i].resize(ssize(tree[2 * i]) + ssize(tree[2 * i + 1]));
        merge(all(tree[2 * i]), all(tree[2 * i + 1]), tree[i].begin());
        tree_sum[i].resize(ssize(tree[i]) + 1);
        for (int j = ssize(tree[i]) - 1; j >= 0; --j) {
            tree_sum[i][j] = tree_sum[i][j + 1] + tree[i][j];
        }
    }
}

pair<int, ll> get(int l, int r, ll k) {
    int cnt = 0;
    ll sum = 0;

    l += tsz;
    r += tsz;

    while (l < r) {
        if (l & 1) {
            int pos = upper_bound(all(tree[l]), k) - tree[l].begin();
            cnt += ssize(tree[l]) - pos;
            sum += tree_sum[l][pos];
            ++l;
        }
        if (r & 1) {
            --r;
            int pos = upper_bound(all(tree[r]), k) - tree[r].begin();
            cnt += ssize(tree[r]) - pos;
            sum += tree_sum[r][pos];
        }
        l >>= 1;
        r >>= 1;
    }

    return {cnt, sum};
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, q;
    cin >> n >> q;
    vector<ll> c(n);
    for (int i = 0; i < n; ++i) {
        cin >> c[i];
    }

    vector<ll> a = c;
    sort(a.rbegin(), a.rend());
    vector<ll> d(n);
    for (int i = 1; i < n; ++i) {
        d[i] = a[i - 1] - a[i];
    }

    build(d);

    vector<pair<ll, int>> sorted_d(n - 1);
    for (int i = 1; i < n; ++i) {
        sorted_d[i - 1] = {d[i], i};
    }

    sort(all(sorted_d));

    vector<ll> d_sum(n);
    vector<ll> inds_sum(n);
    vector<ll> prod_sum(n);
    for (int i = n - 2; i >= 0; --i) {
        d_sum[i] = d_sum[i + 1] + sorted_d[i].first;
        inds_sum[i] = inds_sum[i + 1] + sorted_d[i].second;
        prod_sum[i] = prod_sum[i + 1] + sorted_d[i].first * sorted_d[i].second;
    }

    ll init_sum = accumulate(all(c), 0LL);

    for (int w = 0; w < q; ++w) {
        int t;
        ll k;
        cin >> t >> k;
        if (t == 1) {
            int cnt = 1 + (sorted_d.end() - lower_bound(all(sorted_d), pair(k + 1, 0)));
            cout << cnt << "\n";
        } else if (t == 2) {
            ll cur_sum = a[0];
            int pos = lower_bound(all(sorted_d), pair(k + 1, 0)) - sorted_d.begin();
            cur_sum -= d_sum[pos] - k * (n - 1 - pos);
            cur_sum *= n;
            cur_sum += prod_sum[pos] - k * inds_sum[pos];
            cout << cur_sum - init_sum << "\n";
        } else {
            int i;
            cin >> i;
            --i;

            int lo = -1;
            int hi = n;
            while (hi - lo > 1) {
                int m = (lo + hi) / 2;
                if (a[m] > c[i]) {
                    lo = m;
                } else {
                    hi = m;
                }
            }

            ll val = a[0];
            auto [cnt, sum] = get(0, hi + 1, k);
            val -= sum - k * cnt;
            cout << val << "\n";

//            for (int j = 0; j < n; ++j) {
//                if (a[j] == c[i]) {
//                    cout << val << "\n";
//                    break;
//                }
//                if (d[j + 1] - k > 0) {
//                    val -= d[j + 1] - k;
//                }
//            }
        }
    }



    return 0;
}
