#include <bits/stdc++.h>

#define ssize(a) (int)(a).size()
#define all(a) (a).begin(), (a).end()

using namespace std;

using ll = long long;

const int inf = 2e9;

void solve() {
    int n, m;
    cin >> n >> m;

    vector<vector<int>> g(n + 1);
    vector<vector<char>> matr(n + 1, vector<char>(n + 1, false));
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
        matr[v][u] = matr[u][v] = true;
    }
    vector<vector<int>> dist(n + 1, vector<int>(n + 1, inf));
    dist[1][0] = 0;
    deque<pair<int, int>> q;
    q.emplace_back(1, 0);
    while (!q.empty()) {
        auto [v, u] = q.front();
        q.pop_front();
        if (u == 0) {
            for (int t : g[v]) {
                if (dist[v][u] + 1 < dist[v][t]) {
                    dist[v][t] = dist[v][u] + 1;
                    q.emplace_back(v, t);
                }
            }
        } else {
            for (int t : g[v]) {
                if (t == u) {
                    continue;
                }
                if (dist[v][u] < dist[t][u]) {
                    dist[t][u] = dist[v][u];
                    q.emplace_front(t, u);
                }
            }
            if (matr[v][u]) {
                if (dist[v][u] + 1 < dist[v][0]) {
                    dist[v][0] = dist[v][u] + 1;
                    q.emplace_back(v, 0);
                }
            }
        }
    }

    for (int v = 2; v <= n; ++v) {
        if (dist[v][0] == inf) {
            cout << "-1 ";
        } else {
            cout << dist[v][0] << " ";
        }
    }
    cout << "\n";
}


int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        solve();
    }



    return 0;
}
