#ifdef LOCAL
#include "stdc++.h"
#else
#include <bits/stdc++.h>
#endif

using namespace std;

vector<int> graph[500020];
int tin[500020], fin[500020], parent[500020];
int curTime = 0;
bool visited[500020];

void dfs(int v, int p = -1) {
    visited[v] = true;
    parent[v] = p;
    tin[v] = fin[v] = curTime++;
    for (int u : graph[v]) {
        if (!visited[u]) {
            dfs(u, v);
            fin[v] = min(fin[v], fin[u]);
        } else {
            fin[v] = min(fin[v], tin[u]);
        }
    }
}

bool adj[5020][5020];


int main() {
#ifndef LOCAL
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif

    int tt;
    cin >> tt;
    while (tt--) {
        int n, m;
        cin >> n >> m;

        for (int i = 0; i < n; i++) {
            graph[i].clear();
            visited[i] = false;
        }
        curTime = 0;
        for (int i = 0; i < m; i++) {
            int u, v;
            cin >> u >> v;
            u--, v--;
            graph[u].push_back(v);
            graph[v].push_back(u);
        }
        dfs(0);

        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                adj[i][j] = false;
            }
        }
        for (int i = 0; i < n; i++) {
            for (int v : graph[i]) {
                for (int u : graph[i]) {
                    if (v != u) {
                        if (fin[u] < tin[i] && fin[v] < tin[i]) {
                            adj[v][u] = adj[u][v] = true;
                        }
                    }
                }
            }
        }

        vector<int> dist(n, -1);
        queue<int> q;
        q.push(0);
        dist[0] = 0;
        while (!q.empty()) {
            int v = q.front();
            q.pop();
            for (int u = 0; u < n; u++) {
                if (adj[v][u] && dist[u] == -1) {
                    q.push(u);
                    dist[u] = dist[v] + 2;
                }
            }
        }
        for (int i = 1; i < n; i++) {
            cout << dist[i] << ' ';
        }
        cout << '\n';
    }
}
