#include <bits/stdc++.h>

using namespace std;

const int MAXN = 5e3 + 10;
const int INF = 1e9 + 10;

int color[MAXN][MAXN];
set<int> colors[MAXN][MAXN];
int used[MAXN];
int dist[MAXN];
vector<int> graph[MAXN];

mt19937 gn(2007200769);

void dfs(int vertex, int i, int c) {
    used[vertex] = 1;
    color[i][vertex] = c;
    for (auto elem : graph[vertex]) {
        if (!used[elem]) {
            dfs(elem, i, c);
        }
    }
}

signed solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int b, e;
        cin >> b >> e;
        b--;e--;
        graph[b].push_back(e);
        graph[e].push_back(b);
    }
    for (int i = 0; i < n; ++i) {
        shuffle(graph[i].begin(), graph[i].end(), gn);
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            used[j] = 0;
        }
        used[i] = 1;
        int c = 1;
        for (int j = 0; j < n; ++j) {
            if (!used[j]) {
                dfs(j, i, c++);
            }
        }
        for (auto elem : graph[i]) {
            colors[i][color[i][elem]].insert(elem);
        }
    }
    fill(dist, dist + n, INF);
    queue<int> q;
    dist[0] = 0;
    q.push(0);
    while (!q.empty()) {
        int now = q.front();
        q.pop();
        for (auto elem : graph[now]) {
            for (auto elem2 : colors[elem][color[elem][now]]) {
                // cerr << color[elem][now] << ' ' <<< color[elem][elem2];
                if (dist[elem2] > dist[now] + 2) {
                    dist[elem2] = dist[now] + 2;
                    q.push(elem2);
                }
            }
        }
    }
    for (int i = 1; i < n; ++i) {
        if (dist[i] >= INF) {
            cout << -1 << ' ';
        } else {
            cout << dist[i] << ' ';
        }
    }cout << '\n';
    for (int i = 0; i < n; ++i) {
        graph[i].clear();
    }
    return 0;
}

signed main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}