#include <iostream>
#include <vector>
#include <set>

using namespace std;

// #define int long long
constexpr int inf = 1e9 + 7;
using ll = long long;


void Solve(istream &in, ostream &out) {
    size_t K = 19;

    string s;
    in >> s;
    vector<int> numbers;
    for (char ch : s) {
        numbers.push_back(ch - '0');
    }
    ll y;
    in >> y;
    set<pair<int, int>> order;
    for (int i = 0; i < numbers.size(); ++i) {
        order.emplace(numbers[i], -i);
    }
    vector<int> result;
    vector<bool> used(numbers.size(), false);
    while (order.size() > K) {
        result.push_back(order.rbegin()->first);
        used[-order.rbegin()->second] = true;
        order.erase(--order.end());
    }
    vector<int> remains;
    for (int i = 0; i < numbers.size(); ++i) {
        if (!used[i]) {
            remains.push_back(numbers[i]);
        }
    }
    K = min(K, remains.size());
    vector<ll> pw(19); pw[0] = 1;
    for (int i = 1; i < pw.size(); ++i) {
        pw[i] = pw[i - 1] * 10;
    }

    vector<ll> dp(1 << K, 0);
    vector<ll> P(1 << K, -1);
    for (int mask = 1; mask < (1 << K); ++mask) {
        int cnt = 0;
        for (int i = 0; i < K; ++i) {
            if (!((mask >> i) & 1)) {
                continue;
            }
            ll new_val = numbers[i] * pw[__builtin_popcount(mask) - 1] - cnt * y + dp[mask ^ (1 << i)];
//            cerr << mask << ' ' << new_val << '\n';
            if (P[mask] == -1 || (new_val > dp[mask] || (new_val == dp[mask] && numbers[i] > numbers[P[mask]]))) {
                dp[mask] = new_val;
                P[mask] = i;
            }
            ++cnt;
        }
//        cerr << mask << ' ' << dp[mask] << '\n';
    }
    for (int mask = (1 << K) - 1; mask > 0; mask ^= 1 << P[mask]) {
        result.push_back(numbers[P[mask]]);
    }
    for (int digit : result) {
        out << digit;
    }
    out << '\n';
}


signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif
    Solve(cin, cout);
    return 0;
}
