#include <queue>
#include <sstream>
#include <functional>
#include <random>
#include <ctime>
#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;
mt19937 rnd(time(0) + 239);

 #define int long long
constexpr int inf = 1e9 + 7;
using ll = long long;


void Solve(istream &in, ostream &out) {
    int n, q;
    in >> n >> q;
    vector<ll> C(n);
    for (ll &c_i : C) {
        in >> c_i;
    }
    sort(C.begin(), C.end());
    vector<int> diff;
    for (int i = 1; i < n; ++i) {
        diff.push_back(C[i] - C[i - 1]);
    }
    sort(diff.begin(), diff.end());
    vector<pair<int, int>> Q;
    for (int i = 0; i < q; ++i) {
        ll t, k;
        in >> t >> k;
        Q.emplace_back(k, i);
    }
    sort(Q.begin(), Q.end());
    vector<int> result(q);
    int j = 0;
    for (auto [k, i] : Q) {
        while (j < diff.size() && diff[j] <= k) {
            ++j;
        }
        result[i] = n - j;
    }

    for (int res_i : result) {
        out << res_i << '\n';
    }
}


signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif
    Solve(cin, cout);
//    ostringstream test;
//    GenFull(test);
//    istringstream in(test.str());
//    ostringstream out;
//    Solve(in, cout);
    cerr << clock() * 1.0 / CLOCKS_PER_SEC << '\n';
    return 0;
}
