#include <cassert>
#include <queue>
#include <sstream>
#include <functional>
#include <random>
#include <ctime>
#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;
mt19937 rnd(time(0) + 239);

 #define int long long
constexpr int inf = 1e9 + 7;
using ll = long long;


struct Query {
    int t, k, i, res_i;
};

void Solve(istream &in, ostream &out) {
    int n, q;
    in >> n >> q;
    vector<ll> C(n);
    for (ll &c_i : C) {
        in >> c_i;
    }
    vector<Query> Q;
    sort(C.begin(), C.end());
    for (int i = 1; i < n; ++i) {
        Q.push_back({0, C[i] - C[i - 1], i - 1, -1});
    }
    for (int i = 0; i < q; ++i) {
        Query query;
        in >> query.t >> query.k;
        if (query.t == 3) {
            in >> query.i;
        }
        query.res_i = i;
        Q.push_back(query);
    }
    sort(Q.begin(), Q.end(), [](Query lhs, Query rhs) {
        return make_pair(lhs.k, lhs.t) < make_pair(rhs.k, rhs.t);
    });

    vector<int> result(q);
    int last = 0, dead = 0;
    int s_delta = 0, growth = (n - 1) * n / 2;
    for (auto [t, k, i, res_i] : Q) {
        int d_k = k - last;
        s_delta += growth * d_k;
        if (t == 0) {
            growth -= i + 1;
            ++dead;
        } else if (t == 1) {
            result[res_i] = n - dead;
        } else if (t == 2) {
            result[res_i] = s_delta;
        } else {
            exit(1);
        }
        last += d_k;
    }

    for (int res_i : result) {
        out << res_i << '\n';
    }
}


signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif
    Solve(cin, cout);
//    ostringstream test;
//    GenFull(test);
//    istringstream in(test.str());
//    ostringstream out;
//    Solve(in, cout);
    cerr << clock() * 1.0 / CLOCKS_PER_SEC << '\n';
    return 0;
}
