/*
 * Join us on Telegram:
 * - My blog on competitive programming & software development: @ivanqs_blog
 * - A competitive programming community: @dshindov_chat
 * - Other blogs at @pr_channels_list
 */

#include <bits/stdc++.h>

using namespace std;

#define int long long

vector<vector<pair<int, int>>> adj;
vector<pair<int, int>> edges;
vector<int> tin, fup;
vector<int> used;
int cur_time;
vector<vector<int>> order_by_adj;
int n, m;
vector<vector<pair<int, bool>>> aux_adj;

void pp(int u) {
	if(u < n) {
		cerr << "[" << u + 1 << "]";
	} else {
		auto [u1, v1] = edges[u - n];
		cerr << u1 + 1 << "=>[" << v1 + 1 << "]";
	}
};

void add_group(const vector<int>& group, char c) {
	for(int i = 1; i < group.size(); i++) {
		aux_adj[n + group[i]].emplace_back(n + group[0], false);
		aux_adj[n + group[0]].emplace_back(n + group[i], false);
	}
	// for(int e: group) {
	// 	pp(e + n);
	// 	cerr << " ";
	// }
	// cerr << c << endl;
}

void dfs_cutpoints(int u, int p, int e_in) {
	tin[u] = fup[u] = cur_time++;
	used[u] = 1;
	int n_children = 0;
	bool is_cutpoint = false;
	vector<int> connected_group{e_in};
	vector<vector<int>> disconnected_groups;
	for(auto [v, e]: adj[u]) {
		order_by_adj[v].push_back(e);
		if(v == p) {
			continue;
		}
		if(used[v] == 1) {
			connected_group.push_back(e ^ 1);
			fup[u] = min(fup[u], tin[v]);
		} else if(used[v] == 0) {
			n_children++;
			int pos = order_by_adj[u].size();
			dfs_cutpoints(v, u, e);
			if(p != -1) {
				if(fup[v] >= tin[u]) {
					is_cutpoint = true;
					disconnected_groups.emplace_back(order_by_adj[u].begin() + pos, order_by_adj[u].end());
				} else {
					connected_group.insert(connected_group.end(), order_by_adj[u].begin() + pos, order_by_adj[u].end());
				}
			} else {
				disconnected_groups.emplace_back(order_by_adj[u].begin() + pos, order_by_adj[u].end());
			}
			fup[u] = min(fup[u], fup[v]);
		}
	}
	used[u] = 2;
	// cerr << u + 1 << ": " << fup[u] << " " << tin[u] << endl;
	for(auto& group: disconnected_groups) {
		add_group(group, 'd');
	}
	if(p != -1) {
		add_group(connected_group, 'c');
		if(is_cutpoint) {
			// cerr << u + 1 << " is cutpoint" << endl;
		}
	} else {
		if(n_children > 1) {
			// cerr << u + 1 << " is cutpoint" << endl;
		}
	}
}

void solve() {
	cin >> n >> m;

	adj.clear();
	adj.resize(n);
	edges.clear();
	for(int i = 0; i < m; i++) {
		int u, v;
		cin >> u >> v;
		u--; v--;
		adj[u].emplace_back(v, i * 2);
		adj[v].emplace_back(u, i * 2 + 1);
		edges.emplace_back(u, v);
		edges.emplace_back(v, u);
	}

	int aux_n = n + 2 * m;
	aux_adj.clear();
	aux_adj.resize(aux_n);

	tin.resize(n);
	fup.resize(n);
	used.clear();
	used.resize(n);
	order_by_adj.clear();
	order_by_adj.resize(n);
	dfs_cutpoints(0, -1, -1);

	for(int u = 0; u < n; u++) {
		// Can put down to a neighbour
		for(auto [v, e]: adj[u]) {
			aux_adj[u].emplace_back(n + e, true);
		}
	}

	for(int e = 0; e < edges.size(); e++) {
		auto [u, v] = edges[e];

		// Can take
		aux_adj[n + e].emplace_back(u, true);

		// // Can move to a neighbour of v
		// for(auto [u1, e1]: adj[v]) {
		// 	aux_adj[n + e].emplace_back(n + (e1 ^ 1), false);
		// }
	}

	for(int u = 0; u < aux_n; u++) {
		for(auto [v, c]: aux_adj[u]) {
			// pp(u);
			// cerr << " -> ";
			// pp(v);
			// cerr << " " << c << endl;
		}
	}

	vector<int> dist(aux_n, -1);
	dist[0] = 0;
	deque<int> q;
	q.push_back(0);

	while(!q.empty()) {
		int aux_u = q.front();
		q.pop_front();
		for(auto [aux_v, cost]: aux_adj[aux_u]) {
			if(dist[aux_v] == -1) {
				dist[aux_v] = dist[aux_u] + cost;
				if(cost) {
					q.push_back(aux_v);
				} else {
					q.push_front(aux_v);
				}
			}
		}
	}

	for(int u = 1; u < n; u++) {
		cout << dist[u] << " ";
	}
	cout << "\n";
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t;
	cin >> t;

	while(t --> 0) {
		solve();
	}

	return 0;
}
