#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

#define len(a) int((a).size())
#define all(a) begin(a), end(a)

template<typename Fun>
struct y_combinator {
    const Fun fun;

    y_combinator(const Fun&& fun) : fun(forward<const Fun>(fun)) {}

    template<typename... Args>
    decltype(auto) operator()(Args&&... args) const {
        return fun(ref(*this), forward<Args>(args)...);
    }
};

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> g(n);
    for (int i = 0; i < m; i++) {
        int v, u;
        cin >> v >> u;
        v--, u--;
        g[v].push_back(u);
        g[u].push_back(v);
    }

    struct DSU {
        vector<int> par;

        DSU(int n = 0) : par(n) {
            iota(all(par), 0);
        }

        int root(int v) {
            return par[v] == v ? v : par[v] = root(par[v]);
        }

        void unite(int v, int u) {
            v = root(v);
            u = root(u);
            par[u] = v;
        }
    };
    vector<DSU> dsu(n, DSU(n));
    for (int c = 0; c < n; c++) {
        for (int v = 0; v < n; v++) {
            if (v == c) continue;
            for (auto u : g[v]) {
                if (u == c) continue;
                dsu[c].unite(v, u);
            }
        }
    }

    const int INF = 1e9;
    vector<vector<int>> new_g(n);
    for (int v = 0; v < n; v++) {
        for (auto u1 : g[v]) for (auto u2 : g[v]) {
            if (u1 == u2) continue;
            if (dsu[v].root(u1) == dsu[v].root(u2)) {
                new_g[u1].push_back(u2);
                new_g[u2].push_back(u1);
            }
        }
    }

    queue<int> que;
    que.push(0);
    vector<int> dist(n, INF);
    dist[0] = 0;

    while (!que.empty()) {
        int v = que.front();
        que.pop();
        for (auto u : new_g[v]) {
            if (dist[u] > dist[v] + 1) {
                dist[u] = dist[v] + 1;
                que.push(u);
            }
        }
    }

    for (int i = 1; i < n; i++) {
        if (dist[i] == INF) dist[i] = -1;
        else dist[i] *= 2;
        cout << dist[i] << " \n"[i == n - 1];
    }
}

int main() {
    ios::sync_with_stdio(false), cin.tie(nullptr);

    int tests;
    cin >> tests;
    while (tests--) solve();
}
