#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

#define len(a) int((a).size())
#define all(a) begin(a), end(a)

template<typename Fun>
struct y_combinator {
    const Fun fun;

    y_combinator(const Fun&& fun) : fun(forward<const Fun>(fun)) {}

    template<typename... Args>
    decltype(auto) operator()(Args&&... args) const {
        return fun(ref(*this), forward<Args>(args)...);
    }
};

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    for (auto &x : a) cin >> x;
    vector<int> l(m), r(m), c(m), t(m);
    for (int i = 0; i < m; i++) {
        cin >> l[i] >> r[i] >> c[i] >> t[i];
        l[i]--, r[i]--;
    }

    for (int x = 0; x < n; x++) {
        vector<vector<pair<int, int>>> events(n + 1);
        auto cur_c = c;
        for (int i = 0; i < m; i++) {
            int curl = l[i], curr = r[i];
            if (t[i] == 1) {
                curl = min(curl, x);
                curr = max(curr, x);
            }
            events[curl].push_back({curr, i});
        }

        ll ans = 0;
        set<pair<int, int>> st;
        for (int i = 0; i < n; i++) {
            for (auto &[where, pos] : events[i]) {
                st.insert({where, pos});
            }

            int left = a[i];
            while (!st.empty() && left > 0) {
                auto [a, b] = *st.begin();
                st.erase(st.begin());
                if (a < i || cur_c[b] == 0) continue;
                int take = min(left, cur_c[b]);
                left -= take;
                cur_c[b] -= take;
                st.emplace(a, b);
            }
            ans += a[i] - left;
        }
        cout << ans << " \n"[x == n - 1];
    }
}

int main() {
    ios::sync_with_stdio(false), cin.tie(nullptr);

    int tests;
    cin >> tests;
    while (tests--) solve();
}
