#pragma GCC optimize("O3,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,sse4,abm,mmx,popcnt,avx,avx2,fma,avx512f")
#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cstring>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <deque>
#include <cmath>
#include <bitset>

//#define int long long
#define endl '\n'
#define double long double
#define sqrt sqrtl

using namespace std;

void operator delete(void* ptr) {}

typedef long long ll;
typedef double ld;

const int inf = 1e9 + 7;
const ll inf2 = 1e18 + 9;
const int MAXN = 1000 + 8;
const int MAXN2 = 1e6 + 8;
const ll mod = 1e9 + 7;

vector<int> G[MAXN2];
int dist[MAXN2];
int par[MAXN][MAXN]; // first - u, second - v_comp;

int get_par(int v, int u) {
	if (par[u][v] == v)
		return v;
	else
		return par[u][v] = get_par(par[u][v], u);
}

void connect(int a, int b, int u) {
	int pa = get_par(a, u), pb = get_par(b, u);
	if (pa == pb) {
		return;
	}
	par[u][pa] = pb;
}

queue<int> q;

void bfs(int n) {
	int s = get_par(0, 0) * n;
	dist[s] = 0;
	q.push(s);
	while (q.size()) {
		int v = q.front();
		q.pop();
		for (int u : G[v]) {
			if (dist[u] >= inf) {
				dist[u] = dist[v] + 1;
				q.push(u);
			}
		}
	}
}



signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	int t;
	cin >> t;
	while (t--) {
		int n, m;
		cin >> n >> m;
		while (q.size())
			q.pop();
		for (int i = 0; i < n; i++) {
			int d1 = i * n;
			for (int j = 0; j < n; j++) {
				par[j][i] = i;
				G[d1 + j].clear();
				dist[d1 + j] = inf;
			}
		}
		vector<pair<int, int>> edges;
		for (int i = 0; i < m; i++) {
			int a, b;
			cin >> a >> b;
			--a, --b;
			edges.emplace_back(a, b);
		}
		for (int u = 0; u < n; u++) {
			for (const auto& el : edges) {
				if (el.first != u && el.second != u)
					connect(el.first, el.second, u);
			}
		}
		for (const auto& el : edges) {
			int a = el.first, b = el.second;
			int aa = get_par(a, a) * n + a;
			int ab = get_par(a, b) * n + b;
			int ba = get_par(b, a) * n + a;
			int bb = get_par(b, b) * n + b;
			G[aa].emplace_back(ab);
			G[aa].emplace_back(ba);
			G[ba].emplace_back(aa);
			G[ab].emplace_back(aa);

			G[bb].emplace_back(ab);
			G[bb].emplace_back(ba);
			G[ba].emplace_back(bb);
			G[ab].emplace_back(bb);
		}
		bfs(n);
		for (int i = 1; i < n; i++) {
			int v = get_par(i, i);
			if (dist[v] >= inf) {
				cout << -1 << ' ';
			}
			else {
				cout << dist[v] << ' ';
			}
		}
		cout << endl;
	}
}