#define _CRT_SECURE_NO_WARNINGS

#pragma GCC optimize("avx512")

#include <iostream>
#include <fstream>
#include <iomanip>
#include <numeric>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <assert.h>
#include <random>
#include <bitset>
#include <tuple>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

#define all(v) v.begin(), v.end()
#define mp make_pair
#define endl '\n'
#define pb push_back

const int N = 5005;

vector<int> e1[N];
vector<int> e[N];

int d[N];
int pd[N];

int col[N][N];

int C;

int B;

void dfs(int i)
{
	col[B][i] = C;
	for (int j : e1[i])
	{
		if (j != B && col[B][j] == 0)
		{
			dfs(j);
		}
	}
}

signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int t;
	cin >> t;
	while (t--)
	{
		int n, m;
		cin >> n >> m;
		for (int i = 0; i <= n; i++)
		{
			for (int j = 0; j <= n; j++)
			{
				col[i][j] = 0;
			}
		}
		for (int i = 0; i < n; i++)
		{
			e1[i].clear();
			e[i].clear();
		}
		for (int i = 0; i < m; i++)
		{
			int a, b;
			cin >> a >> b;
			a--;
			b--;
			e1[a].push_back(b);
			e1[b].push_back(a);
		}
		for (int i = 0; i < n; i++)
		{
			B = i;
			C = 1;
			for (int j = 0; j < n; j++)
			{
				if (j != B && col[B][j] == 0)
				{
					dfs(j);
					C++;
				}
			}
		}
		for (int i = 0; i < n; i++)
		{
			for (int j : e1[i])
			{
				for (int u : e1[j])
				{
					if (i != u && col[j][i] == col[j][u])
					{
						e[i].push_back(u);
					}
				}
			}
		}
		fill(d, d + n, -1);
		fill(pd, pd + n, n + 2);
		pd[0] = 0;
		while (true)
		{
			pii now = mp(n + 2, -1);
			for (int i = 0; i < n; i++)
			{
				if (d[i] == -1 && pd[i] != -1)
				{
					now = min(now, mp(pd[i], i));
				}
			}
			if (now.second == -1)
			{
				break;
			}
			auto [dis, i] = now;
			d[i] = dis;
			for (int j : e[i])
			{
				if (d[j] == -1)
				{
					pd[j] = min(pd[j], dis + 1);
				}
			}
		}
		for (int i = 1; i < n; i++)
		{
			if (d[i] == -1)
			{
				cout << "-1 ";
				continue;
			}
			cout << d[i] * 2 << " ";
		}
		cout << endl;
	}
}