#include <bits/stdc++.h>
using namespace std;

const int MAXN = 5e5 + 100, INF = 2e9;
vector<array<int, 2>> g[MAXN];
vector<array<int, 2>> res[MAXN * 3];
int ans[MAXN * 3];

void bfs(int v, int n) {
    deque<int> q;
    q.push_back(v);
    fill(ans, ans + n, INF);
    ans[v] = 0;
    while (!q.empty()) {
        int v = q.front();
        q.pop_front();
        for (auto e : res[v]) {
            int u = e[0], w = e[1];
            if (ans[u] > ans[v] + w) {
                ans[u] = ans[v] + w;
                if (w == 0) {
                    q.push_front(u);
                } else {
                    q.push_back(u);
                }
            }
        }
    }
}

int up[MAXN], d[MAXN], used[MAXN], tin[MAXN], par[MAXN];
vector<int> euler;

void dfs(int v, int p = -1) {
    par[v] = p;
    tin[v] = euler.size();
    euler.push_back(v);
    up[v] = d[v];
    used[v] = true;
    for (auto e : g[v]) {
        int u = e[0];
        if (!used[u]) {
            d[u] = d[v] + 1;
            dfs(u, v);
            up[v] = min(up[v], up[u]);
        } else {
            up[v] = min(up[v], d[u]);
        }
    }
}

bool cmp(array<int, 2> a, array<int, 2> b) {
    return tin[a[0]] < tin[b[0]];
}

int main() {
    int tst;
    cin >> tst;
    while (tst--) {
        int n, m;
        cin >> n >> m;
        for (int i = 0; i < n; ++i) {
            g[i].clear();
        }
        for (int i = 0; i < 2 * m + n; ++i) {
            res[i].clear();
        }
        euler.clear();
        for (int i = 0; i < m; ++i) {
            int u, v;
            cin >> u >> v;
            u--; v--;
            g[u].push_back({v, 2 * i});
            res[2 * m + u].push_back({2 * i, 1});
            res[2 * i].push_back({2 * m + u, 1});
            g[v].push_back({u, 2 * i + 1});
            res[2 * m + v].push_back({2 * i + 1, 1});
            res[2 * i + 1].push_back({2 * m + v, 1});
        }
        fill(used, used + n, 0);
        dfs(0);
        for (int v = 0; v < n; ++v) {
            vector<vector<int>> arr(1);
            sort(g[v].begin(), g[v].end(), cmp);
            int ind = 0;
            for (auto elem : g[v]) {
                int u = elem[0];
                if (d[u] < d[v]) {
                    arr[0].push_back(elem[1]);
                    continue;
                }
                if (par[u] == v) {
                    if (up[u] < d[v]) {
                        ind = 0;
                    } else {
                        ind = arr.size();
                        arr.push_back(vector<int>(0));
                    }
                }
                arr[ind].push_back(elem[1]);
            }
            for (auto elem : arr) {
                for (int i = 0; i < (int)elem.size(); ++i) {
                    int j = (i + 1) % elem.size();
                    res[elem[i] ^ 1].push_back({elem[j] ^ 1, 0});
                }
            }
        }
        bfs(2 * m, 2 * m + n);
        for (int i = 2 * m + 1; i < 2 * m + n; ++i) {
            if (ans[i] == INF) ans[i] = -1;
            cout << ans[i] << " ";
        }
        cout << endl;
    }
    return 0;
}
