#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
#include <queue>
#include <bitset>

using namespace std;

#define fastInp cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
typedef long long ll;
typedef long double ld;

#define int ll

const ll SZ = 5010, INF = 1e9 * 1e9 + 100, MX = 1'000'000'000'000 + 1000;
ll n, m;
vector<vector<ll>> gr;

ll dist[SZ], used[SZ];
bitset<SZ> adj[SZ];
ll col[SZ], cols[SZ];

void color(int v, int cl = -1) {
	if (cl != -1) col[v] = cl;
	used[v] = 1;

	ll cnt = 0;
	
	for (auto to : gr[v]) {
		if (!used[to]) {
			if (cl == -1) {
				color(to, cnt);
				cnt++;
			}
			else {
				color(to, cl);
			}
		}
	}
}

void sol() {
	ll n, m;
	cin >> n >> m;

	for (int i = 0; i < n; i++) adj[i] = 0;

	gr.clear();
	gr.resize(n);

	for (int i = 0; i < m; i++) {
		ll u, v;
		cin >> u >> v;
		u--; v--;
		gr[u].push_back(v);
		gr[v].push_back(u);
		
		adj[u][v] = 1;
		adj[v][u] = 1;
	}

	for (int i = 0; i < n; i++) {
		dist[i] = INF;
	}

	dist[0] = 0;
	queue<ll> q;
	q.push(0);

	while (!q.empty()) {
		ll v = q.front();
		q.pop();

		for (int i = 0; i < n; i++) used[i] = 0;
		for (int i = 0; i < n; i++) cols[i] = 0;
		color(v);
		for (int i = 0; i < n; i++) cols[col[i]]++;

		for (int i = 0; i < n; i++) {
			if ((adj[v] & adj[i]) != 0 && cols[col[i]] >= 2) {
				if (dist[i] > dist[v] + 1) {
					dist[i] = dist[v] + 1;
					q.push(i);
				}
			}
		}

		
	}

	for (int i = 1; i < n; i++) {
		if (dist[i] >= INF) {
			cout << "-1 ";
		}
		else {
			cout << dist[i] * 2 << " ";
		}
	}
}

signed main() {
	fastInp;

	ll t;
	cin >> t;

	while (t--) {
		sol();
	}

	return 0;
}

/*


1
12 15
1 2
1 12

2 3
4 1
2 4
4 3
5 3
5 1
5 6
3 7
7 8
4 9
9 10
10 11
11 9
*/