#include <iostream>
#include <vector>
#include <algorithm>
#define int long long

using namespace std;

vector<int> used;

vector<vector<int>> gen(int n) {
    vector<vector<int>> res;
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            used[i] = true;
            auto res1 = gen(n);
            used[i] = false;
            for (auto& el: res1) {
                el.push_back(i);
                res.push_back(el);
            }
        }
    }
    if (res.empty()) return {{}};
    return res;
}

string solve(const string& x, int y) {
    int n = (int)x.size();
    auto per = gen(n);
    string res = x;
    int best = stoll(x);
    for (auto p: per) {
        string s = x;
        for (int i = 0; i < n; i++) s[i] = x[p[i]];
        int profit = stoll(s);
        for (int i = 0; i < n; i++) {
            profit -= y * (p[i] - i);
            for (int j = i + 1; j < n; j++) if (p[j] < p[i]) p[j]++;
        }
        if (profit > best || (profit == best && s > res)) {
            res = s, best = profit;
        }
    }
    return res;
}

signed main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    string s;
    cin >> s;
    int y;
    cin >> y;
    if (s.size() <= 9) {
        used.resize(s.size());
        cout << solve(s, y) << endl;
    } else {
        vector<int> cnt[10];
        for (int i = 0; i < s.size(); i++) cnt[s[i] - '0'].push_back(i);
        string res;
        int cur_d = 9;
        while (s.size() - res.size() > 10) {
            if (!cnt[cur_d].empty()) {
                cnt[cur_d].pop_back();
                res.push_back(cur_d + '0');
            } else cur_d--;
        }
        vector<pair<int, char>> tmp;
        for (int d = 0; d <= 9; d++) {
            for (int el: cnt[d]) tmp.emplace_back(el, d + '0');
        }
        sort(tmp.begin(), tmp.end());
        string a;
        for (int i = 0; i < 10; i++) a.push_back(tmp[i].second);
        used.resize(10);
        cout << res << solve(a, y) << endl;
    }
}
