#include <iostream>
#include <cmath>

#include <algorithm>

#include <vector>
#include <string>
#include <map>
#include <queue>

using namespace std;

typedef long long ll;

const ll inf = 1e18;

ll to_ll(string s) {
	ll res = 0;
	for (auto c : s) {
		res *= 10;
		res += 0ll + c - '0';
	}
	return res;
}

int main() {
	string s; cin >> s;
	ll y; cin >> y;
	ll n = s.size();

	map<string, ll> dist;
	map<string, bool> used;
	queue<string> q;
	dist[s] = 0;
	used[s] = true;
	q.push(s);

	while (!q.empty()) {
		string v = q.front();
		q.pop();

		string to = v;
		for (ll i = 0; i < n - 1; i++) {
			swap(to[i], to[i + 1]);
			if (!used[to]) {
				dist[to] = dist[v] + 1;
				used[to] = true;
				q.push(to);
			}
			swap(to[i], to[i + 1]);
		}
	}

	string ans = s;
	ll sc = to_ll(s);
	for (auto c : dist) {
		ll cur_sc = to_ll(c.first) - y * c.second;
		if (cur_sc > sc) {
			sc = cur_sc;
			ans = c.first;
		}
		else if (cur_sc == sc && s > ans) {
			ans = s;
		}
	}

	cout << ans;

	return 0;
}