#include <iostream>
#include <cmath>

#include <algorithm>

#include <vector>
#include <string>
#include <map>
#include <queue>

using namespace std;

typedef long long ll;

const ll inf = 1e18;

ll to_ll(string s) {
	ll res = 0;
	for (auto c : s) {
		res *= 10;
		res += 0ll + c - '0';
	}
	return res;
}

bool comp(pair<char, int> a, pair<char, int> b) {
	if (a.first != b.first)
		return a.first > b.first;
	return a.second < b.second;
}

int main() {
	string a; cin >> a;
	vector<bool> used_a(a.size());
	vector<pair<char, int>> pos;
	for (int i = 0; i < a.size(); i++) {
		pos.push_back({ a[i], i });
	}
	sort(pos.begin(), pos.end(), comp);

	string add = "";
	for (int i = 0; i < (int)a.size() - 8; i++) {
		used_a[pos[i].second] = true;
		add += pos[i].first;
	}

	string s = "";
	for (int i = 0; i < a.size(); i++) {
		if (!used_a[i]) {
			s += a[i];
		}
	}

	ll y; cin >> y;
	ll n = s.size();
	
	map<string, ll> dist;
	map<string, bool> used;
	queue<string> q;
	dist[s] = 0;
	used[s] = true;
	q.push(s);
	
	while (!q.empty()) {
		string v = q.front();
		q.pop();
	
		string to = v;
		for (ll i = 0; i < n - 1; i++) {
			if (to[i] == to[i + 1])
				continue;

			swap(to[i], to[i + 1]);
			if (!used[to]) {
				dist[to] = dist[v] + 1;
				used[to] = true;
				q.push(to);
			}
			swap(to[i], to[i + 1]);
		}
	}
	
	string ans = s;
	ll sc = to_ll(s);
	for (auto c : dist) {
		ll cur_sc = to_ll(c.first) - y * c.second;
		if (cur_sc > sc) {
			sc = cur_sc;
			ans = c.first;
		}
		else if (cur_sc == sc && c.first > ans) {
			ans = c.first;
		}
	}
	
	cout << add << ans;

	return 0;
}