#include <iostream>
#include <cmath>

#include <algorithm>

#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>

#include <unordered_map>

using namespace std;

typedef long long ll;

const ll inf = 1e18;

int n, m;
int to_int(pair<int, int> a) {
	return a.first * n + a.second;
}

void solve() {
	cin >> n >> m;
	vector<vector<int>> g(n);
	for (int i = 0; i < m; i++) {
		int v, u; cin >> v >> u;
		v--; u--;

		g[v].push_back(u);
		g[u].push_back(v);
	}

	deque<pair<int, int>> q;
	vector<int> dist(n * n + 1);
	vector<bool> used(n * n + 1);
	q.push_front({ 0, 0 });
	dist[to_int({0, 0})] = 0;
	used[to_int({0, 0})] = true;

	while (!q.empty()) {
		pair<int, int> v = q.front();
		q.pop_front();

		if (dist[to_int(v)] == 10000)
			continue;

		if (v.first == v.second) {
			for (auto to : g[v.first]) {
				pair<int, int> cur = { v.first, to };
				if (!used[to_int(cur)]) {
					q.push_back(cur);
					dist[to_int(cur)] = dist[to_int(v)] + 1;
					used[to_int(cur)] = true;
				}
			}
		}
		else {
			for (auto to : g[v.first]) {
				if (to != v.second) {
					pair<int, int> cur = { to, v.second };
					if (!used[to_int(cur)]) {
						q.push_front(cur);
						dist[to_int(cur)] = dist[to_int(v)];
						used[to_int(cur)] = true;
					}
				}
				else {
					pair<int, int> cur = { v.first, v.first };
					if (!used[to_int(cur)]) {
						q.push_back(cur);
						dist[to_int(cur)] = dist[to_int(v)] + 1;
						used[to_int(cur)] = true;
					}
				}
			}
		}
	}

	for (int i = 1; i < n; i++) {
		if (!used[to_int({i, i})])
			cout << -1 << ' ';
		else
			cout << dist[to_int({i, i})] << ' ';
	}

	cout << '\n';
}

int main() {
	ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL);

	int t; cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}