#include <iostream>
#include <cmath>

#include <algorithm>

#include <vector>
#include <string>
#include <map>
#include <queue>

using namespace std;

typedef long long ll;

const ll inf = 1e18;

struct seg {
	int l, r, c;
	bool t;
	seg() = default;
	seg(int l, int r, int c, bool t) :l(l), r(r), c(c), t(t) {}
	bool operator<(const seg& s)const {
		if (r != s.r)
			return r < s.r;
		return l < s.l;
	}
};

void solve() {
	int n, m; cin >> n >> m;
	vector<int> a(n);
	for (auto& c : a) {
		cin >> c;
	}
	vector<seg> b(m);
	for (auto& c : b) {
		cin >> c.l >> c.r >> c.c >> c.t;
		c.l--;
		c.r--;
	}

	for (int x = 0; x < n; x++) {
		vector<int> cur(n);
		vector<seg> cur_b = b;
		for (auto& c : cur_b) {
			if (c.t) {
				c.l = min(c.l, x);
				c.r = max(c.r, x);
			}
		}

		sort(cur_b.begin(), cur_b.end());
		for (auto c : cur_b) {
			for (int i = c.l; i <= c.r; i++) {
				int have = a[i] - cur[i];
				if (have >= c.c) {
					cur[i] += c.c;
					break;
				}
				else {
					cur[i] += have;
					c.c -= have;
				}
			}
		}

		ll ans = 0;
		for (auto c : cur) {
			ans += c;
		}
		cout << ans << ' ';
	}
}

int main() {
	int t; cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}