#include <bits/stdc++.h>

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array

using namespace std;

typedef long long ll;
typedef long double ld;

using vi = vector<int>;
using vl = vector<ll>;
using vvi = vector<vi>;

const int INFi = 2e9;
const ll INF = 2e18;
const int maxN = 5e5 + 10;

struct dsu {
    vi dsu;

    void build(int n) {
        dsu.resize(n);
        iota(all(dsu), 0);
    }

    int get(int a) {
        return dsu[a] == a ? a : dsu[a] = get(dsu[a]);
    }

    bool unio(int a, int b) {
        if (a == -1 || b == -1) return false;
        a = get(a);
        b = get(b);
        if (a == b) return false;
        dsu[a] = b;
        return true;
    }
} DSU;

vi g[maxN];
int U[maxN * 2], V[maxN * 2];
int h[maxN];
int up[maxN];
vi comp[maxN * 2];

vector<int> stk;

void dfs(int v, int p) {
    up[v] = h[v];
    for (auto &i: g[v]) {
        if (i == p) continue;
        int u = U[i];
        if (h[u]) {
            if (h[u] > h[v]) continue;
            up[v] = min(up[v], h[u]);
            int w = stk[h[u] - 1];
            DSU.unio(w, i ^ 1);
            DSU.unio(p, i);
            continue;
        }
        stk.push_back(i);
        h[u] = h[v] + 1;
        dfs(u, i ^ 1);
        if (up[u] < h[v]) {
            DSU.unio(i, p);
        }
        up[v] = min(up[v], up[u]);
        stk.pop_back();
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 1; i <= n; ++i) {
        g[i].clear();
        h[i] = 0;
        up[i] = 0;
    }
    rep(i, m) {
        int v, u;
        cin >> v >> u;
        g[v].push_back(i * 2);
        g[u].push_back(i * 2 + 1);
        V[i * 2] = v;
        U[i * 2] = u;
        V[i * 2 + 1] = u;
        U[i * 2 + 1] = v;
    }
    DSU.build(m * 2);
    h[1] = 1;
    dfs(1, -1);
    rep(i, m * 2) comp[i].clear();
    rep(i, m * 2) comp[DSU.get(i)].push_back(i);
    queue<pair<int, int>> q;
    q.push({1, 0});
    vi ans(n + 1, -1);
    vi ans2(m * 2, -1);
    ans[1] = 0;
    while (!q.empty()) {
        auto[i, tp] = q.front();
        q.pop();
        if (tp == 0) {
            for (auto j: g[i]) {
                j ^= 1;
                j = DSU.get(j);
                if (ans2[j] != -1) continue;
                q.push({j, 1});
                ans2[j] = ans[i] + 1;
            }
        } else {
            for (auto j: comp[i]) {
                int u = U[j];
                if (ans[u] != -1) continue;
                q.push({u, 0});
                ans[u] = ans2[i] + 1;
            }
        }
    }
    for (int i = 2; i <= n; ++i) cout << ans[i] << ' ';
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
    cin >> t;
    rep(_, t) {
        solve();
    }
    return 0;
}