#include<bits/stdc++.h>
#define int long long
#define p pair<int, int>
#define endl '\n'
const int INF = 1000000001;

using namespace std;

vector<vector<int>> d, point;
vector<map<int, int>> cls;
vector<vector<vector<int>>> comp;
vector<vector<p>> seg;
vector<int> tin, up, order;
vector<bool> was;
int time1 = 0;

void points(int vertex, int parent) {
    tin[vertex] = up[vertex] = time1++, was[vertex] = true;
    order.push_back(vertex);
    for (int q : d[vertex]) {
        if (!was[q]) {
            points(q, vertex);
            up[vertex] = min(up[vertex], up[q]);
            if (up[q] >= tin[vertex]) {
                point[vertex].push_back(q);
                seg[vertex].push_back({tin[q], order.size()});
            }
        } else if (q != parent) {
            up[vertex] = min(up[vertex], tin[q]);
        }
    }
    if (parent == -1 && point[vertex].size() == 1) {
        point[vertex] = {};
    }
    if (point[vertex].empty()) {
        return;
    }
    comp[vertex].assign(point[vertex].size()+1, {});
    for (int q : d[vertex]) {
        int w = upper_bound(seg[vertex].begin(), seg[vertex].end(), p(tin[q], INF))-seg[vertex].begin()-1;
        if (w != -1 && tin[q] < seg[vertex][w].second) {
            comp[vertex][w].push_back(q);
            cls[vertex][q] = w;
        } else {
            comp[vertex].back().push_back(q);
            cls[vertex][q] = point[vertex].size();
        }
    }
}

vector<int> BFS(int vertex) {
    int n = d.size();
    vector<int> dist1(n, INF);
    vector<map<int, int>> dist0(n);
    vector<map<int, bool>> was1(n);
    was.assign(n, false);
    for (int q = 0; q < n; q++) {
        for (int q1 : d[q]) {
            dist0[q][q1] = INF, was1[q][q1] = false;
        }
    }
    queue<pair<int, p>> a;
    a.push({vertex, {1, -1}});
    dist1[vertex] = 0;
    while (!a.empty()) {
        int q = a.front().first, type = a.front().second.first, me = a.front().second.second;
        a.pop();
        if (type == 0) {
            if (dist1[me] == INF) {
                dist1[me] = dist0[q][me]+1;
                a.push({me, {1, -1}});
            }
        } else {
            for (int q1 : d[q]) {
                if (point[q1].empty() && !was[q1]) {
                    was[q1] = true;
                    for (int q2 : d[q1]) {
                        if (dist0[q1][q2] == INF) {
                            dist0[q1][q2] = dist1[q]+1;
                            a.push({q1, {0, q2}});
                        }
                    }
                } else if (!point[q1].empty()) {
                    for (int q2 : comp[q1][cls[q1][q]]) {
                        if (dist0[q1][q2] == INF) {
                            dist0[q1][q2] = dist1[q]+1;
                            a.push({q1, {0, q2}});
                        }
                    }
                }
            }
        }
    }
    return dist1;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t1;
    cin >> t1;
    for (int q11 = 0; q11 < t1; q11++) {
        int n, m;
        cin >> n >> m;
        d.assign(n, {}), tin.assign(n, -1), up.assign(n, -1), was.assign(n, false), time1 = 0;
        point.assign(n, {}), cls.assign(n, {}), comp.assign(n, {}), seg.assign(n, {}), order = {};
        for (int q = 0; q < m; q++) {
            int x, y;
            cin >> x >> y;
            x--, y--;
            d[x].push_back(y);
            d[y].push_back(x);
        }
        points(0, -1);
        vector<int> dist = BFS(0);
        dist.erase(dist.begin());
        for (int q : dist) {
            cout << (q == INF ? -1 : q) << ' ';
        }
        cout << endl;
    }
    return 0;
}
