#include<bits/stdc++.h>
#define int long long
#define p pair<int, int>
#define endl '\n'
const int INF = 1000000001;

using namespace std;

vector<vector<int>> d, point;
vector<int> tin, up;
vector<bool> was;
int time1 = 0;

void points(int vertex, int parent) {
    tin[vertex] = up[vertex] = time1++, was[vertex] = true;
    for (int q : d[vertex]) {
        if (!was[q]) {
            points(q, vertex);
            up[vertex] = min(up[vertex], up[q]);
            if (up[q] >= tin[vertex]) {
                point[vertex].push_back(q);
            }
        } else if (q != parent) {
            up[vertex] = min(up[vertex], tin[q]);
        }
    }
    if (parent == -1 && point[vertex].size() == 1) {
        point[vertex] = {};
    }
    if (parent != -1 && !point[vertex].empty()) {
        point[vertex].push_back(parent);
    }
}

void DFS(int vertex) {
    was[vertex] = true;
    for (int q : d[vertex]) {
        if (!was[q]) {
            DFS(q);
        }
    }
}

vector<int> BFS(int vertex) {
    int n = d.size();
    vector<int> dist1(n, INF);
    vector<map<int, int>> dist0(n);
    vector<map<int, bool>> was1(n);
    for (int q = 0; q < n; q++) {
        for (int q1 : d[q]) {
            dist0[q][q1] = INF, was1[q][q1] = false;
        }
    }
    queue<pair<int, p>> a;
    a.push({vertex, {1, -1}});
    dist1[vertex] = 0;
    while (!a.empty()) {
        int q = a.front().first, type = a.front().second.first, me = a.front().second.second;
        a.pop();
        if (type == 0 && !was1[q][me]) {
            was.assign(n, false);
            was[q] = was1[q][me] = true;
            if (point[q].empty()) {
                was.assign(n, true);
            } else {
                DFS(me);
            }
            for (int q1 : d[q]) {
                if (dist1[q1] == INF && was[q1]) {
                    dist1[q1] = dist0[q][me]+1;
                    a.push({q1, {1, -1}});
                }
            }
        } else {
            for (int q1 : d[q]) {
                if (dist0[q1][q] == INF) {
                    dist0[q1][q] = dist1[q]+1;
                    a.push({q1, {0, q}});
                }
            }
        }
    }
    return dist1;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t1;
    cin >> t1;
    for (int q11 = 0; q11 < t1; q11++) {
        int n, m;
        cin >> n >> m;
        d.assign(n, {}), point.assign(n, {}), tin.assign(n, -1), up.assign(n, -1), was.assign(n, false);
        for (int q = 0; q < m; q++) {
            int x, y;
            cin >> x >> y;
            x--, y--;
            d[x].push_back(y);
            d[y].push_back(x);
        }
        points(0, -1);
        vector<int> dist = BFS(0);
        dist.erase(dist.begin());
        for (int q : dist) {
            cout << (q == INF ? -1 : q) << ' ';
        }
        cout << endl;
    }
    return 0;
}
