#include <bits/stdc++.h>

using namespace std;

#define int long long
#define vi vector<int>
#define vvi vector<vi>
#define pii pair<int, int>

const int inf = 1e9;
const int N = 5005;

vvi a;
vi tin, up;
int now = 0;
vi was;

void dfs(int v, int p = -1) {
    tin[v] = up[v] = now++;
    was[v] = 1;
    for (auto u : a[v]) {
        if (u == p) continue;
        if (was[u]) {
            up[v] = min(up[v], tin[u]);
        } else {
            dfs(u, v);
            up[v] = min(up[v], up[u]);
        }
    }
}
vector<set<int>> cols;
int maxc = 0;
void find(int v, int p = -1, int col = 0) {
    was[v] = 1;
    for (auto u : a[v]) {
        if (u == p) continue;
        if (tin[u] < tin[v]) {
            cols[u].insert(col);
            cols[v].insert(col);
        } else {
            if (was[u]) continue;
            if (up[u] < tin[v]) {
                cols[u].insert(col);
                cols[v].insert(col);
                find(u, v, col);
            } else {
                int ncol = ++maxc;
                cols[u].insert(ncol);
                cols[v].insert(ncol);
                find(u, v, ncol);
            }
        }
    }
}

vector<array<int, 3>> cost[N][N][2];
vector<array<int, 3>> nocost[N][N][2];

int d[N][N][2];
int vis[N][N][2];
void solve() {
    int n, m; cin >> n >> m;
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j <= n; ++j) {
            cost[i][j][0].clear();
            cost[i][j][1].clear();
            nocost[i][j][0].clear();
            nocost[i][j][1].clear();
            d[i][j][0] = d[i][j][1] = inf;
            vis[i][j][0] = vis[i][j][1] = 0;
        }
    }
    maxc = 0;
    a = vvi(n);
    was = tin = up = vi(n);
    cols = vector<set<int>>(n);
    vector<pii> go;
    for (int i = 0; i < m; ++i) {
        int x, y; cin >> x >> y;
        --x, --y;
        a[x].push_back(y);
        a[y].push_back(x);
        go.push_back({x, y});
    }
    dfs(0);
    was = vi(n, 0);
    find(0);

    for (int i = 0; i < n; ++i) {
        for (auto col1 : cols[i]) {
            for (auto col2 : cols[i]) {
                nocost[i][col1][0].push_back({i, col2, 0});
            }
        }
    }
    for (auto par : go) {
        int x = par.first, y = par.second;
        for (auto colx : cols[x]) {
            for (auto coly : cols[y]) {
                if (colx == coly) {
                    cost[x][colx][1].push_back({y, coly, 0});
                    cost[x][colx][0].push_back({y, coly, 1});
                    cost[y][coly][1].push_back({x, colx, 0});
                    cost[y][coly][0].push_back({x, colx, 1});
                }
            }
        }
    }

    deque<array<int, 3>> q;
    for (auto col0 : cols[0]) {
        d[0][col0][0] = 0;
        q.push_back({0, col0, 0});
    }
    while (q.size()) {
        auto info = q.front();
        q.pop_front();
        int a = info[0], b = info[1], c = info[2];
        if (vis[a][b][c]) continue;
        vis[a][b][c] = 1;
        for (auto go : cost[a][b][c]) {
            int aa = go[0], bb = go[1], cc = go[2];
            if (d[aa][bb][cc] > d[a][b][c] + 1) {
                d[aa][bb][cc] = d[a][b][c] + 1;
                q.push_back({aa, bb, cc});
            }
        }
        for (auto go : nocost[a][b][c]) {
            int aa = go[0], bb = go[1], cc = go[2];
            if (d[aa][bb][cc] > d[a][b][c]) {
                d[aa][bb][cc] = d[a][b][c];
                q.push_front({aa, bb, cc});
            }
        }
    }

    for (int i = 1; i < n; ++i) {
        int res = inf;
        for (auto coli : cols[i]) {
            res = min(res, d[i][coli][0]);
        }
        if (res == inf) res = -1;
        cout << res << ' ';
    }
    cout << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);

    int t; cin >> t;
    while (t--) {
        solve();
    }
}

/*
1
5 6
1 2
2 3
3 1
3 4
4 5
5 3

 */
