#include <bits/stdc++.h>

using namespace std;

#define int long long
#define vi vector<int>
#define vvi vector<vi>
#define pii pair<int, int>

const int inf = 1e9;
const int N = 2e6;

vvi a;
vi tin, up;
int now = 0;
vi was;

void dfs(int v, int p = -1) {
    tin[v] = up[v] = now++;
    was[v] = 1;
    for (auto u : a[v]) {
        if (u == p) continue;
        if (was[u]) {
            up[v] = min(up[v], tin[u]);
        } else {
            dfs(u, v);
            up[v] = min(up[v], up[u]);
        }
    }
}
vector<vi> cols;
int maxc = 0;
void find(int v, int p = -1, int col = 0) {
    was[v] = 1;
    for (auto u : a[v]) {
        if (u == p) continue;
        if (tin[u] < tin[v]) {
            cols[u].push_back(col);
            cols[v].push_back(col);
        } else {
            if (was[u]) continue;
            if (up[u] < tin[v]) {
                cols[u].push_back(col);
                cols[v].push_back(col);
                find(u, v, col);
            } else {
                int ncol = ++maxc;
                cols[u].push_back(ncol);
                cols[v].push_back(ncol);
                find(u, v, ncol);
            }
        }
    }
}

vvi cost, nocost;
vi d, vis;

void solve() {
    int n, m; cin >> n >> m;
    maxc = 0;
    nocost.clear();
    cost.clear();
    d.clear();
    vis.clear();
    a = vvi(n);
    was = tin = up = vi(n);
    cols = vector<vi>(n);
    vector<pii> go;
    for (int i = 0; i < m; ++i) {
        int x, y; cin >> x >> y;
        --x, --y;
        a[x].push_back(y);
        a[y].push_back(x);
        go.push_back({x, y});
    }
    dfs(0);
    was = vi(n, 0);
    find(0);
    map<int, int> id;
    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        sort(cols[i].begin(), cols[i].end());
        cols[i].resize(unique(cols[i].begin(), cols[i].end()) - cols[i].begin());
        id[{i * 10000000 + -1}] = cnt++;
        cost.emplace_back();
        cost.emplace_back();
        nocost.emplace_back();
        nocost.emplace_back();
        d.emplace_back(inf);
        d.emplace_back(inf);
        vis.emplace_back();
        vis.emplace_back();
        for (auto col1 : cols[i]) {
            id[i * 10000000 + col1] = cnt++;
            cost.emplace_back();
            cost.emplace_back();
            nocost.emplace_back();
            nocost.emplace_back();
            d.emplace_back(inf);
            d.emplace_back(inf);
            vis.emplace_back();
            vis.emplace_back();
        }
    }

    for (int i = 0; i < n; ++i) {
        for (auto col1 : cols[i]) {
            nocost[id[10000000 * i + col1]].push_back(id[10000000 * i + -1]);
            nocost[id[10000000 * i + -1]].push_back(id[10000000 * i + col1]);
        }
    }

    for (auto par : go) {
        int x = par.first, y = par.second;
        for (auto colx : cols[x]) {
            if (!id.count(10000000 * y + colx)) continue;
            cost[id[10000000 * x + colx]].push_back(id[10000000 * y + colx] + cnt);
            cost[id[10000000 * x + colx] + cnt].push_back(id[10000000 * y + colx]);
            cost[id[10000000 * y + colx]].push_back(id[10000000 * x + colx] + cnt);
            cost[id[10000000 * y + colx] + cnt].push_back(id[10000000 * x + colx]);
        }
    }

    deque<int> q;
    for (auto col0 : cols[0]) {
        d[id[col0]] = 0;
        q.push_back(id[col0]);
    }
    while (q.size()) {
        int v = q.front();
        q.pop_front();
        if (vis[v]) continue;
        vis[v] = 1;
        for (auto u : cost[v]) {
            if (d[u] > d[v] + 1) {
                d[u] = d[v] + 1;
                q.push_back(u);
            }
        }
        for (auto u : nocost[v]) {
            if (d[u] > d[v]) {
                d[u] = d[v];
                q.push_front(u);
            }
        }
    }

    for (int i = 1; i < n; ++i) {
        int res = inf;
        for (auto coli : cols[i]) {
            res = min(res, d[id[10000000 * i + coli]]);
        }
        if (res == inf) res = -1;
        cout << res << ' ';
    }
    cout << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);

    int t; cin >> t;
    while (t--) {
        solve();
    }
}

/*
1
5 6
1 2
2 3
3 1
3 4
4 5
5 3

 */
