#include <iostream>
#include <bits/stdc++.h>

using namespace std;

#define range(i, n) for (int i = 0; i < (n); ++i)
#define rrange(i, n) for (int i = (n) - 1; i >= 0; --i)

#define all(a) (a).begin(), (a).end()

typedef long long ll;

struct Fenwick {
    vector<int> ts;
    int n;
    Fenwick(int n) : ts(n, 0), n(n) {
    }
    int get(int i) {
        int res = 0;
        for (;i >= 0; i = (i & (i + 1)) - 1) {
            res += ts[i];
        }
        return res;
    }
    void add(int i, int x) {
        for (; i < n; i = (i|(i + 1))) {
            ts[i] += x;
        }
    }
};

double bin_pow(double x, int n) {
    assert(n >= 0);
    if (n == 0) return 1;
    if (n == 1) return x;
    if (n & 1)
        return x * bin_pow(x, n - 1);
    else {
        auto t = bin_pow(x, n / 2);
        return t * t;
    }
}

int main() {
    string num; cin >> num;
    ll cost; cin >> cost;
    int n = num.size();
    vector<int> arr(n);
    range(i, n) {
        arr[i] = num[i] - '0';
    }
    vector<vector<int>> where(10, vector<int>());
    rrange(i, n) {
        where[arr[i]].push_back(n - i - 1);
    }
    vector<int> ans(n);
    Fenwick f(n);
    rrange(i, n) {
        int best_a = 0;
        double best_margin = -1;
        rrange(a, 10) {
            if (where[a].empty()) continue;
            int j = where[a].back();
            j -= f.get(j);
            double margin = a * bin_pow(10, i) - cost * (i - j);
            if (margin > best_margin) {
                best_margin = margin;
                best_a = a;
            }
        }
        int j = where[best_a].back();
        j -= f.get(j);
        f.add(where[best_a].back(), 1);
        where[best_a].pop_back();
        ans[i] = best_a;
    }

    rrange(i, n) {
        cout << ans[i];
    }
    cout << '\n';
    return 0;
}
