#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

typedef long long ll;
typedef long double ld;

#define input(a) do {for (auto& e : a) cin >> e;} while(0);
#define print(a) do {cerr << #a << ": "; for (auto& e : a) cerr << e << " "; cerr << "\n";} while(0);

struct robot {
	int l, r;
	int c;
	int t;
	int id;
};

bool operator<(robot a, robot b) {
	if (a.r == b.r)
		return a.id < b.id;
	return a.r < b.r;
}

ll solve(vector<int>& arr, vector<robot>& robots) {
	int n  = arr.size();
	sort(robots.begin(), robots.end(), [](robot& a, robot& b) {
		return a.l < b.l;
	});
	set<robot> avaible;
	ll ans = 0;
	int j = 0;
	for (int i = 0; i < n; i++) {
		while (j < robots.size() && robots[j].l <= i) {
			avaible.insert(robots[j]);
			j++;
		}
		while (!avaible.empty() && avaible.begin()->r <= i)
			avaible.erase(avaible.begin());
		int takeNow = arr[i];
		while (!avaible.empty() && avaible.begin()->c <= takeNow) {
			ans += avaible.begin()->c;
			takeNow -= avaible.begin()->c;
			avaible.erase(avaible.begin());
		}
		if (!avaible.empty()) {
			auto now = *avaible.begin();
			avaible.erase(avaible.begin());
			ans += takeNow;
			now.c -= takeNow;
			avaible.insert(now);
		}
	}
	return ans;
}

void solve() {
	int n, m;
	cin >> n >> m;
	vector<int> arr(n);
	input(arr);
	vector<robot> r(m);
	int id = 0;
	for (auto& e : r) {
		cin >> e.l >> e.r >> e.c >> e.t;
		e.l--;
		e.id = id++;
	}

	for (int x = 0; x < n; x++) {
		vector<robot> now;
		for (auto e : r) {
			if (e.t == 1) {
				e.l = min(e.l, x);
				e.r = max(e.r, x + 1);
			}
			now.push_back(e);
		}
		cout << solve(arr, now) << " ";
	}
	cout << "\n";
}


int main() {
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	int t;
	cin >> t;
	while (t--)
		solve();	
}