#include <iostream>
#include <algorithm>
#include <vector>
#include <iomanip>
#include <set>
#include <random>
#include <map>
#include <cmath>
#include <string>

#pragma GCC target("avx,avx2,sse,sse2,sse3,sse4,popcnt")

#pragma GCC oiptimize("-Ofast,unroll-loops,fast-math")

using namespace std;

int n;

string num, result;

long long y;

long long dif(int ind1, int ind2) {
	long long num1 = 0, num2 = 0;
	for (int i = ind1; i < n; ++i) {
		num1 *= 10;
		num1 += num[i] - '0';
	}
	num2 += num[ind2] - '0';
	for (int i = ind1; i < ind2; ++i) {
		num2 *= 10;
		num2 += num[i] - '0';
	}
	for (int i = ind2 + 1; i < n; ++i) {
		num2 *= 10;
		num2 += num[i] - '0';
	}
	return num2 - num1 - y * (ind2 - ind1);
}

set <pair <int, int>> nums;

void do_nums(int ind1) {
	nums.clear();
	for (int i = ind1; i < n; ++i)
		nums.insert({ num[i] - '0', n - i - 1 });
}

mt19937 rnd(time(0));

void gen() {
	num = "";
	y = rnd() % 1000000 + 1;
	int n1 = rnd() % 8 + 1;
	for (int i = 0; i < n1; ++i) {
		num += (rnd() % 10) + '0';
	}
}

string solve1() {
	//cin >> num;
	//cin >> y;
	result = "";
	n = num.size();
	do_nums(0);
	int ind1 = 0;
	do_nums(ind1);
	while (!nums.empty() && (*nums.rbegin()) == make_pair(num[ind1] - '0', n - ind1 - 1)) {
		nums.erase({ num[ind1] - '0', n - ind1 - 1 });
		result += num[ind1];
		++ind1;
	}
	while (n - ind1 >= 16) {
		auto el = (*nums.rbegin());
		result += el.first + '0';
		nums.erase(el);
		++ind1;
	}
	vector <pair <int, int>> nums3;
	for (auto el : nums) {
		nums3.push_back({ n - el.second - 1, el.first });
	}
	sort(nums3.begin(), nums3.end());
	for (int i = 0; i < nums3.size(); ++i)
		num[ind1 + i] = nums3[i].second + '0';
	for (; ind1 < n; ++ind1) {
		do_nums(ind1);
		int ind2 = n - (*nums.rbegin()).second - 1;
		long long dif_max = dif(ind1, ind2);
		if (dif_max < 0) {
			dif_max = 0;
			ind2 = ind1;
		}
		for (int i = ind1 + 1; i < n; ++i) {
			if (num[ind2] >= num[i])
				continue;
			long long df = dif(ind1, i);
			if (df >= dif_max) {
				ind2 = i;
				dif_max = df;
			}
		}
		result += num[ind2];
		for (int i = ind2; i > ind1; --i)
			num[i] = num[i - 1];
	}
	return result;
}

string solve2() {
	result = "";
	n = num.size();
	do_nums(0);
	int ind1 = 0;
	while (!nums.empty() && (*nums.rbegin()) == make_pair(num[ind1] - '0', ind1)) {
		nums.erase({ num[ind1] - '0', ind1 });
		result += num[ind1];
		++ind1;
	}
	if (y < 10 || n - ind1 >= 21) {
		while (!nums.empty()) {
			result += '0' + (*nums.rbegin()).first;
			nums.erase(*nums.rbegin());
		}
		return result;
	}
	while (n - ind1 >= 19 || (y <= 100000000 && n - ind1 >= 12)) {
		result += '0' + (*nums.rbegin()).first;
		nums.erase(*nums.rbegin());
		++ind1;
	}
	vector <pair <int, int>> nums3;
	for (auto el : nums)
		nums3.push_back({ n - 1 - el.second, el.first });
	sort(nums3.begin(), nums3.end());
	for (int i = 0; i < nums3.size(); ++i)
		num[ind1 + i] = nums3[i].second + '0';
	for (; ind1 < n; ++ind1) {
		do_nums(ind1);
		int ind2 = n - (*nums.rbegin()).second - 1;
		long long dif_max = dif(ind1, ind2);
		if (dif_max < 0) {
			dif_max = 0;
			ind2 = ind1;
		}
		for (int i = ind1 + 1; i < n; ++i) {
			if (num[i] <= num[ind2])
				continue;
			long long df = dif(ind1, i);
			if (df >= dif_max) {
				dif_max = df;
				ind2 = i;
			}
		}
		result += num[ind2];
		for (int i = ind2; i >= ind1 + 1; --i)
			num[i] = num[i - 1];
	}
	return result;
}

void input() {
	cin >> num;
	cin >> y;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	input();
	cout << solve1();
}