#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <cassert>
#include <cstdlib>

using namespace std;
#define int long long

const int ctox(const vector<int> &v) {
    int res = 0;
    int p10 = 1;
    for (int i = v.size() - 1; i >= 0; i--) {
        res += v[i] * p10;
        p10 *= 10;
    }
    return res;
}

bool tryswp(vector<int> &s, int i1, int i2, int y) {
    if (s[i2] > s[i1]) {
        vector<int> c1;
        vector<int> c2;
        c1.reserve(i2 - i1 + 1);
        c2.reserve(i2 - i1 + 1);
        for (int k = i1; k < s.size(); k++) {
            c1.push_back(s[k]);
        }
        c2.push_back(s[i2]);
        for (int k = i1; k < s.size(); k++) {
            if (k == i2) continue;
            c2.push_back(s[k]);
        }
        int v1 = ctox(c1);
        int v2 = ctox(c2);
        if (v2 - v1 >= y * (i2 - i1)) {
            for (int i = i2; i > i1; i--) swap(s[i], s[i - 1]);
            return true;
        } else {
            return false;
        }
    }
    return false;
}

int calcv(vector<int> &s, int i1, int i2, int y) {
    if (s[i1] >= s[i2]) return -1;
    vector<int> c1;
    vector<int> c2;
    c1.reserve(i2 - i1 + 1);
    c2.reserve(i2 - i1 + 1);
    for (int k = i1; k < s.size(); k++) {
        c1.push_back(s[k]);
    }
    c2.push_back(s[i2]);
    for (int k = i1; k < s.size(); k++) {
        if (k == i2) continue;
        c2.push_back(s[k]);
    }
    int v1 = ctox(c1);
    int v2 = ctox(c2);
    return v2 - v1 - y * (i2 - i1);
}

const bool cmp(const int& a, const int& b) {
    return a > b;
}

signed main() {
    string ss;
    cin >> ss;
    vector<int> s(ss.begin(), ss.end());
    int n = s.size();
    for (auto &i: s) i -= '0';
    auto cs = s;
    sort(cs.begin(), cs.end());
    map<int, int> cnt18;
    for (int i = 0; i < min((int)cs.size(), 18ll); i++) {
        cnt18[cs[i]]++;
    }
    vector<int> s0;
    for (int i = n - 1; i >= 0; i--) {
        if (cnt18[s[i]] > 0) {
            cnt18[s[i]]--;
            s0.push_back(s[i]);
        }
    }
    reverse(s0.begin(), s0.end());
    int y;
    cin >> y;
    for (int jj = 0; jj < (s0.size() + 1) * (s0.size() + 1); jj++) {
        pair<int, pair<int, int>> mx = {-1e18, {-1e18, -1e18}};
        for (int i1 = 0; i1 < s0.size(); i1++) {
            for (int i2 = i1 + 1; i2 < s0.size(); i2++) {
                int add = calcv(s0, i1, i2, y);
                mx = max(mx, {add, {i1, i2}});
            }
        }
        if (mx.first < 0) break;
        assert(tryswp(s0, mx.second.first, mx.second.second, y));
    }
    for (int i = n - 1; i > 17; i--) {
        cout << cs[i];
    }
    for (auto v: s0) cout << v;
    return 0;
}
