#include <iostream>
#include <algorithm>
#include <map>

int main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);

    int32_t n, num_q;
    std::cin >> n >> num_q;

    int64_t* arr = new int64_t[n];
    for(int32_t i = 0; i < n; i++)
        std::cin >> arr[i];

    int64_t* sorted_arr = new int64_t[n];
    for(int32_t i = 0; i < n; i++)
        sorted_arr[i] = arr[i];
    std::sort(sorted_arr, sorted_arr + n);

    int64_t* arr2 = new int64_t[n];
    for(int32_t i = 0; i < n; i++)
        arr2[i] = arr[i];
    std::sort(arr2, arr2 + n);
    int32_t levels_start = std::unique(arr2, arr2 + n) - arr2;

    std::vector<int64_t> diffs;
    std::map<int64_t, std::vector<int64_t> > per_diff;
    for(int32_t i = 0; i < levels_start - 1; i++) {
        diffs.push_back(arr2[i + 1] - arr2[i]);
        per_diff[diffs.back()].push_back(arr2[i]);
    }
    std::sort(diffs.begin(), diffs.end());

    std::vector<std::pair<int64_t, int64_t> > changes;
    changes.emplace_back(0, 0);
    for(int32_t i = 0; i < n; i++)
        changes[0].second += levels_start - (std::lower_bound(arr2, arr2 + levels_start, arr[i]) - arr2) - 1;

    int32_t start = 0;
    for(int32_t i = 0; i < diffs.size(); i++) {
        if(i != diffs.size() - 1 && diffs[i + 1] == diffs[i])
            continue;

        //start to i inc
        changes.emplace_back(diffs[i], changes.back().second);
        for(int32_t num : per_diff[diffs[i]])
            changes.back().second -= std::lower_bound(sorted_arr, sorted_arr + n, num + 1) - sorted_arr;
        start = i + 1;
    }

    int64_t* change_pref_sum = new int64_t[changes.size()];
    change_pref_sum[0] = 0;
    for(int32_t i = 1; i < changes.size(); i++)
        change_pref_sum[i] = change_pref_sum[i - 1] + (changes[i].first - changes[i - 1].first) * changes[i - 1].second;

    for(int32_t q = 0; q < num_q; q++) {
        int32_t type;
        int64_t k;
        std::cin >> type >> k;

        if(type == 1) {
            int32_t ans = std::lower_bound(diffs.begin(), diffs.end(), k + 1) - diffs.begin();
            ans = levels_start - ans;
            std::cout << ans << "\n";
        }
        if(type == 2) {
            int32_t period_in = std::lower_bound(changes.begin(), changes.end(), std::pair<int64_t, int64_t>(k - 1, -1)) - changes.begin();
            std::cout << change_pref_sum[period_in] + (k - changes[period_in].first) * changes[period_in].second << "\n";
        }
    }
    return 0;
}
