#pragma GCC optimize("O3,unroll-loops,rename-register,rename-registers,fast-math")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4.1,sse4.2,avx,avx2")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;

#define int long long

using ll = long long;
#define all(a) a.begin(), a.end()
using pii = std::pair<int, int>;
const ll INFLL = 0x3f3f3f3f3f3f3f3f;

const int MAXN = 5005;
std::vector<int> g[MAXN];
int dist[MAXN][MAXN], used[MAXN][MAXN];

void solve() {
    int n, m;
    std::cin >> n >> m;
    for (int i = 0; i < n; i++) for (int j = 0; j < n; j++) used[i][j] = 0, dist[i][j] = INFLL;
    for (int i = 0; i < n; i++) {
        g[i].clear();
    }
    for (int i = 0; i < m; i++) {
        int a, b;
        std::cin >> a >> b;
        a--, b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    dist[0][0] = 0;

    std::deque<pii> q;
    q.emplace_back(0, 0);

//    std::priority_queue<std::pair<int, pii>> q;
//    q.emplace(0, std::make_pair(0, 0));
    while (!q.empty()) {
        auto pos = q.front();
        q.pop_front();
        auto[player, box] = pos;
        if (used[player][box]) continue;
        used[player][box] = true;
        if (player == box) {
            for (auto &to: g[player]) {
                if (dist[player][to] > dist[player][box] + 1) {
                    dist[player][to] = dist[player][box] + 1;
                    q.emplace_back(player, to);
                }
            }
            continue;
        }
        for (auto &to: g[player]) {
            if (to != box && dist[to][box] > dist[player][box]) {
                dist[to][box] = dist[player][box];
                q.push_front(std::make_pair(to, box));
            }
            if (to == box && dist[player][player] > dist[player][box] + 1) {
                dist[player][player] = dist[player][box] + 1;
                q.emplace_back(player, player);
            }
        }
    }

    for (int i = 1; i < n; i++) {
        if (dist[i][i] == INFLL) std::cout << -1 << ' ';
        else std::cout << dist[i][i] << ' ';
    }
    std::cout << '\n';
}

signed main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);
    std::cout.tie(0);

    int t;
    std::cin >> t;
    while (t--) {
        solve();
    }
}