#include <bits/stdc++.h>

#define int long long
#define all(x) x.begin(), x.end()

using namespace std;

const int MAXN = 500500;
const int INF = (int) 1e9;

vector<int> g[MAXN];
vector<int> dist[MAXN];

void sol() {
    int n, m;
    cin >> n >> m;
    fill(g, g + n + 5, vector<int>());
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    fill(dist, dist + n + 5, vector<int>(2, INF));
    dist[1][0] = 0;
    deque<pair<int, int>> q = {{1, 0}};
    while (!q.empty()) {
        auto v = q.front();
        q.pop_front();
        int val = (v.second + 1) % 2;
        for (int u: g[v.first]) {
            if (dist[u][val] > dist[v.first][v.second] + 1) {
                dist[u][val] = dist[v.first][v.second] + 1;
                q.push_back({u, val});
            }
        }
    }
    for (int v = 2; v <= n; v++) {
        cout << (dist[v][0] == INF ? -1 : dist[v][0]) << ' ';
    }
    cout << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        sol();
    }
}

/*
4
4 4
1 2
2 3
3 4
4 1
5 5
1 2
2 3
3 4
4 5
5 1
5 6
1 2
3 2
1 3
3 5
5 4
3 4
9 12
1 2
2 3
3 1
4 5
5 6
6 4
7 8
8 9
9 7
3 6
6 9
9 3
 */
