#pragma GCC optimize("Ofast")

#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <string>
#include <ctime>

using namespace std;
using ll = long long;

auto t = clock();

bool istl()
{
	static bool tl = false;
	static int it = 0;
	
	if (++it % 100 == 0)
		tl = clock() - t > 800;
	return tl;
}

pair<ll, ll> stupid(string& s, ll y, int depth, ll curFine, int pos)
{
	if (depth == 0)
		return { stoll(s) - curFine, stoll(s) };

	if (pos >= s.size())
		return { 0, 0 };

	pair<ll, ll> res = { stoll(s) - curFine, stoll(s) };
	//if (istl())
	//	return res;
	for (int i = pos; i < s.size(); ++i)
	{
		char c = s[i];
		for (int j = i - 1; j >= 0; --j)
		{
			swap(s[j + 1], s[j]);
			//if (istl())
			//	return res;
			if (c >= s[j + 1])
				res = max(res, stupid(s, y, depth - 1, curFine + y * i - j, pos + 1));
		}
		for (int k = 0; k < i; ++k)
			swap(s[k], s[k + 1]);
	}
	return res;
}

string solve12(string s, ll y)
{
	int tpos = 0;
	int n = s.size();
	vector<ll> pows(19, 1);
	for (int i = 0; i < 18; ++i)
		pows[i + 1] = pows[i] * 10;

	string res(n, '1');
	for (int i = 0; i < n; ++i)
	{
		if (s[i] == '2')
		{
			if (n - tpos > 18)
				res[tpos++] = '2';
			else
			{
				int bestPos = i;
				ll bestRes = 0;
				for (int j = i - 1; j >= tpos; --j)
				{
					ll num = stoll(res.substr(j, i - j));
					ll prev = num * 10 + s[i] - '0';
					ll nxt = num + (s[i] - '0') * pows[i - j];
					ll cur = (nxt - prev) * pows[n - i - 1] - y * (i - j);
					if (cur >= bestRes)
						bestPos = j, bestRes = cur;
				}
				res[bestPos] = '2';
				tpos = bestPos + 1;
			}
		}
	}
	return res;
}

string solveThis___(string s, ll y)
{
	int n = s.size();
	vector<ll> pows(19, 1);
	for (int i = 0; i < 18; ++i)
		pows[i + 1] = pows[i] * 10;

	for (char digit = '9'; digit > '0'; --digit)
	{
		int tpos = 0;
		for (int i = 0; i < n; ++i)
		{
			if (s[i] >= digit)
			{
				if (n - tpos > 18)
				{
					for (int j = i; j > tpos; --j)
						swap(s[j], s[j - 1]);
					++tpos;
				}
				else
				{
					ll bestPos = i, bestRes = 0;
					for (int j = i - 1; j >= tpos; --j)
					{
						ll num = stoll(s.substr(j, i - j));
						ll prev = num * 10 + s[i] - '0';
						ll nxt = num + (s[i] - '0') * pows[i - j];
						ll cur = (nxt - prev) * pows[n - i - 1] - y * (i - j);
						if (cur >= bestRes)
							bestPos = j, bestRes = cur;
					}
					for (int j = i; j > bestPos; --j)
						swap(s[j], s[j - 1]);
					tpos = bestPos + 1;
				}
			}
		}
	}
	
	return s;
}

string solve(string s, ll y)
{
	int n = s.size();
	vector<ll> pows(n + 1, 1);
	for (int i = 0; i < n; ++i)
		pows[i + 1] = pows[i] * 10;

	for (int digit = 9; digit >= 0; --digit)
	{
		for (int i = 0; i < n; ++i)
		{
			if (s[i] != digit + '0')
				continue;
			ll bestPos = i, bestRes = 0;
			for (int j = i - 1; j >= 0; --j)
			{
				ll num = stoll(s.substr(j, i - j));
				ll prev = num * 10 + s[i] - '0';
				ll nxt = num + (s[i] - '0') * pows[i - j];
				ll cur = (nxt - prev) * pows[n - i - 1] - y * (i - j);
				if (cur >= 0)
					bestPos = j, bestRes = cur;
			}

			for (int j = i; j > bestPos; --j)
				swap(s[j], s[j - 1]);
		}
	}
	return s;
}

string solveSmall(string s, ll y)
{
	int n = s.size();
	vector<ll> pows(n + 1, 1);
	for (int i = 0; i < n; ++i)
		pows[i + 1] = pows[i] * 10;

	for (int d = 9; d >= 0; --d)
	{
		for (int i = n - 1; i >= 0; --i)
		{
			if (s[i] != d + '0')
				continue;
			for (int t = 0; t < 20; ++t)
			{
				ll bestRes = 0, bestPos = i;
				for (int j = i - 1; j >= 0; --j)
				{
					ll val = stoll(s.substr(j, i - j));
					ll prev = val * 10 + s[i] - '0';
					ll cur = val + (s[i] - '0') * pows[i - j];
					ll curRes = (cur - prev) * pows[n - i - 1] - (i - (ll)j) * y;
					if (curRes >= bestRes)
						bestRes = curRes, bestPos = j;
				}
				for (int j = i; j > bestPos; --j)
					swap(s[j], s[j - 1]);
			}
		}
	}
	
	return s;
}

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	string s;
	cin >> s;

	ll y = 0;
	cin >> y;

	string res = to_string(stupid(s, y, 9, 0, 0).second);
	string add(s.size() - res.size(), '0');
	cout << add + res << "\n";
	//cout << solveThis___(s, y) << "\n";
	//sort(s.begin(), s.end(), std::greater<char>());
	//cout << s << "\n";
	//cout << solveSmall(s, y) << "\n";

	/*int n = s.size();
	sort(s.begin(), s.begin() + max(0, n - 20), std::greater<char>());
	cout << s.substr(0, max(0, n - 20)) + solveSmall(s.substr(max(0, n - 20), min(n, 20)), y);*/

	return 0;
}