#include <set>
#include <vector>
#include <iomanip>
#include <iostream>
#include <algorithm>

using namespace std;

long long solve(const vector<long long> &A, const vector<long long> &C, const vector<pair<int, int>> &segms) {
  int n = A.size();
  int m = C.size();
  vector<int> order_left(m);
  for (int i = 0; i < m; ++i)
    order_left[i] = i;
  sort(order_left.begin(), order_left.end(), [&](int a, int b) {
    return segms[a].first < segms[b].first;
  });
  vector<long long> A1 = A;
  vector<long long> C1 = C;
  set<pair<int, int>> opened;
  long long ans = 0;
  int j = 0;
  for (int i = 0; i < n; ++i) {
    while (j < m && segms[order_left[j]].first == i) {
      opened.emplace(segms[order_left[j]].second, order_left[j]);
      ++j;
    }
    while (!opened.empty()) {
      auto tmp = opened.begin()->second;
      if (segms[tmp].second < i) {
        opened.erase(opened.begin());
        continue;
      }
      if (C1[tmp] <= A1[i]) {
        opened.erase(opened.begin());
        A1[i] -= C1[tmp];
        ans += C1[tmp];
        C1[tmp] = 0;
      } else {
        C1[tmp] -= A1[i];
        ans += A1[i];
        A1[i] = 0;
        break;
      }
    }
  }
  return ans;
}

int main() {
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else
  ios::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
#endif

  int q;
  cin >> q;
  while (q--) {
    int n, m;
    cin >> n >> m;
    vector<long long> A(n);
    for (int i = 0; i < n; ++i)
      cin >> A[i];
    vector<long long> C(m);
    vector<int> t(m);
    vector<pair<int, int>> segms(m);
    for (int i = 0; i < m; ++i) {
      cin >> segms[i].first >> segms[i].second >> C[i] >> t[i];
      --segms[i].first;
      --segms[i].second;
    }
    for (int x = 0; x < n; ++x) {
      vector<pair<int, int>> cur_segms(m);
      for (int i = 0; i < m; ++i) {
        if (t[i])
          cur_segms[i] = make_pair(min(segms[i].first, x), max(segms[i].second, x));
        else
          cur_segms[i] = segms[i];
      }
      cout << solve(A, C, cur_segms) << ' ';
    }
    cout << '\n';
  }
  return 0;
}
