#include <set>
#include <vector>
#include <iomanip>
#include <iostream>
#include <algorithm>

using namespace std;

const int MAXN = 200'200;
int par[MAXN];

int get(int v) {
  if (v == par[v])
    return v;
  return par[v] = get(par[v]);
}

void merge(int v, int u) {
  v = get(v);
  u = get(u);
  par[v] = u;
}

vector<long long> A1;

long long solve(const vector<long long> &A, const vector<long long> &C, const vector<pair<int, int>> &segms, const vector<int> &order0, const vector<int> &order1) {
  int n = A.size();
  A1 = A;
  for (int i = 0; i <= n; ++i)
    par[i] = i;
  long long ans = 0;
  int i0 = 0, i1 = 0;
  while (i0 < order0.size() || i1 < order1.size()) {
    int j;
    if (i0 < order0.size() && (i1 == order1.size() || segms[order0[i0]].second < segms[order1[i1]].second || (segms[order0[i0]].second == segms[order1[i1]].second && segms[order0[i0]].first < segms[order1[i1]].first))) {
      j = order0[i0];
      ++i0;
    } else {
      j = order1[i1];
      ++i1;
    }
    long long rest = C[j];
    int cur = get(segms[j].first);
    while (cur <= segms[j].second) {
      if (A1[cur] <= rest) {
        ans += A1[cur];
        rest -= A1[cur];
        A1[cur] = 0;
        merge(cur, cur + 1);
        cur = get(cur);
      } else {
        ans += rest;
        A1[cur] -= rest;
        rest = 0;
        break;
      }
    }
  }
  return ans;
}

int main() {
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else
  ios::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
#endif

  int q;
  cin >> q;
  while (q--) {
    int n, m;
    cin >> n >> m;
    vector<long long> A(n);
    for (int i = 0; i < n; ++i)
      cin >> A[i];
    vector<long long> C(m);
    vector<int> t(m);
    vector<pair<int, int>> segms(m);
    for (int i = 0; i < m; ++i) {
      cin >> segms[i].first >> segms[i].second >> C[i] >> t[i];
      --segms[i].first;
      --segms[i].second;
    }
    vector<int> order0;
    vector<int> order1;
    for (int i = 0; i < m; ++i) {
      if (t[i])
        order1.emplace_back(i);
      else
        order0.emplace_back(i);
    }
    sort(order1.begin(), order1.end(), [&](int a, int b) {
      if (segms[a].second == segms[b].second)
        return segms[a].first < segms[b].first;
      return segms[a].second < segms[b].second;
    });
    sort(order0.begin(), order0.end(), [&](int a, int b) {
      if (segms[a].second == segms[b].second)
        return segms[a].first < segms[b].first;
      return segms[a].second < segms[b].second;
    });
    vector<int> tmp(m);
    vector<pair<int, int>> cur_segms(m);
    int pr = 0;
    for (int x = 0; x < n; ++x) {
      for (int i = 0; i < m; ++i) {
        if (t[i])
          cur_segms[i] = make_pair(min(segms[i].first, x), max(segms[i].second, x));
        else
          cur_segms[i] = segms[i];
      }
      int j = pr;
      while (j < order1.size() && segms[order1[j]].second == x)
        ++j;
      //merge [0, pr) and [pr, j)
      for (int i = 0; i < pr; ++i)
        tmp[i] = order1[i];
      int i1 = 0, i2 = 0;
      while (i1 < pr || i2 < j - pr) {
        if (i1 < pr && (i2 == j - pr || segms[tmp[i1]].first < segms[order1[pr + i2]].first)) {
          order1[i1 + i2] = tmp[i1];
          ++i1;
        } else {
          order1[i1 + i2] = order1[pr + i2];
          ++i2;
        }
      }
      pr = j;
      cout << solve(A, C, cur_segms, order0, order1) << ' ';
    }
    cout << '\n';
  }
  return 0;
}
