#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ckmin(a, b) a = min(a, b)
#define ckmax(a, b) a = max(a, b)
#define pii pair<int, int>
#define fi first
#define se second
#define ld long double
#define sz(x) (int)x.size()
#define int long long

const int inf = 1e18;

struct Tree {
    int n;
    vector<vector<int>> t, prefSum;
    vector<int> a;

    vector<int> mrg(vector<int> &x, vector<int> &y) {
        vector<int> res;
        int px = 0, py = 0;
        while (px < sz(x) && py < sz(y)) {
            if (x[px] > y[py])
                res.push_back(x[px++]);
            else
                res.push_back(y[py++]);
        }
        while (px < sz(x))
            res.push_back(x[px++]);
        while (py < sz(y))
            res.push_back(y[py++]);

        return res;
    }

    void build(int v, int tl, int tr) {
        if (tl == tr) {
            t[v].push_back(a[tl]);
            prefSum[v].push_back(a[tl]);
        } else {
            int tm = (tl + tr) / 2;
            build(v * 2, tl, tm);
            build(v * 2 + 1, tm + 1, tr);
            t[v] = mrg(t[v * 2], t[v * 2 + 1]);

            if(t[v].empty())
                return;

            prefSum[v].resize(sz(t[v]));
            prefSum[v][0] = t[v][0];

            for (int i = 1; i < sz(t[v]); ++i)
                prefSum[v][i] = prefSum[v][i - 1] + t[v][i];
        }
    }

    Tree(vector<int> &b) {
        a = b;
        n = sz(a);
        t.resize(4 * n);
        prefSum.resize(4 * n);
        build(1, 0, n - 1);
    }

    int get(int v, int tl, int tr, int l, int r, int k) {
        if(tl > r || l > tr)
            return 0;

        if(l <= tl && tr <= r){
            if(sz(t[v]) == 0)
                return 0;
            
            int L = -1, R = sz(t[v]);
            while(L + 1 < R){
                int M = (L + R) / 2;
                if(t[v][M] >= k)
                    L = M;
                else
                    R = M;
            }

            if(L != -1)
                return prefSum[v][L] - k * (L + 1);
            return 0;
        }

        int tm = (tl + tr) / 2;
        return get(v * 2, tl, tm, l, r, k) + get(v * 2 + 1, tm + 1, tr, l, r, k);
    }

    int get(int l, int r, int k){
        if(l > r)
            return 0;
        return get(1, 0, n - 1, l, r, k);
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, q;
    cin >> n >> q;

    vector<pii > c(n);
    vector<int> vise(n);
    int sum = 0;

    for (int i = 0; i < n; ++i) {
        cin >> c[i].fi;
        c[i].se = i;
        sum += c[i].fi;
    }

    sort(all(c));

    for (int i = 0; i < n; ++i)
        vise[c[i].se] = i;

    vector<int> rz(n);
    rz[0] = c[0].fi;
    for (int i = 1; i < n; ++i)
        rz[i] = c[i].fi - c[i - 1].fi;

    Tree tree(rz);

    map<int, vector<pair<int, pii>>> qf;
    qf[inf].push_back({-1, {-1, -1}});

    for (int i = 0; i < q; ++i) {
        int t, k;
        cin >> t >> k;

        if (t == 1) {
            qf[k].push_back({t, {-1, i}});
        } else if (t == 2) {
            qf[k].push_back({t, {-1, i}});
        } else {
            int j;
            cin >> j;
            --j;
            qf[k].push_back({t, {j, i}});
        }
    }


    vector<int> res(q);
    map<int, vector<int>> die;

    for (int i = 1; i < n; ++i)
        die[rz[i]].push_back(i);
    die[inf].push_back(-1);

    int nz = n - 1;

    int k = 0, pnt = n * (n - 1) / 2, adt = 0;


    while (k < inf) {
        for (int i: die[k]) {
            nz--;
            pnt -= i;
        }

        for (auto &qq: qf[k]) {
            int t = qq.fi, j = qq.se.fi, id = qq.se.se;
            if (t == 1) {
                res[id] = nz + 1;
            } else if (t == 2) {
                res[id] = adt;
            } else {
                j = vise[j];
                int cur = rz[0];

                cur += tree.get(1, j, k);
//                for (int i = 1; i <= j; ++i)
//                    cur += max(0ll, rz[i] - k);
                res[id] = cur;
            }
        }

        int K1 = (*die.upper_bound(k)).fi;
        int K2 = (*qf.upper_bound(k)).fi;

        int nk = min(K1, K2);
        rz[0] += nz * (nk - k);
        adt += pnt * (nk - k);
        k = nk;
    }

    for (int i: res)
        cout << i << '\n';
}