﻿#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <queue>
#include <math.h>
using namespace std;

using s64 = long long;
using ld = long double;

#define all(obj) obj.begin(), obj.end()

s64 cast(string s) {
	reverse(all(s));
	ld n = 0;
	for (char c : s) {
		n *= 10;
		n += c - '0';
	}
	return n;
}

s64 epow(s64 a, s64 n) {
	if (n == 0) {
		return 1;
	}
	else {
		s64 z = epow(a, n / 2);
		z *= z;
		if (n & 1) {
			z *= a;
		}
		return z;
	}
}

void solve(istream& cin) {
	string s;
	cin >> s;
	reverse(all(s));
	int n = s.size();
	s64 y;
	cin >> y;

	auto f = [&](string s, int k) {
		for (int i = n - 1; i >= 0; i--) {
			// хотим поставить на место s[i] самую наибольшую цифру
			for (int d = 9; d > s[i] - '0'; d--) {
				int j;
				for (j = i - 1; j >= 0 && s[j] != d + '0'; j--) {}
				if (j != -1 && i - j <= k) {
					k -= i - j;
					while (j < i) {
						swap(s[j], s[j + 1]);
						j++;
					}
				}
			}
		}
		return s;
	};

	s64 ans = cast(s);
	string ans_str = s;

	s64 tl = -1, tr = 1e11;
	while (tl < tr - 1) {
		s64 tm = (tl + tr) / 2;

		if (cast(f(s, tm)) - y * tm <= cast(f(s, tm + 1)) - y * (tm + 1)) {
			tl = tm;
		}
		else {
			tr = tm;
		}
	}

	s = f(s, tr);
	reverse(all(s));
	cout << s << "\n";
}

int main() {
	//ifstream cin("input.txt");

	solve(cin);

	return 0;
}