﻿#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <queue>
#include <math.h>
using namespace std;

using s64 = long long;
using ld = long double;

#define all(obj) obj.begin(), obj.end()

vector<vector<int>> g;

vector<s64> dp;

// comp[dis][v] = номер компоненты, если запретить ходить в вершину dis
vector<vector<int>> comp;

void paint(int v, int color, int dis) {
	comp[dis][v] = color;
	for (int to : g[v]) {
		if (to != dis && comp[dis][to] == -1) {
			paint(to, color, dis);
		}
	}
}

void solve(istream& cin) {
	int n, m;
	{
		cin >> n >> m;
		g.assign(n, {});
		for (int i = 0; i < m; i++) {
			int u, v;
			cin >> u >> v;
			u--, v--;
			g[u].push_back(v);
			g[v].push_back(u);
		}

		dp.assign(n, -1);
		dp[0] = 0;
	}

	comp.assign(n, vector<int>(n, -1));
	for (int dis = 0; dis < n; dis++) {
		int color = 0;
		for (int v = 0; v < n; v++) {
			if (v != dis && comp[dis][v] == -1) {
				paint(v, color, dis);
				color++;
			}
		}
	}

	{
		queue<int> Q;
		Q.push(0);
		while (!Q.empty()) {
			int v = Q.front();
			Q.pop();

			for (int to : g[v]) {
				// поставить коробку в вершину to
				// нужно ее подобрать в какой-то вершине
				for (int to2 : g[to]) {
					// если можно дойти до to2 из v не посещая to
					if (dp[to2] == -1 && comp[to][v] == comp[to][to2]) {
						dp[to2] = dp[v] + 2;
						Q.push(to2);
					}
				}
			}
			
		}
	}

	for (int i = 1; i < n; i++) {
		cout << dp[i] << " ";
	}
	cout << "\n";
}

int main() {
	//ifstream cin("input.txt");

	int t;
	cin >> t;
	while (t--) {
		solve(cin);
	}

	return 0;
}