﻿#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <set>
#include <cmath>
#include <queue>
#include <math.h>
using namespace std;

using s64 = long long;
using ld = long double;

#define all(obj) obj.begin(), obj.end()

vector<set<int>> g;

vector<s64> dp;

void solve(istream& cin) {
	int n, m;
	{
		cin >> n >> m;
		g.assign(n, {});
		for (int i = 0; i < m; i++) {
			int u, v;
			cin >> u >> v;
			u--, v--;
			g[u].insert(v);
			g[v].insert(u);
		}

		dp.assign(n, -1);
		dp[0] = 0;
	}

	{
		queue<int> Q;
		Q.push(0);
		while (!Q.empty()) {
			int v = Q.front();
			Q.pop();

			for (int to : g[v]) {
				// поставить коробку в вершину to
				// нужно ее подобрать в какой-то вершине
				for (int to2 : g[to]) {
					// если можно дойти до to2 из v не посещая to
					if (dp[to2] == -1) {
						dp[to2] = dp[v] + 2;
						Q.push(to2);
					}
				}
			}

			for (int to : g[v]) {
				g[to].erase(v);
			}
			g[v].clear();
		}
	}

	for (int i = 1; i < n; i++) {
		cout << dp[i] << " ";
	}
	cout << "\n";
}

int main() {
	//ifstream cin("input.txt");

	int t;
	cin >> t;
	while (t--) {
		solve(cin);
	}

	return 0;
}