#include<algorithm>
#include<array>
#include<iostream>
#include<vector>

using namespace std;


struct DSU {
	vector<int> p;
	vector<int> left;
	vector<int> right;

	DSU(int n) : p(n, -1), left(n, 0), right(n, 0) {
		for (int i = 0; i < n; ++i) {
			left[i] = right[i] = i;
		}
	}

	int par(int pa) {
		if (p[pa] < 0) {
			return pa;
		}
		return p[pa] = par(p[pa]);
	}

	int siz(int pa) {
		return -p[par(pa)];
	}

	int lef(int pa) {
		return left[par(pa)];
	}
	int righ(int pa) {
		return right[par(pa)];
	}

	bool unite(int a, int b) {
		a = par(a);
		b = par(b);
		if (a == b) {
			return false;
		}

		if (p[a] < p[b]) {
			p[a] += p[b];
			right[a] = right[b];
			p[b] = a;
		}
		else {
			p[b] += p[a];
			left[b] = left[a];
			p[a] = b;
		}
		return true;
	}
};

struct BIT {
	vector<int> data;

	BIT(int n) : data(1 + n, 0) {}

	void qadd(int ind, int val) {
		++ind;
		for (; ind < data.size(); ind += ind & -ind) {
			data[ind] += val;
		}
	}

	int pref(int ind) {
		++ind; int res = 0;
		for (; ind > 0; ind -= ind & -ind) {
			res += data[ind];
		}
		return res;
	}
};

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, q; cin >> n >> q;
	vector<long long> c(n);
	vector<long long>a;
	for (int i = 0; i < n; ++i) {
		cin >> c[i]; a.push_back(c[i]);
	}
	sort(a.begin(), a.end());
	a.resize(unique(a.begin(), a.end()) - a.begin());

	vector<int> in(n);
	vector<int> cnt(a.size(), 0);
	for (int i = 0; i < n; ++i) {
		in[i] = lower_bound(a.begin(), a.end(), c[i]) - a.begin();
		++cnt[in[i]];
	}

	//sort(c.begin(), c.end());


	vector<pair<long long, int>> ch;
	for (int i = 0; i + 1 < a.size(); ++i) {
		ch.push_back({ a[i + 1] - a[i], i });
	}
	sort(ch.rbegin(), ch.rend());

	vector<long long> ans(q, 0);
	vector<array<long long, 4>> que(q);
	for (int i = 0; i < q; ++i) {
		cin >> que[i][1] >> que[i][0]; que[i][3] = i;
		if (que[i][1] == 3) {
			cin >> que[i][2]; --que[i][2];
		}
	}
	sort(que.begin(), que.end());

	int aa = (int)a.size();
	DSU dsu(a.size());
	BIT bit(a.size());
	for (int i = 0; i < a.size(); ++i) {
		bit.qadd(i, 1);
	}
	long long sum = 0;
	long long prev = 0;
	for (auto curr : que) {
		while (!ch.empty() && ch.back().first <= curr[0]) {

			for (int i = 0; i < n; ++i) {
				sum += 1LL * (ch.back().first - prev) * (1LL * aa - bit.pref(in[i]));
			}
			for (int i = 0; i < a.size(); ++i) {
				a[i] += 1LL * (ch.back().first - prev) * (1LL * aa - bit.pref(i));
			}

			prev = ch.back().first;

			bit.qadd(ch.back().second + 1, -1);
			dsu.unite(ch.back().second, ch.back().second + 1);

			ch.pop_back(); --aa;
		}
		if (curr[1] == 1)
			ans[curr[3]] = aa;
		else if(curr[1] == 2) {
			ans[curr[3]] = sum;
			for (int i = 0; i < n; ++i) {
				ans[curr[3]] += 1LL * (curr[0] - prev) * (1LL * aa - bit.pref(in[i]));
			}
		}
		else {
			long long lll = a[dsu.righ(in[curr[2]])];
			ans[curr[3]] = lll + 1LL * (curr[0] - prev) * (1LL * aa - bit.pref(in[curr[2]]));
		}
	}
	for (int i = 0; i < q; ++i) {
		cout << ans[i] << "\n";
	}

	/*long long K = a.back();
	vector<array<long long, 3>> que(q);
	vector<vector<int>> qq(1 + K);
	vector<long long> ans(q, 0);

	for (int i = 0; i < q; ++i) {
		cin >> que[i][0];
		if (que[i][0] == 3) {
			cin >> que[i][1] >> que[i][2]; --que[i][2];
			if (que[i][1] >= K) {
				qq[K].push_back(i);
			}
			else {
				qq[que[i][1]].push_back(i);
			}
		}
		else {
			cin >> que[i][1];
			if (que[i][1] >= K) {
				qq[K].push_back(i);
			}
			else {
				qq[que[i][1]].push_back(i);
			}
		}
	}

	long long sum = 0;
	for (int i = 0; i <= K; ++i) {
		while (!qq[i].empty()) {
			int curr = qq[i].back(); qq[i].pop_back();
			if (que[curr][0] == 1) {
				ans[curr] = a.size();
			}
			else if (que[curr][0] == 2) {
				ans[curr] = sum;
			}
			else {
				ans[curr] = a[ind[que[curr][2]]];
			}
		}

		for (int j = 0; j < a.size(); ++j) {
			a[j] += (int)a.size() - j - 1;
			sum += 1LL * cnt[j] * ((int)a.size() - j - 1);
		}

		for (int j = 0; j + 1 < a.size(); ++j) {
			while (j + 1 < (int)a.size() && a[j] == a[j + 1]) {
				for (int kk = 0; kk < n; ++kk) {
					if (ind[kk] >= j + 1) {
						--cnt[ind[kk]];
						--ind[kk];
						++cnt[ind[kk]];
					}
				}
				a.erase(a.begin() + j + 1);
			}
		}
	}

	for (int i = 0; i < q; ++i) {
		cout << ans[i] << "\n";
	}*/
}
