#include <iostream>
#include <algorithm>
#include <bitset>
#include <vector>
#include <string>
#include <cstring>
#include <array>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <cmath>
#include <random>
#include <chrono>
#define ar array
using namespace std;
typedef long long ll;
typedef long double ld;
const int N = 5e5 + 5;

int n, m, tin[N], tup[N], timer = 0, cut_up[N];
vector<int> g[N], ed;
bool br[N * 2], used[N], ins[N][2], cut[N];

void dfs_br(int v, int p=-1) {
	used[v] = 1;
	tin[v] = tup[v] = timer++;
	for (auto& i : g[v]) {
		int u = ed[i];
		if (u == p) continue;
		if (!used[u]) {
			dfs_br(u, v);
			tup[v] = min(tup[v], tup[u]);
			if (tin[v] < tup[u]) {
				br[i] = br[i ^ 1] = 1;
			}
		}
		else tup[v] = min(tup[v], tin[u]);
	}
}

void dfs_cut(int v, int p = -1) {
	used[v] = 1;
	tin[v] = tup[v] = timer++;
	for (auto& i : g[v]) {
		int u = ed[i];
		if (u == p || br[i]) continue;
		if (!used[u]) {
			dfs_cut(u, v);
			tup[v] = min(tup[v], tup[u]);
			if (tup[u] >= tin[v]) {
				cut[v] = 1;
			}
		}
		else tup[v] = min(tup[v], tin[u]);
	}
}

int cmp[N], cmp_cnt = 0;

void dfs(int v) {
	used[v] = 1;
	cmp[v] = cmp_cnt;
	for (auto& i : g[v]) {
		int u = ed[i];
		if (!br[i] && !used[u] && !cut[u]) {
			dfs(u);
		}
	}
}

int d[N][2], dd[N], prv[N][2];

void solve() {
	cin >> n >> m;
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		--u, --v;
		g[u].push_back(ed.size());
		ed.push_back(v);
		g[v].push_back(ed.size());
		ed.push_back(u);
	}
	dfs_br(0);
	fill(used, used + n, 0);
	timer = 0;
	dfs_cut(0);

	cut[0] = 0;
	fill(used, used + n, 0);
	fill(cmp, cmp + n, -1);
	for (int i = 0; i < n; ++i) {
		if (!used[i] && !cut[i]) {
			dfs(i);
			++cmp_cnt;
		}
	}
	for (int i = 0; i < n; ++i) {
		d[i][0] = d[i][1] = (int)2e9;
		prv[i][0] = prv[i][1] = -1;
	}
	d[0][0] = 0;
	prv[0][0] = cmp[0];
	set<ar<int, 3>> s;
	s.insert({ 0,0,0 });
	while (!s.empty()) {
		auto x = *s.begin();
		s.erase(s.begin());
		int v = x[1], t = x[2];
		ins[v][t] = 0;
		if (cut[v] && t == 1) {
			for (auto& i : g[v]) {
				int u = ed[i];
				if (br[i] || prv[v][t] != cmp[u]) continue;
				if (d[u][1 - t] > d[v][t] + 1) {
					d[u][1 - t] = d[v][t] + 1;
					prv[u][1 - t] = -1;
					if (ins[u][1 - t]) {
						s.erase({ d[u][1 - t],u,1 - t });
					}
					d[u][1 - t] = d[v][t] + 1;
					s.insert({ d[u][1 - t],u,1 - t });
					ins[u][1 - t] = 1;
				}
			}
		}
		else {
			for (auto& i : g[v]) {
				int u = ed[i];
				if (br[i]) continue;
				if (d[u][1 - t] > d[v][t] + 1) {
					d[u][1 - t] = d[v][t] + 1;
					prv[u][1 - t] = cmp[v];
					if (ins[u][1 - t]) {
						s.erase({ d[u][1 - t],u,1 - t });
					}
					d[u][1 - t] = d[v][t] + 1;
					s.insert({ d[u][1 - t],u,1 - t });
					ins[u][1 - t] = 1;
				}
			}
		}
	}
	for (int i = 1; i < n; ++i) {
		if (d[i][0] == (int)2e9) {
			cout << "-1 ";
		}
		else {
			cout << d[i][0] << " ";
		}
	}
}

void clear() {
	cmp_cnt = 0;
	fill(used, used + n, 0);
	fill(br, br + m * 2, 0);
	fill(cut, cut + n, 0);
	ed.clear();
	for (int i = 0; i < n; ++i) {
		g[i].clear();
	}
}
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int t = 1;
	cin >> t;
	while (t--) {
		solve();
		clear();
		cout << "\n";
	}
}
