#include<bits/stdc++.h>
using namespace std;

#define int long long
#define siz(a) (int)a.size()
#define all(a) a.begin(), a.end()
#define eb emplace_back
#define pii pair<int, int>
#define mp make_pair
#define fi first
#define se second

const int N = 5e5 + 3, inf = 1e15;

struct edge {
	int to, type;
	edge() {}
	edge(int to) : to(to) {}
	edge(int to, int type) : to(to), type(type) {}
};

int n, m;
vector<edge> ed;
vector<int> gr[N];
map<int, int> d[N];

int par[N], h[N];

int get(int v) {
	return par[v] == v ? v : par[v] = get(par[v]);
}

void unite(int v1, int v2) {
	v1 = get(v1);
	v2 = get(v2);
	par[v1] = v2;
}

bool used[N];

int dfs(int v, int pe = -1) {

	h[v] = (pe == -1 ? 0 : h[ed[pe].to]) + 1;
	//cout << "dfs " << v+1 << " " << h[v] << endl;

	int vmn = v;

	for (int e : gr[v]) {
		if (used[e/2]) continue;
		used[e/2] = true;
		auto [to, ty] = ed[e];
		if (h[to]) {
			if (h[to] < h[vmn]) vmn = to;

			//cout << "unite " << v+1 << " " << to+1 << " " << vmn << endl;
			unite(ty, ed[pe].type);

		} else {
			int oth = dfs(to, e^1);
			if (h[oth] < h[v]) {
				//cout << "unite " << v+1 << " " << to+1 << endl;
				unite(ty, ed[pe].type);
			} 
			if (h[oth] < h[vmn]) vmn = oth;
		}
	}
	//cout << "end " << v+1 << endl;
	return vmn;
}


void run() {
	cin >> n >> m;
	iota(par, par + m+1, 0);
	fill(h, h + n, 0);
	fill(used, used+m, 0);
	ed.clear();
	for (int i = 0; i < n; ++i) {
		gr[i].clear();
		d[i].clear();
	}
	for (int i = 0; i < m; ++i) {
		int v1, v2; cin >> v1 >> v2; --v1, --v2;
		gr[v1].eb(siz(ed));
		ed.eb(v2, i+1);
		gr[v2].eb(siz(ed));
		ed.eb(v1, i+1);
	}

	dfs(0);

	for (int i = 0; i < siz(ed); ++i) {
		ed[i].type = get(ed[i].type);
		//cout << ed[i].type << " ";
	}
	//cout << '\n';

	for (int i = 0; i < n; ++i) {
		d[i][0] = inf;
		for (int j : gr[i]) {
			d[i][ed[j].type] = inf;
		}
	}

	deque<pii> bfs = {mp(0, 0)};
	d[0][0] = 0;
	while (siz(bfs)) {
		auto [v, t] = bfs.front(); bfs.pop_front();
		for (int e : gr[v]) {
			auto [to, type] = ed[e];
			if ((t == 0 || t == type)) {
				if (t != 0) type = 0;
				if (d[to][type] == inf) {
					bfs.eb(to, type);
					d[to][type] = d[v][t] + 1;
				}
			}
		}
	}
	for (int i = 1; i < n; ++i) {
		cout << (d[i][0] == inf ? -1 : d[i][0]) << " ";	
	}
	cout << '\n';
}

signed main() {
	cin.tie(0), ios_base::sync_with_stdio(0);

	int t;
	cin >> t;
	while (t--) {
		run();	
	}
}