#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
//using namespace __gnu_pbds;
using namespace std;
#define int long long
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
//typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
mt19937_64 rnd(time(0));

struct edge {
    int a, b;
    int xr;
    bool brigde;

    edge(int s, int f) {
        a = s;
        b = f;
        xr = (a ^ b);
        brigde = false;
    }

    int get_to(int v) {
        return v ^ xr;
    }
};

const int maxn = 5e5;
const int inf = 1e18;
vector<edge *> g[maxn];
vector<int> new_graph[maxn * 2];
int tin[maxn];
int fup[maxn];
bool used[maxn];
bool ok[maxn];
int timer = 0;

void clear_used(int n) {
    for (int i = 0; i < n; ++i) {
        used[i] = false;
    }
}

void clear(int n) {
    clear_used(n);
    timer = 0;
    for (int i = 0; i < n; ++i) {
        ok[i] = false;
        fup[i] = 0;
        tin[i] = 0;
        g[i].clear();
    }
    for (int i = 0; i < n * 2; ++i) {
        new_graph[i].clear();
    }
}

void find_bridges(int v, int p) {
    tin[v] = timer++;
    fup[v] = tin[v];
    used[v] = true;
    for (int i = 0; i < g[v].size(); ++i) {
        int to = g[v][i]->get_to(v);
        if (to == p)continue;
        if (!used[to]) {
            find_bridges(to, v);
            fup[v] = min(fup[v], fup[to]);
        } else {
            fup[v] = min(fup[v], tin[to]);
        }
        if (fup[to] > tin[v]) {
            g[v][i]->brigde = true;
        }
    }
}

void make_comp(int v, int C) {
    used[v] = true;
    ok[v] = true;
    for (int i = 0; i < g[v].size(); ++i) {
        int to = g[v][i]->get_to(v);
        if (g[v][i]->brigde)continue;
        if (used[to]) {
            continue;
        }
        make_comp(to, C);
    }
}

vector<int> calc_dist(int s, int n) {
    vector<int> dist(n, inf);
    set<pair<int, int>> st;
    dist[s] = 0;
    st.insert({dist[s], s});
    while (st.size() > 0) {
        int v = st.begin()->second;
        st.erase(st.begin());
        for (int i = 0; i < new_graph[v].size(); ++i) {
            int to = new_graph[v][i];
            if (dist[to] > dist[v] + 1) {
                st.erase({dist[to], to});
                dist[to] = dist[v] + 1;
                st.insert({dist[to], to});
            }
        }
    }
    return dist;
}

signed main() {
    cin.tie();
    cout.tie();
    ios_base::sync_with_stdio(false);
#ifdef foo
    freopen("input.txt", "r", stdin);
#endif
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        clear(n);
        vector<edge *> all_edges;
        for (int i = 0; i < m; ++i) {
            int u, v;
            cin >> u >> v;
            u--;
            v--;
            all_edges.push_back(new edge(u, v));
            g[u].push_back(all_edges.back());
            g[v].push_back(all_edges.back());
        }
        for (int i = 0; i < n; ++i) {
            if (used[i])continue;
            find_bridges(i, -1);
        }
        clear_used(n);
        make_comp(0, -1);
        clear_used(n);
        for (auto ed: all_edges) {
            int a = ed->a;
            int b = ed->b;
            if (!ok[a])continue;
            if (!ok[b])continue;
            new_graph[a * 2].push_back(b * 2 + 1);
            new_graph[a * 2 + 1].push_back(b * 2);
            new_graph[b * 2 + 1].push_back(a * 2);
            new_graph[b * 2].push_back(a * 2 + 1);
        }
        vector<int> d0 = calc_dist(0, n * 2);
        vector<int> d1 = calc_dist(1, n * 2);
        vector<int> ans(n, inf);
        for (int i = 1; i < n; ++i) {
            ans[i] = min(ans[i], d0[i * 2]);
            ans[i] = min(ans[i], d1[i * 2 + 1]);
        }
        for (int i = 1; i < n; ++i) {
            if (ans[i] == inf)ans[i] = -1;
            cout << ans[i] << " ";
        }
        cout << "\n";
    }
}
