//#define _CRT_SECURE_NO_WARNINGS
//#pragma GCC target ("avx,avx2,sse,sse2,sse3,sse4,fma,popcnt")
//#pragma GCC optimize ("-Ofast,unroll-loops,fast-math")
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <sstream>
#include <random>
#include <map>
#include <array>

using namespace std;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

const long long INF = 4e18;
mt19937 gen(0);

struct node {
	long long x, sm;
	int y, cnt, sz;
	node* left, * right;
	node(long long val) {
		x = sm = val;
		sz = cnt = 1;
		y = gen();
		left = right = nullptr;
	}
};

long long get_sm(node* u) {
	return u == nullptr ? 0 : u->sm;
}

int get_sz(node* u) {
	return u == nullptr ? 0 : u->sz;
}

void update(node* u) {
	u->sm = u->x * u->cnt + get_sm(u->left) + get_sm(u->right);
	u->sz = u->cnt + get_sz(u->left) + get_sz(u->right);
}

node* merge(node* u, node* v) {
	if (u == nullptr)
		return v;
	if (v == nullptr)
		return u;
	if (u->y < v->y) {
		u->right = merge(u->right, v);
		update(u);
		return u;
	}
	else {
		v->left = merge(u, v->left);
		update(v);
		return v;
	}
}

pair<node*, node*> split(node* u, int val) {
	if (u == nullptr)
		return { nullptr, nullptr };
	if (u->x >= val) {
		auto [l, r] = split(u->left, val);
		u->left = r;
		update(u);
		return { l, u };
	}
	else {
		auto [l, r] = split(u->right, val);
		u->right = l;
		update(u);
		return { u, r };
	}
}

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, q;
	cin >> n >> q;
	vector<long long> a(n);
	vector<pair<long long, int>> hah(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		hah[i] = { a[i], i };
	}
	sort(all(hah));
	vector<long long> q1;
	q1.reserve(n - 1);
	int beg = n;
	for (int i = 0; i < n - 1; ++i) {
		if (hah[i].first == hah[i + 1].first)
			beg--;
		else
			q1.push_back(hah[i + 1].first - hah[i].first);
	}
	sort(all(q1));

	map<long long, vector<int>> m;
	int cnt = beg - 1;
	long long st = 0;
	for (int i = 0; i < n - 1; ++i) {
		st += cnt;
		if (hah[i].first != hah[i + 1].first) {
			cnt--;
			m[hah[i + 1].first - hah[i].first].push_back(i);
		}
	}
	vector<array<long long, 3>> q2 = { {0, 0, st} }; //proshlo, summ, change
	q2.reserve(m.size() + 1);
	for (auto& [d, v] : m) {
		long long sm = q2.back()[1] + q2.back()[2] * (d - q2.back()[0]);
		for (auto i : v)
			st -= i + 1;
		q2.push_back({ d, sm, st });
	}

	map<long long, int> ok;
	for (auto i : a)
		ok[i] = 0;
	cnt = 0;
	for (auto it = ok.begin(); it != ok.end(); ++it)
		it->second = cnt++;
	vector<int> whr(n);
	vector<long long> heh(cnt);
	for (int i = 0; i < n; ++i) {
		whr[i] = ok[a[i]];
		heh[ok[a[i]]] = a[i];
	}

	vector<long long> ans(q);
	vector<array<long long, 3>> qr;
	qr.reserve(q);
	for (int i = 0; i < q; ++i) {
		int t;
		long long k;
		cin >> t >> k;
		if (t == 1) {
			ans[i] = beg - (upper_bound(all(q1), k) - q1.begin());
		}
		else if (t == 2) {
			auto it = upper_bound(all(q2), array<long long, 3>{ k, INF, INF });
			it--;
			ans[i] = (*it)[1] + (k - (*it)[0]) * (*it)[2];
		}
		else {
			int ind;
			cin >> ind;
			--ind;
			qr.push_back({ whr[ind], k, i });
		}
	}

	sort(all(qr));
	node* root = nullptr;
	for (int i = 0; i < heh.size() - 1; ++i) {
		long long temp = heh[i + 1] - heh[i];
		auto [l, tr] = split(root, temp);
		auto [x, r] = split(tr, temp + 1);
		if (x != nullptr) {
			x->cnt++;
			update(x);
		}
		else
			x = new node(temp);
		root = merge(merge(l, x), r);
	}
	int nw = 0;
	for (auto [fr, to, ind] : qr) {
		while (nw < fr) {
			long long temp = heh[nw + 1] - heh[nw];
			nw++;
			auto [l, tr] = split(root, temp);
			auto [x, r] = split(tr, temp + 1);
			if (x->cnt == 1)
				root = merge(l, r);
			else {
				x->cnt--;
				update(x);
				root = merge(l, merge(x, r));
			}
		}
		if (to == 0) {
			ans[ind] = heh[fr];
			continue;
		}
		auto [l, r] = split(root, to);
		ans[ind] = heh[fr] + (heh.size() - fr - 1) * to - to * get_sz(l) + get_sm(l);
		root = merge(l, r);
	}
	for (auto i : ans)
		cout << i << '\n';
}
