//#define _CRT_SECURE_NO_WARNINGS
//#pragma GCC target ("avx,avx2,sse,sse2,sse3,sse4,fma,popcnt")
//#pragma GCC optimize ("-Ofast,unroll-loops,fast-math")
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <sstream>
#include <random>
#include <map>
#include <array>

using namespace std;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

const int INF = 2e9;
vector<vector<int>> gr, d;

void dfs(int u, int ban, int clr) {
	d[ban][u] = clr;
	for (int v : gr[u])
		if (d[ban][v] == -1 && v != ban) {
			dfs(v, ban, clr);
		}
}

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int t;
	cin >> t;
	while (t--) {
		int n, m;
		cin >> n >> m;
		gr.assign(n, {});
		for (int i = 0; i < m; ++i) {
			int u, v;
			cin >> u >> v;
			--u, --v;
			gr[u].push_back(v);
			gr[v].push_back(u);
		}
		/*d.assign(n, vector<int>(n, -1));
		for (int i = 0; i < n; ++i) {
			int clr = 0;
			for (int j = 0; j < n; ++j) {
				if (i == j || d[i][j] != -1)
					continue;
				dfs(j, i, clr++);
			}
		}*/
		vector<int> up(n, INF), used(2 * n);
		vector<pair<int, int>> dwn(n, { INF, -1 });
		up[0] = 0;
		for (int i = 0; i < 2 * n; ++i) {
			int u1 = -1, u2 = -1;
			for (int v = 0; v < n; ++v)
				if (!used[v] && (u1 == -1 || up[u1] > up[v]))
					u1 = v;
			for (int v = 0; v < n; ++v)
				if (!used[v + n] && (u2 == -1 || dwn[u2].first > dwn[v].first))
					u2 = v;
			if ((u1 == -1 || up[u1] == INF) && (u2 == -1 || dwn[u2].first == INF))
				break;
			if (u2 == -1 || dwn[u2].first == INF || u1 != -1 && up[u1] <= dwn[u2].first) {
				used[u1] = 1;
				for (int v : gr[u1])
					if (dwn[v].first > up[u1] + 1) {
						dwn[v] = { up[u1] + 1, u1 };
					}
			}
			else {
				used[u2 + n] = 1;
				for (int v : gr[u2])
					if (up[v] > dwn[u2].first + 1)
						up[v] = dwn[u2].first + 1;
			}
		}
		for (int i = 1; i < n; ++i) {
			if (up[i] == INF)
				cout << "-1 ";
			else
				cout << up[i] << ' ';
		}
		cout << '\n';
	}
}
