#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <iomanip>
#include <set>
#include <map>
#include <queue>


using namespace std;
#define int long long
#define ld long double
#define debug(x) cout << #x << " is " << x << '\n';

const int mod = 1e9 + 7;

struct Fenwick {
	vector <int> tree;
	Fenwick(int n) {
		tree.resize(n);
	}
};

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout << fixed << setprecision(6);
	
	int n, q; cin >> n >> q;
	vector <int> a(n);
	for (auto& x : a) cin >> x;
	vector <int> ds;
	sort(a.begin(), a.end());
	for (int i = 1; i < n; ++i)
		ds.push_back(a[i] - a[i - 1]);
	sort(ds.begin(), ds.end());
	vector <pair <int, int>> ds2;
	for (int i = 1; i < n; ++i) {
		ds2.push_back({ a[i] - a[i - 1], i });
	}
	sort(ds2.begin(), ds2.end());
	vector <int> cur(n);
	for (int i = 0; i < n; ++i)
		cur[i] = n - 1 - i;
	vector <int> tim, sum, had;
	tim.push_back(0);
	had.push_back(0);
	sum.push_back(n * (n - 1) / 2);
	for (auto& x : ds2) {
		had.push_back(had.back() + (x.first - tim.back()) * sum.back());
		tim.push_back(x.first);
		sum.push_back(sum.back() - x.second);
	}

	while (q--) {
		int typ; cin >> typ;
		if (typ == 1) {
			int k; cin >> k;
			int id = upper_bound(ds.begin(), ds.end(), k) - ds.begin();
			cout << n - id << '\n';
		}
		else if (typ == 2) {
			int k; cin >> k;
			int id = upper_bound(tim.begin(), tim.end(), k) - tim.begin() - 1;
			cout << had[id] + sum[id] * (k - tim[id]) << '\n';
		}
		else if (typ == 3) {
			int k, i; cin >> k >> i;
		}
	}

}