#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve();

int main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int t = 1;
    cin >> t;
    do {
        solve();
    } while (--t);
    return 0;
}

struct edge {
    int u, v, i;

    edge(int u, int v, int i) : u(u), v(v), i(i) {}

    int get(int x) { return v + u - x; }

    edge() = default;
};

struct dsu {
    int n;
    vector<int> p, sz;

    explicit dsu(int n) : n(n), p(n), sz(n, 1) { iota(p.begin(), p.end(), 0); }

    int get(int x) { return x == p[x] ? x : p[x] = get(p[x]); }

    bool unite(int u, int v) {
        u = get(u), v = get(v);
        if (u == v) return false;
        if (sz[u] > sz[v]) swap(u, v);
        p[u] = v;
        sz[v] += sz[u];
        return true;
    }
};

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> g(n);
    vector<edge> es(2 * m);
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        es[2 * i] = edge(u, v, 2 * i);
        es[2 * i + 1] = edge(v, u, 2 * i + 1);
        g[u].emplace_back(2 * i);
        g[v].emplace_back(2 * i + 1);
    }
    dsu esu(2 * m);
    vector<int> depth(n), parentEdge(n);
    vector<bool> used(n);
    auto init = [&](auto init, int cur, int prev) -> void {
        if (used[cur]) return;
        used[cur] = true;
        for (int e: g[cur]) {
            int next = es[e].get(cur);
            if (next == prev) {
                parentEdge[cur] = e;
            } else {
                depth[next] = depth[cur] + 1;
                init(init, next, cur);
            }
        }
    };
    init(init, 0, 0);
    vector<int> fup(n);
    vector<int> stack;
    fill(used.begin(), used.end(), false);
    auto dfs = [&](auto dfs, int cur) -> void {
        if (used[cur]) return;
        used[cur] = true;
        stack.push_back(cur);
        for (int e: g[cur]) {
            if (e == parentEdge[cur]) continue;
            int next = es[e].get(cur);
            if (depth[next] == depth[cur] + 1) {
                dfs(dfs, next);
                fup[cur] = min(fup[cur], fup[next]);
            } else if (depth[next] < depth[cur]) {
                fup[cur] = min(fup[cur], depth[next]);
            }
        }
        for (int e: g[cur]) {
            if (e == parentEdge[cur]) continue;
            int next = es[e].get(cur);
            if (depth[next] == depth[cur] + 1) {
                if (fup[next] < depth[cur]) {
                    esu.unite(parentEdge[cur], e);
                }
            } else if (depth[next] < depth[cur]) {
                esu.unite(e, parentEdge[cur]);
                int alpha = stack[depth[next] + 1];
                esu.unite(parentEdge[alpha] ^ 1, e ^ 1);
            }
        }
        stack.pop_back();
    };
    dfs(dfs, 0);
    for (int i = 0; i < esu.n; ++i) {
        cout << i << ": ";
        for (int j = 0; j < 2 * m; ++j) {
            if (esu.get(j) == i) {
                cout << es[j].u << ' ' << es[j].v << '\n';
            }
        }
        cout << "\n\n";
    }
}