#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve();

int main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int t = 1;
    cin >> t;
    do {
        solve();
    } while (--t);
    return 0;
}

struct bot {
    int l, r, c, t;

    bot(int l, int r, int c, int t) : l(l), r(r), c(c), t(t) {}

    bot() = default;

    bool operator<(bot other) const {
        return pair{r, l} < pair{other.r, other.l};
    }
};

vector<bot> modify(vector<bot> v, int x) {
    vector<bot> res;
    for (auto b: v) {
        if (b.t == 1) {
            b.l = min(b.l, x);
            b.r = max(b.r, x + 1);
        }
        res.push_back(b);
    }
    return res;
}

ll solve(vector<bot> &bots, vector<int> &a) {
    vector<vector<int>> grouped(a.size());
    for (int i = 0; i < bots.size(); ++i) {
        grouped[bots[i].l].push_back(i);
    }
    auto cmp = [&](int i, int j) { return bots[i].r < bots[j].r; };
    multiset<int, decltype(cmp)> cur(cmp);
    ll ans = 0;
    for (int i = 0; i < a.size(); ++i) {
        cur.insert(grouped[i].begin(), grouped[i].end());
        while (!cur.empty()) {
            auto bot = *cur.begin();
            cur.erase(cur.begin());
            if (bots[bot].r < i) continue;
            int surplus = min(bots[bot].c, a[i]);
            ans += surplus;
            bots[bot].c -= surplus;
            a[i] -= surplus;
            if (bots[bot].c) cur.emplace(bot);
            if (a[i] == 0) break;
        }
    }
    return ans;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    for (int &x: a) cin >> x;
    vector<bot> bots(m);
    for (auto &[l, r, c, t]: bots) cin >> l >> r >> c >> t;
    for (auto &[l, r, c, t]: bots) --l, --r;
    ll already = solve(bots, a);
    vector<ll> pts(n);
    vector<vector<bot>> byL(n), byR(n);
    ll surplus = 0;
    for (auto bot: bots) {
        if (bot.l == bot.r) pts[bot.l] += bot.c;
        surplus += bot.c;
        byL[bot.l].push_back(bot);
        byR[bot.r].push_back(bot);
    }
    vector<ll> p1(n), dp1(n), p2(n + 1), dp2(n + 1);
    for (int i = 0; i < n; ++i) {
        if (i) p1[i] = p1[i - 1];
        for (auto bot: byL[i]) {
            p1[i] += bot.c;
        }
        dp1[i] = min((ll) a[i], p1[i]) + (i ? dp1[i - 1] : 0);
        p1[i] -= dp1[i];
    }
    for (int i = n - 1; i >= 0; --i) {
        p2[i] = p2[i + 1];
        for (auto bot: byR[i]) {
            p2[i] += bot.c;
        }
        dp2[i] = min((ll) a[i], p2[i]) + dp2[i + 1];
        p2[i] -= dp2[i];
    }
    for (int x = 0; x < n; ++x) {
        cout << already + (x ? dp1[x - 1] : 0) + dp2[x + 1] + min((ll) a[x], (x ? p1[x - 1] : 0) + pts[x] + p2[x + 1])
             << ' ';
    }
    cout << '\n';
}

