#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
#define vi vector<int>

void dfs(int v, vi &can_reach, int timer, int extra, vector<vi > &adj) {
    can_reach[v] = timer;
    for (int u: adj[v]) {
        if (can_reach[u] == timer)continue;
        if (u == extra) continue;
        dfs(u, can_reach, timer, extra, adj);
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> can_reach(n + 1, -1);
    int timer = 0;
    vector<vector<int>> adj(n + 1);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        adj[a].push_back(b);
        adj[b].push_back(a);
    }

    set<pair<int, int>> q;
    q.insert({0, 1});
    vector<int> dp(n + 1, 1e9);
    dp[1] = 0;

    while (!q.empty()) {
        int v = q.begin()->second;
        q.erase(q.begin());
        for (int u: adj[v]) {
            timer++;
            dfs(v, can_reach, timer, u, adj);
            for (int other_v: adj[u]) {
                if (can_reach[other_v] != timer) continue;
                int d = dp[v] + 2;
                if (dp[other_v] > d) {
                    q.erase({dp[other_v], other_v});
                    dp[other_v] = d;
                    q.insert({dp[other_v], other_v});
                }
            }
        }
    }

    for (int i = 2; i <= n; i++) {
        if (dp[i] == 1e9) cout << -1 << ' ';
        else cout << dp[i] << ' ';
    }
    cout << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.precision(20);
    int tests = 1;
    cin >> tests;
    while (tests--) {
        solve();
    }
}