#include <bits/stdc++.h>
using namespace std;

#define all(x) begin(x), end(x)
#define sz(x) ((int) (x).size())
#define x first
#define y second
using ll = long long;
using ld = long double;

const int N = 5e5 + 10, INF = 0x3f3f3f3f;

struct Edge {
	int v, cc, i;
};

vector<Edge> g[N];
int depth[N], up[N];
char cutpoint[N];

void dfs(int u = 0, int d = 0, int p = -1) {
	int children = 0;
	up[u] = depth[u] = d;
	for (auto e : g[u]) {
		int v = e.v;
		if (depth[v] == -1) {
			++children;
			dfs(v, d + 1, u);
			up[u] = min(up[u], up[v]);
			if (up[v] >= d && p != -1) {
				cutpoint[u] = 1;
			}
		} else {
			up[u] = min(up[u], depth[v]);
		}
	}
	if (p == -1 && children > 1) {
		cutpoint[u] = 1;
	}
}

int next_cc;

void dfs_color(int u = 0, int p = -1, int cc = 0) {
	for (auto &[v, color, i] : g[u]) {
		if (v == p) {
			color = cc;
		} else if (depth[v] == depth[u] + 1) {
			if (cutpoint[u] && up[v] == depth[u]) {
				color = next_cc++;
			} else {
				color = cc;
			}
			dfs_color(v, u, color);
		} else if (depth[v] < depth[u]) {
			color = cc;
			g[v][i].cc = cc;
			continue;
		}
	}
}

vector<int> colors[N];
int pref[N];

int dst[4 * N];

signed main() {
	cin.tie(0)->sync_with_stdio(0);
	int testcases;
	cin >> testcases;
	while (testcases--) {
		int n, m;
		cin >> n >> m;
		for (int i = 0; i < n; ++i) {
			g[i].clear();
		}
		fill(depth, depth + n, -1);
		fill(cutpoint, cutpoint + n, 0);
		next_cc = 1;
		for (int i = 0; i < m; ++i) {
			int u, v;
			cin >> u >> v;
			--u, --v;
			g[u].push_back({v, 0, sz(g[v])});
			g[v].push_back({u, 0, sz(g[u]) - 1});
		}
		dfs();
		dfs_color();

		for (int i = 0; i < n; ++i) {
			colors[i].clear();
			if (cutpoint[i]) {
				for (auto [v, cc, _] : g[i]) {
					colors[i].push_back(cc);
				}
				sort(all(colors[i]));
				colors[i].resize(unique(all(colors[i])) - begin(colors[i]));
			}
			pref[i + 1] = pref[i] + sz(colors[i]);
		}

		fill(dst, dst + 4 * n, +INF);
		dst[0] = 0;
		deque<int> bfs;
		bfs.push_back(0);
		while (sz(bfs)) {
			auto u = bfs.front();
			bfs.pop_front();
			// cout << "at " << u << endl;

			if (u < n) {
				for (auto [v, cc, _2] : g[u]) {
					int w = n + v;
					if (cutpoint[v]) {
						w = 2 * n + pref[v] + int(lower_bound(all(colors[v]), cc) - begin(colors[v]));
						// cout << v << " " << cc << " " << w << endl;
					}
					if (dst[w] > dst[u] + 1) {
						dst[w] = dst[u] + 1;
						bfs.push_back(w);
					}
				}
			} else if (u < 2 * n) {
				for (auto [v, cc, _2] : g[u - n]) {
					if (dst[v] > dst[u] + 1) {
						dst[v] = dst[u] + 1;
						bfs.push_back(v);
					}
				}
			} else {
				int box_v = int(upper_bound(pref, pref + n, u - 2 * n) - pref) - 1;
				// cout << box_v << " " << colors[box_v][u - 2 * n - pref[box_v]] << endl;
				int our_color = colors[box_v][u - 2 * n - pref[box_v]];
				for (auto [v, cc, _2] : g[box_v]) {
					if (cc == our_color && dst[v] > dst[u] + 1) {
						// cout << "opt for " << v << endl;
						dst[v] = dst[u] + 1;
						bfs.push_back(v);
					}
				}
			}
		}

		for (int i = 1; i < n; ++i) {
			if (dst[i] == +INF) {
				cout << "-1 ";
			} else {
				cout << dst[i] << " ";
			}
		}
		cout << "\n";


		// for (int i = 0; i < n; ++i) {
		// 	fill(dst[i], dst[i] + n, +INF);
		// }
		// dst[0][0] = 0;
		// deque<pair<int, int>> bfs;
		// bfs.push_back({0, 0});
		// while (sz(bfs)) {
		// 	auto [u, w] = bfs.front();
		// 	bfs.pop_front();
		// 	if (u == w) {
		// 		for (int v : g[u]) {
		// 			if (dst[u][v] > dst[u][w] + 1) {
		// 				dst[u][v] = dst[u][w] + 1;
		// 				bfs.push_back({u, v});
		// 			}
		// 		}
		// 	} else {
		// 		for (int v : g[u]) {
		// 			if (v != w) {
		// 				if (dst[v][w] > dst[u][w]) {
		// 					dst[v][w] = dst[u][w];
		// 					bfs.push_front({v, w});
		// 				}
		// 			} else {
		// 				if (dst[u][u] > dst[u][w] + 1) {
		// 					dst[u][u] = dst[u][w] + 1;
		// 					bfs.push_back({u, u});
		// 				}
		// 			}
		// 		}
		// 	}
		// }
		// for (int i = 1; i < n; ++i) {
		// 	if (dst[i][i] == +INF) {
		// 		cout << "-1 ";
		// 	} else {
		// 		cout << dst[i][i] << " ";
		// 	}
		// }
		// cout << "\n";
	}
}