#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

#define v vector
#define int long long
#define ll __int128
#define len(a) (int)a.size()
#define all(a) a.begin(), a.end()

const int INF = 1e17;

int n, q;
v<int> c, pos;

struct ask {
    int tp, tm, id, i;
    ask(int tp, int tm, int id, int i): tp(tp), tm(tm), id(id), i(i) {}
};

v<ask> lst;

struct seg {
    int l, r, val;
    seg(int l, int r, int val): l(l), r(r), val(val) {}
};

int get_sum(v<int> &item) {
    int sm = 0;
    for (auto j : item) {
        sm += j;
    }
    return sm;
}

int fnd(v<seg> &item, int index) {
    int L = -1, R = len(item);
    while (R - L > 1) {
        int M = ((L + R) >> 1);
        if (item[M].r >= index) {
            R = M;
        } else {
            L = M;
        }
    }
    return R;
}

void zp(v<seg> &s, v<int> &cur) {
    s.clear();
    int last = 0;
    for (int i = 1; i < len(cur); i++) {
        if (cur[i] == cur[i - 1]) continue;
        s.push_back(seg(last, i - 1, cur[i - 1]));
        last = i;
    }
    s.push_back(seg(last, len(cur) - 1, cur.back()));
}
signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> q;
    c.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> c[i];
    }

    for (int i = 0; i < q; i++) {
        int tp, k, I = 1;
        cin >> tp >> k;
        if (tp == 3) cin >> I;
        I--;
        lst.push_back(ask(tp, k, i, I));
    }

    sort(all(lst), [&](ask A, ask B) {
        return A.tm < B.tm;
    });

    v<pair<int, int>> a;
    for (int i = 0; i < n; i++) {
        a.push_back({c[i], i});
    }
    sort(all(a));
    pos.resize(n);
    for (int i = 0; i < n; i++) {
        pos[a[i].second] = i;
    }

    v<seg> s;
    for (int i = 0; i < n; i++) {
        s.push_back(seg(i, i, a[i].first));
    }

    v<int> cur(n);
    for (int i = 0; i < n; i++) cur[i] = a[i].first;
    int T = 0;
    int iter = 0;
    v<int> ans(q, -1);
    while (len(s) > 1) {
        int d = INF;
        for (int i = 1; i < len(s); i++) {
            d = min(d, s[i].val - s[i - 1].val);
        }

        int rate = 0;
        for (int i = 0; i < len(s); i++) {
            rate += (len(s) - 1 - i) * (s[i].r - s[i].l + 1);
        }

        while (iter < q && lst[iter].tm < T + d) {
            auto [tp, tm, id, i] = lst[iter];
            if (tp == 1) {
                //cout << len(s) << "\n";
                ans[id] = len(s);
            } else if (tp == 2) {
                int res = get_sum(cur) + rate * (tm - T) - get_sum(c);
                //cout << res << "\n";
                ans[id] = res;
            } else {
                int index = fnd(s, pos[i]);
                int res = cur[pos[i]] += (len(s) - 1 - index) * (tm - T);
                ///cout << res << "\n";
                ans[id] = res;
            }

            iter++;
        }

        for (int i = len(s) - 1; i >= 0; i--) {
            s[i].val += (len(s) - 1 - i) * d;
            for (int j = s[i].l; j <= s[i].r; j++) {
                cur[j] = s[i].val;
            }
        }
        zp(s, cur);

        T = T + d;
    }

    int rate = 0;
    for (int i = 0; i < len(s); i++) {
        rate += (len(s) - 1 - i) * (s[i].r - s[i].l + 1);
    }
    while (iter < q) {
        auto [tp, tm, id, i] = lst[iter];
        if (tp == 1) {
            //cout << len(s) << "\n";
            ans[id] = len(s);
        } else if (tp == 2) {
            int res = get_sum(cur) + rate * (tm - T) - get_sum(c);
            //cout << res << "\n";
            ans[id] = res;
        } else {
            int index = fnd(s, pos[i]);
            int res = cur[pos[i]] += (len(s) - 1 - index) * (tm - T);
            ///cout << res << "\n";
            ans[id] = res;
        }

        iter++;
    }

    for (auto j : ans) {
        cout << j << "\n";
    }
    return 0;
}
