#include<bits/stdc++.h>

#define fi first
#define se second
#define mp make_pair
#define sz(v) (int) v.size()
#define all(v) v.begin(), v.end()

using namespace std;

typedef long long int64;
typedef long double float64;
typedef pair<int, int> pii;

const int N = 3e5 + 5, Q = 3e5 + 5;

struct Query {
    int t, i;
    int64 k;

    Query() {}

    friend istream & operator >> (istream &in, Query &que) {
        in >> que.t >> que.k;
        if (que.t == 3) in >> que.i;
        return in;
    }
};

struct DSU {
    int *p, *sz;
    int64 *value;

    DSU() {}

    DSU(int n) {
        p = new int[n + 1];
        iota(p, p + n + 1, 0);
        sz = new int[n + 1];
        fill(sz, sz + n + 1, 1);
        value = new int64[n + 1];
        fill(value, value + n + 1, 0);
    }

    int get(int v) {
        return v == p[v] ? p[v] : p[v] = get(p[v]);
    }

    int unite(int v, int u) {
        v = get(v); u = get(u);
        if (v == u) return v;
        if (sz[v] < sz[u]) swap(v, u);
        sz[v] += sz[u];
        p[u] = v;
        return v;
    }
};

int n, q;
pair<int64, int> c[N];
Query queries[Q];

void read() {
    cin >> n >> q;
    for (int i = 1; i <= n; ++i) {
        cin >> c[i].fi;
        c[i].se = i;
    }
    for (int i = 1; i <= q; ++i) {
        cin >> queries[i];
    }
}

void unite_groups(vector<int> &kings, DSU &dsu) {
    vector<int> new_kings;
    int i = 0;
    while (i < sz(kings)) {
        int j = i, cnt = 0, gking = kings[i];
        while (j < sz(kings) && dsu.value[gking] == dsu.value[kings[j]]) {
            gking = dsu.unite(kings[i], kings[j]);
            ++j;
        }
        i = j;
        new_kings.emplace_back(gking);
    }
    kings.swap(new_kings);
}

int64 ans[Q];

void solve() {
    DSU dsu(n);
    sort(c + 1, c + n + 1);
    vector<int> kings;
    for (int i = 1; i <= n; ++i) {
        kings.emplace_back(c[i].se);
        dsu.value[c[i].se] = c[i].fi;
        dsu.p[c[i].se] = c[i].se;
    }
    unite_groups(kings, dsu);
    vector<pair<int64, int>> que;
    for (int i = 1; i <= q; ++i) {
        que.emplace_back(queries[i].k, i);
    }
    sort(all(que));
    int64 curr_round = 0, sum = 0;
    int ptr = 0;
    while (ptr < sz(que)) {
        int64 go = que[ptr].fi - curr_round;
        for (int i = 1; i < sz(kings); ++i) {
            go = min(go, dsu.value[kings[i]] - dsu.value[kings[i - 1]]);
        }
        for (int i = 0; i < sz(kings); ++i) {
            int64 add = go * (sz(kings) - i - 1);
            dsu.value[kings[i]] += add;
            sum += add * dsu.sz[kings[i]];
        }
        unite_groups(kings, dsu);
        curr_round += go;
        while (ptr < sz(que) && que[ptr].fi == curr_round) {
            int i = que[ptr].se;
            if (queries[i].t == 1) {
                ans[que[ptr].se] = sz(kings);
            } else if (queries[i].t == 2) {
                ans[que[ptr].se] = sum;
            } else {
                ans[que[ptr].se] = dsu.value[dsu.get(queries[i].i)];
            }
            ++ptr;
        }
    }
}

void write() {
    for (int i = 1; i <= q; ++i) {
        cout << ans[i] << "\n";
    }
}

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    read();
    solve();
    write();
    return 0;
}