#include<bits/stdc++.h>

#define fi first
#define se second
#define mp make_pair
#define sz(v) (int) v.size()
#define all(v) v.beign(), v.end()

using namespace std;

typedef long long int64;
typedef long double float64;
typedef pair<int, int> pii;

const int inf = 1e9;
const int N = 5e5 + 5, M = 5e5 + 5;

struct DSU {
    int *p, *sz;
    int64 *value;

    DSU() {}

    DSU(int n) {
        p = new int[n + 1];
        iota(p, p + n + 1, 0);
        sz = new int[n + 1];
        fill(sz, sz + n + 1, 1);
    }

    int get(int v) {
        return v == p[v] ? p[v] : p[v] = get(p[v]);
    }

    bool unite(int v, int u) {
        v = get(v); u = get(u);
        if (v == u) return false;
        if (sz[v] < sz[u]) swap(v, u);
        sz[v] += sz[u];
        p[u] = v;
        return true;
    }
};

int n, m;
pii edges[M];
vector<pii> g[N];
//bitset<N> G[N];
int tin[N], tup[N], tout[N], timer;
bool is_point[N];
int color[M];
bool used[N];
int dp[N];
pii from[N];

void read() {
    cin >> n >> m;
    for (int v = 1; v <= n; ++v) {
        g[v].clear();
        tin[v] = 0;
        tup[v] = 0;
        tout[v] = 0;
        is_point[v] = false;
        dp[v] = inf;
        used[v] = false;
        from[v] = mp(0, 0);
//        G[v].reset();
    }
    timer = 1;
    for (int i = 1; i <= m; ++i) {
        color[i] = 0;
    }
    for (int i = 1; i <= m; ++i) {
        int v, u;
        cin >> v >> u;
//        G[v][u] = true;
//        G[u][v] = true;
        g[v].emplace_back(u, i);
        g[u].emplace_back(v, i);
        edges[i] = mp(v, u);
    }
}

void find_points(int v, int p = 0) {
    tin[v] = timer++;
    tup[v] = tin[v];
    int cnt = 0;
    for (pii &edge : g[v]) {
        int u = edge.fi, i = edge.se;
        if (u == p) continue;
        if (!tin[u]) {
            ++cnt;
            find_points(u, v);
            tup[v] = min(tup[v], tup[u]);
            if (tup[u] >= tin[v]) {
                is_point[v] = true;
            }
        } else {
            tup[v] = min(tup[v], tin[u]);
        }
    }
    if (!p) is_point[v] = (cnt >= 2);
    tout[v] = timer++;
}

void color_edges(int v, DSU &dsu) {
    used[v] = true;
    for (pii &edge : g[v]) {
        int u = edge.fi, i = edge.se;
        if (used[u] && u != from[v].fi && tin[u] <= tin[v] && tout[v] <= tout[u]) {
            int x = v;
            while (x != u) {
                if (!dsu.unite(i, from[x].se)) {
                    break;
                }
                x = from[x].fi;
            }
        } else if (!used[u]) {
            from[u] = mp(v, i);
            color_edges(u, dsu);
        }
    }
}

int Q[5 * N];

void solve() {
    DSU dsu(m);
    find_points(1);
    int root = 0;
    for (int i = 1; i <= n; ++i) {
        if (is_point[i]) {
            root = i;
        }
    }
    if (!root) {
        for (int i = 1; i <= m; ++i) {
            color[i] = 1;
        }
    } else {
        color_edges(1, dsu);
        for (int i = 1; i <= m; ++i) {
            color[i] = dsu.get(i);
        }
    }
    dp[1] = 0;
    int tail = 0;
    Q[tail++] = 1;
    for (int head = 0; head < tail; ++head) {
        int v = Q[head];
        for (pii &edge1: g[v]) {
            int x = edge1.fi, i1 = edge1.se;
            for (pii &edge2: g[x]) {
                int u = edge2.fi, i2 = edge2.se;
                if (v == u) continue;
                if (color[i1] == color[i2] && dp[v] + 2 < dp[u]) {
                    dp[u] = dp[v] + 2;
                    Q[tail++] = u;
                }
            }
        }
    }
}

void write() {
    for (int i = 2; i <= n; ++i) cout << (dp[i] == inf ? -1 : dp[i]) << " ";
    cout << "\n";
}

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tests;
    cin >> tests;
    while (tests--) {
        read();
        solve();
        write();
    }
    return 0;
}