#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <string>
#include <cassert>
#include <map>
#include <list>

using namespace std;

#define int long long
#define all(x) x.begin(), x.end()
#define sz(x) ((int)(x.size()))
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef pair<int, int> pi;
typedef vector<pi> vpi;

const int N = 1 << 19;

struct tree {
	struct Node {
		int s, def;
		Node() {
			s = 0;
			def = 0;
		}
		Node(int c) {
			s = c;
			def = 0;
		}
	};

	Node tree[N * 2];

	void push(int v, int l, int r) {
		if (tree[v].def == 0) return;
		tree[v].s += (r - l) * tree[v].def;
		if (r - l > 1) {
			tree[v * 2].def += tree[v].def;
			tree[v * 2 + 1].def += tree[v].def;
		}
		tree[v].def = 0;
	}

	void update(int v, int l, int r, int ql, int qr, int d) {
		push(v, l, r);
		if (r <= ql || qr <= l) return;
		if (ql <= l && r <= qr) {
			tree[v].def += d;
			push(v, l, r);
			return;
		}
		int m = (l + r) / 2;
		update(v * 2, l, m, ql, qr, d);
		update(v * 2 + 1, m, r, ql, qr, d);
		tree[v].s = tree[v * 2].s + tree[v * 2 + 1].s;
	}

	int ask(int v, int l, int r, int pos) {
		push(v, l, r);
		if (r - l == 1) return tree[v].s;
		int m = (l + r) / 2;
		if (pos < m) return ask(v * 2, l, m, pos);
		return ask(v * 2 + 1, m, r, pos);
	}

};

tree d1;
tree d2;
void solve() {
	int n, q;
	cin >> n >> q;
	vi c(n);
	vi c2(n);
	for (int i = 0; i < n; ++i) {
		cin >> c[i];
		c2[i] = c[i];
	}
	sort(all(c2));
	vpi a;
	a.push_back(make_pair(c2[0], 1));
	for (int i = 1; i < n; ++i) {
		if (c2[i] == c2[i - 1]) {
			++a.back().second;
		}
		else {
			a.push_back(make_pair(c2[i], 1));
		}
	}
	vi pref;
	pref.push_back(a[0].second);
	for (int i = 1; i < sz(a); ++i) {
		pref.push_back(pref.back() + a[i].second);
	}
	vector<pair<int, pair<pi, int>>> events(q);
	for (int i = 0; i < q; ++i) {
		int t;
		cin >> t;
		events[i].second.first.first = t;
		if (t == 1) {
			cin >> events[i].first;
		}
		if (t == 2) {
			cin >> events[i].first;
		}
		if (t == 3) {
			cin >> events[i].first >> events[i].second.first.second;
		}
		events[i].second.second = i;
	} //{k, {t, i}}
	map<int, int> mpc;
	for (int i = 0; i < sz(a); ++i) {
		mpc[a[i].first] = i;
	}
	int lastk = 0;
	int sumd = 0;
	for (int i = 0; i < sz(a); ++i) {
		sumd += a[i].second * (sz(a) - i - 1);
	}
	int ans2 = 0;
	for (int i = 0; i < sz(a) - 1; ++i) {
		events.push_back(make_pair(a[i + 1].first - a[i].first, make_pair(make_pair(0, i), -1)));
	}
	sort(all(events));
	vi ans(q);
	//vpi delta(sz(a), make_pair(0, 0));
	int live = sz(a);
	for (int i = 0; i < sz(events); ++i) {
		int k = events[i].first;
		ans2 += (k - lastk) * sumd;
		int t = events[i].second.first.first;
		int id = events[i].second.first.second;
		int rid = events[i].second.second;
		if (t == 1) {
			ans[rid] = live;
		}
		if (t == 2) {
			ans[rid] = ans2;
		}
		if (t == 3) {
			id = mpc[c[id - 1]];
			ans[rid] = a[id].first + d1.ask(1, 0, N, id) + (sz(a) - id - 1 - d2.ask(1, 0, N, id)) * k;
		}
		if (t == 0) {
			sumd -= pref[id];
			d1.update(1, 0, N, 0, id + 1, k);
			d2.update(1, 0, N, 0, id + 1, 1);
			--live;
		}
		lastk = k;
	}
	for (int i = 0; i < q; ++i) {
		cout << ans[i] << "\n";
	}
}

signed main() {
	solve();
}

/*
6 5
5 4 4 2 2 2
1 0
1 1
1 2
2 1
2 2
*/